// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>Creates a new cost anomaly detection monitor with the requested type and monitor
/// specification. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAnomalyMonitor {
    _private: (),
}
impl CreateAnomalyMonitor {
    /// Creates a new builder-style object to manufacture [`CreateAnomalyMonitorInput`](crate::input::CreateAnomalyMonitorInput)
    pub fn builder() -> crate::input::create_anomaly_monitor_input::Builder {
        crate::input::create_anomaly_monitor_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAnomalyMonitor {
    type Output = std::result::Result<
        crate::output::CreateAnomalyMonitorOutput,
        crate::error::CreateAnomalyMonitorError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_anomaly_monitor_error(response)
        } else {
            crate::operation_deser::parse_create_anomaly_monitor_response(response)
        }
    }
}

/// <p>Adds a subscription to a cost anomaly detection monitor. You can use each subscription to
/// define subscribers with email or SNS notifications. Email subscribers can set a dollar
/// threshold and a time frequency for receiving notifications. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAnomalySubscription {
    _private: (),
}
impl CreateAnomalySubscription {
    /// Creates a new builder-style object to manufacture [`CreateAnomalySubscriptionInput`](crate::input::CreateAnomalySubscriptionInput)
    pub fn builder() -> crate::input::create_anomaly_subscription_input::Builder {
        crate::input::create_anomaly_subscription_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAnomalySubscription {
    type Output = std::result::Result<
        crate::output::CreateAnomalySubscriptionOutput,
        crate::error::CreateAnomalySubscriptionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_anomaly_subscription_error(response)
        } else {
            crate::operation_deser::parse_create_anomaly_subscription_response(response)
        }
    }
}

/// <p>Creates a new Cost Category with the requested name and rules.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateCostCategoryDefinition {
    _private: (),
}
impl CreateCostCategoryDefinition {
    /// Creates a new builder-style object to manufacture [`CreateCostCategoryDefinitionInput`](crate::input::CreateCostCategoryDefinitionInput)
    pub fn builder() -> crate::input::create_cost_category_definition_input::Builder {
        crate::input::create_cost_category_definition_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateCostCategoryDefinition {
    type Output = std::result::Result<
        crate::output::CreateCostCategoryDefinitionOutput,
        crate::error::CreateCostCategoryDefinitionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_cost_category_definition_error(response)
        } else {
            crate::operation_deser::parse_create_cost_category_definition_response(response)
        }
    }
}

/// <p>Deletes a cost anomaly monitor. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAnomalyMonitor {
    _private: (),
}
impl DeleteAnomalyMonitor {
    /// Creates a new builder-style object to manufacture [`DeleteAnomalyMonitorInput`](crate::input::DeleteAnomalyMonitorInput)
    pub fn builder() -> crate::input::delete_anomaly_monitor_input::Builder {
        crate::input::delete_anomaly_monitor_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAnomalyMonitor {
    type Output = std::result::Result<
        crate::output::DeleteAnomalyMonitorOutput,
        crate::error::DeleteAnomalyMonitorError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_anomaly_monitor_error(response)
        } else {
            crate::operation_deser::parse_delete_anomaly_monitor_response(response)
        }
    }
}

/// <p>Deletes a cost anomaly subscription. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAnomalySubscription {
    _private: (),
}
impl DeleteAnomalySubscription {
    /// Creates a new builder-style object to manufacture [`DeleteAnomalySubscriptionInput`](crate::input::DeleteAnomalySubscriptionInput)
    pub fn builder() -> crate::input::delete_anomaly_subscription_input::Builder {
        crate::input::delete_anomaly_subscription_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAnomalySubscription {
    type Output = std::result::Result<
        crate::output::DeleteAnomalySubscriptionOutput,
        crate::error::DeleteAnomalySubscriptionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_anomaly_subscription_error(response)
        } else {
            crate::operation_deser::parse_delete_anomaly_subscription_response(response)
        }
    }
}

/// <p>Deletes a Cost Category. Expenses from this month going forward will no longer be categorized with this Cost Category.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteCostCategoryDefinition {
    _private: (),
}
impl DeleteCostCategoryDefinition {
    /// Creates a new builder-style object to manufacture [`DeleteCostCategoryDefinitionInput`](crate::input::DeleteCostCategoryDefinitionInput)
    pub fn builder() -> crate::input::delete_cost_category_definition_input::Builder {
        crate::input::delete_cost_category_definition_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteCostCategoryDefinition {
    type Output = std::result::Result<
        crate::output::DeleteCostCategoryDefinitionOutput,
        crate::error::DeleteCostCategoryDefinitionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_cost_category_definition_error(response)
        } else {
            crate::operation_deser::parse_delete_cost_category_definition_response(response)
        }
    }
}

/// <p>Returns the name, ARN, rules, definition, and effective dates of a Cost Category that's defined in the account.</p>
/// <p>You have the option to use <code>EffectiveOn</code> to return a Cost Category that is active on a specific date. If there is no <code>EffectiveOn</code> specified, you’ll see a Cost Category that is effective on the current date. If Cost Category is still effective, <code>EffectiveEnd</code> is omitted in the response. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCostCategoryDefinition {
    _private: (),
}
impl DescribeCostCategoryDefinition {
    /// Creates a new builder-style object to manufacture [`DescribeCostCategoryDefinitionInput`](crate::input::DescribeCostCategoryDefinitionInput)
    pub fn builder() -> crate::input::describe_cost_category_definition_input::Builder {
        crate::input::describe_cost_category_definition_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCostCategoryDefinition {
    type Output = std::result::Result<
        crate::output::DescribeCostCategoryDefinitionOutput,
        crate::error::DescribeCostCategoryDefinitionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cost_category_definition_error(response)
        } else {
            crate::operation_deser::parse_describe_cost_category_definition_response(response)
        }
    }
}

/// <p>Retrieves all of the cost anomalies detected on your account, during the time period
/// specified by the <code>DateInterval</code> object. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAnomalies {
    _private: (),
}
impl GetAnomalies {
    /// Creates a new builder-style object to manufacture [`GetAnomaliesInput`](crate::input::GetAnomaliesInput)
    pub fn builder() -> crate::input::get_anomalies_input::Builder {
        crate::input::get_anomalies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAnomalies {
    type Output =
        std::result::Result<crate::output::GetAnomaliesOutput, crate::error::GetAnomaliesError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_anomalies_error(response)
        } else {
            crate::operation_deser::parse_get_anomalies_response(response)
        }
    }
}

/// <p>Retrieves the cost anomaly monitor definitions for your account. You can filter using a
/// list of cost anomaly monitor Amazon Resource Names (ARNs). </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAnomalyMonitors {
    _private: (),
}
impl GetAnomalyMonitors {
    /// Creates a new builder-style object to manufacture [`GetAnomalyMonitorsInput`](crate::input::GetAnomalyMonitorsInput)
    pub fn builder() -> crate::input::get_anomaly_monitors_input::Builder {
        crate::input::get_anomaly_monitors_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAnomalyMonitors {
    type Output = std::result::Result<
        crate::output::GetAnomalyMonitorsOutput,
        crate::error::GetAnomalyMonitorsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_anomaly_monitors_error(response)
        } else {
            crate::operation_deser::parse_get_anomaly_monitors_response(response)
        }
    }
}

/// <p>Retrieves the cost anomaly subscription objects for your account. You can filter using a
/// list of cost anomaly monitor Amazon Resource Names (ARNs). </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAnomalySubscriptions {
    _private: (),
}
impl GetAnomalySubscriptions {
    /// Creates a new builder-style object to manufacture [`GetAnomalySubscriptionsInput`](crate::input::GetAnomalySubscriptionsInput)
    pub fn builder() -> crate::input::get_anomaly_subscriptions_input::Builder {
        crate::input::get_anomaly_subscriptions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAnomalySubscriptions {
    type Output = std::result::Result<
        crate::output::GetAnomalySubscriptionsOutput,
        crate::error::GetAnomalySubscriptionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_anomaly_subscriptions_error(response)
        } else {
            crate::operation_deser::parse_get_anomaly_subscriptions_response(response)
        }
    }
}

/// <p>Retrieves cost and usage metrics for your account. You can specify which cost and usage-related metric, such as
/// <code>BlendedCosts</code> or <code>UsageQuantity</code>, that you want the request to return. You can also filter and group
/// your data by various dimensions, such as <code>SERVICE</code> or <code>AZ</code>, in a specific time range. For a complete list
/// of valid dimensions, see the
/// <a href="https://docs.aws.amazon.com/aws-cost-management/latest/APIReference/API_GetDimensionValues.html">GetDimensionValues</a>
/// operation. Management account in an organization in AWS Organizations have access to all member accounts.</p>
/// <p>For information about filter limitations, see <a href="https://docs.aws.amazon.com/awsaccountbilling/latest/aboutv2/billing-limits.html">Quotas and restrictions</a> in the <i>Billing and Cost Management User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetCostAndUsage {
    _private: (),
}
impl GetCostAndUsage {
    /// Creates a new builder-style object to manufacture [`GetCostAndUsageInput`](crate::input::GetCostAndUsageInput)
    pub fn builder() -> crate::input::get_cost_and_usage_input::Builder {
        crate::input::get_cost_and_usage_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetCostAndUsage {
    type Output = std::result::Result<
        crate::output::GetCostAndUsageOutput,
        crate::error::GetCostAndUsageError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_cost_and_usage_error(response)
        } else {
            crate::operation_deser::parse_get_cost_and_usage_response(response)
        }
    }
}

/// <p>Retrieves cost and usage metrics with resources for your account. You can specify which cost and
/// usage-related metric, such as <code>BlendedCosts</code> or <code>UsageQuantity</code>, that
/// you want the request to return. You can also filter and group your data by various dimensions,
/// such as <code>SERVICE</code> or <code>AZ</code>, in a specific time range. For a complete list
/// of valid dimensions, see the <a href="https://docs.aws.amazon.com/aws-cost-management/latest/APIReference/API_GetDimensionValues.html">GetDimensionValues</a> operation. Management account in an organization in AWS
/// Organizations have access to all member accounts. This API is currently available for the Amazon Elastic Compute Cloud – Compute service only.</p>
/// <note>
/// <p>This is an opt-in only feature. You can enable this feature from the Cost Explorer Settings page. For information on how to access the Settings page, see <a href="https://docs.aws.amazon.com/awsaccountbilling/latest/aboutv2/ce-access.html">Controlling Access for Cost Explorer</a> in the <i>AWS Billing and Cost Management User Guide</i>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetCostAndUsageWithResources {
    _private: (),
}
impl GetCostAndUsageWithResources {
    /// Creates a new builder-style object to manufacture [`GetCostAndUsageWithResourcesInput`](crate::input::GetCostAndUsageWithResourcesInput)
    pub fn builder() -> crate::input::get_cost_and_usage_with_resources_input::Builder {
        crate::input::get_cost_and_usage_with_resources_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetCostAndUsageWithResources {
    type Output = std::result::Result<
        crate::output::GetCostAndUsageWithResourcesOutput,
        crate::error::GetCostAndUsageWithResourcesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_cost_and_usage_with_resources_error(response)
        } else {
            crate::operation_deser::parse_get_cost_and_usage_with_resources_response(response)
        }
    }
}

/// <p>Retrieves an array of Cost Category names and values incurred cost.</p>
/// <note>
/// <p>If some Cost Category names and values are not associated with any cost, they will not be returned by this API.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetCostCategories {
    _private: (),
}
impl GetCostCategories {
    /// Creates a new builder-style object to manufacture [`GetCostCategoriesInput`](crate::input::GetCostCategoriesInput)
    pub fn builder() -> crate::input::get_cost_categories_input::Builder {
        crate::input::get_cost_categories_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetCostCategories {
    type Output = std::result::Result<
        crate::output::GetCostCategoriesOutput,
        crate::error::GetCostCategoriesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_cost_categories_error(response)
        } else {
            crate::operation_deser::parse_get_cost_categories_response(response)
        }
    }
}

/// <p>Retrieves a forecast for how much Amazon Web Services predicts that you will spend over the forecast time period that you select, based on your past costs. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetCostForecast {
    _private: (),
}
impl GetCostForecast {
    /// Creates a new builder-style object to manufacture [`GetCostForecastInput`](crate::input::GetCostForecastInput)
    pub fn builder() -> crate::input::get_cost_forecast_input::Builder {
        crate::input::get_cost_forecast_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetCostForecast {
    type Output = std::result::Result<
        crate::output::GetCostForecastOutput,
        crate::error::GetCostForecastError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_cost_forecast_error(response)
        } else {
            crate::operation_deser::parse_get_cost_forecast_response(response)
        }
    }
}

/// <p>Retrieves all available filter values for a specified filter over a period of time. You can search the dimension values for an arbitrary string. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetDimensionValues {
    _private: (),
}
impl GetDimensionValues {
    /// Creates a new builder-style object to manufacture [`GetDimensionValuesInput`](crate::input::GetDimensionValuesInput)
    pub fn builder() -> crate::input::get_dimension_values_input::Builder {
        crate::input::get_dimension_values_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetDimensionValues {
    type Output = std::result::Result<
        crate::output::GetDimensionValuesOutput,
        crate::error::GetDimensionValuesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_dimension_values_error(response)
        } else {
            crate::operation_deser::parse_get_dimension_values_response(response)
        }
    }
}

/// <p>Retrieves the reservation coverage for your account. This enables you to see how much of your Amazon Elastic Compute Cloud, Amazon ElastiCache, Amazon Relational Database Service, or
/// Amazon Redshift usage is covered by a reservation. An organization's management account can see the coverage of the associated member accounts. This supports dimensions, Cost Categories, and nested expressions.
/// For any time period, you can filter data about reservation usage by the following dimensions:</p>
/// <ul>
/// <li>
/// <p>AZ</p>
/// </li>
/// <li>
/// <p>CACHE_ENGINE</p>
/// </li>
/// <li>
/// <p>DATABASE_ENGINE</p>
/// </li>
/// <li>
/// <p>DEPLOYMENT_OPTION</p>
/// </li>
/// <li>
/// <p>INSTANCE_TYPE</p>
/// </li>
/// <li>
/// <p>LINKED_ACCOUNT</p>
/// </li>
/// <li>
/// <p>OPERATING_SYSTEM</p>
/// </li>
/// <li>
/// <p>PLATFORM</p>
/// </li>
/// <li>
/// <p>REGION</p>
/// </li>
/// <li>
/// <p>SERVICE</p>
/// </li>
/// <li>
/// <p>TAG</p>
/// </li>
/// <li>
/// <p>TENANCY</p>
/// </li>
/// </ul>
/// <p>To determine valid values for a dimension, use the <code>GetDimensionValues</code> operation. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetReservationCoverage {
    _private: (),
}
impl GetReservationCoverage {
    /// Creates a new builder-style object to manufacture [`GetReservationCoverageInput`](crate::input::GetReservationCoverageInput)
    pub fn builder() -> crate::input::get_reservation_coverage_input::Builder {
        crate::input::get_reservation_coverage_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetReservationCoverage {
    type Output = std::result::Result<
        crate::output::GetReservationCoverageOutput,
        crate::error::GetReservationCoverageError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_reservation_coverage_error(response)
        } else {
            crate::operation_deser::parse_get_reservation_coverage_response(response)
        }
    }
}

/// <p>Gets recommendations for which reservations to purchase. These recommendations could help you reduce your costs.
/// Reservations provide a discounted hourly rate (up to 75%) compared to On-Demand pricing.</p>
/// <p>AWS generates your recommendations by identifying your On-Demand usage during a specific time period and collecting your usage
/// into categories that are eligible for a reservation. After AWS has these categories, it simulates every combination of reservations
/// in each category of usage to identify the best number of each type of RI to purchase to maximize your estimated savings. </p>
/// <p>For example, AWS automatically aggregates your Amazon EC2 Linux, shared tenancy, and c4 family usage in the US West (Oregon) Region
/// and recommends that you buy size-flexible regional reservations to apply to the c4 family usage. AWS recommends the smallest size instance
/// in an instance family. This makes it easier to purchase a size-flexible RI. AWS also shows the equal number of normalized units
/// so that you can purchase any instance size that you want. For this example, your RI recommendation would be for <code>c4.large</code>
/// because that is the smallest size instance in the c4 instance family.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetReservationPurchaseRecommendation {
    _private: (),
}
impl GetReservationPurchaseRecommendation {
    /// Creates a new builder-style object to manufacture [`GetReservationPurchaseRecommendationInput`](crate::input::GetReservationPurchaseRecommendationInput)
    pub fn builder() -> crate::input::get_reservation_purchase_recommendation_input::Builder {
        crate::input::get_reservation_purchase_recommendation_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetReservationPurchaseRecommendation {
    type Output = std::result::Result<
        crate::output::GetReservationPurchaseRecommendationOutput,
        crate::error::GetReservationPurchaseRecommendationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_reservation_purchase_recommendation_error(response)
        } else {
            crate::operation_deser::parse_get_reservation_purchase_recommendation_response(response)
        }
    }
}

/// <p>Retrieves the reservation utilization for your account. Management account in an organization have access to member accounts.
/// You can filter data by dimensions in a time period. You can use <code>GetDimensionValues</code> to determine the possible
/// dimension values. Currently, you can group only by <code>SUBSCRIPTION_ID</code>. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetReservationUtilization {
    _private: (),
}
impl GetReservationUtilization {
    /// Creates a new builder-style object to manufacture [`GetReservationUtilizationInput`](crate::input::GetReservationUtilizationInput)
    pub fn builder() -> crate::input::get_reservation_utilization_input::Builder {
        crate::input::get_reservation_utilization_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetReservationUtilization {
    type Output = std::result::Result<
        crate::output::GetReservationUtilizationOutput,
        crate::error::GetReservationUtilizationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_reservation_utilization_error(response)
        } else {
            crate::operation_deser::parse_get_reservation_utilization_response(response)
        }
    }
}

/// <p>Creates recommendations that
/// help you save cost
/// by identifying idle and underutilized Amazon EC2 instances.</p>
/// <p>Recommendations are generated to either downsize or terminate instances, along with
/// providing savings detail and metrics. For details on calculation and function, see
/// <a href="https://docs.aws.amazon.com/awsaccountbilling/latest/aboutv2/ce-rightsizing.html">Optimizing
/// Your Cost with Rightsizing
/// Recommendations</a>
/// in the <i>AWS Billing and Cost Management User
/// Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRightsizingRecommendation {
    _private: (),
}
impl GetRightsizingRecommendation {
    /// Creates a new builder-style object to manufacture [`GetRightsizingRecommendationInput`](crate::input::GetRightsizingRecommendationInput)
    pub fn builder() -> crate::input::get_rightsizing_recommendation_input::Builder {
        crate::input::get_rightsizing_recommendation_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRightsizingRecommendation {
    type Output = std::result::Result<
        crate::output::GetRightsizingRecommendationOutput,
        crate::error::GetRightsizingRecommendationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_rightsizing_recommendation_error(response)
        } else {
            crate::operation_deser::parse_get_rightsizing_recommendation_response(response)
        }
    }
}

/// <p>Retrieves the Savings Plans covered for your account. This enables you to see how much of your cost is covered by a Savings Plan. An organization’s management account can see the coverage of the associated member accounts. This supports dimensions, Cost Categories, and nested expressions. For any time period, you can filter data for Savings Plans usage with the following dimensions:</p>
/// <ul>
/// <li>
/// <p>
/// <code>LINKED_ACCOUNT</code>
/// </p>
/// </li>
/// <li>
/// <p>
/// <code>REGION</code>
/// </p>
/// </li>
/// <li>
/// <p>
/// <code>SERVICE</code>
/// </p>
/// </li>
/// <li>
/// <p>
/// <code>INSTANCE_FAMILY</code>
/// </p>
/// </li>
/// </ul>
/// <p>To determine valid values for a dimension, use the <code>GetDimensionValues</code> operation.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSavingsPlansCoverage {
    _private: (),
}
impl GetSavingsPlansCoverage {
    /// Creates a new builder-style object to manufacture [`GetSavingsPlansCoverageInput`](crate::input::GetSavingsPlansCoverageInput)
    pub fn builder() -> crate::input::get_savings_plans_coverage_input::Builder {
        crate::input::get_savings_plans_coverage_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSavingsPlansCoverage {
    type Output = std::result::Result<
        crate::output::GetSavingsPlansCoverageOutput,
        crate::error::GetSavingsPlansCoverageError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_savings_plans_coverage_error(response)
        } else {
            crate::operation_deser::parse_get_savings_plans_coverage_response(response)
        }
    }
}

/// <p>Retrieves your request parameters, Savings Plan Recommendations Summary and Details. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSavingsPlansPurchaseRecommendation {
    _private: (),
}
impl GetSavingsPlansPurchaseRecommendation {
    /// Creates a new builder-style object to manufacture [`GetSavingsPlansPurchaseRecommendationInput`](crate::input::GetSavingsPlansPurchaseRecommendationInput)
    pub fn builder() -> crate::input::get_savings_plans_purchase_recommendation_input::Builder {
        crate::input::get_savings_plans_purchase_recommendation_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSavingsPlansPurchaseRecommendation {
    type Output = std::result::Result<
        crate::output::GetSavingsPlansPurchaseRecommendationOutput,
        crate::error::GetSavingsPlansPurchaseRecommendationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_savings_plans_purchase_recommendation_error(response)
        } else {
            crate::operation_deser::parse_get_savings_plans_purchase_recommendation_response(
                response,
            )
        }
    }
}

/// <p>Retrieves the Savings Plans utilization for your account across date ranges with daily or monthly granularity. Management account in an organization have access to member accounts. You can use <code>GetDimensionValues</code> in <code>SAVINGS_PLANS</code> to determine the possible dimension values.</p>
/// <note>
/// <p>You cannot group by any dimension values for <code>GetSavingsPlansUtilization</code>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSavingsPlansUtilization {
    _private: (),
}
impl GetSavingsPlansUtilization {
    /// Creates a new builder-style object to manufacture [`GetSavingsPlansUtilizationInput`](crate::input::GetSavingsPlansUtilizationInput)
    pub fn builder() -> crate::input::get_savings_plans_utilization_input::Builder {
        crate::input::get_savings_plans_utilization_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSavingsPlansUtilization {
    type Output = std::result::Result<
        crate::output::GetSavingsPlansUtilizationOutput,
        crate::error::GetSavingsPlansUtilizationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_savings_plans_utilization_error(response)
        } else {
            crate::operation_deser::parse_get_savings_plans_utilization_response(response)
        }
    }
}

/// <p>Retrieves attribute data along with aggregate utilization and savings data for a given time period. This doesn't support granular or grouped data (daily/monthly) in response. You can't retrieve data by dates in a single response similar to <code>GetSavingsPlanUtilization</code>, but you have the option to make multiple calls to <code>GetSavingsPlanUtilizationDetails</code> by providing individual dates. You can use <code>GetDimensionValues</code> in <code>SAVINGS_PLANS</code> to determine the possible dimension values.</p>
/// <note>
/// <p>
/// <code>GetSavingsPlanUtilizationDetails</code> internally groups data by <code>SavingsPlansArn</code>.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSavingsPlansUtilizationDetails {
    _private: (),
}
impl GetSavingsPlansUtilizationDetails {
    /// Creates a new builder-style object to manufacture [`GetSavingsPlansUtilizationDetailsInput`](crate::input::GetSavingsPlansUtilizationDetailsInput)
    pub fn builder() -> crate::input::get_savings_plans_utilization_details_input::Builder {
        crate::input::get_savings_plans_utilization_details_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSavingsPlansUtilizationDetails {
    type Output = std::result::Result<
        crate::output::GetSavingsPlansUtilizationDetailsOutput,
        crate::error::GetSavingsPlansUtilizationDetailsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_savings_plans_utilization_details_error(response)
        } else {
            crate::operation_deser::parse_get_savings_plans_utilization_details_response(response)
        }
    }
}

/// <p>Queries for available tag keys and tag values for a specified period. You can search the tag values for an arbitrary string. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetTags {
    _private: (),
}
impl GetTags {
    /// Creates a new builder-style object to manufacture [`GetTagsInput`](crate::input::GetTagsInput)
    pub fn builder() -> crate::input::get_tags_input::Builder {
        crate::input::get_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetTags {
    type Output = std::result::Result<crate::output::GetTagsOutput, crate::error::GetTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_tags_error(response)
        } else {
            crate::operation_deser::parse_get_tags_response(response)
        }
    }
}

/// <p>Retrieves a forecast for how much Amazon Web Services predicts that you will use over the forecast time period that you select, based on your past usage. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetUsageForecast {
    _private: (),
}
impl GetUsageForecast {
    /// Creates a new builder-style object to manufacture [`GetUsageForecastInput`](crate::input::GetUsageForecastInput)
    pub fn builder() -> crate::input::get_usage_forecast_input::Builder {
        crate::input::get_usage_forecast_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetUsageForecast {
    type Output = std::result::Result<
        crate::output::GetUsageForecastOutput,
        crate::error::GetUsageForecastError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_usage_forecast_error(response)
        } else {
            crate::operation_deser::parse_get_usage_forecast_response(response)
        }
    }
}

/// <p>Returns the name, ARN, <code>NumberOfRules</code> and effective dates of all Cost Categories defined in the account. You have the option to use <code>EffectiveOn</code> to return a list of Cost Categories that were active on a specific date. If there is no <code>EffectiveOn</code> specified, you’ll see Cost Categories that are effective on the current date. If Cost Category is still effective, <code>EffectiveEnd</code> is omitted in the response. <code>ListCostCategoryDefinitions</code> supports pagination. The request can have a <code>MaxResults</code> range up to 100.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListCostCategoryDefinitions {
    _private: (),
}
impl ListCostCategoryDefinitions {
    /// Creates a new builder-style object to manufacture [`ListCostCategoryDefinitionsInput`](crate::input::ListCostCategoryDefinitionsInput)
    pub fn builder() -> crate::input::list_cost_category_definitions_input::Builder {
        crate::input::list_cost_category_definitions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListCostCategoryDefinitions {
    type Output = std::result::Result<
        crate::output::ListCostCategoryDefinitionsOutput,
        crate::error::ListCostCategoryDefinitionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_cost_category_definitions_error(response)
        } else {
            crate::operation_deser::parse_list_cost_category_definitions_response(response)
        }
    }
}

/// <p>Modifies the feedback property of a given cost anomaly. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ProvideAnomalyFeedback {
    _private: (),
}
impl ProvideAnomalyFeedback {
    /// Creates a new builder-style object to manufacture [`ProvideAnomalyFeedbackInput`](crate::input::ProvideAnomalyFeedbackInput)
    pub fn builder() -> crate::input::provide_anomaly_feedback_input::Builder {
        crate::input::provide_anomaly_feedback_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ProvideAnomalyFeedback {
    type Output = std::result::Result<
        crate::output::ProvideAnomalyFeedbackOutput,
        crate::error::ProvideAnomalyFeedbackError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_provide_anomaly_feedback_error(response)
        } else {
            crate::operation_deser::parse_provide_anomaly_feedback_response(response)
        }
    }
}

/// <p>Updates an existing cost anomaly monitor. The changes made are applied going forward, and
/// does not change anomalies detected in the past. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateAnomalyMonitor {
    _private: (),
}
impl UpdateAnomalyMonitor {
    /// Creates a new builder-style object to manufacture [`UpdateAnomalyMonitorInput`](crate::input::UpdateAnomalyMonitorInput)
    pub fn builder() -> crate::input::update_anomaly_monitor_input::Builder {
        crate::input::update_anomaly_monitor_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateAnomalyMonitor {
    type Output = std::result::Result<
        crate::output::UpdateAnomalyMonitorOutput,
        crate::error::UpdateAnomalyMonitorError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_anomaly_monitor_error(response)
        } else {
            crate::operation_deser::parse_update_anomaly_monitor_response(response)
        }
    }
}

/// <p> Updates an existing cost anomaly monitor subscription. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateAnomalySubscription {
    _private: (),
}
impl UpdateAnomalySubscription {
    /// Creates a new builder-style object to manufacture [`UpdateAnomalySubscriptionInput`](crate::input::UpdateAnomalySubscriptionInput)
    pub fn builder() -> crate::input::update_anomaly_subscription_input::Builder {
        crate::input::update_anomaly_subscription_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateAnomalySubscription {
    type Output = std::result::Result<
        crate::output::UpdateAnomalySubscriptionOutput,
        crate::error::UpdateAnomalySubscriptionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_anomaly_subscription_error(response)
        } else {
            crate::operation_deser::parse_update_anomaly_subscription_response(response)
        }
    }
}

/// <p>Updates an existing Cost Category. Changes made to the Cost Category rules will be used to categorize the current month’s expenses and future expenses. This won’t change categorization for the previous months.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateCostCategoryDefinition {
    _private: (),
}
impl UpdateCostCategoryDefinition {
    /// Creates a new builder-style object to manufacture [`UpdateCostCategoryDefinitionInput`](crate::input::UpdateCostCategoryDefinitionInput)
    pub fn builder() -> crate::input::update_cost_category_definition_input::Builder {
        crate::input::update_cost_category_definition_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateCostCategoryDefinition {
    type Output = std::result::Result<
        crate::output::UpdateCostCategoryDefinitionOutput,
        crate::error::UpdateCostCategoryDefinitionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_cost_category_definition_error(response)
        } else {
            crate::operation_deser::parse_update_cost_category_definition_response(response)
        }
    }
}
