// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
use std::fmt::Write;
/// See [`AcceptReservedInstancesExchangeQuoteInput`](crate::input::AcceptReservedInstancesExchangeQuoteInput)
pub mod accept_reserved_instances_exchange_quote_input {
    /// A builder for [`AcceptReservedInstancesExchangeQuoteInput`](crate::input::AcceptReservedInstancesExchangeQuoteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) reserved_instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) target_configurations:
            std::option::Option<std::vec::Vec<crate::model::TargetConfigurationRequest>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn reserved_instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.reserved_instance_ids.unwrap_or_default();
            v.push(input.into());
            self.reserved_instance_ids = Some(v);
            self
        }
        pub fn set_reserved_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.reserved_instance_ids = input;
            self
        }
        pub fn target_configurations(
            mut self,
            input: impl Into<crate::model::TargetConfigurationRequest>,
        ) -> Self {
            let mut v = self.target_configurations.unwrap_or_default();
            v.push(input.into());
            self.target_configurations = Some(v);
            self
        }
        pub fn set_target_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TargetConfigurationRequest>>,
        ) -> Self {
            self.target_configurations = input;
            self
        }
        /// Consumes the builder and constructs a [`AcceptReservedInstancesExchangeQuoteInput`](crate::input::AcceptReservedInstancesExchangeQuoteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AcceptReservedInstancesExchangeQuoteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AcceptReservedInstancesExchangeQuoteInput {
                dry_run: self.dry_run,
                reserved_instance_ids: self.reserved_instance_ids,
                target_configurations: self.target_configurations,
            })
        }
    }
}
#[doc(hidden)]
pub type AcceptReservedInstancesExchangeQuoteInputOperationOutputAlias =
    crate::operation::AcceptReservedInstancesExchangeQuote;
#[doc(hidden)]
pub type AcceptReservedInstancesExchangeQuoteInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl AcceptReservedInstancesExchangeQuoteInput {
    /// Consumes the builder and constructs an Operation<[`AcceptReservedInstancesExchangeQuote`](crate::operation::AcceptReservedInstancesExchangeQuote)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AcceptReservedInstancesExchangeQuote,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_accept_reserved_instances_exchange_quote(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AcceptReservedInstancesExchangeQuote::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AcceptReservedInstancesExchangeQuote",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AcceptReservedInstancesExchangeQuoteInput`](crate::input::AcceptReservedInstancesExchangeQuoteInput)
    pub fn builder() -> crate::input::accept_reserved_instances_exchange_quote_input::Builder {
        crate::input::accept_reserved_instances_exchange_quote_input::Builder::default()
    }
}

/// See [`AcceptTransitGatewayMulticastDomainAssociationsInput`](crate::input::AcceptTransitGatewayMulticastDomainAssociationsInput)
pub mod accept_transit_gateway_multicast_domain_associations_input {
    /// A builder for [`AcceptTransitGatewayMulticastDomainAssociationsInput`](crate::input::AcceptTransitGatewayMulticastDomainAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The ID of the transit gateway attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        pub fn subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.subnet_ids = Some(v);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.subnet_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AcceptTransitGatewayMulticastDomainAssociationsInput`](crate::input::AcceptTransitGatewayMulticastDomainAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AcceptTransitGatewayMulticastDomainAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::AcceptTransitGatewayMulticastDomainAssociationsInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                    subnet_ids: self.subnet_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type AcceptTransitGatewayMulticastDomainAssociationsInputOperationOutputAlias =
    crate::operation::AcceptTransitGatewayMulticastDomainAssociations;
#[doc(hidden)]
pub type AcceptTransitGatewayMulticastDomainAssociationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl AcceptTransitGatewayMulticastDomainAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`AcceptTransitGatewayMulticastDomainAssociations`](crate::operation::AcceptTransitGatewayMulticastDomainAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AcceptTransitGatewayMulticastDomainAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_accept_transit_gateway_multicast_domain_associations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AcceptTransitGatewayMulticastDomainAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AcceptTransitGatewayMulticastDomainAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AcceptTransitGatewayMulticastDomainAssociationsInput`](crate::input::AcceptTransitGatewayMulticastDomainAssociationsInput)
    pub fn builder(
    ) -> crate::input::accept_transit_gateway_multicast_domain_associations_input::Builder {
        crate::input::accept_transit_gateway_multicast_domain_associations_input::Builder::default()
    }
}

/// See [`AcceptTransitGatewayPeeringAttachmentInput`](crate::input::AcceptTransitGatewayPeeringAttachmentInput)
pub mod accept_transit_gateway_peering_attachment_input {
    /// A builder for [`AcceptTransitGatewayPeeringAttachmentInput`](crate::input::AcceptTransitGatewayPeeringAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AcceptTransitGatewayPeeringAttachmentInput`](crate::input::AcceptTransitGatewayPeeringAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AcceptTransitGatewayPeeringAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AcceptTransitGatewayPeeringAttachmentInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AcceptTransitGatewayPeeringAttachmentInputOperationOutputAlias =
    crate::operation::AcceptTransitGatewayPeeringAttachment;
#[doc(hidden)]
pub type AcceptTransitGatewayPeeringAttachmentInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl AcceptTransitGatewayPeeringAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`AcceptTransitGatewayPeeringAttachment`](crate::operation::AcceptTransitGatewayPeeringAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AcceptTransitGatewayPeeringAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_accept_transit_gateway_peering_attachment(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AcceptTransitGatewayPeeringAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AcceptTransitGatewayPeeringAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AcceptTransitGatewayPeeringAttachmentInput`](crate::input::AcceptTransitGatewayPeeringAttachmentInput)
    pub fn builder() -> crate::input::accept_transit_gateway_peering_attachment_input::Builder {
        crate::input::accept_transit_gateway_peering_attachment_input::Builder::default()
    }
}

/// See [`AcceptTransitGatewayVpcAttachmentInput`](crate::input::AcceptTransitGatewayVpcAttachmentInput)
pub mod accept_transit_gateway_vpc_attachment_input {
    /// A builder for [`AcceptTransitGatewayVpcAttachmentInput`](crate::input::AcceptTransitGatewayVpcAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AcceptTransitGatewayVpcAttachmentInput`](crate::input::AcceptTransitGatewayVpcAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AcceptTransitGatewayVpcAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AcceptTransitGatewayVpcAttachmentInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AcceptTransitGatewayVpcAttachmentInputOperationOutputAlias =
    crate::operation::AcceptTransitGatewayVpcAttachment;
#[doc(hidden)]
pub type AcceptTransitGatewayVpcAttachmentInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AcceptTransitGatewayVpcAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`AcceptTransitGatewayVpcAttachment`](crate::operation::AcceptTransitGatewayVpcAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AcceptTransitGatewayVpcAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_accept_transit_gateway_vpc_attachment(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AcceptTransitGatewayVpcAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AcceptTransitGatewayVpcAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AcceptTransitGatewayVpcAttachmentInput`](crate::input::AcceptTransitGatewayVpcAttachmentInput)
    pub fn builder() -> crate::input::accept_transit_gateway_vpc_attachment_input::Builder {
        crate::input::accept_transit_gateway_vpc_attachment_input::Builder::default()
    }
}

/// See [`AcceptVpcEndpointConnectionsInput`](crate::input::AcceptVpcEndpointConnectionsInput)
pub mod accept_vpc_endpoint_connections_input {
    /// A builder for [`AcceptVpcEndpointConnectionsInput`](crate::input::AcceptVpcEndpointConnectionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_id: std::option::Option<std::string::String>,
        pub(crate) vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC endpoint service.</p>
        pub fn service_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_id = Some(input.into());
            self
        }
        pub fn set_service_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_id = input;
            self
        }
        pub fn vpc_endpoint_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_endpoint_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_endpoint_ids = Some(v);
            self
        }
        pub fn set_vpc_endpoint_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_endpoint_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`AcceptVpcEndpointConnectionsInput`](crate::input::AcceptVpcEndpointConnectionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AcceptVpcEndpointConnectionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AcceptVpcEndpointConnectionsInput {
                dry_run: self.dry_run,
                service_id: self.service_id,
                vpc_endpoint_ids: self.vpc_endpoint_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type AcceptVpcEndpointConnectionsInputOperationOutputAlias =
    crate::operation::AcceptVpcEndpointConnections;
#[doc(hidden)]
pub type AcceptVpcEndpointConnectionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AcceptVpcEndpointConnectionsInput {
    /// Consumes the builder and constructs an Operation<[`AcceptVpcEndpointConnections`](crate::operation::AcceptVpcEndpointConnections)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AcceptVpcEndpointConnections,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_accept_vpc_endpoint_connections(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AcceptVpcEndpointConnections::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AcceptVpcEndpointConnections",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AcceptVpcEndpointConnectionsInput`](crate::input::AcceptVpcEndpointConnectionsInput)
    pub fn builder() -> crate::input::accept_vpc_endpoint_connections_input::Builder {
        crate::input::accept_vpc_endpoint_connections_input::Builder::default()
    }
}

/// See [`AcceptVpcPeeringConnectionInput`](crate::input::AcceptVpcPeeringConnectionInput)
pub mod accept_vpc_peering_connection_input {
    /// A builder for [`AcceptVpcPeeringConnectionInput`](crate::input::AcceptVpcPeeringConnectionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_peering_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC peering connection. You must specify this parameter in the
        /// request.</p>
        pub fn vpc_peering_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_peering_connection_id = Some(input.into());
            self
        }
        pub fn set_vpc_peering_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_peering_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AcceptVpcPeeringConnectionInput`](crate::input::AcceptVpcPeeringConnectionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AcceptVpcPeeringConnectionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AcceptVpcPeeringConnectionInput {
                dry_run: self.dry_run,
                vpc_peering_connection_id: self.vpc_peering_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AcceptVpcPeeringConnectionInputOperationOutputAlias =
    crate::operation::AcceptVpcPeeringConnection;
#[doc(hidden)]
pub type AcceptVpcPeeringConnectionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AcceptVpcPeeringConnectionInput {
    /// Consumes the builder and constructs an Operation<[`AcceptVpcPeeringConnection`](crate::operation::AcceptVpcPeeringConnection)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AcceptVpcPeeringConnection,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_accept_vpc_peering_connection(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AcceptVpcPeeringConnection::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AcceptVpcPeeringConnection",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AcceptVpcPeeringConnectionInput`](crate::input::AcceptVpcPeeringConnectionInput)
    pub fn builder() -> crate::input::accept_vpc_peering_connection_input::Builder {
        crate::input::accept_vpc_peering_connection_input::Builder::default()
    }
}

/// See [`AdvertiseByoipCidrInput`](crate::input::AdvertiseByoipCidrInput)
pub mod advertise_byoip_cidr_input {
    /// A builder for [`AdvertiseByoipCidrInput`](crate::input::AdvertiseByoipCidrInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The address range, in CIDR notation. This must be the exact range that you provisioned.
        /// You can't advertise only a portion of the provisioned range.</p>
        pub fn cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr = Some(input.into());
            self
        }
        pub fn set_cidr(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AdvertiseByoipCidrInput`](crate::input::AdvertiseByoipCidrInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AdvertiseByoipCidrInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AdvertiseByoipCidrInput {
                cidr: self.cidr,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AdvertiseByoipCidrInputOperationOutputAlias = crate::operation::AdvertiseByoipCidr;
#[doc(hidden)]
pub type AdvertiseByoipCidrInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AdvertiseByoipCidrInput {
    /// Consumes the builder and constructs an Operation<[`AdvertiseByoipCidr`](crate::operation::AdvertiseByoipCidr)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AdvertiseByoipCidr,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_advertise_byoip_cidr(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AdvertiseByoipCidr::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AdvertiseByoipCidr",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AdvertiseByoipCidrInput`](crate::input::AdvertiseByoipCidrInput)
    pub fn builder() -> crate::input::advertise_byoip_cidr_input::Builder {
        crate::input::advertise_byoip_cidr_input::Builder::default()
    }
}

/// See [`AllocateAddressInput`](crate::input::AllocateAddressInput)
pub mod allocate_address_input {
    /// A builder for [`AllocateAddressInput`](crate::input::AllocateAddressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) domain: std::option::Option<crate::model::DomainType>,
        pub(crate) address: std::option::Option<std::string::String>,
        pub(crate) public_ipv4_pool: std::option::Option<std::string::String>,
        pub(crate) network_border_group: std::option::Option<std::string::String>,
        pub(crate) customer_owned_ipv4_pool: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Indicates whether the Elastic IP address is for use with instances in a VPC or instances in EC2-Classic.</p>
        /// <p>Default: If the Region supports EC2-Classic, the default is <code>standard</code>. Otherwise, the default
        /// is <code>vpc</code>.</p>
        pub fn domain(mut self, input: crate::model::DomainType) -> Self {
            self.domain = Some(input);
            self
        }
        pub fn set_domain(mut self, input: std::option::Option<crate::model::DomainType>) -> Self {
            self.domain = input;
            self
        }
        /// <p>[EC2-VPC] The Elastic IP address to recover or an IPv4 address from an address pool.</p>
        pub fn address(mut self, input: impl Into<std::string::String>) -> Self {
            self.address = Some(input.into());
            self
        }
        pub fn set_address(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.address = input;
            self
        }
        /// <p>The ID of an address pool that you own. Use this parameter to let Amazon EC2 select an address from the address pool.
        /// To specify a specific address from the address pool, use the <code>Address</code> parameter instead.</p>
        pub fn public_ipv4_pool(mut self, input: impl Into<std::string::String>) -> Self {
            self.public_ipv4_pool = Some(input.into());
            self
        }
        pub fn set_public_ipv4_pool(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.public_ipv4_pool = input;
            self
        }
        /// <p> A unique set of Availability Zones, Local Zones, or Wavelength Zones from which AWS
        /// advertises IP addresses. Use this parameter to limit the IP address to this location. IP
        /// addresses cannot move between network border groups.</p>
        /// <p>Use <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_DescribeAvailabilityZones.html">DescribeAvailabilityZones</a> to view the network border groups.</p>
        /// <note>
        /// <p>You cannot use a network border group with EC2 Classic. If you attempt this operation on EC2 classic, you will receive an <code>InvalidParameterCombination</code> error. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html">Error Codes</a>.</p>
        /// </note>
        pub fn network_border_group(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_border_group = Some(input.into());
            self
        }
        pub fn set_network_border_group(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_border_group = input;
            self
        }
        /// <p>The ID of a customer-owned address pool. Use this parameter to let Amazon EC2
        /// select an address from the address pool. Alternatively, specify a specific
        /// address from the address pool.</p>
        pub fn customer_owned_ipv4_pool(mut self, input: impl Into<std::string::String>) -> Self {
            self.customer_owned_ipv4_pool = Some(input.into());
            self
        }
        pub fn set_customer_owned_ipv4_pool(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.customer_owned_ipv4_pool = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`AllocateAddressInput`](crate::input::AllocateAddressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AllocateAddressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AllocateAddressInput {
                domain: self.domain,
                address: self.address,
                public_ipv4_pool: self.public_ipv4_pool,
                network_border_group: self.network_border_group,
                customer_owned_ipv4_pool: self.customer_owned_ipv4_pool,
                dry_run: self.dry_run,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type AllocateAddressInputOperationOutputAlias = crate::operation::AllocateAddress;
#[doc(hidden)]
pub type AllocateAddressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AllocateAddressInput {
    /// Consumes the builder and constructs an Operation<[`AllocateAddress`](crate::operation::AllocateAddress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AllocateAddress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_allocate_address(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AllocateAddress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AllocateAddress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AllocateAddressInput`](crate::input::AllocateAddressInput)
    pub fn builder() -> crate::input::allocate_address_input::Builder {
        crate::input::allocate_address_input::Builder::default()
    }
}

/// See [`AllocateHostsInput`](crate::input::AllocateHostsInput)
pub mod allocate_hosts_input {
    /// A builder for [`AllocateHostsInput`](crate::input::AllocateHostsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) auto_placement: std::option::Option<crate::model::AutoPlacement>,
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) instance_type: std::option::Option<std::string::String>,
        pub(crate) instance_family: std::option::Option<std::string::String>,
        pub(crate) quantity: std::option::Option<i32>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) host_recovery: std::option::Option<crate::model::HostRecovery>,
    }
    impl Builder {
        /// <p>Indicates whether the host accepts any untargeted instance launches that
        /// match its instance type configuration, or if it only accepts Host tenancy
        /// instance launches that specify its unique host ID. For more information,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/how-dedicated-hosts-work.html#dedicated-hosts-understanding">
        /// Understanding auto-placement and affinity</a> in the <i>Amazon EC2 User Guide</i>.</p>
        /// <p>Default: <code>on</code>
        /// </p>
        pub fn auto_placement(mut self, input: crate::model::AutoPlacement) -> Self {
            self.auto_placement = Some(input);
            self
        }
        pub fn set_auto_placement(
            mut self,
            input: std::option::Option<crate::model::AutoPlacement>,
        ) -> Self {
            self.auto_placement = input;
            self
        }
        /// <p>The Availability Zone in which to allocate the Dedicated Host.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Specifies the instance type to be supported by the Dedicated Hosts. If you
        /// specify an instance type, the Dedicated Hosts support instances of the
        /// specified instance type only.</p>
        /// <p>If you want the Dedicated Hosts to support multiple instance types in a specific
        /// instance family, omit this parameter and specify <b>InstanceFamily</b>
        /// instead. You cannot specify <b>InstanceType</b> and
        /// <b>InstanceFamily</b> in the same request.</p>
        pub fn instance_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_type = Some(input.into());
            self
        }
        pub fn set_instance_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.instance_type = input;
            self
        }
        /// <p>Specifies the instance family to be supported by the Dedicated Hosts. If you specify
        /// an instance family, the Dedicated Hosts support multiple instance types within that
        /// instance family.</p>
        /// <p>If you want the Dedicated Hosts to support a specific instance type only, omit this
        /// parameter and specify <b>InstanceType</b>
        /// instead. You cannot specify <b>InstanceFamily</b> and
        /// <b>InstanceType</b> in the same request.</p>
        pub fn instance_family(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_family = Some(input.into());
            self
        }
        pub fn set_instance_family(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.instance_family = input;
            self
        }
        /// <p>The number of Dedicated Hosts to allocate to your account with these parameters.</p>
        pub fn quantity(mut self, input: i32) -> Self {
            self.quantity = Some(input);
            self
        }
        pub fn set_quantity(mut self, input: std::option::Option<i32>) -> Self {
            self.quantity = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Indicates whether to enable or disable host recovery for the Dedicated Host.
        /// Host recovery is disabled by default. For more information, see
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/dedicated-hosts-recovery.html">
        /// Host recovery</a> in the <i>Amazon EC2 User Guide</i>.</p>
        /// <p>Default: <code>off</code>
        /// </p>
        pub fn host_recovery(mut self, input: crate::model::HostRecovery) -> Self {
            self.host_recovery = Some(input);
            self
        }
        pub fn set_host_recovery(
            mut self,
            input: std::option::Option<crate::model::HostRecovery>,
        ) -> Self {
            self.host_recovery = input;
            self
        }
        /// Consumes the builder and constructs a [`AllocateHostsInput`](crate::input::AllocateHostsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::AllocateHostsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::AllocateHostsInput {
                auto_placement: self.auto_placement,
                availability_zone: self.availability_zone,
                client_token: self.client_token,
                instance_type: self.instance_type,
                instance_family: self.instance_family,
                quantity: self.quantity,
                tag_specifications: self.tag_specifications,
                host_recovery: self.host_recovery,
            })
        }
    }
}
#[doc(hidden)]
pub type AllocateHostsInputOperationOutputAlias = crate::operation::AllocateHosts;
#[doc(hidden)]
pub type AllocateHostsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AllocateHostsInput {
    /// Consumes the builder and constructs an Operation<[`AllocateHosts`](crate::operation::AllocateHosts)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AllocateHosts,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_allocate_hosts(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AllocateHosts::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AllocateHosts",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AllocateHostsInput`](crate::input::AllocateHostsInput)
    pub fn builder() -> crate::input::allocate_hosts_input::Builder {
        crate::input::allocate_hosts_input::Builder::default()
    }
}

/// See [`ApplySecurityGroupsToClientVpnTargetNetworkInput`](crate::input::ApplySecurityGroupsToClientVpnTargetNetworkInput)
pub mod apply_security_groups_to_client_vpn_target_network_input {
    /// A builder for [`ApplySecurityGroupsToClientVpnTargetNetworkInput`](crate::input::ApplySecurityGroupsToClientVpnTargetNetworkInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The ID of the VPC in which the associated target network is located.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn security_group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.security_group_ids.unwrap_or_default();
            v.push(input.into());
            self.security_group_ids = Some(v);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.security_group_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ApplySecurityGroupsToClientVpnTargetNetworkInput`](crate::input::ApplySecurityGroupsToClientVpnTargetNetworkInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ApplySecurityGroupsToClientVpnTargetNetworkInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::ApplySecurityGroupsToClientVpnTargetNetworkInput {
                    client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                    vpc_id: self.vpc_id,
                    security_group_ids: self.security_group_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type ApplySecurityGroupsToClientVpnTargetNetworkInputOperationOutputAlias =
    crate::operation::ApplySecurityGroupsToClientVpnTargetNetwork;
#[doc(hidden)]
pub type ApplySecurityGroupsToClientVpnTargetNetworkInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ApplySecurityGroupsToClientVpnTargetNetworkInput {
    /// Consumes the builder and constructs an Operation<[`ApplySecurityGroupsToClientVpnTargetNetwork`](crate::operation::ApplySecurityGroupsToClientVpnTargetNetwork)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ApplySecurityGroupsToClientVpnTargetNetwork,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_apply_security_groups_to_client_vpn_target_network(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ApplySecurityGroupsToClientVpnTargetNetwork::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ApplySecurityGroupsToClientVpnTargetNetwork",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ApplySecurityGroupsToClientVpnTargetNetworkInput`](crate::input::ApplySecurityGroupsToClientVpnTargetNetworkInput)
    pub fn builder(
    ) -> crate::input::apply_security_groups_to_client_vpn_target_network_input::Builder {
        crate::input::apply_security_groups_to_client_vpn_target_network_input::Builder::default()
    }
}

/// See [`AssignIpv6AddressesInput`](crate::input::AssignIpv6AddressesInput)
pub mod assign_ipv6_addresses_input {
    /// A builder for [`AssignIpv6AddressesInput`](crate::input::AssignIpv6AddressesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) ipv6_address_count: std::option::Option<i32>,
        pub(crate) ipv6_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The number of additional IPv6 addresses to assign to the network interface.
        /// The specified number of IPv6 addresses are assigned in addition to the
        /// existing IPv6 addresses that are already assigned to the network interface.
        /// Amazon EC2 automatically selects the IPv6 addresses from the subnet range. You
        /// can't use this option if specifying specific IPv6 addresses.</p>
        pub fn ipv6_address_count(mut self, input: i32) -> Self {
            self.ipv6_address_count = Some(input);
            self
        }
        pub fn set_ipv6_address_count(mut self, input: std::option::Option<i32>) -> Self {
            self.ipv6_address_count = input;
            self
        }
        pub fn ipv6_addresses(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.ipv6_addresses.unwrap_or_default();
            v.push(input.into());
            self.ipv6_addresses = Some(v);
            self
        }
        pub fn set_ipv6_addresses(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.ipv6_addresses = input;
            self
        }
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AssignIpv6AddressesInput`](crate::input::AssignIpv6AddressesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssignIpv6AddressesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssignIpv6AddressesInput {
                ipv6_address_count: self.ipv6_address_count,
                ipv6_addresses: self.ipv6_addresses,
                network_interface_id: self.network_interface_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AssignIpv6AddressesInputOperationOutputAlias = crate::operation::AssignIpv6Addresses;
#[doc(hidden)]
pub type AssignIpv6AddressesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssignIpv6AddressesInput {
    /// Consumes the builder and constructs an Operation<[`AssignIpv6Addresses`](crate::operation::AssignIpv6Addresses)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssignIpv6Addresses,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_assign_ipv6_addresses(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssignIpv6Addresses::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssignIpv6Addresses",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssignIpv6AddressesInput`](crate::input::AssignIpv6AddressesInput)
    pub fn builder() -> crate::input::assign_ipv6_addresses_input::Builder {
        crate::input::assign_ipv6_addresses_input::Builder::default()
    }
}

/// See [`AssignPrivateIpAddressesInput`](crate::input::AssignPrivateIpAddressesInput)
pub mod assign_private_ip_addresses_input {
    /// A builder for [`AssignPrivateIpAddressesInput`](crate::input::AssignPrivateIpAddressesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) allow_reassignment: std::option::Option<bool>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) private_ip_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) secondary_private_ip_address_count: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>Indicates whether to allow an IP address that is already assigned to another network interface or instance to be reassigned to the specified network interface.</p>
        pub fn allow_reassignment(mut self, input: bool) -> Self {
            self.allow_reassignment = Some(input);
            self
        }
        pub fn set_allow_reassignment(mut self, input: std::option::Option<bool>) -> Self {
            self.allow_reassignment = input;
            self
        }
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        pub fn private_ip_addresses(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.private_ip_addresses.unwrap_or_default();
            v.push(input.into());
            self.private_ip_addresses = Some(v);
            self
        }
        pub fn set_private_ip_addresses(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.private_ip_addresses = input;
            self
        }
        /// <p>The number of secondary IP addresses to assign to the network interface. You can't specify this parameter when also specifying private IP addresses.</p>
        pub fn secondary_private_ip_address_count(mut self, input: i32) -> Self {
            self.secondary_private_ip_address_count = Some(input);
            self
        }
        pub fn set_secondary_private_ip_address_count(
            mut self,
            input: std::option::Option<i32>,
        ) -> Self {
            self.secondary_private_ip_address_count = input;
            self
        }
        /// Consumes the builder and constructs a [`AssignPrivateIpAddressesInput`](crate::input::AssignPrivateIpAddressesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssignPrivateIpAddressesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssignPrivateIpAddressesInput {
                allow_reassignment: self.allow_reassignment,
                network_interface_id: self.network_interface_id,
                private_ip_addresses: self.private_ip_addresses,
                secondary_private_ip_address_count: self.secondary_private_ip_address_count,
            })
        }
    }
}
#[doc(hidden)]
pub type AssignPrivateIpAddressesInputOperationOutputAlias =
    crate::operation::AssignPrivateIpAddresses;
#[doc(hidden)]
pub type AssignPrivateIpAddressesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssignPrivateIpAddressesInput {
    /// Consumes the builder and constructs an Operation<[`AssignPrivateIpAddresses`](crate::operation::AssignPrivateIpAddresses)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssignPrivateIpAddresses,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_assign_private_ip_addresses(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssignPrivateIpAddresses::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssignPrivateIpAddresses",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssignPrivateIpAddressesInput`](crate::input::AssignPrivateIpAddressesInput)
    pub fn builder() -> crate::input::assign_private_ip_addresses_input::Builder {
        crate::input::assign_private_ip_addresses_input::Builder::default()
    }
}

/// See [`AssociateAddressInput`](crate::input::AssociateAddressInput)
pub mod associate_address_input {
    /// A builder for [`AssociateAddressInput`](crate::input::AssociateAddressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) allocation_id: std::option::Option<std::string::String>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) public_ip: std::option::Option<std::string::String>,
        pub(crate) allow_reassociation: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) private_ip_address: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>[EC2-VPC] The allocation ID. This is required for EC2-VPC.</p>
        pub fn allocation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.allocation_id = Some(input.into());
            self
        }
        pub fn set_allocation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.allocation_id = input;
            self
        }
        /// <p>The ID of the instance. The instance must have exactly one attached network interface.
        /// For EC2-VPC, you can specify either the instance ID or the network interface ID, but not both.
        /// For EC2-Classic, you must specify an instance ID and the instance must be in the running
        /// state.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>[EC2-Classic] The Elastic IP address to associate with the instance. This is required for
        /// EC2-Classic.</p>
        pub fn public_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.public_ip = Some(input.into());
            self
        }
        pub fn set_public_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.public_ip = input;
            self
        }
        /// <p>[EC2-VPC] For a VPC in an EC2-Classic account, specify true to allow an Elastic IP address that is already associated with an instance or network interface to be reassociated with the specified instance or network interface. Otherwise, the operation fails. In a VPC in an EC2-VPC-only account, reassociation is automatic, therefore you can specify false to ensure the operation fails if the Elastic IP address is already associated with another resource.</p>
        pub fn allow_reassociation(mut self, input: bool) -> Self {
            self.allow_reassociation = Some(input);
            self
        }
        pub fn set_allow_reassociation(mut self, input: std::option::Option<bool>) -> Self {
            self.allow_reassociation = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>[EC2-VPC] The ID of the network interface. If the instance has more than one network interface, you must specify a network interface ID.</p>
        /// <p>For EC2-VPC, you can specify either the instance ID or the network interface ID, but not both. </p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>[EC2-VPC] The primary or secondary private IP address to associate with the Elastic IP address. If no private IP address is specified, the Elastic IP address is associated with the primary private IP address.</p>
        pub fn private_ip_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.private_ip_address = Some(input.into());
            self
        }
        pub fn set_private_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.private_ip_address = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateAddressInput`](crate::input::AssociateAddressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateAddressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateAddressInput {
                allocation_id: self.allocation_id,
                instance_id: self.instance_id,
                public_ip: self.public_ip,
                allow_reassociation: self.allow_reassociation,
                dry_run: self.dry_run,
                network_interface_id: self.network_interface_id,
                private_ip_address: self.private_ip_address,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateAddressInputOperationOutputAlias = crate::operation::AssociateAddress;
#[doc(hidden)]
pub type AssociateAddressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateAddressInput {
    /// Consumes the builder and constructs an Operation<[`AssociateAddress`](crate::operation::AssociateAddress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateAddress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_associate_address(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateAddress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateAddress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateAddressInput`](crate::input::AssociateAddressInput)
    pub fn builder() -> crate::input::associate_address_input::Builder {
        crate::input::associate_address_input::Builder::default()
    }
}

/// See [`AssociateClientVpnTargetNetworkInput`](crate::input::AssociateClientVpnTargetNetworkInput)
pub mod associate_client_vpn_target_network_input {
    /// A builder for [`AssociateClientVpnTargetNetworkInput`](crate::input::AssociateClientVpnTargetNetworkInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) subnet_id: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The ID of the subnet to associate with the Client VPN endpoint.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateClientVpnTargetNetworkInput`](crate::input::AssociateClientVpnTargetNetworkInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateClientVpnTargetNetworkInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateClientVpnTargetNetworkInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                subnet_id: self.subnet_id,
                client_token: self.client_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateClientVpnTargetNetworkInputOperationOutputAlias =
    crate::operation::AssociateClientVpnTargetNetwork;
#[doc(hidden)]
pub type AssociateClientVpnTargetNetworkInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateClientVpnTargetNetworkInput {
    /// Consumes the builder and constructs an Operation<[`AssociateClientVpnTargetNetwork`](crate::operation::AssociateClientVpnTargetNetwork)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateClientVpnTargetNetwork,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_associate_client_vpn_target_network(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateClientVpnTargetNetwork::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateClientVpnTargetNetwork",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateClientVpnTargetNetworkInput`](crate::input::AssociateClientVpnTargetNetworkInput)
    pub fn builder() -> crate::input::associate_client_vpn_target_network_input::Builder {
        crate::input::associate_client_vpn_target_network_input::Builder::default()
    }
}

/// See [`AssociateDhcpOptionsInput`](crate::input::AssociateDhcpOptionsInput)
pub mod associate_dhcp_options_input {
    /// A builder for [`AssociateDhcpOptionsInput`](crate::input::AssociateDhcpOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dhcp_options_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the DHCP options set, or <code>default</code> to associate
        /// no DHCP options with the VPC.</p>
        pub fn dhcp_options_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.dhcp_options_id = Some(input.into());
            self
        }
        pub fn set_dhcp_options_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.dhcp_options_id = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateDhcpOptionsInput`](crate::input::AssociateDhcpOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateDhcpOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateDhcpOptionsInput {
                dhcp_options_id: self.dhcp_options_id,
                vpc_id: self.vpc_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateDhcpOptionsInputOperationOutputAlias = crate::operation::AssociateDhcpOptions;
#[doc(hidden)]
pub type AssociateDhcpOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateDhcpOptionsInput {
    /// Consumes the builder and constructs an Operation<[`AssociateDhcpOptions`](crate::operation::AssociateDhcpOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateDhcpOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_associate_dhcp_options(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateDhcpOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateDhcpOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateDhcpOptionsInput`](crate::input::AssociateDhcpOptionsInput)
    pub fn builder() -> crate::input::associate_dhcp_options_input::Builder {
        crate::input::associate_dhcp_options_input::Builder::default()
    }
}

/// See [`AssociateEnclaveCertificateIamRoleInput`](crate::input::AssociateEnclaveCertificateIamRoleInput)
pub mod associate_enclave_certificate_iam_role_input {
    /// A builder for [`AssociateEnclaveCertificateIamRoleInput`](crate::input::AssociateEnclaveCertificateIamRoleInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) certificate_arn: std::option::Option<std::string::String>,
        pub(crate) role_arn: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ARN of the ACM certificate with which to associate the IAM role.</p>
        pub fn certificate_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.certificate_arn = Some(input.into());
            self
        }
        pub fn set_certificate_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.certificate_arn = input;
            self
        }
        /// <p>The ARN of the IAM role to associate with the ACM certificate. You can associate up to 16 IAM roles with an ACM
        /// certificate.</p>
        pub fn role_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.role_arn = Some(input.into());
            self
        }
        pub fn set_role_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.role_arn = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateEnclaveCertificateIamRoleInput`](crate::input::AssociateEnclaveCertificateIamRoleInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateEnclaveCertificateIamRoleInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateEnclaveCertificateIamRoleInput {
                certificate_arn: self.certificate_arn,
                role_arn: self.role_arn,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateEnclaveCertificateIamRoleInputOperationOutputAlias =
    crate::operation::AssociateEnclaveCertificateIamRole;
#[doc(hidden)]
pub type AssociateEnclaveCertificateIamRoleInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateEnclaveCertificateIamRoleInput {
    /// Consumes the builder and constructs an Operation<[`AssociateEnclaveCertificateIamRole`](crate::operation::AssociateEnclaveCertificateIamRole)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateEnclaveCertificateIamRole,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_associate_enclave_certificate_iam_role(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateEnclaveCertificateIamRole::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateEnclaveCertificateIamRole",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateEnclaveCertificateIamRoleInput`](crate::input::AssociateEnclaveCertificateIamRoleInput)
    pub fn builder() -> crate::input::associate_enclave_certificate_iam_role_input::Builder {
        crate::input::associate_enclave_certificate_iam_role_input::Builder::default()
    }
}

/// See [`AssociateIamInstanceProfileInput`](crate::input::AssociateIamInstanceProfileInput)
pub mod associate_iam_instance_profile_input {
    /// A builder for [`AssociateIamInstanceProfileInput`](crate::input::AssociateIamInstanceProfileInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) iam_instance_profile:
            std::option::Option<crate::model::IamInstanceProfileSpecification>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The IAM instance profile.</p>
        pub fn iam_instance_profile(
            mut self,
            input: crate::model::IamInstanceProfileSpecification,
        ) -> Self {
            self.iam_instance_profile = Some(input);
            self
        }
        pub fn set_iam_instance_profile(
            mut self,
            input: std::option::Option<crate::model::IamInstanceProfileSpecification>,
        ) -> Self {
            self.iam_instance_profile = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateIamInstanceProfileInput`](crate::input::AssociateIamInstanceProfileInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateIamInstanceProfileInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateIamInstanceProfileInput {
                iam_instance_profile: self.iam_instance_profile,
                instance_id: self.instance_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateIamInstanceProfileInputOperationOutputAlias =
    crate::operation::AssociateIamInstanceProfile;
#[doc(hidden)]
pub type AssociateIamInstanceProfileInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateIamInstanceProfileInput {
    /// Consumes the builder and constructs an Operation<[`AssociateIamInstanceProfile`](crate::operation::AssociateIamInstanceProfile)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateIamInstanceProfile,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_associate_iam_instance_profile(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateIamInstanceProfile::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateIamInstanceProfile",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateIamInstanceProfileInput`](crate::input::AssociateIamInstanceProfileInput)
    pub fn builder() -> crate::input::associate_iam_instance_profile_input::Builder {
        crate::input::associate_iam_instance_profile_input::Builder::default()
    }
}

/// See [`AssociateRouteTableInput`](crate::input::AssociateRouteTableInput)
pub mod associate_route_table_input {
    /// A builder for [`AssociateRouteTableInput`](crate::input::AssociateRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
        pub(crate) subnet_id: std::option::Option<std::string::String>,
        pub(crate) gateway_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the route table.</p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// <p>The ID of the subnet.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        /// <p>The ID of the internet gateway or virtual private gateway.</p>
        pub fn gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.gateway_id = Some(input.into());
            self
        }
        pub fn set_gateway_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.gateway_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateRouteTableInput`](crate::input::AssociateRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateRouteTableInput {
                dry_run: self.dry_run,
                route_table_id: self.route_table_id,
                subnet_id: self.subnet_id,
                gateway_id: self.gateway_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateRouteTableInputOperationOutputAlias = crate::operation::AssociateRouteTable;
#[doc(hidden)]
pub type AssociateRouteTableInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`AssociateRouteTable`](crate::operation::AssociateRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_associate_route_table(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateRouteTableInput`](crate::input::AssociateRouteTableInput)
    pub fn builder() -> crate::input::associate_route_table_input::Builder {
        crate::input::associate_route_table_input::Builder::default()
    }
}

/// See [`AssociateSubnetCidrBlockInput`](crate::input::AssociateSubnetCidrBlockInput)
pub mod associate_subnet_cidr_block_input {
    /// A builder for [`AssociateSubnetCidrBlockInput`](crate::input::AssociateSubnetCidrBlockInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) subnet_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The IPv6 CIDR block for your subnet. The subnet must have a /64 prefix
        /// length.</p>
        pub fn ipv6_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block = input;
            self
        }
        /// <p>The ID of your subnet.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateSubnetCidrBlockInput`](crate::input::AssociateSubnetCidrBlockInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateSubnetCidrBlockInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateSubnetCidrBlockInput {
                ipv6_cidr_block: self.ipv6_cidr_block,
                subnet_id: self.subnet_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateSubnetCidrBlockInputOperationOutputAlias =
    crate::operation::AssociateSubnetCidrBlock;
#[doc(hidden)]
pub type AssociateSubnetCidrBlockInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateSubnetCidrBlockInput {
    /// Consumes the builder and constructs an Operation<[`AssociateSubnetCidrBlock`](crate::operation::AssociateSubnetCidrBlock)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateSubnetCidrBlock,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_associate_subnet_cidr_block(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateSubnetCidrBlock::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateSubnetCidrBlock",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateSubnetCidrBlockInput`](crate::input::AssociateSubnetCidrBlockInput)
    pub fn builder() -> crate::input::associate_subnet_cidr_block_input::Builder {
        crate::input::associate_subnet_cidr_block_input::Builder::default()
    }
}

/// See [`AssociateTransitGatewayMulticastDomainInput`](crate::input::AssociateTransitGatewayMulticastDomainInput)
pub mod associate_transit_gateway_multicast_domain_input {
    /// A builder for [`AssociateTransitGatewayMulticastDomainInput`](crate::input::AssociateTransitGatewayMulticastDomainInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The ID of the transit gateway attachment to associate with the transit gateway multicast domain.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        pub fn subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.subnet_ids = Some(v);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.subnet_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateTransitGatewayMulticastDomainInput`](crate::input::AssociateTransitGatewayMulticastDomainInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateTransitGatewayMulticastDomainInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateTransitGatewayMulticastDomainInput {
                transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                subnet_ids: self.subnet_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateTransitGatewayMulticastDomainInputOperationOutputAlias =
    crate::operation::AssociateTransitGatewayMulticastDomain;
#[doc(hidden)]
pub type AssociateTransitGatewayMulticastDomainInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl AssociateTransitGatewayMulticastDomainInput {
    /// Consumes the builder and constructs an Operation<[`AssociateTransitGatewayMulticastDomain`](crate::operation::AssociateTransitGatewayMulticastDomain)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateTransitGatewayMulticastDomain,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_associate_transit_gateway_multicast_domain(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateTransitGatewayMulticastDomain::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateTransitGatewayMulticastDomain",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateTransitGatewayMulticastDomainInput`](crate::input::AssociateTransitGatewayMulticastDomainInput)
    pub fn builder() -> crate::input::associate_transit_gateway_multicast_domain_input::Builder {
        crate::input::associate_transit_gateway_multicast_domain_input::Builder::default()
    }
}

/// See [`AssociateTransitGatewayRouteTableInput`](crate::input::AssociateTransitGatewayRouteTableInput)
pub mod associate_transit_gateway_route_table_input {
    /// A builder for [`AssociateTransitGatewayRouteTableInput`](crate::input::AssociateTransitGatewayRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateTransitGatewayRouteTableInput`](crate::input::AssociateTransitGatewayRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateTransitGatewayRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateTransitGatewayRouteTableInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateTransitGatewayRouteTableInputOperationOutputAlias =
    crate::operation::AssociateTransitGatewayRouteTable;
#[doc(hidden)]
pub type AssociateTransitGatewayRouteTableInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateTransitGatewayRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`AssociateTransitGatewayRouteTable`](crate::operation::AssociateTransitGatewayRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateTransitGatewayRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_associate_transit_gateway_route_table(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateTransitGatewayRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateTransitGatewayRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateTransitGatewayRouteTableInput`](crate::input::AssociateTransitGatewayRouteTableInput)
    pub fn builder() -> crate::input::associate_transit_gateway_route_table_input::Builder {
        crate::input::associate_transit_gateway_route_table_input::Builder::default()
    }
}

/// See [`AssociateTrunkInterfaceInput`](crate::input::AssociateTrunkInterfaceInput)
pub mod associate_trunk_interface_input {
    /// A builder for [`AssociateTrunkInterfaceInput`](crate::input::AssociateTrunkInterfaceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) branch_interface_id: std::option::Option<std::string::String>,
        pub(crate) trunk_interface_id: std::option::Option<std::string::String>,
        pub(crate) vlan_id: std::option::Option<i32>,
        pub(crate) gre_key: std::option::Option<i32>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the branch network interface.</p>
        pub fn branch_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.branch_interface_id = Some(input.into());
            self
        }
        pub fn set_branch_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.branch_interface_id = input;
            self
        }
        /// <p>The ID of the trunk network interface.</p>
        pub fn trunk_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.trunk_interface_id = Some(input.into());
            self
        }
        pub fn set_trunk_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.trunk_interface_id = input;
            self
        }
        /// <p>The ID of the VLAN. This applies to the VLAN protocol.</p>
        pub fn vlan_id(mut self, input: i32) -> Self {
            self.vlan_id = Some(input);
            self
        }
        pub fn set_vlan_id(mut self, input: std::option::Option<i32>) -> Self {
            self.vlan_id = input;
            self
        }
        /// <p>The application key. This applies to the GRE protocol.</p>
        pub fn gre_key(mut self, input: i32) -> Self {
            self.gre_key = Some(input);
            self
        }
        pub fn set_gre_key(mut self, input: std::option::Option<i32>) -> Self {
            self.gre_key = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateTrunkInterfaceInput`](crate::input::AssociateTrunkInterfaceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateTrunkInterfaceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateTrunkInterfaceInput {
                branch_interface_id: self.branch_interface_id,
                trunk_interface_id: self.trunk_interface_id,
                vlan_id: self.vlan_id,
                gre_key: self.gre_key,
                client_token: self.client_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateTrunkInterfaceInputOperationOutputAlias =
    crate::operation::AssociateTrunkInterface;
#[doc(hidden)]
pub type AssociateTrunkInterfaceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateTrunkInterfaceInput {
    /// Consumes the builder and constructs an Operation<[`AssociateTrunkInterface`](crate::operation::AssociateTrunkInterface)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateTrunkInterface,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_associate_trunk_interface(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateTrunkInterface::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateTrunkInterface",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateTrunkInterfaceInput`](crate::input::AssociateTrunkInterfaceInput)
    pub fn builder() -> crate::input::associate_trunk_interface_input::Builder {
        crate::input::associate_trunk_interface_input::Builder::default()
    }
}

/// See [`AssociateVpcCidrBlockInput`](crate::input::AssociateVpcCidrBlockInput)
pub mod associate_vpc_cidr_block_input {
    /// A builder for [`AssociateVpcCidrBlockInput`](crate::input::AssociateVpcCidrBlockInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) amazon_provided_ipv6_cidr_block: std::option::Option<bool>,
        pub(crate) cidr_block: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) ipv6_cidr_block_network_border_group: std::option::Option<std::string::String>,
        pub(crate) ipv6_pool: std::option::Option<std::string::String>,
        pub(crate) ipv6_cidr_block: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Requests an Amazon-provided IPv6 CIDR block with a /56 prefix length for the VPC. You cannot specify the range of IPv6 addresses, or the size of the CIDR block.</p>
        pub fn amazon_provided_ipv6_cidr_block(mut self, input: bool) -> Self {
            self.amazon_provided_ipv6_cidr_block = Some(input);
            self
        }
        pub fn set_amazon_provided_ipv6_cidr_block(
            mut self,
            input: std::option::Option<bool>,
        ) -> Self {
            self.amazon_provided_ipv6_cidr_block = input;
            self
        }
        /// <p>An IPv4 CIDR block to associate with the VPC.</p>
        pub fn cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_block = Some(input.into());
            self
        }
        pub fn set_cidr_block(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_block = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>The name of the location from which we advertise the IPV6 CIDR block. Use this parameter
        /// to limit the CIDR block to this location.</p>
        /// <p> You must set <code>AmazonProvidedIpv6CidrBlock</code> to <code>true</code> to use this parameter.</p>
        /// <p> You can have one IPv6 CIDR block association per network border group.</p>
        pub fn ipv6_cidr_block_network_border_group(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block_network_border_group = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block_network_border_group(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block_network_border_group = input;
            self
        }
        /// <p>The ID of an IPv6 address pool from which to allocate the IPv6 CIDR block.</p>
        pub fn ipv6_pool(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_pool = Some(input.into());
            self
        }
        pub fn set_ipv6_pool(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ipv6_pool = input;
            self
        }
        /// <p>An IPv6 CIDR block from the IPv6 address pool. You must also specify <code>Ipv6Pool</code> in the request.</p>
        /// <p>To let Amazon choose the IPv6 CIDR block for you, omit this parameter.</p>
        pub fn ipv6_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block = input;
            self
        }
        /// Consumes the builder and constructs a [`AssociateVpcCidrBlockInput`](crate::input::AssociateVpcCidrBlockInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AssociateVpcCidrBlockInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AssociateVpcCidrBlockInput {
                amazon_provided_ipv6_cidr_block: self.amazon_provided_ipv6_cidr_block,
                cidr_block: self.cidr_block,
                vpc_id: self.vpc_id,
                ipv6_cidr_block_network_border_group: self.ipv6_cidr_block_network_border_group,
                ipv6_pool: self.ipv6_pool,
                ipv6_cidr_block: self.ipv6_cidr_block,
            })
        }
    }
}
#[doc(hidden)]
pub type AssociateVpcCidrBlockInputOperationOutputAlias = crate::operation::AssociateVpcCidrBlock;
#[doc(hidden)]
pub type AssociateVpcCidrBlockInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AssociateVpcCidrBlockInput {
    /// Consumes the builder and constructs an Operation<[`AssociateVpcCidrBlock`](crate::operation::AssociateVpcCidrBlock)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AssociateVpcCidrBlock,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_associate_vpc_cidr_block(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AssociateVpcCidrBlock::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AssociateVpcCidrBlock",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AssociateVpcCidrBlockInput`](crate::input::AssociateVpcCidrBlockInput)
    pub fn builder() -> crate::input::associate_vpc_cidr_block_input::Builder {
        crate::input::associate_vpc_cidr_block_input::Builder::default()
    }
}

/// See [`AttachClassicLinkVpcInput`](crate::input::AttachClassicLinkVpcInput)
pub mod attach_classic_link_vpc_input {
    /// A builder for [`AttachClassicLinkVpcInput`](crate::input::AttachClassicLinkVpcInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) groups: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn groups(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.groups.unwrap_or_default();
            v.push(input.into());
            self.groups = Some(v);
            self
        }
        pub fn set_groups(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.groups = input;
            self
        }
        /// <p>The ID of an EC2-Classic instance to link to the ClassicLink-enabled VPC.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The ID of a ClassicLink-enabled VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AttachClassicLinkVpcInput`](crate::input::AttachClassicLinkVpcInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AttachClassicLinkVpcInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AttachClassicLinkVpcInput {
                dry_run: self.dry_run,
                groups: self.groups,
                instance_id: self.instance_id,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AttachClassicLinkVpcInputOperationOutputAlias = crate::operation::AttachClassicLinkVpc;
#[doc(hidden)]
pub type AttachClassicLinkVpcInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AttachClassicLinkVpcInput {
    /// Consumes the builder and constructs an Operation<[`AttachClassicLinkVpc`](crate::operation::AttachClassicLinkVpc)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AttachClassicLinkVpc,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_attach_classic_link_vpc(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AttachClassicLinkVpc::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AttachClassicLinkVpc",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AttachClassicLinkVpcInput`](crate::input::AttachClassicLinkVpcInput)
    pub fn builder() -> crate::input::attach_classic_link_vpc_input::Builder {
        crate::input::attach_classic_link_vpc_input::Builder::default()
    }
}

/// See [`AttachInternetGatewayInput`](crate::input::AttachInternetGatewayInput)
pub mod attach_internet_gateway_input {
    /// A builder for [`AttachInternetGatewayInput`](crate::input::AttachInternetGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) internet_gateway_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the internet gateway.</p>
        pub fn internet_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.internet_gateway_id = Some(input.into());
            self
        }
        pub fn set_internet_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.internet_gateway_id = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AttachInternetGatewayInput`](crate::input::AttachInternetGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AttachInternetGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AttachInternetGatewayInput {
                dry_run: self.dry_run,
                internet_gateway_id: self.internet_gateway_id,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AttachInternetGatewayInputOperationOutputAlias = crate::operation::AttachInternetGateway;
#[doc(hidden)]
pub type AttachInternetGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AttachInternetGatewayInput {
    /// Consumes the builder and constructs an Operation<[`AttachInternetGateway`](crate::operation::AttachInternetGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AttachInternetGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_attach_internet_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AttachInternetGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AttachInternetGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AttachInternetGatewayInput`](crate::input::AttachInternetGatewayInput)
    pub fn builder() -> crate::input::attach_internet_gateway_input::Builder {
        crate::input::attach_internet_gateway_input::Builder::default()
    }
}

/// See [`AttachNetworkInterfaceInput`](crate::input::AttachNetworkInterfaceInput)
pub mod attach_network_interface_input {
    /// A builder for [`AttachNetworkInterfaceInput`](crate::input::AttachNetworkInterfaceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) device_index: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) network_card_index: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The index of the device for the network interface attachment.</p>
        pub fn device_index(mut self, input: i32) -> Self {
            self.device_index = Some(input);
            self
        }
        pub fn set_device_index(mut self, input: std::option::Option<i32>) -> Self {
            self.device_index = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>The index of the network card. Some instance types support multiple network cards.
        /// The primary network interface must be assigned to network card index 0.
        /// The default is network card index 0.</p>
        pub fn network_card_index(mut self, input: i32) -> Self {
            self.network_card_index = Some(input);
            self
        }
        pub fn set_network_card_index(mut self, input: std::option::Option<i32>) -> Self {
            self.network_card_index = input;
            self
        }
        /// Consumes the builder and constructs a [`AttachNetworkInterfaceInput`](crate::input::AttachNetworkInterfaceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AttachNetworkInterfaceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AttachNetworkInterfaceInput {
                device_index: self.device_index,
                dry_run: self.dry_run,
                instance_id: self.instance_id,
                network_interface_id: self.network_interface_id,
                network_card_index: self.network_card_index,
            })
        }
    }
}
#[doc(hidden)]
pub type AttachNetworkInterfaceInputOperationOutputAlias = crate::operation::AttachNetworkInterface;
#[doc(hidden)]
pub type AttachNetworkInterfaceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AttachNetworkInterfaceInput {
    /// Consumes the builder and constructs an Operation<[`AttachNetworkInterface`](crate::operation::AttachNetworkInterface)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AttachNetworkInterface,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_attach_network_interface(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AttachNetworkInterface::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AttachNetworkInterface",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AttachNetworkInterfaceInput`](crate::input::AttachNetworkInterfaceInput)
    pub fn builder() -> crate::input::attach_network_interface_input::Builder {
        crate::input::attach_network_interface_input::Builder::default()
    }
}

/// See [`AttachVolumeInput`](crate::input::AttachVolumeInput)
pub mod attach_volume_input {
    /// A builder for [`AttachVolumeInput`](crate::input::AttachVolumeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) device: std::option::Option<std::string::String>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) volume_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The device name (for example, <code>/dev/sdh</code> or <code>xvdh</code>).</p>
        pub fn device(mut self, input: impl Into<std::string::String>) -> Self {
            self.device = Some(input.into());
            self
        }
        pub fn set_device(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.device = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The ID of the EBS volume. The volume and instance must be within the same Availability
        /// Zone.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AttachVolumeInput`](crate::input::AttachVolumeInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::AttachVolumeInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::AttachVolumeInput {
                device: self.device,
                instance_id: self.instance_id,
                volume_id: self.volume_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AttachVolumeInputOperationOutputAlias = crate::operation::AttachVolume;
#[doc(hidden)]
pub type AttachVolumeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AttachVolumeInput {
    /// Consumes the builder and constructs an Operation<[`AttachVolume`](crate::operation::AttachVolume)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AttachVolume,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_attach_volume(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AttachVolume::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("AttachVolume", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AttachVolumeInput`](crate::input::AttachVolumeInput)
    pub fn builder() -> crate::input::attach_volume_input::Builder {
        crate::input::attach_volume_input::Builder::default()
    }
}

/// See [`AttachVpnGatewayInput`](crate::input::AttachVpnGatewayInput)
pub mod attach_vpn_gateway_input {
    /// A builder for [`AttachVpnGatewayInput`](crate::input::AttachVpnGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) vpn_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>The ID of the virtual private gateway.</p>
        pub fn vpn_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_gateway_id = Some(input.into());
            self
        }
        pub fn set_vpn_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AttachVpnGatewayInput`](crate::input::AttachVpnGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AttachVpnGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AttachVpnGatewayInput {
                vpc_id: self.vpc_id,
                vpn_gateway_id: self.vpn_gateway_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AttachVpnGatewayInputOperationOutputAlias = crate::operation::AttachVpnGateway;
#[doc(hidden)]
pub type AttachVpnGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AttachVpnGatewayInput {
    /// Consumes the builder and constructs an Operation<[`AttachVpnGateway`](crate::operation::AttachVpnGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AttachVpnGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_attach_vpn_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AttachVpnGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AttachVpnGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AttachVpnGatewayInput`](crate::input::AttachVpnGatewayInput)
    pub fn builder() -> crate::input::attach_vpn_gateway_input::Builder {
        crate::input::attach_vpn_gateway_input::Builder::default()
    }
}

/// See [`AuthorizeClientVpnIngressInput`](crate::input::AuthorizeClientVpnIngressInput)
pub mod authorize_client_vpn_ingress_input {
    /// A builder for [`AuthorizeClientVpnIngressInput`](crate::input::AuthorizeClientVpnIngressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) target_network_cidr: std::option::Option<std::string::String>,
        pub(crate) access_group_id: std::option::Option<std::string::String>,
        pub(crate) authorize_all_groups: std::option::Option<bool>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The IPv4 address range, in CIDR notation, of the network for which access is being authorized.</p>
        pub fn target_network_cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.target_network_cidr = Some(input.into());
            self
        }
        pub fn set_target_network_cidr(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.target_network_cidr = input;
            self
        }
        /// <p>The ID of the group to grant access to, for example, the Active Directory group or identity provider (IdP) group. Required if <code>AuthorizeAllGroups</code> is <code>false</code> or not specified.</p>
        pub fn access_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.access_group_id = Some(input.into());
            self
        }
        pub fn set_access_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.access_group_id = input;
            self
        }
        /// <p>Indicates whether to grant access to all clients. Specify <code>true</code> to grant all
        /// clients who successfully establish a VPN connection access to the network. Must be set
        /// to <code>true</code> if <code>AccessGroupId</code> is not specified.</p>
        pub fn authorize_all_groups(mut self, input: bool) -> Self {
            self.authorize_all_groups = Some(input);
            self
        }
        pub fn set_authorize_all_groups(mut self, input: std::option::Option<bool>) -> Self {
            self.authorize_all_groups = input;
            self
        }
        /// <p>A brief description of the authorization rule.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AuthorizeClientVpnIngressInput`](crate::input::AuthorizeClientVpnIngressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AuthorizeClientVpnIngressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AuthorizeClientVpnIngressInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                target_network_cidr: self.target_network_cidr,
                access_group_id: self.access_group_id,
                authorize_all_groups: self.authorize_all_groups,
                description: self.description,
                client_token: self.client_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AuthorizeClientVpnIngressInputOperationOutputAlias =
    crate::operation::AuthorizeClientVpnIngress;
#[doc(hidden)]
pub type AuthorizeClientVpnIngressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AuthorizeClientVpnIngressInput {
    /// Consumes the builder and constructs an Operation<[`AuthorizeClientVpnIngress`](crate::operation::AuthorizeClientVpnIngress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AuthorizeClientVpnIngress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_authorize_client_vpn_ingress(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AuthorizeClientVpnIngress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AuthorizeClientVpnIngress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AuthorizeClientVpnIngressInput`](crate::input::AuthorizeClientVpnIngressInput)
    pub fn builder() -> crate::input::authorize_client_vpn_ingress_input::Builder {
        crate::input::authorize_client_vpn_ingress_input::Builder::default()
    }
}

/// See [`AuthorizeSecurityGroupEgressInput`](crate::input::AuthorizeSecurityGroupEgressInput)
pub mod authorize_security_group_egress_input {
    /// A builder for [`AuthorizeSecurityGroupEgressInput`](crate::input::AuthorizeSecurityGroupEgressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_id: std::option::Option<std::string::String>,
        pub(crate) ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        pub(crate) cidr_ip: std::option::Option<std::string::String>,
        pub(crate) from_port: std::option::Option<i32>,
        pub(crate) ip_protocol: std::option::Option<std::string::String>,
        pub(crate) to_port: std::option::Option<i32>,
        pub(crate) source_security_group_name: std::option::Option<std::string::String>,
        pub(crate) source_security_group_owner_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the security group.</p>
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_id = Some(input.into());
            self
        }
        pub fn set_group_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_id = input;
            self
        }
        pub fn ip_permissions(mut self, input: impl Into<crate::model::IpPermission>) -> Self {
            let mut v = self.ip_permissions.unwrap_or_default();
            v.push(input.into());
            self.ip_permissions = Some(v);
            self
        }
        pub fn set_ip_permissions(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        ) -> Self {
            self.ip_permissions = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the CIDR.</p>
        pub fn cidr_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_ip = Some(input.into());
            self
        }
        pub fn set_cidr_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_ip = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
        pub fn from_port(mut self, input: i32) -> Self {
            self.from_port = Some(input);
            self
        }
        pub fn set_from_port(mut self, input: std::option::Option<i32>) -> Self {
            self.from_port = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the protocol name or
        /// number.</p>
        pub fn ip_protocol(mut self, input: impl Into<std::string::String>) -> Self {
            self.ip_protocol = Some(input.into());
            self
        }
        pub fn set_ip_protocol(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ip_protocol = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
        pub fn to_port(mut self, input: i32) -> Self {
            self.to_port = Some(input);
            self
        }
        pub fn set_to_port(mut self, input: std::option::Option<i32>) -> Self {
            self.to_port = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify a
        /// destination security group.</p>
        pub fn source_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_security_group_name = Some(input.into());
            self
        }
        pub fn set_source_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_name = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify a
        /// destination security group.</p>
        pub fn source_security_group_owner_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = Some(input.into());
            self
        }
        pub fn set_source_security_group_owner_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = input;
            self
        }
        /// Consumes the builder and constructs a [`AuthorizeSecurityGroupEgressInput`](crate::input::AuthorizeSecurityGroupEgressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AuthorizeSecurityGroupEgressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AuthorizeSecurityGroupEgressInput {
                dry_run: self.dry_run,
                group_id: self.group_id,
                ip_permissions: self.ip_permissions,
                cidr_ip: self.cidr_ip,
                from_port: self.from_port,
                ip_protocol: self.ip_protocol,
                to_port: self.to_port,
                source_security_group_name: self.source_security_group_name,
                source_security_group_owner_id: self.source_security_group_owner_id,
            })
        }
    }
}
#[doc(hidden)]
pub type AuthorizeSecurityGroupEgressInputOperationOutputAlias =
    crate::operation::AuthorizeSecurityGroupEgress;
#[doc(hidden)]
pub type AuthorizeSecurityGroupEgressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AuthorizeSecurityGroupEgressInput {
    /// Consumes the builder and constructs an Operation<[`AuthorizeSecurityGroupEgress`](crate::operation::AuthorizeSecurityGroupEgress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AuthorizeSecurityGroupEgress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_authorize_security_group_egress(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AuthorizeSecurityGroupEgress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AuthorizeSecurityGroupEgress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AuthorizeSecurityGroupEgressInput`](crate::input::AuthorizeSecurityGroupEgressInput)
    pub fn builder() -> crate::input::authorize_security_group_egress_input::Builder {
        crate::input::authorize_security_group_egress_input::Builder::default()
    }
}

/// See [`AuthorizeSecurityGroupIngressInput`](crate::input::AuthorizeSecurityGroupIngressInput)
pub mod authorize_security_group_ingress_input {
    /// A builder for [`AuthorizeSecurityGroupIngressInput`](crate::input::AuthorizeSecurityGroupIngressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr_ip: std::option::Option<std::string::String>,
        pub(crate) from_port: std::option::Option<i32>,
        pub(crate) group_id: std::option::Option<std::string::String>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        pub(crate) ip_protocol: std::option::Option<std::string::String>,
        pub(crate) source_security_group_name: std::option::Option<std::string::String>,
        pub(crate) source_security_group_owner_id: std::option::Option<std::string::String>,
        pub(crate) to_port: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The IPv4 address range, in CIDR format. You can't specify this parameter when specifying a source
        /// security group. To specify an IPv6 address range, use a set of IP permissions.</p>
        /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
        pub fn cidr_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_ip = Some(input.into());
            self
        }
        pub fn set_cidr_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_ip = input;
            self
        }
        /// <p>The start of port range for the TCP and UDP protocols, or an ICMP type number.
        /// For the ICMP type number, use <code>-1</code> to specify all types. If you
        /// specify all ICMP types, you must specify all codes.</p>
        /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
        pub fn from_port(mut self, input: i32) -> Self {
            self.from_port = Some(input);
            self
        }
        pub fn set_from_port(mut self, input: std::option::Option<i32>) -> Self {
            self.from_port = input;
            self
        }
        /// <p>The ID of the security group. You must specify either the security group ID or the
        /// security group name in the request. For security groups in a nondefault VPC, you must
        /// specify the security group ID.</p>
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_id = Some(input.into());
            self
        }
        pub fn set_group_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_id = input;
            self
        }
        /// <p>[EC2-Classic, default VPC] The name of the security group. You must specify either the
        /// security group ID or the security group name in the request.</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        pub fn ip_permissions(mut self, input: impl Into<crate::model::IpPermission>) -> Self {
            let mut v = self.ip_permissions.unwrap_or_default();
            v.push(input.into());
            self.ip_permissions = Some(v);
            self
        }
        pub fn set_ip_permissions(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        ) -> Self {
            self.ip_permissions = input;
            self
        }
        /// <p>The IP protocol name (<code>tcp</code>, <code>udp</code>, <code>icmp</code>) or number
        /// (see <a href="http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml">Protocol Numbers</a>). To specify <code>icmpv6</code>, use a set of IP permissions.</p>
        /// <p>[VPC only] Use <code>-1</code> to specify all protocols. If you specify <code>-1</code> or a
        /// protocol other than <code>tcp</code>, <code>udp</code>, or <code>icmp</code>, traffic on all ports
        /// is allowed, regardless of any ports you specify.</p>
        /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
        pub fn ip_protocol(mut self, input: impl Into<std::string::String>) -> Self {
            self.ip_protocol = Some(input.into());
            self
        }
        pub fn set_ip_protocol(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ip_protocol = input;
            self
        }
        /// <p>[EC2-Classic, default VPC] The name of the source security group. You can't specify this parameter
        /// in combination with the following parameters: the CIDR IP address range, the start of the port range,
        /// the IP protocol, and the end of the port range. Creates rules that grant full ICMP, UDP, and TCP access.
        /// To create a rule with a specific IP protocol and port range, use a set of IP permissions instead. For
        /// EC2-VPC, the source security group must be in the same VPC.</p>
        pub fn source_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_security_group_name = Some(input.into());
            self
        }
        pub fn set_source_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_name = input;
            self
        }
        /// <p>[nondefault VPC] The AWS account ID for the source security group, if the source security group is
        /// in a different account. You can't specify this parameter in combination with the following parameters:
        /// the CIDR IP address range, the IP protocol, the start of the port range, and the end of the port range.
        /// Creates rules that grant full ICMP, UDP, and TCP access. To create a rule with a specific IP protocol
        /// and port range, use a set of IP permissions instead.</p>
        pub fn source_security_group_owner_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = Some(input.into());
            self
        }
        pub fn set_source_security_group_owner_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = input;
            self
        }
        /// <p>The end of port range for the TCP and UDP protocols, or an ICMP code number.
        /// For the ICMP code number, use <code>-1</code> to specify all codes. If you
        /// specify all ICMP types, you must specify all codes.</p>
        /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
        pub fn to_port(mut self, input: i32) -> Self {
            self.to_port = Some(input);
            self
        }
        pub fn set_to_port(mut self, input: std::option::Option<i32>) -> Self {
            self.to_port = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`AuthorizeSecurityGroupIngressInput`](crate::input::AuthorizeSecurityGroupIngressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::AuthorizeSecurityGroupIngressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::AuthorizeSecurityGroupIngressInput {
                cidr_ip: self.cidr_ip,
                from_port: self.from_port,
                group_id: self.group_id,
                group_name: self.group_name,
                ip_permissions: self.ip_permissions,
                ip_protocol: self.ip_protocol,
                source_security_group_name: self.source_security_group_name,
                source_security_group_owner_id: self.source_security_group_owner_id,
                to_port: self.to_port,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type AuthorizeSecurityGroupIngressInputOperationOutputAlias =
    crate::operation::AuthorizeSecurityGroupIngress;
#[doc(hidden)]
pub type AuthorizeSecurityGroupIngressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl AuthorizeSecurityGroupIngressInput {
    /// Consumes the builder and constructs an Operation<[`AuthorizeSecurityGroupIngress`](crate::operation::AuthorizeSecurityGroupIngress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::AuthorizeSecurityGroupIngress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_authorize_security_group_ingress(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::AuthorizeSecurityGroupIngress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "AuthorizeSecurityGroupIngress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`AuthorizeSecurityGroupIngressInput`](crate::input::AuthorizeSecurityGroupIngressInput)
    pub fn builder() -> crate::input::authorize_security_group_ingress_input::Builder {
        crate::input::authorize_security_group_ingress_input::Builder::default()
    }
}

/// See [`BundleInstanceInput`](crate::input::BundleInstanceInput)
pub mod bundle_instance_input {
    /// A builder for [`BundleInstanceInput`](crate::input::BundleInstanceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) storage: std::option::Option<crate::model::Storage>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the instance to bundle.</p>
        /// <p>Type: String</p>
        /// <p>Default: None</p>
        /// <p>Required: Yes</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The bucket in which to store the AMI. You can specify a bucket that you already own or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to someone else, Amazon EC2 returns an error.</p>
        pub fn storage(mut self, input: crate::model::Storage) -> Self {
            self.storage = Some(input);
            self
        }
        pub fn set_storage(mut self, input: std::option::Option<crate::model::Storage>) -> Self {
            self.storage = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`BundleInstanceInput`](crate::input::BundleInstanceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::BundleInstanceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::BundleInstanceInput {
                instance_id: self.instance_id,
                storage: self.storage,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type BundleInstanceInputOperationOutputAlias = crate::operation::BundleInstance;
#[doc(hidden)]
pub type BundleInstanceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl BundleInstanceInput {
    /// Consumes the builder and constructs an Operation<[`BundleInstance`](crate::operation::BundleInstance)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::BundleInstance,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_bundle_instance(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::BundleInstance::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "BundleInstance",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`BundleInstanceInput`](crate::input::BundleInstanceInput)
    pub fn builder() -> crate::input::bundle_instance_input::Builder {
        crate::input::bundle_instance_input::Builder::default()
    }
}

/// See [`CancelBundleTaskInput`](crate::input::CancelBundleTaskInput)
pub mod cancel_bundle_task_input {
    /// A builder for [`CancelBundleTaskInput`](crate::input::CancelBundleTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) bundle_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the bundle task.</p>
        pub fn bundle_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.bundle_id = Some(input.into());
            self
        }
        pub fn set_bundle_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.bundle_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelBundleTaskInput`](crate::input::CancelBundleTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelBundleTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelBundleTaskInput {
                bundle_id: self.bundle_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelBundleTaskInputOperationOutputAlias = crate::operation::CancelBundleTask;
#[doc(hidden)]
pub type CancelBundleTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelBundleTaskInput {
    /// Consumes the builder and constructs an Operation<[`CancelBundleTask`](crate::operation::CancelBundleTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelBundleTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_cancel_bundle_task(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelBundleTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelBundleTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelBundleTaskInput`](crate::input::CancelBundleTaskInput)
    pub fn builder() -> crate::input::cancel_bundle_task_input::Builder {
        crate::input::cancel_bundle_task_input::Builder::default()
    }
}

/// See [`CancelCapacityReservationInput`](crate::input::CancelCapacityReservationInput)
pub mod cancel_capacity_reservation_input {
    /// A builder for [`CancelCapacityReservationInput`](crate::input::CancelCapacityReservationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) capacity_reservation_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Capacity Reservation to be cancelled.</p>
        pub fn capacity_reservation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.capacity_reservation_id = Some(input.into());
            self
        }
        pub fn set_capacity_reservation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.capacity_reservation_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelCapacityReservationInput`](crate::input::CancelCapacityReservationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelCapacityReservationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelCapacityReservationInput {
                capacity_reservation_id: self.capacity_reservation_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelCapacityReservationInputOperationOutputAlias =
    crate::operation::CancelCapacityReservation;
#[doc(hidden)]
pub type CancelCapacityReservationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelCapacityReservationInput {
    /// Consumes the builder and constructs an Operation<[`CancelCapacityReservation`](crate::operation::CancelCapacityReservation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelCapacityReservation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_cancel_capacity_reservation(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelCapacityReservation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelCapacityReservation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelCapacityReservationInput`](crate::input::CancelCapacityReservationInput)
    pub fn builder() -> crate::input::cancel_capacity_reservation_input::Builder {
        crate::input::cancel_capacity_reservation_input::Builder::default()
    }
}

/// See [`CancelConversionTaskInput`](crate::input::CancelConversionTaskInput)
pub mod cancel_conversion_task_input {
    /// A builder for [`CancelConversionTaskInput`](crate::input::CancelConversionTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) conversion_task_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) reason_message: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the conversion task.</p>
        pub fn conversion_task_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.conversion_task_id = Some(input.into());
            self
        }
        pub fn set_conversion_task_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.conversion_task_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The reason for canceling the conversion task.</p>
        pub fn reason_message(mut self, input: impl Into<std::string::String>) -> Self {
            self.reason_message = Some(input.into());
            self
        }
        pub fn set_reason_message(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.reason_message = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelConversionTaskInput`](crate::input::CancelConversionTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelConversionTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelConversionTaskInput {
                conversion_task_id: self.conversion_task_id,
                dry_run: self.dry_run,
                reason_message: self.reason_message,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelConversionTaskInputOperationOutputAlias = crate::operation::CancelConversionTask;
#[doc(hidden)]
pub type CancelConversionTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelConversionTaskInput {
    /// Consumes the builder and constructs an Operation<[`CancelConversionTask`](crate::operation::CancelConversionTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelConversionTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_cancel_conversion_task(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelConversionTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelConversionTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelConversionTaskInput`](crate::input::CancelConversionTaskInput)
    pub fn builder() -> crate::input::cancel_conversion_task_input::Builder {
        crate::input::cancel_conversion_task_input::Builder::default()
    }
}

/// See [`CancelExportTaskInput`](crate::input::CancelExportTaskInput)
pub mod cancel_export_task_input {
    /// A builder for [`CancelExportTaskInput`](crate::input::CancelExportTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) export_task_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the export task. This is the ID returned by <code>CreateInstanceExportTask</code>.</p>
        pub fn export_task_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.export_task_id = Some(input.into());
            self
        }
        pub fn set_export_task_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.export_task_id = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelExportTaskInput`](crate::input::CancelExportTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelExportTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelExportTaskInput {
                export_task_id: self.export_task_id,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelExportTaskInputOperationOutputAlias = crate::operation::CancelExportTask;
#[doc(hidden)]
pub type CancelExportTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelExportTaskInput {
    /// Consumes the builder and constructs an Operation<[`CancelExportTask`](crate::operation::CancelExportTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelExportTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_cancel_export_task(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelExportTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelExportTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelExportTaskInput`](crate::input::CancelExportTaskInput)
    pub fn builder() -> crate::input::cancel_export_task_input::Builder {
        crate::input::cancel_export_task_input::Builder::default()
    }
}

/// See [`CancelImportTaskInput`](crate::input::CancelImportTaskInput)
pub mod cancel_import_task_input {
    /// A builder for [`CancelImportTaskInput`](crate::input::CancelImportTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cancel_reason: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) import_task_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The reason for canceling the task.</p>
        pub fn cancel_reason(mut self, input: impl Into<std::string::String>) -> Self {
            self.cancel_reason = Some(input.into());
            self
        }
        pub fn set_cancel_reason(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.cancel_reason = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the import image or import snapshot task to be canceled.</p>
        pub fn import_task_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.import_task_id = Some(input.into());
            self
        }
        pub fn set_import_task_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.import_task_id = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelImportTaskInput`](crate::input::CancelImportTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelImportTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelImportTaskInput {
                cancel_reason: self.cancel_reason,
                dry_run: self.dry_run,
                import_task_id: self.import_task_id,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelImportTaskInputOperationOutputAlias = crate::operation::CancelImportTask;
#[doc(hidden)]
pub type CancelImportTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelImportTaskInput {
    /// Consumes the builder and constructs an Operation<[`CancelImportTask`](crate::operation::CancelImportTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelImportTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_cancel_import_task(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelImportTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelImportTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelImportTaskInput`](crate::input::CancelImportTaskInput)
    pub fn builder() -> crate::input::cancel_import_task_input::Builder {
        crate::input::cancel_import_task_input::Builder::default()
    }
}

/// See [`CancelReservedInstancesListingInput`](crate::input::CancelReservedInstancesListingInput)
pub mod cancel_reserved_instances_listing_input {
    /// A builder for [`CancelReservedInstancesListingInput`](crate::input::CancelReservedInstancesListingInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) reserved_instances_listing_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the Reserved Instance listing.</p>
        pub fn reserved_instances_listing_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.reserved_instances_listing_id = Some(input.into());
            self
        }
        pub fn set_reserved_instances_listing_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.reserved_instances_listing_id = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelReservedInstancesListingInput`](crate::input::CancelReservedInstancesListingInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelReservedInstancesListingInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelReservedInstancesListingInput {
                reserved_instances_listing_id: self.reserved_instances_listing_id,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelReservedInstancesListingInputOperationOutputAlias =
    crate::operation::CancelReservedInstancesListing;
#[doc(hidden)]
pub type CancelReservedInstancesListingInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelReservedInstancesListingInput {
    /// Consumes the builder and constructs an Operation<[`CancelReservedInstancesListing`](crate::operation::CancelReservedInstancesListing)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelReservedInstancesListing,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_cancel_reserved_instances_listing(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelReservedInstancesListing::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelReservedInstancesListing",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelReservedInstancesListingInput`](crate::input::CancelReservedInstancesListingInput)
    pub fn builder() -> crate::input::cancel_reserved_instances_listing_input::Builder {
        crate::input::cancel_reserved_instances_listing_input::Builder::default()
    }
}

/// See [`CancelSpotFleetRequestsInput`](crate::input::CancelSpotFleetRequestsInput)
pub mod cancel_spot_fleet_requests_input {
    /// A builder for [`CancelSpotFleetRequestsInput`](crate::input::CancelSpotFleetRequestsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) spot_fleet_request_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) terminate_instances: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn spot_fleet_request_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.spot_fleet_request_ids.unwrap_or_default();
            v.push(input.into());
            self.spot_fleet_request_ids = Some(v);
            self
        }
        pub fn set_spot_fleet_request_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.spot_fleet_request_ids = input;
            self
        }
        /// <p>Indicates whether to terminate instances for a Spot Fleet request if it is canceled
        /// successfully.</p>
        pub fn terminate_instances(mut self, input: bool) -> Self {
            self.terminate_instances = Some(input);
            self
        }
        pub fn set_terminate_instances(mut self, input: std::option::Option<bool>) -> Self {
            self.terminate_instances = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelSpotFleetRequestsInput`](crate::input::CancelSpotFleetRequestsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelSpotFleetRequestsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelSpotFleetRequestsInput {
                dry_run: self.dry_run,
                spot_fleet_request_ids: self.spot_fleet_request_ids,
                terminate_instances: self.terminate_instances,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelSpotFleetRequestsInputOperationOutputAlias =
    crate::operation::CancelSpotFleetRequests;
#[doc(hidden)]
pub type CancelSpotFleetRequestsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelSpotFleetRequestsInput {
    /// Consumes the builder and constructs an Operation<[`CancelSpotFleetRequests`](crate::operation::CancelSpotFleetRequests)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelSpotFleetRequests,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_cancel_spot_fleet_requests(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelSpotFleetRequests::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelSpotFleetRequests",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelSpotFleetRequestsInput`](crate::input::CancelSpotFleetRequestsInput)
    pub fn builder() -> crate::input::cancel_spot_fleet_requests_input::Builder {
        crate::input::cancel_spot_fleet_requests_input::Builder::default()
    }
}

/// See [`CancelSpotInstanceRequestsInput`](crate::input::CancelSpotInstanceRequestsInput)
pub mod cancel_spot_instance_requests_input {
    /// A builder for [`CancelSpotInstanceRequestsInput`](crate::input::CancelSpotInstanceRequestsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) spot_instance_request_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn spot_instance_request_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.spot_instance_request_ids.unwrap_or_default();
            v.push(input.into());
            self.spot_instance_request_ids = Some(v);
            self
        }
        pub fn set_spot_instance_request_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.spot_instance_request_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`CancelSpotInstanceRequestsInput`](crate::input::CancelSpotInstanceRequestsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CancelSpotInstanceRequestsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CancelSpotInstanceRequestsInput {
                dry_run: self.dry_run,
                spot_instance_request_ids: self.spot_instance_request_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type CancelSpotInstanceRequestsInputOperationOutputAlias =
    crate::operation::CancelSpotInstanceRequests;
#[doc(hidden)]
pub type CancelSpotInstanceRequestsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CancelSpotInstanceRequestsInput {
    /// Consumes the builder and constructs an Operation<[`CancelSpotInstanceRequests`](crate::operation::CancelSpotInstanceRequests)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CancelSpotInstanceRequests,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_cancel_spot_instance_requests(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CancelSpotInstanceRequests::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CancelSpotInstanceRequests",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CancelSpotInstanceRequestsInput`](crate::input::CancelSpotInstanceRequestsInput)
    pub fn builder() -> crate::input::cancel_spot_instance_requests_input::Builder {
        crate::input::cancel_spot_instance_requests_input::Builder::default()
    }
}

/// See [`ConfirmProductInstanceInput`](crate::input::ConfirmProductInstanceInput)
pub mod confirm_product_instance_input {
    /// A builder for [`ConfirmProductInstanceInput`](crate::input::ConfirmProductInstanceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) product_code: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The product code. This must be a product code that you own.</p>
        pub fn product_code(mut self, input: impl Into<std::string::String>) -> Self {
            self.product_code = Some(input.into());
            self
        }
        pub fn set_product_code(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.product_code = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ConfirmProductInstanceInput`](crate::input::ConfirmProductInstanceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ConfirmProductInstanceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ConfirmProductInstanceInput {
                instance_id: self.instance_id,
                product_code: self.product_code,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ConfirmProductInstanceInputOperationOutputAlias = crate::operation::ConfirmProductInstance;
#[doc(hidden)]
pub type ConfirmProductInstanceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ConfirmProductInstanceInput {
    /// Consumes the builder and constructs an Operation<[`ConfirmProductInstance`](crate::operation::ConfirmProductInstance)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ConfirmProductInstance,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_confirm_product_instance(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ConfirmProductInstance::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ConfirmProductInstance",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ConfirmProductInstanceInput`](crate::input::ConfirmProductInstanceInput)
    pub fn builder() -> crate::input::confirm_product_instance_input::Builder {
        crate::input::confirm_product_instance_input::Builder::default()
    }
}

/// See [`CopyFpgaImageInput`](crate::input::CopyFpgaImageInput)
pub mod copy_fpga_image_input {
    /// A builder for [`CopyFpgaImageInput`](crate::input::CopyFpgaImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) source_fpga_image_id: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) source_region: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the source AFI.</p>
        pub fn source_fpga_image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_fpga_image_id = Some(input.into());
            self
        }
        pub fn set_source_fpga_image_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_fpga_image_id = input;
            self
        }
        /// <p>The description for the new AFI.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The name for the new AFI. The default is the name of the source AFI.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        /// <p>The Region that contains the source AFI.</p>
        pub fn source_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_region = Some(input.into());
            self
        }
        pub fn set_source_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_region = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
        /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CopyFpgaImageInput`](crate::input::CopyFpgaImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CopyFpgaImageInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CopyFpgaImageInput {
                dry_run: self.dry_run,
                source_fpga_image_id: self.source_fpga_image_id,
                description: self.description,
                name: self.name,
                source_region: self.source_region,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CopyFpgaImageInputOperationOutputAlias = crate::operation::CopyFpgaImage;
#[doc(hidden)]
pub type CopyFpgaImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CopyFpgaImageInput {
    /// Consumes the builder and constructs an Operation<[`CopyFpgaImage`](crate::operation::CopyFpgaImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CopyFpgaImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_copy_fpga_image(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CopyFpgaImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CopyFpgaImage",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CopyFpgaImageInput`](crate::input::CopyFpgaImageInput)
    pub fn builder() -> crate::input::copy_fpga_image_input::Builder {
        crate::input::copy_fpga_image_input::Builder::default()
    }
}

/// See [`CopyImageInput`](crate::input::CopyImageInput)
pub mod copy_image_input {
    /// A builder for [`CopyImageInput`](crate::input::CopyImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) encrypted: std::option::Option<bool>,
        pub(crate) kms_key_id: std::option::Option<std::string::String>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) source_image_id: std::option::Option<std::string::String>,
        pub(crate) source_region: std::option::Option<std::string::String>,
        pub(crate) destination_outpost_arn: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Unique, case-sensitive identifier you provide to ensure
        /// idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring idempotency</a>
        /// in the <i>Amazon EC2 API Reference</i>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>A description for the new AMI in the destination Region.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Specifies whether the destination snapshots of the copied image should be encrypted.
        /// You can encrypt a copy of an unencrypted snapshot, but you cannot create an unencrypted
        /// copy of an encrypted snapshot. The default CMK for EBS is used unless you specify a non-default
        /// AWS Key Management Service (AWS KMS) CMK using <code>KmsKeyId</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS Encryption</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn encrypted(mut self, input: bool) -> Self {
            self.encrypted = Some(input);
            self
        }
        pub fn set_encrypted(mut self, input: std::option::Option<bool>) -> Self {
            self.encrypted = input;
            self
        }
        /// <p>The identifier of the symmetric AWS Key Management Service (AWS KMS) customer master key (CMK) to use when creating
        /// encrypted volumes. If this parameter is not specified, your AWS managed CMK for EBS is used.
        /// If you specify a CMK, you must also set the encrypted state to <code>true</code>.</p>
        /// <p>You can specify a CMK using any of the following:</p>
        /// <ul>
        /// <li>
        /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Key alias. For example, alias/ExampleAlias.</p>
        /// </li>
        /// <li>
        /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
        /// </li>
        /// </ul>
        /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an identifier that is not valid,
        /// the action can appear to complete, but eventually fails.</p>
        /// <p>The specified CMK must exist in the destination Region.</p>
        /// <p>Amazon EBS does not support asymmetric CMKs.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kms_key_id = Some(input.into());
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kms_key_id = input;
            self
        }
        /// <p>The name of the new AMI in the destination Region.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        /// <p>The ID of the AMI to copy.</p>
        pub fn source_image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_image_id = Some(input.into());
            self
        }
        pub fn set_source_image_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_image_id = input;
            self
        }
        /// <p>The name of the Region that contains the AMI to copy.</p>
        pub fn source_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_region = Some(input.into());
            self
        }
        pub fn set_source_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_region = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Outpost to which to copy the AMI. Only
        /// specify this parameter when copying an AMI from an AWS Region to an Outpost.
        /// The AMI must be in the Region of the destination Outpost. You cannot copy an
        /// AMI from an Outpost to a Region, from one Outpost to another, or within the same
        /// Outpost.</p>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#copy-amis">
        /// Copying AMIs from an AWS Region to an Outpost</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn destination_outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_outpost_arn = Some(input.into());
            self
        }
        pub fn set_destination_outpost_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_outpost_arn = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CopyImageInput`](crate::input::CopyImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CopyImageInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CopyImageInput {
                client_token: self.client_token,
                description: self.description,
                encrypted: self.encrypted,
                kms_key_id: self.kms_key_id,
                name: self.name,
                source_image_id: self.source_image_id,
                source_region: self.source_region,
                destination_outpost_arn: self.destination_outpost_arn,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CopyImageInputOperationOutputAlias = crate::operation::CopyImage;
#[doc(hidden)]
pub type CopyImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CopyImageInput {
    /// Consumes the builder and constructs an Operation<[`CopyImage`](crate::operation::CopyImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CopyImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_copy_image(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op =
                smithy_http::operation::Operation::new(request, crate::operation::CopyImage::new())
                    .with_metadata(smithy_http::operation::Metadata::new("CopyImage", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CopyImageInput`](crate::input::CopyImageInput)
    pub fn builder() -> crate::input::copy_image_input::Builder {
        crate::input::copy_image_input::Builder::default()
    }
}

/// See [`CopySnapshotInput`](crate::input::CopySnapshotInput)
pub mod copy_snapshot_input {
    /// A builder for [`CopySnapshotInput`](crate::input::CopySnapshotInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) destination_outpost_arn: std::option::Option<std::string::String>,
        pub(crate) destination_region: std::option::Option<std::string::String>,
        pub(crate) encrypted: std::option::Option<bool>,
        pub(crate) kms_key_id: std::option::Option<std::string::String>,
        pub(crate) presigned_url: std::option::Option<std::string::String>,
        pub(crate) source_region: std::option::Option<std::string::String>,
        pub(crate) source_snapshot_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>A description for the EBS snapshot.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Outpost to which to copy the snapshot. Only
        /// specify this parameter when copying a snapshot from an AWS Region to an Outpost.
        /// The snapshot must be in the Region for the destination Outpost. You cannot copy a
        /// snapshot from an Outpost to a Region, from one Outpost to another, or within the same
        /// Outpost.</p>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#copy-snapshots">
        /// Copying snapshots from an AWS Region to an Outpost</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn destination_outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_outpost_arn = Some(input.into());
            self
        }
        pub fn set_destination_outpost_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_outpost_arn = input;
            self
        }
        /// <p>The destination Region to use in the <code>PresignedUrl</code> parameter of a snapshot
        /// copy operation. This parameter is only valid for specifying the destination Region in a
        /// <code>PresignedUrl</code> parameter, where it is required.</p>
        /// <p>The snapshot copy is sent to the regional endpoint that you sent the HTTP
        /// request to (for example, <code>ec2.us-east-1.amazonaws.com</code>). With the AWS CLI, this is
        /// specified using the <code>--region</code> parameter or the default Region in your AWS
        /// configuration file.</p>
        pub fn destination_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_region = Some(input.into());
            self
        }
        pub fn set_destination_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_region = input;
            self
        }
        /// <p>To encrypt a copy of an unencrypted snapshot if encryption by default is not enabled,
        /// enable encryption using this parameter. Otherwise, omit this parameter. Encrypted snapshots
        /// are encrypted, even if you omit this parameter and encryption by default is not enabled. You
        /// cannot set this parameter to false. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS encryption</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn encrypted(mut self, input: bool) -> Self {
            self.encrypted = Some(input);
            self
        }
        pub fn set_encrypted(mut self, input: std::option::Option<bool>) -> Self {
            self.encrypted = input;
            self
        }
        /// <p>The identifier of the AWS Key Management Service (AWS KMS) customer master key (CMK) to use for Amazon EBS encryption.
        /// If this parameter is not specified, your AWS managed CMK for EBS is used. If <code>KmsKeyId</code> is
        /// specified, the encrypted state must be <code>true</code>.</p>
        /// <p>You can specify the CMK using any of the following:</p>
        /// <ul>
        /// <li>
        /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Key alias. For example, alias/ExampleAlias.</p>
        /// </li>
        /// <li>
        /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
        /// </li>
        /// </ul>
        /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an ID, alias, or ARN that is not valid,
        /// the action can appear to complete, but eventually fails.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kms_key_id = Some(input.into());
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kms_key_id = input;
            self
        }
        /// <p>When you copy an encrypted source snapshot using the Amazon EC2 Query API, you must supply a
        /// pre-signed URL. This parameter is optional for unencrypted snapshots. For more information,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Query-Requests.html">Query
        /// requests</a>.</p>
        /// <p>The <code>PresignedUrl</code> should use the snapshot source endpoint, the
        /// <code>CopySnapshot</code> action, and include the <code>SourceRegion</code>,
        /// <code>SourceSnapshotId</code>, and <code>DestinationRegion</code> parameters. The
        /// <code>PresignedUrl</code> must be signed using AWS Signature Version 4. Because EBS
        /// snapshots are stored in Amazon S3, the signing algorithm for this parameter uses the same logic
        /// that is described in <a href="https://docs.aws.amazon.com/AmazonS3/latest/API/sigv4-query-string-auth.html">Authenticating Requests: Using Query
        /// Parameters (AWS Signature Version 4)</a> in the <i>Amazon Simple Storage Service API Reference</i>. An
        /// invalid or improperly signed <code>PresignedUrl</code> will cause the copy operation to fail
        /// asynchronously, and the snapshot will move to an <code>error</code> state.</p>
        pub fn presigned_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.presigned_url = Some(input.into());
            self
        }
        pub fn set_presigned_url(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.presigned_url = input;
            self
        }
        /// <p>The ID of the Region that contains the snapshot to be copied.</p>
        pub fn source_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_region = Some(input.into());
            self
        }
        pub fn set_source_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_region = input;
            self
        }
        /// <p>The ID of the EBS snapshot to copy.</p>
        pub fn source_snapshot_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_snapshot_id = Some(input.into());
            self
        }
        pub fn set_source_snapshot_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_snapshot_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CopySnapshotInput`](crate::input::CopySnapshotInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CopySnapshotInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CopySnapshotInput {
                description: self.description,
                destination_outpost_arn: self.destination_outpost_arn,
                destination_region: self.destination_region,
                encrypted: self.encrypted,
                kms_key_id: self.kms_key_id,
                presigned_url: self.presigned_url,
                source_region: self.source_region,
                source_snapshot_id: self.source_snapshot_id,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CopySnapshotInputOperationOutputAlias = crate::operation::CopySnapshot;
#[doc(hidden)]
pub type CopySnapshotInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CopySnapshotInput {
    /// Consumes the builder and constructs an Operation<[`CopySnapshot`](crate::operation::CopySnapshot)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CopySnapshot,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_copy_snapshot(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CopySnapshot::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("CopySnapshot", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CopySnapshotInput`](crate::input::CopySnapshotInput)
    pub fn builder() -> crate::input::copy_snapshot_input::Builder {
        crate::input::copy_snapshot_input::Builder::default()
    }
}

/// See [`CreateCapacityReservationInput`](crate::input::CreateCapacityReservationInput)
pub mod create_capacity_reservation_input {
    /// A builder for [`CreateCapacityReservationInput`](crate::input::CreateCapacityReservationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) instance_type: std::option::Option<std::string::String>,
        pub(crate) instance_platform:
            std::option::Option<crate::model::CapacityReservationInstancePlatform>,
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) availability_zone_id: std::option::Option<std::string::String>,
        pub(crate) tenancy: std::option::Option<crate::model::CapacityReservationTenancy>,
        pub(crate) instance_count: std::option::Option<i32>,
        pub(crate) ebs_optimized: std::option::Option<bool>,
        pub(crate) ephemeral_storage: std::option::Option<bool>,
        pub(crate) end_date: std::option::Option<smithy_types::Instant>,
        pub(crate) end_date_type: std::option::Option<crate::model::EndDateType>,
        pub(crate) instance_match_criteria:
            std::option::Option<crate::model::InstanceMatchCriteria>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) outpost_arn: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>The instance type for which to reserve capacity. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance types</a> in the <i>Amazon EC2 User Guide</i>.</p>
        pub fn instance_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_type = Some(input.into());
            self
        }
        pub fn set_instance_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.instance_type = input;
            self
        }
        /// <p>The type of operating system for which to reserve capacity.</p>
        pub fn instance_platform(
            mut self,
            input: crate::model::CapacityReservationInstancePlatform,
        ) -> Self {
            self.instance_platform = Some(input);
            self
        }
        pub fn set_instance_platform(
            mut self,
            input: std::option::Option<crate::model::CapacityReservationInstancePlatform>,
        ) -> Self {
            self.instance_platform = input;
            self
        }
        /// <p>The Availability Zone in which to create the Capacity Reservation.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>The ID of the Availability Zone in which to create the Capacity Reservation.</p>
        pub fn availability_zone_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone_id = Some(input.into());
            self
        }
        pub fn set_availability_zone_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone_id = input;
            self
        }
        /// <p>Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of the following tenancy settings:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>default</code> - The Capacity Reservation is created on hardware that is shared with other accounts.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>dedicated</code> - The Capacity Reservation is created on single-tenant hardware that is dedicated to a single account.</p>
        /// </li>
        /// </ul>
        pub fn tenancy(mut self, input: crate::model::CapacityReservationTenancy) -> Self {
            self.tenancy = Some(input);
            self
        }
        pub fn set_tenancy(
            mut self,
            input: std::option::Option<crate::model::CapacityReservationTenancy>,
        ) -> Self {
            self.tenancy = input;
            self
        }
        /// <p>The number of instances for which to reserve capacity.</p>
        pub fn instance_count(mut self, input: i32) -> Self {
            self.instance_count = Some(input);
            self
        }
        pub fn set_instance_count(mut self, input: std::option::Option<i32>) -> Self {
            self.instance_count = input;
            self
        }
        /// <p>Indicates whether the Capacity Reservation supports EBS-optimized instances. This optimization provides
        /// dedicated throughput to Amazon EBS and an optimized configuration stack to provide
        /// optimal I/O performance. This optimization isn't available with all instance types.
        /// Additional usage charges apply when using an EBS- optimized instance.</p>
        pub fn ebs_optimized(mut self, input: bool) -> Self {
            self.ebs_optimized = Some(input);
            self
        }
        pub fn set_ebs_optimized(mut self, input: std::option::Option<bool>) -> Self {
            self.ebs_optimized = input;
            self
        }
        /// <p>Indicates whether the Capacity Reservation supports instances with temporary, block-level
        /// storage.</p>
        pub fn ephemeral_storage(mut self, input: bool) -> Self {
            self.ephemeral_storage = Some(input);
            self
        }
        pub fn set_ephemeral_storage(mut self, input: std::option::Option<bool>) -> Self {
            self.ephemeral_storage = input;
            self
        }
        /// <p>The date and time at which the Capacity Reservation expires. When a Capacity Reservation expires, the reserved capacity
        /// is released and you can no longer launch instances into it. The Capacity Reservation's state changes to
        /// <code>expired</code> when it reaches its end date and time.</p>  
        /// <p>You must provide an <code>EndDate</code> value if <code>EndDateType</code> is
        /// <code>limited</code>. Omit <code>EndDate</code> if <code>EndDateType</code> is
        /// <code>unlimited</code>.</p>
        /// <p>If the <code>EndDateType</code> is <code>limited</code>, the Capacity Reservation is cancelled within an hour from the specified time. For example, if you specify
        /// 5/31/2019, 13:30:55, the Capacity Reservation is guaranteed to end between 13:30:55 and 14:30:55 on 5/31/2019.</p>
        pub fn end_date(mut self, input: smithy_types::Instant) -> Self {
            self.end_date = Some(input);
            self
        }
        pub fn set_end_date(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.end_date = input;
            self
        }
        /// <p>Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have one of the following end
        /// types:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>unlimited</code> - The Capacity Reservation remains active until you explicitly cancel it. Do not
        /// provide an <code>EndDate</code> if the <code>EndDateType</code> is
        /// <code>unlimited</code>.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>limited</code> - The Capacity Reservation expires automatically at a specified date and time. You must
        /// provide an <code>EndDate</code> value if the <code>EndDateType</code> value is
        /// <code>limited</code>.</p>
        /// </li>
        /// </ul>
        pub fn end_date_type(mut self, input: crate::model::EndDateType) -> Self {
            self.end_date_type = Some(input);
            self
        }
        pub fn set_end_date_type(
            mut self,
            input: std::option::Option<crate::model::EndDateType>,
        ) -> Self {
            self.end_date_type = input;
            self
        }
        /// <p>Indicates the type of instance launches that the Capacity Reservation accepts. The options
        /// include:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>open</code> - The Capacity Reservation automatically matches all instances that have matching attributes (instance type, platform,
        /// and Availability Zone). Instances that have matching attributes run in the Capacity Reservation automatically without specifying
        /// any additional parameters.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>targeted</code> - The Capacity Reservation only accepts instances that have matching attributes
        /// (instance type, platform, and Availability Zone), and explicitly target the
        /// Capacity Reservation. This ensures that only permitted instances can use the reserved capacity. </p>
        /// </li>
        /// </ul>
        /// <p>Default: <code>open</code>
        /// </p>
        pub fn instance_match_criteria(
            mut self,
            input: crate::model::InstanceMatchCriteria,
        ) -> Self {
            self.instance_match_criteria = Some(input);
            self
        }
        pub fn set_instance_match_criteria(
            mut self,
            input: std::option::Option<crate::model::InstanceMatchCriteria>,
        ) -> Self {
            self.instance_match_criteria = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Outpost on which to create the Capacity Reservation.</p>
        pub fn outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.outpost_arn = Some(input.into());
            self
        }
        pub fn set_outpost_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.outpost_arn = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateCapacityReservationInput`](crate::input::CreateCapacityReservationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateCapacityReservationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateCapacityReservationInput {
                client_token: self.client_token,
                instance_type: self.instance_type,
                instance_platform: self.instance_platform,
                availability_zone: self.availability_zone,
                availability_zone_id: self.availability_zone_id,
                tenancy: self.tenancy,
                instance_count: self.instance_count,
                ebs_optimized: self.ebs_optimized,
                ephemeral_storage: self.ephemeral_storage,
                end_date: self.end_date,
                end_date_type: self.end_date_type,
                instance_match_criteria: self.instance_match_criteria,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
                outpost_arn: self.outpost_arn,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateCapacityReservationInputOperationOutputAlias =
    crate::operation::CreateCapacityReservation;
#[doc(hidden)]
pub type CreateCapacityReservationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateCapacityReservationInput {
    /// Consumes the builder and constructs an Operation<[`CreateCapacityReservation`](crate::operation::CreateCapacityReservation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateCapacityReservation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_capacity_reservation(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateCapacityReservation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateCapacityReservation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateCapacityReservationInput`](crate::input::CreateCapacityReservationInput)
    pub fn builder() -> crate::input::create_capacity_reservation_input::Builder {
        crate::input::create_capacity_reservation_input::Builder::default()
    }
}

/// See [`CreateCarrierGatewayInput`](crate::input::CreateCarrierGatewayInput)
pub mod create_carrier_gateway_input {
    /// A builder for [`CreateCarrierGatewayInput`](crate::input::CreateCarrierGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the VPC to associate with the carrier gateway.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateCarrierGatewayInput`](crate::input::CreateCarrierGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateCarrierGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateCarrierGatewayInput {
                vpc_id: self.vpc_id,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateCarrierGatewayInputOperationOutputAlias = crate::operation::CreateCarrierGateway;
#[doc(hidden)]
pub type CreateCarrierGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateCarrierGatewayInput {
    /// Consumes the builder and constructs an Operation<[`CreateCarrierGateway`](crate::operation::CreateCarrierGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateCarrierGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_carrier_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateCarrierGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateCarrierGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateCarrierGatewayInput`](crate::input::CreateCarrierGatewayInput)
    pub fn builder() -> crate::input::create_carrier_gateway_input::Builder {
        crate::input::create_carrier_gateway_input::Builder::default()
    }
}

/// See [`CreateClientVpnEndpointInput`](crate::input::CreateClientVpnEndpointInput)
pub mod create_client_vpn_endpoint_input {
    /// A builder for [`CreateClientVpnEndpointInput`](crate::input::CreateClientVpnEndpointInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_cidr_block: std::option::Option<std::string::String>,
        pub(crate) server_certificate_arn: std::option::Option<std::string::String>,
        pub(crate) authentication_options:
            std::option::Option<std::vec::Vec<crate::model::ClientVpnAuthenticationRequest>>,
        pub(crate) connection_log_options: std::option::Option<crate::model::ConnectionLogOptions>,
        pub(crate) dns_servers: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) transport_protocol: std::option::Option<crate::model::TransportProtocol>,
        pub(crate) vpn_port: std::option::Option<i32>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) split_tunnel: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) self_service_portal: std::option::Option<crate::model::SelfServicePortal>,
        pub(crate) client_connect_options: std::option::Option<crate::model::ClientConnectOptions>,
    }
    impl Builder {
        /// <p>The IPv4 address range, in CIDR notation, from which to assign client IP addresses. The address range cannot overlap with the local CIDR of the VPC in which the associated subnet is located, or the routes that you add manually. The address range cannot be changed after the Client VPN endpoint has been created. The CIDR block should be /22 or greater.</p>
        pub fn client_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_cidr_block = Some(input.into());
            self
        }
        pub fn set_client_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_cidr_block = input;
            self
        }
        /// <p>The ARN of the server certificate. For more information, see
        /// the <a href="https://docs.aws.amazon.com/acm/latest/userguide/">AWS Certificate Manager User Guide</a>.</p>
        pub fn server_certificate_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.server_certificate_arn = Some(input.into());
            self
        }
        pub fn set_server_certificate_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.server_certificate_arn = input;
            self
        }
        pub fn authentication_options(
            mut self,
            input: impl Into<crate::model::ClientVpnAuthenticationRequest>,
        ) -> Self {
            let mut v = self.authentication_options.unwrap_or_default();
            v.push(input.into());
            self.authentication_options = Some(v);
            self
        }
        pub fn set_authentication_options(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ClientVpnAuthenticationRequest>>,
        ) -> Self {
            self.authentication_options = input;
            self
        }
        /// <p>Information about the client connection logging options.</p>
        /// <p>If you enable client connection logging, data about client connections is sent to a
        /// Cloudwatch Logs log stream. The following information is logged:</p>
        /// <ul>
        /// <li>
        /// <p>Client connection requests</p>
        /// </li>
        /// <li>
        /// <p>Client connection results (successful and unsuccessful)</p>
        /// </li>
        /// <li>
        /// <p>Reasons for unsuccessful client connection requests</p>
        /// </li>
        /// <li>
        /// <p>Client connection termination time</p>
        /// </li>
        /// </ul>
        pub fn connection_log_options(mut self, input: crate::model::ConnectionLogOptions) -> Self {
            self.connection_log_options = Some(input);
            self
        }
        pub fn set_connection_log_options(
            mut self,
            input: std::option::Option<crate::model::ConnectionLogOptions>,
        ) -> Self {
            self.connection_log_options = input;
            self
        }
        pub fn dns_servers(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.dns_servers.unwrap_or_default();
            v.push(input.into());
            self.dns_servers = Some(v);
            self
        }
        pub fn set_dns_servers(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.dns_servers = input;
            self
        }
        /// <p>The transport protocol to be used by the VPN session.</p>
        /// <p>Default value: <code>udp</code>
        /// </p>
        pub fn transport_protocol(mut self, input: crate::model::TransportProtocol) -> Self {
            self.transport_protocol = Some(input);
            self
        }
        pub fn set_transport_protocol(
            mut self,
            input: std::option::Option<crate::model::TransportProtocol>,
        ) -> Self {
            self.transport_protocol = input;
            self
        }
        /// <p>The port number to assign to the Client VPN endpoint for TCP and UDP traffic.</p>
        /// <p>Valid Values: <code>443</code> | <code>1194</code>
        /// </p>
        /// <p>Default Value: <code>443</code>
        /// </p>
        pub fn vpn_port(mut self, input: i32) -> Self {
            self.vpn_port = Some(input);
            self
        }
        pub fn set_vpn_port(mut self, input: std::option::Option<i32>) -> Self {
            self.vpn_port = input;
            self
        }
        /// <p>A brief description of the Client VPN endpoint.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Indicates whether split-tunnel is enabled on the AWS Client VPN endpoint.</p>
        /// <p>By default, split-tunnel on a VPN endpoint is disabled.</p>
        /// <p>For information about split-tunnel VPN endpoints, see <a href="https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html">Split-Tunnel AWS Client VPN Endpoint</a> in the <i>AWS
        /// Client VPN Administrator Guide</i>.</p>
        pub fn split_tunnel(mut self, input: bool) -> Self {
            self.split_tunnel = Some(input);
            self
        }
        pub fn set_split_tunnel(mut self, input: std::option::Option<bool>) -> Self {
            self.split_tunnel = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        pub fn security_group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.security_group_ids.unwrap_or_default();
            v.push(input.into());
            self.security_group_ids = Some(v);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.security_group_ids = input;
            self
        }
        /// <p>The ID of the VPC to associate with the Client VPN endpoint. If no security group IDs are specified in the request, the default security group for the VPC is applied.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>Specify whether to enable the self-service portal for the Client VPN endpoint.</p>
        /// <p>Default Value: <code>enabled</code>
        /// </p>
        pub fn self_service_portal(mut self, input: crate::model::SelfServicePortal) -> Self {
            self.self_service_portal = Some(input);
            self
        }
        pub fn set_self_service_portal(
            mut self,
            input: std::option::Option<crate::model::SelfServicePortal>,
        ) -> Self {
            self.self_service_portal = input;
            self
        }
        /// <p>The options for managing connection authorization for new client connections.</p>
        pub fn client_connect_options(mut self, input: crate::model::ClientConnectOptions) -> Self {
            self.client_connect_options = Some(input);
            self
        }
        pub fn set_client_connect_options(
            mut self,
            input: std::option::Option<crate::model::ClientConnectOptions>,
        ) -> Self {
            self.client_connect_options = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateClientVpnEndpointInput`](crate::input::CreateClientVpnEndpointInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateClientVpnEndpointInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateClientVpnEndpointInput {
                client_cidr_block: self.client_cidr_block,
                server_certificate_arn: self.server_certificate_arn,
                authentication_options: self.authentication_options,
                connection_log_options: self.connection_log_options,
                dns_servers: self.dns_servers,
                transport_protocol: self.transport_protocol,
                vpn_port: self.vpn_port,
                description: self.description,
                split_tunnel: self.split_tunnel,
                dry_run: self.dry_run,
                client_token: self.client_token,
                tag_specifications: self.tag_specifications,
                security_group_ids: self.security_group_ids,
                vpc_id: self.vpc_id,
                self_service_portal: self.self_service_portal,
                client_connect_options: self.client_connect_options,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateClientVpnEndpointInputOperationOutputAlias =
    crate::operation::CreateClientVpnEndpoint;
#[doc(hidden)]
pub type CreateClientVpnEndpointInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateClientVpnEndpointInput {
    /// Consumes the builder and constructs an Operation<[`CreateClientVpnEndpoint`](crate::operation::CreateClientVpnEndpoint)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateClientVpnEndpoint,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_client_vpn_endpoint(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateClientVpnEndpoint::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateClientVpnEndpoint",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateClientVpnEndpointInput`](crate::input::CreateClientVpnEndpointInput)
    pub fn builder() -> crate::input::create_client_vpn_endpoint_input::Builder {
        crate::input::create_client_vpn_endpoint_input::Builder::default()
    }
}

/// See [`CreateClientVpnRouteInput`](crate::input::CreateClientVpnRouteInput)
pub mod create_client_vpn_route_input {
    /// A builder for [`CreateClientVpnRouteInput`](crate::input::CreateClientVpnRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) target_vpc_subnet_id: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint to which to add the route.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The IPv4 address range, in CIDR notation, of the route destination. For example:</p>
        /// <ul>
        /// <li>
        /// <p>To add a route for Internet access, enter <code>0.0.0.0/0</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>To add a route for a peered VPC, enter the peered VPC's IPv4 CIDR range</p>
        /// </li>
        /// <li>
        /// <p>To add a route for an on-premises network, enter the AWS Site-to-Site VPN connection's IPv4 CIDR range</p>
        /// </li>
        /// <li>
        /// <p>To add a route for the local network, enter the client CIDR range</p>
        /// </li>
        /// </ul>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The ID of the subnet through which you want to route traffic. The specified subnet must be
        /// an existing target network of the Client VPN endpoint.</p>
        /// <p>Alternatively, if you're adding a route for the local network, specify <code>local</code>.</p>
        pub fn target_vpc_subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.target_vpc_subnet_id = Some(input.into());
            self
        }
        pub fn set_target_vpc_subnet_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.target_vpc_subnet_id = input;
            self
        }
        /// <p>A brief description of the route.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateClientVpnRouteInput`](crate::input::CreateClientVpnRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateClientVpnRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateClientVpnRouteInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                destination_cidr_block: self.destination_cidr_block,
                target_vpc_subnet_id: self.target_vpc_subnet_id,
                description: self.description,
                client_token: self.client_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateClientVpnRouteInputOperationOutputAlias = crate::operation::CreateClientVpnRoute;
#[doc(hidden)]
pub type CreateClientVpnRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateClientVpnRouteInput {
    /// Consumes the builder and constructs an Operation<[`CreateClientVpnRoute`](crate::operation::CreateClientVpnRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateClientVpnRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_client_vpn_route(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateClientVpnRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateClientVpnRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateClientVpnRouteInput`](crate::input::CreateClientVpnRouteInput)
    pub fn builder() -> crate::input::create_client_vpn_route_input::Builder {
        crate::input::create_client_vpn_route_input::Builder::default()
    }
}

/// See [`CreateCustomerGatewayInput`](crate::input::CreateCustomerGatewayInput)
pub mod create_customer_gateway_input {
    /// A builder for [`CreateCustomerGatewayInput`](crate::input::CreateCustomerGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) bgp_asn: std::option::Option<i32>,
        pub(crate) public_ip: std::option::Option<std::string::String>,
        pub(crate) certificate_arn: std::option::Option<std::string::String>,
        pub(crate) r#type: std::option::Option<crate::model::GatewayType>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) device_name: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>For devices that support BGP, the customer gateway's BGP ASN.</p>
        /// <p>Default: 65000</p>
        pub fn bgp_asn(mut self, input: i32) -> Self {
            self.bgp_asn = Some(input);
            self
        }
        pub fn set_bgp_asn(mut self, input: std::option::Option<i32>) -> Self {
            self.bgp_asn = input;
            self
        }
        /// <p>The Internet-routable IP address for the customer gateway's outside interface. The address must be static.</p>
        pub fn public_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.public_ip = Some(input.into());
            self
        }
        pub fn set_public_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.public_ip = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) for the customer gateway certificate.</p>
        pub fn certificate_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.certificate_arn = Some(input.into());
            self
        }
        pub fn set_certificate_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.certificate_arn = input;
            self
        }
        /// <p>The type of VPN connection that this customer gateway supports (<code>ipsec.1</code>).</p>
        pub fn r#type(mut self, input: crate::model::GatewayType) -> Self {
            self.r#type = Some(input);
            self
        }
        pub fn set_type(mut self, input: std::option::Option<crate::model::GatewayType>) -> Self {
            self.r#type = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>A name for the customer gateway device.</p>
        /// <p>Length Constraints: Up to 255 characters.</p>
        pub fn device_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.device_name = Some(input.into());
            self
        }
        pub fn set_device_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.device_name = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateCustomerGatewayInput`](crate::input::CreateCustomerGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateCustomerGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateCustomerGatewayInput {
                bgp_asn: self.bgp_asn,
                public_ip: self.public_ip,
                certificate_arn: self.certificate_arn,
                r#type: self.r#type,
                tag_specifications: self.tag_specifications,
                device_name: self.device_name,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateCustomerGatewayInputOperationOutputAlias = crate::operation::CreateCustomerGateway;
#[doc(hidden)]
pub type CreateCustomerGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateCustomerGatewayInput {
    /// Consumes the builder and constructs an Operation<[`CreateCustomerGateway`](crate::operation::CreateCustomerGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateCustomerGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_customer_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateCustomerGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateCustomerGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateCustomerGatewayInput`](crate::input::CreateCustomerGatewayInput)
    pub fn builder() -> crate::input::create_customer_gateway_input::Builder {
        crate::input::create_customer_gateway_input::Builder::default()
    }
}

/// See [`CreateDefaultSubnetInput`](crate::input::CreateDefaultSubnetInput)
pub mod create_default_subnet_input {
    /// A builder for [`CreateDefaultSubnetInput`](crate::input::CreateDefaultSubnetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The Availability Zone in which to create the default subnet.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateDefaultSubnetInput`](crate::input::CreateDefaultSubnetInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateDefaultSubnetInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateDefaultSubnetInput {
                availability_zone: self.availability_zone,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateDefaultSubnetInputOperationOutputAlias = crate::operation::CreateDefaultSubnet;
#[doc(hidden)]
pub type CreateDefaultSubnetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateDefaultSubnetInput {
    /// Consumes the builder and constructs an Operation<[`CreateDefaultSubnet`](crate::operation::CreateDefaultSubnet)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateDefaultSubnet,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_default_subnet(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateDefaultSubnet::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateDefaultSubnet",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateDefaultSubnetInput`](crate::input::CreateDefaultSubnetInput)
    pub fn builder() -> crate::input::create_default_subnet_input::Builder {
        crate::input::create_default_subnet_input::Builder::default()
    }
}

/// See [`CreateDefaultVpcInput`](crate::input::CreateDefaultVpcInput)
pub mod create_default_vpc_input {
    /// A builder for [`CreateDefaultVpcInput`](crate::input::CreateDefaultVpcInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateDefaultVpcInput`](crate::input::CreateDefaultVpcInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateDefaultVpcInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateDefaultVpcInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateDefaultVpcInputOperationOutputAlias = crate::operation::CreateDefaultVpc;
#[doc(hidden)]
pub type CreateDefaultVpcInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateDefaultVpcInput {
    /// Consumes the builder and constructs an Operation<[`CreateDefaultVpc`](crate::operation::CreateDefaultVpc)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateDefaultVpc,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_default_vpc(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateDefaultVpc::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateDefaultVpc",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateDefaultVpcInput`](crate::input::CreateDefaultVpcInput)
    pub fn builder() -> crate::input::create_default_vpc_input::Builder {
        crate::input::create_default_vpc_input::Builder::default()
    }
}

/// See [`CreateDhcpOptionsInput`](crate::input::CreateDhcpOptionsInput)
pub mod create_dhcp_options_input {
    /// A builder for [`CreateDhcpOptionsInput`](crate::input::CreateDhcpOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dhcp_configurations:
            std::option::Option<std::vec::Vec<crate::model::NewDhcpConfiguration>>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn dhcp_configurations(
            mut self,
            input: impl Into<crate::model::NewDhcpConfiguration>,
        ) -> Self {
            let mut v = self.dhcp_configurations.unwrap_or_default();
            v.push(input.into());
            self.dhcp_configurations = Some(v);
            self
        }
        pub fn set_dhcp_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::NewDhcpConfiguration>>,
        ) -> Self {
            self.dhcp_configurations = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateDhcpOptionsInput`](crate::input::CreateDhcpOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateDhcpOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateDhcpOptionsInput {
                dhcp_configurations: self.dhcp_configurations,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateDhcpOptionsInputOperationOutputAlias = crate::operation::CreateDhcpOptions;
#[doc(hidden)]
pub type CreateDhcpOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateDhcpOptionsInput {
    /// Consumes the builder and constructs an Operation<[`CreateDhcpOptions`](crate::operation::CreateDhcpOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateDhcpOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_dhcp_options(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateDhcpOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateDhcpOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateDhcpOptionsInput`](crate::input::CreateDhcpOptionsInput)
    pub fn builder() -> crate::input::create_dhcp_options_input::Builder {
        crate::input::create_dhcp_options_input::Builder::default()
    }
}

/// See [`CreateEgressOnlyInternetGatewayInput`](crate::input::CreateEgressOnlyInternetGatewayInput)
pub mod create_egress_only_internet_gateway_input {
    /// A builder for [`CreateEgressOnlyInternetGatewayInput`](crate::input::CreateEgressOnlyInternetGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC for which to create the egress-only internet gateway.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateEgressOnlyInternetGatewayInput`](crate::input::CreateEgressOnlyInternetGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateEgressOnlyInternetGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateEgressOnlyInternetGatewayInput {
                client_token: self.client_token,
                dry_run: self.dry_run,
                vpc_id: self.vpc_id,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateEgressOnlyInternetGatewayInputOperationOutputAlias =
    crate::operation::CreateEgressOnlyInternetGateway;
#[doc(hidden)]
pub type CreateEgressOnlyInternetGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateEgressOnlyInternetGatewayInput {
    /// Consumes the builder and constructs an Operation<[`CreateEgressOnlyInternetGateway`](crate::operation::CreateEgressOnlyInternetGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateEgressOnlyInternetGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_egress_only_internet_gateway(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateEgressOnlyInternetGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateEgressOnlyInternetGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateEgressOnlyInternetGatewayInput`](crate::input::CreateEgressOnlyInternetGatewayInput)
    pub fn builder() -> crate::input::create_egress_only_internet_gateway_input::Builder {
        crate::input::create_egress_only_internet_gateway_input::Builder::default()
    }
}

/// See [`CreateFleetInput`](crate::input::CreateFleetInput)
pub mod create_fleet_input {
    /// A builder for [`CreateFleetInput`](crate::input::CreateFleetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) spot_options: std::option::Option<crate::model::SpotOptionsRequest>,
        pub(crate) on_demand_options: std::option::Option<crate::model::OnDemandOptionsRequest>,
        pub(crate) excess_capacity_termination_policy:
            std::option::Option<crate::model::FleetExcessCapacityTerminationPolicy>,
        pub(crate) launch_template_configs:
            std::option::Option<std::vec::Vec<crate::model::FleetLaunchTemplateConfigRequest>>,
        pub(crate) target_capacity_specification:
            std::option::Option<crate::model::TargetCapacitySpecificationRequest>,
        pub(crate) terminate_instances_with_expiration: std::option::Option<bool>,
        pub(crate) r#type: std::option::Option<crate::model::FleetType>,
        pub(crate) valid_from: std::option::Option<smithy_types::Instant>,
        pub(crate) valid_until: std::option::Option<smithy_types::Instant>,
        pub(crate) replace_unhealthy_instances: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) context: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Describes the configuration of Spot Instances in an EC2 Fleet.</p>
        pub fn spot_options(mut self, input: crate::model::SpotOptionsRequest) -> Self {
            self.spot_options = Some(input);
            self
        }
        pub fn set_spot_options(
            mut self,
            input: std::option::Option<crate::model::SpotOptionsRequest>,
        ) -> Self {
            self.spot_options = input;
            self
        }
        /// <p>Describes the configuration of On-Demand Instances in an EC2 Fleet.</p>
        pub fn on_demand_options(mut self, input: crate::model::OnDemandOptionsRequest) -> Self {
            self.on_demand_options = Some(input);
            self
        }
        pub fn set_on_demand_options(
            mut self,
            input: std::option::Option<crate::model::OnDemandOptionsRequest>,
        ) -> Self {
            self.on_demand_options = input;
            self
        }
        /// <p>Indicates whether running instances should be terminated if the total target capacity of
        /// the EC2 Fleet is decreased below the current size of the EC2 Fleet.</p>
        pub fn excess_capacity_termination_policy(
            mut self,
            input: crate::model::FleetExcessCapacityTerminationPolicy,
        ) -> Self {
            self.excess_capacity_termination_policy = Some(input);
            self
        }
        pub fn set_excess_capacity_termination_policy(
            mut self,
            input: std::option::Option<crate::model::FleetExcessCapacityTerminationPolicy>,
        ) -> Self {
            self.excess_capacity_termination_policy = input;
            self
        }
        pub fn launch_template_configs(
            mut self,
            input: impl Into<crate::model::FleetLaunchTemplateConfigRequest>,
        ) -> Self {
            let mut v = self.launch_template_configs.unwrap_or_default();
            v.push(input.into());
            self.launch_template_configs = Some(v);
            self
        }
        pub fn set_launch_template_configs(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::FleetLaunchTemplateConfigRequest>,
            >,
        ) -> Self {
            self.launch_template_configs = input;
            self
        }
        /// <p>The number of units to request.</p>
        pub fn target_capacity_specification(
            mut self,
            input: crate::model::TargetCapacitySpecificationRequest,
        ) -> Self {
            self.target_capacity_specification = Some(input);
            self
        }
        pub fn set_target_capacity_specification(
            mut self,
            input: std::option::Option<crate::model::TargetCapacitySpecificationRequest>,
        ) -> Self {
            self.target_capacity_specification = input;
            self
        }
        /// <p>Indicates whether running instances should be terminated when the EC2 Fleet expires.</p>
        pub fn terminate_instances_with_expiration(mut self, input: bool) -> Self {
            self.terminate_instances_with_expiration = Some(input);
            self
        }
        pub fn set_terminate_instances_with_expiration(
            mut self,
            input: std::option::Option<bool>,
        ) -> Self {
            self.terminate_instances_with_expiration = input;
            self
        }
        /// <p>The fleet type. The default value is <code>maintain</code>.</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>maintain</code> - The EC2 Fleet places an asynchronous request for your desired
        /// capacity, and continues to maintain your desired Spot capacity by replenishing
        /// interrupted Spot Instances.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>request</code> - The EC2 Fleet places an asynchronous one-time request for your
        /// desired capacity, but does submit Spot requests in alternative capacity pools if Spot
        /// capacity is unavailable, and does not maintain Spot capacity if Spot Instances are
        /// interrupted.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>instant</code> - The EC2 Fleet places a synchronous one-time request for your
        /// desired capacity, and returns errors for any instances that could not be
        /// launched.</p>
        /// </li>
        /// </ul>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-fleet-configuration-strategies.html#ec2-fleet-request-type">EC2 Fleet
        /// request types</a> in the <i>Amazon EC2 User Guide</i>.</p>
        pub fn r#type(mut self, input: crate::model::FleetType) -> Self {
            self.r#type = Some(input);
            self
        }
        pub fn set_type(mut self, input: std::option::Option<crate::model::FleetType>) -> Self {
            self.r#type = input;
            self
        }
        /// <p>The start date and time of the request, in UTC format (for example,
        /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).
        /// The default is to start fulfilling the request immediately.</p>
        pub fn valid_from(mut self, input: smithy_types::Instant) -> Self {
            self.valid_from = Some(input);
            self
        }
        pub fn set_valid_from(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.valid_from = input;
            self
        }
        /// <p>The end date and time of the request, in UTC format (for example,
        /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).
        /// At this point, no new EC2 Fleet requests are placed or able to fulfill the request. If no value is specified, the request remains until you cancel it.</p>
        pub fn valid_until(mut self, input: smithy_types::Instant) -> Self {
            self.valid_until = Some(input);
            self
        }
        pub fn set_valid_until(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.valid_until = input;
            self
        }
        /// <p>Indicates whether EC2 Fleet should replace unhealthy Spot Instances. Supported only for
        /// fleets of type <code>maintain</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/manage-ec2-fleet.html#ec2-fleet-health-checks">EC2 Fleet
        /// health checks</a> in the <i>Amazon EC2 User Guide</i>.</p>
        pub fn replace_unhealthy_instances(mut self, input: bool) -> Self {
            self.replace_unhealthy_instances = Some(input);
            self
        }
        pub fn set_replace_unhealthy_instances(mut self, input: std::option::Option<bool>) -> Self {
            self.replace_unhealthy_instances = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Reserved.</p>
        pub fn context(mut self, input: impl Into<std::string::String>) -> Self {
            self.context = Some(input.into());
            self
        }
        pub fn set_context(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.context = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateFleetInput`](crate::input::CreateFleetInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateFleetInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateFleetInput {
                dry_run: self.dry_run,
                client_token: self.client_token,
                spot_options: self.spot_options,
                on_demand_options: self.on_demand_options,
                excess_capacity_termination_policy: self.excess_capacity_termination_policy,
                launch_template_configs: self.launch_template_configs,
                target_capacity_specification: self.target_capacity_specification,
                terminate_instances_with_expiration: self.terminate_instances_with_expiration,
                r#type: self.r#type,
                valid_from: self.valid_from,
                valid_until: self.valid_until,
                replace_unhealthy_instances: self.replace_unhealthy_instances,
                tag_specifications: self.tag_specifications,
                context: self.context,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateFleetInputOperationOutputAlias = crate::operation::CreateFleet;
#[doc(hidden)]
pub type CreateFleetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateFleetInput {
    /// Consumes the builder and constructs an Operation<[`CreateFleet`](crate::operation::CreateFleet)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateFleet,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_fleet(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateFleet::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("CreateFleet", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateFleetInput`](crate::input::CreateFleetInput)
    pub fn builder() -> crate::input::create_fleet_input::Builder {
        crate::input::create_fleet_input::Builder::default()
    }
}

/// See [`CreateFlowLogsInput`](crate::input::CreateFlowLogsInput)
pub mod create_flow_logs_input {
    /// A builder for [`CreateFlowLogsInput`](crate::input::CreateFlowLogsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) deliver_logs_permission_arn: std::option::Option<std::string::String>,
        pub(crate) log_group_name: std::option::Option<std::string::String>,
        pub(crate) resource_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) resource_type: std::option::Option<crate::model::FlowLogsResourceType>,
        pub(crate) traffic_type: std::option::Option<crate::model::TrafficType>,
        pub(crate) log_destination_type: std::option::Option<crate::model::LogDestinationType>,
        pub(crate) log_destination: std::option::Option<std::string::String>,
        pub(crate) log_format: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) max_aggregation_interval: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>The ARN for the IAM role that permits Amazon EC2 to publish flow logs to a CloudWatch Logs log group
        /// in your account.</p>
        /// <p>If you specify <code>LogDestinationType</code> as <code>s3</code>, do not specify
        /// <code>DeliverLogsPermissionArn</code> or <code>LogGroupName</code>.</p>
        pub fn deliver_logs_permission_arn(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.deliver_logs_permission_arn = Some(input.into());
            self
        }
        pub fn set_deliver_logs_permission_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.deliver_logs_permission_arn = input;
            self
        }
        /// <p>The name of a new or existing CloudWatch Logs log group where Amazon EC2 publishes your flow logs.</p>
        /// <p>If you specify <code>LogDestinationType</code> as <code>s3</code>, do not specify
        /// <code>DeliverLogsPermissionArn</code> or <code>LogGroupName</code>.</p>
        pub fn log_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.log_group_name = Some(input.into());
            self
        }
        pub fn set_log_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.log_group_name = input;
            self
        }
        pub fn resource_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.resource_ids.unwrap_or_default();
            v.push(input.into());
            self.resource_ids = Some(v);
            self
        }
        pub fn set_resource_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.resource_ids = input;
            self
        }
        /// <p>The type of resource for which to create the flow log. For example, if you specified a VPC ID for
        /// the <code>ResourceId</code> property, specify <code>VPC</code> for this property.</p>
        pub fn resource_type(mut self, input: crate::model::FlowLogsResourceType) -> Self {
            self.resource_type = Some(input);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::FlowLogsResourceType>,
        ) -> Self {
            self.resource_type = input;
            self
        }
        /// <p>The type of traffic to log. You can log traffic that the resource accepts or rejects, or all traffic.</p>
        pub fn traffic_type(mut self, input: crate::model::TrafficType) -> Self {
            self.traffic_type = Some(input);
            self
        }
        pub fn set_traffic_type(
            mut self,
            input: std::option::Option<crate::model::TrafficType>,
        ) -> Self {
            self.traffic_type = input;
            self
        }
        /// <p>Specifies the type of destination to which the flow log data is to be published. Flow log data can be
        /// published to CloudWatch Logs or Amazon S3. To publish flow log data to CloudWatch Logs, specify <code>cloud-watch-logs</code>. To
        /// publish flow log data to Amazon S3, specify <code>s3</code>.</p>
        /// <p>If you specify <code>LogDestinationType</code> as <code>s3</code>, do not specify
        /// <code>DeliverLogsPermissionArn</code> or <code>LogGroupName</code>.</p>
        /// <p>Default: <code>cloud-watch-logs</code>
        /// </p>
        pub fn log_destination_type(mut self, input: crate::model::LogDestinationType) -> Self {
            self.log_destination_type = Some(input);
            self
        }
        pub fn set_log_destination_type(
            mut self,
            input: std::option::Option<crate::model::LogDestinationType>,
        ) -> Self {
            self.log_destination_type = input;
            self
        }
        /// <p>Specifies the destination to which the flow log data is to be published. Flow log data can be published
        /// to a CloudWatch Logs log group or an Amazon S3 bucket. The value specified for this parameter depends on the value specified
        /// for <code>LogDestinationType</code>.</p>
        /// <p>If <code>LogDestinationType</code> is not specified or <code>cloud-watch-logs</code>,
        /// specify the Amazon Resource Name (ARN) of the CloudWatch Logs log group. For example, to publish
        /// to a log group called <code>my-logs</code>, specify
        /// <code>arn:aws:logs:us-east-1:123456789012:log-group:my-logs</code>. Alternatively,
        /// use <code>LogGroupName</code> instead.</p>
        /// <p>If LogDestinationType is <code>s3</code>, specify the ARN of the Amazon S3 bucket. You can also specify a
        /// subfolder in the bucket. To specify a subfolder in the bucket, use the following  ARN format:
        /// <code>bucket_ARN/subfolder_name/</code>. For example, to specify a subfolder named <code>my-logs</code> in a
        /// bucket named <code>my-bucket</code>, use the following ARN: <code>arn:aws:s3:::my-bucket/my-logs/</code>. You
        /// cannot use <code>AWSLogs</code> as a subfolder name. This is a reserved term.</p>
        pub fn log_destination(mut self, input: impl Into<std::string::String>) -> Self {
            self.log_destination = Some(input.into());
            self
        }
        pub fn set_log_destination(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.log_destination = input;
            self
        }
        /// <p>The fields to include in the flow log record, in the order in which they should
        /// appear. For a list of available fields, see <a href="https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs.html#flow-log-records">Flow Log Records</a>. If you
        /// omit this parameter, the flow log is created using the default format. If you specify this parameter, you must specify at least one field.</p>
        /// <p>Specify the fields using the <code>${field-id}</code> format, separated by spaces. For
        /// the AWS CLI, use single quotation marks (' ') to surround the parameter value.</p>
        pub fn log_format(mut self, input: impl Into<std::string::String>) -> Self {
            self.log_format = Some(input.into());
            self
        }
        pub fn set_log_format(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.log_format = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record. You can specify 60 seconds (1 minute) or 600 seconds (10 minutes).</p>
        /// <p>When a network interface is attached to a <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">Nitro-based
        /// instance</a>, the aggregation interval is always 60 seconds or less, regardless
        /// of the value that you specify.</p>
        /// <p>Default: 600</p>
        pub fn max_aggregation_interval(mut self, input: i32) -> Self {
            self.max_aggregation_interval = Some(input);
            self
        }
        pub fn set_max_aggregation_interval(mut self, input: std::option::Option<i32>) -> Self {
            self.max_aggregation_interval = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateFlowLogsInput`](crate::input::CreateFlowLogsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateFlowLogsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateFlowLogsInput {
                dry_run: self.dry_run,
                client_token: self.client_token,
                deliver_logs_permission_arn: self.deliver_logs_permission_arn,
                log_group_name: self.log_group_name,
                resource_ids: self.resource_ids,
                resource_type: self.resource_type,
                traffic_type: self.traffic_type,
                log_destination_type: self.log_destination_type,
                log_destination: self.log_destination,
                log_format: self.log_format,
                tag_specifications: self.tag_specifications,
                max_aggregation_interval: self.max_aggregation_interval,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateFlowLogsInputOperationOutputAlias = crate::operation::CreateFlowLogs;
#[doc(hidden)]
pub type CreateFlowLogsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateFlowLogsInput {
    /// Consumes the builder and constructs an Operation<[`CreateFlowLogs`](crate::operation::CreateFlowLogs)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateFlowLogs,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_flow_logs(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateFlowLogs::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateFlowLogs",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateFlowLogsInput`](crate::input::CreateFlowLogsInput)
    pub fn builder() -> crate::input::create_flow_logs_input::Builder {
        crate::input::create_flow_logs_input::Builder::default()
    }
}

/// See [`CreateFpgaImageInput`](crate::input::CreateFpgaImageInput)
pub mod create_fpga_image_input {
    /// A builder for [`CreateFpgaImageInput`](crate::input::CreateFpgaImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) input_storage_location: std::option::Option<crate::model::StorageLocation>,
        pub(crate) logs_storage_location: std::option::Option<crate::model::StorageLocation>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The location of the encrypted design checkpoint in Amazon S3. The input must be a tarball.</p>
        pub fn input_storage_location(mut self, input: crate::model::StorageLocation) -> Self {
            self.input_storage_location = Some(input);
            self
        }
        pub fn set_input_storage_location(
            mut self,
            input: std::option::Option<crate::model::StorageLocation>,
        ) -> Self {
            self.input_storage_location = input;
            self
        }
        /// <p>The location in Amazon S3 for the output logs.</p>
        pub fn logs_storage_location(mut self, input: crate::model::StorageLocation) -> Self {
            self.logs_storage_location = Some(input);
            self
        }
        pub fn set_logs_storage_location(
            mut self,
            input: std::option::Option<crate::model::StorageLocation>,
        ) -> Self {
            self.logs_storage_location = input;
            self
        }
        /// <p>A description for the AFI.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>A name for the AFI.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
        /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateFpgaImageInput`](crate::input::CreateFpgaImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateFpgaImageInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateFpgaImageInput {
                dry_run: self.dry_run,
                input_storage_location: self.input_storage_location,
                logs_storage_location: self.logs_storage_location,
                description: self.description,
                name: self.name,
                client_token: self.client_token,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateFpgaImageInputOperationOutputAlias = crate::operation::CreateFpgaImage;
#[doc(hidden)]
pub type CreateFpgaImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateFpgaImageInput {
    /// Consumes the builder and constructs an Operation<[`CreateFpgaImage`](crate::operation::CreateFpgaImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateFpgaImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_fpga_image(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateFpgaImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateFpgaImage",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateFpgaImageInput`](crate::input::CreateFpgaImageInput)
    pub fn builder() -> crate::input::create_fpga_image_input::Builder {
        crate::input::create_fpga_image_input::Builder::default()
    }
}

/// See [`CreateImageInput`](crate::input::CreateImageInput)
pub mod create_image_input {
    /// A builder for [`CreateImageInput`](crate::input::CreateImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) block_device_mappings:
            std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) no_reboot: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        pub fn block_device_mappings(
            mut self,
            input: impl Into<crate::model::BlockDeviceMapping>,
        ) -> Self {
            let mut v = self.block_device_mappings.unwrap_or_default();
            v.push(input.into());
            self.block_device_mappings = Some(v);
            self
        }
        pub fn set_block_device_mappings(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
        ) -> Self {
            self.block_device_mappings = input;
            self
        }
        /// <p>A description for the new image.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>A name for the new image.</p>
        /// <p>Constraints: 3-128 alphanumeric characters, parentheses (()), square brackets ([]), spaces ( ), periods (.), slashes (/), dashes (-), single quotes ('), at-signs (@), or underscores(_)</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        /// <p>By default, Amazon EC2 attempts to shut down and reboot the instance before creating the image. If the <code>No Reboot</code> option is set, Amazon EC2 doesn't shut down the instance before creating the image. When this option is used, file system integrity on the created image can't be guaranteed.</p>
        pub fn no_reboot(mut self, input: bool) -> Self {
            self.no_reboot = Some(input);
            self
        }
        pub fn set_no_reboot(mut self, input: std::option::Option<bool>) -> Self {
            self.no_reboot = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateImageInput`](crate::input::CreateImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateImageInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateImageInput {
                block_device_mappings: self.block_device_mappings,
                description: self.description,
                dry_run: self.dry_run,
                instance_id: self.instance_id,
                name: self.name,
                no_reboot: self.no_reboot,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateImageInputOperationOutputAlias = crate::operation::CreateImage;
#[doc(hidden)]
pub type CreateImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateImageInput {
    /// Consumes the builder and constructs an Operation<[`CreateImage`](crate::operation::CreateImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_image(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("CreateImage", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateImageInput`](crate::input::CreateImageInput)
    pub fn builder() -> crate::input::create_image_input::Builder {
        crate::input::create_image_input::Builder::default()
    }
}

/// See [`CreateInstanceExportTaskInput`](crate::input::CreateInstanceExportTaskInput)
pub mod create_instance_export_task_input {
    /// A builder for [`CreateInstanceExportTaskInput`](crate::input::CreateInstanceExportTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) export_to_s3_task:
            std::option::Option<crate::model::ExportToS3TaskSpecification>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) target_environment: std::option::Option<crate::model::ExportEnvironment>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>A description for the conversion task or the resource being exported. The maximum length is 255 characters.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The format and location for an export instance task.</p>
        pub fn export_to_s3_task(
            mut self,
            input: crate::model::ExportToS3TaskSpecification,
        ) -> Self {
            self.export_to_s3_task = Some(input);
            self
        }
        pub fn set_export_to_s3_task(
            mut self,
            input: std::option::Option<crate::model::ExportToS3TaskSpecification>,
        ) -> Self {
            self.export_to_s3_task = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The target virtualization environment.</p>
        pub fn target_environment(mut self, input: crate::model::ExportEnvironment) -> Self {
            self.target_environment = Some(input);
            self
        }
        pub fn set_target_environment(
            mut self,
            input: std::option::Option<crate::model::ExportEnvironment>,
        ) -> Self {
            self.target_environment = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateInstanceExportTaskInput`](crate::input::CreateInstanceExportTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateInstanceExportTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateInstanceExportTaskInput {
                description: self.description,
                export_to_s3_task: self.export_to_s3_task,
                instance_id: self.instance_id,
                target_environment: self.target_environment,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateInstanceExportTaskInputOperationOutputAlias =
    crate::operation::CreateInstanceExportTask;
#[doc(hidden)]
pub type CreateInstanceExportTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateInstanceExportTaskInput {
    /// Consumes the builder and constructs an Operation<[`CreateInstanceExportTask`](crate::operation::CreateInstanceExportTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateInstanceExportTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_instance_export_task(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateInstanceExportTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateInstanceExportTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateInstanceExportTaskInput`](crate::input::CreateInstanceExportTaskInput)
    pub fn builder() -> crate::input::create_instance_export_task_input::Builder {
        crate::input::create_instance_export_task_input::Builder::default()
    }
}

/// See [`CreateInternetGatewayInput`](crate::input::CreateInternetGatewayInput)
pub mod create_internet_gateway_input {
    /// A builder for [`CreateInternetGatewayInput`](crate::input::CreateInternetGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateInternetGatewayInput`](crate::input::CreateInternetGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateInternetGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateInternetGatewayInput {
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateInternetGatewayInputOperationOutputAlias = crate::operation::CreateInternetGateway;
#[doc(hidden)]
pub type CreateInternetGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateInternetGatewayInput {
    /// Consumes the builder and constructs an Operation<[`CreateInternetGateway`](crate::operation::CreateInternetGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateInternetGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_internet_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateInternetGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateInternetGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateInternetGatewayInput`](crate::input::CreateInternetGatewayInput)
    pub fn builder() -> crate::input::create_internet_gateway_input::Builder {
        crate::input::create_internet_gateway_input::Builder::default()
    }
}

/// See [`CreateKeyPairInput`](crate::input::CreateKeyPairInput)
pub mod create_key_pair_input {
    /// A builder for [`CreateKeyPairInput`](crate::input::CreateKeyPairInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) key_name: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>A unique name for the key pair.</p>
        /// <p>Constraints: Up to 255 ASCII characters</p>
        pub fn key_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.key_name = Some(input.into());
            self
        }
        pub fn set_key_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.key_name = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateKeyPairInput`](crate::input::CreateKeyPairInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateKeyPairInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateKeyPairInput {
                key_name: self.key_name,
                dry_run: self.dry_run,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateKeyPairInputOperationOutputAlias = crate::operation::CreateKeyPair;
#[doc(hidden)]
pub type CreateKeyPairInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateKeyPairInput {
    /// Consumes the builder and constructs an Operation<[`CreateKeyPair`](crate::operation::CreateKeyPair)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateKeyPair,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_key_pair(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateKeyPair::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateKeyPair",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateKeyPairInput`](crate::input::CreateKeyPairInput)
    pub fn builder() -> crate::input::create_key_pair_input::Builder {
        crate::input::create_key_pair_input::Builder::default()
    }
}

/// See [`CreateLaunchTemplateInput`](crate::input::CreateLaunchTemplateInput)
pub mod create_launch_template_input {
    /// A builder for [`CreateLaunchTemplateInput`](crate::input::CreateLaunchTemplateInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) launch_template_name: std::option::Option<std::string::String>,
        pub(crate) version_description: std::option::Option<std::string::String>,
        pub(crate) launch_template_data:
            std::option::Option<crate::model::RequestLaunchTemplateData>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
        /// Idempotency</a>.</p>
        /// <p>Constraint: Maximum 128 ASCII characters.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>A name for the launch template.</p>
        pub fn launch_template_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_name = Some(input.into());
            self
        }
        pub fn set_launch_template_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_name = input;
            self
        }
        /// <p>A description for the first version of the launch template.</p>
        pub fn version_description(mut self, input: impl Into<std::string::String>) -> Self {
            self.version_description = Some(input.into());
            self
        }
        pub fn set_version_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.version_description = input;
            self
        }
        /// <p>The information for the launch template.</p>
        pub fn launch_template_data(
            mut self,
            input: crate::model::RequestLaunchTemplateData,
        ) -> Self {
            self.launch_template_data = Some(input);
            self
        }
        pub fn set_launch_template_data(
            mut self,
            input: std::option::Option<crate::model::RequestLaunchTemplateData>,
        ) -> Self {
            self.launch_template_data = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateLaunchTemplateInput`](crate::input::CreateLaunchTemplateInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateLaunchTemplateInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateLaunchTemplateInput {
                dry_run: self.dry_run,
                client_token: self.client_token,
                launch_template_name: self.launch_template_name,
                version_description: self.version_description,
                launch_template_data: self.launch_template_data,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateLaunchTemplateInputOperationOutputAlias = crate::operation::CreateLaunchTemplate;
#[doc(hidden)]
pub type CreateLaunchTemplateInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateLaunchTemplateInput {
    /// Consumes the builder and constructs an Operation<[`CreateLaunchTemplate`](crate::operation::CreateLaunchTemplate)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateLaunchTemplate,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_launch_template(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateLaunchTemplate::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateLaunchTemplate",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateLaunchTemplateInput`](crate::input::CreateLaunchTemplateInput)
    pub fn builder() -> crate::input::create_launch_template_input::Builder {
        crate::input::create_launch_template_input::Builder::default()
    }
}

/// See [`CreateLaunchTemplateVersionInput`](crate::input::CreateLaunchTemplateVersionInput)
pub mod create_launch_template_version_input {
    /// A builder for [`CreateLaunchTemplateVersionInput`](crate::input::CreateLaunchTemplateVersionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) launch_template_id: std::option::Option<std::string::String>,
        pub(crate) launch_template_name: std::option::Option<std::string::String>,
        pub(crate) source_version: std::option::Option<std::string::String>,
        pub(crate) version_description: std::option::Option<std::string::String>,
        pub(crate) launch_template_data:
            std::option::Option<crate::model::RequestLaunchTemplateData>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
        /// Idempotency</a>.</p>
        /// <p>Constraint: Maximum 128 ASCII characters.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>The ID of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_id = Some(input.into());
            self
        }
        pub fn set_launch_template_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_id = input;
            self
        }
        /// <p>The name of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_name = Some(input.into());
            self
        }
        pub fn set_launch_template_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_name = input;
            self
        }
        /// <p>The version number of the launch template version on which to base the new version.
        /// The new version inherits the same launch parameters as the source version, except for
        /// parameters that you specify in <code>LaunchTemplateData</code>. Snapshots applied
        /// to the block device mapping are ignored when creating a new version unless they
        /// are explicitly included.</p>
        pub fn source_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_version = Some(input.into());
            self
        }
        pub fn set_source_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_version = input;
            self
        }
        /// <p>A description for the version of the launch template.</p>
        pub fn version_description(mut self, input: impl Into<std::string::String>) -> Self {
            self.version_description = Some(input.into());
            self
        }
        pub fn set_version_description(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.version_description = input;
            self
        }
        /// <p>The information for the launch template.</p>
        pub fn launch_template_data(
            mut self,
            input: crate::model::RequestLaunchTemplateData,
        ) -> Self {
            self.launch_template_data = Some(input);
            self
        }
        pub fn set_launch_template_data(
            mut self,
            input: std::option::Option<crate::model::RequestLaunchTemplateData>,
        ) -> Self {
            self.launch_template_data = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateLaunchTemplateVersionInput`](crate::input::CreateLaunchTemplateVersionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateLaunchTemplateVersionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateLaunchTemplateVersionInput {
                dry_run: self.dry_run,
                client_token: self.client_token,
                launch_template_id: self.launch_template_id,
                launch_template_name: self.launch_template_name,
                source_version: self.source_version,
                version_description: self.version_description,
                launch_template_data: self.launch_template_data,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateLaunchTemplateVersionInputOperationOutputAlias =
    crate::operation::CreateLaunchTemplateVersion;
#[doc(hidden)]
pub type CreateLaunchTemplateVersionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateLaunchTemplateVersionInput {
    /// Consumes the builder and constructs an Operation<[`CreateLaunchTemplateVersion`](crate::operation::CreateLaunchTemplateVersion)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateLaunchTemplateVersion,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_launch_template_version(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateLaunchTemplateVersion::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateLaunchTemplateVersion",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateLaunchTemplateVersionInput`](crate::input::CreateLaunchTemplateVersionInput)
    pub fn builder() -> crate::input::create_launch_template_version_input::Builder {
        crate::input::create_launch_template_version_input::Builder::default()
    }
}

/// See [`CreateLocalGatewayRouteInput`](crate::input::CreateLocalGatewayRouteInput)
pub mod create_local_gateway_route_input {
    /// A builder for [`CreateLocalGatewayRouteInput`](crate::input::CreateLocalGatewayRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) local_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) local_gateway_virtual_interface_group_id:
            std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The CIDR range used for destination matches. Routing decisions are based on
        /// the most specific match.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The ID of the local gateway route table.</p>
        pub fn local_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the virtual interface group.</p>
        pub fn local_gateway_virtual_interface_group_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.local_gateway_virtual_interface_group_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_virtual_interface_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_virtual_interface_group_id = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateLocalGatewayRouteInput`](crate::input::CreateLocalGatewayRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateLocalGatewayRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateLocalGatewayRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                local_gateway_route_table_id: self.local_gateway_route_table_id,
                dry_run: self.dry_run,
                local_gateway_virtual_interface_group_id: self
                    .local_gateway_virtual_interface_group_id,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateLocalGatewayRouteInputOperationOutputAlias =
    crate::operation::CreateLocalGatewayRoute;
#[doc(hidden)]
pub type CreateLocalGatewayRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateLocalGatewayRouteInput {
    /// Consumes the builder and constructs an Operation<[`CreateLocalGatewayRoute`](crate::operation::CreateLocalGatewayRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateLocalGatewayRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_local_gateway_route(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateLocalGatewayRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateLocalGatewayRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateLocalGatewayRouteInput`](crate::input::CreateLocalGatewayRouteInput)
    pub fn builder() -> crate::input::create_local_gateway_route_input::Builder {
        crate::input::create_local_gateway_route_input::Builder::default()
    }
}

/// See [`CreateLocalGatewayRouteTableVpcAssociationInput`](crate::input::CreateLocalGatewayRouteTableVpcAssociationInput)
pub mod create_local_gateway_route_table_vpc_association_input {
    /// A builder for [`CreateLocalGatewayRouteTableVpcAssociationInput`](crate::input::CreateLocalGatewayRouteTableVpcAssociationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the local gateway route table.</p>
        pub fn local_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateLocalGatewayRouteTableVpcAssociationInput`](crate::input::CreateLocalGatewayRouteTableVpcAssociationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateLocalGatewayRouteTableVpcAssociationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::CreateLocalGatewayRouteTableVpcAssociationInput {
                    local_gateway_route_table_id: self.local_gateway_route_table_id,
                    vpc_id: self.vpc_id,
                    tag_specifications: self.tag_specifications,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type CreateLocalGatewayRouteTableVpcAssociationInputOperationOutputAlias =
    crate::operation::CreateLocalGatewayRouteTableVpcAssociation;
#[doc(hidden)]
pub type CreateLocalGatewayRouteTableVpcAssociationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl CreateLocalGatewayRouteTableVpcAssociationInput {
    /// Consumes the builder and constructs an Operation<[`CreateLocalGatewayRouteTableVpcAssociation`](crate::operation::CreateLocalGatewayRouteTableVpcAssociation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateLocalGatewayRouteTableVpcAssociation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_local_gateway_route_table_vpc_association(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateLocalGatewayRouteTableVpcAssociation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateLocalGatewayRouteTableVpcAssociation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateLocalGatewayRouteTableVpcAssociationInput`](crate::input::CreateLocalGatewayRouteTableVpcAssociationInput)
    pub fn builder() -> crate::input::create_local_gateway_route_table_vpc_association_input::Builder
    {
        crate::input::create_local_gateway_route_table_vpc_association_input::Builder::default()
    }
}

/// See [`CreateManagedPrefixListInput`](crate::input::CreateManagedPrefixListInput)
pub mod create_managed_prefix_list_input {
    /// A builder for [`CreateManagedPrefixListInput`](crate::input::CreateManagedPrefixListInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) prefix_list_name: std::option::Option<std::string::String>,
        pub(crate) entries: std::option::Option<std::vec::Vec<crate::model::AddPrefixListEntry>>,
        pub(crate) max_entries: std::option::Option<i32>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) address_family: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>A name for the prefix list.</p>
        /// <p>Constraints: Up to 255 characters in length. The name cannot start with <code>com.amazonaws</code>.</p>
        pub fn prefix_list_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_name = Some(input.into());
            self
        }
        pub fn set_prefix_list_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_name = input;
            self
        }
        pub fn entries(mut self, input: impl Into<crate::model::AddPrefixListEntry>) -> Self {
            let mut v = self.entries.unwrap_or_default();
            v.push(input.into());
            self.entries = Some(v);
            self
        }
        pub fn set_entries(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AddPrefixListEntry>>,
        ) -> Self {
            self.entries = input;
            self
        }
        /// <p>The maximum number of entries for the prefix list.</p>
        pub fn max_entries(mut self, input: i32) -> Self {
            self.max_entries = Some(input);
            self
        }
        pub fn set_max_entries(mut self, input: std::option::Option<i32>) -> Self {
            self.max_entries = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>The IP address type.</p>
        /// <p>Valid Values: <code>IPv4</code> | <code>IPv6</code>
        /// </p>
        pub fn address_family(mut self, input: impl Into<std::string::String>) -> Self {
            self.address_family = Some(input.into());
            self
        }
        pub fn set_address_family(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.address_family = input;
            self
        }
        /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
        /// Idempotency</a>.</p>
        /// <p>Constraints: Up to 255 UTF-8 characters in length.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateManagedPrefixListInput`](crate::input::CreateManagedPrefixListInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateManagedPrefixListInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateManagedPrefixListInput {
                dry_run: self.dry_run,
                prefix_list_name: self.prefix_list_name,
                entries: self.entries,
                max_entries: self.max_entries,
                tag_specifications: self.tag_specifications,
                address_family: self.address_family,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateManagedPrefixListInputOperationOutputAlias =
    crate::operation::CreateManagedPrefixList;
#[doc(hidden)]
pub type CreateManagedPrefixListInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateManagedPrefixListInput {
    /// Consumes the builder and constructs an Operation<[`CreateManagedPrefixList`](crate::operation::CreateManagedPrefixList)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateManagedPrefixList,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_managed_prefix_list(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateManagedPrefixList::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateManagedPrefixList",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateManagedPrefixListInput`](crate::input::CreateManagedPrefixListInput)
    pub fn builder() -> crate::input::create_managed_prefix_list_input::Builder {
        crate::input::create_managed_prefix_list_input::Builder::default()
    }
}

/// See [`CreateNatGatewayInput`](crate::input::CreateNatGatewayInput)
pub mod create_nat_gateway_input {
    /// A builder for [`CreateNatGatewayInput`](crate::input::CreateNatGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) allocation_id: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) subnet_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) connectivity_type: std::option::Option<crate::model::ConnectivityType>,
    }
    impl Builder {
        /// <p>[Public NAT gateways only] The allocation ID of an Elastic IP address to associate
        /// with the NAT gateway. You cannot specify an Elastic IP address with a private NAT gateway.
        /// If the Elastic IP address is associated with another resource, you must first disassociate it.</p>
        pub fn allocation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.allocation_id = Some(input.into());
            self
        }
        pub fn set_allocation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.allocation_id = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        /// <p>Constraint: Maximum 64 ASCII characters.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The subnet in which to create the NAT gateway.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Indicates whether the NAT gateway supports public or private connectivity.
        /// The default is public connectivity.</p>
        pub fn connectivity_type(mut self, input: crate::model::ConnectivityType) -> Self {
            self.connectivity_type = Some(input);
            self
        }
        pub fn set_connectivity_type(
            mut self,
            input: std::option::Option<crate::model::ConnectivityType>,
        ) -> Self {
            self.connectivity_type = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateNatGatewayInput`](crate::input::CreateNatGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateNatGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateNatGatewayInput {
                allocation_id: self.allocation_id,
                client_token: self.client_token,
                dry_run: self.dry_run,
                subnet_id: self.subnet_id,
                tag_specifications: self.tag_specifications,
                connectivity_type: self.connectivity_type,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateNatGatewayInputOperationOutputAlias = crate::operation::CreateNatGateway;
#[doc(hidden)]
pub type CreateNatGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateNatGatewayInput {
    /// Consumes the builder and constructs an Operation<[`CreateNatGateway`](crate::operation::CreateNatGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateNatGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_nat_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateNatGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateNatGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateNatGatewayInput`](crate::input::CreateNatGatewayInput)
    pub fn builder() -> crate::input::create_nat_gateway_input::Builder {
        crate::input::create_nat_gateway_input::Builder::default()
    }
}

/// See [`CreateNetworkAclInput`](crate::input::CreateNetworkAclInput)
pub mod create_network_acl_input {
    /// A builder for [`CreateNetworkAclInput`](crate::input::CreateNetworkAclInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateNetworkAclInput`](crate::input::CreateNetworkAclInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateNetworkAclInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateNetworkAclInput {
                dry_run: self.dry_run,
                vpc_id: self.vpc_id,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateNetworkAclInputOperationOutputAlias = crate::operation::CreateNetworkAcl;
#[doc(hidden)]
pub type CreateNetworkAclInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateNetworkAclInput {
    /// Consumes the builder and constructs an Operation<[`CreateNetworkAcl`](crate::operation::CreateNetworkAcl)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateNetworkAcl,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_network_acl(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateNetworkAcl::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateNetworkAcl",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateNetworkAclInput`](crate::input::CreateNetworkAclInput)
    pub fn builder() -> crate::input::create_network_acl_input::Builder {
        crate::input::create_network_acl_input::Builder::default()
    }
}

/// See [`CreateNetworkAclEntryInput`](crate::input::CreateNetworkAclEntryInput)
pub mod create_network_acl_entry_input {
    /// A builder for [`CreateNetworkAclEntryInput`](crate::input::CreateNetworkAclEntryInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr_block: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) egress: std::option::Option<bool>,
        pub(crate) icmp_type_code: std::option::Option<crate::model::IcmpTypeCode>,
        pub(crate) ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) network_acl_id: std::option::Option<std::string::String>,
        pub(crate) port_range: std::option::Option<crate::model::PortRange>,
        pub(crate) protocol: std::option::Option<std::string::String>,
        pub(crate) rule_action: std::option::Option<crate::model::RuleAction>,
        pub(crate) rule_number: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The IPv4 network range to allow or deny, in CIDR notation (for example
        /// <code>172.16.0.0/24</code>). We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
        pub fn cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_block = Some(input.into());
            self
        }
        pub fn set_cidr_block(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_block = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Indicates whether this is an egress rule (rule is applied to traffic leaving the subnet).</p>
        pub fn egress(mut self, input: bool) -> Self {
            self.egress = Some(input);
            self
        }
        pub fn set_egress(mut self, input: std::option::Option<bool>) -> Self {
            self.egress = input;
            self
        }
        /// <p>ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol
        /// 1 (ICMP) or protocol 58 (ICMPv6) with an IPv6 CIDR block.</p>
        pub fn icmp_type_code(mut self, input: crate::model::IcmpTypeCode) -> Self {
            self.icmp_type_code = Some(input);
            self
        }
        pub fn set_icmp_type_code(
            mut self,
            input: std::option::Option<crate::model::IcmpTypeCode>,
        ) -> Self {
            self.icmp_type_code = input;
            self
        }
        /// <p>The IPv6 network range to allow or deny, in CIDR notation (for example
        /// <code>2001:db8:1234:1a00::/64</code>).</p>
        pub fn ipv6_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block = input;
            self
        }
        /// <p>The ID of the network ACL.</p>
        pub fn network_acl_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_acl_id = Some(input.into());
            self
        }
        pub fn set_network_acl_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_acl_id = input;
            self
        }
        /// <p>TCP or UDP protocols: The range of ports the rule applies to.
        /// Required if specifying protocol 6 (TCP) or 17 (UDP).</p>
        pub fn port_range(mut self, input: crate::model::PortRange) -> Self {
            self.port_range = Some(input);
            self
        }
        pub fn set_port_range(
            mut self,
            input: std::option::Option<crate::model::PortRange>,
        ) -> Self {
            self.port_range = input;
            self
        }
        /// <p>The protocol number. A value of "-1" means all protocols. If you specify "-1" or a
        /// protocol number other than "6" (TCP), "17" (UDP), or "1" (ICMP), traffic on all ports is
        /// allowed, regardless of any ports or ICMP types or codes that you specify. If you specify
        /// protocol "58" (ICMPv6) and specify an IPv4 CIDR block, traffic for all ICMP types and
        /// codes allowed, regardless of any that you specify. If you specify protocol "58" (ICMPv6)
        /// and specify an IPv6 CIDR block, you must specify an ICMP type and code.</p>
        pub fn protocol(mut self, input: impl Into<std::string::String>) -> Self {
            self.protocol = Some(input.into());
            self
        }
        pub fn set_protocol(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.protocol = input;
            self
        }
        /// <p>Indicates whether to allow or deny the traffic that matches the rule.</p>
        pub fn rule_action(mut self, input: crate::model::RuleAction) -> Self {
            self.rule_action = Some(input);
            self
        }
        pub fn set_rule_action(
            mut self,
            input: std::option::Option<crate::model::RuleAction>,
        ) -> Self {
            self.rule_action = input;
            self
        }
        /// <p>The rule number for the entry (for example, 100). ACL entries are processed in ascending order by rule number.</p>
        /// <p>Constraints: Positive integer from 1 to 32766. The range 32767 to 65535 is reserved for internal use.</p>
        pub fn rule_number(mut self, input: i32) -> Self {
            self.rule_number = Some(input);
            self
        }
        pub fn set_rule_number(mut self, input: std::option::Option<i32>) -> Self {
            self.rule_number = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateNetworkAclEntryInput`](crate::input::CreateNetworkAclEntryInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateNetworkAclEntryInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateNetworkAclEntryInput {
                cidr_block: self.cidr_block,
                dry_run: self.dry_run,
                egress: self.egress,
                icmp_type_code: self.icmp_type_code,
                ipv6_cidr_block: self.ipv6_cidr_block,
                network_acl_id: self.network_acl_id,
                port_range: self.port_range,
                protocol: self.protocol,
                rule_action: self.rule_action,
                rule_number: self.rule_number,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateNetworkAclEntryInputOperationOutputAlias = crate::operation::CreateNetworkAclEntry;
#[doc(hidden)]
pub type CreateNetworkAclEntryInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateNetworkAclEntryInput {
    /// Consumes the builder and constructs an Operation<[`CreateNetworkAclEntry`](crate::operation::CreateNetworkAclEntry)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateNetworkAclEntry,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_network_acl_entry(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateNetworkAclEntry::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateNetworkAclEntry",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateNetworkAclEntryInput`](crate::input::CreateNetworkAclEntryInput)
    pub fn builder() -> crate::input::create_network_acl_entry_input::Builder {
        crate::input::create_network_acl_entry_input::Builder::default()
    }
}

/// See [`CreateNetworkInsightsPathInput`](crate::input::CreateNetworkInsightsPathInput)
pub mod create_network_insights_path_input {
    /// A builder for [`CreateNetworkInsightsPathInput`](crate::input::CreateNetworkInsightsPathInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) source_ip: std::option::Option<std::string::String>,
        pub(crate) destination_ip: std::option::Option<std::string::String>,
        pub(crate) source: std::option::Option<std::string::String>,
        pub(crate) destination: std::option::Option<std::string::String>,
        pub(crate) protocol: std::option::Option<crate::model::Protocol>,
        pub(crate) destination_port: std::option::Option<i32>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The IP address of the AWS resource that is the source of the path.</p>
        pub fn source_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_ip = Some(input.into());
            self
        }
        pub fn set_source_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.source_ip = input;
            self
        }
        /// <p>The IP address of the AWS resource that is the destination of the path.</p>
        pub fn destination_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_ip = Some(input.into());
            self
        }
        pub fn set_destination_ip(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_ip = input;
            self
        }
        /// <p>The AWS resource that is the source of the path.</p>
        pub fn source(mut self, input: impl Into<std::string::String>) -> Self {
            self.source = Some(input.into());
            self
        }
        pub fn set_source(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.source = input;
            self
        }
        /// <p>The AWS resource that is the destination of the path.</p>
        pub fn destination(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination = Some(input.into());
            self
        }
        pub fn set_destination(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.destination = input;
            self
        }
        /// <p>The protocol.</p>
        pub fn protocol(mut self, input: crate::model::Protocol) -> Self {
            self.protocol = Some(input);
            self
        }
        pub fn set_protocol(mut self, input: std::option::Option<crate::model::Protocol>) -> Self {
            self.protocol = input;
            self
        }
        /// <p>The destination port.</p>
        pub fn destination_port(mut self, input: i32) -> Self {
            self.destination_port = Some(input);
            self
        }
        pub fn set_destination_port(mut self, input: std::option::Option<i32>) -> Self {
            self.destination_port = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateNetworkInsightsPathInput`](crate::input::CreateNetworkInsightsPathInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateNetworkInsightsPathInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateNetworkInsightsPathInput {
                source_ip: self.source_ip,
                destination_ip: self.destination_ip,
                source: self.source,
                destination: self.destination,
                protocol: self.protocol,
                destination_port: self.destination_port,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateNetworkInsightsPathInputOperationOutputAlias =
    crate::operation::CreateNetworkInsightsPath;
#[doc(hidden)]
pub type CreateNetworkInsightsPathInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateNetworkInsightsPathInput {
    /// Consumes the builder and constructs an Operation<[`CreateNetworkInsightsPath`](crate::operation::CreateNetworkInsightsPath)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateNetworkInsightsPath,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_network_insights_path(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateNetworkInsightsPath::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateNetworkInsightsPath",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateNetworkInsightsPathInput`](crate::input::CreateNetworkInsightsPathInput)
    pub fn builder() -> crate::input::create_network_insights_path_input::Builder {
        crate::input::create_network_insights_path_input::Builder::default()
    }
}

/// See [`CreateNetworkInterfaceInput`](crate::input::CreateNetworkInterfaceInput)
pub mod create_network_interface_input {
    /// A builder for [`CreateNetworkInterfaceInput`](crate::input::CreateNetworkInterfaceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) groups: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) ipv6_address_count: std::option::Option<i32>,
        pub(crate) ipv6_addresses:
            std::option::Option<std::vec::Vec<crate::model::InstanceIpv6Address>>,
        pub(crate) private_ip_address: std::option::Option<std::string::String>,
        pub(crate) private_ip_addresses:
            std::option::Option<std::vec::Vec<crate::model::PrivateIpAddressSpecification>>,
        pub(crate) secondary_private_ip_address_count: std::option::Option<i32>,
        pub(crate) interface_type: std::option::Option<crate::model::NetworkInterfaceCreationType>,
        pub(crate) subnet_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>A description for the network interface.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn groups(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.groups.unwrap_or_default();
            v.push(input.into());
            self.groups = Some(v);
            self
        }
        pub fn set_groups(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.groups = input;
            self
        }
        /// <p>The number of IPv6 addresses to assign to a network interface. Amazon EC2
        /// automatically selects the IPv6 addresses from the subnet range. You can't use this
        /// option if specifying specific IPv6 addresses. If your subnet has the <code>AssignIpv6AddressOnCreation</code> attribute set
        /// to <code>true</code>, you can specify <code>0</code> to override this setting.</p>
        pub fn ipv6_address_count(mut self, input: i32) -> Self {
            self.ipv6_address_count = Some(input);
            self
        }
        pub fn set_ipv6_address_count(mut self, input: std::option::Option<i32>) -> Self {
            self.ipv6_address_count = input;
            self
        }
        pub fn ipv6_addresses(
            mut self,
            input: impl Into<crate::model::InstanceIpv6Address>,
        ) -> Self {
            let mut v = self.ipv6_addresses.unwrap_or_default();
            v.push(input.into());
            self.ipv6_addresses = Some(v);
            self
        }
        pub fn set_ipv6_addresses(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::InstanceIpv6Address>>,
        ) -> Self {
            self.ipv6_addresses = input;
            self
        }
        /// <p>The primary private IPv4 address of the network interface. If you don't specify an
        /// IPv4 address, Amazon EC2 selects one for you from the subnet's IPv4 CIDR range. If you
        /// specify an IP address, you cannot indicate any IP addresses specified in
        /// <code>privateIpAddresses</code> as primary (only one IP address can be designated as
        /// primary).</p>
        pub fn private_ip_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.private_ip_address = Some(input.into());
            self
        }
        pub fn set_private_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.private_ip_address = input;
            self
        }
        pub fn private_ip_addresses(
            mut self,
            input: impl Into<crate::model::PrivateIpAddressSpecification>,
        ) -> Self {
            let mut v = self.private_ip_addresses.unwrap_or_default();
            v.push(input.into());
            self.private_ip_addresses = Some(v);
            self
        }
        pub fn set_private_ip_addresses(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::PrivateIpAddressSpecification>>,
        ) -> Self {
            self.private_ip_addresses = input;
            self
        }
        /// <p>The number of secondary private IPv4 addresses to assign to a network interface. When
        /// you specify a number of secondary IPv4 addresses, Amazon EC2 selects these IP addresses
        /// within the subnet's IPv4 CIDR range. You can't specify this option and specify more than
        /// one private IP address using <code>privateIpAddresses</code>.</p>
        /// <p>The number of IP addresses you can assign to a network interface varies by instance
        /// type. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-eni.html#AvailableIpPerENI">IP Addresses Per ENI Per
        /// Instance Type</a> in the <i>Amazon Virtual Private Cloud User Guide</i>.</p>
        pub fn secondary_private_ip_address_count(mut self, input: i32) -> Self {
            self.secondary_private_ip_address_count = Some(input);
            self
        }
        pub fn set_secondary_private_ip_address_count(
            mut self,
            input: std::option::Option<i32>,
        ) -> Self {
            self.secondary_private_ip_address_count = input;
            self
        }
        /// <p>Indicates the type of network interface. To create an Elastic Fabric Adapter (EFA), specify
        /// <code>efa</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html">
        /// Elastic Fabric Adapter</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>. To create a trunk network interface, specify
        /// <code>efa</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/eni-trunking.html">
        /// Network interface trunking</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn interface_type(mut self, input: crate::model::NetworkInterfaceCreationType) -> Self {
            self.interface_type = Some(input);
            self
        }
        pub fn set_interface_type(
            mut self,
            input: std::option::Option<crate::model::NetworkInterfaceCreationType>,
        ) -> Self {
            self.interface_type = input;
            self
        }
        /// <p>The ID of the subnet to associate with the network interface.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateNetworkInterfaceInput`](crate::input::CreateNetworkInterfaceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateNetworkInterfaceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateNetworkInterfaceInput {
                description: self.description,
                dry_run: self.dry_run,
                groups: self.groups,
                ipv6_address_count: self.ipv6_address_count,
                ipv6_addresses: self.ipv6_addresses,
                private_ip_address: self.private_ip_address,
                private_ip_addresses: self.private_ip_addresses,
                secondary_private_ip_address_count: self.secondary_private_ip_address_count,
                interface_type: self.interface_type,
                subnet_id: self.subnet_id,
                tag_specifications: self.tag_specifications,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateNetworkInterfaceInputOperationOutputAlias = crate::operation::CreateNetworkInterface;
#[doc(hidden)]
pub type CreateNetworkInterfaceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateNetworkInterfaceInput {
    /// Consumes the builder and constructs an Operation<[`CreateNetworkInterface`](crate::operation::CreateNetworkInterface)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateNetworkInterface,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_network_interface(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateNetworkInterface::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateNetworkInterface",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateNetworkInterfaceInput`](crate::input::CreateNetworkInterfaceInput)
    pub fn builder() -> crate::input::create_network_interface_input::Builder {
        crate::input::create_network_interface_input::Builder::default()
    }
}

/// See [`CreateNetworkInterfacePermissionInput`](crate::input::CreateNetworkInterfacePermissionInput)
pub mod create_network_interface_permission_input {
    /// A builder for [`CreateNetworkInterfacePermissionInput`](crate::input::CreateNetworkInterfacePermissionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) aws_account_id: std::option::Option<std::string::String>,
        pub(crate) aws_service: std::option::Option<std::string::String>,
        pub(crate) permission: std::option::Option<crate::model::InterfacePermissionType>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>The account ID.</p>
        pub fn aws_account_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.aws_account_id = Some(input.into());
            self
        }
        pub fn set_aws_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.aws_account_id = input;
            self
        }
        /// <p>The Amazon Web Service. Currently not supported.</p>
        pub fn aws_service(mut self, input: impl Into<std::string::String>) -> Self {
            self.aws_service = Some(input.into());
            self
        }
        pub fn set_aws_service(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.aws_service = input;
            self
        }
        /// <p>The type of permission to grant.</p>
        pub fn permission(mut self, input: crate::model::InterfacePermissionType) -> Self {
            self.permission = Some(input);
            self
        }
        pub fn set_permission(
            mut self,
            input: std::option::Option<crate::model::InterfacePermissionType>,
        ) -> Self {
            self.permission = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateNetworkInterfacePermissionInput`](crate::input::CreateNetworkInterfacePermissionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateNetworkInterfacePermissionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateNetworkInterfacePermissionInput {
                network_interface_id: self.network_interface_id,
                aws_account_id: self.aws_account_id,
                aws_service: self.aws_service,
                permission: self.permission,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateNetworkInterfacePermissionInputOperationOutputAlias =
    crate::operation::CreateNetworkInterfacePermission;
#[doc(hidden)]
pub type CreateNetworkInterfacePermissionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateNetworkInterfacePermissionInput {
    /// Consumes the builder and constructs an Operation<[`CreateNetworkInterfacePermission`](crate::operation::CreateNetworkInterfacePermission)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateNetworkInterfacePermission,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_network_interface_permission(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateNetworkInterfacePermission::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateNetworkInterfacePermission",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateNetworkInterfacePermissionInput`](crate::input::CreateNetworkInterfacePermissionInput)
    pub fn builder() -> crate::input::create_network_interface_permission_input::Builder {
        crate::input::create_network_interface_permission_input::Builder::default()
    }
}

/// See [`CreatePlacementGroupInput`](crate::input::CreatePlacementGroupInput)
pub mod create_placement_group_input {
    /// A builder for [`CreatePlacementGroupInput`](crate::input::CreatePlacementGroupInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) strategy: std::option::Option<crate::model::PlacementStrategy>,
        pub(crate) partition_count: std::option::Option<i32>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>A name for the placement group. Must be unique within the scope of your account for
        /// the Region.</p>
        /// <p>Constraints: Up to 255 ASCII characters</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        /// <p>The placement strategy.</p>
        pub fn strategy(mut self, input: crate::model::PlacementStrategy) -> Self {
            self.strategy = Some(input);
            self
        }
        pub fn set_strategy(
            mut self,
            input: std::option::Option<crate::model::PlacementStrategy>,
        ) -> Self {
            self.strategy = input;
            self
        }
        /// <p>The number of partitions. Valid only when <b>Strategy</b> is
        /// set to <code>partition</code>.</p>
        pub fn partition_count(mut self, input: i32) -> Self {
            self.partition_count = Some(input);
            self
        }
        pub fn set_partition_count(mut self, input: std::option::Option<i32>) -> Self {
            self.partition_count = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreatePlacementGroupInput`](crate::input::CreatePlacementGroupInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreatePlacementGroupInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreatePlacementGroupInput {
                dry_run: self.dry_run,
                group_name: self.group_name,
                strategy: self.strategy,
                partition_count: self.partition_count,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreatePlacementGroupInputOperationOutputAlias = crate::operation::CreatePlacementGroup;
#[doc(hidden)]
pub type CreatePlacementGroupInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreatePlacementGroupInput {
    /// Consumes the builder and constructs an Operation<[`CreatePlacementGroup`](crate::operation::CreatePlacementGroup)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreatePlacementGroup,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_placement_group(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreatePlacementGroup::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreatePlacementGroup",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreatePlacementGroupInput`](crate::input::CreatePlacementGroupInput)
    pub fn builder() -> crate::input::create_placement_group_input::Builder {
        crate::input::create_placement_group_input::Builder::default()
    }
}

/// See [`CreateReplaceRootVolumeTaskInput`](crate::input::CreateReplaceRootVolumeTaskInput)
pub mod create_replace_root_volume_task_input {
    /// A builder for [`CreateReplaceRootVolumeTaskInput`](crate::input::CreateReplaceRootVolumeTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) snapshot_id: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>The ID of the instance for which to replace the root volume.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The ID of the snapshot from which to restore the replacement root volume. If you want to
        /// restore the volume to the initial launch state, omit this parameter.</p>
        pub fn snapshot_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.snapshot_id = Some(input.into());
            self
        }
        pub fn set_snapshot_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.snapshot_id = input;
            self
        }
        /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
        /// If you do not specify a client token, a randomly generated token is used for the request
        /// to ensure idempotency. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateReplaceRootVolumeTaskInput`](crate::input::CreateReplaceRootVolumeTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateReplaceRootVolumeTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateReplaceRootVolumeTaskInput {
                instance_id: self.instance_id,
                snapshot_id: self.snapshot_id,
                client_token: self.client_token,
                dry_run: self.dry_run,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateReplaceRootVolumeTaskInputOperationOutputAlias =
    crate::operation::CreateReplaceRootVolumeTask;
#[doc(hidden)]
pub type CreateReplaceRootVolumeTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateReplaceRootVolumeTaskInput {
    /// Consumes the builder and constructs an Operation<[`CreateReplaceRootVolumeTask`](crate::operation::CreateReplaceRootVolumeTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateReplaceRootVolumeTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_replace_root_volume_task(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateReplaceRootVolumeTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateReplaceRootVolumeTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateReplaceRootVolumeTaskInput`](crate::input::CreateReplaceRootVolumeTaskInput)
    pub fn builder() -> crate::input::create_replace_root_volume_task_input::Builder {
        crate::input::create_replace_root_volume_task_input::Builder::default()
    }
}

/// See [`CreateReservedInstancesListingInput`](crate::input::CreateReservedInstancesListingInput)
pub mod create_reserved_instances_listing_input {
    /// A builder for [`CreateReservedInstancesListingInput`](crate::input::CreateReservedInstancesListingInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) instance_count: std::option::Option<i32>,
        pub(crate) price_schedules:
            std::option::Option<std::vec::Vec<crate::model::PriceScheduleSpecification>>,
        pub(crate) reserved_instances_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Unique, case-sensitive identifier you provide to ensure idempotency of your
        /// listings. This helps avoid duplicate listings. For more information, see
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>The number of instances that are a part of a Reserved Instance account to be listed in the Reserved Instance Marketplace. This number should be less than or equal to the instance count associated with the Reserved Instance ID specified in this call.</p>
        pub fn instance_count(mut self, input: i32) -> Self {
            self.instance_count = Some(input);
            self
        }
        pub fn set_instance_count(mut self, input: std::option::Option<i32>) -> Self {
            self.instance_count = input;
            self
        }
        pub fn price_schedules(
            mut self,
            input: impl Into<crate::model::PriceScheduleSpecification>,
        ) -> Self {
            let mut v = self.price_schedules.unwrap_or_default();
            v.push(input.into());
            self.price_schedules = Some(v);
            self
        }
        pub fn set_price_schedules(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::PriceScheduleSpecification>>,
        ) -> Self {
            self.price_schedules = input;
            self
        }
        /// <p>The ID of the active Standard Reserved Instance.</p>
        pub fn reserved_instances_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.reserved_instances_id = Some(input.into());
            self
        }
        pub fn set_reserved_instances_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.reserved_instances_id = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateReservedInstancesListingInput`](crate::input::CreateReservedInstancesListingInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateReservedInstancesListingInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateReservedInstancesListingInput {
                client_token: self.client_token,
                instance_count: self.instance_count,
                price_schedules: self.price_schedules,
                reserved_instances_id: self.reserved_instances_id,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateReservedInstancesListingInputOperationOutputAlias =
    crate::operation::CreateReservedInstancesListing;
#[doc(hidden)]
pub type CreateReservedInstancesListingInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateReservedInstancesListingInput {
    /// Consumes the builder and constructs an Operation<[`CreateReservedInstancesListing`](crate::operation::CreateReservedInstancesListing)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateReservedInstancesListing,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_reserved_instances_listing(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateReservedInstancesListing::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateReservedInstancesListing",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateReservedInstancesListingInput`](crate::input::CreateReservedInstancesListingInput)
    pub fn builder() -> crate::input::create_reserved_instances_listing_input::Builder {
        crate::input::create_reserved_instances_listing_input::Builder::default()
    }
}

/// See [`CreateRestoreImageTaskInput`](crate::input::CreateRestoreImageTaskInput)
pub mod create_restore_image_task_input {
    /// A builder for [`CreateRestoreImageTaskInput`](crate::input::CreateRestoreImageTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) bucket: std::option::Option<std::string::String>,
        pub(crate) object_key: std::option::Option<std::string::String>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The name of the S3 bucket that contains the stored AMI object.</p>
        pub fn bucket(mut self, input: impl Into<std::string::String>) -> Self {
            self.bucket = Some(input.into());
            self
        }
        pub fn set_bucket(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.bucket = input;
            self
        }
        /// <p>The name of the stored AMI object in the bucket.</p>
        pub fn object_key(mut self, input: impl Into<std::string::String>) -> Self {
            self.object_key = Some(input.into());
            self
        }
        pub fn set_object_key(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.object_key = input;
            self
        }
        /// <p>The name for the restored AMI. The name must be unique for AMIs in the Region for this
        /// account. If you do not provide a name, the new AMI gets the same name as the original
        /// AMI.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateRestoreImageTaskInput`](crate::input::CreateRestoreImageTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateRestoreImageTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateRestoreImageTaskInput {
                bucket: self.bucket,
                object_key: self.object_key,
                name: self.name,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateRestoreImageTaskInputOperationOutputAlias = crate::operation::CreateRestoreImageTask;
#[doc(hidden)]
pub type CreateRestoreImageTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateRestoreImageTaskInput {
    /// Consumes the builder and constructs an Operation<[`CreateRestoreImageTask`](crate::operation::CreateRestoreImageTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateRestoreImageTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_restore_image_task(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateRestoreImageTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateRestoreImageTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateRestoreImageTaskInput`](crate::input::CreateRestoreImageTaskInput)
    pub fn builder() -> crate::input::create_restore_image_task_input::Builder {
        crate::input::create_restore_image_task_input::Builder::default()
    }
}

/// See [`CreateRouteInput`](crate::input::CreateRouteInput)
pub mod create_route_input {
    /// A builder for [`CreateRouteInput`](crate::input::CreateRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) destination_ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) destination_prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) egress_only_internet_gateway_id: std::option::Option<std::string::String>,
        pub(crate) gateway_id: std::option::Option<std::string::String>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) nat_gateway_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) local_gateway_id: std::option::Option<std::string::String>,
        pub(crate) carrier_gateway_id: std::option::Option<std::string::String>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
        pub(crate) vpc_peering_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The IPv4 CIDR address block used for the destination match. Routing decisions are based on the most specific match. We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The IPv6 CIDR block used for the destination match. Routing decisions are based on the most specific match.</p>
        pub fn destination_ipv6_cidr_block(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.destination_ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_ipv6_cidr_block = input;
            self
        }
        /// <p>The ID of a prefix list used for the destination match.</p>
        pub fn destination_prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_prefix_list_id = Some(input.into());
            self
        }
        pub fn set_destination_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_prefix_list_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of a VPC endpoint. Supported for Gateway Load Balancer endpoints only.</p>
        pub fn vpc_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_endpoint_id = Some(input.into());
            self
        }
        pub fn set_vpc_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_endpoint_id = input;
            self
        }
        /// <p>[IPv6 traffic only] The ID of an egress-only internet gateway.</p>
        pub fn egress_only_internet_gateway_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.egress_only_internet_gateway_id = Some(input.into());
            self
        }
        pub fn set_egress_only_internet_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.egress_only_internet_gateway_id = input;
            self
        }
        /// <p>The ID of an internet gateway or virtual private gateway attached to your
        /// VPC.</p>
        pub fn gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.gateway_id = Some(input.into());
            self
        }
        pub fn set_gateway_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.gateway_id = input;
            self
        }
        /// <p>The ID of a NAT instance in your VPC. The operation fails if you specify an instance ID unless exactly one network interface is attached.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>[IPv4 traffic only] The ID of a NAT gateway.</p>
        pub fn nat_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.nat_gateway_id = Some(input.into());
            self
        }
        pub fn set_nat_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.nat_gateway_id = input;
            self
        }
        /// <p>The ID of a transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>The ID of the local gateway.</p>
        pub fn local_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.local_gateway_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_id = input;
            self
        }
        /// <p>The ID of the carrier gateway.</p>
        /// <p>You can only use this option when the VPC contains a subnet which is associated with a Wavelength Zone.</p>
        pub fn carrier_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.carrier_gateway_id = Some(input.into());
            self
        }
        pub fn set_carrier_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.carrier_gateway_id = input;
            self
        }
        /// <p>The ID of a network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>The ID of the route table for the route.</p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// <p>The ID of a VPC peering connection.</p>
        pub fn vpc_peering_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_peering_connection_id = Some(input.into());
            self
        }
        pub fn set_vpc_peering_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_peering_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateRouteInput`](crate::input::CreateRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateRouteInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                destination_ipv6_cidr_block: self.destination_ipv6_cidr_block,
                destination_prefix_list_id: self.destination_prefix_list_id,
                dry_run: self.dry_run,
                vpc_endpoint_id: self.vpc_endpoint_id,
                egress_only_internet_gateway_id: self.egress_only_internet_gateway_id,
                gateway_id: self.gateway_id,
                instance_id: self.instance_id,
                nat_gateway_id: self.nat_gateway_id,
                transit_gateway_id: self.transit_gateway_id,
                local_gateway_id: self.local_gateway_id,
                carrier_gateway_id: self.carrier_gateway_id,
                network_interface_id: self.network_interface_id,
                route_table_id: self.route_table_id,
                vpc_peering_connection_id: self.vpc_peering_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateRouteInputOperationOutputAlias = crate::operation::CreateRoute;
#[doc(hidden)]
pub type CreateRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateRouteInput {
    /// Consumes the builder and constructs an Operation<[`CreateRoute`](crate::operation::CreateRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_route(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("CreateRoute", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateRouteInput`](crate::input::CreateRouteInput)
    pub fn builder() -> crate::input::create_route_input::Builder {
        crate::input::create_route_input::Builder::default()
    }
}

/// See [`CreateRouteTableInput`](crate::input::CreateRouteTableInput)
pub mod create_route_table_input {
    /// A builder for [`CreateRouteTableInput`](crate::input::CreateRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateRouteTableInput`](crate::input::CreateRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateRouteTableInput {
                dry_run: self.dry_run,
                vpc_id: self.vpc_id,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateRouteTableInputOperationOutputAlias = crate::operation::CreateRouteTable;
#[doc(hidden)]
pub type CreateRouteTableInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`CreateRouteTable`](crate::operation::CreateRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_route_table(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateRouteTableInput`](crate::input::CreateRouteTableInput)
    pub fn builder() -> crate::input::create_route_table_input::Builder {
        crate::input::create_route_table_input::Builder::default()
    }
}

/// See [`CreateSecurityGroupInput`](crate::input::CreateSecurityGroupInput)
pub mod create_security_group_input {
    /// A builder for [`CreateSecurityGroupInput`](crate::input::CreateSecurityGroupInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>A description for the security group. This is informational only.</p>
        /// <p>Constraints: Up to 255 characters in length</p>
        /// <p>Constraints for EC2-Classic: ASCII characters</p>
        /// <p>Constraints for EC2-VPC: a-z, A-Z, 0-9, spaces, and ._-:/()#,@[]+=&;{}!$*</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The name of the security group.</p>
        /// <p>Constraints: Up to 255 characters in length. Cannot start with
        /// <code>sg-</code>.</p>
        /// <p>Constraints for EC2-Classic: ASCII characters</p>
        /// <p>Constraints for EC2-VPC: a-z, A-Z, 0-9, spaces, and ._-:/()#,@[]+=&;{}!$*</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        /// <p>[EC2-VPC] The ID of the VPC. Required for EC2-VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateSecurityGroupInput`](crate::input::CreateSecurityGroupInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateSecurityGroupInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateSecurityGroupInput {
                description: self.description,
                group_name: self.group_name,
                vpc_id: self.vpc_id,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateSecurityGroupInputOperationOutputAlias = crate::operation::CreateSecurityGroup;
#[doc(hidden)]
pub type CreateSecurityGroupInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateSecurityGroupInput {
    /// Consumes the builder and constructs an Operation<[`CreateSecurityGroup`](crate::operation::CreateSecurityGroup)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateSecurityGroup,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_security_group(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateSecurityGroup::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateSecurityGroup",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateSecurityGroupInput`](crate::input::CreateSecurityGroupInput)
    pub fn builder() -> crate::input::create_security_group_input::Builder {
        crate::input::create_security_group_input::Builder::default()
    }
}

/// See [`CreateSnapshotInput`](crate::input::CreateSnapshotInput)
pub mod create_snapshot_input {
    /// A builder for [`CreateSnapshotInput`](crate::input::CreateSnapshotInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) outpost_arn: std::option::Option<std::string::String>,
        pub(crate) volume_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>A description for the snapshot.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the AWS Outpost on which to create a local  
        /// snapshot.</p>
        /// <ul>
        /// <li>
        /// <p>To create a snapshot of a volume in a Region, omit this parameter. The snapshot
        /// is created in the same Region as the volume.</p>
        /// </li>
        /// <li>
        /// <p>To create a snapshot of a volume on an Outpost and store the snapshot in the
        /// Region, omit this parameter. The snapshot is created in the Region for the
        /// Outpost.</p>
        /// </li>
        /// <li>
        /// <p>To create a snapshot of a volume on an Outpost and store the snapshot on an
        /// Outpost, specify the ARN of the destination Outpost. The snapshot must be created on
        /// the same Outpost as the volume.</p>
        /// </li>
        /// </ul>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#create-snapshot">
        /// Creating local snapshots from volumes on an Outpost</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.outpost_arn = Some(input.into());
            self
        }
        pub fn set_outpost_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.outpost_arn = input;
            self
        }
        /// <p>The ID of the EBS volume.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateSnapshotInput`](crate::input::CreateSnapshotInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateSnapshotInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateSnapshotInput {
                description: self.description,
                outpost_arn: self.outpost_arn,
                volume_id: self.volume_id,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateSnapshotInputOperationOutputAlias = crate::operation::CreateSnapshot;
#[doc(hidden)]
pub type CreateSnapshotInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateSnapshotInput {
    /// Consumes the builder and constructs an Operation<[`CreateSnapshot`](crate::operation::CreateSnapshot)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateSnapshot,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_snapshot(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateSnapshot::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateSnapshot",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateSnapshotInput`](crate::input::CreateSnapshotInput)
    pub fn builder() -> crate::input::create_snapshot_input::Builder {
        crate::input::create_snapshot_input::Builder::default()
    }
}

/// See [`CreateSnapshotsInput`](crate::input::CreateSnapshotsInput)
pub mod create_snapshots_input {
    /// A builder for [`CreateSnapshotsInput`](crate::input::CreateSnapshotsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) instance_specification: std::option::Option<crate::model::InstanceSpecification>,
        pub(crate) outpost_arn: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) copy_tags_from_source: std::option::Option<crate::model::CopyTagsFromSource>,
    }
    impl Builder {
        /// <p> A description propagated to every snapshot specified by the instance.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The instance to specify which volumes should be included in the snapshots.</p>
        pub fn instance_specification(
            mut self,
            input: crate::model::InstanceSpecification,
        ) -> Self {
            self.instance_specification = Some(input);
            self
        }
        pub fn set_instance_specification(
            mut self,
            input: std::option::Option<crate::model::InstanceSpecification>,
        ) -> Self {
            self.instance_specification = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the AWS Outpost on which to create the local  
        /// snapshots.</p>
        /// <ul>
        /// <li>
        /// <p>To create snapshots from an instance in a Region, omit this parameter. The
        /// snapshots are created in the same Region as the instance.</p>
        /// </li>
        /// <li>
        /// <p>To create snapshots from an instance on an Outpost and store the snapshots
        /// in the Region, omit this parameter. The snapshots are created in the Region
        /// for the Outpost.</p>
        /// </li>
        /// <li>
        /// <p>To create snapshots from an instance on an Outpost and store the snapshots
        /// on an Outpost, specify the ARN of the destination Outpost. The snapshots must
        /// be created on the same Outpost as the instance.</p>
        /// </li>
        /// </ul>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#create-multivol-snapshot">
        /// Creating multi-volume local snapshots from instances on an Outpost</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.outpost_arn = Some(input.into());
            self
        }
        pub fn set_outpost_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.outpost_arn = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Copies the tags from the specified volume to corresponding snapshot.</p>
        pub fn copy_tags_from_source(mut self, input: crate::model::CopyTagsFromSource) -> Self {
            self.copy_tags_from_source = Some(input);
            self
        }
        pub fn set_copy_tags_from_source(
            mut self,
            input: std::option::Option<crate::model::CopyTagsFromSource>,
        ) -> Self {
            self.copy_tags_from_source = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateSnapshotsInput`](crate::input::CreateSnapshotsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateSnapshotsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateSnapshotsInput {
                description: self.description,
                instance_specification: self.instance_specification,
                outpost_arn: self.outpost_arn,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
                copy_tags_from_source: self.copy_tags_from_source,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateSnapshotsInputOperationOutputAlias = crate::operation::CreateSnapshots;
#[doc(hidden)]
pub type CreateSnapshotsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateSnapshotsInput {
    /// Consumes the builder and constructs an Operation<[`CreateSnapshots`](crate::operation::CreateSnapshots)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateSnapshots,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_snapshots(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateSnapshots::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateSnapshots",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateSnapshotsInput`](crate::input::CreateSnapshotsInput)
    pub fn builder() -> crate::input::create_snapshots_input::Builder {
        crate::input::create_snapshots_input::Builder::default()
    }
}

/// See [`CreateSpotDatafeedSubscriptionInput`](crate::input::CreateSpotDatafeedSubscriptionInput)
pub mod create_spot_datafeed_subscription_input {
    /// A builder for [`CreateSpotDatafeedSubscriptionInput`](crate::input::CreateSpotDatafeedSubscriptionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) bucket: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) prefix: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The name of the Amazon S3 bucket in which to store the Spot Instance data feed. For
        /// more information about bucket names, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/BucketRestrictions.html#bucketnamingrules">Rules for bucket
        /// naming</a> in the <i>Amazon S3 Developer Guide</i>.</p>
        pub fn bucket(mut self, input: impl Into<std::string::String>) -> Self {
            self.bucket = Some(input.into());
            self
        }
        pub fn set_bucket(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.bucket = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The prefix for the data feed file names.</p>
        pub fn prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix = Some(input.into());
            self
        }
        pub fn set_prefix(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.prefix = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateSpotDatafeedSubscriptionInput`](crate::input::CreateSpotDatafeedSubscriptionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateSpotDatafeedSubscriptionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateSpotDatafeedSubscriptionInput {
                bucket: self.bucket,
                dry_run: self.dry_run,
                prefix: self.prefix,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateSpotDatafeedSubscriptionInputOperationOutputAlias =
    crate::operation::CreateSpotDatafeedSubscription;
#[doc(hidden)]
pub type CreateSpotDatafeedSubscriptionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateSpotDatafeedSubscriptionInput {
    /// Consumes the builder and constructs an Operation<[`CreateSpotDatafeedSubscription`](crate::operation::CreateSpotDatafeedSubscription)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateSpotDatafeedSubscription,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_spot_datafeed_subscription(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateSpotDatafeedSubscription::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateSpotDatafeedSubscription",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateSpotDatafeedSubscriptionInput`](crate::input::CreateSpotDatafeedSubscriptionInput)
    pub fn builder() -> crate::input::create_spot_datafeed_subscription_input::Builder {
        crate::input::create_spot_datafeed_subscription_input::Builder::default()
    }
}

/// See [`CreateStoreImageTaskInput`](crate::input::CreateStoreImageTaskInput)
pub mod create_store_image_task_input {
    /// A builder for [`CreateStoreImageTaskInput`](crate::input::CreateStoreImageTaskInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) bucket: std::option::Option<std::string::String>,
        pub(crate) s3_object_tags: std::option::Option<std::vec::Vec<crate::model::S3ObjectTag>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the AMI.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>The name of the S3 bucket in which the AMI object will be stored. The bucket must be in
        /// the Region in which the request is being made. The AMI object appears in the bucket only after
        /// the upload task has completed. </p>
        pub fn bucket(mut self, input: impl Into<std::string::String>) -> Self {
            self.bucket = Some(input.into());
            self
        }
        pub fn set_bucket(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.bucket = input;
            self
        }
        pub fn s3_object_tags(mut self, input: impl Into<crate::model::S3ObjectTag>) -> Self {
            let mut v = self.s3_object_tags.unwrap_or_default();
            v.push(input.into());
            self.s3_object_tags = Some(v);
            self
        }
        pub fn set_s3_object_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::S3ObjectTag>>,
        ) -> Self {
            self.s3_object_tags = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateStoreImageTaskInput`](crate::input::CreateStoreImageTaskInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateStoreImageTaskInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateStoreImageTaskInput {
                image_id: self.image_id,
                bucket: self.bucket,
                s3_object_tags: self.s3_object_tags,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateStoreImageTaskInputOperationOutputAlias = crate::operation::CreateStoreImageTask;
#[doc(hidden)]
pub type CreateStoreImageTaskInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateStoreImageTaskInput {
    /// Consumes the builder and constructs an Operation<[`CreateStoreImageTask`](crate::operation::CreateStoreImageTask)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateStoreImageTask,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_store_image_task(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateStoreImageTask::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateStoreImageTask",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateStoreImageTaskInput`](crate::input::CreateStoreImageTaskInput)
    pub fn builder() -> crate::input::create_store_image_task_input::Builder {
        crate::input::create_store_image_task_input::Builder::default()
    }
}

/// See [`CreateSubnetInput`](crate::input::CreateSubnetInput)
pub mod create_subnet_input {
    /// A builder for [`CreateSubnetInput`](crate::input::CreateSubnetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) availability_zone_id: std::option::Option<std::string::String>,
        pub(crate) cidr_block: std::option::Option<std::string::String>,
        pub(crate) ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) outpost_arn: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>The Availability Zone or Local Zone for the subnet.</p>
        /// <p>Default: AWS selects one for you. If you create more than one subnet in your VPC, we
        /// do not necessarily select a different zone for each subnet.</p>
        /// <p>To create a subnet in a Local Zone, set this value to the Local Zone ID, for example
        /// <code>us-west-2-lax-1a</code>. For information about the Regions that support Local Zones,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-regions-availability-zones.html#concepts-available-regions">Available Regions</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        /// <p>To create a subnet in an Outpost, set this value to the Availability Zone for the
        /// Outpost and specify the Outpost ARN.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>The AZ ID or the Local Zone ID of the subnet.</p>
        pub fn availability_zone_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone_id = Some(input.into());
            self
        }
        pub fn set_availability_zone_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone_id = input;
            self
        }
        /// <p>The IPv4 network range for the subnet, in CIDR notation. For example, <code>10.0.0.0/24</code>. We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
        pub fn cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_block = Some(input.into());
            self
        }
        pub fn set_cidr_block(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_block = input;
            self
        }
        /// <p>The IPv6 network range for the subnet, in CIDR notation. The subnet size must use a
        /// /64 prefix length.</p>
        pub fn ipv6_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Outpost. If you specify an Outpost ARN, you must also
        /// specify the Availability Zone of the Outpost subnet.</p>
        pub fn outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.outpost_arn = Some(input.into());
            self
        }
        pub fn set_outpost_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.outpost_arn = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateSubnetInput`](crate::input::CreateSubnetInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateSubnetInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateSubnetInput {
                tag_specifications: self.tag_specifications,
                availability_zone: self.availability_zone,
                availability_zone_id: self.availability_zone_id,
                cidr_block: self.cidr_block,
                ipv6_cidr_block: self.ipv6_cidr_block,
                outpost_arn: self.outpost_arn,
                vpc_id: self.vpc_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateSubnetInputOperationOutputAlias = crate::operation::CreateSubnet;
#[doc(hidden)]
pub type CreateSubnetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateSubnetInput {
    /// Consumes the builder and constructs an Operation<[`CreateSubnet`](crate::operation::CreateSubnet)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateSubnet,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_subnet(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateSubnet::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("CreateSubnet", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateSubnetInput`](crate::input::CreateSubnetInput)
    pub fn builder() -> crate::input::create_subnet_input::Builder {
        crate::input::create_subnet_input::Builder::default()
    }
}

/// See [`CreateTagsInput`](crate::input::CreateTagsInput)
pub mod create_tags_input {
    /// A builder for [`CreateTagsInput`](crate::input::CreateTagsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) resources: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) tags: std::option::Option<std::vec::Vec<crate::model::Tag>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn resources(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.resources.unwrap_or_default();
            v.push(input.into());
            self.resources = Some(v);
            self
        }
        pub fn set_resources(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.resources = input;
            self
        }
        pub fn tags(mut self, input: impl Into<crate::model::Tag>) -> Self {
            let mut v = self.tags.unwrap_or_default();
            v.push(input.into());
            self.tags = Some(v);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.tags = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTagsInput`](crate::input::CreateTagsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateTagsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateTagsInput {
                dry_run: self.dry_run,
                resources: self.resources,
                tags: self.tags,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTagsInputOperationOutputAlias = crate::operation::CreateTags;
#[doc(hidden)]
pub type CreateTagsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTagsInput {
    /// Consumes the builder and constructs an Operation<[`CreateTags`](crate::operation::CreateTags)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTags,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_tags(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTags::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("CreateTags", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTagsInput`](crate::input::CreateTagsInput)
    pub fn builder() -> crate::input::create_tags_input::Builder {
        crate::input::create_tags_input::Builder::default()
    }
}

/// See [`CreateTrafficMirrorFilterInput`](crate::input::CreateTrafficMirrorFilterInput)
pub mod create_traffic_mirror_filter_input {
    /// A builder for [`CreateTrafficMirrorFilterInput`](crate::input::CreateTrafficMirrorFilterInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The description of the Traffic Mirror filter.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTrafficMirrorFilterInput`](crate::input::CreateTrafficMirrorFilterInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTrafficMirrorFilterInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTrafficMirrorFilterInput {
                description: self.description,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTrafficMirrorFilterInputOperationOutputAlias =
    crate::operation::CreateTrafficMirrorFilter;
#[doc(hidden)]
pub type CreateTrafficMirrorFilterInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTrafficMirrorFilterInput {
    /// Consumes the builder and constructs an Operation<[`CreateTrafficMirrorFilter`](crate::operation::CreateTrafficMirrorFilter)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTrafficMirrorFilter,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_traffic_mirror_filter(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTrafficMirrorFilter::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTrafficMirrorFilter",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTrafficMirrorFilterInput`](crate::input::CreateTrafficMirrorFilterInput)
    pub fn builder() -> crate::input::create_traffic_mirror_filter_input::Builder {
        crate::input::create_traffic_mirror_filter_input::Builder::default()
    }
}

/// See [`CreateTrafficMirrorFilterRuleInput`](crate::input::CreateTrafficMirrorFilterRuleInput)
pub mod create_traffic_mirror_filter_rule_input {
    /// A builder for [`CreateTrafficMirrorFilterRuleInput`](crate::input::CreateTrafficMirrorFilterRuleInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_filter_id: std::option::Option<std::string::String>,
        pub(crate) traffic_direction: std::option::Option<crate::model::TrafficDirection>,
        pub(crate) rule_number: std::option::Option<i32>,
        pub(crate) rule_action: std::option::Option<crate::model::TrafficMirrorRuleAction>,
        pub(crate) destination_port_range:
            std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        pub(crate) source_port_range:
            std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        pub(crate) protocol: std::option::Option<i32>,
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) source_cidr_block: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the filter that this rule is associated with.</p>
        pub fn traffic_mirror_filter_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_filter_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_filter_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_id = input;
            self
        }
        /// <p>The type of traffic (<code>ingress</code> | <code>egress</code>).</p>
        pub fn traffic_direction(mut self, input: crate::model::TrafficDirection) -> Self {
            self.traffic_direction = Some(input);
            self
        }
        pub fn set_traffic_direction(
            mut self,
            input: std::option::Option<crate::model::TrafficDirection>,
        ) -> Self {
            self.traffic_direction = input;
            self
        }
        /// <p>The number of the Traffic Mirror rule. This number must be unique for each Traffic Mirror rule in a given
        /// direction. The rules are processed in ascending order by rule number.</p>
        pub fn rule_number(mut self, input: i32) -> Self {
            self.rule_number = Some(input);
            self
        }
        pub fn set_rule_number(mut self, input: std::option::Option<i32>) -> Self {
            self.rule_number = input;
            self
        }
        /// <p>The action to take (<code>accept</code> | <code>reject</code>) on the filtered traffic.</p>
        pub fn rule_action(mut self, input: crate::model::TrafficMirrorRuleAction) -> Self {
            self.rule_action = Some(input);
            self
        }
        pub fn set_rule_action(
            mut self,
            input: std::option::Option<crate::model::TrafficMirrorRuleAction>,
        ) -> Self {
            self.rule_action = input;
            self
        }
        /// <p>The destination port range.</p>
        pub fn destination_port_range(
            mut self,
            input: crate::model::TrafficMirrorPortRangeRequest,
        ) -> Self {
            self.destination_port_range = Some(input);
            self
        }
        pub fn set_destination_port_range(
            mut self,
            input: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        ) -> Self {
            self.destination_port_range = input;
            self
        }
        /// <p>The source port range.</p>
        pub fn source_port_range(
            mut self,
            input: crate::model::TrafficMirrorPortRangeRequest,
        ) -> Self {
            self.source_port_range = Some(input);
            self
        }
        pub fn set_source_port_range(
            mut self,
            input: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        ) -> Self {
            self.source_port_range = input;
            self
        }
        /// <p>The protocol, for example UDP, to assign to the Traffic Mirror rule.</p>
        /// <p>For information about the protocol value, see <a href="https://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml">Protocol Numbers</a> on the  Internet Assigned Numbers Authority (IANA) website.</p>
        pub fn protocol(mut self, input: i32) -> Self {
            self.protocol = Some(input);
            self
        }
        pub fn set_protocol(mut self, input: std::option::Option<i32>) -> Self {
            self.protocol = input;
            self
        }
        /// <p>The destination CIDR block to assign to the Traffic Mirror rule.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The source CIDR block to assign to the Traffic Mirror rule.</p>
        pub fn source_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_cidr_block = Some(input.into());
            self
        }
        pub fn set_source_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_cidr_block = input;
            self
        }
        /// <p>The description of the Traffic Mirror rule.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTrafficMirrorFilterRuleInput`](crate::input::CreateTrafficMirrorFilterRuleInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTrafficMirrorFilterRuleInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTrafficMirrorFilterRuleInput {
                traffic_mirror_filter_id: self.traffic_mirror_filter_id,
                traffic_direction: self.traffic_direction,
                rule_number: self.rule_number,
                rule_action: self.rule_action,
                destination_port_range: self.destination_port_range,
                source_port_range: self.source_port_range,
                protocol: self.protocol,
                destination_cidr_block: self.destination_cidr_block,
                source_cidr_block: self.source_cidr_block,
                description: self.description,
                dry_run: self.dry_run,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTrafficMirrorFilterRuleInputOperationOutputAlias =
    crate::operation::CreateTrafficMirrorFilterRule;
#[doc(hidden)]
pub type CreateTrafficMirrorFilterRuleInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTrafficMirrorFilterRuleInput {
    /// Consumes the builder and constructs an Operation<[`CreateTrafficMirrorFilterRule`](crate::operation::CreateTrafficMirrorFilterRule)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTrafficMirrorFilterRule,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_traffic_mirror_filter_rule(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTrafficMirrorFilterRule::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTrafficMirrorFilterRule",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTrafficMirrorFilterRuleInput`](crate::input::CreateTrafficMirrorFilterRuleInput)
    pub fn builder() -> crate::input::create_traffic_mirror_filter_rule_input::Builder {
        crate::input::create_traffic_mirror_filter_rule_input::Builder::default()
    }
}

/// See [`CreateTrafficMirrorSessionInput`](crate::input::CreateTrafficMirrorSessionInput)
pub mod create_traffic_mirror_session_input {
    /// A builder for [`CreateTrafficMirrorSessionInput`](crate::input::CreateTrafficMirrorSessionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) traffic_mirror_target_id: std::option::Option<std::string::String>,
        pub(crate) traffic_mirror_filter_id: std::option::Option<std::string::String>,
        pub(crate) packet_length: std::option::Option<i32>,
        pub(crate) session_number: std::option::Option<i32>,
        pub(crate) virtual_network_id: std::option::Option<i32>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the source network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>The ID of the Traffic Mirror target.</p>
        pub fn traffic_mirror_target_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_target_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_target_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_target_id = input;
            self
        }
        /// <p>The ID of the Traffic Mirror filter.</p>
        pub fn traffic_mirror_filter_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_filter_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_filter_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_id = input;
            self
        }
        /// <p>The number of bytes in each packet to mirror. These are bytes after the VXLAN header. Do
        /// not specify this parameter when you want to mirror the entire packet. To mirror a subset of
        /// the packet, set this to the length (in bytes) that you want to mirror. For example, if you
        /// set this value to 100, then the first 100 bytes that meet the filter criteria are copied to
        /// the target.</p>
        /// <p>If you do not want to mirror the entire packet, use the <code>PacketLength</code> parameter to specify the number of bytes in each packet to mirror.</p>
        pub fn packet_length(mut self, input: i32) -> Self {
            self.packet_length = Some(input);
            self
        }
        pub fn set_packet_length(mut self, input: std::option::Option<i32>) -> Self {
            self.packet_length = input;
            self
        }
        /// <p>The session number determines the order in which sessions are evaluated when an interface is used by multiple sessions. The first session with a matching filter is the one that mirrors the packets.</p>
        /// <p>Valid values are 1-32766.</p>
        pub fn session_number(mut self, input: i32) -> Self {
            self.session_number = Some(input);
            self
        }
        pub fn set_session_number(mut self, input: std::option::Option<i32>) -> Self {
            self.session_number = input;
            self
        }
        /// <p>The VXLAN ID for the Traffic Mirror session. For more information about the VXLAN
        /// protocol, see <a href="https://tools.ietf.org/html/rfc7348">RFC 7348</a>. If you do
        /// not specify a <code>VirtualNetworkId</code>, an account-wide unique id is chosen at
        /// random.</p>
        pub fn virtual_network_id(mut self, input: i32) -> Self {
            self.virtual_network_id = Some(input);
            self
        }
        pub fn set_virtual_network_id(mut self, input: std::option::Option<i32>) -> Self {
            self.virtual_network_id = input;
            self
        }
        /// <p>The description of the Traffic Mirror session.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTrafficMirrorSessionInput`](crate::input::CreateTrafficMirrorSessionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTrafficMirrorSessionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTrafficMirrorSessionInput {
                network_interface_id: self.network_interface_id,
                traffic_mirror_target_id: self.traffic_mirror_target_id,
                traffic_mirror_filter_id: self.traffic_mirror_filter_id,
                packet_length: self.packet_length,
                session_number: self.session_number,
                virtual_network_id: self.virtual_network_id,
                description: self.description,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTrafficMirrorSessionInputOperationOutputAlias =
    crate::operation::CreateTrafficMirrorSession;
#[doc(hidden)]
pub type CreateTrafficMirrorSessionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTrafficMirrorSessionInput {
    /// Consumes the builder and constructs an Operation<[`CreateTrafficMirrorSession`](crate::operation::CreateTrafficMirrorSession)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTrafficMirrorSession,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_traffic_mirror_session(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTrafficMirrorSession::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTrafficMirrorSession",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTrafficMirrorSessionInput`](crate::input::CreateTrafficMirrorSessionInput)
    pub fn builder() -> crate::input::create_traffic_mirror_session_input::Builder {
        crate::input::create_traffic_mirror_session_input::Builder::default()
    }
}

/// See [`CreateTrafficMirrorTargetInput`](crate::input::CreateTrafficMirrorTargetInput)
pub mod create_traffic_mirror_target_input {
    /// A builder for [`CreateTrafficMirrorTargetInput`](crate::input::CreateTrafficMirrorTargetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) network_load_balancer_arn: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The network interface ID that is associated with the target.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Network Load Balancer that is associated with the target.</p>
        pub fn network_load_balancer_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_load_balancer_arn = Some(input.into());
            self
        }
        pub fn set_network_load_balancer_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_load_balancer_arn = input;
            self
        }
        /// <p>The description of the Traffic Mirror target.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTrafficMirrorTargetInput`](crate::input::CreateTrafficMirrorTargetInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTrafficMirrorTargetInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTrafficMirrorTargetInput {
                network_interface_id: self.network_interface_id,
                network_load_balancer_arn: self.network_load_balancer_arn,
                description: self.description,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTrafficMirrorTargetInputOperationOutputAlias =
    crate::operation::CreateTrafficMirrorTarget;
#[doc(hidden)]
pub type CreateTrafficMirrorTargetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTrafficMirrorTargetInput {
    /// Consumes the builder and constructs an Operation<[`CreateTrafficMirrorTarget`](crate::operation::CreateTrafficMirrorTarget)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTrafficMirrorTarget,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_traffic_mirror_target(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTrafficMirrorTarget::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTrafficMirrorTarget",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTrafficMirrorTargetInput`](crate::input::CreateTrafficMirrorTargetInput)
    pub fn builder() -> crate::input::create_traffic_mirror_target_input::Builder {
        crate::input::create_traffic_mirror_target_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayInput`](crate::input::CreateTransitGatewayInput)
pub mod create_transit_gateway_input {
    /// A builder for [`CreateTransitGatewayInput`](crate::input::CreateTransitGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) options: std::option::Option<crate::model::TransitGatewayRequestOptions>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>A description of the transit gateway.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The transit gateway options.</p>
        pub fn options(mut self, input: crate::model::TransitGatewayRequestOptions) -> Self {
            self.options = Some(input);
            self
        }
        pub fn set_options(
            mut self,
            input: std::option::Option<crate::model::TransitGatewayRequestOptions>,
        ) -> Self {
            self.options = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayInput`](crate::input::CreateTransitGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayInput {
                description: self.description,
                options: self.options,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayInputOperationOutputAlias = crate::operation::CreateTransitGateway;
#[doc(hidden)]
pub type CreateTransitGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGateway`](crate::operation::CreateTransitGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_transit_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayInput`](crate::input::CreateTransitGatewayInput)
    pub fn builder() -> crate::input::create_transit_gateway_input::Builder {
        crate::input::create_transit_gateway_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayConnectInput`](crate::input::CreateTransitGatewayConnectInput)
pub mod create_transit_gateway_connect_input {
    /// A builder for [`CreateTransitGatewayConnectInput`](crate::input::CreateTransitGatewayConnectInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transport_transit_gateway_attachment_id:
            std::option::Option<std::string::String>,
        pub(crate) options:
            std::option::Option<crate::model::CreateTransitGatewayConnectRequestOptions>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway attachment. You can specify a VPC attachment or a AWS Direct Connect attachment.</p>
        pub fn transport_transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transport_transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transport_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transport_transit_gateway_attachment_id = input;
            self
        }
        /// <p>The Connect attachment options.</p>
        pub fn options(
            mut self,
            input: crate::model::CreateTransitGatewayConnectRequestOptions,
        ) -> Self {
            self.options = Some(input);
            self
        }
        pub fn set_options(
            mut self,
            input: std::option::Option<crate::model::CreateTransitGatewayConnectRequestOptions>,
        ) -> Self {
            self.options = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayConnectInput`](crate::input::CreateTransitGatewayConnectInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayConnectInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayConnectInput {
                transport_transit_gateway_attachment_id: self
                    .transport_transit_gateway_attachment_id,
                options: self.options,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayConnectInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayConnect;
#[doc(hidden)]
pub type CreateTransitGatewayConnectInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayConnectInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayConnect`](crate::operation::CreateTransitGatewayConnect)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayConnect,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_connect(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayConnect::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayConnect",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayConnectInput`](crate::input::CreateTransitGatewayConnectInput)
    pub fn builder() -> crate::input::create_transit_gateway_connect_input::Builder {
        crate::input::create_transit_gateway_connect_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayConnectPeerInput`](crate::input::CreateTransitGatewayConnectPeerInput)
pub mod create_transit_gateway_connect_peer_input {
    /// A builder for [`CreateTransitGatewayConnectPeerInput`](crate::input::CreateTransitGatewayConnectPeerInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_address: std::option::Option<std::string::String>,
        pub(crate) peer_address: std::option::Option<std::string::String>,
        pub(crate) bgp_options:
            std::option::Option<crate::model::TransitGatewayConnectRequestBgpOptions>,
        pub(crate) inside_cidr_blocks: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Connect attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>The peer IP address (GRE outer IP address) on the transit gateway side of the Connect peer, which must be
        /// specified from a transit gateway CIDR block. If not specified, Amazon automatically assigns
        /// the first available IP address from the transit gateway CIDR block.</p>
        pub fn transit_gateway_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_address = Some(input.into());
            self
        }
        pub fn set_transit_gateway_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_address = input;
            self
        }
        /// <p>The peer IP address (GRE outer IP address) on the appliance side of the Connect peer.</p>
        pub fn peer_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.peer_address = Some(input.into());
            self
        }
        pub fn set_peer_address(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.peer_address = input;
            self
        }
        /// <p>The BGP options for the Connect peer.</p>
        pub fn bgp_options(
            mut self,
            input: crate::model::TransitGatewayConnectRequestBgpOptions,
        ) -> Self {
            self.bgp_options = Some(input);
            self
        }
        pub fn set_bgp_options(
            mut self,
            input: std::option::Option<crate::model::TransitGatewayConnectRequestBgpOptions>,
        ) -> Self {
            self.bgp_options = input;
            self
        }
        pub fn inside_cidr_blocks(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.inside_cidr_blocks.unwrap_or_default();
            v.push(input.into());
            self.inside_cidr_blocks = Some(v);
            self
        }
        pub fn set_inside_cidr_blocks(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inside_cidr_blocks = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayConnectPeerInput`](crate::input::CreateTransitGatewayConnectPeerInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayConnectPeerInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayConnectPeerInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                transit_gateway_address: self.transit_gateway_address,
                peer_address: self.peer_address,
                bgp_options: self.bgp_options,
                inside_cidr_blocks: self.inside_cidr_blocks,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayConnectPeerInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayConnectPeer;
#[doc(hidden)]
pub type CreateTransitGatewayConnectPeerInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayConnectPeerInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayConnectPeer`](crate::operation::CreateTransitGatewayConnectPeer)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayConnectPeer,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_connect_peer(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayConnectPeer::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayConnectPeer",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayConnectPeerInput`](crate::input::CreateTransitGatewayConnectPeerInput)
    pub fn builder() -> crate::input::create_transit_gateway_connect_peer_input::Builder {
        crate::input::create_transit_gateway_connect_peer_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayMulticastDomainInput`](crate::input::CreateTransitGatewayMulticastDomainInput)
pub mod create_transit_gateway_multicast_domain_input {
    /// A builder for [`CreateTransitGatewayMulticastDomainInput`](crate::input::CreateTransitGatewayMulticastDomainInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) options:
            std::option::Option<crate::model::CreateTransitGatewayMulticastDomainRequestOptions>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>The options for the transit gateway multicast domain.</p>
        pub fn options(
            mut self,
            input: crate::model::CreateTransitGatewayMulticastDomainRequestOptions,
        ) -> Self {
            self.options = Some(input);
            self
        }
        pub fn set_options(
            mut self,
            input: std::option::Option<
                crate::model::CreateTransitGatewayMulticastDomainRequestOptions,
            >,
        ) -> Self {
            self.options = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayMulticastDomainInput`](crate::input::CreateTransitGatewayMulticastDomainInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayMulticastDomainInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayMulticastDomainInput {
                transit_gateway_id: self.transit_gateway_id,
                options: self.options,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayMulticastDomainInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayMulticastDomain;
#[doc(hidden)]
pub type CreateTransitGatewayMulticastDomainInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayMulticastDomainInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayMulticastDomain`](crate::operation::CreateTransitGatewayMulticastDomain)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayMulticastDomain,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_multicast_domain(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayMulticastDomain::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayMulticastDomain",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayMulticastDomainInput`](crate::input::CreateTransitGatewayMulticastDomainInput)
    pub fn builder() -> crate::input::create_transit_gateway_multicast_domain_input::Builder {
        crate::input::create_transit_gateway_multicast_domain_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayPeeringAttachmentInput`](crate::input::CreateTransitGatewayPeeringAttachmentInput)
pub mod create_transit_gateway_peering_attachment_input {
    /// A builder for [`CreateTransitGatewayPeeringAttachmentInput`](crate::input::CreateTransitGatewayPeeringAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) peer_transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) peer_account_id: std::option::Option<std::string::String>,
        pub(crate) peer_region: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>The ID of the peer transit gateway with which to create the peering attachment.</p>
        pub fn peer_transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.peer_transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_peer_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.peer_transit_gateway_id = input;
            self
        }
        /// <p>The AWS account ID of the owner of the peer transit gateway.</p>
        pub fn peer_account_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.peer_account_id = Some(input.into());
            self
        }
        pub fn set_peer_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.peer_account_id = input;
            self
        }
        /// <p>The Region where the peer transit gateway is located.</p>
        pub fn peer_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.peer_region = Some(input.into());
            self
        }
        pub fn set_peer_region(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.peer_region = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayPeeringAttachmentInput`](crate::input::CreateTransitGatewayPeeringAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayPeeringAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayPeeringAttachmentInput {
                transit_gateway_id: self.transit_gateway_id,
                peer_transit_gateway_id: self.peer_transit_gateway_id,
                peer_account_id: self.peer_account_id,
                peer_region: self.peer_region,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayPeeringAttachmentInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayPeeringAttachment;
#[doc(hidden)]
pub type CreateTransitGatewayPeeringAttachmentInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayPeeringAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayPeeringAttachment`](crate::operation::CreateTransitGatewayPeeringAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayPeeringAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_peering_attachment(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayPeeringAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayPeeringAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayPeeringAttachmentInput`](crate::input::CreateTransitGatewayPeeringAttachmentInput)
    pub fn builder() -> crate::input::create_transit_gateway_peering_attachment_input::Builder {
        crate::input::create_transit_gateway_peering_attachment_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayPrefixListReferenceInput`](crate::input::CreateTransitGatewayPrefixListReferenceInput)
pub mod create_transit_gateway_prefix_list_reference_input {
    /// A builder for [`CreateTransitGatewayPrefixListReferenceInput`](crate::input::CreateTransitGatewayPrefixListReferenceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) blackhole: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the prefix list that is used for destination matches.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// <p>The ID of the attachment to which traffic is routed.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Indicates whether to drop traffic that matches this route.</p>
        pub fn blackhole(mut self, input: bool) -> Self {
            self.blackhole = Some(input);
            self
        }
        pub fn set_blackhole(mut self, input: std::option::Option<bool>) -> Self {
            self.blackhole = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayPrefixListReferenceInput`](crate::input::CreateTransitGatewayPrefixListReferenceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayPrefixListReferenceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayPrefixListReferenceInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                prefix_list_id: self.prefix_list_id,
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                blackhole: self.blackhole,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayPrefixListReferenceInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayPrefixListReference;
#[doc(hidden)]
pub type CreateTransitGatewayPrefixListReferenceInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayPrefixListReferenceInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayPrefixListReference`](crate::operation::CreateTransitGatewayPrefixListReference)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayPrefixListReference,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_prefix_list_reference(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayPrefixListReference::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayPrefixListReference",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayPrefixListReferenceInput`](crate::input::CreateTransitGatewayPrefixListReferenceInput)
    pub fn builder() -> crate::input::create_transit_gateway_prefix_list_reference_input::Builder {
        crate::input::create_transit_gateway_prefix_list_reference_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayRouteInput`](crate::input::CreateTransitGatewayRouteInput)
pub mod create_transit_gateway_route_input {
    /// A builder for [`CreateTransitGatewayRouteInput`](crate::input::CreateTransitGatewayRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) blackhole: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The CIDR range used for destination matches. Routing decisions are based on the
        /// most specific match.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Indicates whether to drop traffic that matches this route.</p>
        pub fn blackhole(mut self, input: bool) -> Self {
            self.blackhole = Some(input);
            self
        }
        pub fn set_blackhole(mut self, input: std::option::Option<bool>) -> Self {
            self.blackhole = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayRouteInput`](crate::input::CreateTransitGatewayRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                blackhole: self.blackhole,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayRouteInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayRoute;
#[doc(hidden)]
pub type CreateTransitGatewayRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayRouteInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayRoute`](crate::operation::CreateTransitGatewayRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_route(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayRouteInput`](crate::input::CreateTransitGatewayRouteInput)
    pub fn builder() -> crate::input::create_transit_gateway_route_input::Builder {
        crate::input::create_transit_gateway_route_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayRouteTableInput`](crate::input::CreateTransitGatewayRouteTableInput)
pub mod create_transit_gateway_route_table_input {
    /// A builder for [`CreateTransitGatewayRouteTableInput`](crate::input::CreateTransitGatewayRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayRouteTableInput`](crate::input::CreateTransitGatewayRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayRouteTableInput {
                transit_gateway_id: self.transit_gateway_id,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayRouteTableInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayRouteTable;
#[doc(hidden)]
pub type CreateTransitGatewayRouteTableInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayRouteTable`](crate::operation::CreateTransitGatewayRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_route_table(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayRouteTableInput`](crate::input::CreateTransitGatewayRouteTableInput)
    pub fn builder() -> crate::input::create_transit_gateway_route_table_input::Builder {
        crate::input::create_transit_gateway_route_table_input::Builder::default()
    }
}

/// See [`CreateTransitGatewayVpcAttachmentInput`](crate::input::CreateTransitGatewayVpcAttachmentInput)
pub mod create_transit_gateway_vpc_attachment_input {
    /// A builder for [`CreateTransitGatewayVpcAttachmentInput`](crate::input::CreateTransitGatewayVpcAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) options:
            std::option::Option<crate::model::CreateTransitGatewayVpcAttachmentRequestOptions>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        pub fn subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.subnet_ids = Some(v);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.subnet_ids = input;
            self
        }
        /// <p>The VPC attachment options.</p>
        pub fn options(
            mut self,
            input: crate::model::CreateTransitGatewayVpcAttachmentRequestOptions,
        ) -> Self {
            self.options = Some(input);
            self
        }
        pub fn set_options(
            mut self,
            input: std::option::Option<
                crate::model::CreateTransitGatewayVpcAttachmentRequestOptions,
            >,
        ) -> Self {
            self.options = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateTransitGatewayVpcAttachmentInput`](crate::input::CreateTransitGatewayVpcAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateTransitGatewayVpcAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateTransitGatewayVpcAttachmentInput {
                transit_gateway_id: self.transit_gateway_id,
                vpc_id: self.vpc_id,
                subnet_ids: self.subnet_ids,
                options: self.options,
                tag_specifications: self.tag_specifications,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateTransitGatewayVpcAttachmentInputOperationOutputAlias =
    crate::operation::CreateTransitGatewayVpcAttachment;
#[doc(hidden)]
pub type CreateTransitGatewayVpcAttachmentInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateTransitGatewayVpcAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`CreateTransitGatewayVpcAttachment`](crate::operation::CreateTransitGatewayVpcAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateTransitGatewayVpcAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_transit_gateway_vpc_attachment(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateTransitGatewayVpcAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateTransitGatewayVpcAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateTransitGatewayVpcAttachmentInput`](crate::input::CreateTransitGatewayVpcAttachmentInput)
    pub fn builder() -> crate::input::create_transit_gateway_vpc_attachment_input::Builder {
        crate::input::create_transit_gateway_vpc_attachment_input::Builder::default()
    }
}

/// See [`CreateVolumeInput`](crate::input::CreateVolumeInput)
pub mod create_volume_input {
    /// A builder for [`CreateVolumeInput`](crate::input::CreateVolumeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) encrypted: std::option::Option<bool>,
        pub(crate) iops: std::option::Option<i32>,
        pub(crate) kms_key_id: std::option::Option<std::string::String>,
        pub(crate) outpost_arn: std::option::Option<std::string::String>,
        pub(crate) size: std::option::Option<i32>,
        pub(crate) snapshot_id: std::option::Option<std::string::String>,
        pub(crate) volume_type: std::option::Option<crate::model::VolumeType>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) multi_attach_enabled: std::option::Option<bool>,
        pub(crate) throughput: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The Availability Zone in which to create the volume.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>Indicates whether the volume should be encrypted.
        /// The effect of setting the encryption state to <code>true</code> depends on
        /// the volume origin (new or from a snapshot), starting encryption state, ownership, and whether encryption by default is enabled.
        /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-by-default">Encryption by default</a>
        /// in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        /// <p>Encrypted Amazon EBS volumes must be attached to instances that support Amazon EBS encryption.
        /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances">Supported
        /// instance types</a>.</p>
        pub fn encrypted(mut self, input: bool) -> Self {
            self.encrypted = Some(input);
            self
        }
        pub fn set_encrypted(mut self, input: std::option::Option<bool>) -> Self {
            self.encrypted = input;
            self
        }
        /// <p>The number of I/O operations per second (IOPS). For <code>gp3</code>, <code>io1</code>, and <code>io2</code> volumes, this represents
        /// the number of IOPS that are provisioned for the volume. For <code>gp2</code> volumes, this represents the baseline
        /// performance of the volume and the rate at which the volume accumulates I/O credits for bursting.</p>
        /// <p>The following are the supported values for each volume type:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>gp3</code>: 3,000-16,000 IOPS</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>io1</code>: 100-64,000 IOPS</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>io2</code>: 100-64,000 IOPS</p>
        /// </li>
        /// </ul>
        /// <p>For <code>io1</code> and <code>io2</code> volumes, we guarantee 64,000 IOPS only for  
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">Instances built on the Nitro System</a>. Other instance families guarantee performance
        /// up to 32,000 IOPS.</p>
        /// <p>This parameter is required for <code>io1</code> and <code>io2</code> volumes.
        /// The default for <code>gp3</code> volumes is 3,000 IOPS.
        /// This parameter is not supported for <code>gp2</code>, <code>st1</code>, <code>sc1</code>, or <code>standard</code> volumes.</p>
        pub fn iops(mut self, input: i32) -> Self {
            self.iops = Some(input);
            self
        }
        pub fn set_iops(mut self, input: std::option::Option<i32>) -> Self {
            self.iops = input;
            self
        }
        /// <p>The identifier of the AWS Key Management Service (AWS KMS) customer master key (CMK) to use for Amazon EBS encryption.
        /// If this parameter is not specified, your AWS managed CMK for EBS is used. If <code>KmsKeyId</code> is
        /// specified, the encrypted state must be <code>true</code>.</p>
        /// <p>You can specify the CMK using any of the following:</p>
        /// <ul>
        /// <li>
        /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Key alias. For example, alias/ExampleAlias.</p>
        /// </li>
        /// <li>
        /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
        /// </li>
        /// </ul>
        /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an ID, alias, or ARN that is not valid,
        /// the action can appear to complete, but eventually fails.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kms_key_id = Some(input.into());
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kms_key_id = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the Outpost.</p>
        pub fn outpost_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.outpost_arn = Some(input.into());
            self
        }
        pub fn set_outpost_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.outpost_arn = input;
            self
        }
        /// <p>The size of the volume, in GiBs. You must specify either a snapshot ID or a volume size.
        /// If you specify a snapshot, the default is the snapshot size. You can specify a volume
        /// size that is equal to or larger than the snapshot size.</p>
        /// <p>The following are the supported volumes sizes for each volume type:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>gp2</code> and <code>gp3</code>: 1-16,384</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>io1</code> and <code>io2</code>: 4-16,384</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>st1</code> and <code>sc1</code>: 125-16,384</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>standard</code>: 1-1,024</p>
        /// </li>
        /// </ul>
        pub fn size(mut self, input: i32) -> Self {
            self.size = Some(input);
            self
        }
        pub fn set_size(mut self, input: std::option::Option<i32>) -> Self {
            self.size = input;
            self
        }
        /// <p>The snapshot from which to create the volume. You must specify either a snapshot ID or a volume size.</p>
        pub fn snapshot_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.snapshot_id = Some(input.into());
            self
        }
        pub fn set_snapshot_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.snapshot_id = input;
            self
        }
        /// <p>The volume type. This parameter can be one of the following values:</p>
        /// <ul>
        /// <li>
        /// <p>General Purpose SSD: <code>gp2</code> | <code>gp3</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Provisioned IOPS SSD: <code>io1</code> | <code>io2</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Throughput Optimized HDD: <code>st1</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Cold HDD: <code>sc1</code>
        /// </p>
        /// </li>
        /// <li>
        /// <p>Magnetic: <code>standard</code>
        /// </p>
        /// </li>
        /// </ul>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html">Amazon EBS volume types</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        /// <p>Default: <code>gp2</code>
        /// </p>
        pub fn volume_type(mut self, input: crate::model::VolumeType) -> Self {
            self.volume_type = Some(input);
            self
        }
        pub fn set_volume_type(
            mut self,
            input: std::option::Option<crate::model::VolumeType>,
        ) -> Self {
            self.volume_type = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Indicates whether to enable Amazon EBS Multi-Attach. If you enable Multi-Attach, you can attach the
        /// volume to up to 16 <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">Instances built on the Nitro System</a> in the same Availability Zone. This parameter is
        /// supported with <code>io1</code> and <code>io2</code> volumes only. For more information,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-volumes-multi.html">
        /// Amazon EBS Multi-Attach</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn multi_attach_enabled(mut self, input: bool) -> Self {
            self.multi_attach_enabled = Some(input);
            self
        }
        pub fn set_multi_attach_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.multi_attach_enabled = input;
            self
        }
        /// <p>The throughput to provision for a volume, with a maximum of 1,000 MiB/s.</p>
        /// <p>This parameter is valid only for <code>gp3</code> volumes.</p>
        /// <p>Valid Range: Minimum value of 125. Maximum value of 1000.</p>
        pub fn throughput(mut self, input: i32) -> Self {
            self.throughput = Some(input);
            self
        }
        pub fn set_throughput(mut self, input: std::option::Option<i32>) -> Self {
            self.throughput = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVolumeInput`](crate::input::CreateVolumeInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateVolumeInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateVolumeInput {
                availability_zone: self.availability_zone,
                encrypted: self.encrypted,
                iops: self.iops,
                kms_key_id: self.kms_key_id,
                outpost_arn: self.outpost_arn,
                size: self.size,
                snapshot_id: self.snapshot_id,
                volume_type: self.volume_type,
                dry_run: self.dry_run,
                tag_specifications: self.tag_specifications,
                multi_attach_enabled: self.multi_attach_enabled,
                throughput: self.throughput,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVolumeInputOperationOutputAlias = crate::operation::CreateVolume;
#[doc(hidden)]
pub type CreateVolumeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateVolumeInput {
    /// Consumes the builder and constructs an Operation<[`CreateVolume`](crate::operation::CreateVolume)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVolume,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_volume(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVolume::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("CreateVolume", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVolumeInput`](crate::input::CreateVolumeInput)
    pub fn builder() -> crate::input::create_volume_input::Builder {
        crate::input::create_volume_input::Builder::default()
    }
}

/// See [`CreateVpcInput`](crate::input::CreateVpcInput)
pub mod create_vpc_input {
    /// A builder for [`CreateVpcInput`](crate::input::CreateVpcInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr_block: std::option::Option<std::string::String>,
        pub(crate) amazon_provided_ipv6_cidr_block: std::option::Option<bool>,
        pub(crate) ipv6_pool: std::option::Option<std::string::String>,
        pub(crate) ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_tenancy: std::option::Option<crate::model::Tenancy>,
        pub(crate) ipv6_cidr_block_network_border_group: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>The IPv4 network range for the VPC, in CIDR notation. For example,
        /// <code>10.0.0.0/16</code>. We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
        pub fn cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_block = Some(input.into());
            self
        }
        pub fn set_cidr_block(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_block = input;
            self
        }
        /// <p>Requests an Amazon-provided IPv6 CIDR block with a /56 prefix length for the VPC.
        /// You cannot specify the range of IP addresses, or the size of the CIDR block.</p>
        pub fn amazon_provided_ipv6_cidr_block(mut self, input: bool) -> Self {
            self.amazon_provided_ipv6_cidr_block = Some(input);
            self
        }
        pub fn set_amazon_provided_ipv6_cidr_block(
            mut self,
            input: std::option::Option<bool>,
        ) -> Self {
            self.amazon_provided_ipv6_cidr_block = input;
            self
        }
        /// <p>The ID of an IPv6 address pool from which to allocate the IPv6 CIDR block.</p>
        pub fn ipv6_pool(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_pool = Some(input.into());
            self
        }
        pub fn set_ipv6_pool(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ipv6_pool = input;
            self
        }
        /// <p>The IPv6 CIDR block from the IPv6 address pool. You must also specify <code>Ipv6Pool</code> in the request.</p>
        /// <p>To let Amazon choose the IPv6 CIDR block for you, omit this parameter.</p>
        pub fn ipv6_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The tenancy options for instances launched into the VPC. For <code>default</code>, instances
        /// are launched with shared tenancy by default. You can launch instances with any tenancy into a
        /// shared tenancy VPC. For <code>dedicated</code>, instances are launched as dedicated tenancy
        /// instances by default. You can only launch instances with a tenancy of <code>dedicated</code>
        /// or <code>host</code> into a dedicated tenancy VPC. </p>
        /// <p>
        /// <b>Important:</b> The <code>host</code> value cannot be used with this parameter. Use the <code>default</code> or <code>dedicated</code> values only.</p>
        /// <p>Default: <code>default</code>
        /// </p>
        pub fn instance_tenancy(mut self, input: crate::model::Tenancy) -> Self {
            self.instance_tenancy = Some(input);
            self
        }
        pub fn set_instance_tenancy(
            mut self,
            input: std::option::Option<crate::model::Tenancy>,
        ) -> Self {
            self.instance_tenancy = input;
            self
        }
        /// <p>The name of the location from which we advertise the IPV6 CIDR block. Use this parameter to limit the address to this location.</p>
        /// <p> You must set <code>AmazonProvidedIpv6CidrBlock</code> to <code>true</code> to use this parameter.</p>
        pub fn ipv6_cidr_block_network_border_group(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block_network_border_group = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block_network_border_group(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block_network_border_group = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpcInput`](crate::input::CreateVpcInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::CreateVpcInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::CreateVpcInput {
                cidr_block: self.cidr_block,
                amazon_provided_ipv6_cidr_block: self.amazon_provided_ipv6_cidr_block,
                ipv6_pool: self.ipv6_pool,
                ipv6_cidr_block: self.ipv6_cidr_block,
                dry_run: self.dry_run,
                instance_tenancy: self.instance_tenancy,
                ipv6_cidr_block_network_border_group: self.ipv6_cidr_block_network_border_group,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpcInputOperationOutputAlias = crate::operation::CreateVpc;
#[doc(hidden)]
pub type CreateVpcInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateVpcInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpc`](crate::operation::CreateVpc)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpc,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_vpc(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op =
                smithy_http::operation::Operation::new(request, crate::operation::CreateVpc::new())
                    .with_metadata(smithy_http::operation::Metadata::new("CreateVpc", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpcInput`](crate::input::CreateVpcInput)
    pub fn builder() -> crate::input::create_vpc_input::Builder {
        crate::input::create_vpc_input::Builder::default()
    }
}

/// See [`CreateVpcEndpointInput`](crate::input::CreateVpcEndpointInput)
pub mod create_vpc_endpoint_input {
    /// A builder for [`CreateVpcEndpointInput`](crate::input::CreateVpcEndpointInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_endpoint_type: std::option::Option<crate::model::VpcEndpointType>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) service_name: std::option::Option<std::string::String>,
        pub(crate) policy_document: std::option::Option<std::string::String>,
        pub(crate) route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) private_dns_enabled: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The type of endpoint.</p>
        /// <p>Default: Gateway</p>
        pub fn vpc_endpoint_type(mut self, input: crate::model::VpcEndpointType) -> Self {
            self.vpc_endpoint_type = Some(input);
            self
        }
        pub fn set_vpc_endpoint_type(
            mut self,
            input: std::option::Option<crate::model::VpcEndpointType>,
        ) -> Self {
            self.vpc_endpoint_type = input;
            self
        }
        /// <p>The ID of the VPC in which the endpoint will be used.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>The service name. To get a list of available services, use the <a>DescribeVpcEndpointServices</a> request, or get the name from the service
        /// provider.</p>
        pub fn service_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_name = Some(input.into());
            self
        }
        pub fn set_service_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_name = input;
            self
        }
        /// <p>(Interface and gateway endpoints) A policy to attach to the endpoint that controls access to the
        /// service. The policy must be in valid JSON format. If this parameter is not specified, we
        /// attach a default policy that allows full access to the service.</p>
        pub fn policy_document(mut self, input: impl Into<std::string::String>) -> Self {
            self.policy_document = Some(input.into());
            self
        }
        pub fn set_policy_document(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.policy_document = input;
            self
        }
        pub fn route_table_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.route_table_ids.unwrap_or_default();
            v.push(input.into());
            self.route_table_ids = Some(v);
            self
        }
        pub fn set_route_table_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.route_table_ids = input;
            self
        }
        pub fn subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.subnet_ids = Some(v);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.subnet_ids = input;
            self
        }
        pub fn security_group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.security_group_ids.unwrap_or_default();
            v.push(input.into());
            self.security_group_ids = Some(v);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.security_group_ids = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>(Interface endpoint) Indicates whether to associate a private hosted zone with the
        /// specified VPC. The private hosted zone contains a record set for the default public DNS
        /// name for the service for the Region (for example,
        /// <code>kinesis.us-east-1.amazonaws.com</code>), which resolves to the private IP
        /// addresses of the endpoint network interfaces in the VPC. This enables you to make
        /// requests to the default public DNS name for the service instead of the public DNS names
        /// that are automatically generated by the VPC endpoint service.</p>
        /// <p>To use a private hosted zone, you must set the following VPC attributes to
        /// <code>true</code>: <code>enableDnsHostnames</code> and
        /// <code>enableDnsSupport</code>. Use <a>ModifyVpcAttribute</a> to set the VPC
        /// attributes.</p>
        /// <p>Default: <code>true</code>
        /// </p>
        pub fn private_dns_enabled(mut self, input: bool) -> Self {
            self.private_dns_enabled = Some(input);
            self
        }
        pub fn set_private_dns_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.private_dns_enabled = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpcEndpointInput`](crate::input::CreateVpcEndpointInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateVpcEndpointInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateVpcEndpointInput {
                dry_run: self.dry_run,
                vpc_endpoint_type: self.vpc_endpoint_type,
                vpc_id: self.vpc_id,
                service_name: self.service_name,
                policy_document: self.policy_document,
                route_table_ids: self.route_table_ids,
                subnet_ids: self.subnet_ids,
                security_group_ids: self.security_group_ids,
                client_token: self.client_token,
                private_dns_enabled: self.private_dns_enabled,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpcEndpointInputOperationOutputAlias = crate::operation::CreateVpcEndpoint;
#[doc(hidden)]
pub type CreateVpcEndpointInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateVpcEndpointInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpcEndpoint`](crate::operation::CreateVpcEndpoint)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpcEndpoint,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_vpc_endpoint(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVpcEndpoint::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateVpcEndpoint",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpcEndpointInput`](crate::input::CreateVpcEndpointInput)
    pub fn builder() -> crate::input::create_vpc_endpoint_input::Builder {
        crate::input::create_vpc_endpoint_input::Builder::default()
    }
}

/// See [`CreateVpcEndpointConnectionNotificationInput`](crate::input::CreateVpcEndpointConnectionNotificationInput)
pub mod create_vpc_endpoint_connection_notification_input {
    /// A builder for [`CreateVpcEndpointConnectionNotificationInput`](crate::input::CreateVpcEndpointConnectionNotificationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_id: std::option::Option<std::string::String>,
        pub(crate) vpc_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) connection_notification_arn: std::option::Option<std::string::String>,
        pub(crate) connection_events: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the endpoint service.</p>
        pub fn service_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_id = Some(input.into());
            self
        }
        pub fn set_service_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_id = input;
            self
        }
        /// <p>The ID of the endpoint.</p>
        pub fn vpc_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_endpoint_id = Some(input.into());
            self
        }
        pub fn set_vpc_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_endpoint_id = input;
            self
        }
        /// <p>The ARN of the SNS topic for the notifications.</p>
        pub fn connection_notification_arn(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.connection_notification_arn = Some(input.into());
            self
        }
        pub fn set_connection_notification_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.connection_notification_arn = input;
            self
        }
        pub fn connection_events(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.connection_events.unwrap_or_default();
            v.push(input.into());
            self.connection_events = Some(v);
            self
        }
        pub fn set_connection_events(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.connection_events = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpcEndpointConnectionNotificationInput`](crate::input::CreateVpcEndpointConnectionNotificationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateVpcEndpointConnectionNotificationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateVpcEndpointConnectionNotificationInput {
                dry_run: self.dry_run,
                service_id: self.service_id,
                vpc_endpoint_id: self.vpc_endpoint_id,
                connection_notification_arn: self.connection_notification_arn,
                connection_events: self.connection_events,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpcEndpointConnectionNotificationInputOperationOutputAlias =
    crate::operation::CreateVpcEndpointConnectionNotification;
#[doc(hidden)]
pub type CreateVpcEndpointConnectionNotificationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl CreateVpcEndpointConnectionNotificationInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpcEndpointConnectionNotification`](crate::operation::CreateVpcEndpointConnectionNotification)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpcEndpointConnectionNotification,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_vpc_endpoint_connection_notification(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVpcEndpointConnectionNotification::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateVpcEndpointConnectionNotification",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpcEndpointConnectionNotificationInput`](crate::input::CreateVpcEndpointConnectionNotificationInput)
    pub fn builder() -> crate::input::create_vpc_endpoint_connection_notification_input::Builder {
        crate::input::create_vpc_endpoint_connection_notification_input::Builder::default()
    }
}

/// See [`CreateVpcEndpointServiceConfigurationInput`](crate::input::CreateVpcEndpointServiceConfigurationInput)
pub mod create_vpc_endpoint_service_configuration_input {
    /// A builder for [`CreateVpcEndpointServiceConfigurationInput`](crate::input::CreateVpcEndpointServiceConfigurationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) acceptance_required: std::option::Option<bool>,
        pub(crate) private_dns_name: std::option::Option<std::string::String>,
        pub(crate) network_load_balancer_arns:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) gateway_load_balancer_arns:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Indicates whether requests from service consumers to create an endpoint to your service must
        /// be accepted. To accept a request, use <a>AcceptVpcEndpointConnections</a>.</p>
        pub fn acceptance_required(mut self, input: bool) -> Self {
            self.acceptance_required = Some(input);
            self
        }
        pub fn set_acceptance_required(mut self, input: std::option::Option<bool>) -> Self {
            self.acceptance_required = input;
            self
        }
        /// <p>(Interface endpoint configuration) The private DNS name to assign to the VPC endpoint service.</p>
        pub fn private_dns_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.private_dns_name = Some(input.into());
            self
        }
        pub fn set_private_dns_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.private_dns_name = input;
            self
        }
        pub fn network_load_balancer_arns(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_load_balancer_arns.unwrap_or_default();
            v.push(input.into());
            self.network_load_balancer_arns = Some(v);
            self
        }
        pub fn set_network_load_balancer_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_load_balancer_arns = input;
            self
        }
        pub fn gateway_load_balancer_arns(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.gateway_load_balancer_arns.unwrap_or_default();
            v.push(input.into());
            self.gateway_load_balancer_arns = Some(v);
            self
        }
        pub fn set_gateway_load_balancer_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.gateway_load_balancer_arns = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
        /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpcEndpointServiceConfigurationInput`](crate::input::CreateVpcEndpointServiceConfigurationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateVpcEndpointServiceConfigurationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateVpcEndpointServiceConfigurationInput {
                dry_run: self.dry_run,
                acceptance_required: self.acceptance_required,
                private_dns_name: self.private_dns_name,
                network_load_balancer_arns: self.network_load_balancer_arns,
                gateway_load_balancer_arns: self.gateway_load_balancer_arns,
                client_token: self.client_token,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpcEndpointServiceConfigurationInputOperationOutputAlias =
    crate::operation::CreateVpcEndpointServiceConfiguration;
#[doc(hidden)]
pub type CreateVpcEndpointServiceConfigurationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl CreateVpcEndpointServiceConfigurationInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpcEndpointServiceConfiguration`](crate::operation::CreateVpcEndpointServiceConfiguration)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpcEndpointServiceConfiguration,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_vpc_endpoint_service_configuration(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVpcEndpointServiceConfiguration::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateVpcEndpointServiceConfiguration",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpcEndpointServiceConfigurationInput`](crate::input::CreateVpcEndpointServiceConfigurationInput)
    pub fn builder() -> crate::input::create_vpc_endpoint_service_configuration_input::Builder {
        crate::input::create_vpc_endpoint_service_configuration_input::Builder::default()
    }
}

/// See [`CreateVpcPeeringConnectionInput`](crate::input::CreateVpcPeeringConnectionInput)
pub mod create_vpc_peering_connection_input {
    /// A builder for [`CreateVpcPeeringConnectionInput`](crate::input::CreateVpcPeeringConnectionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) peer_owner_id: std::option::Option<std::string::String>,
        pub(crate) peer_vpc_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) peer_region: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The AWS account ID of the owner of the accepter VPC.</p>
        /// <p>Default: Your AWS account ID</p>
        pub fn peer_owner_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.peer_owner_id = Some(input.into());
            self
        }
        pub fn set_peer_owner_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.peer_owner_id = input;
            self
        }
        /// <p>The ID of the VPC with which you are creating the VPC peering connection. You must
        /// specify this parameter in the request.</p>
        pub fn peer_vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.peer_vpc_id = Some(input.into());
            self
        }
        pub fn set_peer_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.peer_vpc_id = input;
            self
        }
        /// <p>The ID of the requester VPC. You must specify this parameter in the
        /// request.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>The Region code for the accepter VPC, if the accepter VPC is located in a Region
        /// other than the Region in which you make the request.</p>
        /// <p>Default: The Region in which you make the request.</p>
        pub fn peer_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.peer_region = Some(input.into());
            self
        }
        pub fn set_peer_region(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.peer_region = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpcPeeringConnectionInput`](crate::input::CreateVpcPeeringConnectionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateVpcPeeringConnectionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateVpcPeeringConnectionInput {
                dry_run: self.dry_run,
                peer_owner_id: self.peer_owner_id,
                peer_vpc_id: self.peer_vpc_id,
                vpc_id: self.vpc_id,
                peer_region: self.peer_region,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpcPeeringConnectionInputOperationOutputAlias =
    crate::operation::CreateVpcPeeringConnection;
#[doc(hidden)]
pub type CreateVpcPeeringConnectionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateVpcPeeringConnectionInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpcPeeringConnection`](crate::operation::CreateVpcPeeringConnection)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpcPeeringConnection,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_create_vpc_peering_connection(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVpcPeeringConnection::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateVpcPeeringConnection",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpcPeeringConnectionInput`](crate::input::CreateVpcPeeringConnectionInput)
    pub fn builder() -> crate::input::create_vpc_peering_connection_input::Builder {
        crate::input::create_vpc_peering_connection_input::Builder::default()
    }
}

/// See [`CreateVpnConnectionInput`](crate::input::CreateVpnConnectionInput)
pub mod create_vpn_connection_input {
    /// A builder for [`CreateVpnConnectionInput`](crate::input::CreateVpnConnectionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) customer_gateway_id: std::option::Option<std::string::String>,
        pub(crate) r#type: std::option::Option<std::string::String>,
        pub(crate) vpn_gateway_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) options: std::option::Option<crate::model::VpnConnectionOptionsSpecification>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>The ID of the customer gateway.</p>
        pub fn customer_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.customer_gateway_id = Some(input.into());
            self
        }
        pub fn set_customer_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.customer_gateway_id = input;
            self
        }
        /// <p>The type of VPN connection (<code>ipsec.1</code>).</p>
        pub fn r#type(mut self, input: impl Into<std::string::String>) -> Self {
            self.r#type = Some(input.into());
            self
        }
        pub fn set_type(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.r#type = input;
            self
        }
        /// <p>The ID of the virtual private gateway. If you specify a virtual private gateway, you cannot specify a transit gateway.</p>
        pub fn vpn_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_gateway_id = Some(input.into());
            self
        }
        pub fn set_vpn_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_gateway_id = input;
            self
        }
        /// <p>The ID of the transit gateway. If you specify a transit gateway, you cannot specify a virtual private gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The options for the VPN connection.</p>
        pub fn options(mut self, input: crate::model::VpnConnectionOptionsSpecification) -> Self {
            self.options = Some(input);
            self
        }
        pub fn set_options(
            mut self,
            input: std::option::Option<crate::model::VpnConnectionOptionsSpecification>,
        ) -> Self {
            self.options = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpnConnectionInput`](crate::input::CreateVpnConnectionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateVpnConnectionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateVpnConnectionInput {
                customer_gateway_id: self.customer_gateway_id,
                r#type: self.r#type,
                vpn_gateway_id: self.vpn_gateway_id,
                transit_gateway_id: self.transit_gateway_id,
                dry_run: self.dry_run,
                options: self.options,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpnConnectionInputOperationOutputAlias = crate::operation::CreateVpnConnection;
#[doc(hidden)]
pub type CreateVpnConnectionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateVpnConnectionInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpnConnection`](crate::operation::CreateVpnConnection)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpnConnection,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_vpn_connection(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVpnConnection::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateVpnConnection",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpnConnectionInput`](crate::input::CreateVpnConnectionInput)
    pub fn builder() -> crate::input::create_vpn_connection_input::Builder {
        crate::input::create_vpn_connection_input::Builder::default()
    }
}

/// See [`CreateVpnConnectionRouteInput`](crate::input::CreateVpnConnectionRouteInput)
pub mod create_vpn_connection_route_input {
    /// A builder for [`CreateVpnConnectionRouteInput`](crate::input::CreateVpnConnectionRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) vpn_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The CIDR block associated with the local subnet of the customer network.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The ID of the VPN connection.</p>
        pub fn vpn_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_connection_id = Some(input.into());
            self
        }
        pub fn set_vpn_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpnConnectionRouteInput`](crate::input::CreateVpnConnectionRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateVpnConnectionRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateVpnConnectionRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                vpn_connection_id: self.vpn_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpnConnectionRouteInputOperationOutputAlias =
    crate::operation::CreateVpnConnectionRoute;
#[doc(hidden)]
pub type CreateVpnConnectionRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateVpnConnectionRouteInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpnConnectionRoute`](crate::operation::CreateVpnConnectionRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpnConnectionRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_vpn_connection_route(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVpnConnectionRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateVpnConnectionRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpnConnectionRouteInput`](crate::input::CreateVpnConnectionRouteInput)
    pub fn builder() -> crate::input::create_vpn_connection_route_input::Builder {
        crate::input::create_vpn_connection_route_input::Builder::default()
    }
}

/// See [`CreateVpnGatewayInput`](crate::input::CreateVpnGatewayInput)
pub mod create_vpn_gateway_input {
    /// A builder for [`CreateVpnGatewayInput`](crate::input::CreateVpnGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) r#type: std::option::Option<crate::model::GatewayType>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) amazon_side_asn: std::option::Option<i64>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The Availability Zone for the virtual private gateway.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>The type of VPN connection this virtual private gateway supports.</p>
        pub fn r#type(mut self, input: crate::model::GatewayType) -> Self {
            self.r#type = Some(input);
            self
        }
        pub fn set_type(mut self, input: std::option::Option<crate::model::GatewayType>) -> Self {
            self.r#type = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>A private Autonomous System Number (ASN) for the Amazon side of a BGP session. If you're using a 16-bit ASN, it must be in the 64512 to 65534 range. If you're using a 32-bit ASN, it must be in the 4200000000 to 4294967294 range.</p>
        /// <p>Default: 64512</p>
        pub fn amazon_side_asn(mut self, input: i64) -> Self {
            self.amazon_side_asn = Some(input);
            self
        }
        pub fn set_amazon_side_asn(mut self, input: std::option::Option<i64>) -> Self {
            self.amazon_side_asn = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`CreateVpnGatewayInput`](crate::input::CreateVpnGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::CreateVpnGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::CreateVpnGatewayInput {
                availability_zone: self.availability_zone,
                r#type: self.r#type,
                tag_specifications: self.tag_specifications,
                amazon_side_asn: self.amazon_side_asn,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type CreateVpnGatewayInputOperationOutputAlias = crate::operation::CreateVpnGateway;
#[doc(hidden)]
pub type CreateVpnGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl CreateVpnGatewayInput {
    /// Consumes the builder and constructs an Operation<[`CreateVpnGateway`](crate::operation::CreateVpnGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::CreateVpnGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_create_vpn_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::CreateVpnGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "CreateVpnGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`CreateVpnGatewayInput`](crate::input::CreateVpnGatewayInput)
    pub fn builder() -> crate::input::create_vpn_gateway_input::Builder {
        crate::input::create_vpn_gateway_input::Builder::default()
    }
}

/// See [`DeleteCarrierGatewayInput`](crate::input::DeleteCarrierGatewayInput)
pub mod delete_carrier_gateway_input {
    /// A builder for [`DeleteCarrierGatewayInput`](crate::input::DeleteCarrierGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) carrier_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the carrier gateway.</p>
        pub fn carrier_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.carrier_gateway_id = Some(input.into());
            self
        }
        pub fn set_carrier_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.carrier_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteCarrierGatewayInput`](crate::input::DeleteCarrierGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteCarrierGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteCarrierGatewayInput {
                carrier_gateway_id: self.carrier_gateway_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteCarrierGatewayInputOperationOutputAlias = crate::operation::DeleteCarrierGateway;
#[doc(hidden)]
pub type DeleteCarrierGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteCarrierGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DeleteCarrierGateway`](crate::operation::DeleteCarrierGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteCarrierGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_carrier_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteCarrierGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteCarrierGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteCarrierGatewayInput`](crate::input::DeleteCarrierGatewayInput)
    pub fn builder() -> crate::input::delete_carrier_gateway_input::Builder {
        crate::input::delete_carrier_gateway_input::Builder::default()
    }
}

/// See [`DeleteClientVpnEndpointInput`](crate::input::DeleteClientVpnEndpointInput)
pub mod delete_client_vpn_endpoint_input {
    /// A builder for [`DeleteClientVpnEndpointInput`](crate::input::DeleteClientVpnEndpointInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN to be deleted.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteClientVpnEndpointInput`](crate::input::DeleteClientVpnEndpointInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteClientVpnEndpointInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteClientVpnEndpointInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteClientVpnEndpointInputOperationOutputAlias =
    crate::operation::DeleteClientVpnEndpoint;
#[doc(hidden)]
pub type DeleteClientVpnEndpointInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteClientVpnEndpointInput {
    /// Consumes the builder and constructs an Operation<[`DeleteClientVpnEndpoint`](crate::operation::DeleteClientVpnEndpoint)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteClientVpnEndpoint,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_client_vpn_endpoint(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteClientVpnEndpoint::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteClientVpnEndpoint",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteClientVpnEndpointInput`](crate::input::DeleteClientVpnEndpointInput)
    pub fn builder() -> crate::input::delete_client_vpn_endpoint_input::Builder {
        crate::input::delete_client_vpn_endpoint_input::Builder::default()
    }
}

/// See [`DeleteClientVpnRouteInput`](crate::input::DeleteClientVpnRouteInput)
pub mod delete_client_vpn_route_input {
    /// A builder for [`DeleteClientVpnRouteInput`](crate::input::DeleteClientVpnRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) target_vpc_subnet_id: std::option::Option<std::string::String>,
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint from which the route is to be deleted.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The ID of the target subnet used by the route.</p>
        pub fn target_vpc_subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.target_vpc_subnet_id = Some(input.into());
            self
        }
        pub fn set_target_vpc_subnet_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.target_vpc_subnet_id = input;
            self
        }
        /// <p>The IPv4 address range, in CIDR notation, of the route to be deleted.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteClientVpnRouteInput`](crate::input::DeleteClientVpnRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteClientVpnRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteClientVpnRouteInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                target_vpc_subnet_id: self.target_vpc_subnet_id,
                destination_cidr_block: self.destination_cidr_block,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteClientVpnRouteInputOperationOutputAlias = crate::operation::DeleteClientVpnRoute;
#[doc(hidden)]
pub type DeleteClientVpnRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteClientVpnRouteInput {
    /// Consumes the builder and constructs an Operation<[`DeleteClientVpnRoute`](crate::operation::DeleteClientVpnRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteClientVpnRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_client_vpn_route(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteClientVpnRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteClientVpnRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteClientVpnRouteInput`](crate::input::DeleteClientVpnRouteInput)
    pub fn builder() -> crate::input::delete_client_vpn_route_input::Builder {
        crate::input::delete_client_vpn_route_input::Builder::default()
    }
}

/// See [`DeleteCustomerGatewayInput`](crate::input::DeleteCustomerGatewayInput)
pub mod delete_customer_gateway_input {
    /// A builder for [`DeleteCustomerGatewayInput`](crate::input::DeleteCustomerGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) customer_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the customer gateway.</p>
        pub fn customer_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.customer_gateway_id = Some(input.into());
            self
        }
        pub fn set_customer_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.customer_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteCustomerGatewayInput`](crate::input::DeleteCustomerGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteCustomerGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteCustomerGatewayInput {
                customer_gateway_id: self.customer_gateway_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteCustomerGatewayInputOperationOutputAlias = crate::operation::DeleteCustomerGateway;
#[doc(hidden)]
pub type DeleteCustomerGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteCustomerGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DeleteCustomerGateway`](crate::operation::DeleteCustomerGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteCustomerGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_customer_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteCustomerGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteCustomerGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteCustomerGatewayInput`](crate::input::DeleteCustomerGatewayInput)
    pub fn builder() -> crate::input::delete_customer_gateway_input::Builder {
        crate::input::delete_customer_gateway_input::Builder::default()
    }
}

/// See [`DeleteDhcpOptionsInput`](crate::input::DeleteDhcpOptionsInput)
pub mod delete_dhcp_options_input {
    /// A builder for [`DeleteDhcpOptionsInput`](crate::input::DeleteDhcpOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dhcp_options_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the DHCP options set.</p>
        pub fn dhcp_options_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.dhcp_options_id = Some(input.into());
            self
        }
        pub fn set_dhcp_options_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.dhcp_options_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteDhcpOptionsInput`](crate::input::DeleteDhcpOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteDhcpOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteDhcpOptionsInput {
                dhcp_options_id: self.dhcp_options_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteDhcpOptionsInputOperationOutputAlias = crate::operation::DeleteDhcpOptions;
#[doc(hidden)]
pub type DeleteDhcpOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteDhcpOptionsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteDhcpOptions`](crate::operation::DeleteDhcpOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteDhcpOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_dhcp_options(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteDhcpOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteDhcpOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteDhcpOptionsInput`](crate::input::DeleteDhcpOptionsInput)
    pub fn builder() -> crate::input::delete_dhcp_options_input::Builder {
        crate::input::delete_dhcp_options_input::Builder::default()
    }
}

/// See [`DeleteEgressOnlyInternetGatewayInput`](crate::input::DeleteEgressOnlyInternetGatewayInput)
pub mod delete_egress_only_internet_gateway_input {
    /// A builder for [`DeleteEgressOnlyInternetGatewayInput`](crate::input::DeleteEgressOnlyInternetGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) egress_only_internet_gateway_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the egress-only internet gateway.</p>
        pub fn egress_only_internet_gateway_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.egress_only_internet_gateway_id = Some(input.into());
            self
        }
        pub fn set_egress_only_internet_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.egress_only_internet_gateway_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteEgressOnlyInternetGatewayInput`](crate::input::DeleteEgressOnlyInternetGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteEgressOnlyInternetGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteEgressOnlyInternetGatewayInput {
                dry_run: self.dry_run,
                egress_only_internet_gateway_id: self.egress_only_internet_gateway_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteEgressOnlyInternetGatewayInputOperationOutputAlias =
    crate::operation::DeleteEgressOnlyInternetGateway;
#[doc(hidden)]
pub type DeleteEgressOnlyInternetGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteEgressOnlyInternetGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DeleteEgressOnlyInternetGateway`](crate::operation::DeleteEgressOnlyInternetGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteEgressOnlyInternetGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_egress_only_internet_gateway(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteEgressOnlyInternetGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteEgressOnlyInternetGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteEgressOnlyInternetGatewayInput`](crate::input::DeleteEgressOnlyInternetGatewayInput)
    pub fn builder() -> crate::input::delete_egress_only_internet_gateway_input::Builder {
        crate::input::delete_egress_only_internet_gateway_input::Builder::default()
    }
}

/// See [`DeleteFleetsInput`](crate::input::DeleteFleetsInput)
pub mod delete_fleets_input {
    /// A builder for [`DeleteFleetsInput`](crate::input::DeleteFleetsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) fleet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) terminate_instances: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn fleet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.fleet_ids.unwrap_or_default();
            v.push(input.into());
            self.fleet_ids = Some(v);
            self
        }
        pub fn set_fleet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.fleet_ids = input;
            self
        }
        /// <p>Indicates whether to terminate the instances when the EC2 Fleet is deleted. The default is to
        /// terminate the instances.</p>
        /// <p>To let the instances continue to run after the EC2 Fleet is deleted, specify
        /// <code>NoTerminateInstances</code>. Supported only for fleets of type
        /// <code>maintain</code> and <code>request</code>.</p>
        /// <p>For <code>instant</code> fleets, you cannot specify <code>NoTerminateInstances</code>. A
        /// deleted <code>instant</code> fleet with running instances is not supported.</p>
        pub fn terminate_instances(mut self, input: bool) -> Self {
            self.terminate_instances = Some(input);
            self
        }
        pub fn set_terminate_instances(mut self, input: std::option::Option<bool>) -> Self {
            self.terminate_instances = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteFleetsInput`](crate::input::DeleteFleetsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DeleteFleetsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DeleteFleetsInput {
                dry_run: self.dry_run,
                fleet_ids: self.fleet_ids,
                terminate_instances: self.terminate_instances,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteFleetsInputOperationOutputAlias = crate::operation::DeleteFleets;
#[doc(hidden)]
pub type DeleteFleetsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteFleetsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteFleets`](crate::operation::DeleteFleets)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteFleets,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_fleets(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteFleets::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DeleteFleets", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteFleetsInput`](crate::input::DeleteFleetsInput)
    pub fn builder() -> crate::input::delete_fleets_input::Builder {
        crate::input::delete_fleets_input::Builder::default()
    }
}

/// See [`DeleteFlowLogsInput`](crate::input::DeleteFlowLogsInput)
pub mod delete_flow_logs_input {
    /// A builder for [`DeleteFlowLogsInput`](crate::input::DeleteFlowLogsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) flow_log_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn flow_log_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.flow_log_ids.unwrap_or_default();
            v.push(input.into());
            self.flow_log_ids = Some(v);
            self
        }
        pub fn set_flow_log_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.flow_log_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteFlowLogsInput`](crate::input::DeleteFlowLogsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteFlowLogsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteFlowLogsInput {
                dry_run: self.dry_run,
                flow_log_ids: self.flow_log_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteFlowLogsInputOperationOutputAlias = crate::operation::DeleteFlowLogs;
#[doc(hidden)]
pub type DeleteFlowLogsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteFlowLogsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteFlowLogs`](crate::operation::DeleteFlowLogs)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteFlowLogs,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_flow_logs(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteFlowLogs::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteFlowLogs",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteFlowLogsInput`](crate::input::DeleteFlowLogsInput)
    pub fn builder() -> crate::input::delete_flow_logs_input::Builder {
        crate::input::delete_flow_logs_input::Builder::default()
    }
}

/// See [`DeleteFpgaImageInput`](crate::input::DeleteFpgaImageInput)
pub mod delete_fpga_image_input {
    /// A builder for [`DeleteFpgaImageInput`](crate::input::DeleteFpgaImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) fpga_image_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the AFI.</p>
        pub fn fpga_image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.fpga_image_id = Some(input.into());
            self
        }
        pub fn set_fpga_image_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.fpga_image_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteFpgaImageInput`](crate::input::DeleteFpgaImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteFpgaImageInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteFpgaImageInput {
                dry_run: self.dry_run,
                fpga_image_id: self.fpga_image_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteFpgaImageInputOperationOutputAlias = crate::operation::DeleteFpgaImage;
#[doc(hidden)]
pub type DeleteFpgaImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteFpgaImageInput {
    /// Consumes the builder and constructs an Operation<[`DeleteFpgaImage`](crate::operation::DeleteFpgaImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteFpgaImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_fpga_image(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteFpgaImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteFpgaImage",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteFpgaImageInput`](crate::input::DeleteFpgaImageInput)
    pub fn builder() -> crate::input::delete_fpga_image_input::Builder {
        crate::input::delete_fpga_image_input::Builder::default()
    }
}

/// See [`DeleteInternetGatewayInput`](crate::input::DeleteInternetGatewayInput)
pub mod delete_internet_gateway_input {
    /// A builder for [`DeleteInternetGatewayInput`](crate::input::DeleteInternetGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) internet_gateway_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the internet gateway.</p>
        pub fn internet_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.internet_gateway_id = Some(input.into());
            self
        }
        pub fn set_internet_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.internet_gateway_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteInternetGatewayInput`](crate::input::DeleteInternetGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteInternetGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteInternetGatewayInput {
                dry_run: self.dry_run,
                internet_gateway_id: self.internet_gateway_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteInternetGatewayInputOperationOutputAlias = crate::operation::DeleteInternetGateway;
#[doc(hidden)]
pub type DeleteInternetGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteInternetGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DeleteInternetGateway`](crate::operation::DeleteInternetGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteInternetGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_internet_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteInternetGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteInternetGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteInternetGatewayInput`](crate::input::DeleteInternetGatewayInput)
    pub fn builder() -> crate::input::delete_internet_gateway_input::Builder {
        crate::input::delete_internet_gateway_input::Builder::default()
    }
}

/// See [`DeleteKeyPairInput`](crate::input::DeleteKeyPairInput)
pub mod delete_key_pair_input {
    /// A builder for [`DeleteKeyPairInput`](crate::input::DeleteKeyPairInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) key_name: std::option::Option<std::string::String>,
        pub(crate) key_pair_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The name of the key pair.</p>
        pub fn key_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.key_name = Some(input.into());
            self
        }
        pub fn set_key_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.key_name = input;
            self
        }
        /// <p>The ID of the key pair.</p>
        pub fn key_pair_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.key_pair_id = Some(input.into());
            self
        }
        pub fn set_key_pair_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.key_pair_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteKeyPairInput`](crate::input::DeleteKeyPairInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DeleteKeyPairInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DeleteKeyPairInput {
                key_name: self.key_name,
                key_pair_id: self.key_pair_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteKeyPairInputOperationOutputAlias = crate::operation::DeleteKeyPair;
#[doc(hidden)]
pub type DeleteKeyPairInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteKeyPairInput {
    /// Consumes the builder and constructs an Operation<[`DeleteKeyPair`](crate::operation::DeleteKeyPair)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteKeyPair,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_key_pair(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteKeyPair::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteKeyPair",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteKeyPairInput`](crate::input::DeleteKeyPairInput)
    pub fn builder() -> crate::input::delete_key_pair_input::Builder {
        crate::input::delete_key_pair_input::Builder::default()
    }
}

/// See [`DeleteLaunchTemplateInput`](crate::input::DeleteLaunchTemplateInput)
pub mod delete_launch_template_input {
    /// A builder for [`DeleteLaunchTemplateInput`](crate::input::DeleteLaunchTemplateInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) launch_template_id: std::option::Option<std::string::String>,
        pub(crate) launch_template_name: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_id = Some(input.into());
            self
        }
        pub fn set_launch_template_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_id = input;
            self
        }
        /// <p>The name of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_name = Some(input.into());
            self
        }
        pub fn set_launch_template_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_name = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteLaunchTemplateInput`](crate::input::DeleteLaunchTemplateInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteLaunchTemplateInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteLaunchTemplateInput {
                dry_run: self.dry_run,
                launch_template_id: self.launch_template_id,
                launch_template_name: self.launch_template_name,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteLaunchTemplateInputOperationOutputAlias = crate::operation::DeleteLaunchTemplate;
#[doc(hidden)]
pub type DeleteLaunchTemplateInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteLaunchTemplateInput {
    /// Consumes the builder and constructs an Operation<[`DeleteLaunchTemplate`](crate::operation::DeleteLaunchTemplate)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteLaunchTemplate,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_launch_template(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteLaunchTemplate::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteLaunchTemplate",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteLaunchTemplateInput`](crate::input::DeleteLaunchTemplateInput)
    pub fn builder() -> crate::input::delete_launch_template_input::Builder {
        crate::input::delete_launch_template_input::Builder::default()
    }
}

/// See [`DeleteLaunchTemplateVersionsInput`](crate::input::DeleteLaunchTemplateVersionsInput)
pub mod delete_launch_template_versions_input {
    /// A builder for [`DeleteLaunchTemplateVersionsInput`](crate::input::DeleteLaunchTemplateVersionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) launch_template_id: std::option::Option<std::string::String>,
        pub(crate) launch_template_name: std::option::Option<std::string::String>,
        pub(crate) versions: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_id = Some(input.into());
            self
        }
        pub fn set_launch_template_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_id = input;
            self
        }
        /// <p>The name of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_name = Some(input.into());
            self
        }
        pub fn set_launch_template_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_name = input;
            self
        }
        pub fn versions(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.versions.unwrap_or_default();
            v.push(input.into());
            self.versions = Some(v);
            self
        }
        pub fn set_versions(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.versions = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteLaunchTemplateVersionsInput`](crate::input::DeleteLaunchTemplateVersionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteLaunchTemplateVersionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteLaunchTemplateVersionsInput {
                dry_run: self.dry_run,
                launch_template_id: self.launch_template_id,
                launch_template_name: self.launch_template_name,
                versions: self.versions,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteLaunchTemplateVersionsInputOperationOutputAlias =
    crate::operation::DeleteLaunchTemplateVersions;
#[doc(hidden)]
pub type DeleteLaunchTemplateVersionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteLaunchTemplateVersionsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteLaunchTemplateVersions`](crate::operation::DeleteLaunchTemplateVersions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteLaunchTemplateVersions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_launch_template_versions(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteLaunchTemplateVersions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteLaunchTemplateVersions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteLaunchTemplateVersionsInput`](crate::input::DeleteLaunchTemplateVersionsInput)
    pub fn builder() -> crate::input::delete_launch_template_versions_input::Builder {
        crate::input::delete_launch_template_versions_input::Builder::default()
    }
}

/// See [`DeleteLocalGatewayRouteInput`](crate::input::DeleteLocalGatewayRouteInput)
pub mod delete_local_gateway_route_input {
    /// A builder for [`DeleteLocalGatewayRouteInput`](crate::input::DeleteLocalGatewayRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) local_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The CIDR range for the route. This must match the CIDR for the route exactly.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The ID of the local gateway route table.</p>
        pub fn local_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteLocalGatewayRouteInput`](crate::input::DeleteLocalGatewayRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteLocalGatewayRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteLocalGatewayRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                local_gateway_route_table_id: self.local_gateway_route_table_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteLocalGatewayRouteInputOperationOutputAlias =
    crate::operation::DeleteLocalGatewayRoute;
#[doc(hidden)]
pub type DeleteLocalGatewayRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteLocalGatewayRouteInput {
    /// Consumes the builder and constructs an Operation<[`DeleteLocalGatewayRoute`](crate::operation::DeleteLocalGatewayRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteLocalGatewayRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_local_gateway_route(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteLocalGatewayRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteLocalGatewayRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteLocalGatewayRouteInput`](crate::input::DeleteLocalGatewayRouteInput)
    pub fn builder() -> crate::input::delete_local_gateway_route_input::Builder {
        crate::input::delete_local_gateway_route_input::Builder::default()
    }
}

/// See [`DeleteLocalGatewayRouteTableVpcAssociationInput`](crate::input::DeleteLocalGatewayRouteTableVpcAssociationInput)
pub mod delete_local_gateway_route_table_vpc_association_input {
    /// A builder for [`DeleteLocalGatewayRouteTableVpcAssociationInput`](crate::input::DeleteLocalGatewayRouteTableVpcAssociationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_route_table_vpc_association_id:
            std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the association.</p>
        pub fn local_gateway_route_table_vpc_association_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_vpc_association_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_route_table_vpc_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_vpc_association_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteLocalGatewayRouteTableVpcAssociationInput`](crate::input::DeleteLocalGatewayRouteTableVpcAssociationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteLocalGatewayRouteTableVpcAssociationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DeleteLocalGatewayRouteTableVpcAssociationInput {
                    local_gateway_route_table_vpc_association_id: self
                        .local_gateway_route_table_vpc_association_id,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DeleteLocalGatewayRouteTableVpcAssociationInputOperationOutputAlias =
    crate::operation::DeleteLocalGatewayRouteTableVpcAssociation;
#[doc(hidden)]
pub type DeleteLocalGatewayRouteTableVpcAssociationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeleteLocalGatewayRouteTableVpcAssociationInput {
    /// Consumes the builder and constructs an Operation<[`DeleteLocalGatewayRouteTableVpcAssociation`](crate::operation::DeleteLocalGatewayRouteTableVpcAssociation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteLocalGatewayRouteTableVpcAssociation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_local_gateway_route_table_vpc_association(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteLocalGatewayRouteTableVpcAssociation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteLocalGatewayRouteTableVpcAssociation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteLocalGatewayRouteTableVpcAssociationInput`](crate::input::DeleteLocalGatewayRouteTableVpcAssociationInput)
    pub fn builder() -> crate::input::delete_local_gateway_route_table_vpc_association_input::Builder
    {
        crate::input::delete_local_gateway_route_table_vpc_association_input::Builder::default()
    }
}

/// See [`DeleteManagedPrefixListInput`](crate::input::DeleteManagedPrefixListInput)
pub mod delete_managed_prefix_list_input {
    /// A builder for [`DeleteManagedPrefixListInput`](crate::input::DeleteManagedPrefixListInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the prefix list.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteManagedPrefixListInput`](crate::input::DeleteManagedPrefixListInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteManagedPrefixListInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteManagedPrefixListInput {
                dry_run: self.dry_run,
                prefix_list_id: self.prefix_list_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteManagedPrefixListInputOperationOutputAlias =
    crate::operation::DeleteManagedPrefixList;
#[doc(hidden)]
pub type DeleteManagedPrefixListInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteManagedPrefixListInput {
    /// Consumes the builder and constructs an Operation<[`DeleteManagedPrefixList`](crate::operation::DeleteManagedPrefixList)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteManagedPrefixList,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_managed_prefix_list(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteManagedPrefixList::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteManagedPrefixList",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteManagedPrefixListInput`](crate::input::DeleteManagedPrefixListInput)
    pub fn builder() -> crate::input::delete_managed_prefix_list_input::Builder {
        crate::input::delete_managed_prefix_list_input::Builder::default()
    }
}

/// See [`DeleteNatGatewayInput`](crate::input::DeleteNatGatewayInput)
pub mod delete_nat_gateway_input {
    /// A builder for [`DeleteNatGatewayInput`](crate::input::DeleteNatGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) nat_gateway_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the NAT gateway.</p>
        pub fn nat_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.nat_gateway_id = Some(input.into());
            self
        }
        pub fn set_nat_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.nat_gateway_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteNatGatewayInput`](crate::input::DeleteNatGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteNatGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteNatGatewayInput {
                dry_run: self.dry_run,
                nat_gateway_id: self.nat_gateway_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteNatGatewayInputOperationOutputAlias = crate::operation::DeleteNatGateway;
#[doc(hidden)]
pub type DeleteNatGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteNatGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DeleteNatGateway`](crate::operation::DeleteNatGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteNatGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_nat_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteNatGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteNatGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteNatGatewayInput`](crate::input::DeleteNatGatewayInput)
    pub fn builder() -> crate::input::delete_nat_gateway_input::Builder {
        crate::input::delete_nat_gateway_input::Builder::default()
    }
}

/// See [`DeleteNetworkAclInput`](crate::input::DeleteNetworkAclInput)
pub mod delete_network_acl_input {
    /// A builder for [`DeleteNetworkAclInput`](crate::input::DeleteNetworkAclInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_acl_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the network ACL.</p>
        pub fn network_acl_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_acl_id = Some(input.into());
            self
        }
        pub fn set_network_acl_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_acl_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteNetworkAclInput`](crate::input::DeleteNetworkAclInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteNetworkAclInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteNetworkAclInput {
                dry_run: self.dry_run,
                network_acl_id: self.network_acl_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteNetworkAclInputOperationOutputAlias = crate::operation::DeleteNetworkAcl;
#[doc(hidden)]
pub type DeleteNetworkAclInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteNetworkAclInput {
    /// Consumes the builder and constructs an Operation<[`DeleteNetworkAcl`](crate::operation::DeleteNetworkAcl)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteNetworkAcl,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_network_acl(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteNetworkAcl::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteNetworkAcl",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteNetworkAclInput`](crate::input::DeleteNetworkAclInput)
    pub fn builder() -> crate::input::delete_network_acl_input::Builder {
        crate::input::delete_network_acl_input::Builder::default()
    }
}

/// See [`DeleteNetworkAclEntryInput`](crate::input::DeleteNetworkAclEntryInput)
pub mod delete_network_acl_entry_input {
    /// A builder for [`DeleteNetworkAclEntryInput`](crate::input::DeleteNetworkAclEntryInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) egress: std::option::Option<bool>,
        pub(crate) network_acl_id: std::option::Option<std::string::String>,
        pub(crate) rule_number: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Indicates whether the rule is an egress rule.</p>
        pub fn egress(mut self, input: bool) -> Self {
            self.egress = Some(input);
            self
        }
        pub fn set_egress(mut self, input: std::option::Option<bool>) -> Self {
            self.egress = input;
            self
        }
        /// <p>The ID of the network ACL.</p>
        pub fn network_acl_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_acl_id = Some(input.into());
            self
        }
        pub fn set_network_acl_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_acl_id = input;
            self
        }
        /// <p>The rule number of the entry to delete.</p>
        pub fn rule_number(mut self, input: i32) -> Self {
            self.rule_number = Some(input);
            self
        }
        pub fn set_rule_number(mut self, input: std::option::Option<i32>) -> Self {
            self.rule_number = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteNetworkAclEntryInput`](crate::input::DeleteNetworkAclEntryInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteNetworkAclEntryInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteNetworkAclEntryInput {
                dry_run: self.dry_run,
                egress: self.egress,
                network_acl_id: self.network_acl_id,
                rule_number: self.rule_number,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteNetworkAclEntryInputOperationOutputAlias = crate::operation::DeleteNetworkAclEntry;
#[doc(hidden)]
pub type DeleteNetworkAclEntryInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteNetworkAclEntryInput {
    /// Consumes the builder and constructs an Operation<[`DeleteNetworkAclEntry`](crate::operation::DeleteNetworkAclEntry)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteNetworkAclEntry,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_network_acl_entry(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteNetworkAclEntry::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteNetworkAclEntry",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteNetworkAclEntryInput`](crate::input::DeleteNetworkAclEntryInput)
    pub fn builder() -> crate::input::delete_network_acl_entry_input::Builder {
        crate::input::delete_network_acl_entry_input::Builder::default()
    }
}

/// See [`DeleteNetworkInsightsAnalysisInput`](crate::input::DeleteNetworkInsightsAnalysisInput)
pub mod delete_network_insights_analysis_input {
    /// A builder for [`DeleteNetworkInsightsAnalysisInput`](crate::input::DeleteNetworkInsightsAnalysisInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_insights_analysis_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the network insights analysis.</p>
        pub fn network_insights_analysis_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.network_insights_analysis_id = Some(input.into());
            self
        }
        pub fn set_network_insights_analysis_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_insights_analysis_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteNetworkInsightsAnalysisInput`](crate::input::DeleteNetworkInsightsAnalysisInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteNetworkInsightsAnalysisInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteNetworkInsightsAnalysisInput {
                dry_run: self.dry_run,
                network_insights_analysis_id: self.network_insights_analysis_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteNetworkInsightsAnalysisInputOperationOutputAlias =
    crate::operation::DeleteNetworkInsightsAnalysis;
#[doc(hidden)]
pub type DeleteNetworkInsightsAnalysisInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteNetworkInsightsAnalysisInput {
    /// Consumes the builder and constructs an Operation<[`DeleteNetworkInsightsAnalysis`](crate::operation::DeleteNetworkInsightsAnalysis)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteNetworkInsightsAnalysis,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_network_insights_analysis(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteNetworkInsightsAnalysis::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteNetworkInsightsAnalysis",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteNetworkInsightsAnalysisInput`](crate::input::DeleteNetworkInsightsAnalysisInput)
    pub fn builder() -> crate::input::delete_network_insights_analysis_input::Builder {
        crate::input::delete_network_insights_analysis_input::Builder::default()
    }
}

/// See [`DeleteNetworkInsightsPathInput`](crate::input::DeleteNetworkInsightsPathInput)
pub mod delete_network_insights_path_input {
    /// A builder for [`DeleteNetworkInsightsPathInput`](crate::input::DeleteNetworkInsightsPathInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_insights_path_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the path.</p>
        pub fn network_insights_path_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_insights_path_id = Some(input.into());
            self
        }
        pub fn set_network_insights_path_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_insights_path_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteNetworkInsightsPathInput`](crate::input::DeleteNetworkInsightsPathInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteNetworkInsightsPathInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteNetworkInsightsPathInput {
                dry_run: self.dry_run,
                network_insights_path_id: self.network_insights_path_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteNetworkInsightsPathInputOperationOutputAlias =
    crate::operation::DeleteNetworkInsightsPath;
#[doc(hidden)]
pub type DeleteNetworkInsightsPathInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteNetworkInsightsPathInput {
    /// Consumes the builder and constructs an Operation<[`DeleteNetworkInsightsPath`](crate::operation::DeleteNetworkInsightsPath)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteNetworkInsightsPath,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_network_insights_path(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteNetworkInsightsPath::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteNetworkInsightsPath",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteNetworkInsightsPathInput`](crate::input::DeleteNetworkInsightsPathInput)
    pub fn builder() -> crate::input::delete_network_insights_path_input::Builder {
        crate::input::delete_network_insights_path_input::Builder::default()
    }
}

/// See [`DeleteNetworkInterfaceInput`](crate::input::DeleteNetworkInterfaceInput)
pub mod delete_network_interface_input {
    /// A builder for [`DeleteNetworkInterfaceInput`](crate::input::DeleteNetworkInterfaceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteNetworkInterfaceInput`](crate::input::DeleteNetworkInterfaceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteNetworkInterfaceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteNetworkInterfaceInput {
                dry_run: self.dry_run,
                network_interface_id: self.network_interface_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteNetworkInterfaceInputOperationOutputAlias = crate::operation::DeleteNetworkInterface;
#[doc(hidden)]
pub type DeleteNetworkInterfaceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteNetworkInterfaceInput {
    /// Consumes the builder and constructs an Operation<[`DeleteNetworkInterface`](crate::operation::DeleteNetworkInterface)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteNetworkInterface,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_network_interface(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteNetworkInterface::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteNetworkInterface",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteNetworkInterfaceInput`](crate::input::DeleteNetworkInterfaceInput)
    pub fn builder() -> crate::input::delete_network_interface_input::Builder {
        crate::input::delete_network_interface_input::Builder::default()
    }
}

/// See [`DeleteNetworkInterfacePermissionInput`](crate::input::DeleteNetworkInterfacePermissionInput)
pub mod delete_network_interface_permission_input {
    /// A builder for [`DeleteNetworkInterfacePermissionInput`](crate::input::DeleteNetworkInterfacePermissionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_interface_permission_id: std::option::Option<std::string::String>,
        pub(crate) force: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the network interface permission.</p>
        pub fn network_interface_permission_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.network_interface_permission_id = Some(input.into());
            self
        }
        pub fn set_network_interface_permission_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_permission_id = input;
            self
        }
        /// <p>Specify <code>true</code> to remove the permission even if the network interface is
        /// attached to an instance.</p>
        pub fn force(mut self, input: bool) -> Self {
            self.force = Some(input);
            self
        }
        pub fn set_force(mut self, input: std::option::Option<bool>) -> Self {
            self.force = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteNetworkInterfacePermissionInput`](crate::input::DeleteNetworkInterfacePermissionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteNetworkInterfacePermissionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteNetworkInterfacePermissionInput {
                network_interface_permission_id: self.network_interface_permission_id,
                force: self.force,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteNetworkInterfacePermissionInputOperationOutputAlias =
    crate::operation::DeleteNetworkInterfacePermission;
#[doc(hidden)]
pub type DeleteNetworkInterfacePermissionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteNetworkInterfacePermissionInput {
    /// Consumes the builder and constructs an Operation<[`DeleteNetworkInterfacePermission`](crate::operation::DeleteNetworkInterfacePermission)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteNetworkInterfacePermission,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_network_interface_permission(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteNetworkInterfacePermission::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteNetworkInterfacePermission",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteNetworkInterfacePermissionInput`](crate::input::DeleteNetworkInterfacePermissionInput)
    pub fn builder() -> crate::input::delete_network_interface_permission_input::Builder {
        crate::input::delete_network_interface_permission_input::Builder::default()
    }
}

/// See [`DeletePlacementGroupInput`](crate::input::DeletePlacementGroupInput)
pub mod delete_placement_group_input {
    /// A builder for [`DeletePlacementGroupInput`](crate::input::DeletePlacementGroupInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_name: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The name of the placement group.</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        /// Consumes the builder and constructs a [`DeletePlacementGroupInput`](crate::input::DeletePlacementGroupInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeletePlacementGroupInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeletePlacementGroupInput {
                dry_run: self.dry_run,
                group_name: self.group_name,
            })
        }
    }
}
#[doc(hidden)]
pub type DeletePlacementGroupInputOperationOutputAlias = crate::operation::DeletePlacementGroup;
#[doc(hidden)]
pub type DeletePlacementGroupInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeletePlacementGroupInput {
    /// Consumes the builder and constructs an Operation<[`DeletePlacementGroup`](crate::operation::DeletePlacementGroup)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeletePlacementGroup,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_placement_group(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeletePlacementGroup::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeletePlacementGroup",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeletePlacementGroupInput`](crate::input::DeletePlacementGroupInput)
    pub fn builder() -> crate::input::delete_placement_group_input::Builder {
        crate::input::delete_placement_group_input::Builder::default()
    }
}

/// See [`DeleteQueuedReservedInstancesInput`](crate::input::DeleteQueuedReservedInstancesInput)
pub mod delete_queued_reserved_instances_input {
    /// A builder for [`DeleteQueuedReservedInstancesInput`](crate::input::DeleteQueuedReservedInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) reserved_instances_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn reserved_instances_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.reserved_instances_ids.unwrap_or_default();
            v.push(input.into());
            self.reserved_instances_ids = Some(v);
            self
        }
        pub fn set_reserved_instances_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.reserved_instances_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteQueuedReservedInstancesInput`](crate::input::DeleteQueuedReservedInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteQueuedReservedInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteQueuedReservedInstancesInput {
                dry_run: self.dry_run,
                reserved_instances_ids: self.reserved_instances_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteQueuedReservedInstancesInputOperationOutputAlias =
    crate::operation::DeleteQueuedReservedInstances;
#[doc(hidden)]
pub type DeleteQueuedReservedInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteQueuedReservedInstancesInput {
    /// Consumes the builder and constructs an Operation<[`DeleteQueuedReservedInstances`](crate::operation::DeleteQueuedReservedInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteQueuedReservedInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_queued_reserved_instances(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteQueuedReservedInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteQueuedReservedInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteQueuedReservedInstancesInput`](crate::input::DeleteQueuedReservedInstancesInput)
    pub fn builder() -> crate::input::delete_queued_reserved_instances_input::Builder {
        crate::input::delete_queued_reserved_instances_input::Builder::default()
    }
}

/// See [`DeleteRouteInput`](crate::input::DeleteRouteInput)
pub mod delete_route_input {
    /// A builder for [`DeleteRouteInput`](crate::input::DeleteRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) destination_ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) destination_prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The IPv4 CIDR range for the route. The value you specify must match the CIDR for the route exactly.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The IPv6 CIDR range for the route. The value you specify must match the CIDR for the route exactly.</p>
        pub fn destination_ipv6_cidr_block(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.destination_ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_ipv6_cidr_block = input;
            self
        }
        /// <p>The ID of the prefix list for the route.</p>
        pub fn destination_prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_prefix_list_id = Some(input.into());
            self
        }
        pub fn set_destination_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_prefix_list_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the route table.</p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteRouteInput`](crate::input::DeleteRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DeleteRouteInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DeleteRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                destination_ipv6_cidr_block: self.destination_ipv6_cidr_block,
                destination_prefix_list_id: self.destination_prefix_list_id,
                dry_run: self.dry_run,
                route_table_id: self.route_table_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteRouteInputOperationOutputAlias = crate::operation::DeleteRoute;
#[doc(hidden)]
pub type DeleteRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteRouteInput {
    /// Consumes the builder and constructs an Operation<[`DeleteRoute`](crate::operation::DeleteRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_route(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DeleteRoute", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteRouteInput`](crate::input::DeleteRouteInput)
    pub fn builder() -> crate::input::delete_route_input::Builder {
        crate::input::delete_route_input::Builder::default()
    }
}

/// See [`DeleteRouteTableInput`](crate::input::DeleteRouteTableInput)
pub mod delete_route_table_input {
    /// A builder for [`DeleteRouteTableInput`](crate::input::DeleteRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the route table.</p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteRouteTableInput`](crate::input::DeleteRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteRouteTableInput {
                dry_run: self.dry_run,
                route_table_id: self.route_table_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteRouteTableInputOperationOutputAlias = crate::operation::DeleteRouteTable;
#[doc(hidden)]
pub type DeleteRouteTableInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`DeleteRouteTable`](crate::operation::DeleteRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_route_table(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteRouteTableInput`](crate::input::DeleteRouteTableInput)
    pub fn builder() -> crate::input::delete_route_table_input::Builder {
        crate::input::delete_route_table_input::Builder::default()
    }
}

/// See [`DeleteSecurityGroupInput`](crate::input::DeleteSecurityGroupInput)
pub mod delete_security_group_input {
    /// A builder for [`DeleteSecurityGroupInput`](crate::input::DeleteSecurityGroupInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) group_id: std::option::Option<std::string::String>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the security group. Required for a nondefault VPC.</p>
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_id = Some(input.into());
            self
        }
        pub fn set_group_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_id = input;
            self
        }
        /// <p>[EC2-Classic, default VPC] The name of the security group. You can specify either the security group name or the security group ID.</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteSecurityGroupInput`](crate::input::DeleteSecurityGroupInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteSecurityGroupInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteSecurityGroupInput {
                group_id: self.group_id,
                group_name: self.group_name,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteSecurityGroupInputOperationOutputAlias = crate::operation::DeleteSecurityGroup;
#[doc(hidden)]
pub type DeleteSecurityGroupInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteSecurityGroupInput {
    /// Consumes the builder and constructs an Operation<[`DeleteSecurityGroup`](crate::operation::DeleteSecurityGroup)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteSecurityGroup,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_security_group(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteSecurityGroup::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteSecurityGroup",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteSecurityGroupInput`](crate::input::DeleteSecurityGroupInput)
    pub fn builder() -> crate::input::delete_security_group_input::Builder {
        crate::input::delete_security_group_input::Builder::default()
    }
}

/// See [`DeleteSnapshotInput`](crate::input::DeleteSnapshotInput)
pub mod delete_snapshot_input {
    /// A builder for [`DeleteSnapshotInput`](crate::input::DeleteSnapshotInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) snapshot_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the EBS snapshot.</p>
        pub fn snapshot_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.snapshot_id = Some(input.into());
            self
        }
        pub fn set_snapshot_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.snapshot_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteSnapshotInput`](crate::input::DeleteSnapshotInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteSnapshotInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteSnapshotInput {
                snapshot_id: self.snapshot_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteSnapshotInputOperationOutputAlias = crate::operation::DeleteSnapshot;
#[doc(hidden)]
pub type DeleteSnapshotInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteSnapshotInput {
    /// Consumes the builder and constructs an Operation<[`DeleteSnapshot`](crate::operation::DeleteSnapshot)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteSnapshot,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_snapshot(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteSnapshot::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteSnapshot",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteSnapshotInput`](crate::input::DeleteSnapshotInput)
    pub fn builder() -> crate::input::delete_snapshot_input::Builder {
        crate::input::delete_snapshot_input::Builder::default()
    }
}

/// See [`DeleteSpotDatafeedSubscriptionInput`](crate::input::DeleteSpotDatafeedSubscriptionInput)
pub mod delete_spot_datafeed_subscription_input {
    /// A builder for [`DeleteSpotDatafeedSubscriptionInput`](crate::input::DeleteSpotDatafeedSubscriptionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteSpotDatafeedSubscriptionInput`](crate::input::DeleteSpotDatafeedSubscriptionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteSpotDatafeedSubscriptionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteSpotDatafeedSubscriptionInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteSpotDatafeedSubscriptionInputOperationOutputAlias =
    crate::operation::DeleteSpotDatafeedSubscription;
#[doc(hidden)]
pub type DeleteSpotDatafeedSubscriptionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteSpotDatafeedSubscriptionInput {
    /// Consumes the builder and constructs an Operation<[`DeleteSpotDatafeedSubscription`](crate::operation::DeleteSpotDatafeedSubscription)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteSpotDatafeedSubscription,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_spot_datafeed_subscription(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteSpotDatafeedSubscription::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteSpotDatafeedSubscription",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteSpotDatafeedSubscriptionInput`](crate::input::DeleteSpotDatafeedSubscriptionInput)
    pub fn builder() -> crate::input::delete_spot_datafeed_subscription_input::Builder {
        crate::input::delete_spot_datafeed_subscription_input::Builder::default()
    }
}

/// See [`DeleteSubnetInput`](crate::input::DeleteSubnetInput)
pub mod delete_subnet_input {
    /// A builder for [`DeleteSubnetInput`](crate::input::DeleteSubnetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) subnet_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the subnet.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteSubnetInput`](crate::input::DeleteSubnetInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DeleteSubnetInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DeleteSubnetInput {
                subnet_id: self.subnet_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteSubnetInputOperationOutputAlias = crate::operation::DeleteSubnet;
#[doc(hidden)]
pub type DeleteSubnetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteSubnetInput {
    /// Consumes the builder and constructs an Operation<[`DeleteSubnet`](crate::operation::DeleteSubnet)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteSubnet,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_subnet(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteSubnet::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DeleteSubnet", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteSubnetInput`](crate::input::DeleteSubnetInput)
    pub fn builder() -> crate::input::delete_subnet_input::Builder {
        crate::input::delete_subnet_input::Builder::default()
    }
}

/// See [`DeleteTagsInput`](crate::input::DeleteTagsInput)
pub mod delete_tags_input {
    /// A builder for [`DeleteTagsInput`](crate::input::DeleteTagsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) resources: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) tags: std::option::Option<std::vec::Vec<crate::model::Tag>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn resources(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.resources.unwrap_or_default();
            v.push(input.into());
            self.resources = Some(v);
            self
        }
        pub fn set_resources(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.resources = input;
            self
        }
        pub fn tags(mut self, input: impl Into<crate::model::Tag>) -> Self {
            let mut v = self.tags.unwrap_or_default();
            v.push(input.into());
            self.tags = Some(v);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.tags = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTagsInput`](crate::input::DeleteTagsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DeleteTagsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DeleteTagsInput {
                dry_run: self.dry_run,
                resources: self.resources,
                tags: self.tags,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTagsInputOperationOutputAlias = crate::operation::DeleteTags;
#[doc(hidden)]
pub type DeleteTagsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTagsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTags`](crate::operation::DeleteTags)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTags,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_tags(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTags::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DeleteTags", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTagsInput`](crate::input::DeleteTagsInput)
    pub fn builder() -> crate::input::delete_tags_input::Builder {
        crate::input::delete_tags_input::Builder::default()
    }
}

/// See [`DeleteTrafficMirrorFilterInput`](crate::input::DeleteTrafficMirrorFilterInput)
pub mod delete_traffic_mirror_filter_input {
    /// A builder for [`DeleteTrafficMirrorFilterInput`](crate::input::DeleteTrafficMirrorFilterInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_filter_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Traffic Mirror filter.</p>
        pub fn traffic_mirror_filter_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_filter_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_filter_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTrafficMirrorFilterInput`](crate::input::DeleteTrafficMirrorFilterInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTrafficMirrorFilterInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTrafficMirrorFilterInput {
                traffic_mirror_filter_id: self.traffic_mirror_filter_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTrafficMirrorFilterInputOperationOutputAlias =
    crate::operation::DeleteTrafficMirrorFilter;
#[doc(hidden)]
pub type DeleteTrafficMirrorFilterInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTrafficMirrorFilterInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTrafficMirrorFilter`](crate::operation::DeleteTrafficMirrorFilter)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTrafficMirrorFilter,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_traffic_mirror_filter(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTrafficMirrorFilter::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTrafficMirrorFilter",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTrafficMirrorFilterInput`](crate::input::DeleteTrafficMirrorFilterInput)
    pub fn builder() -> crate::input::delete_traffic_mirror_filter_input::Builder {
        crate::input::delete_traffic_mirror_filter_input::Builder::default()
    }
}

/// See [`DeleteTrafficMirrorFilterRuleInput`](crate::input::DeleteTrafficMirrorFilterRuleInput)
pub mod delete_traffic_mirror_filter_rule_input {
    /// A builder for [`DeleteTrafficMirrorFilterRuleInput`](crate::input::DeleteTrafficMirrorFilterRuleInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_filter_rule_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Traffic Mirror rule.</p>
        pub fn traffic_mirror_filter_rule_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_rule_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_filter_rule_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_rule_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTrafficMirrorFilterRuleInput`](crate::input::DeleteTrafficMirrorFilterRuleInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTrafficMirrorFilterRuleInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTrafficMirrorFilterRuleInput {
                traffic_mirror_filter_rule_id: self.traffic_mirror_filter_rule_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTrafficMirrorFilterRuleInputOperationOutputAlias =
    crate::operation::DeleteTrafficMirrorFilterRule;
#[doc(hidden)]
pub type DeleteTrafficMirrorFilterRuleInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTrafficMirrorFilterRuleInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTrafficMirrorFilterRule`](crate::operation::DeleteTrafficMirrorFilterRule)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTrafficMirrorFilterRule,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_traffic_mirror_filter_rule(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTrafficMirrorFilterRule::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTrafficMirrorFilterRule",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTrafficMirrorFilterRuleInput`](crate::input::DeleteTrafficMirrorFilterRuleInput)
    pub fn builder() -> crate::input::delete_traffic_mirror_filter_rule_input::Builder {
        crate::input::delete_traffic_mirror_filter_rule_input::Builder::default()
    }
}

/// See [`DeleteTrafficMirrorSessionInput`](crate::input::DeleteTrafficMirrorSessionInput)
pub mod delete_traffic_mirror_session_input {
    /// A builder for [`DeleteTrafficMirrorSessionInput`](crate::input::DeleteTrafficMirrorSessionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_session_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Traffic Mirror session.</p>
        pub fn traffic_mirror_session_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_session_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_session_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_session_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTrafficMirrorSessionInput`](crate::input::DeleteTrafficMirrorSessionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTrafficMirrorSessionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTrafficMirrorSessionInput {
                traffic_mirror_session_id: self.traffic_mirror_session_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTrafficMirrorSessionInputOperationOutputAlias =
    crate::operation::DeleteTrafficMirrorSession;
#[doc(hidden)]
pub type DeleteTrafficMirrorSessionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTrafficMirrorSessionInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTrafficMirrorSession`](crate::operation::DeleteTrafficMirrorSession)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTrafficMirrorSession,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_traffic_mirror_session(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTrafficMirrorSession::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTrafficMirrorSession",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTrafficMirrorSessionInput`](crate::input::DeleteTrafficMirrorSessionInput)
    pub fn builder() -> crate::input::delete_traffic_mirror_session_input::Builder {
        crate::input::delete_traffic_mirror_session_input::Builder::default()
    }
}

/// See [`DeleteTrafficMirrorTargetInput`](crate::input::DeleteTrafficMirrorTargetInput)
pub mod delete_traffic_mirror_target_input {
    /// A builder for [`DeleteTrafficMirrorTargetInput`](crate::input::DeleteTrafficMirrorTargetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_target_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Traffic Mirror target.</p>
        pub fn traffic_mirror_target_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_target_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_target_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_target_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTrafficMirrorTargetInput`](crate::input::DeleteTrafficMirrorTargetInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTrafficMirrorTargetInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTrafficMirrorTargetInput {
                traffic_mirror_target_id: self.traffic_mirror_target_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTrafficMirrorTargetInputOperationOutputAlias =
    crate::operation::DeleteTrafficMirrorTarget;
#[doc(hidden)]
pub type DeleteTrafficMirrorTargetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTrafficMirrorTargetInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTrafficMirrorTarget`](crate::operation::DeleteTrafficMirrorTarget)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTrafficMirrorTarget,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_traffic_mirror_target(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTrafficMirrorTarget::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTrafficMirrorTarget",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTrafficMirrorTargetInput`](crate::input::DeleteTrafficMirrorTargetInput)
    pub fn builder() -> crate::input::delete_traffic_mirror_target_input::Builder {
        crate::input::delete_traffic_mirror_target_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayInput`](crate::input::DeleteTransitGatewayInput)
pub mod delete_transit_gateway_input {
    /// A builder for [`DeleteTransitGatewayInput`](crate::input::DeleteTransitGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayInput`](crate::input::DeleteTransitGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayInput {
                transit_gateway_id: self.transit_gateway_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayInputOperationOutputAlias = crate::operation::DeleteTransitGateway;
#[doc(hidden)]
pub type DeleteTransitGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGateway`](crate::operation::DeleteTransitGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_transit_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayInput`](crate::input::DeleteTransitGatewayInput)
    pub fn builder() -> crate::input::delete_transit_gateway_input::Builder {
        crate::input::delete_transit_gateway_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayConnectInput`](crate::input::DeleteTransitGatewayConnectInput)
pub mod delete_transit_gateway_connect_input {
    /// A builder for [`DeleteTransitGatewayConnectInput`](crate::input::DeleteTransitGatewayConnectInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Connect attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayConnectInput`](crate::input::DeleteTransitGatewayConnectInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayConnectInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayConnectInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayConnectInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayConnect;
#[doc(hidden)]
pub type DeleteTransitGatewayConnectInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayConnectInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayConnect`](crate::operation::DeleteTransitGatewayConnect)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayConnect,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_connect(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayConnect::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayConnect",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayConnectInput`](crate::input::DeleteTransitGatewayConnectInput)
    pub fn builder() -> crate::input::delete_transit_gateway_connect_input::Builder {
        crate::input::delete_transit_gateway_connect_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayConnectPeerInput`](crate::input::DeleteTransitGatewayConnectPeerInput)
pub mod delete_transit_gateway_connect_peer_input {
    /// A builder for [`DeleteTransitGatewayConnectPeerInput`](crate::input::DeleteTransitGatewayConnectPeerInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_connect_peer_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Connect peer.</p>
        pub fn transit_gateway_connect_peer_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_connect_peer_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_connect_peer_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_connect_peer_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayConnectPeerInput`](crate::input::DeleteTransitGatewayConnectPeerInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayConnectPeerInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayConnectPeerInput {
                transit_gateway_connect_peer_id: self.transit_gateway_connect_peer_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayConnectPeerInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayConnectPeer;
#[doc(hidden)]
pub type DeleteTransitGatewayConnectPeerInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayConnectPeerInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayConnectPeer`](crate::operation::DeleteTransitGatewayConnectPeer)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayConnectPeer,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_connect_peer(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayConnectPeer::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayConnectPeer",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayConnectPeerInput`](crate::input::DeleteTransitGatewayConnectPeerInput)
    pub fn builder() -> crate::input::delete_transit_gateway_connect_peer_input::Builder {
        crate::input::delete_transit_gateway_connect_peer_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayMulticastDomainInput`](crate::input::DeleteTransitGatewayMulticastDomainInput)
pub mod delete_transit_gateway_multicast_domain_input {
    /// A builder for [`DeleteTransitGatewayMulticastDomainInput`](crate::input::DeleteTransitGatewayMulticastDomainInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayMulticastDomainInput`](crate::input::DeleteTransitGatewayMulticastDomainInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayMulticastDomainInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayMulticastDomainInput {
                transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayMulticastDomainInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayMulticastDomain;
#[doc(hidden)]
pub type DeleteTransitGatewayMulticastDomainInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayMulticastDomainInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayMulticastDomain`](crate::operation::DeleteTransitGatewayMulticastDomain)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayMulticastDomain,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_multicast_domain(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayMulticastDomain::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayMulticastDomain",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayMulticastDomainInput`](crate::input::DeleteTransitGatewayMulticastDomainInput)
    pub fn builder() -> crate::input::delete_transit_gateway_multicast_domain_input::Builder {
        crate::input::delete_transit_gateway_multicast_domain_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayPeeringAttachmentInput`](crate::input::DeleteTransitGatewayPeeringAttachmentInput)
pub mod delete_transit_gateway_peering_attachment_input {
    /// A builder for [`DeleteTransitGatewayPeeringAttachmentInput`](crate::input::DeleteTransitGatewayPeeringAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway peering attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayPeeringAttachmentInput`](crate::input::DeleteTransitGatewayPeeringAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayPeeringAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayPeeringAttachmentInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayPeeringAttachmentInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayPeeringAttachment;
#[doc(hidden)]
pub type DeleteTransitGatewayPeeringAttachmentInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayPeeringAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayPeeringAttachment`](crate::operation::DeleteTransitGatewayPeeringAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayPeeringAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_peering_attachment(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayPeeringAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayPeeringAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayPeeringAttachmentInput`](crate::input::DeleteTransitGatewayPeeringAttachmentInput)
    pub fn builder() -> crate::input::delete_transit_gateway_peering_attachment_input::Builder {
        crate::input::delete_transit_gateway_peering_attachment_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayPrefixListReferenceInput`](crate::input::DeleteTransitGatewayPrefixListReferenceInput)
pub mod delete_transit_gateway_prefix_list_reference_input {
    /// A builder for [`DeleteTransitGatewayPrefixListReferenceInput`](crate::input::DeleteTransitGatewayPrefixListReferenceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the prefix list.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayPrefixListReferenceInput`](crate::input::DeleteTransitGatewayPrefixListReferenceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayPrefixListReferenceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayPrefixListReferenceInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                prefix_list_id: self.prefix_list_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayPrefixListReferenceInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayPrefixListReference;
#[doc(hidden)]
pub type DeleteTransitGatewayPrefixListReferenceInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayPrefixListReferenceInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayPrefixListReference`](crate::operation::DeleteTransitGatewayPrefixListReference)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayPrefixListReference,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_prefix_list_reference(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayPrefixListReference::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayPrefixListReference",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayPrefixListReferenceInput`](crate::input::DeleteTransitGatewayPrefixListReferenceInput)
    pub fn builder() -> crate::input::delete_transit_gateway_prefix_list_reference_input::Builder {
        crate::input::delete_transit_gateway_prefix_list_reference_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayRouteInput`](crate::input::DeleteTransitGatewayRouteInput)
pub mod delete_transit_gateway_route_input {
    /// A builder for [`DeleteTransitGatewayRouteInput`](crate::input::DeleteTransitGatewayRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The CIDR range for the route. This must match the CIDR for the route exactly.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayRouteInput`](crate::input::DeleteTransitGatewayRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayRouteInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                destination_cidr_block: self.destination_cidr_block,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayRouteInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayRoute;
#[doc(hidden)]
pub type DeleteTransitGatewayRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayRouteInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayRoute`](crate::operation::DeleteTransitGatewayRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_route(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayRouteInput`](crate::input::DeleteTransitGatewayRouteInput)
    pub fn builder() -> crate::input::delete_transit_gateway_route_input::Builder {
        crate::input::delete_transit_gateway_route_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayRouteTableInput`](crate::input::DeleteTransitGatewayRouteTableInput)
pub mod delete_transit_gateway_route_table_input {
    /// A builder for [`DeleteTransitGatewayRouteTableInput`](crate::input::DeleteTransitGatewayRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayRouteTableInput`](crate::input::DeleteTransitGatewayRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayRouteTableInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayRouteTableInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayRouteTable;
#[doc(hidden)]
pub type DeleteTransitGatewayRouteTableInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayRouteTable`](crate::operation::DeleteTransitGatewayRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_route_table(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayRouteTableInput`](crate::input::DeleteTransitGatewayRouteTableInput)
    pub fn builder() -> crate::input::delete_transit_gateway_route_table_input::Builder {
        crate::input::delete_transit_gateway_route_table_input::Builder::default()
    }
}

/// See [`DeleteTransitGatewayVpcAttachmentInput`](crate::input::DeleteTransitGatewayVpcAttachmentInput)
pub mod delete_transit_gateway_vpc_attachment_input {
    /// A builder for [`DeleteTransitGatewayVpcAttachmentInput`](crate::input::DeleteTransitGatewayVpcAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteTransitGatewayVpcAttachmentInput`](crate::input::DeleteTransitGatewayVpcAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteTransitGatewayVpcAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteTransitGatewayVpcAttachmentInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteTransitGatewayVpcAttachmentInputOperationOutputAlias =
    crate::operation::DeleteTransitGatewayVpcAttachment;
#[doc(hidden)]
pub type DeleteTransitGatewayVpcAttachmentInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteTransitGatewayVpcAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`DeleteTransitGatewayVpcAttachment`](crate::operation::DeleteTransitGatewayVpcAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteTransitGatewayVpcAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_transit_gateway_vpc_attachment(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteTransitGatewayVpcAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteTransitGatewayVpcAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteTransitGatewayVpcAttachmentInput`](crate::input::DeleteTransitGatewayVpcAttachmentInput)
    pub fn builder() -> crate::input::delete_transit_gateway_vpc_attachment_input::Builder {
        crate::input::delete_transit_gateway_vpc_attachment_input::Builder::default()
    }
}

/// See [`DeleteVolumeInput`](crate::input::DeleteVolumeInput)
pub mod delete_volume_input {
    /// A builder for [`DeleteVolumeInput`](crate::input::DeleteVolumeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) volume_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the volume.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVolumeInput`](crate::input::DeleteVolumeInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DeleteVolumeInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DeleteVolumeInput {
                volume_id: self.volume_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVolumeInputOperationOutputAlias = crate::operation::DeleteVolume;
#[doc(hidden)]
pub type DeleteVolumeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteVolumeInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVolume`](crate::operation::DeleteVolume)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVolume,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_volume(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVolume::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DeleteVolume", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVolumeInput`](crate::input::DeleteVolumeInput)
    pub fn builder() -> crate::input::delete_volume_input::Builder {
        crate::input::delete_volume_input::Builder::default()
    }
}

/// See [`DeleteVpcInput`](crate::input::DeleteVpcInput)
pub mod delete_vpc_input {
    /// A builder for [`DeleteVpcInput`](crate::input::DeleteVpcInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpcInput`](crate::input::DeleteVpcInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DeleteVpcInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DeleteVpcInput {
                vpc_id: self.vpc_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVpcInputOperationOutputAlias = crate::operation::DeleteVpc;
#[doc(hidden)]
pub type DeleteVpcInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteVpcInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpc`](crate::operation::DeleteVpc)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpc,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_vpc(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op =
                smithy_http::operation::Operation::new(request, crate::operation::DeleteVpc::new())
                    .with_metadata(smithy_http::operation::Metadata::new("DeleteVpc", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpcInput`](crate::input::DeleteVpcInput)
    pub fn builder() -> crate::input::delete_vpc_input::Builder {
        crate::input::delete_vpc_input::Builder::default()
    }
}

/// See [`DeleteVpcEndpointConnectionNotificationsInput`](crate::input::DeleteVpcEndpointConnectionNotificationsInput)
pub mod delete_vpc_endpoint_connection_notifications_input {
    /// A builder for [`DeleteVpcEndpointConnectionNotificationsInput`](crate::input::DeleteVpcEndpointConnectionNotificationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) connection_notification_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn connection_notification_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.connection_notification_ids.unwrap_or_default();
            v.push(input.into());
            self.connection_notification_ids = Some(v);
            self
        }
        pub fn set_connection_notification_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.connection_notification_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpcEndpointConnectionNotificationsInput`](crate::input::DeleteVpcEndpointConnectionNotificationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteVpcEndpointConnectionNotificationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DeleteVpcEndpointConnectionNotificationsInput {
                    dry_run: self.dry_run,
                    connection_notification_ids: self.connection_notification_ids,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DeleteVpcEndpointConnectionNotificationsInputOperationOutputAlias =
    crate::operation::DeleteVpcEndpointConnectionNotifications;
#[doc(hidden)]
pub type DeleteVpcEndpointConnectionNotificationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeleteVpcEndpointConnectionNotificationsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpcEndpointConnectionNotifications`](crate::operation::DeleteVpcEndpointConnectionNotifications)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpcEndpointConnectionNotifications,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_vpc_endpoint_connection_notifications(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVpcEndpointConnectionNotifications::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteVpcEndpointConnectionNotifications",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpcEndpointConnectionNotificationsInput`](crate::input::DeleteVpcEndpointConnectionNotificationsInput)
    pub fn builder() -> crate::input::delete_vpc_endpoint_connection_notifications_input::Builder {
        crate::input::delete_vpc_endpoint_connection_notifications_input::Builder::default()
    }
}

/// See [`DeleteVpcEndpointsInput`](crate::input::DeleteVpcEndpointsInput)
pub mod delete_vpc_endpoints_input {
    /// A builder for [`DeleteVpcEndpointsInput`](crate::input::DeleteVpcEndpointsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn vpc_endpoint_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_endpoint_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_endpoint_ids = Some(v);
            self
        }
        pub fn set_vpc_endpoint_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_endpoint_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpcEndpointsInput`](crate::input::DeleteVpcEndpointsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteVpcEndpointsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteVpcEndpointsInput {
                dry_run: self.dry_run,
                vpc_endpoint_ids: self.vpc_endpoint_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVpcEndpointsInputOperationOutputAlias = crate::operation::DeleteVpcEndpoints;
#[doc(hidden)]
pub type DeleteVpcEndpointsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteVpcEndpointsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpcEndpoints`](crate::operation::DeleteVpcEndpoints)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpcEndpoints,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_vpc_endpoints(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVpcEndpoints::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteVpcEndpoints",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpcEndpointsInput`](crate::input::DeleteVpcEndpointsInput)
    pub fn builder() -> crate::input::delete_vpc_endpoints_input::Builder {
        crate::input::delete_vpc_endpoints_input::Builder::default()
    }
}

/// See [`DeleteVpcEndpointServiceConfigurationsInput`](crate::input::DeleteVpcEndpointServiceConfigurationsInput)
pub mod delete_vpc_endpoint_service_configurations_input {
    /// A builder for [`DeleteVpcEndpointServiceConfigurationsInput`](crate::input::DeleteVpcEndpointServiceConfigurationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn service_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.service_ids.unwrap_or_default();
            v.push(input.into());
            self.service_ids = Some(v);
            self
        }
        pub fn set_service_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.service_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpcEndpointServiceConfigurationsInput`](crate::input::DeleteVpcEndpointServiceConfigurationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteVpcEndpointServiceConfigurationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteVpcEndpointServiceConfigurationsInput {
                dry_run: self.dry_run,
                service_ids: self.service_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVpcEndpointServiceConfigurationsInputOperationOutputAlias =
    crate::operation::DeleteVpcEndpointServiceConfigurations;
#[doc(hidden)]
pub type DeleteVpcEndpointServiceConfigurationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeleteVpcEndpointServiceConfigurationsInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpcEndpointServiceConfigurations`](crate::operation::DeleteVpcEndpointServiceConfigurations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpcEndpointServiceConfigurations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_vpc_endpoint_service_configurations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVpcEndpointServiceConfigurations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteVpcEndpointServiceConfigurations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpcEndpointServiceConfigurationsInput`](crate::input::DeleteVpcEndpointServiceConfigurationsInput)
    pub fn builder() -> crate::input::delete_vpc_endpoint_service_configurations_input::Builder {
        crate::input::delete_vpc_endpoint_service_configurations_input::Builder::default()
    }
}

/// See [`DeleteVpcPeeringConnectionInput`](crate::input::DeleteVpcPeeringConnectionInput)
pub mod delete_vpc_peering_connection_input {
    /// A builder for [`DeleteVpcPeeringConnectionInput`](crate::input::DeleteVpcPeeringConnectionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_peering_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC peering connection.</p>
        pub fn vpc_peering_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_peering_connection_id = Some(input.into());
            self
        }
        pub fn set_vpc_peering_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_peering_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpcPeeringConnectionInput`](crate::input::DeleteVpcPeeringConnectionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteVpcPeeringConnectionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteVpcPeeringConnectionInput {
                dry_run: self.dry_run,
                vpc_peering_connection_id: self.vpc_peering_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVpcPeeringConnectionInputOperationOutputAlias =
    crate::operation::DeleteVpcPeeringConnection;
#[doc(hidden)]
pub type DeleteVpcPeeringConnectionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteVpcPeeringConnectionInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpcPeeringConnection`](crate::operation::DeleteVpcPeeringConnection)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpcPeeringConnection,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_delete_vpc_peering_connection(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVpcPeeringConnection::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteVpcPeeringConnection",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpcPeeringConnectionInput`](crate::input::DeleteVpcPeeringConnectionInput)
    pub fn builder() -> crate::input::delete_vpc_peering_connection_input::Builder {
        crate::input::delete_vpc_peering_connection_input::Builder::default()
    }
}

/// See [`DeleteVpnConnectionInput`](crate::input::DeleteVpnConnectionInput)
pub mod delete_vpn_connection_input {
    /// A builder for [`DeleteVpnConnectionInput`](crate::input::DeleteVpnConnectionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpn_connection_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the VPN connection.</p>
        pub fn vpn_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_connection_id = Some(input.into());
            self
        }
        pub fn set_vpn_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_connection_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpnConnectionInput`](crate::input::DeleteVpnConnectionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteVpnConnectionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteVpnConnectionInput {
                vpn_connection_id: self.vpn_connection_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVpnConnectionInputOperationOutputAlias = crate::operation::DeleteVpnConnection;
#[doc(hidden)]
pub type DeleteVpnConnectionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteVpnConnectionInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpnConnection`](crate::operation::DeleteVpnConnection)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpnConnection,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_vpn_connection(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVpnConnection::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteVpnConnection",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpnConnectionInput`](crate::input::DeleteVpnConnectionInput)
    pub fn builder() -> crate::input::delete_vpn_connection_input::Builder {
        crate::input::delete_vpn_connection_input::Builder::default()
    }
}

/// See [`DeleteVpnConnectionRouteInput`](crate::input::DeleteVpnConnectionRouteInput)
pub mod delete_vpn_connection_route_input {
    /// A builder for [`DeleteVpnConnectionRouteInput`](crate::input::DeleteVpnConnectionRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) vpn_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The CIDR block associated with the local subnet of the customer network.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The ID of the VPN connection.</p>
        pub fn vpn_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_connection_id = Some(input.into());
            self
        }
        pub fn set_vpn_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpnConnectionRouteInput`](crate::input::DeleteVpnConnectionRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteVpnConnectionRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteVpnConnectionRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                vpn_connection_id: self.vpn_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVpnConnectionRouteInputOperationOutputAlias =
    crate::operation::DeleteVpnConnectionRoute;
#[doc(hidden)]
pub type DeleteVpnConnectionRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteVpnConnectionRouteInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpnConnectionRoute`](crate::operation::DeleteVpnConnectionRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpnConnectionRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_vpn_connection_route(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVpnConnectionRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteVpnConnectionRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpnConnectionRouteInput`](crate::input::DeleteVpnConnectionRouteInput)
    pub fn builder() -> crate::input::delete_vpn_connection_route_input::Builder {
        crate::input::delete_vpn_connection_route_input::Builder::default()
    }
}

/// See [`DeleteVpnGatewayInput`](crate::input::DeleteVpnGatewayInput)
pub mod delete_vpn_gateway_input {
    /// A builder for [`DeleteVpnGatewayInput`](crate::input::DeleteVpnGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpn_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the virtual private gateway.</p>
        pub fn vpn_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_gateway_id = Some(input.into());
            self
        }
        pub fn set_vpn_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeleteVpnGatewayInput`](crate::input::DeleteVpnGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeleteVpnGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeleteVpnGatewayInput {
                vpn_gateway_id: self.vpn_gateway_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeleteVpnGatewayInputOperationOutputAlias = crate::operation::DeleteVpnGateway;
#[doc(hidden)]
pub type DeleteVpnGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeleteVpnGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DeleteVpnGateway`](crate::operation::DeleteVpnGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeleteVpnGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_delete_vpn_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeleteVpnGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeleteVpnGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeleteVpnGatewayInput`](crate::input::DeleteVpnGatewayInput)
    pub fn builder() -> crate::input::delete_vpn_gateway_input::Builder {
        crate::input::delete_vpn_gateway_input::Builder::default()
    }
}

/// See [`DeprovisionByoipCidrInput`](crate::input::DeprovisionByoipCidrInput)
pub mod deprovision_byoip_cidr_input {
    /// A builder for [`DeprovisionByoipCidrInput`](crate::input::DeprovisionByoipCidrInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The address range, in CIDR notation. The prefix must be the same prefix
        /// that you specified when you provisioned the address range.</p>
        pub fn cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr = Some(input.into());
            self
        }
        pub fn set_cidr(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeprovisionByoipCidrInput`](crate::input::DeprovisionByoipCidrInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeprovisionByoipCidrInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeprovisionByoipCidrInput {
                cidr: self.cidr,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeprovisionByoipCidrInputOperationOutputAlias = crate::operation::DeprovisionByoipCidr;
#[doc(hidden)]
pub type DeprovisionByoipCidrInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeprovisionByoipCidrInput {
    /// Consumes the builder and constructs an Operation<[`DeprovisionByoipCidr`](crate::operation::DeprovisionByoipCidr)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeprovisionByoipCidr,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_deprovision_byoip_cidr(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeprovisionByoipCidr::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeprovisionByoipCidr",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeprovisionByoipCidrInput`](crate::input::DeprovisionByoipCidrInput)
    pub fn builder() -> crate::input::deprovision_byoip_cidr_input::Builder {
        crate::input::deprovision_byoip_cidr_input::Builder::default()
    }
}

/// See [`DeregisterImageInput`](crate::input::DeregisterImageInput)
pub mod deregister_image_input {
    /// A builder for [`DeregisterImageInput`](crate::input::DeregisterImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the AMI.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeregisterImageInput`](crate::input::DeregisterImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeregisterImageInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DeregisterImageInput {
                image_id: self.image_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DeregisterImageInputOperationOutputAlias = crate::operation::DeregisterImage;
#[doc(hidden)]
pub type DeregisterImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DeregisterImageInput {
    /// Consumes the builder and constructs an Operation<[`DeregisterImage`](crate::operation::DeregisterImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeregisterImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_deregister_image(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeregisterImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeregisterImage",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeregisterImageInput`](crate::input::DeregisterImageInput)
    pub fn builder() -> crate::input::deregister_image_input::Builder {
        crate::input::deregister_image_input::Builder::default()
    }
}

/// See [`DeregisterInstanceEventNotificationAttributesInput`](crate::input::DeregisterInstanceEventNotificationAttributesInput)
pub mod deregister_instance_event_notification_attributes_input {
    /// A builder for [`DeregisterInstanceEventNotificationAttributesInput`](crate::input::DeregisterInstanceEventNotificationAttributesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_tag_attribute:
            std::option::Option<crate::model::DeregisterInstanceTagAttributeRequest>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Information about the tag keys to deregister.</p>
        pub fn instance_tag_attribute(
            mut self,
            input: crate::model::DeregisterInstanceTagAttributeRequest,
        ) -> Self {
            self.instance_tag_attribute = Some(input);
            self
        }
        pub fn set_instance_tag_attribute(
            mut self,
            input: std::option::Option<crate::model::DeregisterInstanceTagAttributeRequest>,
        ) -> Self {
            self.instance_tag_attribute = input;
            self
        }
        /// Consumes the builder and constructs a [`DeregisterInstanceEventNotificationAttributesInput`](crate::input::DeregisterInstanceEventNotificationAttributesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeregisterInstanceEventNotificationAttributesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DeregisterInstanceEventNotificationAttributesInput {
                    dry_run: self.dry_run,
                    instance_tag_attribute: self.instance_tag_attribute,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DeregisterInstanceEventNotificationAttributesInputOperationOutputAlias =
    crate::operation::DeregisterInstanceEventNotificationAttributes;
#[doc(hidden)]
pub type DeregisterInstanceEventNotificationAttributesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeregisterInstanceEventNotificationAttributesInput {
    /// Consumes the builder and constructs an Operation<[`DeregisterInstanceEventNotificationAttributes`](crate::operation::DeregisterInstanceEventNotificationAttributes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeregisterInstanceEventNotificationAttributes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_deregister_instance_event_notification_attributes(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeregisterInstanceEventNotificationAttributes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeregisterInstanceEventNotificationAttributes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeregisterInstanceEventNotificationAttributesInput`](crate::input::DeregisterInstanceEventNotificationAttributesInput)
    pub fn builder(
    ) -> crate::input::deregister_instance_event_notification_attributes_input::Builder {
        crate::input::deregister_instance_event_notification_attributes_input::Builder::default()
    }
}

/// See [`DeregisterTransitGatewayMulticastGroupMembersInput`](crate::input::DeregisterTransitGatewayMulticastGroupMembersInput)
pub mod deregister_transit_gateway_multicast_group_members_input {
    /// A builder for [`DeregisterTransitGatewayMulticastGroupMembersInput`](crate::input::DeregisterTransitGatewayMulticastGroupMembersInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) group_ip_address: std::option::Option<std::string::String>,
        pub(crate) network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The IP address assigned to the  transit gateway multicast group.</p>
        pub fn group_ip_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_ip_address = Some(input.into());
            self
        }
        pub fn set_group_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.group_ip_address = input;
            self
        }
        pub fn network_interface_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_interface_ids.unwrap_or_default();
            v.push(input.into());
            self.network_interface_ids = Some(v);
            self
        }
        pub fn set_network_interface_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_interface_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeregisterTransitGatewayMulticastGroupMembersInput`](crate::input::DeregisterTransitGatewayMulticastGroupMembersInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeregisterTransitGatewayMulticastGroupMembersInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DeregisterTransitGatewayMulticastGroupMembersInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    group_ip_address: self.group_ip_address,
                    network_interface_ids: self.network_interface_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DeregisterTransitGatewayMulticastGroupMembersInputOperationOutputAlias =
    crate::operation::DeregisterTransitGatewayMulticastGroupMembers;
#[doc(hidden)]
pub type DeregisterTransitGatewayMulticastGroupMembersInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeregisterTransitGatewayMulticastGroupMembersInput {
    /// Consumes the builder and constructs an Operation<[`DeregisterTransitGatewayMulticastGroupMembers`](crate::operation::DeregisterTransitGatewayMulticastGroupMembers)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeregisterTransitGatewayMulticastGroupMembers,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_deregister_transit_gateway_multicast_group_members(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeregisterTransitGatewayMulticastGroupMembers::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeregisterTransitGatewayMulticastGroupMembers",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeregisterTransitGatewayMulticastGroupMembersInput`](crate::input::DeregisterTransitGatewayMulticastGroupMembersInput)
    pub fn builder(
    ) -> crate::input::deregister_transit_gateway_multicast_group_members_input::Builder {
        crate::input::deregister_transit_gateway_multicast_group_members_input::Builder::default()
    }
}

/// See [`DeregisterTransitGatewayMulticastGroupSourcesInput`](crate::input::DeregisterTransitGatewayMulticastGroupSourcesInput)
pub mod deregister_transit_gateway_multicast_group_sources_input {
    /// A builder for [`DeregisterTransitGatewayMulticastGroupSourcesInput`](crate::input::DeregisterTransitGatewayMulticastGroupSourcesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) group_ip_address: std::option::Option<std::string::String>,
        pub(crate) network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The IP address assigned to the  transit gateway multicast group.</p>
        pub fn group_ip_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_ip_address = Some(input.into());
            self
        }
        pub fn set_group_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.group_ip_address = input;
            self
        }
        pub fn network_interface_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_interface_ids.unwrap_or_default();
            v.push(input.into());
            self.network_interface_ids = Some(v);
            self
        }
        pub fn set_network_interface_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_interface_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DeregisterTransitGatewayMulticastGroupSourcesInput`](crate::input::DeregisterTransitGatewayMulticastGroupSourcesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DeregisterTransitGatewayMulticastGroupSourcesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DeregisterTransitGatewayMulticastGroupSourcesInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    group_ip_address: self.group_ip_address,
                    network_interface_ids: self.network_interface_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DeregisterTransitGatewayMulticastGroupSourcesInputOperationOutputAlias =
    crate::operation::DeregisterTransitGatewayMulticastGroupSources;
#[doc(hidden)]
pub type DeregisterTransitGatewayMulticastGroupSourcesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DeregisterTransitGatewayMulticastGroupSourcesInput {
    /// Consumes the builder and constructs an Operation<[`DeregisterTransitGatewayMulticastGroupSources`](crate::operation::DeregisterTransitGatewayMulticastGroupSources)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DeregisterTransitGatewayMulticastGroupSources,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_deregister_transit_gateway_multicast_group_sources(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DeregisterTransitGatewayMulticastGroupSources::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DeregisterTransitGatewayMulticastGroupSources",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DeregisterTransitGatewayMulticastGroupSourcesInput`](crate::input::DeregisterTransitGatewayMulticastGroupSourcesInput)
    pub fn builder(
    ) -> crate::input::deregister_transit_gateway_multicast_group_sources_input::Builder {
        crate::input::deregister_transit_gateway_multicast_group_sources_input::Builder::default()
    }
}

/// See [`DescribeAccountAttributesInput`](crate::input::DescribeAccountAttributesInput)
pub mod describe_account_attributes_input {
    /// A builder for [`DescribeAccountAttributesInput`](crate::input::DescribeAccountAttributesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute_names:
            std::option::Option<std::vec::Vec<crate::model::AccountAttributeName>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn attribute_names(
            mut self,
            input: impl Into<crate::model::AccountAttributeName>,
        ) -> Self {
            let mut v = self.attribute_names.unwrap_or_default();
            v.push(input.into());
            self.attribute_names = Some(v);
            self
        }
        pub fn set_attribute_names(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AccountAttributeName>>,
        ) -> Self {
            self.attribute_names = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeAccountAttributesInput`](crate::input::DescribeAccountAttributesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeAccountAttributesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeAccountAttributesInput {
                attribute_names: self.attribute_names,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeAccountAttributesInputOperationOutputAlias =
    crate::operation::DescribeAccountAttributes;
#[doc(hidden)]
pub type DescribeAccountAttributesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeAccountAttributesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeAccountAttributes`](crate::operation::DescribeAccountAttributes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeAccountAttributes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_account_attributes(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeAccountAttributes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeAccountAttributes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeAccountAttributesInput`](crate::input::DescribeAccountAttributesInput)
    pub fn builder() -> crate::input::describe_account_attributes_input::Builder {
        crate::input::describe_account_attributes_input::Builder::default()
    }
}

/// See [`DescribeAddressesInput`](crate::input::DescribeAddressesInput)
pub mod describe_addresses_input {
    /// A builder for [`DescribeAddressesInput`](crate::input::DescribeAddressesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) public_ips: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) allocation_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn public_ips(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.public_ips.unwrap_or_default();
            v.push(input.into());
            self.public_ips = Some(v);
            self
        }
        pub fn set_public_ips(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.public_ips = input;
            self
        }
        pub fn allocation_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.allocation_ids.unwrap_or_default();
            v.push(input.into());
            self.allocation_ids = Some(v);
            self
        }
        pub fn set_allocation_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.allocation_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeAddressesInput`](crate::input::DescribeAddressesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeAddressesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeAddressesInput {
                filters: self.filters,
                public_ips: self.public_ips,
                allocation_ids: self.allocation_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeAddressesInputOperationOutputAlias = crate::operation::DescribeAddresses;
#[doc(hidden)]
pub type DescribeAddressesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeAddressesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeAddresses`](crate::operation::DescribeAddresses)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeAddresses,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_addresses(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeAddresses::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeAddresses",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeAddressesInput`](crate::input::DescribeAddressesInput)
    pub fn builder() -> crate::input::describe_addresses_input::Builder {
        crate::input::describe_addresses_input::Builder::default()
    }
}

/// See [`DescribeAddressesAttributeInput`](crate::input::DescribeAddressesAttributeInput)
pub mod describe_addresses_attribute_input {
    /// A builder for [`DescribeAddressesAttributeInput`](crate::input::DescribeAddressesAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) allocation_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) attribute: std::option::Option<crate::model::AddressAttributeName>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn allocation_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.allocation_ids.unwrap_or_default();
            v.push(input.into());
            self.allocation_ids = Some(v);
            self
        }
        pub fn set_allocation_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.allocation_ids = input;
            self
        }
        /// <p>The attribute of the IP address.</p>
        pub fn attribute(mut self, input: crate::model::AddressAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::AddressAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call. To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeAddressesAttributeInput`](crate::input::DescribeAddressesAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeAddressesAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeAddressesAttributeInput {
                allocation_ids: self.allocation_ids,
                attribute: self.attribute,
                next_token: self.next_token,
                max_results: self.max_results,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeAddressesAttributeInputOperationOutputAlias =
    crate::operation::DescribeAddressesAttribute;
#[doc(hidden)]
pub type DescribeAddressesAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeAddressesAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeAddressesAttribute`](crate::operation::DescribeAddressesAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeAddressesAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_addresses_attribute(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeAddressesAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeAddressesAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeAddressesAttributeInput`](crate::input::DescribeAddressesAttributeInput)
    pub fn builder() -> crate::input::describe_addresses_attribute_input::Builder {
        crate::input::describe_addresses_attribute_input::Builder::default()
    }
}

/// See [`DescribeAggregateIdFormatInput`](crate::input::DescribeAggregateIdFormatInput)
pub mod describe_aggregate_id_format_input {
    /// A builder for [`DescribeAggregateIdFormatInput`](crate::input::DescribeAggregateIdFormatInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeAggregateIdFormatInput`](crate::input::DescribeAggregateIdFormatInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeAggregateIdFormatInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeAggregateIdFormatInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeAggregateIdFormatInputOperationOutputAlias =
    crate::operation::DescribeAggregateIdFormat;
#[doc(hidden)]
pub type DescribeAggregateIdFormatInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeAggregateIdFormatInput {
    /// Consumes the builder and constructs an Operation<[`DescribeAggregateIdFormat`](crate::operation::DescribeAggregateIdFormat)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeAggregateIdFormat,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_aggregate_id_format(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeAggregateIdFormat::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeAggregateIdFormat",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeAggregateIdFormatInput`](crate::input::DescribeAggregateIdFormatInput)
    pub fn builder() -> crate::input::describe_aggregate_id_format_input::Builder {
        crate::input::describe_aggregate_id_format_input::Builder::default()
    }
}

/// See [`DescribeAvailabilityZonesInput`](crate::input::DescribeAvailabilityZonesInput)
pub mod describe_availability_zones_input {
    /// A builder for [`DescribeAvailabilityZonesInput`](crate::input::DescribeAvailabilityZonesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) zone_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) zone_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) all_availability_zones: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn zone_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.zone_names.unwrap_or_default();
            v.push(input.into());
            self.zone_names = Some(v);
            self
        }
        pub fn set_zone_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.zone_names = input;
            self
        }
        pub fn zone_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.zone_ids.unwrap_or_default();
            v.push(input.into());
            self.zone_ids = Some(v);
            self
        }
        pub fn set_zone_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.zone_ids = input;
            self
        }
        /// <p>Include all Availability Zones, Local Zones, and Wavelength Zones regardless of your
        /// opt-in status.</p>
        /// <p>If you do not use this parameter, the results include only the zones for the Regions where you have chosen the option to opt in.</p>
        pub fn all_availability_zones(mut self, input: bool) -> Self {
            self.all_availability_zones = Some(input);
            self
        }
        pub fn set_all_availability_zones(mut self, input: std::option::Option<bool>) -> Self {
            self.all_availability_zones = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeAvailabilityZonesInput`](crate::input::DescribeAvailabilityZonesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeAvailabilityZonesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeAvailabilityZonesInput {
                filters: self.filters,
                zone_names: self.zone_names,
                zone_ids: self.zone_ids,
                all_availability_zones: self.all_availability_zones,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeAvailabilityZonesInputOperationOutputAlias =
    crate::operation::DescribeAvailabilityZones;
#[doc(hidden)]
pub type DescribeAvailabilityZonesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeAvailabilityZonesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeAvailabilityZones`](crate::operation::DescribeAvailabilityZones)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeAvailabilityZones,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_availability_zones(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeAvailabilityZones::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeAvailabilityZones",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeAvailabilityZonesInput`](crate::input::DescribeAvailabilityZonesInput)
    pub fn builder() -> crate::input::describe_availability_zones_input::Builder {
        crate::input::describe_availability_zones_input::Builder::default()
    }
}

/// See [`DescribeBundleTasksInput`](crate::input::DescribeBundleTasksInput)
pub mod describe_bundle_tasks_input {
    /// A builder for [`DescribeBundleTasksInput`](crate::input::DescribeBundleTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) bundle_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn bundle_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.bundle_ids.unwrap_or_default();
            v.push(input.into());
            self.bundle_ids = Some(v);
            self
        }
        pub fn set_bundle_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.bundle_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeBundleTasksInput`](crate::input::DescribeBundleTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeBundleTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeBundleTasksInput {
                bundle_ids: self.bundle_ids,
                filters: self.filters,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeBundleTasksInputOperationOutputAlias = crate::operation::DescribeBundleTasks;
#[doc(hidden)]
pub type DescribeBundleTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeBundleTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeBundleTasks`](crate::operation::DescribeBundleTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeBundleTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_bundle_tasks(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeBundleTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeBundleTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeBundleTasksInput`](crate::input::DescribeBundleTasksInput)
    pub fn builder() -> crate::input::describe_bundle_tasks_input::Builder {
        crate::input::describe_bundle_tasks_input::Builder::default()
    }
}

/// See [`DescribeByoipCidrsInput`](crate::input::DescribeByoipCidrsInput)
pub mod describe_byoip_cidrs_input {
    /// A builder for [`DescribeByoipCidrsInput`](crate::input::DescribeByoipCidrsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeByoipCidrsInput`](crate::input::DescribeByoipCidrsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeByoipCidrsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeByoipCidrsInput {
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeByoipCidrsInputOperationOutputAlias = crate::operation::DescribeByoipCidrs;
#[doc(hidden)]
pub type DescribeByoipCidrsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeByoipCidrsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeByoipCidrs`](crate::operation::DescribeByoipCidrs)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeByoipCidrs,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_byoip_cidrs(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeByoipCidrs::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeByoipCidrs",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeByoipCidrsInput`](crate::input::DescribeByoipCidrsInput)
    pub fn builder() -> crate::input::describe_byoip_cidrs_input::Builder {
        crate::input::describe_byoip_cidrs_input::Builder::default()
    }
}

/// See [`DescribeCapacityReservationsInput`](crate::input::DescribeCapacityReservationsInput)
pub mod describe_capacity_reservations_input {
    /// A builder for [`DescribeCapacityReservationsInput`](crate::input::DescribeCapacityReservationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) capacity_reservation_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn capacity_reservation_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.capacity_reservation_ids.unwrap_or_default();
            v.push(input.into());
            self.capacity_reservation_ids = Some(v);
            self
        }
        pub fn set_capacity_reservation_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.capacity_reservation_ids = input;
            self
        }
        /// <p>The token to use to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeCapacityReservationsInput`](crate::input::DescribeCapacityReservationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeCapacityReservationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeCapacityReservationsInput {
                capacity_reservation_ids: self.capacity_reservation_ids,
                next_token: self.next_token,
                max_results: self.max_results,
                filters: self.filters,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeCapacityReservationsInputOperationOutputAlias =
    crate::operation::DescribeCapacityReservations;
#[doc(hidden)]
pub type DescribeCapacityReservationsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeCapacityReservationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeCapacityReservations`](crate::operation::DescribeCapacityReservations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeCapacityReservations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_capacity_reservations(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeCapacityReservations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeCapacityReservations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeCapacityReservationsInput`](crate::input::DescribeCapacityReservationsInput)
    pub fn builder() -> crate::input::describe_capacity_reservations_input::Builder {
        crate::input::describe_capacity_reservations_input::Builder::default()
    }
}

/// See [`DescribeCarrierGatewaysInput`](crate::input::DescribeCarrierGatewaysInput)
pub mod describe_carrier_gateways_input {
    /// A builder for [`DescribeCarrierGatewaysInput`](crate::input::DescribeCarrierGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) carrier_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn carrier_gateway_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.carrier_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.carrier_gateway_ids = Some(v);
            self
        }
        pub fn set_carrier_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.carrier_gateway_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeCarrierGatewaysInput`](crate::input::DescribeCarrierGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeCarrierGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeCarrierGatewaysInput {
                carrier_gateway_ids: self.carrier_gateway_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeCarrierGatewaysInputOperationOutputAlias =
    crate::operation::DescribeCarrierGateways;
#[doc(hidden)]
pub type DescribeCarrierGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeCarrierGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeCarrierGateways`](crate::operation::DescribeCarrierGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeCarrierGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_carrier_gateways(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeCarrierGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeCarrierGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeCarrierGatewaysInput`](crate::input::DescribeCarrierGatewaysInput)
    pub fn builder() -> crate::input::describe_carrier_gateways_input::Builder {
        crate::input::describe_carrier_gateways_input::Builder::default()
    }
}

/// See [`DescribeClassicLinkInstancesInput`](crate::input::DescribeClassicLinkInstancesInput)
pub mod describe_classic_link_instances_input {
    /// A builder for [`DescribeClassicLinkInstancesInput`](crate::input::DescribeClassicLinkInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        /// <p>Constraint: If the value is greater than 1000, we return only 1000 items.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeClassicLinkInstancesInput`](crate::input::DescribeClassicLinkInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeClassicLinkInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeClassicLinkInstancesInput {
                filters: self.filters,
                dry_run: self.dry_run,
                instance_ids: self.instance_ids,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeClassicLinkInstancesInputOperationOutputAlias =
    crate::operation::DescribeClassicLinkInstances;
#[doc(hidden)]
pub type DescribeClassicLinkInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeClassicLinkInstancesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeClassicLinkInstances`](crate::operation::DescribeClassicLinkInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeClassicLinkInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_classic_link_instances(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeClassicLinkInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeClassicLinkInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeClassicLinkInstancesInput`](crate::input::DescribeClassicLinkInstancesInput)
    pub fn builder() -> crate::input::describe_classic_link_instances_input::Builder {
        crate::input::describe_classic_link_instances_input::Builder::default()
    }
}

/// See [`DescribeClientVpnAuthorizationRulesInput`](crate::input::DescribeClientVpnAuthorizationRulesInput)
pub mod describe_client_vpn_authorization_rules_input {
    /// A builder for [`DescribeClientVpnAuthorizationRulesInput`](crate::input::DescribeClientVpnAuthorizationRulesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeClientVpnAuthorizationRulesInput`](crate::input::DescribeClientVpnAuthorizationRulesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeClientVpnAuthorizationRulesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeClientVpnAuthorizationRulesInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                dry_run: self.dry_run,
                next_token: self.next_token,
                filters: self.filters,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeClientVpnAuthorizationRulesInputOperationOutputAlias =
    crate::operation::DescribeClientVpnAuthorizationRules;
#[doc(hidden)]
pub type DescribeClientVpnAuthorizationRulesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeClientVpnAuthorizationRulesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeClientVpnAuthorizationRules`](crate::operation::DescribeClientVpnAuthorizationRules)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeClientVpnAuthorizationRules,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_client_vpn_authorization_rules(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeClientVpnAuthorizationRules::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeClientVpnAuthorizationRules",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeClientVpnAuthorizationRulesInput`](crate::input::DescribeClientVpnAuthorizationRulesInput)
    pub fn builder() -> crate::input::describe_client_vpn_authorization_rules_input::Builder {
        crate::input::describe_client_vpn_authorization_rules_input::Builder::default()
    }
}

/// See [`DescribeClientVpnConnectionsInput`](crate::input::DescribeClientVpnConnectionsInput)
pub mod describe_client_vpn_connections_input {
    /// A builder for [`DescribeClientVpnConnectionsInput`](crate::input::DescribeClientVpnConnectionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeClientVpnConnectionsInput`](crate::input::DescribeClientVpnConnectionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeClientVpnConnectionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeClientVpnConnectionsInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                filters: self.filters,
                next_token: self.next_token,
                max_results: self.max_results,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeClientVpnConnectionsInputOperationOutputAlias =
    crate::operation::DescribeClientVpnConnections;
#[doc(hidden)]
pub type DescribeClientVpnConnectionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeClientVpnConnectionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeClientVpnConnections`](crate::operation::DescribeClientVpnConnections)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeClientVpnConnections,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_client_vpn_connections(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeClientVpnConnections::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeClientVpnConnections",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeClientVpnConnectionsInput`](crate::input::DescribeClientVpnConnectionsInput)
    pub fn builder() -> crate::input::describe_client_vpn_connections_input::Builder {
        crate::input::describe_client_vpn_connections_input::Builder::default()
    }
}

/// See [`DescribeClientVpnEndpointsInput`](crate::input::DescribeClientVpnEndpointsInput)
pub mod describe_client_vpn_endpoints_input {
    /// A builder for [`DescribeClientVpnEndpointsInput`](crate::input::DescribeClientVpnEndpointsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn client_vpn_endpoint_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.client_vpn_endpoint_ids.unwrap_or_default();
            v.push(input.into());
            self.client_vpn_endpoint_ids = Some(v);
            self
        }
        pub fn set_client_vpn_endpoint_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.client_vpn_endpoint_ids = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeClientVpnEndpointsInput`](crate::input::DescribeClientVpnEndpointsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeClientVpnEndpointsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeClientVpnEndpointsInput {
                client_vpn_endpoint_ids: self.client_vpn_endpoint_ids,
                max_results: self.max_results,
                next_token: self.next_token,
                filters: self.filters,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeClientVpnEndpointsInputOperationOutputAlias =
    crate::operation::DescribeClientVpnEndpoints;
#[doc(hidden)]
pub type DescribeClientVpnEndpointsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeClientVpnEndpointsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeClientVpnEndpoints`](crate::operation::DescribeClientVpnEndpoints)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeClientVpnEndpoints,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_client_vpn_endpoints(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeClientVpnEndpoints::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeClientVpnEndpoints",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeClientVpnEndpointsInput`](crate::input::DescribeClientVpnEndpointsInput)
    pub fn builder() -> crate::input::describe_client_vpn_endpoints_input::Builder {
        crate::input::describe_client_vpn_endpoints_input::Builder::default()
    }
}

/// See [`DescribeClientVpnRoutesInput`](crate::input::DescribeClientVpnRoutesInput)
pub mod describe_client_vpn_routes_input {
    /// A builder for [`DescribeClientVpnRoutesInput`](crate::input::DescribeClientVpnRoutesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeClientVpnRoutesInput`](crate::input::DescribeClientVpnRoutesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeClientVpnRoutesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeClientVpnRoutesInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeClientVpnRoutesInputOperationOutputAlias =
    crate::operation::DescribeClientVpnRoutes;
#[doc(hidden)]
pub type DescribeClientVpnRoutesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeClientVpnRoutesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeClientVpnRoutes`](crate::operation::DescribeClientVpnRoutes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeClientVpnRoutes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_client_vpn_routes(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeClientVpnRoutes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeClientVpnRoutes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeClientVpnRoutesInput`](crate::input::DescribeClientVpnRoutesInput)
    pub fn builder() -> crate::input::describe_client_vpn_routes_input::Builder {
        crate::input::describe_client_vpn_routes_input::Builder::default()
    }
}

/// See [`DescribeClientVpnTargetNetworksInput`](crate::input::DescribeClientVpnTargetNetworksInput)
pub mod describe_client_vpn_target_networks_input {
    /// A builder for [`DescribeClientVpnTargetNetworksInput`](crate::input::DescribeClientVpnTargetNetworksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) association_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        pub fn association_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.association_ids.unwrap_or_default();
            v.push(input.into());
            self.association_ids = Some(v);
            self
        }
        pub fn set_association_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.association_ids = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeClientVpnTargetNetworksInput`](crate::input::DescribeClientVpnTargetNetworksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeClientVpnTargetNetworksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeClientVpnTargetNetworksInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                association_ids: self.association_ids,
                max_results: self.max_results,
                next_token: self.next_token,
                filters: self.filters,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeClientVpnTargetNetworksInputOperationOutputAlias =
    crate::operation::DescribeClientVpnTargetNetworks;
#[doc(hidden)]
pub type DescribeClientVpnTargetNetworksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeClientVpnTargetNetworksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeClientVpnTargetNetworks`](crate::operation::DescribeClientVpnTargetNetworks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeClientVpnTargetNetworks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_client_vpn_target_networks(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeClientVpnTargetNetworks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeClientVpnTargetNetworks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeClientVpnTargetNetworksInput`](crate::input::DescribeClientVpnTargetNetworksInput)
    pub fn builder() -> crate::input::describe_client_vpn_target_networks_input::Builder {
        crate::input::describe_client_vpn_target_networks_input::Builder::default()
    }
}

/// See [`DescribeCoipPoolsInput`](crate::input::DescribeCoipPoolsInput)
pub mod describe_coip_pools_input {
    /// A builder for [`DescribeCoipPoolsInput`](crate::input::DescribeCoipPoolsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) pool_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn pool_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.pool_ids.unwrap_or_default();
            v.push(input.into());
            self.pool_ids = Some(v);
            self
        }
        pub fn set_pool_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.pool_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeCoipPoolsInput`](crate::input::DescribeCoipPoolsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeCoipPoolsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeCoipPoolsInput {
                pool_ids: self.pool_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeCoipPoolsInputOperationOutputAlias = crate::operation::DescribeCoipPools;
#[doc(hidden)]
pub type DescribeCoipPoolsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeCoipPoolsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeCoipPools`](crate::operation::DescribeCoipPools)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeCoipPools,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_coip_pools(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeCoipPools::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeCoipPools",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeCoipPoolsInput`](crate::input::DescribeCoipPoolsInput)
    pub fn builder() -> crate::input::describe_coip_pools_input::Builder {
        crate::input::describe_coip_pools_input::Builder::default()
    }
}

/// See [`DescribeConversionTasksInput`](crate::input::DescribeConversionTasksInput)
pub mod describe_conversion_tasks_input {
    /// A builder for [`DescribeConversionTasksInput`](crate::input::DescribeConversionTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) conversion_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn conversion_task_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.conversion_task_ids.unwrap_or_default();
            v.push(input.into());
            self.conversion_task_ids = Some(v);
            self
        }
        pub fn set_conversion_task_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.conversion_task_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeConversionTasksInput`](crate::input::DescribeConversionTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeConversionTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeConversionTasksInput {
                conversion_task_ids: self.conversion_task_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeConversionTasksInputOperationOutputAlias =
    crate::operation::DescribeConversionTasks;
#[doc(hidden)]
pub type DescribeConversionTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeConversionTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeConversionTasks`](crate::operation::DescribeConversionTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeConversionTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_conversion_tasks(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeConversionTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeConversionTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeConversionTasksInput`](crate::input::DescribeConversionTasksInput)
    pub fn builder() -> crate::input::describe_conversion_tasks_input::Builder {
        crate::input::describe_conversion_tasks_input::Builder::default()
    }
}

/// See [`DescribeCustomerGatewaysInput`](crate::input::DescribeCustomerGatewaysInput)
pub mod describe_customer_gateways_input {
    /// A builder for [`DescribeCustomerGatewaysInput`](crate::input::DescribeCustomerGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) customer_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn customer_gateway_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.customer_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.customer_gateway_ids = Some(v);
            self
        }
        pub fn set_customer_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.customer_gateway_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeCustomerGatewaysInput`](crate::input::DescribeCustomerGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeCustomerGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeCustomerGatewaysInput {
                customer_gateway_ids: self.customer_gateway_ids,
                filters: self.filters,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeCustomerGatewaysInputOperationOutputAlias =
    crate::operation::DescribeCustomerGateways;
#[doc(hidden)]
pub type DescribeCustomerGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeCustomerGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeCustomerGateways`](crate::operation::DescribeCustomerGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeCustomerGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_customer_gateways(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeCustomerGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeCustomerGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeCustomerGatewaysInput`](crate::input::DescribeCustomerGatewaysInput)
    pub fn builder() -> crate::input::describe_customer_gateways_input::Builder {
        crate::input::describe_customer_gateways_input::Builder::default()
    }
}

/// See [`DescribeDhcpOptionsInput`](crate::input::DescribeDhcpOptionsInput)
pub mod describe_dhcp_options_input {
    /// A builder for [`DescribeDhcpOptionsInput`](crate::input::DescribeDhcpOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dhcp_options_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn dhcp_options_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.dhcp_options_ids.unwrap_or_default();
            v.push(input.into());
            self.dhcp_options_ids = Some(v);
            self
        }
        pub fn set_dhcp_options_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.dhcp_options_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeDhcpOptionsInput`](crate::input::DescribeDhcpOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeDhcpOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeDhcpOptionsInput {
                dhcp_options_ids: self.dhcp_options_ids,
                filters: self.filters,
                dry_run: self.dry_run,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeDhcpOptionsInputOperationOutputAlias = crate::operation::DescribeDhcpOptions;
#[doc(hidden)]
pub type DescribeDhcpOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeDhcpOptionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeDhcpOptions`](crate::operation::DescribeDhcpOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeDhcpOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_dhcp_options(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeDhcpOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeDhcpOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeDhcpOptionsInput`](crate::input::DescribeDhcpOptionsInput)
    pub fn builder() -> crate::input::describe_dhcp_options_input::Builder {
        crate::input::describe_dhcp_options_input::Builder::default()
    }
}

/// See [`DescribeEgressOnlyInternetGatewaysInput`](crate::input::DescribeEgressOnlyInternetGatewaysInput)
pub mod describe_egress_only_internet_gateways_input {
    /// A builder for [`DescribeEgressOnlyInternetGatewaysInput`](crate::input::DescribeEgressOnlyInternetGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) egress_only_internet_gateway_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn egress_only_internet_gateway_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.egress_only_internet_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.egress_only_internet_gateway_ids = Some(v);
            self
        }
        pub fn set_egress_only_internet_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.egress_only_internet_gateway_ids = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeEgressOnlyInternetGatewaysInput`](crate::input::DescribeEgressOnlyInternetGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeEgressOnlyInternetGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeEgressOnlyInternetGatewaysInput {
                dry_run: self.dry_run,
                egress_only_internet_gateway_ids: self.egress_only_internet_gateway_ids,
                max_results: self.max_results,
                next_token: self.next_token,
                filters: self.filters,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeEgressOnlyInternetGatewaysInputOperationOutputAlias =
    crate::operation::DescribeEgressOnlyInternetGateways;
#[doc(hidden)]
pub type DescribeEgressOnlyInternetGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeEgressOnlyInternetGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeEgressOnlyInternetGateways`](crate::operation::DescribeEgressOnlyInternetGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeEgressOnlyInternetGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_egress_only_internet_gateways(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeEgressOnlyInternetGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeEgressOnlyInternetGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeEgressOnlyInternetGatewaysInput`](crate::input::DescribeEgressOnlyInternetGatewaysInput)
    pub fn builder() -> crate::input::describe_egress_only_internet_gateways_input::Builder {
        crate::input::describe_egress_only_internet_gateways_input::Builder::default()
    }
}

/// See [`DescribeElasticGpusInput`](crate::input::DescribeElasticGpusInput)
pub mod describe_elastic_gpus_input {
    /// A builder for [`DescribeElasticGpusInput`](crate::input::DescribeElasticGpusInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) elastic_gpu_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn elastic_gpu_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.elastic_gpu_ids.unwrap_or_default();
            v.push(input.into());
            self.elastic_gpu_ids = Some(v);
            self
        }
        pub fn set_elastic_gpu_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.elastic_gpu_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value. This value
        /// can be between 5 and 1000.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeElasticGpusInput`](crate::input::DescribeElasticGpusInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeElasticGpusInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeElasticGpusInput {
                elastic_gpu_ids: self.elastic_gpu_ids,
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeElasticGpusInputOperationOutputAlias = crate::operation::DescribeElasticGpus;
#[doc(hidden)]
pub type DescribeElasticGpusInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeElasticGpusInput {
    /// Consumes the builder and constructs an Operation<[`DescribeElasticGpus`](crate::operation::DescribeElasticGpus)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeElasticGpus,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_elastic_gpus(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeElasticGpus::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeElasticGpus",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeElasticGpusInput`](crate::input::DescribeElasticGpusInput)
    pub fn builder() -> crate::input::describe_elastic_gpus_input::Builder {
        crate::input::describe_elastic_gpus_input::Builder::default()
    }
}

/// See [`DescribeExportImageTasksInput`](crate::input::DescribeExportImageTasksInput)
pub mod describe_export_image_tasks_input {
    /// A builder for [`DescribeExportImageTasksInput`](crate::input::DescribeExportImageTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) export_image_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn export_image_task_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.export_image_task_ids.unwrap_or_default();
            v.push(input.into());
            self.export_image_task_ids = Some(v);
            self
        }
        pub fn set_export_image_task_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.export_image_task_ids = input;
            self
        }
        /// <p>The maximum number of results to return in a single call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>A token that indicates the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeExportImageTasksInput`](crate::input::DescribeExportImageTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeExportImageTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeExportImageTasksInput {
                dry_run: self.dry_run,
                filters: self.filters,
                export_image_task_ids: self.export_image_task_ids,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeExportImageTasksInputOperationOutputAlias =
    crate::operation::DescribeExportImageTasks;
#[doc(hidden)]
pub type DescribeExportImageTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeExportImageTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeExportImageTasks`](crate::operation::DescribeExportImageTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeExportImageTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_export_image_tasks(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeExportImageTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeExportImageTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeExportImageTasksInput`](crate::input::DescribeExportImageTasksInput)
    pub fn builder() -> crate::input::describe_export_image_tasks_input::Builder {
        crate::input::describe_export_image_tasks_input::Builder::default()
    }
}

/// See [`DescribeExportTasksInput`](crate::input::DescribeExportTasksInput)
pub mod describe_export_tasks_input {
    /// A builder for [`DescribeExportTasksInput`](crate::input::DescribeExportTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) export_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    }
    impl Builder {
        pub fn export_task_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.export_task_ids.unwrap_or_default();
            v.push(input.into());
            self.export_task_ids = Some(v);
            self
        }
        pub fn set_export_task_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.export_task_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeExportTasksInput`](crate::input::DescribeExportTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeExportTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeExportTasksInput {
                export_task_ids: self.export_task_ids,
                filters: self.filters,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeExportTasksInputOperationOutputAlias = crate::operation::DescribeExportTasks;
#[doc(hidden)]
pub type DescribeExportTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeExportTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeExportTasks`](crate::operation::DescribeExportTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeExportTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_export_tasks(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeExportTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeExportTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeExportTasksInput`](crate::input::DescribeExportTasksInput)
    pub fn builder() -> crate::input::describe_export_tasks_input::Builder {
        crate::input::describe_export_tasks_input::Builder::default()
    }
}

/// See [`DescribeFastSnapshotRestoresInput`](crate::input::DescribeFastSnapshotRestoresInput)
pub mod describe_fast_snapshot_restores_input {
    /// A builder for [`DescribeFastSnapshotRestoresInput`](crate::input::DescribeFastSnapshotRestoresInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeFastSnapshotRestoresInput`](crate::input::DescribeFastSnapshotRestoresInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeFastSnapshotRestoresInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeFastSnapshotRestoresInput {
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeFastSnapshotRestoresInputOperationOutputAlias =
    crate::operation::DescribeFastSnapshotRestores;
#[doc(hidden)]
pub type DescribeFastSnapshotRestoresInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeFastSnapshotRestoresInput {
    /// Consumes the builder and constructs an Operation<[`DescribeFastSnapshotRestores`](crate::operation::DescribeFastSnapshotRestores)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeFastSnapshotRestores,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_fast_snapshot_restores(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeFastSnapshotRestores::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeFastSnapshotRestores",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeFastSnapshotRestoresInput`](crate::input::DescribeFastSnapshotRestoresInput)
    pub fn builder() -> crate::input::describe_fast_snapshot_restores_input::Builder {
        crate::input::describe_fast_snapshot_restores_input::Builder::default()
    }
}

/// See [`DescribeFleetHistoryInput`](crate::input::DescribeFleetHistoryInput)
pub mod describe_fleet_history_input {
    /// A builder for [`DescribeFleetHistoryInput`](crate::input::DescribeFleetHistoryInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) event_type: std::option::Option<crate::model::FleetEventType>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) fleet_id: std::option::Option<std::string::String>,
        pub(crate) start_time: std::option::Option<smithy_types::Instant>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The type of events to describe. By default, all events are described.</p>
        pub fn event_type(mut self, input: crate::model::FleetEventType) -> Self {
            self.event_type = Some(input);
            self
        }
        pub fn set_event_type(
            mut self,
            input: std::option::Option<crate::model::FleetEventType>,
        ) -> Self {
            self.event_type = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 1 and
        /// 1000. The default value is 1000. To retrieve the remaining results, make another call with
        /// the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The ID of the EC2 Fleet.</p>
        pub fn fleet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.fleet_id = Some(input.into());
            self
        }
        pub fn set_fleet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.fleet_id = input;
            self
        }
        /// <p>The start date and time for the events, in UTC format (for example,
        /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
        pub fn start_time(mut self, input: smithy_types::Instant) -> Self {
            self.start_time = Some(input);
            self
        }
        pub fn set_start_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.start_time = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeFleetHistoryInput`](crate::input::DescribeFleetHistoryInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeFleetHistoryInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeFleetHistoryInput {
                dry_run: self.dry_run,
                event_type: self.event_type,
                max_results: self.max_results,
                next_token: self.next_token,
                fleet_id: self.fleet_id,
                start_time: self.start_time,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeFleetHistoryInputOperationOutputAlias = crate::operation::DescribeFleetHistory;
#[doc(hidden)]
pub type DescribeFleetHistoryInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeFleetHistoryInput {
    /// Consumes the builder and constructs an Operation<[`DescribeFleetHistory`](crate::operation::DescribeFleetHistory)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeFleetHistory,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_fleet_history(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeFleetHistory::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeFleetHistory",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeFleetHistoryInput`](crate::input::DescribeFleetHistoryInput)
    pub fn builder() -> crate::input::describe_fleet_history_input::Builder {
        crate::input::describe_fleet_history_input::Builder::default()
    }
}

/// See [`DescribeFleetInstancesInput`](crate::input::DescribeFleetInstancesInput)
pub mod describe_fleet_instances_input {
    /// A builder for [`DescribeFleetInstancesInput`](crate::input::DescribeFleetInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) fleet_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 1 and
        /// 1000. The default value is 1000. To retrieve the remaining results, make another call with
        /// the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The ID of the EC2 Fleet.</p>
        pub fn fleet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.fleet_id = Some(input.into());
            self
        }
        pub fn set_fleet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.fleet_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeFleetInstancesInput`](crate::input::DescribeFleetInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeFleetInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeFleetInstancesInput {
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
                fleet_id: self.fleet_id,
                filters: self.filters,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeFleetInstancesInputOperationOutputAlias = crate::operation::DescribeFleetInstances;
#[doc(hidden)]
pub type DescribeFleetInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeFleetInstancesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeFleetInstances`](crate::operation::DescribeFleetInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeFleetInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_fleet_instances(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeFleetInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeFleetInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeFleetInstancesInput`](crate::input::DescribeFleetInstancesInput)
    pub fn builder() -> crate::input::describe_fleet_instances_input::Builder {
        crate::input::describe_fleet_instances_input::Builder::default()
    }
}

/// See [`DescribeFleetsInput`](crate::input::DescribeFleetsInput)
pub mod describe_fleets_input {
    /// A builder for [`DescribeFleetsInput`](crate::input::DescribeFleetsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) fleet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 1 and
        /// 1000. The default value is 1000. To retrieve the remaining results, make another call with
        /// the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn fleet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.fleet_ids.unwrap_or_default();
            v.push(input.into());
            self.fleet_ids = Some(v);
            self
        }
        pub fn set_fleet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.fleet_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeFleetsInput`](crate::input::DescribeFleetsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeFleetsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeFleetsInput {
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
                fleet_ids: self.fleet_ids,
                filters: self.filters,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeFleetsInputOperationOutputAlias = crate::operation::DescribeFleets;
#[doc(hidden)]
pub type DescribeFleetsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeFleetsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeFleets`](crate::operation::DescribeFleets)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeFleets,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_fleets(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeFleets::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeFleets",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeFleetsInput`](crate::input::DescribeFleetsInput)
    pub fn builder() -> crate::input::describe_fleets_input::Builder {
        crate::input::describe_fleets_input::Builder::default()
    }
}

/// See [`DescribeFlowLogsInput`](crate::input::DescribeFlowLogsInput)
pub mod describe_flow_logs_input {
    /// A builder for [`DescribeFlowLogsInput`](crate::input::DescribeFlowLogsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) flow_log_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filter(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filter.unwrap_or_default();
            v.push(input.into());
            self.filter = Some(v);
            self
        }
        pub fn set_filter(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filter = input;
            self
        }
        pub fn flow_log_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.flow_log_ids.unwrap_or_default();
            v.push(input.into());
            self.flow_log_ids = Some(v);
            self
        }
        pub fn set_flow_log_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.flow_log_ids = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeFlowLogsInput`](crate::input::DescribeFlowLogsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeFlowLogsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeFlowLogsInput {
                dry_run: self.dry_run,
                filter: self.filter,
                flow_log_ids: self.flow_log_ids,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeFlowLogsInputOperationOutputAlias = crate::operation::DescribeFlowLogs;
#[doc(hidden)]
pub type DescribeFlowLogsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeFlowLogsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeFlowLogs`](crate::operation::DescribeFlowLogs)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeFlowLogs,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_flow_logs(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeFlowLogs::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeFlowLogs",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeFlowLogsInput`](crate::input::DescribeFlowLogsInput)
    pub fn builder() -> crate::input::describe_flow_logs_input::Builder {
        crate::input::describe_flow_logs_input::Builder::default()
    }
}

/// See [`DescribeFpgaImageAttributeInput`](crate::input::DescribeFpgaImageAttributeInput)
pub mod describe_fpga_image_attribute_input {
    /// A builder for [`DescribeFpgaImageAttributeInput`](crate::input::DescribeFpgaImageAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) fpga_image_id: std::option::Option<std::string::String>,
        pub(crate) attribute: std::option::Option<crate::model::FpgaImageAttributeName>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the AFI.</p>
        pub fn fpga_image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.fpga_image_id = Some(input.into());
            self
        }
        pub fn set_fpga_image_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.fpga_image_id = input;
            self
        }
        /// <p>The AFI attribute.</p>
        pub fn attribute(mut self, input: crate::model::FpgaImageAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::FpgaImageAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeFpgaImageAttributeInput`](crate::input::DescribeFpgaImageAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeFpgaImageAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeFpgaImageAttributeInput {
                dry_run: self.dry_run,
                fpga_image_id: self.fpga_image_id,
                attribute: self.attribute,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeFpgaImageAttributeInputOperationOutputAlias =
    crate::operation::DescribeFpgaImageAttribute;
#[doc(hidden)]
pub type DescribeFpgaImageAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeFpgaImageAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeFpgaImageAttribute`](crate::operation::DescribeFpgaImageAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeFpgaImageAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_fpga_image_attribute(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeFpgaImageAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeFpgaImageAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeFpgaImageAttributeInput`](crate::input::DescribeFpgaImageAttributeInput)
    pub fn builder() -> crate::input::describe_fpga_image_attribute_input::Builder {
        crate::input::describe_fpga_image_attribute_input::Builder::default()
    }
}

/// See [`DescribeFpgaImagesInput`](crate::input::DescribeFpgaImagesInput)
pub mod describe_fpga_images_input {
    /// A builder for [`DescribeFpgaImagesInput`](crate::input::DescribeFpgaImagesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) fpga_image_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) owners: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn fpga_image_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.fpga_image_ids.unwrap_or_default();
            v.push(input.into());
            self.fpga_image_ids = Some(v);
            self
        }
        pub fn set_fpga_image_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.fpga_image_ids = input;
            self
        }
        pub fn owners(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.owners.unwrap_or_default();
            v.push(input.into());
            self.owners = Some(v);
            self
        }
        pub fn set_owners(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.owners = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return in a single call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeFpgaImagesInput`](crate::input::DescribeFpgaImagesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeFpgaImagesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeFpgaImagesInput {
                dry_run: self.dry_run,
                fpga_image_ids: self.fpga_image_ids,
                owners: self.owners,
                filters: self.filters,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeFpgaImagesInputOperationOutputAlias = crate::operation::DescribeFpgaImages;
#[doc(hidden)]
pub type DescribeFpgaImagesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeFpgaImagesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeFpgaImages`](crate::operation::DescribeFpgaImages)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeFpgaImages,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_fpga_images(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeFpgaImages::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeFpgaImages",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeFpgaImagesInput`](crate::input::DescribeFpgaImagesInput)
    pub fn builder() -> crate::input::describe_fpga_images_input::Builder {
        crate::input::describe_fpga_images_input::Builder::default()
    }
}

/// See [`DescribeHostReservationOfferingsInput`](crate::input::DescribeHostReservationOfferingsInput)
pub mod describe_host_reservation_offerings_input {
    /// A builder for [`DescribeHostReservationOfferingsInput`](crate::input::DescribeHostReservationOfferingsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_duration: std::option::Option<i32>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) min_duration: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) offering_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filter(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filter.unwrap_or_default();
            v.push(input.into());
            self.filter = Some(v);
            self
        }
        pub fn set_filter(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filter = input;
            self
        }
        /// <p>This is the maximum duration of the reservation to purchase, specified in seconds.
        /// Reservations are available in one-year and three-year terms. The number of seconds
        /// specified must be the number of seconds in a year (365x24x60x60) times one of the
        /// supported durations (1 or 3). For example, specify 94608000 for three years.</p>
        pub fn max_duration(mut self, input: i32) -> Self {
            self.max_duration = Some(input);
            self
        }
        pub fn set_max_duration(mut self, input: std::option::Option<i32>) -> Self {
            self.max_duration = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>This is the minimum duration of the reservation you'd like to purchase, specified
        /// in seconds. Reservations are available in one-year and three-year terms. The number of
        /// seconds specified must be the number of seconds in a year (365x24x60x60) times one of
        /// the supported durations (1 or 3). For example, specify 31536000 for one year.</p>
        pub fn min_duration(mut self, input: i32) -> Self {
            self.min_duration = Some(input);
            self
        }
        pub fn set_min_duration(mut self, input: std::option::Option<i32>) -> Self {
            self.min_duration = input;
            self
        }
        /// <p>The token to use to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The ID of the reservation offering.</p>
        pub fn offering_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.offering_id = Some(input.into());
            self
        }
        pub fn set_offering_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.offering_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeHostReservationOfferingsInput`](crate::input::DescribeHostReservationOfferingsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeHostReservationOfferingsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeHostReservationOfferingsInput {
                filter: self.filter,
                max_duration: self.max_duration,
                max_results: self.max_results,
                min_duration: self.min_duration,
                next_token: self.next_token,
                offering_id: self.offering_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeHostReservationOfferingsInputOperationOutputAlias =
    crate::operation::DescribeHostReservationOfferings;
#[doc(hidden)]
pub type DescribeHostReservationOfferingsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeHostReservationOfferingsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeHostReservationOfferings`](crate::operation::DescribeHostReservationOfferings)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeHostReservationOfferings,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_host_reservation_offerings(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeHostReservationOfferings::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeHostReservationOfferings",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeHostReservationOfferingsInput`](crate::input::DescribeHostReservationOfferingsInput)
    pub fn builder() -> crate::input::describe_host_reservation_offerings_input::Builder {
        crate::input::describe_host_reservation_offerings_input::Builder::default()
    }
}

/// See [`DescribeHostReservationsInput`](crate::input::DescribeHostReservationsInput)
pub mod describe_host_reservations_input {
    /// A builder for [`DescribeHostReservationsInput`](crate::input::DescribeHostReservationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) host_reservation_id_set: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filter(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filter.unwrap_or_default();
            v.push(input.into());
            self.filter = Some(v);
            self
        }
        pub fn set_filter(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filter = input;
            self
        }
        pub fn host_reservation_id_set(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.host_reservation_id_set.unwrap_or_default();
            v.push(input.into());
            self.host_reservation_id_set = Some(v);
            self
        }
        pub fn set_host_reservation_id_set(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.host_reservation_id_set = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to use to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeHostReservationsInput`](crate::input::DescribeHostReservationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeHostReservationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeHostReservationsInput {
                filter: self.filter,
                host_reservation_id_set: self.host_reservation_id_set,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeHostReservationsInputOperationOutputAlias =
    crate::operation::DescribeHostReservations;
#[doc(hidden)]
pub type DescribeHostReservationsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeHostReservationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeHostReservations`](crate::operation::DescribeHostReservations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeHostReservations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_host_reservations(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeHostReservations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeHostReservations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeHostReservationsInput`](crate::input::DescribeHostReservationsInput)
    pub fn builder() -> crate::input::describe_host_reservations_input::Builder {
        crate::input::describe_host_reservations_input::Builder::default()
    }
}

/// See [`DescribeHostsInput`](crate::input::DescribeHostsInput)
pub mod describe_hosts_input {
    /// A builder for [`DescribeHostsInput`](crate::input::DescribeHostsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) host_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filter(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filter.unwrap_or_default();
            v.push(input.into());
            self.filter = Some(v);
            self
        }
        pub fn set_filter(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filter = input;
            self
        }
        pub fn host_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.host_ids.unwrap_or_default();
            v.push(input.into());
            self.host_ids = Some(v);
            self
        }
        pub fn set_host_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.host_ids = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
        /// <p>You cannot specify this parameter and the host IDs parameter in the same request.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to use to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeHostsInput`](crate::input::DescribeHostsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DescribeHostsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DescribeHostsInput {
                filter: self.filter,
                host_ids: self.host_ids,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeHostsInputOperationOutputAlias = crate::operation::DescribeHosts;
#[doc(hidden)]
pub type DescribeHostsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeHostsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeHosts`](crate::operation::DescribeHosts)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeHosts,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_hosts(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeHosts::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeHosts",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeHostsInput`](crate::input::DescribeHostsInput)
    pub fn builder() -> crate::input::describe_hosts_input::Builder {
        crate::input::describe_hosts_input::Builder::default()
    }
}

/// See [`DescribeIamInstanceProfileAssociationsInput`](crate::input::DescribeIamInstanceProfileAssociationsInput)
pub mod describe_iam_instance_profile_associations_input {
    /// A builder for [`DescribeIamInstanceProfileAssociationsInput`](crate::input::DescribeIamInstanceProfileAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn association_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.association_ids.unwrap_or_default();
            v.push(input.into());
            self.association_ids = Some(v);
            self
        }
        pub fn set_association_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.association_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeIamInstanceProfileAssociationsInput`](crate::input::DescribeIamInstanceProfileAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeIamInstanceProfileAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeIamInstanceProfileAssociationsInput {
                association_ids: self.association_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeIamInstanceProfileAssociationsInputOperationOutputAlias =
    crate::operation::DescribeIamInstanceProfileAssociations;
#[doc(hidden)]
pub type DescribeIamInstanceProfileAssociationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeIamInstanceProfileAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeIamInstanceProfileAssociations`](crate::operation::DescribeIamInstanceProfileAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeIamInstanceProfileAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_iam_instance_profile_associations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeIamInstanceProfileAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeIamInstanceProfileAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeIamInstanceProfileAssociationsInput`](crate::input::DescribeIamInstanceProfileAssociationsInput)
    pub fn builder() -> crate::input::describe_iam_instance_profile_associations_input::Builder {
        crate::input::describe_iam_instance_profile_associations_input::Builder::default()
    }
}

/// See [`DescribeIdentityIdFormatInput`](crate::input::DescribeIdentityIdFormatInput)
pub mod describe_identity_id_format_input {
    /// A builder for [`DescribeIdentityIdFormatInput`](crate::input::DescribeIdentityIdFormatInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) principal_arn: std::option::Option<std::string::String>,
        pub(crate) resource: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ARN of the principal, which can be an IAM role, IAM user, or the root user.</p>
        pub fn principal_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.principal_arn = Some(input.into());
            self
        }
        pub fn set_principal_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.principal_arn = input;
            self
        }
        /// <p>The type of resource: <code>bundle</code> |
        /// <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
        /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
        /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
        /// <code>import-task</code> | <code>instance</code> | <code>internet-gateway</code> |
        /// <code>network-acl</code> | <code>network-acl-association</code> |
        /// <code>network-interface</code> | <code>network-interface-attachment</code> |
        /// <code>prefix-list</code> | <code>reservation</code> | <code>route-table</code> |
        /// <code>route-table-association</code> | <code>security-group</code> |
        /// <code>snapshot</code> | <code>subnet</code> |
        /// <code>subnet-cidr-block-association</code> | <code>volume</code> | <code>vpc</code>
        /// | <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> |
        /// <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>
        /// </p>
        pub fn resource(mut self, input: impl Into<std::string::String>) -> Self {
            self.resource = Some(input.into());
            self
        }
        pub fn set_resource(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.resource = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeIdentityIdFormatInput`](crate::input::DescribeIdentityIdFormatInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeIdentityIdFormatInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeIdentityIdFormatInput {
                principal_arn: self.principal_arn,
                resource: self.resource,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeIdentityIdFormatInputOperationOutputAlias =
    crate::operation::DescribeIdentityIdFormat;
#[doc(hidden)]
pub type DescribeIdentityIdFormatInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeIdentityIdFormatInput {
    /// Consumes the builder and constructs an Operation<[`DescribeIdentityIdFormat`](crate::operation::DescribeIdentityIdFormat)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeIdentityIdFormat,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_identity_id_format(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeIdentityIdFormat::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeIdentityIdFormat",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeIdentityIdFormatInput`](crate::input::DescribeIdentityIdFormatInput)
    pub fn builder() -> crate::input::describe_identity_id_format_input::Builder {
        crate::input::describe_identity_id_format_input::Builder::default()
    }
}

/// See [`DescribeIdFormatInput`](crate::input::DescribeIdFormatInput)
pub mod describe_id_format_input {
    /// A builder for [`DescribeIdFormatInput`](crate::input::DescribeIdFormatInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) resource: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The type of resource: <code>bundle</code> |
        /// <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
        /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
        /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
        /// <code>import-task</code> | <code>instance</code> | <code>internet-gateway</code> |
        /// <code>network-acl</code> | <code>network-acl-association</code> |
        /// <code>network-interface</code> | <code>network-interface-attachment</code> |
        /// <code>prefix-list</code> | <code>reservation</code> | <code>route-table</code> |
        /// <code>route-table-association</code> | <code>security-group</code> |
        /// <code>snapshot</code> | <code>subnet</code> |
        /// <code>subnet-cidr-block-association</code> | <code>volume</code> | <code>vpc</code>
        /// | <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> |
        /// <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>
        /// </p>
        pub fn resource(mut self, input: impl Into<std::string::String>) -> Self {
            self.resource = Some(input.into());
            self
        }
        pub fn set_resource(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.resource = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeIdFormatInput`](crate::input::DescribeIdFormatInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeIdFormatInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeIdFormatInput {
                resource: self.resource,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeIdFormatInputOperationOutputAlias = crate::operation::DescribeIdFormat;
#[doc(hidden)]
pub type DescribeIdFormatInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeIdFormatInput {
    /// Consumes the builder and constructs an Operation<[`DescribeIdFormat`](crate::operation::DescribeIdFormat)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeIdFormat,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_id_format(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeIdFormat::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeIdFormat",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeIdFormatInput`](crate::input::DescribeIdFormatInput)
    pub fn builder() -> crate::input::describe_id_format_input::Builder {
        crate::input::describe_id_format_input::Builder::default()
    }
}

/// See [`DescribeImageAttributeInput`](crate::input::DescribeImageAttributeInput)
pub mod describe_image_attribute_input {
    /// A builder for [`DescribeImageAttributeInput`](crate::input::DescribeImageAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::ImageAttributeName>,
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The AMI attribute.</p>
        /// <p>
        /// <b>Note</b>: The <code>blockDeviceMapping</code> attribute is deprecated.
        /// Using this attribute returns the <code>Client.AuthFailure</code> error. To get information about
        /// the block device mappings for an AMI, use the <a>DescribeImages</a> action.</p>
        pub fn attribute(mut self, input: crate::model::ImageAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::ImageAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The ID of the AMI.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeImageAttributeInput`](crate::input::DescribeImageAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeImageAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeImageAttributeInput {
                attribute: self.attribute,
                image_id: self.image_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeImageAttributeInputOperationOutputAlias = crate::operation::DescribeImageAttribute;
#[doc(hidden)]
pub type DescribeImageAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeImageAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeImageAttribute`](crate::operation::DescribeImageAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeImageAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_image_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeImageAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeImageAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeImageAttributeInput`](crate::input::DescribeImageAttributeInput)
    pub fn builder() -> crate::input::describe_image_attribute_input::Builder {
        crate::input::describe_image_attribute_input::Builder::default()
    }
}

/// See [`DescribeImagesInput`](crate::input::DescribeImagesInput)
pub mod describe_images_input {
    /// A builder for [`DescribeImagesInput`](crate::input::DescribeImagesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) executable_users: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) image_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) owners: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) include_deprecated: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn executable_users(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.executable_users.unwrap_or_default();
            v.push(input.into());
            self.executable_users = Some(v);
            self
        }
        pub fn set_executable_users(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.executable_users = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn image_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.image_ids.unwrap_or_default();
            v.push(input.into());
            self.image_ids = Some(v);
            self
        }
        pub fn set_image_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.image_ids = input;
            self
        }
        pub fn owners(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.owners.unwrap_or_default();
            v.push(input.into());
            self.owners = Some(v);
            self
        }
        pub fn set_owners(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.owners = input;
            self
        }
        /// <p>If <code>true</code>, all deprecated AMIs are included in the response. If
        /// <code>false</code>, no deprecated AMIs are included in the response. If no value is
        /// specified, the default value is <code>false</code>.</p>
        /// <note>
        /// <p>If you are the AMI owner, all deprecated AMIs appear in the response regardless of the value (<code>true</code> or <code>false</code>) that you set for this parameter.</p>
        /// </note>
        pub fn include_deprecated(mut self, input: bool) -> Self {
            self.include_deprecated = Some(input);
            self
        }
        pub fn set_include_deprecated(mut self, input: std::option::Option<bool>) -> Self {
            self.include_deprecated = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeImagesInput`](crate::input::DescribeImagesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeImagesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeImagesInput {
                executable_users: self.executable_users,
                filters: self.filters,
                image_ids: self.image_ids,
                owners: self.owners,
                include_deprecated: self.include_deprecated,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeImagesInputOperationOutputAlias = crate::operation::DescribeImages;
#[doc(hidden)]
pub type DescribeImagesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeImagesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeImages`](crate::operation::DescribeImages)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeImages,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_images(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeImages::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeImages",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeImagesInput`](crate::input::DescribeImagesInput)
    pub fn builder() -> crate::input::describe_images_input::Builder {
        crate::input::describe_images_input::Builder::default()
    }
}

/// See [`DescribeImportImageTasksInput`](crate::input::DescribeImportImageTasksInput)
pub mod describe_import_image_tasks_input {
    /// A builder for [`DescribeImportImageTasksInput`](crate::input::DescribeImportImageTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) import_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn import_task_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.import_task_ids.unwrap_or_default();
            v.push(input.into());
            self.import_task_ids = Some(v);
            self
        }
        pub fn set_import_task_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.import_task_ids = input;
            self
        }
        /// <p>The maximum number of results to return in a single call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>A token that indicates the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeImportImageTasksInput`](crate::input::DescribeImportImageTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeImportImageTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeImportImageTasksInput {
                dry_run: self.dry_run,
                filters: self.filters,
                import_task_ids: self.import_task_ids,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeImportImageTasksInputOperationOutputAlias =
    crate::operation::DescribeImportImageTasks;
#[doc(hidden)]
pub type DescribeImportImageTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeImportImageTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeImportImageTasks`](crate::operation::DescribeImportImageTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeImportImageTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_import_image_tasks(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeImportImageTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeImportImageTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeImportImageTasksInput`](crate::input::DescribeImportImageTasksInput)
    pub fn builder() -> crate::input::describe_import_image_tasks_input::Builder {
        crate::input::describe_import_image_tasks_input::Builder::default()
    }
}

/// See [`DescribeImportSnapshotTasksInput`](crate::input::DescribeImportSnapshotTasksInput)
pub mod describe_import_snapshot_tasks_input {
    /// A builder for [`DescribeImportSnapshotTasksInput`](crate::input::DescribeImportSnapshotTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) import_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn import_task_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.import_task_ids.unwrap_or_default();
            v.push(input.into());
            self.import_task_ids = Some(v);
            self
        }
        pub fn set_import_task_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.import_task_ids = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining results, make another call
        /// with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>A token that indicates the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeImportSnapshotTasksInput`](crate::input::DescribeImportSnapshotTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeImportSnapshotTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeImportSnapshotTasksInput {
                dry_run: self.dry_run,
                filters: self.filters,
                import_task_ids: self.import_task_ids,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeImportSnapshotTasksInputOperationOutputAlias =
    crate::operation::DescribeImportSnapshotTasks;
#[doc(hidden)]
pub type DescribeImportSnapshotTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeImportSnapshotTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeImportSnapshotTasks`](crate::operation::DescribeImportSnapshotTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeImportSnapshotTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_import_snapshot_tasks(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeImportSnapshotTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeImportSnapshotTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeImportSnapshotTasksInput`](crate::input::DescribeImportSnapshotTasksInput)
    pub fn builder() -> crate::input::describe_import_snapshot_tasks_input::Builder {
        crate::input::describe_import_snapshot_tasks_input::Builder::default()
    }
}

/// See [`DescribeInstanceAttributeInput`](crate::input::DescribeInstanceAttributeInput)
pub mod describe_instance_attribute_input {
    /// A builder for [`DescribeInstanceAttributeInput`](crate::input::DescribeInstanceAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::InstanceAttributeName>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The instance attribute.</p>
        /// <p>Note: The <code>enaSupport</code> attribute is not supported at this time.</p>
        pub fn attribute(mut self, input: crate::model::InstanceAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::InstanceAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInstanceAttributeInput`](crate::input::DescribeInstanceAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInstanceAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeInstanceAttributeInput {
                attribute: self.attribute,
                dry_run: self.dry_run,
                instance_id: self.instance_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeInstanceAttributeInputOperationOutputAlias =
    crate::operation::DescribeInstanceAttribute;
#[doc(hidden)]
pub type DescribeInstanceAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeInstanceAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInstanceAttribute`](crate::operation::DescribeInstanceAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInstanceAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_instance_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInstanceAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInstanceAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInstanceAttributeInput`](crate::input::DescribeInstanceAttributeInput)
    pub fn builder() -> crate::input::describe_instance_attribute_input::Builder {
        crate::input::describe_instance_attribute_input::Builder::default()
    }
}

/// See [`DescribeInstanceCreditSpecificationsInput`](crate::input::DescribeInstanceCreditSpecificationsInput)
pub mod describe_instance_credit_specifications_input {
    /// A builder for [`DescribeInstanceCreditSpecificationsInput`](crate::input::DescribeInstanceCreditSpecificationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value. This value
        /// can be between 5 and 1000. You cannot specify this parameter and the instance IDs
        /// parameter in the same call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInstanceCreditSpecificationsInput`](crate::input::DescribeInstanceCreditSpecificationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInstanceCreditSpecificationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeInstanceCreditSpecificationsInput {
                dry_run: self.dry_run,
                filters: self.filters,
                instance_ids: self.instance_ids,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeInstanceCreditSpecificationsInputOperationOutputAlias =
    crate::operation::DescribeInstanceCreditSpecifications;
#[doc(hidden)]
pub type DescribeInstanceCreditSpecificationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeInstanceCreditSpecificationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInstanceCreditSpecifications`](crate::operation::DescribeInstanceCreditSpecifications)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInstanceCreditSpecifications,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_instance_credit_specifications(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInstanceCreditSpecifications::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInstanceCreditSpecifications",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInstanceCreditSpecificationsInput`](crate::input::DescribeInstanceCreditSpecificationsInput)
    pub fn builder() -> crate::input::describe_instance_credit_specifications_input::Builder {
        crate::input::describe_instance_credit_specifications_input::Builder::default()
    }
}

/// See [`DescribeInstanceEventNotificationAttributesInput`](crate::input::DescribeInstanceEventNotificationAttributesInput)
pub mod describe_instance_event_notification_attributes_input {
    /// A builder for [`DescribeInstanceEventNotificationAttributesInput`](crate::input::DescribeInstanceEventNotificationAttributesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInstanceEventNotificationAttributesInput`](crate::input::DescribeInstanceEventNotificationAttributesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInstanceEventNotificationAttributesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DescribeInstanceEventNotificationAttributesInput {
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DescribeInstanceEventNotificationAttributesInputOperationOutputAlias =
    crate::operation::DescribeInstanceEventNotificationAttributes;
#[doc(hidden)]
pub type DescribeInstanceEventNotificationAttributesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeInstanceEventNotificationAttributesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInstanceEventNotificationAttributes`](crate::operation::DescribeInstanceEventNotificationAttributes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInstanceEventNotificationAttributes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_instance_event_notification_attributes(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInstanceEventNotificationAttributes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInstanceEventNotificationAttributes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInstanceEventNotificationAttributesInput`](crate::input::DescribeInstanceEventNotificationAttributesInput)
    pub fn builder() -> crate::input::describe_instance_event_notification_attributes_input::Builder
    {
        crate::input::describe_instance_event_notification_attributes_input::Builder::default()
    }
}

/// See [`DescribeInstancesInput`](crate::input::DescribeInstancesInput)
pub mod describe_instances_input {
    /// A builder for [`DescribeInstancesInput`](crate::input::DescribeInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value. This value
        /// can be between 5 and 1000. You cannot specify this parameter and the instance IDs
        /// parameter in the same call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInstancesInput`](crate::input::DescribeInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeInstancesInput {
                filters: self.filters,
                instance_ids: self.instance_ids,
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeInstancesInputOperationOutputAlias = crate::operation::DescribeInstances;
#[doc(hidden)]
pub type DescribeInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeInstancesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInstances`](crate::operation::DescribeInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_instances(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInstancesInput`](crate::input::DescribeInstancesInput)
    pub fn builder() -> crate::input::describe_instances_input::Builder {
        crate::input::describe_instances_input::Builder::default()
    }
}

/// See [`DescribeInstanceStatusInput`](crate::input::DescribeInstanceStatusInput)
pub mod describe_instance_status_input {
    /// A builder for [`DescribeInstanceStatusInput`](crate::input::DescribeInstanceStatusInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) include_all_instances: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value. This value
        /// can be between 5 and 1000. You cannot specify this parameter and the instance IDs
        /// parameter in the same call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>When <code>true</code>, includes the health status for all instances. When
        /// <code>false</code>, includes the health status for running instances only.</p>
        /// <p>Default: <code>false</code>
        /// </p>
        pub fn include_all_instances(mut self, input: bool) -> Self {
            self.include_all_instances = Some(input);
            self
        }
        pub fn set_include_all_instances(mut self, input: std::option::Option<bool>) -> Self {
            self.include_all_instances = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInstanceStatusInput`](crate::input::DescribeInstanceStatusInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInstanceStatusInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeInstanceStatusInput {
                filters: self.filters,
                instance_ids: self.instance_ids,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
                include_all_instances: self.include_all_instances,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeInstanceStatusInputOperationOutputAlias = crate::operation::DescribeInstanceStatus;
#[doc(hidden)]
pub type DescribeInstanceStatusInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeInstanceStatusInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInstanceStatus`](crate::operation::DescribeInstanceStatus)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInstanceStatus,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_instance_status(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInstanceStatus::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInstanceStatus",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInstanceStatusInput`](crate::input::DescribeInstanceStatusInput)
    pub fn builder() -> crate::input::describe_instance_status_input::Builder {
        crate::input::describe_instance_status_input::Builder::default()
    }
}

/// See [`DescribeInstanceTypeOfferingsInput`](crate::input::DescribeInstanceTypeOfferingsInput)
pub mod describe_instance_type_offerings_input {
    /// A builder for [`DescribeInstanceTypeOfferingsInput`](crate::input::DescribeInstanceTypeOfferingsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) location_type: std::option::Option<crate::model::LocationType>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is
        /// <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The location type.</p>
        pub fn location_type(mut self, input: crate::model::LocationType) -> Self {
            self.location_type = Some(input);
            self
        }
        pub fn set_location_type(
            mut self,
            input: std::option::Option<crate::model::LocationType>,
        ) -> Self {
            self.location_type = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results
        /// can be seen by sending another request with the next token value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInstanceTypeOfferingsInput`](crate::input::DescribeInstanceTypeOfferingsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInstanceTypeOfferingsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeInstanceTypeOfferingsInput {
                dry_run: self.dry_run,
                location_type: self.location_type,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeInstanceTypeOfferingsInputOperationOutputAlias =
    crate::operation::DescribeInstanceTypeOfferings;
#[doc(hidden)]
pub type DescribeInstanceTypeOfferingsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeInstanceTypeOfferingsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInstanceTypeOfferings`](crate::operation::DescribeInstanceTypeOfferings)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInstanceTypeOfferings,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_instance_type_offerings(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInstanceTypeOfferings::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInstanceTypeOfferings",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInstanceTypeOfferingsInput`](crate::input::DescribeInstanceTypeOfferingsInput)
    pub fn builder() -> crate::input::describe_instance_type_offerings_input::Builder {
        crate::input::describe_instance_type_offerings_input::Builder::default()
    }
}

/// See [`DescribeInstanceTypesInput`](crate::input::DescribeInstanceTypesInput)
pub mod describe_instance_types_input {
    /// A builder for [`DescribeInstanceTypesInput`](crate::input::DescribeInstanceTypesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_types: std::option::Option<std::vec::Vec<crate::model::InstanceType>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is
        /// <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn instance_types(mut self, input: impl Into<crate::model::InstanceType>) -> Self {
            let mut v = self.instance_types.unwrap_or_default();
            v.push(input.into());
            self.instance_types = Some(v);
            self
        }
        pub fn set_instance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::InstanceType>>,
        ) -> Self {
            self.instance_types = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results
        /// can be seen by sending another request with the next token value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInstanceTypesInput`](crate::input::DescribeInstanceTypesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInstanceTypesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeInstanceTypesInput {
                dry_run: self.dry_run,
                instance_types: self.instance_types,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeInstanceTypesInputOperationOutputAlias = crate::operation::DescribeInstanceTypes;
#[doc(hidden)]
pub type DescribeInstanceTypesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeInstanceTypesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInstanceTypes`](crate::operation::DescribeInstanceTypes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInstanceTypes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_instance_types(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInstanceTypes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInstanceTypes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInstanceTypesInput`](crate::input::DescribeInstanceTypesInput)
    pub fn builder() -> crate::input::describe_instance_types_input::Builder {
        crate::input::describe_instance_types_input::Builder::default()
    }
}

/// See [`DescribeInternetGatewaysInput`](crate::input::DescribeInternetGatewaysInput)
pub mod describe_internet_gateways_input {
    /// A builder for [`DescribeInternetGatewaysInput`](crate::input::DescribeInternetGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) internet_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn internet_gateway_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.internet_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.internet_gateway_ids = Some(v);
            self
        }
        pub fn set_internet_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.internet_gateway_ids = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeInternetGatewaysInput`](crate::input::DescribeInternetGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeInternetGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeInternetGatewaysInput {
                filters: self.filters,
                dry_run: self.dry_run,
                internet_gateway_ids: self.internet_gateway_ids,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeInternetGatewaysInputOperationOutputAlias =
    crate::operation::DescribeInternetGateways;
#[doc(hidden)]
pub type DescribeInternetGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeInternetGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeInternetGateways`](crate::operation::DescribeInternetGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeInternetGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_internet_gateways(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeInternetGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeInternetGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeInternetGatewaysInput`](crate::input::DescribeInternetGatewaysInput)
    pub fn builder() -> crate::input::describe_internet_gateways_input::Builder {
        crate::input::describe_internet_gateways_input::Builder::default()
    }
}

/// See [`DescribeIpv6PoolsInput`](crate::input::DescribeIpv6PoolsInput)
pub mod describe_ipv6_pools_input {
    /// A builder for [`DescribeIpv6PoolsInput`](crate::input::DescribeIpv6PoolsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) pool_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    }
    impl Builder {
        pub fn pool_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.pool_ids.unwrap_or_default();
            v.push(input.into());
            self.pool_ids = Some(v);
            self
        }
        pub fn set_pool_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.pool_ids = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeIpv6PoolsInput`](crate::input::DescribeIpv6PoolsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeIpv6PoolsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeIpv6PoolsInput {
                pool_ids: self.pool_ids,
                next_token: self.next_token,
                max_results: self.max_results,
                dry_run: self.dry_run,
                filters: self.filters,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeIpv6PoolsInputOperationOutputAlias = crate::operation::DescribeIpv6Pools;
#[doc(hidden)]
pub type DescribeIpv6PoolsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeIpv6PoolsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeIpv6Pools`](crate::operation::DescribeIpv6Pools)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeIpv6Pools,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_ipv6_pools(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeIpv6Pools::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeIpv6Pools",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeIpv6PoolsInput`](crate::input::DescribeIpv6PoolsInput)
    pub fn builder() -> crate::input::describe_ipv6_pools_input::Builder {
        crate::input::describe_ipv6_pools_input::Builder::default()
    }
}

/// See [`DescribeKeyPairsInput`](crate::input::DescribeKeyPairsInput)
pub mod describe_key_pairs_input {
    /// A builder for [`DescribeKeyPairsInput`](crate::input::DescribeKeyPairsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) key_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) key_pair_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn key_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.key_names.unwrap_or_default();
            v.push(input.into());
            self.key_names = Some(v);
            self
        }
        pub fn set_key_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.key_names = input;
            self
        }
        pub fn key_pair_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.key_pair_ids.unwrap_or_default();
            v.push(input.into());
            self.key_pair_ids = Some(v);
            self
        }
        pub fn set_key_pair_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.key_pair_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeKeyPairsInput`](crate::input::DescribeKeyPairsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeKeyPairsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeKeyPairsInput {
                filters: self.filters,
                key_names: self.key_names,
                key_pair_ids: self.key_pair_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeKeyPairsInputOperationOutputAlias = crate::operation::DescribeKeyPairs;
#[doc(hidden)]
pub type DescribeKeyPairsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeKeyPairsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeKeyPairs`](crate::operation::DescribeKeyPairs)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeKeyPairs,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_key_pairs(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeKeyPairs::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeKeyPairs",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeKeyPairsInput`](crate::input::DescribeKeyPairsInput)
    pub fn builder() -> crate::input::describe_key_pairs_input::Builder {
        crate::input::describe_key_pairs_input::Builder::default()
    }
}

/// See [`DescribeLaunchTemplatesInput`](crate::input::DescribeLaunchTemplatesInput)
pub mod describe_launch_templates_input {
    /// A builder for [`DescribeLaunchTemplatesInput`](crate::input::DescribeLaunchTemplatesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) launch_template_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) launch_template_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn launch_template_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.launch_template_ids.unwrap_or_default();
            v.push(input.into());
            self.launch_template_ids = Some(v);
            self
        }
        pub fn set_launch_template_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.launch_template_ids = input;
            self
        }
        pub fn launch_template_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.launch_template_names.unwrap_or_default();
            v.push(input.into());
            self.launch_template_names = Some(v);
            self
        }
        pub fn set_launch_template_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.launch_template_names = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value. This value
        /// can be between 1 and 200.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLaunchTemplatesInput`](crate::input::DescribeLaunchTemplatesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLaunchTemplatesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeLaunchTemplatesInput {
                dry_run: self.dry_run,
                launch_template_ids: self.launch_template_ids,
                launch_template_names: self.launch_template_names,
                filters: self.filters,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeLaunchTemplatesInputOperationOutputAlias =
    crate::operation::DescribeLaunchTemplates;
#[doc(hidden)]
pub type DescribeLaunchTemplatesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeLaunchTemplatesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLaunchTemplates`](crate::operation::DescribeLaunchTemplates)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLaunchTemplates,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_launch_templates(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeLaunchTemplates::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeLaunchTemplates",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLaunchTemplatesInput`](crate::input::DescribeLaunchTemplatesInput)
    pub fn builder() -> crate::input::describe_launch_templates_input::Builder {
        crate::input::describe_launch_templates_input::Builder::default()
    }
}

/// See [`DescribeLaunchTemplateVersionsInput`](crate::input::DescribeLaunchTemplateVersionsInput)
pub mod describe_launch_template_versions_input {
    /// A builder for [`DescribeLaunchTemplateVersionsInput`](crate::input::DescribeLaunchTemplateVersionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) launch_template_id: std::option::Option<std::string::String>,
        pub(crate) launch_template_name: std::option::Option<std::string::String>,
        pub(crate) versions: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) min_version: std::option::Option<std::string::String>,
        pub(crate) max_version: std::option::Option<std::string::String>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the launch template. To describe one or more versions of a specified launch
        /// template, you must specify either the launch template ID or the launch template name in
        /// the request. To describe all the latest or default launch template versions in your
        /// account, you must omit this parameter.</p>
        pub fn launch_template_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_id = Some(input.into());
            self
        }
        pub fn set_launch_template_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_id = input;
            self
        }
        /// <p>The name of the launch template. To describe one or more versions of a specified
        /// launch template, you must specify either the launch template ID or the launch template
        /// name in the request. To describe all the latest or default launch template versions in
        /// your account, you must omit this parameter.</p>
        pub fn launch_template_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_name = Some(input.into());
            self
        }
        pub fn set_launch_template_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_name = input;
            self
        }
        pub fn versions(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.versions.unwrap_or_default();
            v.push(input.into());
            self.versions = Some(v);
            self
        }
        pub fn set_versions(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.versions = input;
            self
        }
        /// <p>The version number after which to describe launch template versions.</p>
        pub fn min_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.min_version = Some(input.into());
            self
        }
        pub fn set_min_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.min_version = input;
            self
        }
        /// <p>The version number up to which to describe launch template versions.</p>
        pub fn max_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.max_version = Some(input.into());
            self
        }
        pub fn set_max_version(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.max_version = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value. This value
        /// can be between 1 and 200.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLaunchTemplateVersionsInput`](crate::input::DescribeLaunchTemplateVersionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLaunchTemplateVersionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeLaunchTemplateVersionsInput {
                dry_run: self.dry_run,
                launch_template_id: self.launch_template_id,
                launch_template_name: self.launch_template_name,
                versions: self.versions,
                min_version: self.min_version,
                max_version: self.max_version,
                next_token: self.next_token,
                max_results: self.max_results,
                filters: self.filters,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeLaunchTemplateVersionsInputOperationOutputAlias =
    crate::operation::DescribeLaunchTemplateVersions;
#[doc(hidden)]
pub type DescribeLaunchTemplateVersionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeLaunchTemplateVersionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLaunchTemplateVersions`](crate::operation::DescribeLaunchTemplateVersions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLaunchTemplateVersions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_launch_template_versions(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeLaunchTemplateVersions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeLaunchTemplateVersions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLaunchTemplateVersionsInput`](crate::input::DescribeLaunchTemplateVersionsInput)
    pub fn builder() -> crate::input::describe_launch_template_versions_input::Builder {
        crate::input::describe_launch_template_versions_input::Builder::default()
    }
}

/// See [`DescribeLocalGatewayRouteTablesInput`](crate::input::DescribeLocalGatewayRouteTablesInput)
pub mod describe_local_gateway_route_tables_input {
    /// A builder for [`DescribeLocalGatewayRouteTablesInput`](crate::input::DescribeLocalGatewayRouteTablesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_route_table_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn local_gateway_route_table_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.local_gateway_route_table_ids.unwrap_or_default();
            v.push(input.into());
            self.local_gateway_route_table_ids = Some(v);
            self
        }
        pub fn set_local_gateway_route_table_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.local_gateway_route_table_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLocalGatewayRouteTablesInput`](crate::input::DescribeLocalGatewayRouteTablesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLocalGatewayRouteTablesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeLocalGatewayRouteTablesInput {
                local_gateway_route_table_ids: self.local_gateway_route_table_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeLocalGatewayRouteTablesInputOperationOutputAlias =
    crate::operation::DescribeLocalGatewayRouteTables;
#[doc(hidden)]
pub type DescribeLocalGatewayRouteTablesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeLocalGatewayRouteTablesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLocalGatewayRouteTables`](crate::operation::DescribeLocalGatewayRouteTables)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLocalGatewayRouteTables,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_local_gateway_route_tables(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeLocalGatewayRouteTables::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeLocalGatewayRouteTables",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLocalGatewayRouteTablesInput`](crate::input::DescribeLocalGatewayRouteTablesInput)
    pub fn builder() -> crate::input::describe_local_gateway_route_tables_input::Builder {
        crate::input::describe_local_gateway_route_tables_input::Builder::default()
    }
}

/// See [`DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput)
pub mod describe_local_gateway_route_table_virtual_interface_group_associations_input {
    /// A builder for [`DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_route_table_virtual_interface_group_association_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn local_gateway_route_table_virtual_interface_group_association_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self
                .local_gateway_route_table_virtual_interface_group_association_ids
                .unwrap_or_default();
            v.push(input.into());
            self.local_gateway_route_table_virtual_interface_group_association_ids = Some(v);
            self
        }
        pub fn set_local_gateway_route_table_virtual_interface_group_association_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.local_gateway_route_table_virtual_interface_group_association_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput {
                    local_gateway_route_table_virtual_interface_group_association_ids: self.local_gateway_route_table_virtual_interface_group_association_ids
                    ,
                    filters: self.filters
                    ,
                    max_results: self.max_results
                    ,
                    next_token: self.next_token
                    ,
                    dry_run: self.dry_run
                    ,
                }
            )
        }
    }
}
#[doc(hidden)]
pub type DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInputOperationOutputAlias =
    crate::operation::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations;
#[doc(hidden)]
pub type DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations`](crate::operation::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_local_gateway_route_table_virtual_interface_group_associations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                                    request,
                                    crate::operation::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations::new()
                                ).with_metadata(smithy_http::operation::Metadata::new("DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput)
    pub fn builder() -> crate::input::describe_local_gateway_route_table_virtual_interface_group_associations_input::Builder{
        crate::input::describe_local_gateway_route_table_virtual_interface_group_associations_input::Builder::default()
    }
}

/// See [`DescribeLocalGatewayRouteTableVpcAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVpcAssociationsInput)
pub mod describe_local_gateway_route_table_vpc_associations_input {
    /// A builder for [`DescribeLocalGatewayRouteTableVpcAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVpcAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_route_table_vpc_association_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn local_gateway_route_table_vpc_association_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self
                .local_gateway_route_table_vpc_association_ids
                .unwrap_or_default();
            v.push(input.into());
            self.local_gateway_route_table_vpc_association_ids = Some(v);
            self
        }
        pub fn set_local_gateway_route_table_vpc_association_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.local_gateway_route_table_vpc_association_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLocalGatewayRouteTableVpcAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVpcAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLocalGatewayRouteTableVpcAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DescribeLocalGatewayRouteTableVpcAssociationsInput {
                    local_gateway_route_table_vpc_association_ids: self
                        .local_gateway_route_table_vpc_association_ids,
                    filters: self.filters,
                    max_results: self.max_results,
                    next_token: self.next_token,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DescribeLocalGatewayRouteTableVpcAssociationsInputOperationOutputAlias =
    crate::operation::DescribeLocalGatewayRouteTableVpcAssociations;
#[doc(hidden)]
pub type DescribeLocalGatewayRouteTableVpcAssociationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeLocalGatewayRouteTableVpcAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLocalGatewayRouteTableVpcAssociations`](crate::operation::DescribeLocalGatewayRouteTableVpcAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLocalGatewayRouteTableVpcAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_local_gateway_route_table_vpc_associations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeLocalGatewayRouteTableVpcAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeLocalGatewayRouteTableVpcAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLocalGatewayRouteTableVpcAssociationsInput`](crate::input::DescribeLocalGatewayRouteTableVpcAssociationsInput)
    pub fn builder(
    ) -> crate::input::describe_local_gateway_route_table_vpc_associations_input::Builder {
        crate::input::describe_local_gateway_route_table_vpc_associations_input::Builder::default()
    }
}

/// See [`DescribeLocalGatewaysInput`](crate::input::DescribeLocalGatewaysInput)
pub mod describe_local_gateways_input {
    /// A builder for [`DescribeLocalGatewaysInput`](crate::input::DescribeLocalGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn local_gateway_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.local_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.local_gateway_ids = Some(v);
            self
        }
        pub fn set_local_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.local_gateway_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLocalGatewaysInput`](crate::input::DescribeLocalGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLocalGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeLocalGatewaysInput {
                local_gateway_ids: self.local_gateway_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeLocalGatewaysInputOperationOutputAlias = crate::operation::DescribeLocalGateways;
#[doc(hidden)]
pub type DescribeLocalGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeLocalGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLocalGateways`](crate::operation::DescribeLocalGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLocalGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_local_gateways(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeLocalGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeLocalGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLocalGatewaysInput`](crate::input::DescribeLocalGatewaysInput)
    pub fn builder() -> crate::input::describe_local_gateways_input::Builder {
        crate::input::describe_local_gateways_input::Builder::default()
    }
}

/// See [`DescribeLocalGatewayVirtualInterfaceGroupsInput`](crate::input::DescribeLocalGatewayVirtualInterfaceGroupsInput)
pub mod describe_local_gateway_virtual_interface_groups_input {
    /// A builder for [`DescribeLocalGatewayVirtualInterfaceGroupsInput`](crate::input::DescribeLocalGatewayVirtualInterfaceGroupsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_virtual_interface_group_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn local_gateway_virtual_interface_group_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self
                .local_gateway_virtual_interface_group_ids
                .unwrap_or_default();
            v.push(input.into());
            self.local_gateway_virtual_interface_group_ids = Some(v);
            self
        }
        pub fn set_local_gateway_virtual_interface_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.local_gateway_virtual_interface_group_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLocalGatewayVirtualInterfaceGroupsInput`](crate::input::DescribeLocalGatewayVirtualInterfaceGroupsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLocalGatewayVirtualInterfaceGroupsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DescribeLocalGatewayVirtualInterfaceGroupsInput {
                    local_gateway_virtual_interface_group_ids: self
                        .local_gateway_virtual_interface_group_ids,
                    filters: self.filters,
                    max_results: self.max_results,
                    next_token: self.next_token,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DescribeLocalGatewayVirtualInterfaceGroupsInputOperationOutputAlias =
    crate::operation::DescribeLocalGatewayVirtualInterfaceGroups;
#[doc(hidden)]
pub type DescribeLocalGatewayVirtualInterfaceGroupsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeLocalGatewayVirtualInterfaceGroupsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLocalGatewayVirtualInterfaceGroups`](crate::operation::DescribeLocalGatewayVirtualInterfaceGroups)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLocalGatewayVirtualInterfaceGroups,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_local_gateway_virtual_interface_groups(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeLocalGatewayVirtualInterfaceGroups::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeLocalGatewayVirtualInterfaceGroups",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLocalGatewayVirtualInterfaceGroupsInput`](crate::input::DescribeLocalGatewayVirtualInterfaceGroupsInput)
    pub fn builder() -> crate::input::describe_local_gateway_virtual_interface_groups_input::Builder
    {
        crate::input::describe_local_gateway_virtual_interface_groups_input::Builder::default()
    }
}

/// See [`DescribeLocalGatewayVirtualInterfacesInput`](crate::input::DescribeLocalGatewayVirtualInterfacesInput)
pub mod describe_local_gateway_virtual_interfaces_input {
    /// A builder for [`DescribeLocalGatewayVirtualInterfacesInput`](crate::input::DescribeLocalGatewayVirtualInterfacesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_virtual_interface_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn local_gateway_virtual_interface_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.local_gateway_virtual_interface_ids.unwrap_or_default();
            v.push(input.into());
            self.local_gateway_virtual_interface_ids = Some(v);
            self
        }
        pub fn set_local_gateway_virtual_interface_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.local_gateway_virtual_interface_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeLocalGatewayVirtualInterfacesInput`](crate::input::DescribeLocalGatewayVirtualInterfacesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeLocalGatewayVirtualInterfacesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeLocalGatewayVirtualInterfacesInput {
                local_gateway_virtual_interface_ids: self.local_gateway_virtual_interface_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeLocalGatewayVirtualInterfacesInputOperationOutputAlias =
    crate::operation::DescribeLocalGatewayVirtualInterfaces;
#[doc(hidden)]
pub type DescribeLocalGatewayVirtualInterfacesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeLocalGatewayVirtualInterfacesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeLocalGatewayVirtualInterfaces`](crate::operation::DescribeLocalGatewayVirtualInterfaces)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeLocalGatewayVirtualInterfaces,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_local_gateway_virtual_interfaces(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeLocalGatewayVirtualInterfaces::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeLocalGatewayVirtualInterfaces",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeLocalGatewayVirtualInterfacesInput`](crate::input::DescribeLocalGatewayVirtualInterfacesInput)
    pub fn builder() -> crate::input::describe_local_gateway_virtual_interfaces_input::Builder {
        crate::input::describe_local_gateway_virtual_interfaces_input::Builder::default()
    }
}

/// See [`DescribeManagedPrefixListsInput`](crate::input::DescribeManagedPrefixListsInput)
pub mod describe_managed_prefix_lists_input {
    /// A builder for [`DescribeManagedPrefixListsInput`](crate::input::DescribeManagedPrefixListsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) prefix_list_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn prefix_list_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.prefix_list_ids.unwrap_or_default();
            v.push(input.into());
            self.prefix_list_ids = Some(v);
            self
        }
        pub fn set_prefix_list_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.prefix_list_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeManagedPrefixListsInput`](crate::input::DescribeManagedPrefixListsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeManagedPrefixListsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeManagedPrefixListsInput {
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                prefix_list_ids: self.prefix_list_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeManagedPrefixListsInputOperationOutputAlias =
    crate::operation::DescribeManagedPrefixLists;
#[doc(hidden)]
pub type DescribeManagedPrefixListsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeManagedPrefixListsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeManagedPrefixLists`](crate::operation::DescribeManagedPrefixLists)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeManagedPrefixLists,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_managed_prefix_lists(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeManagedPrefixLists::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeManagedPrefixLists",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeManagedPrefixListsInput`](crate::input::DescribeManagedPrefixListsInput)
    pub fn builder() -> crate::input::describe_managed_prefix_lists_input::Builder {
        crate::input::describe_managed_prefix_lists_input::Builder::default()
    }
}

/// See [`DescribeMovingAddressesInput`](crate::input::DescribeMovingAddressesInput)
pub mod describe_moving_addresses_input {
    /// A builder for [`DescribeMovingAddressesInput`](crate::input::DescribeMovingAddressesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) public_ips: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining
        /// results of the initial request can be seen by sending another request with the returned
        /// <code>NextToken</code> value. This value can be between 5 and 1000; if
        /// <code>MaxResults</code> is given a value outside of this range, an error is returned.</p>
        /// <p>Default: If no value is provided, the default is 1000.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn public_ips(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.public_ips.unwrap_or_default();
            v.push(input.into());
            self.public_ips = Some(v);
            self
        }
        pub fn set_public_ips(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.public_ips = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeMovingAddressesInput`](crate::input::DescribeMovingAddressesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeMovingAddressesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeMovingAddressesInput {
                filters: self.filters,
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
                public_ips: self.public_ips,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeMovingAddressesInputOperationOutputAlias =
    crate::operation::DescribeMovingAddresses;
#[doc(hidden)]
pub type DescribeMovingAddressesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeMovingAddressesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeMovingAddresses`](crate::operation::DescribeMovingAddresses)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeMovingAddresses,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_moving_addresses(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeMovingAddresses::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeMovingAddresses",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeMovingAddressesInput`](crate::input::DescribeMovingAddressesInput)
    pub fn builder() -> crate::input::describe_moving_addresses_input::Builder {
        crate::input::describe_moving_addresses_input::Builder::default()
    }
}

/// See [`DescribeNatGatewaysInput`](crate::input::DescribeNatGatewaysInput)
pub mod describe_nat_gateways_input {
    /// A builder for [`DescribeNatGatewaysInput`](crate::input::DescribeNatGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) nat_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filter(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filter.unwrap_or_default();
            v.push(input.into());
            self.filter = Some(v);
            self
        }
        pub fn set_filter(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filter = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        pub fn nat_gateway_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.nat_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.nat_gateway_ids = Some(v);
            self
        }
        pub fn set_nat_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.nat_gateway_ids = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeNatGatewaysInput`](crate::input::DescribeNatGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeNatGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeNatGatewaysInput {
                dry_run: self.dry_run,
                filter: self.filter,
                max_results: self.max_results,
                nat_gateway_ids: self.nat_gateway_ids,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeNatGatewaysInputOperationOutputAlias = crate::operation::DescribeNatGateways;
#[doc(hidden)]
pub type DescribeNatGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeNatGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeNatGateways`](crate::operation::DescribeNatGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeNatGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_nat_gateways(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeNatGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeNatGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeNatGatewaysInput`](crate::input::DescribeNatGatewaysInput)
    pub fn builder() -> crate::input::describe_nat_gateways_input::Builder {
        crate::input::describe_nat_gateways_input::Builder::default()
    }
}

/// See [`DescribeNetworkAclsInput`](crate::input::DescribeNetworkAclsInput)
pub mod describe_network_acls_input {
    /// A builder for [`DescribeNetworkAclsInput`](crate::input::DescribeNetworkAclsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_acl_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn network_acl_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_acl_ids.unwrap_or_default();
            v.push(input.into());
            self.network_acl_ids = Some(v);
            self
        }
        pub fn set_network_acl_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_acl_ids = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeNetworkAclsInput`](crate::input::DescribeNetworkAclsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeNetworkAclsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeNetworkAclsInput {
                filters: self.filters,
                dry_run: self.dry_run,
                network_acl_ids: self.network_acl_ids,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeNetworkAclsInputOperationOutputAlias = crate::operation::DescribeNetworkAcls;
#[doc(hidden)]
pub type DescribeNetworkAclsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeNetworkAclsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeNetworkAcls`](crate::operation::DescribeNetworkAcls)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeNetworkAcls,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_network_acls(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeNetworkAcls::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeNetworkAcls",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeNetworkAclsInput`](crate::input::DescribeNetworkAclsInput)
    pub fn builder() -> crate::input::describe_network_acls_input::Builder {
        crate::input::describe_network_acls_input::Builder::default()
    }
}

/// See [`DescribeNetworkInsightsAnalysesInput`](crate::input::DescribeNetworkInsightsAnalysesInput)
pub mod describe_network_insights_analyses_input {
    /// A builder for [`DescribeNetworkInsightsAnalysesInput`](crate::input::DescribeNetworkInsightsAnalysesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_insights_analysis_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) network_insights_path_id: std::option::Option<std::string::String>,
        pub(crate) analysis_start_time: std::option::Option<smithy_types::Instant>,
        pub(crate) analysis_end_time: std::option::Option<smithy_types::Instant>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn network_insights_analysis_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.network_insights_analysis_ids.unwrap_or_default();
            v.push(input.into());
            self.network_insights_analysis_ids = Some(v);
            self
        }
        pub fn set_network_insights_analysis_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_insights_analysis_ids = input;
            self
        }
        /// <p>The ID of the path. You must specify either a path ID or analysis IDs.</p>
        pub fn network_insights_path_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_insights_path_id = Some(input.into());
            self
        }
        pub fn set_network_insights_path_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_insights_path_id = input;
            self
        }
        /// <p>The time when the network insights analyses started.</p>
        pub fn analysis_start_time(mut self, input: smithy_types::Instant) -> Self {
            self.analysis_start_time = Some(input);
            self
        }
        pub fn set_analysis_start_time(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.analysis_start_time = input;
            self
        }
        /// <p>The time when the network insights analyses ended.</p>
        pub fn analysis_end_time(mut self, input: smithy_types::Instant) -> Self {
            self.analysis_end_time = Some(input);
            self
        }
        pub fn set_analysis_end_time(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.analysis_end_time = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeNetworkInsightsAnalysesInput`](crate::input::DescribeNetworkInsightsAnalysesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeNetworkInsightsAnalysesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeNetworkInsightsAnalysesInput {
                network_insights_analysis_ids: self.network_insights_analysis_ids,
                network_insights_path_id: self.network_insights_path_id,
                analysis_start_time: self.analysis_start_time,
                analysis_end_time: self.analysis_end_time,
                filters: self.filters,
                max_results: self.max_results,
                dry_run: self.dry_run,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeNetworkInsightsAnalysesInputOperationOutputAlias =
    crate::operation::DescribeNetworkInsightsAnalyses;
#[doc(hidden)]
pub type DescribeNetworkInsightsAnalysesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeNetworkInsightsAnalysesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeNetworkInsightsAnalyses`](crate::operation::DescribeNetworkInsightsAnalyses)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeNetworkInsightsAnalyses,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_network_insights_analyses(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeNetworkInsightsAnalyses::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeNetworkInsightsAnalyses",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeNetworkInsightsAnalysesInput`](crate::input::DescribeNetworkInsightsAnalysesInput)
    pub fn builder() -> crate::input::describe_network_insights_analyses_input::Builder {
        crate::input::describe_network_insights_analyses_input::Builder::default()
    }
}

/// See [`DescribeNetworkInsightsPathsInput`](crate::input::DescribeNetworkInsightsPathsInput)
pub mod describe_network_insights_paths_input {
    /// A builder for [`DescribeNetworkInsightsPathsInput`](crate::input::DescribeNetworkInsightsPathsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_insights_path_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn network_insights_path_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_insights_path_ids.unwrap_or_default();
            v.push(input.into());
            self.network_insights_path_ids = Some(v);
            self
        }
        pub fn set_network_insights_path_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_insights_path_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeNetworkInsightsPathsInput`](crate::input::DescribeNetworkInsightsPathsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeNetworkInsightsPathsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeNetworkInsightsPathsInput {
                network_insights_path_ids: self.network_insights_path_ids,
                filters: self.filters,
                max_results: self.max_results,
                dry_run: self.dry_run,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeNetworkInsightsPathsInputOperationOutputAlias =
    crate::operation::DescribeNetworkInsightsPaths;
#[doc(hidden)]
pub type DescribeNetworkInsightsPathsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeNetworkInsightsPathsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeNetworkInsightsPaths`](crate::operation::DescribeNetworkInsightsPaths)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeNetworkInsightsPaths,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_network_insights_paths(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeNetworkInsightsPaths::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeNetworkInsightsPaths",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeNetworkInsightsPathsInput`](crate::input::DescribeNetworkInsightsPathsInput)
    pub fn builder() -> crate::input::describe_network_insights_paths_input::Builder {
        crate::input::describe_network_insights_paths_input::Builder::default()
    }
}

/// See [`DescribeNetworkInterfaceAttributeInput`](crate::input::DescribeNetworkInterfaceAttributeInput)
pub mod describe_network_interface_attribute_input {
    /// A builder for [`DescribeNetworkInterfaceAttributeInput`](crate::input::DescribeNetworkInterfaceAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::NetworkInterfaceAttribute>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The attribute of the network interface. This parameter is required.</p>
        pub fn attribute(mut self, input: crate::model::NetworkInterfaceAttribute) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::NetworkInterfaceAttribute>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeNetworkInterfaceAttributeInput`](crate::input::DescribeNetworkInterfaceAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeNetworkInterfaceAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeNetworkInterfaceAttributeInput {
                attribute: self.attribute,
                dry_run: self.dry_run,
                network_interface_id: self.network_interface_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeNetworkInterfaceAttributeInputOperationOutputAlias =
    crate::operation::DescribeNetworkInterfaceAttribute;
#[doc(hidden)]
pub type DescribeNetworkInterfaceAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeNetworkInterfaceAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeNetworkInterfaceAttribute`](crate::operation::DescribeNetworkInterfaceAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeNetworkInterfaceAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_network_interface_attribute(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeNetworkInterfaceAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeNetworkInterfaceAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeNetworkInterfaceAttributeInput`](crate::input::DescribeNetworkInterfaceAttributeInput)
    pub fn builder() -> crate::input::describe_network_interface_attribute_input::Builder {
        crate::input::describe_network_interface_attribute_input::Builder::default()
    }
}

/// See [`DescribeNetworkInterfacePermissionsInput`](crate::input::DescribeNetworkInterfacePermissionsInput)
pub mod describe_network_interface_permissions_input {
    /// A builder for [`DescribeNetworkInterfacePermissionsInput`](crate::input::DescribeNetworkInterfacePermissionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_interface_permission_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn network_interface_permission_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.network_interface_permission_ids.unwrap_or_default();
            v.push(input.into());
            self.network_interface_permission_ids = Some(v);
            self
        }
        pub fn set_network_interface_permission_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_interface_permission_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining results,
        /// make another call with the returned <code>NextToken</code> value. If this parameter is not specified, up to 50 results are returned by default.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeNetworkInterfacePermissionsInput`](crate::input::DescribeNetworkInterfacePermissionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeNetworkInterfacePermissionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeNetworkInterfacePermissionsInput {
                network_interface_permission_ids: self.network_interface_permission_ids,
                filters: self.filters,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeNetworkInterfacePermissionsInputOperationOutputAlias =
    crate::operation::DescribeNetworkInterfacePermissions;
#[doc(hidden)]
pub type DescribeNetworkInterfacePermissionsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeNetworkInterfacePermissionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeNetworkInterfacePermissions`](crate::operation::DescribeNetworkInterfacePermissions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeNetworkInterfacePermissions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_network_interface_permissions(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeNetworkInterfacePermissions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeNetworkInterfacePermissions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeNetworkInterfacePermissionsInput`](crate::input::DescribeNetworkInterfacePermissionsInput)
    pub fn builder() -> crate::input::describe_network_interface_permissions_input::Builder {
        crate::input::describe_network_interface_permissions_input::Builder::default()
    }
}

/// See [`DescribeNetworkInterfacesInput`](crate::input::DescribeNetworkInterfacesInput)
pub mod describe_network_interfaces_input {
    /// A builder for [`DescribeNetworkInterfacesInput`](crate::input::DescribeNetworkInterfacesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn network_interface_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_interface_ids.unwrap_or_default();
            v.push(input.into());
            self.network_interface_ids = Some(v);
            self
        }
        pub fn set_network_interface_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_interface_ids = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of items to return for this request. The request returns a token that you
        /// can specify in a subsequent call to get the next set of results. You cannot specify this
        /// parameter and the network interface IDs parameter in the same request.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeNetworkInterfacesInput`](crate::input::DescribeNetworkInterfacesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeNetworkInterfacesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeNetworkInterfacesInput {
                filters: self.filters,
                dry_run: self.dry_run,
                network_interface_ids: self.network_interface_ids,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeNetworkInterfacesInputOperationOutputAlias =
    crate::operation::DescribeNetworkInterfaces;
#[doc(hidden)]
pub type DescribeNetworkInterfacesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeNetworkInterfacesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeNetworkInterfaces`](crate::operation::DescribeNetworkInterfaces)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeNetworkInterfaces,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_network_interfaces(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeNetworkInterfaces::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeNetworkInterfaces",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeNetworkInterfacesInput`](crate::input::DescribeNetworkInterfacesInput)
    pub fn builder() -> crate::input::describe_network_interfaces_input::Builder {
        crate::input::describe_network_interfaces_input::Builder::default()
    }
}

/// See [`DescribePlacementGroupsInput`](crate::input::DescribePlacementGroupsInput)
pub mod describe_placement_groups_input {
    /// A builder for [`DescribePlacementGroupsInput`](crate::input::DescribePlacementGroupsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn group_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.group_names.unwrap_or_default();
            v.push(input.into());
            self.group_names = Some(v);
            self
        }
        pub fn set_group_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.group_names = input;
            self
        }
        pub fn group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.group_ids.unwrap_or_default();
            v.push(input.into());
            self.group_ids = Some(v);
            self
        }
        pub fn set_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.group_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribePlacementGroupsInput`](crate::input::DescribePlacementGroupsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribePlacementGroupsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribePlacementGroupsInput {
                filters: self.filters,
                dry_run: self.dry_run,
                group_names: self.group_names,
                group_ids: self.group_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribePlacementGroupsInputOperationOutputAlias =
    crate::operation::DescribePlacementGroups;
#[doc(hidden)]
pub type DescribePlacementGroupsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribePlacementGroupsInput {
    /// Consumes the builder and constructs an Operation<[`DescribePlacementGroups`](crate::operation::DescribePlacementGroups)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribePlacementGroups,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_placement_groups(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribePlacementGroups::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribePlacementGroups",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribePlacementGroupsInput`](crate::input::DescribePlacementGroupsInput)
    pub fn builder() -> crate::input::describe_placement_groups_input::Builder {
        crate::input::describe_placement_groups_input::Builder::default()
    }
}

/// See [`DescribePrefixListsInput`](crate::input::DescribePrefixListsInput)
pub mod describe_prefix_lists_input {
    /// A builder for [`DescribePrefixListsInput`](crate::input::DescribePrefixListsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) prefix_list_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn prefix_list_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.prefix_list_ids.unwrap_or_default();
            v.push(input.into());
            self.prefix_list_ids = Some(v);
            self
        }
        pub fn set_prefix_list_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.prefix_list_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribePrefixListsInput`](crate::input::DescribePrefixListsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribePrefixListsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribePrefixListsInput {
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                prefix_list_ids: self.prefix_list_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribePrefixListsInputOperationOutputAlias = crate::operation::DescribePrefixLists;
#[doc(hidden)]
pub type DescribePrefixListsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribePrefixListsInput {
    /// Consumes the builder and constructs an Operation<[`DescribePrefixLists`](crate::operation::DescribePrefixLists)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribePrefixLists,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_prefix_lists(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribePrefixLists::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribePrefixLists",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribePrefixListsInput`](crate::input::DescribePrefixListsInput)
    pub fn builder() -> crate::input::describe_prefix_lists_input::Builder {
        crate::input::describe_prefix_lists_input::Builder::default()
    }
}

/// See [`DescribePrincipalIdFormatInput`](crate::input::DescribePrincipalIdFormatInput)
pub mod describe_principal_id_format_input {
    /// A builder for [`DescribePrincipalIdFormatInput`](crate::input::DescribePrincipalIdFormatInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) resources: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn resources(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.resources.unwrap_or_default();
            v.push(input.into());
            self.resources = Some(v);
            self
        }
        pub fn set_resources(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.resources = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned NextToken value. </p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribePrincipalIdFormatInput`](crate::input::DescribePrincipalIdFormatInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribePrincipalIdFormatInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribePrincipalIdFormatInput {
                dry_run: self.dry_run,
                resources: self.resources,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribePrincipalIdFormatInputOperationOutputAlias =
    crate::operation::DescribePrincipalIdFormat;
#[doc(hidden)]
pub type DescribePrincipalIdFormatInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribePrincipalIdFormatInput {
    /// Consumes the builder and constructs an Operation<[`DescribePrincipalIdFormat`](crate::operation::DescribePrincipalIdFormat)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribePrincipalIdFormat,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_principal_id_format(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribePrincipalIdFormat::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribePrincipalIdFormat",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribePrincipalIdFormatInput`](crate::input::DescribePrincipalIdFormatInput)
    pub fn builder() -> crate::input::describe_principal_id_format_input::Builder {
        crate::input::describe_principal_id_format_input::Builder::default()
    }
}

/// See [`DescribePublicIpv4PoolsInput`](crate::input::DescribePublicIpv4PoolsInput)
pub mod describe_public_ipv4_pools_input {
    /// A builder for [`DescribePublicIpv4PoolsInput`](crate::input::DescribePublicIpv4PoolsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) pool_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    }
    impl Builder {
        pub fn pool_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.pool_ids.unwrap_or_default();
            v.push(input.into());
            self.pool_ids = Some(v);
            self
        }
        pub fn set_pool_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.pool_ids = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribePublicIpv4PoolsInput`](crate::input::DescribePublicIpv4PoolsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribePublicIpv4PoolsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribePublicIpv4PoolsInput {
                pool_ids: self.pool_ids,
                next_token: self.next_token,
                max_results: self.max_results,
                filters: self.filters,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribePublicIpv4PoolsInputOperationOutputAlias =
    crate::operation::DescribePublicIpv4Pools;
#[doc(hidden)]
pub type DescribePublicIpv4PoolsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribePublicIpv4PoolsInput {
    /// Consumes the builder and constructs an Operation<[`DescribePublicIpv4Pools`](crate::operation::DescribePublicIpv4Pools)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribePublicIpv4Pools,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_public_ipv4_pools(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribePublicIpv4Pools::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribePublicIpv4Pools",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribePublicIpv4PoolsInput`](crate::input::DescribePublicIpv4PoolsInput)
    pub fn builder() -> crate::input::describe_public_ipv4_pools_input::Builder {
        crate::input::describe_public_ipv4_pools_input::Builder::default()
    }
}

/// See [`DescribeRegionsInput`](crate::input::DescribeRegionsInput)
pub mod describe_regions_input {
    /// A builder for [`DescribeRegionsInput`](crate::input::DescribeRegionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) region_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) all_regions: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn region_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.region_names.unwrap_or_default();
            v.push(input.into());
            self.region_names = Some(v);
            self
        }
        pub fn set_region_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.region_names = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Indicates whether to display all Regions, including Regions that are disabled for your account.</p>
        pub fn all_regions(mut self, input: bool) -> Self {
            self.all_regions = Some(input);
            self
        }
        pub fn set_all_regions(mut self, input: std::option::Option<bool>) -> Self {
            self.all_regions = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeRegionsInput`](crate::input::DescribeRegionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeRegionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeRegionsInput {
                filters: self.filters,
                region_names: self.region_names,
                dry_run: self.dry_run,
                all_regions: self.all_regions,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeRegionsInputOperationOutputAlias = crate::operation::DescribeRegions;
#[doc(hidden)]
pub type DescribeRegionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeRegionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeRegions`](crate::operation::DescribeRegions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeRegions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_regions(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeRegions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeRegions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeRegionsInput`](crate::input::DescribeRegionsInput)
    pub fn builder() -> crate::input::describe_regions_input::Builder {
        crate::input::describe_regions_input::Builder::default()
    }
}

/// See [`DescribeReplaceRootVolumeTasksInput`](crate::input::DescribeReplaceRootVolumeTasksInput)
pub mod describe_replace_root_volume_tasks_input {
    /// A builder for [`DescribeReplaceRootVolumeTasksInput`](crate::input::DescribeReplaceRootVolumeTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) replace_root_volume_task_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn replace_root_volume_task_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.replace_root_volume_task_ids.unwrap_or_default();
            v.push(input.into());
            self.replace_root_volume_task_ids = Some(v);
            self
        }
        pub fn set_replace_root_volume_task_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.replace_root_volume_task_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call. To retrieve the remaining results,
        /// make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeReplaceRootVolumeTasksInput`](crate::input::DescribeReplaceRootVolumeTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeReplaceRootVolumeTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeReplaceRootVolumeTasksInput {
                replace_root_volume_task_ids: self.replace_root_volume_task_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeReplaceRootVolumeTasksInputOperationOutputAlias =
    crate::operation::DescribeReplaceRootVolumeTasks;
#[doc(hidden)]
pub type DescribeReplaceRootVolumeTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeReplaceRootVolumeTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeReplaceRootVolumeTasks`](crate::operation::DescribeReplaceRootVolumeTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeReplaceRootVolumeTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_replace_root_volume_tasks(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeReplaceRootVolumeTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeReplaceRootVolumeTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeReplaceRootVolumeTasksInput`](crate::input::DescribeReplaceRootVolumeTasksInput)
    pub fn builder() -> crate::input::describe_replace_root_volume_tasks_input::Builder {
        crate::input::describe_replace_root_volume_tasks_input::Builder::default()
    }
}

/// See [`DescribeReservedInstancesInput`](crate::input::DescribeReservedInstancesInput)
pub mod describe_reserved_instances_input {
    /// A builder for [`DescribeReservedInstancesInput`](crate::input::DescribeReservedInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) offering_class: std::option::Option<crate::model::OfferingClassType>,
        pub(crate) reserved_instances_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) offering_type: std::option::Option<crate::model::OfferingTypeValues>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Describes whether the Reserved Instance is Standard or Convertible.</p>
        pub fn offering_class(mut self, input: crate::model::OfferingClassType) -> Self {
            self.offering_class = Some(input);
            self
        }
        pub fn set_offering_class(
            mut self,
            input: std::option::Option<crate::model::OfferingClassType>,
        ) -> Self {
            self.offering_class = input;
            self
        }
        pub fn reserved_instances_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.reserved_instances_ids.unwrap_or_default();
            v.push(input.into());
            self.reserved_instances_ids = Some(v);
            self
        }
        pub fn set_reserved_instances_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.reserved_instances_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The Reserved Instance offering type. If you are using tools that predate the 2011-11-01 API
        /// version, you only have access to the <code>Medium Utilization</code> Reserved Instance
        /// offering type.</p>
        pub fn offering_type(mut self, input: crate::model::OfferingTypeValues) -> Self {
            self.offering_type = Some(input);
            self
        }
        pub fn set_offering_type(
            mut self,
            input: std::option::Option<crate::model::OfferingTypeValues>,
        ) -> Self {
            self.offering_type = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeReservedInstancesInput`](crate::input::DescribeReservedInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeReservedInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeReservedInstancesInput {
                filters: self.filters,
                offering_class: self.offering_class,
                reserved_instances_ids: self.reserved_instances_ids,
                dry_run: self.dry_run,
                offering_type: self.offering_type,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeReservedInstancesInputOperationOutputAlias =
    crate::operation::DescribeReservedInstances;
#[doc(hidden)]
pub type DescribeReservedInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeReservedInstancesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeReservedInstances`](crate::operation::DescribeReservedInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeReservedInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_reserved_instances(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeReservedInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeReservedInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeReservedInstancesInput`](crate::input::DescribeReservedInstancesInput)
    pub fn builder() -> crate::input::describe_reserved_instances_input::Builder {
        crate::input::describe_reserved_instances_input::Builder::default()
    }
}

/// See [`DescribeReservedInstancesListingsInput`](crate::input::DescribeReservedInstancesListingsInput)
pub mod describe_reserved_instances_listings_input {
    /// A builder for [`DescribeReservedInstancesListingsInput`](crate::input::DescribeReservedInstancesListingsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) reserved_instances_id: std::option::Option<std::string::String>,
        pub(crate) reserved_instances_listing_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>One or more Reserved Instance IDs.</p>
        pub fn reserved_instances_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.reserved_instances_id = Some(input.into());
            self
        }
        pub fn set_reserved_instances_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.reserved_instances_id = input;
            self
        }
        /// <p>One or more Reserved Instance listing IDs.</p>
        pub fn reserved_instances_listing_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.reserved_instances_listing_id = Some(input.into());
            self
        }
        pub fn set_reserved_instances_listing_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.reserved_instances_listing_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeReservedInstancesListingsInput`](crate::input::DescribeReservedInstancesListingsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeReservedInstancesListingsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeReservedInstancesListingsInput {
                filters: self.filters,
                reserved_instances_id: self.reserved_instances_id,
                reserved_instances_listing_id: self.reserved_instances_listing_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeReservedInstancesListingsInputOperationOutputAlias =
    crate::operation::DescribeReservedInstancesListings;
#[doc(hidden)]
pub type DescribeReservedInstancesListingsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeReservedInstancesListingsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeReservedInstancesListings`](crate::operation::DescribeReservedInstancesListings)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeReservedInstancesListings,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_reserved_instances_listings(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeReservedInstancesListings::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeReservedInstancesListings",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeReservedInstancesListingsInput`](crate::input::DescribeReservedInstancesListingsInput)
    pub fn builder() -> crate::input::describe_reserved_instances_listings_input::Builder {
        crate::input::describe_reserved_instances_listings_input::Builder::default()
    }
}

/// See [`DescribeReservedInstancesModificationsInput`](crate::input::DescribeReservedInstancesModificationsInput)
pub mod describe_reserved_instances_modifications_input {
    /// A builder for [`DescribeReservedInstancesModificationsInput`](crate::input::DescribeReservedInstancesModificationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) reserved_instances_modification_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn reserved_instances_modification_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.reserved_instances_modification_ids.unwrap_or_default();
            v.push(input.into());
            self.reserved_instances_modification_ids = Some(v);
            self
        }
        pub fn set_reserved_instances_modification_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.reserved_instances_modification_ids = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeReservedInstancesModificationsInput`](crate::input::DescribeReservedInstancesModificationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeReservedInstancesModificationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeReservedInstancesModificationsInput {
                filters: self.filters,
                reserved_instances_modification_ids: self.reserved_instances_modification_ids,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeReservedInstancesModificationsInputOperationOutputAlias =
    crate::operation::DescribeReservedInstancesModifications;
#[doc(hidden)]
pub type DescribeReservedInstancesModificationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeReservedInstancesModificationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeReservedInstancesModifications`](crate::operation::DescribeReservedInstancesModifications)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeReservedInstancesModifications,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_reserved_instances_modifications(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeReservedInstancesModifications::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeReservedInstancesModifications",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeReservedInstancesModificationsInput`](crate::input::DescribeReservedInstancesModificationsInput)
    pub fn builder() -> crate::input::describe_reserved_instances_modifications_input::Builder {
        crate::input::describe_reserved_instances_modifications_input::Builder::default()
    }
}

/// See [`DescribeReservedInstancesOfferingsInput`](crate::input::DescribeReservedInstancesOfferingsInput)
pub mod describe_reserved_instances_offerings_input {
    /// A builder for [`DescribeReservedInstancesOfferingsInput`](crate::input::DescribeReservedInstancesOfferingsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) include_marketplace: std::option::Option<bool>,
        pub(crate) instance_type: std::option::Option<crate::model::InstanceType>,
        pub(crate) max_duration: std::option::Option<i64>,
        pub(crate) max_instance_count: std::option::Option<i32>,
        pub(crate) min_duration: std::option::Option<i64>,
        pub(crate) offering_class: std::option::Option<crate::model::OfferingClassType>,
        pub(crate) product_description: std::option::Option<crate::model::RiProductDescription>,
        pub(crate) reserved_instances_offering_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_tenancy: std::option::Option<crate::model::Tenancy>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) offering_type: std::option::Option<crate::model::OfferingTypeValues>,
    }
    impl Builder {
        /// <p>The Availability Zone in which the Reserved Instance can be used.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Include Reserved Instance Marketplace offerings in the response.</p>
        pub fn include_marketplace(mut self, input: bool) -> Self {
            self.include_marketplace = Some(input);
            self
        }
        pub fn set_include_marketplace(mut self, input: std::option::Option<bool>) -> Self {
            self.include_marketplace = input;
            self
        }
        /// <p>The instance type that the reservation will cover (for example, <code>m1.small</code>). For more information, see
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance types</a> in the
        /// <i>Amazon EC2 User Guide</i>.</p>
        pub fn instance_type(mut self, input: crate::model::InstanceType) -> Self {
            self.instance_type = Some(input);
            self
        }
        pub fn set_instance_type(
            mut self,
            input: std::option::Option<crate::model::InstanceType>,
        ) -> Self {
            self.instance_type = input;
            self
        }
        /// <p>The maximum duration (in seconds) to filter when searching for offerings.</p>
        /// <p>Default: 94608000 (3 years)</p>
        pub fn max_duration(mut self, input: i64) -> Self {
            self.max_duration = Some(input);
            self
        }
        pub fn set_max_duration(mut self, input: std::option::Option<i64>) -> Self {
            self.max_duration = input;
            self
        }
        /// <p>The maximum number of instances to filter when searching for offerings.</p>
        /// <p>Default: 20</p>
        pub fn max_instance_count(mut self, input: i32) -> Self {
            self.max_instance_count = Some(input);
            self
        }
        pub fn set_max_instance_count(mut self, input: std::option::Option<i32>) -> Self {
            self.max_instance_count = input;
            self
        }
        /// <p>The minimum duration (in seconds) to filter when searching for offerings.</p>
        /// <p>Default: 2592000 (1 month)</p>
        pub fn min_duration(mut self, input: i64) -> Self {
            self.min_duration = Some(input);
            self
        }
        pub fn set_min_duration(mut self, input: std::option::Option<i64>) -> Self {
            self.min_duration = input;
            self
        }
        /// <p>The offering class of the Reserved Instance. Can be <code>standard</code> or <code>convertible</code>.</p>
        pub fn offering_class(mut self, input: crate::model::OfferingClassType) -> Self {
            self.offering_class = Some(input);
            self
        }
        pub fn set_offering_class(
            mut self,
            input: std::option::Option<crate::model::OfferingClassType>,
        ) -> Self {
            self.offering_class = input;
            self
        }
        /// <p>The Reserved Instance product platform description. Instances that include <code>(Amazon
        /// VPC)</code> in the description are for use with Amazon VPC.</p>
        pub fn product_description(mut self, input: crate::model::RiProductDescription) -> Self {
            self.product_description = Some(input);
            self
        }
        pub fn set_product_description(
            mut self,
            input: std::option::Option<crate::model::RiProductDescription>,
        ) -> Self {
            self.product_description = input;
            self
        }
        pub fn reserved_instances_offering_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.reserved_instances_offering_ids.unwrap_or_default();
            v.push(input.into());
            self.reserved_instances_offering_ids = Some(v);
            self
        }
        pub fn set_reserved_instances_offering_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.reserved_instances_offering_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The tenancy of the instances covered by the reservation. A Reserved Instance with a tenancy
        /// of <code>dedicated</code> is applied to instances that run in a VPC on single-tenant hardware
        /// (i.e., Dedicated Instances).</p>
        /// <p>
        /// <b>Important:</b> The <code>host</code> value cannot be used with this parameter. Use the <code>default</code> or <code>dedicated</code> values only.</p>
        /// <p>Default: <code>default</code>
        /// </p>
        pub fn instance_tenancy(mut self, input: crate::model::Tenancy) -> Self {
            self.instance_tenancy = Some(input);
            self
        }
        pub fn set_instance_tenancy(
            mut self,
            input: std::option::Option<crate::model::Tenancy>,
        ) -> Self {
            self.instance_tenancy = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining
        /// results of the initial request can be seen by sending another request with the returned
        /// <code>NextToken</code> value. The maximum is 100.</p>
        /// <p>Default: 100</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The Reserved Instance offering type. If you are using tools that predate the 2011-11-01 API
        /// version, you only have access to the <code>Medium Utilization</code> Reserved Instance
        /// offering type. </p>
        pub fn offering_type(mut self, input: crate::model::OfferingTypeValues) -> Self {
            self.offering_type = Some(input);
            self
        }
        pub fn set_offering_type(
            mut self,
            input: std::option::Option<crate::model::OfferingTypeValues>,
        ) -> Self {
            self.offering_type = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeReservedInstancesOfferingsInput`](crate::input::DescribeReservedInstancesOfferingsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeReservedInstancesOfferingsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeReservedInstancesOfferingsInput {
                availability_zone: self.availability_zone,
                filters: self.filters,
                include_marketplace: self.include_marketplace,
                instance_type: self.instance_type,
                max_duration: self.max_duration,
                max_instance_count: self.max_instance_count,
                min_duration: self.min_duration,
                offering_class: self.offering_class,
                product_description: self.product_description,
                reserved_instances_offering_ids: self.reserved_instances_offering_ids,
                dry_run: self.dry_run,
                instance_tenancy: self.instance_tenancy,
                max_results: self.max_results,
                next_token: self.next_token,
                offering_type: self.offering_type,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeReservedInstancesOfferingsInputOperationOutputAlias =
    crate::operation::DescribeReservedInstancesOfferings;
#[doc(hidden)]
pub type DescribeReservedInstancesOfferingsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeReservedInstancesOfferingsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeReservedInstancesOfferings`](crate::operation::DescribeReservedInstancesOfferings)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeReservedInstancesOfferings,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_reserved_instances_offerings(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeReservedInstancesOfferings::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeReservedInstancesOfferings",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeReservedInstancesOfferingsInput`](crate::input::DescribeReservedInstancesOfferingsInput)
    pub fn builder() -> crate::input::describe_reserved_instances_offerings_input::Builder {
        crate::input::describe_reserved_instances_offerings_input::Builder::default()
    }
}

/// See [`DescribeRouteTablesInput`](crate::input::DescribeRouteTablesInput)
pub mod describe_route_tables_input {
    /// A builder for [`DescribeRouteTablesInput`](crate::input::DescribeRouteTablesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn route_table_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.route_table_ids.unwrap_or_default();
            v.push(input.into());
            self.route_table_ids = Some(v);
            self
        }
        pub fn set_route_table_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.route_table_ids = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeRouteTablesInput`](crate::input::DescribeRouteTablesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeRouteTablesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeRouteTablesInput {
                filters: self.filters,
                dry_run: self.dry_run,
                route_table_ids: self.route_table_ids,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeRouteTablesInputOperationOutputAlias = crate::operation::DescribeRouteTables;
#[doc(hidden)]
pub type DescribeRouteTablesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeRouteTablesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeRouteTables`](crate::operation::DescribeRouteTables)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeRouteTables,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_route_tables(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeRouteTables::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeRouteTables",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeRouteTablesInput`](crate::input::DescribeRouteTablesInput)
    pub fn builder() -> crate::input::describe_route_tables_input::Builder {
        crate::input::describe_route_tables_input::Builder::default()
    }
}

/// See [`DescribeScheduledInstanceAvailabilityInput`](crate::input::DescribeScheduledInstanceAvailabilityInput)
pub mod describe_scheduled_instance_availability_input {
    /// A builder for [`DescribeScheduledInstanceAvailabilityInput`](crate::input::DescribeScheduledInstanceAvailabilityInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) first_slot_start_time_range:
            std::option::Option<crate::model::SlotDateTimeRangeRequest>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) max_slot_duration_in_hours: std::option::Option<i32>,
        pub(crate) min_slot_duration_in_hours: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) recurrence:
            std::option::Option<crate::model::ScheduledInstanceRecurrenceRequest>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The time period for the first schedule to start.</p>
        pub fn first_slot_start_time_range(
            mut self,
            input: crate::model::SlotDateTimeRangeRequest,
        ) -> Self {
            self.first_slot_start_time_range = Some(input);
            self
        }
        pub fn set_first_slot_start_time_range(
            mut self,
            input: std::option::Option<crate::model::SlotDateTimeRangeRequest>,
        ) -> Self {
            self.first_slot_start_time_range = input;
            self
        }
        /// <p>The maximum number of results to return in a single call.
        /// This value can be between 5 and 300. The default value is 300.
        /// To retrieve the remaining results, make another call with the returned
        /// <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The maximum available duration, in hours. This value must be greater than <code>MinSlotDurationInHours</code>
        /// and less than 1,720.</p>
        pub fn max_slot_duration_in_hours(mut self, input: i32) -> Self {
            self.max_slot_duration_in_hours = Some(input);
            self
        }
        pub fn set_max_slot_duration_in_hours(mut self, input: std::option::Option<i32>) -> Self {
            self.max_slot_duration_in_hours = input;
            self
        }
        /// <p>The minimum available duration, in hours. The minimum required duration is 1,200 hours per year. For example, the minimum daily schedule is 4 hours, the minimum weekly schedule is 24 hours, and the minimum monthly schedule is 100 hours.</p>
        pub fn min_slot_duration_in_hours(mut self, input: i32) -> Self {
            self.min_slot_duration_in_hours = Some(input);
            self
        }
        pub fn set_min_slot_duration_in_hours(mut self, input: std::option::Option<i32>) -> Self {
            self.min_slot_duration_in_hours = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The schedule recurrence.</p>
        pub fn recurrence(
            mut self,
            input: crate::model::ScheduledInstanceRecurrenceRequest,
        ) -> Self {
            self.recurrence = Some(input);
            self
        }
        pub fn set_recurrence(
            mut self,
            input: std::option::Option<crate::model::ScheduledInstanceRecurrenceRequest>,
        ) -> Self {
            self.recurrence = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeScheduledInstanceAvailabilityInput`](crate::input::DescribeScheduledInstanceAvailabilityInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeScheduledInstanceAvailabilityInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeScheduledInstanceAvailabilityInput {
                dry_run: self.dry_run,
                filters: self.filters,
                first_slot_start_time_range: self.first_slot_start_time_range,
                max_results: self.max_results,
                max_slot_duration_in_hours: self.max_slot_duration_in_hours,
                min_slot_duration_in_hours: self.min_slot_duration_in_hours,
                next_token: self.next_token,
                recurrence: self.recurrence,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeScheduledInstanceAvailabilityInputOperationOutputAlias =
    crate::operation::DescribeScheduledInstanceAvailability;
#[doc(hidden)]
pub type DescribeScheduledInstanceAvailabilityInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeScheduledInstanceAvailabilityInput {
    /// Consumes the builder and constructs an Operation<[`DescribeScheduledInstanceAvailability`](crate::operation::DescribeScheduledInstanceAvailability)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeScheduledInstanceAvailability,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_scheduled_instance_availability(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeScheduledInstanceAvailability::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeScheduledInstanceAvailability",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeScheduledInstanceAvailabilityInput`](crate::input::DescribeScheduledInstanceAvailabilityInput)
    pub fn builder() -> crate::input::describe_scheduled_instance_availability_input::Builder {
        crate::input::describe_scheduled_instance_availability_input::Builder::default()
    }
}

/// See [`DescribeScheduledInstancesInput`](crate::input::DescribeScheduledInstancesInput)
pub mod describe_scheduled_instances_input {
    /// A builder for [`DescribeScheduledInstancesInput`](crate::input::DescribeScheduledInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) scheduled_instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) slot_start_time_range:
            std::option::Option<crate::model::SlotStartTimeRangeRequest>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return in a single call.
        /// This value can be between 5 and 300. The default value is 100.
        /// To retrieve the remaining results, make another call with the returned
        /// <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn scheduled_instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.scheduled_instance_ids.unwrap_or_default();
            v.push(input.into());
            self.scheduled_instance_ids = Some(v);
            self
        }
        pub fn set_scheduled_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.scheduled_instance_ids = input;
            self
        }
        /// <p>The time period for the first schedule to start.</p>
        pub fn slot_start_time_range(
            mut self,
            input: crate::model::SlotStartTimeRangeRequest,
        ) -> Self {
            self.slot_start_time_range = Some(input);
            self
        }
        pub fn set_slot_start_time_range(
            mut self,
            input: std::option::Option<crate::model::SlotStartTimeRangeRequest>,
        ) -> Self {
            self.slot_start_time_range = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeScheduledInstancesInput`](crate::input::DescribeScheduledInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeScheduledInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeScheduledInstancesInput {
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                scheduled_instance_ids: self.scheduled_instance_ids,
                slot_start_time_range: self.slot_start_time_range,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeScheduledInstancesInputOperationOutputAlias =
    crate::operation::DescribeScheduledInstances;
#[doc(hidden)]
pub type DescribeScheduledInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeScheduledInstancesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeScheduledInstances`](crate::operation::DescribeScheduledInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeScheduledInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_scheduled_instances(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeScheduledInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeScheduledInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeScheduledInstancesInput`](crate::input::DescribeScheduledInstancesInput)
    pub fn builder() -> crate::input::describe_scheduled_instances_input::Builder {
        crate::input::describe_scheduled_instances_input::Builder::default()
    }
}

/// See [`DescribeSecurityGroupReferencesInput`](crate::input::DescribeSecurityGroupReferencesInput)
pub mod describe_security_group_references_input {
    /// A builder for [`DescribeSecurityGroupReferencesInput`](crate::input::DescribeSecurityGroupReferencesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_id: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.group_id.unwrap_or_default();
            v.push(input.into());
            self.group_id = Some(v);
            self
        }
        pub fn set_group_id(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.group_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSecurityGroupReferencesInput`](crate::input::DescribeSecurityGroupReferencesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSecurityGroupReferencesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSecurityGroupReferencesInput {
                dry_run: self.dry_run,
                group_id: self.group_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSecurityGroupReferencesInputOperationOutputAlias =
    crate::operation::DescribeSecurityGroupReferences;
#[doc(hidden)]
pub type DescribeSecurityGroupReferencesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSecurityGroupReferencesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSecurityGroupReferences`](crate::operation::DescribeSecurityGroupReferences)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSecurityGroupReferences,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_security_group_references(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSecurityGroupReferences::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSecurityGroupReferences",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSecurityGroupReferencesInput`](crate::input::DescribeSecurityGroupReferencesInput)
    pub fn builder() -> crate::input::describe_security_group_references_input::Builder {
        crate::input::describe_security_group_references_input::Builder::default()
    }
}

/// See [`DescribeSecurityGroupsInput`](crate::input::DescribeSecurityGroupsInput)
pub mod describe_security_groups_input {
    /// A builder for [`DescribeSecurityGroupsInput`](crate::input::DescribeSecurityGroupsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) group_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.group_ids.unwrap_or_default();
            v.push(input.into());
            self.group_ids = Some(v);
            self
        }
        pub fn set_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.group_ids = input;
            self
        }
        pub fn group_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.group_names.unwrap_or_default();
            v.push(input.into());
            self.group_names = Some(v);
            self
        }
        pub fn set_group_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.group_names = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another request with the returned <code>NextToken</code> value. This value
        /// can be between 5 and 1000. If this parameter is not specified, then all results are
        /// returned.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSecurityGroupsInput`](crate::input::DescribeSecurityGroupsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSecurityGroupsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSecurityGroupsInput {
                filters: self.filters,
                group_ids: self.group_ids,
                group_names: self.group_names,
                dry_run: self.dry_run,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSecurityGroupsInputOperationOutputAlias = crate::operation::DescribeSecurityGroups;
#[doc(hidden)]
pub type DescribeSecurityGroupsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSecurityGroupsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSecurityGroups`](crate::operation::DescribeSecurityGroups)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSecurityGroups,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_security_groups(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSecurityGroups::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSecurityGroups",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSecurityGroupsInput`](crate::input::DescribeSecurityGroupsInput)
    pub fn builder() -> crate::input::describe_security_groups_input::Builder {
        crate::input::describe_security_groups_input::Builder::default()
    }
}

/// See [`DescribeSnapshotAttributeInput`](crate::input::DescribeSnapshotAttributeInput)
pub mod describe_snapshot_attribute_input {
    /// A builder for [`DescribeSnapshotAttributeInput`](crate::input::DescribeSnapshotAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::SnapshotAttributeName>,
        pub(crate) snapshot_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The snapshot attribute you would like to view.</p>
        pub fn attribute(mut self, input: crate::model::SnapshotAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::SnapshotAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The ID of the EBS snapshot.</p>
        pub fn snapshot_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.snapshot_id = Some(input.into());
            self
        }
        pub fn set_snapshot_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.snapshot_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSnapshotAttributeInput`](crate::input::DescribeSnapshotAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSnapshotAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSnapshotAttributeInput {
                attribute: self.attribute,
                snapshot_id: self.snapshot_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSnapshotAttributeInputOperationOutputAlias =
    crate::operation::DescribeSnapshotAttribute;
#[doc(hidden)]
pub type DescribeSnapshotAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSnapshotAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSnapshotAttribute`](crate::operation::DescribeSnapshotAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSnapshotAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_snapshot_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSnapshotAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSnapshotAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSnapshotAttributeInput`](crate::input::DescribeSnapshotAttributeInput)
    pub fn builder() -> crate::input::describe_snapshot_attribute_input::Builder {
        crate::input::describe_snapshot_attribute_input::Builder::default()
    }
}

/// See [`DescribeSnapshotsInput`](crate::input::DescribeSnapshotsInput)
pub mod describe_snapshots_input {
    /// A builder for [`DescribeSnapshotsInput`](crate::input::DescribeSnapshotsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) owner_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) restorable_by_user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) snapshot_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of snapshot results returned by <code>DescribeSnapshots</code> in
        /// paginated output. When this parameter is used, <code>DescribeSnapshots</code> only returns
        /// <code>MaxResults</code> results in a single page along with a <code>NextToken</code>
        /// response element. The remaining results of the initial request can be seen by sending another
        /// <code>DescribeSnapshots</code> request with the returned <code>NextToken</code> value. This
        /// value can be between 5 and 1,000; if <code>MaxResults</code> is given a value larger than 1,000,
        /// only 1,000 results are returned. If this parameter is not used, then
        /// <code>DescribeSnapshots</code> returns all results. You cannot specify this parameter and
        /// the snapshot IDs parameter in the same request.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The <code>NextToken</code> value returned from a previous paginated
        /// <code>DescribeSnapshots</code> request where <code>MaxResults</code> was used and the
        /// results exceeded the value of that parameter. Pagination continues from the end of the
        /// previous results that returned the <code>NextToken</code> value. This value is
        /// <code>null</code> when there are no more results to return.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn owner_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.owner_ids.unwrap_or_default();
            v.push(input.into());
            self.owner_ids = Some(v);
            self
        }
        pub fn set_owner_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.owner_ids = input;
            self
        }
        pub fn restorable_by_user_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.restorable_by_user_ids.unwrap_or_default();
            v.push(input.into());
            self.restorable_by_user_ids = Some(v);
            self
        }
        pub fn set_restorable_by_user_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.restorable_by_user_ids = input;
            self
        }
        pub fn snapshot_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.snapshot_ids.unwrap_or_default();
            v.push(input.into());
            self.snapshot_ids = Some(v);
            self
        }
        pub fn set_snapshot_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.snapshot_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSnapshotsInput`](crate::input::DescribeSnapshotsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSnapshotsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSnapshotsInput {
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                owner_ids: self.owner_ids,
                restorable_by_user_ids: self.restorable_by_user_ids,
                snapshot_ids: self.snapshot_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSnapshotsInputOperationOutputAlias = crate::operation::DescribeSnapshots;
#[doc(hidden)]
pub type DescribeSnapshotsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSnapshotsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSnapshots`](crate::operation::DescribeSnapshots)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSnapshots,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_snapshots(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSnapshots::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSnapshots",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSnapshotsInput`](crate::input::DescribeSnapshotsInput)
    pub fn builder() -> crate::input::describe_snapshots_input::Builder {
        crate::input::describe_snapshots_input::Builder::default()
    }
}

/// See [`DescribeSpotDatafeedSubscriptionInput`](crate::input::DescribeSpotDatafeedSubscriptionInput)
pub mod describe_spot_datafeed_subscription_input {
    /// A builder for [`DescribeSpotDatafeedSubscriptionInput`](crate::input::DescribeSpotDatafeedSubscriptionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSpotDatafeedSubscriptionInput`](crate::input::DescribeSpotDatafeedSubscriptionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSpotDatafeedSubscriptionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSpotDatafeedSubscriptionInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSpotDatafeedSubscriptionInputOperationOutputAlias =
    crate::operation::DescribeSpotDatafeedSubscription;
#[doc(hidden)]
pub type DescribeSpotDatafeedSubscriptionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSpotDatafeedSubscriptionInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSpotDatafeedSubscription`](crate::operation::DescribeSpotDatafeedSubscription)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSpotDatafeedSubscription,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_spot_datafeed_subscription(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSpotDatafeedSubscription::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSpotDatafeedSubscription",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSpotDatafeedSubscriptionInput`](crate::input::DescribeSpotDatafeedSubscriptionInput)
    pub fn builder() -> crate::input::describe_spot_datafeed_subscription_input::Builder {
        crate::input::describe_spot_datafeed_subscription_input::Builder::default()
    }
}

/// See [`DescribeSpotFleetInstancesInput`](crate::input::DescribeSpotFleetInstancesInput)
pub mod describe_spot_fleet_instances_input {
    /// A builder for [`DescribeSpotFleetInstancesInput`](crate::input::DescribeSpotFleetInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) spot_fleet_request_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 1
        /// and 1000. The default value is 1000. To retrieve the remaining results, make another
        /// call with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The ID of the Spot Fleet request.</p>
        pub fn spot_fleet_request_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.spot_fleet_request_id = Some(input.into());
            self
        }
        pub fn set_spot_fleet_request_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.spot_fleet_request_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSpotFleetInstancesInput`](crate::input::DescribeSpotFleetInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSpotFleetInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSpotFleetInstancesInput {
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
                spot_fleet_request_id: self.spot_fleet_request_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSpotFleetInstancesInputOperationOutputAlias =
    crate::operation::DescribeSpotFleetInstances;
#[doc(hidden)]
pub type DescribeSpotFleetInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSpotFleetInstancesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSpotFleetInstances`](crate::operation::DescribeSpotFleetInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSpotFleetInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_spot_fleet_instances(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSpotFleetInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSpotFleetInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSpotFleetInstancesInput`](crate::input::DescribeSpotFleetInstancesInput)
    pub fn builder() -> crate::input::describe_spot_fleet_instances_input::Builder {
        crate::input::describe_spot_fleet_instances_input::Builder::default()
    }
}

/// See [`DescribeSpotFleetRequestHistoryInput`](crate::input::DescribeSpotFleetRequestHistoryInput)
pub mod describe_spot_fleet_request_history_input {
    /// A builder for [`DescribeSpotFleetRequestHistoryInput`](crate::input::DescribeSpotFleetRequestHistoryInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) event_type: std::option::Option<crate::model::EventType>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) spot_fleet_request_id: std::option::Option<std::string::String>,
        pub(crate) start_time: std::option::Option<smithy_types::Instant>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The type of events to describe. By default, all events are described.</p>
        pub fn event_type(mut self, input: crate::model::EventType) -> Self {
            self.event_type = Some(input);
            self
        }
        pub fn set_event_type(
            mut self,
            input: std::option::Option<crate::model::EventType>,
        ) -> Self {
            self.event_type = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 1
        /// and 1000. The default value is 1000. To retrieve the remaining results, make another
        /// call with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The ID of the Spot Fleet request.</p>
        pub fn spot_fleet_request_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.spot_fleet_request_id = Some(input.into());
            self
        }
        pub fn set_spot_fleet_request_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.spot_fleet_request_id = input;
            self
        }
        /// <p>The starting date and time for the events, in UTC format (for example,
        /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
        pub fn start_time(mut self, input: smithy_types::Instant) -> Self {
            self.start_time = Some(input);
            self
        }
        pub fn set_start_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.start_time = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSpotFleetRequestHistoryInput`](crate::input::DescribeSpotFleetRequestHistoryInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSpotFleetRequestHistoryInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSpotFleetRequestHistoryInput {
                dry_run: self.dry_run,
                event_type: self.event_type,
                max_results: self.max_results,
                next_token: self.next_token,
                spot_fleet_request_id: self.spot_fleet_request_id,
                start_time: self.start_time,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSpotFleetRequestHistoryInputOperationOutputAlias =
    crate::operation::DescribeSpotFleetRequestHistory;
#[doc(hidden)]
pub type DescribeSpotFleetRequestHistoryInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSpotFleetRequestHistoryInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSpotFleetRequestHistory`](crate::operation::DescribeSpotFleetRequestHistory)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSpotFleetRequestHistory,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_spot_fleet_request_history(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSpotFleetRequestHistory::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSpotFleetRequestHistory",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSpotFleetRequestHistoryInput`](crate::input::DescribeSpotFleetRequestHistoryInput)
    pub fn builder() -> crate::input::describe_spot_fleet_request_history_input::Builder {
        crate::input::describe_spot_fleet_request_history_input::Builder::default()
    }
}

/// See [`DescribeSpotFleetRequestsInput`](crate::input::DescribeSpotFleetRequestsInput)
pub mod describe_spot_fleet_requests_input {
    /// A builder for [`DescribeSpotFleetRequestsInput`](crate::input::DescribeSpotFleetRequestsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) spot_fleet_request_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 1
        /// and 1000. The default value is 1000. To retrieve the remaining results, make another
        /// call with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn spot_fleet_request_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.spot_fleet_request_ids.unwrap_or_default();
            v.push(input.into());
            self.spot_fleet_request_ids = Some(v);
            self
        }
        pub fn set_spot_fleet_request_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.spot_fleet_request_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSpotFleetRequestsInput`](crate::input::DescribeSpotFleetRequestsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSpotFleetRequestsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSpotFleetRequestsInput {
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
                spot_fleet_request_ids: self.spot_fleet_request_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSpotFleetRequestsInputOperationOutputAlias =
    crate::operation::DescribeSpotFleetRequests;
#[doc(hidden)]
pub type DescribeSpotFleetRequestsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSpotFleetRequestsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSpotFleetRequests`](crate::operation::DescribeSpotFleetRequests)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSpotFleetRequests,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_spot_fleet_requests(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSpotFleetRequests::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSpotFleetRequests",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSpotFleetRequestsInput`](crate::input::DescribeSpotFleetRequestsInput)
    pub fn builder() -> crate::input::describe_spot_fleet_requests_input::Builder {
        crate::input::describe_spot_fleet_requests_input::Builder::default()
    }
}

/// See [`DescribeSpotInstanceRequestsInput`](crate::input::DescribeSpotInstanceRequestsInput)
pub mod describe_spot_instance_requests_input {
    /// A builder for [`DescribeSpotInstanceRequestsInput`](crate::input::DescribeSpotInstanceRequestsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) spot_instance_request_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn spot_instance_request_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.spot_instance_request_ids.unwrap_or_default();
            v.push(input.into());
            self.spot_instance_request_ids = Some(v);
            self
        }
        pub fn set_spot_instance_request_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.spot_instance_request_ids = input;
            self
        }
        /// <p>The token to request the next set of results. This value is <code>null</code> when
        /// there are no more results to return.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 5
        /// and 1000. To retrieve the remaining results, make another call with the returned
        /// <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSpotInstanceRequestsInput`](crate::input::DescribeSpotInstanceRequestsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSpotInstanceRequestsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSpotInstanceRequestsInput {
                filters: self.filters,
                dry_run: self.dry_run,
                spot_instance_request_ids: self.spot_instance_request_ids,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSpotInstanceRequestsInputOperationOutputAlias =
    crate::operation::DescribeSpotInstanceRequests;
#[doc(hidden)]
pub type DescribeSpotInstanceRequestsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSpotInstanceRequestsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSpotInstanceRequests`](crate::operation::DescribeSpotInstanceRequests)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSpotInstanceRequests,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_spot_instance_requests(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSpotInstanceRequests::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSpotInstanceRequests",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSpotInstanceRequestsInput`](crate::input::DescribeSpotInstanceRequestsInput)
    pub fn builder() -> crate::input::describe_spot_instance_requests_input::Builder {
        crate::input::describe_spot_instance_requests_input::Builder::default()
    }
}

/// See [`DescribeSpotPriceHistoryInput`](crate::input::DescribeSpotPriceHistoryInput)
pub mod describe_spot_price_history_input {
    /// A builder for [`DescribeSpotPriceHistoryInput`](crate::input::DescribeSpotPriceHistoryInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) end_time: std::option::Option<smithy_types::Instant>,
        pub(crate) instance_types: std::option::Option<std::vec::Vec<crate::model::InstanceType>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) product_descriptions: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) start_time: std::option::Option<smithy_types::Instant>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Filters the results by the specified Availability Zone.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The date and time, up to the current date, from which to stop retrieving the price
        /// history data, in UTC format (for example,
        /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
        pub fn end_time(mut self, input: smithy_types::Instant) -> Self {
            self.end_time = Some(input);
            self
        }
        pub fn set_end_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.end_time = input;
            self
        }
        pub fn instance_types(mut self, input: impl Into<crate::model::InstanceType>) -> Self {
            let mut v = self.instance_types.unwrap_or_default();
            v.push(input.into());
            self.instance_types = Some(v);
            self
        }
        pub fn set_instance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::InstanceType>>,
        ) -> Self {
            self.instance_types = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. Specify a value between 1
        /// and 1000. The default value is 1000. To retrieve the remaining results, make another
        /// call with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn product_descriptions(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.product_descriptions.unwrap_or_default();
            v.push(input.into());
            self.product_descriptions = Some(v);
            self
        }
        pub fn set_product_descriptions(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.product_descriptions = input;
            self
        }
        /// <p>The date and time, up to the past 90 days, from which to start retrieving the price
        /// history data, in UTC format (for example,
        /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
        pub fn start_time(mut self, input: smithy_types::Instant) -> Self {
            self.start_time = Some(input);
            self
        }
        pub fn set_start_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.start_time = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSpotPriceHistoryInput`](crate::input::DescribeSpotPriceHistoryInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSpotPriceHistoryInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSpotPriceHistoryInput {
                filters: self.filters,
                availability_zone: self.availability_zone,
                dry_run: self.dry_run,
                end_time: self.end_time,
                instance_types: self.instance_types,
                max_results: self.max_results,
                next_token: self.next_token,
                product_descriptions: self.product_descriptions,
                start_time: self.start_time,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSpotPriceHistoryInputOperationOutputAlias =
    crate::operation::DescribeSpotPriceHistory;
#[doc(hidden)]
pub type DescribeSpotPriceHistoryInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSpotPriceHistoryInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSpotPriceHistory`](crate::operation::DescribeSpotPriceHistory)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSpotPriceHistory,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_spot_price_history(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSpotPriceHistory::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSpotPriceHistory",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSpotPriceHistoryInput`](crate::input::DescribeSpotPriceHistoryInput)
    pub fn builder() -> crate::input::describe_spot_price_history_input::Builder {
        crate::input::describe_spot_price_history_input::Builder::default()
    }
}

/// See [`DescribeStaleSecurityGroupsInput`](crate::input::DescribeStaleSecurityGroupsInput)
pub mod describe_stale_security_groups_input {
    /// A builder for [`DescribeStaleSecurityGroupsInput`](crate::input::DescribeStaleSecurityGroupsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of items to return for this request. The request returns a token that you can specify in a subsequent call to get the next set of results.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of items to return. (You received this token from a prior call.)</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeStaleSecurityGroupsInput`](crate::input::DescribeStaleSecurityGroupsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeStaleSecurityGroupsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeStaleSecurityGroupsInput {
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeStaleSecurityGroupsInputOperationOutputAlias =
    crate::operation::DescribeStaleSecurityGroups;
#[doc(hidden)]
pub type DescribeStaleSecurityGroupsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeStaleSecurityGroupsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeStaleSecurityGroups`](crate::operation::DescribeStaleSecurityGroups)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeStaleSecurityGroups,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_stale_security_groups(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeStaleSecurityGroups::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeStaleSecurityGroups",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeStaleSecurityGroupsInput`](crate::input::DescribeStaleSecurityGroupsInput)
    pub fn builder() -> crate::input::describe_stale_security_groups_input::Builder {
        crate::input::describe_stale_security_groups_input::Builder::default()
    }
}

/// See [`DescribeStoreImageTasksInput`](crate::input::DescribeStoreImageTasksInput)
pub mod describe_store_image_tasks_input {
    /// A builder for [`DescribeStoreImageTasksInput`](crate::input::DescribeStoreImageTasksInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) image_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn image_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.image_ids.unwrap_or_default();
            v.push(input.into());
            self.image_ids = Some(v);
            self
        }
        pub fn set_image_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.image_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another call with the returned <code>NextToken</code> value. This value can be
        /// between 1 and 200. You cannot specify this parameter and the <code>ImageIDs</code> parameter
        /// in the same call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeStoreImageTasksInput`](crate::input::DescribeStoreImageTasksInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeStoreImageTasksInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeStoreImageTasksInput {
                image_ids: self.image_ids,
                dry_run: self.dry_run,
                filters: self.filters,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeStoreImageTasksInputOperationOutputAlias =
    crate::operation::DescribeStoreImageTasks;
#[doc(hidden)]
pub type DescribeStoreImageTasksInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeStoreImageTasksInput {
    /// Consumes the builder and constructs an Operation<[`DescribeStoreImageTasks`](crate::operation::DescribeStoreImageTasks)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeStoreImageTasks,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_store_image_tasks(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeStoreImageTasks::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeStoreImageTasks",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeStoreImageTasksInput`](crate::input::DescribeStoreImageTasksInput)
    pub fn builder() -> crate::input::describe_store_image_tasks_input::Builder {
        crate::input::describe_store_image_tasks_input::Builder::default()
    }
}

/// See [`DescribeSubnetsInput`](crate::input::DescribeSubnetsInput)
pub mod describe_subnets_input {
    /// A builder for [`DescribeSubnetsInput`](crate::input::DescribeSubnetsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.subnet_ids = Some(v);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.subnet_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeSubnetsInput`](crate::input::DescribeSubnetsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeSubnetsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeSubnetsInput {
                filters: self.filters,
                subnet_ids: self.subnet_ids,
                dry_run: self.dry_run,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeSubnetsInputOperationOutputAlias = crate::operation::DescribeSubnets;
#[doc(hidden)]
pub type DescribeSubnetsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeSubnetsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeSubnets`](crate::operation::DescribeSubnets)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeSubnets,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_subnets(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeSubnets::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeSubnets",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeSubnetsInput`](crate::input::DescribeSubnetsInput)
    pub fn builder() -> crate::input::describe_subnets_input::Builder {
        crate::input::describe_subnets_input::Builder::default()
    }
}

/// See [`DescribeTagsInput`](crate::input::DescribeTagsInput)
pub mod describe_tags_input {
    /// A builder for [`DescribeTagsInput`](crate::input::DescribeTagsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return in a single call.
        /// This value can be between 5 and 1000.
        /// To retrieve the remaining results, make another call with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTagsInput`](crate::input::DescribeTagsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DescribeTagsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DescribeTagsInput {
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTagsInputOperationOutputAlias = crate::operation::DescribeTags;
#[doc(hidden)]
pub type DescribeTagsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTagsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTags`](crate::operation::DescribeTags)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTags,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_tags(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTags::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DescribeTags", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTagsInput`](crate::input::DescribeTagsInput)
    pub fn builder() -> crate::input::describe_tags_input::Builder {
        crate::input::describe_tags_input::Builder::default()
    }
}

/// See [`DescribeTrafficMirrorFiltersInput`](crate::input::DescribeTrafficMirrorFiltersInput)
pub mod describe_traffic_mirror_filters_input {
    /// A builder for [`DescribeTrafficMirrorFiltersInput`](crate::input::DescribeTrafficMirrorFiltersInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_filter_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn traffic_mirror_filter_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.traffic_mirror_filter_ids.unwrap_or_default();
            v.push(input.into());
            self.traffic_mirror_filter_ids = Some(v);
            self
        }
        pub fn set_traffic_mirror_filter_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.traffic_mirror_filter_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTrafficMirrorFiltersInput`](crate::input::DescribeTrafficMirrorFiltersInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTrafficMirrorFiltersInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTrafficMirrorFiltersInput {
                traffic_mirror_filter_ids: self.traffic_mirror_filter_ids,
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTrafficMirrorFiltersInputOperationOutputAlias =
    crate::operation::DescribeTrafficMirrorFilters;
#[doc(hidden)]
pub type DescribeTrafficMirrorFiltersInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTrafficMirrorFiltersInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTrafficMirrorFilters`](crate::operation::DescribeTrafficMirrorFilters)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTrafficMirrorFilters,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_traffic_mirror_filters(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTrafficMirrorFilters::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTrafficMirrorFilters",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTrafficMirrorFiltersInput`](crate::input::DescribeTrafficMirrorFiltersInput)
    pub fn builder() -> crate::input::describe_traffic_mirror_filters_input::Builder {
        crate::input::describe_traffic_mirror_filters_input::Builder::default()
    }
}

/// See [`DescribeTrafficMirrorSessionsInput`](crate::input::DescribeTrafficMirrorSessionsInput)
pub mod describe_traffic_mirror_sessions_input {
    /// A builder for [`DescribeTrafficMirrorSessionsInput`](crate::input::DescribeTrafficMirrorSessionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_session_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn traffic_mirror_session_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.traffic_mirror_session_ids.unwrap_or_default();
            v.push(input.into());
            self.traffic_mirror_session_ids = Some(v);
            self
        }
        pub fn set_traffic_mirror_session_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.traffic_mirror_session_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTrafficMirrorSessionsInput`](crate::input::DescribeTrafficMirrorSessionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTrafficMirrorSessionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTrafficMirrorSessionsInput {
                traffic_mirror_session_ids: self.traffic_mirror_session_ids,
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTrafficMirrorSessionsInputOperationOutputAlias =
    crate::operation::DescribeTrafficMirrorSessions;
#[doc(hidden)]
pub type DescribeTrafficMirrorSessionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTrafficMirrorSessionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTrafficMirrorSessions`](crate::operation::DescribeTrafficMirrorSessions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTrafficMirrorSessions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_traffic_mirror_sessions(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTrafficMirrorSessions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTrafficMirrorSessions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTrafficMirrorSessionsInput`](crate::input::DescribeTrafficMirrorSessionsInput)
    pub fn builder() -> crate::input::describe_traffic_mirror_sessions_input::Builder {
        crate::input::describe_traffic_mirror_sessions_input::Builder::default()
    }
}

/// See [`DescribeTrafficMirrorTargetsInput`](crate::input::DescribeTrafficMirrorTargetsInput)
pub mod describe_traffic_mirror_targets_input {
    /// A builder for [`DescribeTrafficMirrorTargetsInput`](crate::input::DescribeTrafficMirrorTargetsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_target_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn traffic_mirror_target_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.traffic_mirror_target_ids.unwrap_or_default();
            v.push(input.into());
            self.traffic_mirror_target_ids = Some(v);
            self
        }
        pub fn set_traffic_mirror_target_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.traffic_mirror_target_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTrafficMirrorTargetsInput`](crate::input::DescribeTrafficMirrorTargetsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTrafficMirrorTargetsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTrafficMirrorTargetsInput {
                traffic_mirror_target_ids: self.traffic_mirror_target_ids,
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTrafficMirrorTargetsInputOperationOutputAlias =
    crate::operation::DescribeTrafficMirrorTargets;
#[doc(hidden)]
pub type DescribeTrafficMirrorTargetsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTrafficMirrorTargetsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTrafficMirrorTargets`](crate::operation::DescribeTrafficMirrorTargets)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTrafficMirrorTargets,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_traffic_mirror_targets(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTrafficMirrorTargets::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTrafficMirrorTargets",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTrafficMirrorTargetsInput`](crate::input::DescribeTrafficMirrorTargetsInput)
    pub fn builder() -> crate::input::describe_traffic_mirror_targets_input::Builder {
        crate::input::describe_traffic_mirror_targets_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewayAttachmentsInput`](crate::input::DescribeTransitGatewayAttachmentsInput)
pub mod describe_transit_gateway_attachments_input {
    /// A builder for [`DescribeTransitGatewayAttachmentsInput`](crate::input::DescribeTransitGatewayAttachmentsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_attachment_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.transit_gateway_attachment_ids.unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_attachment_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_attachment_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_attachment_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewayAttachmentsInput`](crate::input::DescribeTransitGatewayAttachmentsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewayAttachmentsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTransitGatewayAttachmentsInput {
                transit_gateway_attachment_ids: self.transit_gateway_attachment_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewayAttachmentsInputOperationOutputAlias =
    crate::operation::DescribeTransitGatewayAttachments;
#[doc(hidden)]
pub type DescribeTransitGatewayAttachmentsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewayAttachmentsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGatewayAttachments`](crate::operation::DescribeTransitGatewayAttachments)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGatewayAttachments,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_transit_gateway_attachments(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGatewayAttachments::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGatewayAttachments",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewayAttachmentsInput`](crate::input::DescribeTransitGatewayAttachmentsInput)
    pub fn builder() -> crate::input::describe_transit_gateway_attachments_input::Builder {
        crate::input::describe_transit_gateway_attachments_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewayConnectPeersInput`](crate::input::DescribeTransitGatewayConnectPeersInput)
pub mod describe_transit_gateway_connect_peers_input {
    /// A builder for [`DescribeTransitGatewayConnectPeersInput`](crate::input::DescribeTransitGatewayConnectPeersInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_connect_peer_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_connect_peer_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.transit_gateway_connect_peer_ids.unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_connect_peer_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_connect_peer_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_connect_peer_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewayConnectPeersInput`](crate::input::DescribeTransitGatewayConnectPeersInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewayConnectPeersInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTransitGatewayConnectPeersInput {
                transit_gateway_connect_peer_ids: self.transit_gateway_connect_peer_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewayConnectPeersInputOperationOutputAlias =
    crate::operation::DescribeTransitGatewayConnectPeers;
#[doc(hidden)]
pub type DescribeTransitGatewayConnectPeersInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewayConnectPeersInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGatewayConnectPeers`](crate::operation::DescribeTransitGatewayConnectPeers)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGatewayConnectPeers,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_transit_gateway_connect_peers(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGatewayConnectPeers::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGatewayConnectPeers",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewayConnectPeersInput`](crate::input::DescribeTransitGatewayConnectPeersInput)
    pub fn builder() -> crate::input::describe_transit_gateway_connect_peers_input::Builder {
        crate::input::describe_transit_gateway_connect_peers_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewayConnectsInput`](crate::input::DescribeTransitGatewayConnectsInput)
pub mod describe_transit_gateway_connects_input {
    /// A builder for [`DescribeTransitGatewayConnectsInput`](crate::input::DescribeTransitGatewayConnectsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_attachment_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.transit_gateway_attachment_ids.unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_attachment_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_attachment_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_attachment_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewayConnectsInput`](crate::input::DescribeTransitGatewayConnectsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewayConnectsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTransitGatewayConnectsInput {
                transit_gateway_attachment_ids: self.transit_gateway_attachment_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewayConnectsInputOperationOutputAlias =
    crate::operation::DescribeTransitGatewayConnects;
#[doc(hidden)]
pub type DescribeTransitGatewayConnectsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewayConnectsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGatewayConnects`](crate::operation::DescribeTransitGatewayConnects)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGatewayConnects,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_transit_gateway_connects(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGatewayConnects::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGatewayConnects",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewayConnectsInput`](crate::input::DescribeTransitGatewayConnectsInput)
    pub fn builder() -> crate::input::describe_transit_gateway_connects_input::Builder {
        crate::input::describe_transit_gateway_connects_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewayMulticastDomainsInput`](crate::input::DescribeTransitGatewayMulticastDomainsInput)
pub mod describe_transit_gateway_multicast_domains_input {
    /// A builder for [`DescribeTransitGatewayMulticastDomainsInput`](crate::input::DescribeTransitGatewayMulticastDomainsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_multicast_domain_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self
                .transit_gateway_multicast_domain_ids
                .unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_multicast_domain_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_multicast_domain_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_multicast_domain_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewayMulticastDomainsInput`](crate::input::DescribeTransitGatewayMulticastDomainsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewayMulticastDomainsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTransitGatewayMulticastDomainsInput {
                transit_gateway_multicast_domain_ids: self.transit_gateway_multicast_domain_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewayMulticastDomainsInputOperationOutputAlias =
    crate::operation::DescribeTransitGatewayMulticastDomains;
#[doc(hidden)]
pub type DescribeTransitGatewayMulticastDomainsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewayMulticastDomainsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGatewayMulticastDomains`](crate::operation::DescribeTransitGatewayMulticastDomains)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGatewayMulticastDomains,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_transit_gateway_multicast_domains(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGatewayMulticastDomains::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGatewayMulticastDomains",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewayMulticastDomainsInput`](crate::input::DescribeTransitGatewayMulticastDomainsInput)
    pub fn builder() -> crate::input::describe_transit_gateway_multicast_domains_input::Builder {
        crate::input::describe_transit_gateway_multicast_domains_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewayPeeringAttachmentsInput`](crate::input::DescribeTransitGatewayPeeringAttachmentsInput)
pub mod describe_transit_gateway_peering_attachments_input {
    /// A builder for [`DescribeTransitGatewayPeeringAttachmentsInput`](crate::input::DescribeTransitGatewayPeeringAttachmentsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_attachment_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.transit_gateway_attachment_ids.unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_attachment_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_attachment_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_attachment_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewayPeeringAttachmentsInput`](crate::input::DescribeTransitGatewayPeeringAttachmentsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewayPeeringAttachmentsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DescribeTransitGatewayPeeringAttachmentsInput {
                    transit_gateway_attachment_ids: self.transit_gateway_attachment_ids,
                    filters: self.filters,
                    max_results: self.max_results,
                    next_token: self.next_token,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewayPeeringAttachmentsInputOperationOutputAlias =
    crate::operation::DescribeTransitGatewayPeeringAttachments;
#[doc(hidden)]
pub type DescribeTransitGatewayPeeringAttachmentsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewayPeeringAttachmentsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGatewayPeeringAttachments`](crate::operation::DescribeTransitGatewayPeeringAttachments)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGatewayPeeringAttachments,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_transit_gateway_peering_attachments(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGatewayPeeringAttachments::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGatewayPeeringAttachments",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewayPeeringAttachmentsInput`](crate::input::DescribeTransitGatewayPeeringAttachmentsInput)
    pub fn builder() -> crate::input::describe_transit_gateway_peering_attachments_input::Builder {
        crate::input::describe_transit_gateway_peering_attachments_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewayRouteTablesInput`](crate::input::DescribeTransitGatewayRouteTablesInput)
pub mod describe_transit_gateway_route_tables_input {
    /// A builder for [`DescribeTransitGatewayRouteTablesInput`](crate::input::DescribeTransitGatewayRouteTablesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_route_table_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.transit_gateway_route_table_ids.unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_route_table_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_route_table_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_route_table_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewayRouteTablesInput`](crate::input::DescribeTransitGatewayRouteTablesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewayRouteTablesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTransitGatewayRouteTablesInput {
                transit_gateway_route_table_ids: self.transit_gateway_route_table_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewayRouteTablesInputOperationOutputAlias =
    crate::operation::DescribeTransitGatewayRouteTables;
#[doc(hidden)]
pub type DescribeTransitGatewayRouteTablesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewayRouteTablesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGatewayRouteTables`](crate::operation::DescribeTransitGatewayRouteTables)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGatewayRouteTables,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_transit_gateway_route_tables(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGatewayRouteTables::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGatewayRouteTables",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewayRouteTablesInput`](crate::input::DescribeTransitGatewayRouteTablesInput)
    pub fn builder() -> crate::input::describe_transit_gateway_route_tables_input::Builder {
        crate::input::describe_transit_gateway_route_tables_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewaysInput`](crate::input::DescribeTransitGatewaysInput)
pub mod describe_transit_gateways_input {
    /// A builder for [`DescribeTransitGatewaysInput`](crate::input::DescribeTransitGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.transit_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewaysInput`](crate::input::DescribeTransitGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTransitGatewaysInput {
                transit_gateway_ids: self.transit_gateway_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewaysInputOperationOutputAlias =
    crate::operation::DescribeTransitGateways;
#[doc(hidden)]
pub type DescribeTransitGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGateways`](crate::operation::DescribeTransitGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_transit_gateways(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewaysInput`](crate::input::DescribeTransitGatewaysInput)
    pub fn builder() -> crate::input::describe_transit_gateways_input::Builder {
        crate::input::describe_transit_gateways_input::Builder::default()
    }
}

/// See [`DescribeTransitGatewayVpcAttachmentsInput`](crate::input::DescribeTransitGatewayVpcAttachmentsInput)
pub mod describe_transit_gateway_vpc_attachments_input {
    /// A builder for [`DescribeTransitGatewayVpcAttachmentsInput`](crate::input::DescribeTransitGatewayVpcAttachmentsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn transit_gateway_attachment_ids(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.transit_gateway_attachment_ids.unwrap_or_default();
            v.push(input.into());
            self.transit_gateway_attachment_ids = Some(v);
            self
        }
        pub fn set_transit_gateway_attachment_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.transit_gateway_attachment_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTransitGatewayVpcAttachmentsInput`](crate::input::DescribeTransitGatewayVpcAttachmentsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTransitGatewayVpcAttachmentsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTransitGatewayVpcAttachmentsInput {
                transit_gateway_attachment_ids: self.transit_gateway_attachment_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTransitGatewayVpcAttachmentsInputOperationOutputAlias =
    crate::operation::DescribeTransitGatewayVpcAttachments;
#[doc(hidden)]
pub type DescribeTransitGatewayVpcAttachmentsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeTransitGatewayVpcAttachmentsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTransitGatewayVpcAttachments`](crate::operation::DescribeTransitGatewayVpcAttachments)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTransitGatewayVpcAttachments,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_transit_gateway_vpc_attachments(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTransitGatewayVpcAttachments::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTransitGatewayVpcAttachments",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTransitGatewayVpcAttachmentsInput`](crate::input::DescribeTransitGatewayVpcAttachmentsInput)
    pub fn builder() -> crate::input::describe_transit_gateway_vpc_attachments_input::Builder {
        crate::input::describe_transit_gateway_vpc_attachments_input::Builder::default()
    }
}

/// See [`DescribeTrunkInterfaceAssociationsInput`](crate::input::DescribeTrunkInterfaceAssociationsInput)
pub mod describe_trunk_interface_associations_input {
    /// A builder for [`DescribeTrunkInterfaceAssociationsInput`](crate::input::DescribeTrunkInterfaceAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn association_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.association_ids.unwrap_or_default();
            v.push(input.into());
            self.association_ids = Some(v);
            self
        }
        pub fn set_association_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.association_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeTrunkInterfaceAssociationsInput`](crate::input::DescribeTrunkInterfaceAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeTrunkInterfaceAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeTrunkInterfaceAssociationsInput {
                association_ids: self.association_ids,
                dry_run: self.dry_run,
                filters: self.filters,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeTrunkInterfaceAssociationsInputOperationOutputAlias =
    crate::operation::DescribeTrunkInterfaceAssociations;
#[doc(hidden)]
pub type DescribeTrunkInterfaceAssociationsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeTrunkInterfaceAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeTrunkInterfaceAssociations`](crate::operation::DescribeTrunkInterfaceAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeTrunkInterfaceAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_trunk_interface_associations(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeTrunkInterfaceAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeTrunkInterfaceAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeTrunkInterfaceAssociationsInput`](crate::input::DescribeTrunkInterfaceAssociationsInput)
    pub fn builder() -> crate::input::describe_trunk_interface_associations_input::Builder {
        crate::input::describe_trunk_interface_associations_input::Builder::default()
    }
}

/// See [`DescribeVolumeAttributeInput`](crate::input::DescribeVolumeAttributeInput)
pub mod describe_volume_attribute_input {
    /// A builder for [`DescribeVolumeAttributeInput`](crate::input::DescribeVolumeAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::VolumeAttributeName>,
        pub(crate) volume_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The attribute of the volume. This parameter is required.</p>
        pub fn attribute(mut self, input: crate::model::VolumeAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::VolumeAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The ID of the volume.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVolumeAttributeInput`](crate::input::DescribeVolumeAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVolumeAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVolumeAttributeInput {
                attribute: self.attribute,
                volume_id: self.volume_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVolumeAttributeInputOperationOutputAlias =
    crate::operation::DescribeVolumeAttribute;
#[doc(hidden)]
pub type DescribeVolumeAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVolumeAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVolumeAttribute`](crate::operation::DescribeVolumeAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVolumeAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_volume_attribute(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVolumeAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVolumeAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVolumeAttributeInput`](crate::input::DescribeVolumeAttributeInput)
    pub fn builder() -> crate::input::describe_volume_attribute_input::Builder {
        crate::input::describe_volume_attribute_input::Builder::default()
    }
}

/// See [`DescribeVolumesInput`](crate::input::DescribeVolumesInput)
pub mod describe_volumes_input {
    /// A builder for [`DescribeVolumesInput`](crate::input::DescribeVolumesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) volume_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn volume_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.volume_ids.unwrap_or_default();
            v.push(input.into());
            self.volume_ids = Some(v);
            self
        }
        pub fn set_volume_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.volume_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of volume results returned by <code>DescribeVolumes</code> in paginated
        /// output. When this parameter is used, <code>DescribeVolumes</code> only returns
        /// <code>MaxResults</code> results in a single page along with a <code>NextToken</code>
        /// response element. The remaining results of the initial request can be seen by sending another
        /// <code>DescribeVolumes</code> request with the returned <code>NextToken</code> value. This
        /// value can be between 5 and 500; if <code>MaxResults</code> is given a value larger than 500,
        /// only 500 results are returned. If this parameter is not used, then
        /// <code>DescribeVolumes</code> returns all results. You cannot specify this parameter and the
        /// volume IDs parameter in the same request.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The <code>NextToken</code> value returned from a previous paginated
        /// <code>DescribeVolumes</code> request where <code>MaxResults</code> was used and the results
        /// exceeded the value of that parameter. Pagination continues from the end of the previous
        /// results that returned the <code>NextToken</code> value. This value is <code>null</code> when
        /// there are no more results to return.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVolumesInput`](crate::input::DescribeVolumesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVolumesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVolumesInput {
                filters: self.filters,
                volume_ids: self.volume_ids,
                dry_run: self.dry_run,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVolumesInputOperationOutputAlias = crate::operation::DescribeVolumes;
#[doc(hidden)]
pub type DescribeVolumesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVolumesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVolumes`](crate::operation::DescribeVolumes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVolumes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_volumes(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVolumes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVolumes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVolumesInput`](crate::input::DescribeVolumesInput)
    pub fn builder() -> crate::input::describe_volumes_input::Builder {
        crate::input::describe_volumes_input::Builder::default()
    }
}

/// See [`DescribeVolumesModificationsInput`](crate::input::DescribeVolumesModificationsInput)
pub mod describe_volumes_modifications_input {
    /// A builder for [`DescribeVolumesModificationsInput`](crate::input::DescribeVolumesModificationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) volume_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn volume_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.volume_ids.unwrap_or_default();
            v.push(input.into());
            self.volume_ids = Some(v);
            self
        }
        pub fn set_volume_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.volume_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The <code>nextToken</code> value returned by a previous paginated request.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results (up to a limit of 500) to be returned in a paginated
        /// request.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVolumesModificationsInput`](crate::input::DescribeVolumesModificationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVolumesModificationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVolumesModificationsInput {
                dry_run: self.dry_run,
                volume_ids: self.volume_ids,
                filters: self.filters,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVolumesModificationsInputOperationOutputAlias =
    crate::operation::DescribeVolumesModifications;
#[doc(hidden)]
pub type DescribeVolumesModificationsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVolumesModificationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVolumesModifications`](crate::operation::DescribeVolumesModifications)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVolumesModifications,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_volumes_modifications(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVolumesModifications::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVolumesModifications",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVolumesModificationsInput`](crate::input::DescribeVolumesModificationsInput)
    pub fn builder() -> crate::input::describe_volumes_modifications_input::Builder {
        crate::input::describe_volumes_modifications_input::Builder::default()
    }
}

/// See [`DescribeVolumeStatusInput`](crate::input::DescribeVolumeStatusInput)
pub mod describe_volume_status_input {
    /// A builder for [`DescribeVolumeStatusInput`](crate::input::DescribeVolumeStatusInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) volume_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of volume results returned by <code>DescribeVolumeStatus</code> in
        /// paginated output. When this parameter is used, the request only returns
        /// <code>MaxResults</code> results in a single page along with a <code>NextToken</code>
        /// response element. The remaining results of the initial request can be seen by sending another
        /// request with the returned <code>NextToken</code> value. This value can be between 5 and 1,000;
        /// if <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are returned.
        /// If this parameter is not used, then <code>DescribeVolumeStatus</code> returns all results. You
        /// cannot specify this parameter and the volume IDs parameter in the same request.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The <code>NextToken</code> value to include in a future <code>DescribeVolumeStatus</code>
        /// request. When the results of the request exceed <code>MaxResults</code>, this value can be
        /// used to retrieve the next page of results. This value is <code>null</code> when there are no
        /// more results to return.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn volume_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.volume_ids.unwrap_or_default();
            v.push(input.into());
            self.volume_ids = Some(v);
            self
        }
        pub fn set_volume_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.volume_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVolumeStatusInput`](crate::input::DescribeVolumeStatusInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVolumeStatusInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVolumeStatusInput {
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                volume_ids: self.volume_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVolumeStatusInputOperationOutputAlias = crate::operation::DescribeVolumeStatus;
#[doc(hidden)]
pub type DescribeVolumeStatusInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVolumeStatusInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVolumeStatus`](crate::operation::DescribeVolumeStatus)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVolumeStatus,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_volume_status(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVolumeStatus::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVolumeStatus",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVolumeStatusInput`](crate::input::DescribeVolumeStatusInput)
    pub fn builder() -> crate::input::describe_volume_status_input::Builder {
        crate::input::describe_volume_status_input::Builder::default()
    }
}

/// See [`DescribeVpcAttributeInput`](crate::input::DescribeVpcAttributeInput)
pub mod describe_vpc_attribute_input {
    /// A builder for [`DescribeVpcAttributeInput`](crate::input::DescribeVpcAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::VpcAttributeName>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The VPC attribute.</p>
        pub fn attribute(mut self, input: crate::model::VpcAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::VpcAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcAttributeInput`](crate::input::DescribeVpcAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcAttributeInput {
                attribute: self.attribute,
                vpc_id: self.vpc_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcAttributeInputOperationOutputAlias = crate::operation::DescribeVpcAttribute;
#[doc(hidden)]
pub type DescribeVpcAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcAttributeInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcAttribute`](crate::operation::DescribeVpcAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_vpc_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcAttributeInput`](crate::input::DescribeVpcAttributeInput)
    pub fn builder() -> crate::input::describe_vpc_attribute_input::Builder {
        crate::input::describe_vpc_attribute_input::Builder::default()
    }
}

/// See [`DescribeVpcClassicLinkInput`](crate::input::DescribeVpcClassicLinkInput)
pub mod describe_vpc_classic_link_input {
    /// A builder for [`DescribeVpcClassicLinkInput`](crate::input::DescribeVpcClassicLinkInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn vpc_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_ids = Some(v);
            self
        }
        pub fn set_vpc_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcClassicLinkInput`](crate::input::DescribeVpcClassicLinkInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcClassicLinkInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcClassicLinkInput {
                filters: self.filters,
                dry_run: self.dry_run,
                vpc_ids: self.vpc_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcClassicLinkInputOperationOutputAlias = crate::operation::DescribeVpcClassicLink;
#[doc(hidden)]
pub type DescribeVpcClassicLinkInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcClassicLinkInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcClassicLink`](crate::operation::DescribeVpcClassicLink)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcClassicLink,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_vpc_classic_link(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcClassicLink::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcClassicLink",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcClassicLinkInput`](crate::input::DescribeVpcClassicLinkInput)
    pub fn builder() -> crate::input::describe_vpc_classic_link_input::Builder {
        crate::input::describe_vpc_classic_link_input::Builder::default()
    }
}

/// See [`DescribeVpcClassicLinkDnsSupportInput`](crate::input::DescribeVpcClassicLinkDnsSupportInput)
pub mod describe_vpc_classic_link_dns_support_input {
    /// A builder for [`DescribeVpcClassicLinkDnsSupportInput`](crate::input::DescribeVpcClassicLinkDnsSupportInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) vpc_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        pub fn vpc_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_ids = Some(v);
            self
        }
        pub fn set_vpc_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcClassicLinkDnsSupportInput`](crate::input::DescribeVpcClassicLinkDnsSupportInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcClassicLinkDnsSupportInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcClassicLinkDnsSupportInput {
                max_results: self.max_results,
                next_token: self.next_token,
                vpc_ids: self.vpc_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcClassicLinkDnsSupportInputOperationOutputAlias =
    crate::operation::DescribeVpcClassicLinkDnsSupport;
#[doc(hidden)]
pub type DescribeVpcClassicLinkDnsSupportInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcClassicLinkDnsSupportInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcClassicLinkDnsSupport`](crate::operation::DescribeVpcClassicLinkDnsSupport)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcClassicLinkDnsSupport,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpc_classic_link_dns_support(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcClassicLinkDnsSupport::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcClassicLinkDnsSupport",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcClassicLinkDnsSupportInput`](crate::input::DescribeVpcClassicLinkDnsSupportInput)
    pub fn builder() -> crate::input::describe_vpc_classic_link_dns_support_input::Builder {
        crate::input::describe_vpc_classic_link_dns_support_input::Builder::default()
    }
}

/// See [`DescribeVpcEndpointConnectionNotificationsInput`](crate::input::DescribeVpcEndpointConnectionNotificationsInput)
pub mod describe_vpc_endpoint_connection_notifications_input {
    /// A builder for [`DescribeVpcEndpointConnectionNotificationsInput`](crate::input::DescribeVpcEndpointConnectionNotificationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) connection_notification_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the notification.</p>
        pub fn connection_notification_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.connection_notification_id = Some(input.into());
            self
        }
        pub fn set_connection_notification_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.connection_notification_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return in a single call. To retrieve the remaining
        /// results, make another request with the returned <code>NextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to request the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcEndpointConnectionNotificationsInput`](crate::input::DescribeVpcEndpointConnectionNotificationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcEndpointConnectionNotificationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DescribeVpcEndpointConnectionNotificationsInput {
                    dry_run: self.dry_run,
                    connection_notification_id: self.connection_notification_id,
                    filters: self.filters,
                    max_results: self.max_results,
                    next_token: self.next_token,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcEndpointConnectionNotificationsInputOperationOutputAlias =
    crate::operation::DescribeVpcEndpointConnectionNotifications;
#[doc(hidden)]
pub type DescribeVpcEndpointConnectionNotificationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeVpcEndpointConnectionNotificationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcEndpointConnectionNotifications`](crate::operation::DescribeVpcEndpointConnectionNotifications)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcEndpointConnectionNotifications,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpc_endpoint_connection_notifications(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcEndpointConnectionNotifications::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcEndpointConnectionNotifications",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcEndpointConnectionNotificationsInput`](crate::input::DescribeVpcEndpointConnectionNotificationsInput)
    pub fn builder() -> crate::input::describe_vpc_endpoint_connection_notifications_input::Builder
    {
        crate::input::describe_vpc_endpoint_connection_notifications_input::Builder::default()
    }
}

/// See [`DescribeVpcEndpointConnectionsInput`](crate::input::DescribeVpcEndpointConnectionsInput)
pub mod describe_vpc_endpoint_connections_input {
    /// A builder for [`DescribeVpcEndpointConnectionsInput`](crate::input::DescribeVpcEndpointConnectionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining
        /// results of the initial request can be seen by sending another request with the returned
        /// <code>NextToken</code> value. This value can be between 5 and 1,000; if
        /// <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are
        /// returned.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcEndpointConnectionsInput`](crate::input::DescribeVpcEndpointConnectionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcEndpointConnectionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcEndpointConnectionsInput {
                dry_run: self.dry_run,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcEndpointConnectionsInputOperationOutputAlias =
    crate::operation::DescribeVpcEndpointConnections;
#[doc(hidden)]
pub type DescribeVpcEndpointConnectionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcEndpointConnectionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcEndpointConnections`](crate::operation::DescribeVpcEndpointConnections)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcEndpointConnections,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpc_endpoint_connections(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcEndpointConnections::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcEndpointConnections",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcEndpointConnectionsInput`](crate::input::DescribeVpcEndpointConnectionsInput)
    pub fn builder() -> crate::input::describe_vpc_endpoint_connections_input::Builder {
        crate::input::describe_vpc_endpoint_connections_input::Builder::default()
    }
}

/// See [`DescribeVpcEndpointsInput`](crate::input::DescribeVpcEndpointsInput)
pub mod describe_vpc_endpoints_input {
    /// A builder for [`DescribeVpcEndpointsInput`](crate::input::DescribeVpcEndpointsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn vpc_endpoint_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_endpoint_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_endpoint_ids = Some(v);
            self
        }
        pub fn set_vpc_endpoint_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_endpoint_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of items to return for this request. The request returns a token that you can specify in a subsequent call to get the next set of results.</p>
        /// <p>Constraint: If the value is greater than 1,000, we return only 1,000 items.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of items to return. (You received this token from a prior call.)</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcEndpointsInput`](crate::input::DescribeVpcEndpointsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcEndpointsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcEndpointsInput {
                dry_run: self.dry_run,
                vpc_endpoint_ids: self.vpc_endpoint_ids,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcEndpointsInputOperationOutputAlias = crate::operation::DescribeVpcEndpoints;
#[doc(hidden)]
pub type DescribeVpcEndpointsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcEndpointsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcEndpoints`](crate::operation::DescribeVpcEndpoints)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcEndpoints,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_vpc_endpoints(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcEndpoints::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcEndpoints",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcEndpointsInput`](crate::input::DescribeVpcEndpointsInput)
    pub fn builder() -> crate::input::describe_vpc_endpoints_input::Builder {
        crate::input::describe_vpc_endpoints_input::Builder::default()
    }
}

/// See [`DescribeVpcEndpointServiceConfigurationsInput`](crate::input::DescribeVpcEndpointServiceConfigurationsInput)
pub mod describe_vpc_endpoint_service_configurations_input {
    /// A builder for [`DescribeVpcEndpointServiceConfigurationsInput`](crate::input::DescribeVpcEndpointServiceConfigurationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn service_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.service_ids.unwrap_or_default();
            v.push(input.into());
            self.service_ids = Some(v);
            self
        }
        pub fn set_service_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.service_ids = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining
        /// results of the initial request can be seen by sending another request with the returned
        /// <code>NextToken</code> value. This value can be between 5 and 1,000; if
        /// <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are
        /// returned.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcEndpointServiceConfigurationsInput`](crate::input::DescribeVpcEndpointServiceConfigurationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcEndpointServiceConfigurationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DescribeVpcEndpointServiceConfigurationsInput {
                    dry_run: self.dry_run,
                    service_ids: self.service_ids,
                    filters: self.filters,
                    max_results: self.max_results,
                    next_token: self.next_token,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcEndpointServiceConfigurationsInputOperationOutputAlias =
    crate::operation::DescribeVpcEndpointServiceConfigurations;
#[doc(hidden)]
pub type DescribeVpcEndpointServiceConfigurationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeVpcEndpointServiceConfigurationsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcEndpointServiceConfigurations`](crate::operation::DescribeVpcEndpointServiceConfigurations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcEndpointServiceConfigurations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpc_endpoint_service_configurations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcEndpointServiceConfigurations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcEndpointServiceConfigurations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcEndpointServiceConfigurationsInput`](crate::input::DescribeVpcEndpointServiceConfigurationsInput)
    pub fn builder() -> crate::input::describe_vpc_endpoint_service_configurations_input::Builder {
        crate::input::describe_vpc_endpoint_service_configurations_input::Builder::default()
    }
}

/// See [`DescribeVpcEndpointServicePermissionsInput`](crate::input::DescribeVpcEndpointServicePermissionsInput)
pub mod describe_vpc_endpoint_service_permissions_input {
    /// A builder for [`DescribeVpcEndpointServicePermissionsInput`](crate::input::DescribeVpcEndpointServicePermissionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the service.</p>
        pub fn service_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_id = Some(input.into());
            self
        }
        pub fn set_service_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining
        /// results of the initial request can be seen by sending another request with the returned
        /// <code>NextToken</code> value. This value can be between 5 and 1,000; if
        /// <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are
        /// returned.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcEndpointServicePermissionsInput`](crate::input::DescribeVpcEndpointServicePermissionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcEndpointServicePermissionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcEndpointServicePermissionsInput {
                dry_run: self.dry_run,
                service_id: self.service_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcEndpointServicePermissionsInputOperationOutputAlias =
    crate::operation::DescribeVpcEndpointServicePermissions;
#[doc(hidden)]
pub type DescribeVpcEndpointServicePermissionsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DescribeVpcEndpointServicePermissionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcEndpointServicePermissions`](crate::operation::DescribeVpcEndpointServicePermissions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcEndpointServicePermissions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpc_endpoint_service_permissions(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcEndpointServicePermissions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcEndpointServicePermissions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcEndpointServicePermissionsInput`](crate::input::DescribeVpcEndpointServicePermissionsInput)
    pub fn builder() -> crate::input::describe_vpc_endpoint_service_permissions_input::Builder {
        crate::input::describe_vpc_endpoint_service_permissions_input::Builder::default()
    }
}

/// See [`DescribeVpcEndpointServicesInput`](crate::input::DescribeVpcEndpointServicesInput)
pub mod describe_vpc_endpoint_services_input {
    /// A builder for [`DescribeVpcEndpointServicesInput`](crate::input::DescribeVpcEndpointServicesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn service_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.service_names.unwrap_or_default();
            v.push(input.into());
            self.service_names = Some(v);
            self
        }
        pub fn set_service_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.service_names = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of items to return for this request. The request returns a token that you can specify in a subsequent call to get the next set of results.</p>
        /// <p>Constraint: If the value is greater than 1,000, we return only 1,000 items.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next set of items to return. (You received this token from a prior call.)</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcEndpointServicesInput`](crate::input::DescribeVpcEndpointServicesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcEndpointServicesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcEndpointServicesInput {
                dry_run: self.dry_run,
                service_names: self.service_names,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcEndpointServicesInputOperationOutputAlias =
    crate::operation::DescribeVpcEndpointServices;
#[doc(hidden)]
pub type DescribeVpcEndpointServicesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcEndpointServicesInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcEndpointServices`](crate::operation::DescribeVpcEndpointServices)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcEndpointServices,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpc_endpoint_services(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcEndpointServices::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcEndpointServices",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcEndpointServicesInput`](crate::input::DescribeVpcEndpointServicesInput)
    pub fn builder() -> crate::input::describe_vpc_endpoint_services_input::Builder {
        crate::input::describe_vpc_endpoint_services_input::Builder::default()
    }
}

/// See [`DescribeVpcPeeringConnectionsInput`](crate::input::DescribeVpcPeeringConnectionsInput)
pub mod describe_vpc_peering_connections_input {
    /// A builder for [`DescribeVpcPeeringConnectionsInput`](crate::input::DescribeVpcPeeringConnectionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_peering_connection_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn vpc_peering_connection_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_peering_connection_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_peering_connection_ids = Some(v);
            self
        }
        pub fn set_vpc_peering_connection_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_peering_connection_ids = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcPeeringConnectionsInput`](crate::input::DescribeVpcPeeringConnectionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpcPeeringConnectionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpcPeeringConnectionsInput {
                filters: self.filters,
                dry_run: self.dry_run,
                vpc_peering_connection_ids: self.vpc_peering_connection_ids,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcPeeringConnectionsInputOperationOutputAlias =
    crate::operation::DescribeVpcPeeringConnections;
#[doc(hidden)]
pub type DescribeVpcPeeringConnectionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcPeeringConnectionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcPeeringConnections`](crate::operation::DescribeVpcPeeringConnections)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcPeeringConnections,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpc_peering_connections(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcPeeringConnections::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpcPeeringConnections",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcPeeringConnectionsInput`](crate::input::DescribeVpcPeeringConnectionsInput)
    pub fn builder() -> crate::input::describe_vpc_peering_connections_input::Builder {
        crate::input::describe_vpc_peering_connections_input::Builder::default()
    }
}

/// See [`DescribeVpcsInput`](crate::input::DescribeVpcsInput)
pub mod describe_vpcs_input {
    /// A builder for [`DescribeVpcsInput`](crate::input::DescribeVpcsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) vpc_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn vpc_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_ids = Some(v);
            self
        }
        pub fn set_vpc_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpcsInput`](crate::input::DescribeVpcsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DescribeVpcsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DescribeVpcsInput {
                filters: self.filters,
                vpc_ids: self.vpc_ids,
                dry_run: self.dry_run,
                next_token: self.next_token,
                max_results: self.max_results,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpcsInputOperationOutputAlias = crate::operation::DescribeVpcs;
#[doc(hidden)]
pub type DescribeVpcsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpcsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpcs`](crate::operation::DescribeVpcs)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpcs,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_describe_vpcs(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpcs::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DescribeVpcs", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpcsInput`](crate::input::DescribeVpcsInput)
    pub fn builder() -> crate::input::describe_vpcs_input::Builder {
        crate::input::describe_vpcs_input::Builder::default()
    }
}

/// See [`DescribeVpnConnectionsInput`](crate::input::DescribeVpnConnectionsInput)
pub mod describe_vpn_connections_input {
    /// A builder for [`DescribeVpnConnectionsInput`](crate::input::DescribeVpnConnectionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) vpn_connection_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn vpn_connection_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpn_connection_ids.unwrap_or_default();
            v.push(input.into());
            self.vpn_connection_ids = Some(v);
            self
        }
        pub fn set_vpn_connection_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpn_connection_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpnConnectionsInput`](crate::input::DescribeVpnConnectionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpnConnectionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpnConnectionsInput {
                filters: self.filters,
                vpn_connection_ids: self.vpn_connection_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpnConnectionsInputOperationOutputAlias = crate::operation::DescribeVpnConnections;
#[doc(hidden)]
pub type DescribeVpnConnectionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpnConnectionsInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpnConnections`](crate::operation::DescribeVpnConnections)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpnConnections,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_vpn_connections(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpnConnections::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpnConnections",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpnConnectionsInput`](crate::input::DescribeVpnConnectionsInput)
    pub fn builder() -> crate::input::describe_vpn_connections_input::Builder {
        crate::input::describe_vpn_connections_input::Builder::default()
    }
}

/// See [`DescribeVpnGatewaysInput`](crate::input::DescribeVpnGatewaysInput)
pub mod describe_vpn_gateways_input {
    /// A builder for [`DescribeVpnGatewaysInput`](crate::input::DescribeVpnGatewaysInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) vpn_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        pub fn vpn_gateway_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpn_gateway_ids.unwrap_or_default();
            v.push(input.into());
            self.vpn_gateway_ids = Some(v);
            self
        }
        pub fn set_vpn_gateway_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpn_gateway_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DescribeVpnGatewaysInput`](crate::input::DescribeVpnGatewaysInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DescribeVpnGatewaysInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DescribeVpnGatewaysInput {
                filters: self.filters,
                vpn_gateway_ids: self.vpn_gateway_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DescribeVpnGatewaysInputOperationOutputAlias = crate::operation::DescribeVpnGateways;
#[doc(hidden)]
pub type DescribeVpnGatewaysInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DescribeVpnGatewaysInput {
    /// Consumes the builder and constructs an Operation<[`DescribeVpnGateways`](crate::operation::DescribeVpnGateways)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DescribeVpnGateways,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_describe_vpn_gateways(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DescribeVpnGateways::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DescribeVpnGateways",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DescribeVpnGatewaysInput`](crate::input::DescribeVpnGatewaysInput)
    pub fn builder() -> crate::input::describe_vpn_gateways_input::Builder {
        crate::input::describe_vpn_gateways_input::Builder::default()
    }
}

/// See [`DetachClassicLinkVpcInput`](crate::input::DetachClassicLinkVpcInput)
pub mod detach_classic_link_vpc_input {
    /// A builder for [`DetachClassicLinkVpcInput`](crate::input::DetachClassicLinkVpcInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance to unlink from the VPC.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The ID of the VPC to which the instance is linked.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DetachClassicLinkVpcInput`](crate::input::DetachClassicLinkVpcInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DetachClassicLinkVpcInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DetachClassicLinkVpcInput {
                dry_run: self.dry_run,
                instance_id: self.instance_id,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DetachClassicLinkVpcInputOperationOutputAlias = crate::operation::DetachClassicLinkVpc;
#[doc(hidden)]
pub type DetachClassicLinkVpcInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DetachClassicLinkVpcInput {
    /// Consumes the builder and constructs an Operation<[`DetachClassicLinkVpc`](crate::operation::DetachClassicLinkVpc)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DetachClassicLinkVpc,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_detach_classic_link_vpc(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DetachClassicLinkVpc::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DetachClassicLinkVpc",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DetachClassicLinkVpcInput`](crate::input::DetachClassicLinkVpcInput)
    pub fn builder() -> crate::input::detach_classic_link_vpc_input::Builder {
        crate::input::detach_classic_link_vpc_input::Builder::default()
    }
}

/// See [`DetachInternetGatewayInput`](crate::input::DetachInternetGatewayInput)
pub mod detach_internet_gateway_input {
    /// A builder for [`DetachInternetGatewayInput`](crate::input::DetachInternetGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) internet_gateway_id: std::option::Option<std::string::String>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the internet gateway.</p>
        pub fn internet_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.internet_gateway_id = Some(input.into());
            self
        }
        pub fn set_internet_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.internet_gateway_id = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DetachInternetGatewayInput`](crate::input::DetachInternetGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DetachInternetGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DetachInternetGatewayInput {
                dry_run: self.dry_run,
                internet_gateway_id: self.internet_gateway_id,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DetachInternetGatewayInputOperationOutputAlias = crate::operation::DetachInternetGateway;
#[doc(hidden)]
pub type DetachInternetGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DetachInternetGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DetachInternetGateway`](crate::operation::DetachInternetGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DetachInternetGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_detach_internet_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DetachInternetGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DetachInternetGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DetachInternetGatewayInput`](crate::input::DetachInternetGatewayInput)
    pub fn builder() -> crate::input::detach_internet_gateway_input::Builder {
        crate::input::detach_internet_gateway_input::Builder::default()
    }
}

/// See [`DetachNetworkInterfaceInput`](crate::input::DetachNetworkInterfaceInput)
pub mod detach_network_interface_input {
    /// A builder for [`DetachNetworkInterfaceInput`](crate::input::DetachNetworkInterfaceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) force: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the attachment.</p>
        pub fn attachment_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.attachment_id = Some(input.into());
            self
        }
        pub fn set_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Specifies whether to force a detachment.</p>
        /// <note>
        /// <ul>
        /// <li>
        /// <p>Use the <code>Force</code> parameter only as a last resort to detach a network interface from a failed instance. </p>
        /// </li>
        /// <li>
        /// <p>If you use the <code>Force</code> parameter to detach a network interface, you might not be able to attach a different network interface to the same index on the instance without first stopping and starting the instance.</p>
        /// </li>
        /// <li>
        /// <p>If you force the detachment of a network interface, the <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html">instance metadata</a>
        /// might not get updated. This means that the attributes associated
        /// with the detached network interface might still be visible. The
        /// instance metadata will get updated when you stop and start the
        /// instance.</p>
        /// </li>
        /// </ul>
        /// </note>
        pub fn force(mut self, input: bool) -> Self {
            self.force = Some(input);
            self
        }
        pub fn set_force(mut self, input: std::option::Option<bool>) -> Self {
            self.force = input;
            self
        }
        /// Consumes the builder and constructs a [`DetachNetworkInterfaceInput`](crate::input::DetachNetworkInterfaceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DetachNetworkInterfaceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DetachNetworkInterfaceInput {
                attachment_id: self.attachment_id,
                dry_run: self.dry_run,
                force: self.force,
            })
        }
    }
}
#[doc(hidden)]
pub type DetachNetworkInterfaceInputOperationOutputAlias = crate::operation::DetachNetworkInterface;
#[doc(hidden)]
pub type DetachNetworkInterfaceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DetachNetworkInterfaceInput {
    /// Consumes the builder and constructs an Operation<[`DetachNetworkInterface`](crate::operation::DetachNetworkInterface)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DetachNetworkInterface,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_detach_network_interface(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DetachNetworkInterface::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DetachNetworkInterface",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DetachNetworkInterfaceInput`](crate::input::DetachNetworkInterfaceInput)
    pub fn builder() -> crate::input::detach_network_interface_input::Builder {
        crate::input::detach_network_interface_input::Builder::default()
    }
}

/// See [`DetachVolumeInput`](crate::input::DetachVolumeInput)
pub mod detach_volume_input {
    /// A builder for [`DetachVolumeInput`](crate::input::DetachVolumeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) device: std::option::Option<std::string::String>,
        pub(crate) force: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) volume_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The device name.</p>
        pub fn device(mut self, input: impl Into<std::string::String>) -> Self {
            self.device = Some(input.into());
            self
        }
        pub fn set_device(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.device = input;
            self
        }
        /// <p>Forces detachment if the previous detachment attempt did not occur cleanly (for example,
        /// logging into an instance, unmounting the volume, and detaching normally). This option can lead
        /// to data loss or a corrupted file system. Use this option only as a last resort to detach a
        /// volume from a failed instance. The instance won't have an opportunity to flush file system
        /// caches or file system metadata. If you use this option, you must perform file system check and
        /// repair procedures.</p>
        pub fn force(mut self, input: bool) -> Self {
            self.force = Some(input);
            self
        }
        pub fn set_force(mut self, input: std::option::Option<bool>) -> Self {
            self.force = input;
            self
        }
        /// <p>The ID of the instance. If you are detaching a Multi-Attach enabled volume, you must specify an instance ID.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The ID of the volume.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DetachVolumeInput`](crate::input::DetachVolumeInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::DetachVolumeInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::DetachVolumeInput {
                device: self.device,
                force: self.force,
                instance_id: self.instance_id,
                volume_id: self.volume_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DetachVolumeInputOperationOutputAlias = crate::operation::DetachVolume;
#[doc(hidden)]
pub type DetachVolumeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DetachVolumeInput {
    /// Consumes the builder and constructs an Operation<[`DetachVolume`](crate::operation::DetachVolume)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DetachVolume,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_detach_volume(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DetachVolume::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("DetachVolume", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DetachVolumeInput`](crate::input::DetachVolumeInput)
    pub fn builder() -> crate::input::detach_volume_input::Builder {
        crate::input::detach_volume_input::Builder::default()
    }
}

/// See [`DetachVpnGatewayInput`](crate::input::DetachVpnGatewayInput)
pub mod detach_vpn_gateway_input {
    /// A builder for [`DetachVpnGatewayInput`](crate::input::DetachVpnGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) vpn_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>The ID of the virtual private gateway.</p>
        pub fn vpn_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_gateway_id = Some(input.into());
            self
        }
        pub fn set_vpn_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DetachVpnGatewayInput`](crate::input::DetachVpnGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DetachVpnGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DetachVpnGatewayInput {
                vpc_id: self.vpc_id,
                vpn_gateway_id: self.vpn_gateway_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DetachVpnGatewayInputOperationOutputAlias = crate::operation::DetachVpnGateway;
#[doc(hidden)]
pub type DetachVpnGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DetachVpnGatewayInput {
    /// Consumes the builder and constructs an Operation<[`DetachVpnGateway`](crate::operation::DetachVpnGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DetachVpnGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_detach_vpn_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DetachVpnGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DetachVpnGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DetachVpnGatewayInput`](crate::input::DetachVpnGatewayInput)
    pub fn builder() -> crate::input::detach_vpn_gateway_input::Builder {
        crate::input::detach_vpn_gateway_input::Builder::default()
    }
}

/// See [`DisableEbsEncryptionByDefaultInput`](crate::input::DisableEbsEncryptionByDefaultInput)
pub mod disable_ebs_encryption_by_default_input {
    /// A builder for [`DisableEbsEncryptionByDefaultInput`](crate::input::DisableEbsEncryptionByDefaultInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableEbsEncryptionByDefaultInput`](crate::input::DisableEbsEncryptionByDefaultInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableEbsEncryptionByDefaultInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisableEbsEncryptionByDefaultInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisableEbsEncryptionByDefaultInputOperationOutputAlias =
    crate::operation::DisableEbsEncryptionByDefault;
#[doc(hidden)]
pub type DisableEbsEncryptionByDefaultInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisableEbsEncryptionByDefaultInput {
    /// Consumes the builder and constructs an Operation<[`DisableEbsEncryptionByDefault`](crate::operation::DisableEbsEncryptionByDefault)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableEbsEncryptionByDefault,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disable_ebs_encryption_by_default(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableEbsEncryptionByDefault::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableEbsEncryptionByDefault",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableEbsEncryptionByDefaultInput`](crate::input::DisableEbsEncryptionByDefaultInput)
    pub fn builder() -> crate::input::disable_ebs_encryption_by_default_input::Builder {
        crate::input::disable_ebs_encryption_by_default_input::Builder::default()
    }
}

/// See [`DisableFastSnapshotRestoresInput`](crate::input::DisableFastSnapshotRestoresInput)
pub mod disable_fast_snapshot_restores_input {
    /// A builder for [`DisableFastSnapshotRestoresInput`](crate::input::DisableFastSnapshotRestoresInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zones: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) source_snapshot_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn availability_zones(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.availability_zones.unwrap_or_default();
            v.push(input.into());
            self.availability_zones = Some(v);
            self
        }
        pub fn set_availability_zones(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.availability_zones = input;
            self
        }
        pub fn source_snapshot_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.source_snapshot_ids.unwrap_or_default();
            v.push(input.into());
            self.source_snapshot_ids = Some(v);
            self
        }
        pub fn set_source_snapshot_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.source_snapshot_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableFastSnapshotRestoresInput`](crate::input::DisableFastSnapshotRestoresInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableFastSnapshotRestoresInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisableFastSnapshotRestoresInput {
                availability_zones: self.availability_zones,
                source_snapshot_ids: self.source_snapshot_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisableFastSnapshotRestoresInputOperationOutputAlias =
    crate::operation::DisableFastSnapshotRestores;
#[doc(hidden)]
pub type DisableFastSnapshotRestoresInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisableFastSnapshotRestoresInput {
    /// Consumes the builder and constructs an Operation<[`DisableFastSnapshotRestores`](crate::operation::DisableFastSnapshotRestores)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableFastSnapshotRestores,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disable_fast_snapshot_restores(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableFastSnapshotRestores::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableFastSnapshotRestores",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableFastSnapshotRestoresInput`](crate::input::DisableFastSnapshotRestoresInput)
    pub fn builder() -> crate::input::disable_fast_snapshot_restores_input::Builder {
        crate::input::disable_fast_snapshot_restores_input::Builder::default()
    }
}

/// See [`DisableImageDeprecationInput`](crate::input::DisableImageDeprecationInput)
pub mod disable_image_deprecation_input {
    /// A builder for [`DisableImageDeprecationInput`](crate::input::DisableImageDeprecationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the AMI.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableImageDeprecationInput`](crate::input::DisableImageDeprecationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableImageDeprecationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisableImageDeprecationInput {
                image_id: self.image_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisableImageDeprecationInputOperationOutputAlias =
    crate::operation::DisableImageDeprecation;
#[doc(hidden)]
pub type DisableImageDeprecationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisableImageDeprecationInput {
    /// Consumes the builder and constructs an Operation<[`DisableImageDeprecation`](crate::operation::DisableImageDeprecation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableImageDeprecation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_disable_image_deprecation(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableImageDeprecation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableImageDeprecation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableImageDeprecationInput`](crate::input::DisableImageDeprecationInput)
    pub fn builder() -> crate::input::disable_image_deprecation_input::Builder {
        crate::input::disable_image_deprecation_input::Builder::default()
    }
}

/// See [`DisableSerialConsoleAccessInput`](crate::input::DisableSerialConsoleAccessInput)
pub mod disable_serial_console_access_input {
    /// A builder for [`DisableSerialConsoleAccessInput`](crate::input::DisableSerialConsoleAccessInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableSerialConsoleAccessInput`](crate::input::DisableSerialConsoleAccessInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableSerialConsoleAccessInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisableSerialConsoleAccessInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisableSerialConsoleAccessInputOperationOutputAlias =
    crate::operation::DisableSerialConsoleAccess;
#[doc(hidden)]
pub type DisableSerialConsoleAccessInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisableSerialConsoleAccessInput {
    /// Consumes the builder and constructs an Operation<[`DisableSerialConsoleAccess`](crate::operation::DisableSerialConsoleAccess)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableSerialConsoleAccess,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disable_serial_console_access(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableSerialConsoleAccess::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableSerialConsoleAccess",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableSerialConsoleAccessInput`](crate::input::DisableSerialConsoleAccessInput)
    pub fn builder() -> crate::input::disable_serial_console_access_input::Builder {
        crate::input::disable_serial_console_access_input::Builder::default()
    }
}

/// See [`DisableTransitGatewayRouteTablePropagationInput`](crate::input::DisableTransitGatewayRouteTablePropagationInput)
pub mod disable_transit_gateway_route_table_propagation_input {
    /// A builder for [`DisableTransitGatewayRouteTablePropagationInput`](crate::input::DisableTransitGatewayRouteTablePropagationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the propagation route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableTransitGatewayRouteTablePropagationInput`](crate::input::DisableTransitGatewayRouteTablePropagationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableTransitGatewayRouteTablePropagationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DisableTransitGatewayRouteTablePropagationInput {
                    transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                    transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DisableTransitGatewayRouteTablePropagationInputOperationOutputAlias =
    crate::operation::DisableTransitGatewayRouteTablePropagation;
#[doc(hidden)]
pub type DisableTransitGatewayRouteTablePropagationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DisableTransitGatewayRouteTablePropagationInput {
    /// Consumes the builder and constructs an Operation<[`DisableTransitGatewayRouteTablePropagation`](crate::operation::DisableTransitGatewayRouteTablePropagation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableTransitGatewayRouteTablePropagation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disable_transit_gateway_route_table_propagation(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableTransitGatewayRouteTablePropagation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableTransitGatewayRouteTablePropagation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableTransitGatewayRouteTablePropagationInput`](crate::input::DisableTransitGatewayRouteTablePropagationInput)
    pub fn builder() -> crate::input::disable_transit_gateway_route_table_propagation_input::Builder
    {
        crate::input::disable_transit_gateway_route_table_propagation_input::Builder::default()
    }
}

/// See [`DisableVgwRoutePropagationInput`](crate::input::DisableVgwRoutePropagationInput)
pub mod disable_vgw_route_propagation_input {
    /// A builder for [`DisableVgwRoutePropagationInput`](crate::input::DisableVgwRoutePropagationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) gateway_id: std::option::Option<std::string::String>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the virtual private gateway.</p>
        pub fn gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.gateway_id = Some(input.into());
            self
        }
        pub fn set_gateway_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.gateway_id = input;
            self
        }
        /// <p>The ID of the route table.</p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableVgwRoutePropagationInput`](crate::input::DisableVgwRoutePropagationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableVgwRoutePropagationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisableVgwRoutePropagationInput {
                gateway_id: self.gateway_id,
                route_table_id: self.route_table_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisableVgwRoutePropagationInputOperationOutputAlias =
    crate::operation::DisableVgwRoutePropagation;
#[doc(hidden)]
pub type DisableVgwRoutePropagationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisableVgwRoutePropagationInput {
    /// Consumes the builder and constructs an Operation<[`DisableVgwRoutePropagation`](crate::operation::DisableVgwRoutePropagation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableVgwRoutePropagation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disable_vgw_route_propagation(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableVgwRoutePropagation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableVgwRoutePropagation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableVgwRoutePropagationInput`](crate::input::DisableVgwRoutePropagationInput)
    pub fn builder() -> crate::input::disable_vgw_route_propagation_input::Builder {
        crate::input::disable_vgw_route_propagation_input::Builder::default()
    }
}

/// See [`DisableVpcClassicLinkInput`](crate::input::DisableVpcClassicLinkInput)
pub mod disable_vpc_classic_link_input {
    /// A builder for [`DisableVpcClassicLinkInput`](crate::input::DisableVpcClassicLinkInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableVpcClassicLinkInput`](crate::input::DisableVpcClassicLinkInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableVpcClassicLinkInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisableVpcClassicLinkInput {
                dry_run: self.dry_run,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DisableVpcClassicLinkInputOperationOutputAlias = crate::operation::DisableVpcClassicLink;
#[doc(hidden)]
pub type DisableVpcClassicLinkInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisableVpcClassicLinkInput {
    /// Consumes the builder and constructs an Operation<[`DisableVpcClassicLink`](crate::operation::DisableVpcClassicLink)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableVpcClassicLink,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_disable_vpc_classic_link(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableVpcClassicLink::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableVpcClassicLink",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableVpcClassicLinkInput`](crate::input::DisableVpcClassicLinkInput)
    pub fn builder() -> crate::input::disable_vpc_classic_link_input::Builder {
        crate::input::disable_vpc_classic_link_input::Builder::default()
    }
}

/// See [`DisableVpcClassicLinkDnsSupportInput`](crate::input::DisableVpcClassicLinkDnsSupportInput)
pub mod disable_vpc_classic_link_dns_support_input {
    /// A builder for [`DisableVpcClassicLinkDnsSupportInput`](crate::input::DisableVpcClassicLinkDnsSupportInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DisableVpcClassicLinkDnsSupportInput`](crate::input::DisableVpcClassicLinkDnsSupportInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisableVpcClassicLinkDnsSupportInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisableVpcClassicLinkDnsSupportInput {
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DisableVpcClassicLinkDnsSupportInputOperationOutputAlias =
    crate::operation::DisableVpcClassicLinkDnsSupport;
#[doc(hidden)]
pub type DisableVpcClassicLinkDnsSupportInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisableVpcClassicLinkDnsSupportInput {
    /// Consumes the builder and constructs an Operation<[`DisableVpcClassicLinkDnsSupport`](crate::operation::DisableVpcClassicLinkDnsSupport)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisableVpcClassicLinkDnsSupport,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disable_vpc_classic_link_dns_support(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisableVpcClassicLinkDnsSupport::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisableVpcClassicLinkDnsSupport",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisableVpcClassicLinkDnsSupportInput`](crate::input::DisableVpcClassicLinkDnsSupportInput)
    pub fn builder() -> crate::input::disable_vpc_classic_link_dns_support_input::Builder {
        crate::input::disable_vpc_classic_link_dns_support_input::Builder::default()
    }
}

/// See [`DisassociateAddressInput`](crate::input::DisassociateAddressInput)
pub mod disassociate_address_input {
    /// A builder for [`DisassociateAddressInput`](crate::input::DisassociateAddressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
        pub(crate) public_ip: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>[EC2-VPC] The association ID. Required for EC2-VPC.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// <p>[EC2-Classic] The Elastic IP address. Required for EC2-Classic.</p>
        pub fn public_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.public_ip = Some(input.into());
            self
        }
        pub fn set_public_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.public_ip = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateAddressInput`](crate::input::DisassociateAddressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateAddressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateAddressInput {
                association_id: self.association_id,
                public_ip: self.public_ip,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateAddressInputOperationOutputAlias = crate::operation::DisassociateAddress;
#[doc(hidden)]
pub type DisassociateAddressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisassociateAddressInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateAddress`](crate::operation::DisassociateAddress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateAddress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_disassociate_address(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateAddress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateAddress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateAddressInput`](crate::input::DisassociateAddressInput)
    pub fn builder() -> crate::input::disassociate_address_input::Builder {
        crate::input::disassociate_address_input::Builder::default()
    }
}

/// See [`DisassociateClientVpnTargetNetworkInput`](crate::input::DisassociateClientVpnTargetNetworkInput)
pub mod disassociate_client_vpn_target_network_input {
    /// A builder for [`DisassociateClientVpnTargetNetworkInput`](crate::input::DisassociateClientVpnTargetNetworkInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) association_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint from which to disassociate the target network.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The ID of the target network association.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateClientVpnTargetNetworkInput`](crate::input::DisassociateClientVpnTargetNetworkInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateClientVpnTargetNetworkInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateClientVpnTargetNetworkInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                association_id: self.association_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateClientVpnTargetNetworkInputOperationOutputAlias =
    crate::operation::DisassociateClientVpnTargetNetwork;
#[doc(hidden)]
pub type DisassociateClientVpnTargetNetworkInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisassociateClientVpnTargetNetworkInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateClientVpnTargetNetwork`](crate::operation::DisassociateClientVpnTargetNetwork)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateClientVpnTargetNetwork,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disassociate_client_vpn_target_network(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateClientVpnTargetNetwork::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateClientVpnTargetNetwork",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateClientVpnTargetNetworkInput`](crate::input::DisassociateClientVpnTargetNetworkInput)
    pub fn builder() -> crate::input::disassociate_client_vpn_target_network_input::Builder {
        crate::input::disassociate_client_vpn_target_network_input::Builder::default()
    }
}

/// See [`DisassociateEnclaveCertificateIamRoleInput`](crate::input::DisassociateEnclaveCertificateIamRoleInput)
pub mod disassociate_enclave_certificate_iam_role_input {
    /// A builder for [`DisassociateEnclaveCertificateIamRoleInput`](crate::input::DisassociateEnclaveCertificateIamRoleInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) certificate_arn: std::option::Option<std::string::String>,
        pub(crate) role_arn: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ARN of the ACM certificate from which to disassociate the IAM role.</p>
        pub fn certificate_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.certificate_arn = Some(input.into());
            self
        }
        pub fn set_certificate_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.certificate_arn = input;
            self
        }
        /// <p>The ARN of the IAM role to disassociate.</p>
        pub fn role_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.role_arn = Some(input.into());
            self
        }
        pub fn set_role_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.role_arn = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateEnclaveCertificateIamRoleInput`](crate::input::DisassociateEnclaveCertificateIamRoleInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateEnclaveCertificateIamRoleInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateEnclaveCertificateIamRoleInput {
                certificate_arn: self.certificate_arn,
                role_arn: self.role_arn,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateEnclaveCertificateIamRoleInputOperationOutputAlias =
    crate::operation::DisassociateEnclaveCertificateIamRole;
#[doc(hidden)]
pub type DisassociateEnclaveCertificateIamRoleInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DisassociateEnclaveCertificateIamRoleInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateEnclaveCertificateIamRole`](crate::operation::DisassociateEnclaveCertificateIamRole)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateEnclaveCertificateIamRole,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disassociate_enclave_certificate_iam_role(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateEnclaveCertificateIamRole::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateEnclaveCertificateIamRole",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateEnclaveCertificateIamRoleInput`](crate::input::DisassociateEnclaveCertificateIamRoleInput)
    pub fn builder() -> crate::input::disassociate_enclave_certificate_iam_role_input::Builder {
        crate::input::disassociate_enclave_certificate_iam_role_input::Builder::default()
    }
}

/// See [`DisassociateIamInstanceProfileInput`](crate::input::DisassociateIamInstanceProfileInput)
pub mod disassociate_iam_instance_profile_input {
    /// A builder for [`DisassociateIamInstanceProfileInput`](crate::input::DisassociateIamInstanceProfileInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the IAM instance profile association.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateIamInstanceProfileInput`](crate::input::DisassociateIamInstanceProfileInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateIamInstanceProfileInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateIamInstanceProfileInput {
                association_id: self.association_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateIamInstanceProfileInputOperationOutputAlias =
    crate::operation::DisassociateIamInstanceProfile;
#[doc(hidden)]
pub type DisassociateIamInstanceProfileInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisassociateIamInstanceProfileInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateIamInstanceProfile`](crate::operation::DisassociateIamInstanceProfile)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateIamInstanceProfile,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disassociate_iam_instance_profile(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateIamInstanceProfile::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateIamInstanceProfile",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateIamInstanceProfileInput`](crate::input::DisassociateIamInstanceProfileInput)
    pub fn builder() -> crate::input::disassociate_iam_instance_profile_input::Builder {
        crate::input::disassociate_iam_instance_profile_input::Builder::default()
    }
}

/// See [`DisassociateRouteTableInput`](crate::input::DisassociateRouteTableInput)
pub mod disassociate_route_table_input {
    /// A builder for [`DisassociateRouteTableInput`](crate::input::DisassociateRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The association ID representing the current association between the route table and subnet or gateway.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateRouteTableInput`](crate::input::DisassociateRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateRouteTableInput {
                association_id: self.association_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateRouteTableInputOperationOutputAlias = crate::operation::DisassociateRouteTable;
#[doc(hidden)]
pub type DisassociateRouteTableInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisassociateRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateRouteTable`](crate::operation::DisassociateRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_disassociate_route_table(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateRouteTableInput`](crate::input::DisassociateRouteTableInput)
    pub fn builder() -> crate::input::disassociate_route_table_input::Builder {
        crate::input::disassociate_route_table_input::Builder::default()
    }
}

/// See [`DisassociateSubnetCidrBlockInput`](crate::input::DisassociateSubnetCidrBlockInput)
pub mod disassociate_subnet_cidr_block_input {
    /// A builder for [`DisassociateSubnetCidrBlockInput`](crate::input::DisassociateSubnetCidrBlockInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The association ID for the CIDR block.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateSubnetCidrBlockInput`](crate::input::DisassociateSubnetCidrBlockInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateSubnetCidrBlockInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateSubnetCidrBlockInput {
                association_id: self.association_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateSubnetCidrBlockInputOperationOutputAlias =
    crate::operation::DisassociateSubnetCidrBlock;
#[doc(hidden)]
pub type DisassociateSubnetCidrBlockInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisassociateSubnetCidrBlockInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateSubnetCidrBlock`](crate::operation::DisassociateSubnetCidrBlock)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateSubnetCidrBlock,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disassociate_subnet_cidr_block(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateSubnetCidrBlock::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateSubnetCidrBlock",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateSubnetCidrBlockInput`](crate::input::DisassociateSubnetCidrBlockInput)
    pub fn builder() -> crate::input::disassociate_subnet_cidr_block_input::Builder {
        crate::input::disassociate_subnet_cidr_block_input::Builder::default()
    }
}

/// See [`DisassociateTransitGatewayMulticastDomainInput`](crate::input::DisassociateTransitGatewayMulticastDomainInput)
pub mod disassociate_transit_gateway_multicast_domain_input {
    /// A builder for [`DisassociateTransitGatewayMulticastDomainInput`](crate::input::DisassociateTransitGatewayMulticastDomainInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        pub fn subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.subnet_ids = Some(v);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.subnet_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateTransitGatewayMulticastDomainInput`](crate::input::DisassociateTransitGatewayMulticastDomainInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateTransitGatewayMulticastDomainInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::DisassociateTransitGatewayMulticastDomainInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                    subnet_ids: self.subnet_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type DisassociateTransitGatewayMulticastDomainInputOperationOutputAlias =
    crate::operation::DisassociateTransitGatewayMulticastDomain;
#[doc(hidden)]
pub type DisassociateTransitGatewayMulticastDomainInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DisassociateTransitGatewayMulticastDomainInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateTransitGatewayMulticastDomain`](crate::operation::DisassociateTransitGatewayMulticastDomain)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateTransitGatewayMulticastDomain,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disassociate_transit_gateway_multicast_domain(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateTransitGatewayMulticastDomain::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateTransitGatewayMulticastDomain",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateTransitGatewayMulticastDomainInput`](crate::input::DisassociateTransitGatewayMulticastDomainInput)
    pub fn builder() -> crate::input::disassociate_transit_gateway_multicast_domain_input::Builder {
        crate::input::disassociate_transit_gateway_multicast_domain_input::Builder::default()
    }
}

/// See [`DisassociateTransitGatewayRouteTableInput`](crate::input::DisassociateTransitGatewayRouteTableInput)
pub mod disassociate_transit_gateway_route_table_input {
    /// A builder for [`DisassociateTransitGatewayRouteTableInput`](crate::input::DisassociateTransitGatewayRouteTableInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateTransitGatewayRouteTableInput`](crate::input::DisassociateTransitGatewayRouteTableInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateTransitGatewayRouteTableInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateTransitGatewayRouteTableInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateTransitGatewayRouteTableInputOperationOutputAlias =
    crate::operation::DisassociateTransitGatewayRouteTable;
#[doc(hidden)]
pub type DisassociateTransitGatewayRouteTableInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl DisassociateTransitGatewayRouteTableInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateTransitGatewayRouteTable`](crate::operation::DisassociateTransitGatewayRouteTable)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateTransitGatewayRouteTable,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disassociate_transit_gateway_route_table(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateTransitGatewayRouteTable::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateTransitGatewayRouteTable",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateTransitGatewayRouteTableInput`](crate::input::DisassociateTransitGatewayRouteTableInput)
    pub fn builder() -> crate::input::disassociate_transit_gateway_route_table_input::Builder {
        crate::input::disassociate_transit_gateway_route_table_input::Builder::default()
    }
}

/// See [`DisassociateTrunkInterfaceInput`](crate::input::DisassociateTrunkInterfaceInput)
pub mod disassociate_trunk_interface_input {
    /// A builder for [`DisassociateTrunkInterfaceInput`](crate::input::DisassociateTrunkInterfaceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID ofthe association</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateTrunkInterfaceInput`](crate::input::DisassociateTrunkInterfaceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateTrunkInterfaceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateTrunkInterfaceInput {
                association_id: self.association_id,
                client_token: self.client_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateTrunkInterfaceInputOperationOutputAlias =
    crate::operation::DisassociateTrunkInterface;
#[doc(hidden)]
pub type DisassociateTrunkInterfaceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisassociateTrunkInterfaceInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateTrunkInterface`](crate::operation::DisassociateTrunkInterface)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateTrunkInterface,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_disassociate_trunk_interface(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateTrunkInterface::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateTrunkInterface",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateTrunkInterfaceInput`](crate::input::DisassociateTrunkInterfaceInput)
    pub fn builder() -> crate::input::disassociate_trunk_interface_input::Builder {
        crate::input::disassociate_trunk_interface_input::Builder::default()
    }
}

/// See [`DisassociateVpcCidrBlockInput`](crate::input::DisassociateVpcCidrBlockInput)
pub mod disassociate_vpc_cidr_block_input {
    /// A builder for [`DisassociateVpcCidrBlockInput`](crate::input::DisassociateVpcCidrBlockInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The association ID for the CIDR block.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// Consumes the builder and constructs a [`DisassociateVpcCidrBlockInput`](crate::input::DisassociateVpcCidrBlockInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::DisassociateVpcCidrBlockInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::DisassociateVpcCidrBlockInput {
                association_id: self.association_id,
            })
        }
    }
}
#[doc(hidden)]
pub type DisassociateVpcCidrBlockInputOperationOutputAlias =
    crate::operation::DisassociateVpcCidrBlock;
#[doc(hidden)]
pub type DisassociateVpcCidrBlockInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl DisassociateVpcCidrBlockInput {
    /// Consumes the builder and constructs an Operation<[`DisassociateVpcCidrBlock`](crate::operation::DisassociateVpcCidrBlock)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::DisassociateVpcCidrBlock,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_disassociate_vpc_cidr_block(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::DisassociateVpcCidrBlock::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "DisassociateVpcCidrBlock",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`DisassociateVpcCidrBlockInput`](crate::input::DisassociateVpcCidrBlockInput)
    pub fn builder() -> crate::input::disassociate_vpc_cidr_block_input::Builder {
        crate::input::disassociate_vpc_cidr_block_input::Builder::default()
    }
}

/// See [`EnableEbsEncryptionByDefaultInput`](crate::input::EnableEbsEncryptionByDefaultInput)
pub mod enable_ebs_encryption_by_default_input {
    /// A builder for [`EnableEbsEncryptionByDefaultInput`](crate::input::EnableEbsEncryptionByDefaultInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableEbsEncryptionByDefaultInput`](crate::input::EnableEbsEncryptionByDefaultInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableEbsEncryptionByDefaultInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableEbsEncryptionByDefaultInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableEbsEncryptionByDefaultInputOperationOutputAlias =
    crate::operation::EnableEbsEncryptionByDefault;
#[doc(hidden)]
pub type EnableEbsEncryptionByDefaultInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableEbsEncryptionByDefaultInput {
    /// Consumes the builder and constructs an Operation<[`EnableEbsEncryptionByDefault`](crate::operation::EnableEbsEncryptionByDefault)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableEbsEncryptionByDefault,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_enable_ebs_encryption_by_default(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableEbsEncryptionByDefault::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableEbsEncryptionByDefault",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableEbsEncryptionByDefaultInput`](crate::input::EnableEbsEncryptionByDefaultInput)
    pub fn builder() -> crate::input::enable_ebs_encryption_by_default_input::Builder {
        crate::input::enable_ebs_encryption_by_default_input::Builder::default()
    }
}

/// See [`EnableFastSnapshotRestoresInput`](crate::input::EnableFastSnapshotRestoresInput)
pub mod enable_fast_snapshot_restores_input {
    /// A builder for [`EnableFastSnapshotRestoresInput`](crate::input::EnableFastSnapshotRestoresInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zones: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) source_snapshot_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn availability_zones(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.availability_zones.unwrap_or_default();
            v.push(input.into());
            self.availability_zones = Some(v);
            self
        }
        pub fn set_availability_zones(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.availability_zones = input;
            self
        }
        pub fn source_snapshot_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.source_snapshot_ids.unwrap_or_default();
            v.push(input.into());
            self.source_snapshot_ids = Some(v);
            self
        }
        pub fn set_source_snapshot_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.source_snapshot_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableFastSnapshotRestoresInput`](crate::input::EnableFastSnapshotRestoresInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableFastSnapshotRestoresInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableFastSnapshotRestoresInput {
                availability_zones: self.availability_zones,
                source_snapshot_ids: self.source_snapshot_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableFastSnapshotRestoresInputOperationOutputAlias =
    crate::operation::EnableFastSnapshotRestores;
#[doc(hidden)]
pub type EnableFastSnapshotRestoresInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableFastSnapshotRestoresInput {
    /// Consumes the builder and constructs an Operation<[`EnableFastSnapshotRestores`](crate::operation::EnableFastSnapshotRestores)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableFastSnapshotRestores,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_enable_fast_snapshot_restores(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableFastSnapshotRestores::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableFastSnapshotRestores",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableFastSnapshotRestoresInput`](crate::input::EnableFastSnapshotRestoresInput)
    pub fn builder() -> crate::input::enable_fast_snapshot_restores_input::Builder {
        crate::input::enable_fast_snapshot_restores_input::Builder::default()
    }
}

/// See [`EnableImageDeprecationInput`](crate::input::EnableImageDeprecationInput)
pub mod enable_image_deprecation_input {
    /// A builder for [`EnableImageDeprecationInput`](crate::input::EnableImageDeprecationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) deprecate_at: std::option::Option<smithy_types::Instant>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the AMI.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>The date and time to deprecate the AMI, in UTC, in the following format:
        /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z.
        /// If you specify a value for seconds, Amazon EC2 rounds the seconds to the
        /// nearest minute.</p>
        /// <p>You can’t specify a date in the past. The upper limit for <code>DeprecateAt</code> is 10
        /// years from now.</p>
        pub fn deprecate_at(mut self, input: smithy_types::Instant) -> Self {
            self.deprecate_at = Some(input);
            self
        }
        pub fn set_deprecate_at(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.deprecate_at = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableImageDeprecationInput`](crate::input::EnableImageDeprecationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableImageDeprecationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableImageDeprecationInput {
                image_id: self.image_id,
                deprecate_at: self.deprecate_at,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableImageDeprecationInputOperationOutputAlias = crate::operation::EnableImageDeprecation;
#[doc(hidden)]
pub type EnableImageDeprecationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableImageDeprecationInput {
    /// Consumes the builder and constructs an Operation<[`EnableImageDeprecation`](crate::operation::EnableImageDeprecation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableImageDeprecation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_enable_image_deprecation(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableImageDeprecation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableImageDeprecation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableImageDeprecationInput`](crate::input::EnableImageDeprecationInput)
    pub fn builder() -> crate::input::enable_image_deprecation_input::Builder {
        crate::input::enable_image_deprecation_input::Builder::default()
    }
}

/// See [`EnableSerialConsoleAccessInput`](crate::input::EnableSerialConsoleAccessInput)
pub mod enable_serial_console_access_input {
    /// A builder for [`EnableSerialConsoleAccessInput`](crate::input::EnableSerialConsoleAccessInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableSerialConsoleAccessInput`](crate::input::EnableSerialConsoleAccessInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableSerialConsoleAccessInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableSerialConsoleAccessInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableSerialConsoleAccessInputOperationOutputAlias =
    crate::operation::EnableSerialConsoleAccess;
#[doc(hidden)]
pub type EnableSerialConsoleAccessInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableSerialConsoleAccessInput {
    /// Consumes the builder and constructs an Operation<[`EnableSerialConsoleAccess`](crate::operation::EnableSerialConsoleAccess)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableSerialConsoleAccess,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_enable_serial_console_access(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableSerialConsoleAccess::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableSerialConsoleAccess",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableSerialConsoleAccessInput`](crate::input::EnableSerialConsoleAccessInput)
    pub fn builder() -> crate::input::enable_serial_console_access_input::Builder {
        crate::input::enable_serial_console_access_input::Builder::default()
    }
}

/// See [`EnableTransitGatewayRouteTablePropagationInput`](crate::input::EnableTransitGatewayRouteTablePropagationInput)
pub mod enable_transit_gateway_route_table_propagation_input {
    /// A builder for [`EnableTransitGatewayRouteTablePropagationInput`](crate::input::EnableTransitGatewayRouteTablePropagationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the propagation route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableTransitGatewayRouteTablePropagationInput`](crate::input::EnableTransitGatewayRouteTablePropagationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableTransitGatewayRouteTablePropagationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::EnableTransitGatewayRouteTablePropagationInput {
                    transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                    transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type EnableTransitGatewayRouteTablePropagationInputOperationOutputAlias =
    crate::operation::EnableTransitGatewayRouteTablePropagation;
#[doc(hidden)]
pub type EnableTransitGatewayRouteTablePropagationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl EnableTransitGatewayRouteTablePropagationInput {
    /// Consumes the builder and constructs an Operation<[`EnableTransitGatewayRouteTablePropagation`](crate::operation::EnableTransitGatewayRouteTablePropagation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableTransitGatewayRouteTablePropagation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_enable_transit_gateway_route_table_propagation(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableTransitGatewayRouteTablePropagation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableTransitGatewayRouteTablePropagation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableTransitGatewayRouteTablePropagationInput`](crate::input::EnableTransitGatewayRouteTablePropagationInput)
    pub fn builder() -> crate::input::enable_transit_gateway_route_table_propagation_input::Builder
    {
        crate::input::enable_transit_gateway_route_table_propagation_input::Builder::default()
    }
}

/// See [`EnableVgwRoutePropagationInput`](crate::input::EnableVgwRoutePropagationInput)
pub mod enable_vgw_route_propagation_input {
    /// A builder for [`EnableVgwRoutePropagationInput`](crate::input::EnableVgwRoutePropagationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) gateway_id: std::option::Option<std::string::String>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the virtual private gateway that is attached to a VPC. The virtual private gateway must be attached to the same VPC that the routing tables are associated with. </p>
        pub fn gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.gateway_id = Some(input.into());
            self
        }
        pub fn set_gateway_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.gateway_id = input;
            self
        }
        /// <p>The ID of the route table. The routing table must be associated with the same VPC that the virtual private gateway is attached to. </p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableVgwRoutePropagationInput`](crate::input::EnableVgwRoutePropagationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableVgwRoutePropagationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableVgwRoutePropagationInput {
                gateway_id: self.gateway_id,
                route_table_id: self.route_table_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableVgwRoutePropagationInputOperationOutputAlias =
    crate::operation::EnableVgwRoutePropagation;
#[doc(hidden)]
pub type EnableVgwRoutePropagationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableVgwRoutePropagationInput {
    /// Consumes the builder and constructs an Operation<[`EnableVgwRoutePropagation`](crate::operation::EnableVgwRoutePropagation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableVgwRoutePropagation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_enable_vgw_route_propagation(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableVgwRoutePropagation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableVgwRoutePropagation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableVgwRoutePropagationInput`](crate::input::EnableVgwRoutePropagationInput)
    pub fn builder() -> crate::input::enable_vgw_route_propagation_input::Builder {
        crate::input::enable_vgw_route_propagation_input::Builder::default()
    }
}

/// See [`EnableVolumeIoInput`](crate::input::EnableVolumeIoInput)
pub mod enable_volume_io_input {
    /// A builder for [`EnableVolumeIoInput`](crate::input::EnableVolumeIoInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) volume_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the volume.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableVolumeIoInput`](crate::input::EnableVolumeIoInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableVolumeIoInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableVolumeIoInput {
                dry_run: self.dry_run,
                volume_id: self.volume_id,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableVolumeIOInputOperationOutputAlias = crate::operation::EnableVolumeIO;
#[doc(hidden)]
pub type EnableVolumeIOInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableVolumeIoInput {
    /// Consumes the builder and constructs an Operation<[`EnableVolumeIO`](crate::operation::EnableVolumeIO)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableVolumeIO,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_enable_volume_io(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableVolumeIO::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableVolumeIO",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableVolumeIoInput`](crate::input::EnableVolumeIoInput)
    pub fn builder() -> crate::input::enable_volume_io_input::Builder {
        crate::input::enable_volume_io_input::Builder::default()
    }
}

/// See [`EnableVpcClassicLinkInput`](crate::input::EnableVpcClassicLinkInput)
pub mod enable_vpc_classic_link_input {
    /// A builder for [`EnableVpcClassicLinkInput`](crate::input::EnableVpcClassicLinkInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableVpcClassicLinkInput`](crate::input::EnableVpcClassicLinkInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableVpcClassicLinkInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableVpcClassicLinkInput {
                dry_run: self.dry_run,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableVpcClassicLinkInputOperationOutputAlias = crate::operation::EnableVpcClassicLink;
#[doc(hidden)]
pub type EnableVpcClassicLinkInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableVpcClassicLinkInput {
    /// Consumes the builder and constructs an Operation<[`EnableVpcClassicLink`](crate::operation::EnableVpcClassicLink)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableVpcClassicLink,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_enable_vpc_classic_link(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableVpcClassicLink::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableVpcClassicLink",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableVpcClassicLinkInput`](crate::input::EnableVpcClassicLinkInput)
    pub fn builder() -> crate::input::enable_vpc_classic_link_input::Builder {
        crate::input::enable_vpc_classic_link_input::Builder::default()
    }
}

/// See [`EnableVpcClassicLinkDnsSupportInput`](crate::input::EnableVpcClassicLinkDnsSupportInput)
pub mod enable_vpc_classic_link_dns_support_input {
    /// A builder for [`EnableVpcClassicLinkDnsSupportInput`](crate::input::EnableVpcClassicLinkDnsSupportInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`EnableVpcClassicLinkDnsSupportInput`](crate::input::EnableVpcClassicLinkDnsSupportInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::EnableVpcClassicLinkDnsSupportInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::EnableVpcClassicLinkDnsSupportInput {
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type EnableVpcClassicLinkDnsSupportInputOperationOutputAlias =
    crate::operation::EnableVpcClassicLinkDnsSupport;
#[doc(hidden)]
pub type EnableVpcClassicLinkDnsSupportInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl EnableVpcClassicLinkDnsSupportInput {
    /// Consumes the builder and constructs an Operation<[`EnableVpcClassicLinkDnsSupport`](crate::operation::EnableVpcClassicLinkDnsSupport)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::EnableVpcClassicLinkDnsSupport,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_enable_vpc_classic_link_dns_support(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::EnableVpcClassicLinkDnsSupport::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "EnableVpcClassicLinkDnsSupport",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`EnableVpcClassicLinkDnsSupportInput`](crate::input::EnableVpcClassicLinkDnsSupportInput)
    pub fn builder() -> crate::input::enable_vpc_classic_link_dns_support_input::Builder {
        crate::input::enable_vpc_classic_link_dns_support_input::Builder::default()
    }
}

/// See [`ExportClientVpnClientCertificateRevocationListInput`](crate::input::ExportClientVpnClientCertificateRevocationListInput)
pub mod export_client_vpn_client_certificate_revocation_list_input {
    /// A builder for [`ExportClientVpnClientCertificateRevocationListInput`](crate::input::ExportClientVpnClientCertificateRevocationListInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ExportClientVpnClientCertificateRevocationListInput`](crate::input::ExportClientVpnClientCertificateRevocationListInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ExportClientVpnClientCertificateRevocationListInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::ExportClientVpnClientCertificateRevocationListInput {
                    client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type ExportClientVpnClientCertificateRevocationListInputOperationOutputAlias =
    crate::operation::ExportClientVpnClientCertificateRevocationList;
#[doc(hidden)]
pub type ExportClientVpnClientCertificateRevocationListInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ExportClientVpnClientCertificateRevocationListInput {
    /// Consumes the builder and constructs an Operation<[`ExportClientVpnClientCertificateRevocationList`](crate::operation::ExportClientVpnClientCertificateRevocationList)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ExportClientVpnClientCertificateRevocationList,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_export_client_vpn_client_certificate_revocation_list(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ExportClientVpnClientCertificateRevocationList::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ExportClientVpnClientCertificateRevocationList",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ExportClientVpnClientCertificateRevocationListInput`](crate::input::ExportClientVpnClientCertificateRevocationListInput)
    pub fn builder(
    ) -> crate::input::export_client_vpn_client_certificate_revocation_list_input::Builder {
        crate::input::export_client_vpn_client_certificate_revocation_list_input::Builder::default()
    }
}

/// See [`ExportClientVpnClientConfigurationInput`](crate::input::ExportClientVpnClientConfigurationInput)
pub mod export_client_vpn_client_configuration_input {
    /// A builder for [`ExportClientVpnClientConfigurationInput`](crate::input::ExportClientVpnClientConfigurationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ExportClientVpnClientConfigurationInput`](crate::input::ExportClientVpnClientConfigurationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ExportClientVpnClientConfigurationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ExportClientVpnClientConfigurationInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ExportClientVpnClientConfigurationInputOperationOutputAlias =
    crate::operation::ExportClientVpnClientConfiguration;
#[doc(hidden)]
pub type ExportClientVpnClientConfigurationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ExportClientVpnClientConfigurationInput {
    /// Consumes the builder and constructs an Operation<[`ExportClientVpnClientConfiguration`](crate::operation::ExportClientVpnClientConfiguration)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ExportClientVpnClientConfiguration,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_export_client_vpn_client_configuration(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ExportClientVpnClientConfiguration::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ExportClientVpnClientConfiguration",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ExportClientVpnClientConfigurationInput`](crate::input::ExportClientVpnClientConfigurationInput)
    pub fn builder() -> crate::input::export_client_vpn_client_configuration_input::Builder {
        crate::input::export_client_vpn_client_configuration_input::Builder::default()
    }
}

/// See [`ExportImageInput`](crate::input::ExportImageInput)
pub mod export_image_input {
    /// A builder for [`ExportImageInput`](crate::input::ExportImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) disk_image_format: std::option::Option<crate::model::DiskImageFormat>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) s3_export_location:
            std::option::Option<crate::model::ExportTaskS3LocationRequest>,
        pub(crate) role_name: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Token to enable idempotency for export image requests.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>A description of the image being exported. The maximum length is 255 characters.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The disk image format.</p>
        pub fn disk_image_format(mut self, input: crate::model::DiskImageFormat) -> Self {
            self.disk_image_format = Some(input);
            self
        }
        pub fn set_disk_image_format(
            mut self,
            input: std::option::Option<crate::model::DiskImageFormat>,
        ) -> Self {
            self.disk_image_format = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the image.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>Information about the destination Amazon S3 bucket. The bucket must exist and grant WRITE
        /// and READ_ACP permissions to the AWS account vm-import-export@amazon.com.</p>
        pub fn s3_export_location(
            mut self,
            input: crate::model::ExportTaskS3LocationRequest,
        ) -> Self {
            self.s3_export_location = Some(input);
            self
        }
        pub fn set_s3_export_location(
            mut self,
            input: std::option::Option<crate::model::ExportTaskS3LocationRequest>,
        ) -> Self {
            self.s3_export_location = input;
            self
        }
        /// <p>The name of the role that grants VM Import/Export permission to export images to your Amazon
        /// S3 bucket. If this parameter is not specified, the default role is named 'vmimport'.</p>
        pub fn role_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.role_name = Some(input.into());
            self
        }
        pub fn set_role_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.role_name = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`ExportImageInput`](crate::input::ExportImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ExportImageInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ExportImageInput {
                client_token: self.client_token,
                description: self.description,
                disk_image_format: self.disk_image_format,
                dry_run: self.dry_run,
                image_id: self.image_id,
                s3_export_location: self.s3_export_location,
                role_name: self.role_name,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type ExportImageInputOperationOutputAlias = crate::operation::ExportImage;
#[doc(hidden)]
pub type ExportImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ExportImageInput {
    /// Consumes the builder and constructs an Operation<[`ExportImage`](crate::operation::ExportImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ExportImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_export_image(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ExportImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ExportImage", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ExportImageInput`](crate::input::ExportImageInput)
    pub fn builder() -> crate::input::export_image_input::Builder {
        crate::input::export_image_input::Builder::default()
    }
}

/// See [`ExportTransitGatewayRoutesInput`](crate::input::ExportTransitGatewayRoutesInput)
pub mod export_transit_gateway_routes_input {
    /// A builder for [`ExportTransitGatewayRoutesInput`](crate::input::ExportTransitGatewayRoutesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) s3_bucket: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The name of the S3 bucket.</p>
        pub fn s3_bucket(mut self, input: impl Into<std::string::String>) -> Self {
            self.s3_bucket = Some(input.into());
            self
        }
        pub fn set_s3_bucket(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.s3_bucket = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ExportTransitGatewayRoutesInput`](crate::input::ExportTransitGatewayRoutesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ExportTransitGatewayRoutesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ExportTransitGatewayRoutesInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                filters: self.filters,
                s3_bucket: self.s3_bucket,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ExportTransitGatewayRoutesInputOperationOutputAlias =
    crate::operation::ExportTransitGatewayRoutes;
#[doc(hidden)]
pub type ExportTransitGatewayRoutesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ExportTransitGatewayRoutesInput {
    /// Consumes the builder and constructs an Operation<[`ExportTransitGatewayRoutes`](crate::operation::ExportTransitGatewayRoutes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ExportTransitGatewayRoutes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_export_transit_gateway_routes(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ExportTransitGatewayRoutes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ExportTransitGatewayRoutes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ExportTransitGatewayRoutesInput`](crate::input::ExportTransitGatewayRoutesInput)
    pub fn builder() -> crate::input::export_transit_gateway_routes_input::Builder {
        crate::input::export_transit_gateway_routes_input::Builder::default()
    }
}

/// See [`GetAssociatedEnclaveCertificateIamRolesInput`](crate::input::GetAssociatedEnclaveCertificateIamRolesInput)
pub mod get_associated_enclave_certificate_iam_roles_input {
    /// A builder for [`GetAssociatedEnclaveCertificateIamRolesInput`](crate::input::GetAssociatedEnclaveCertificateIamRolesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) certificate_arn: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ARN of the ACM certificate for which to view the associated IAM roles, encryption keys, and Amazon
        /// S3 object information.</p>
        pub fn certificate_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.certificate_arn = Some(input.into());
            self
        }
        pub fn set_certificate_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.certificate_arn = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetAssociatedEnclaveCertificateIamRolesInput`](crate::input::GetAssociatedEnclaveCertificateIamRolesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetAssociatedEnclaveCertificateIamRolesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetAssociatedEnclaveCertificateIamRolesInput {
                certificate_arn: self.certificate_arn,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetAssociatedEnclaveCertificateIamRolesInputOperationOutputAlias =
    crate::operation::GetAssociatedEnclaveCertificateIamRoles;
#[doc(hidden)]
pub type GetAssociatedEnclaveCertificateIamRolesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl GetAssociatedEnclaveCertificateIamRolesInput {
    /// Consumes the builder and constructs an Operation<[`GetAssociatedEnclaveCertificateIamRoles`](crate::operation::GetAssociatedEnclaveCertificateIamRoles)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetAssociatedEnclaveCertificateIamRoles,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_associated_enclave_certificate_iam_roles(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetAssociatedEnclaveCertificateIamRoles::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetAssociatedEnclaveCertificateIamRoles",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetAssociatedEnclaveCertificateIamRolesInput`](crate::input::GetAssociatedEnclaveCertificateIamRolesInput)
    pub fn builder() -> crate::input::get_associated_enclave_certificate_iam_roles_input::Builder {
        crate::input::get_associated_enclave_certificate_iam_roles_input::Builder::default()
    }
}

/// See [`GetAssociatedIpv6PoolCidrsInput`](crate::input::GetAssociatedIpv6PoolCidrsInput)
pub mod get_associated_ipv6_pool_cidrs_input {
    /// A builder for [`GetAssociatedIpv6PoolCidrsInput`](crate::input::GetAssociatedIpv6PoolCidrsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) pool_id: std::option::Option<std::string::String>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the IPv6 address pool.</p>
        pub fn pool_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.pool_id = Some(input.into());
            self
        }
        pub fn set_pool_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.pool_id = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetAssociatedIpv6PoolCidrsInput`](crate::input::GetAssociatedIpv6PoolCidrsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetAssociatedIpv6PoolCidrsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetAssociatedIpv6PoolCidrsInput {
                pool_id: self.pool_id,
                next_token: self.next_token,
                max_results: self.max_results,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetAssociatedIpv6PoolCidrsInputOperationOutputAlias =
    crate::operation::GetAssociatedIpv6PoolCidrs;
#[doc(hidden)]
pub type GetAssociatedIpv6PoolCidrsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetAssociatedIpv6PoolCidrsInput {
    /// Consumes the builder and constructs an Operation<[`GetAssociatedIpv6PoolCidrs`](crate::operation::GetAssociatedIpv6PoolCidrs)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetAssociatedIpv6PoolCidrs,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_associated_ipv6_pool_cidrs(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetAssociatedIpv6PoolCidrs::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetAssociatedIpv6PoolCidrs",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetAssociatedIpv6PoolCidrsInput`](crate::input::GetAssociatedIpv6PoolCidrsInput)
    pub fn builder() -> crate::input::get_associated_ipv6_pool_cidrs_input::Builder {
        crate::input::get_associated_ipv6_pool_cidrs_input::Builder::default()
    }
}

/// See [`GetCapacityReservationUsageInput`](crate::input::GetCapacityReservationUsageInput)
pub mod get_capacity_reservation_usage_input {
    /// A builder for [`GetCapacityReservationUsageInput`](crate::input::GetCapacityReservationUsageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) capacity_reservation_id: std::option::Option<std::string::String>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Capacity Reservation.</p>
        pub fn capacity_reservation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.capacity_reservation_id = Some(input.into());
            self
        }
        pub fn set_capacity_reservation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.capacity_reservation_id = input;
            self
        }
        /// <p>The token to use to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
        /// <p>Valid range: Minimum value of 1. Maximum value of 1000.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetCapacityReservationUsageInput`](crate::input::GetCapacityReservationUsageInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetCapacityReservationUsageInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetCapacityReservationUsageInput {
                capacity_reservation_id: self.capacity_reservation_id,
                next_token: self.next_token,
                max_results: self.max_results,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetCapacityReservationUsageInputOperationOutputAlias =
    crate::operation::GetCapacityReservationUsage;
#[doc(hidden)]
pub type GetCapacityReservationUsageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetCapacityReservationUsageInput {
    /// Consumes the builder and constructs an Operation<[`GetCapacityReservationUsage`](crate::operation::GetCapacityReservationUsage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetCapacityReservationUsage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_capacity_reservation_usage(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetCapacityReservationUsage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetCapacityReservationUsage",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetCapacityReservationUsageInput`](crate::input::GetCapacityReservationUsageInput)
    pub fn builder() -> crate::input::get_capacity_reservation_usage_input::Builder {
        crate::input::get_capacity_reservation_usage_input::Builder::default()
    }
}

/// See [`GetCoipPoolUsageInput`](crate::input::GetCoipPoolUsageInput)
pub mod get_coip_pool_usage_input {
    /// A builder for [`GetCoipPoolUsageInput`](crate::input::GetCoipPoolUsageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) pool_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the address pool.</p>
        pub fn pool_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.pool_id = Some(input.into());
            self
        }
        pub fn set_pool_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.pool_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetCoipPoolUsageInput`](crate::input::GetCoipPoolUsageInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetCoipPoolUsageInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetCoipPoolUsageInput {
                pool_id: self.pool_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetCoipPoolUsageInputOperationOutputAlias = crate::operation::GetCoipPoolUsage;
#[doc(hidden)]
pub type GetCoipPoolUsageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetCoipPoolUsageInput {
    /// Consumes the builder and constructs an Operation<[`GetCoipPoolUsage`](crate::operation::GetCoipPoolUsage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetCoipPoolUsage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_get_coip_pool_usage(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetCoipPoolUsage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetCoipPoolUsage",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetCoipPoolUsageInput`](crate::input::GetCoipPoolUsageInput)
    pub fn builder() -> crate::input::get_coip_pool_usage_input::Builder {
        crate::input::get_coip_pool_usage_input::Builder::default()
    }
}

/// See [`GetConsoleOutputInput`](crate::input::GetConsoleOutputInput)
pub mod get_console_output_input {
    /// A builder for [`GetConsoleOutputInput`](crate::input::GetConsoleOutputInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) latest: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>When enabled, retrieves the latest console output for the instance.</p>
        /// <p>Default: disabled (<code>false</code>)</p>
        pub fn latest(mut self, input: bool) -> Self {
            self.latest = Some(input);
            self
        }
        pub fn set_latest(mut self, input: std::option::Option<bool>) -> Self {
            self.latest = input;
            self
        }
        /// Consumes the builder and constructs a [`GetConsoleOutputInput`](crate::input::GetConsoleOutputInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetConsoleOutputInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetConsoleOutputInput {
                instance_id: self.instance_id,
                dry_run: self.dry_run,
                latest: self.latest,
            })
        }
    }
}
#[doc(hidden)]
pub type GetConsoleOutputInputOperationOutputAlias = crate::operation::GetConsoleOutput;
#[doc(hidden)]
pub type GetConsoleOutputInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetConsoleOutputInput {
    /// Consumes the builder and constructs an Operation<[`GetConsoleOutput`](crate::operation::GetConsoleOutput)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetConsoleOutput,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_get_console_output(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetConsoleOutput::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetConsoleOutput",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetConsoleOutputInput`](crate::input::GetConsoleOutputInput)
    pub fn builder() -> crate::input::get_console_output_input::Builder {
        crate::input::get_console_output_input::Builder::default()
    }
}

/// See [`GetConsoleScreenshotInput`](crate::input::GetConsoleScreenshotInput)
pub mod get_console_screenshot_input {
    /// A builder for [`GetConsoleScreenshotInput`](crate::input::GetConsoleScreenshotInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) wake_up: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>When set to <code>true</code>, acts as keystroke input and wakes up an instance that's
        /// in standby or "sleep" mode.</p>
        pub fn wake_up(mut self, input: bool) -> Self {
            self.wake_up = Some(input);
            self
        }
        pub fn set_wake_up(mut self, input: std::option::Option<bool>) -> Self {
            self.wake_up = input;
            self
        }
        /// Consumes the builder and constructs a [`GetConsoleScreenshotInput`](crate::input::GetConsoleScreenshotInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetConsoleScreenshotInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetConsoleScreenshotInput {
                dry_run: self.dry_run,
                instance_id: self.instance_id,
                wake_up: self.wake_up,
            })
        }
    }
}
#[doc(hidden)]
pub type GetConsoleScreenshotInputOperationOutputAlias = crate::operation::GetConsoleScreenshot;
#[doc(hidden)]
pub type GetConsoleScreenshotInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetConsoleScreenshotInput {
    /// Consumes the builder and constructs an Operation<[`GetConsoleScreenshot`](crate::operation::GetConsoleScreenshot)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetConsoleScreenshot,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_get_console_screenshot(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetConsoleScreenshot::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetConsoleScreenshot",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetConsoleScreenshotInput`](crate::input::GetConsoleScreenshotInput)
    pub fn builder() -> crate::input::get_console_screenshot_input::Builder {
        crate::input::get_console_screenshot_input::Builder::default()
    }
}

/// See [`GetDefaultCreditSpecificationInput`](crate::input::GetDefaultCreditSpecificationInput)
pub mod get_default_credit_specification_input {
    /// A builder for [`GetDefaultCreditSpecificationInput`](crate::input::GetDefaultCreditSpecificationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_family:
            std::option::Option<crate::model::UnlimitedSupportedInstanceFamily>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The instance family.</p>
        pub fn instance_family(
            mut self,
            input: crate::model::UnlimitedSupportedInstanceFamily,
        ) -> Self {
            self.instance_family = Some(input);
            self
        }
        pub fn set_instance_family(
            mut self,
            input: std::option::Option<crate::model::UnlimitedSupportedInstanceFamily>,
        ) -> Self {
            self.instance_family = input;
            self
        }
        /// Consumes the builder and constructs a [`GetDefaultCreditSpecificationInput`](crate::input::GetDefaultCreditSpecificationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetDefaultCreditSpecificationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetDefaultCreditSpecificationInput {
                dry_run: self.dry_run,
                instance_family: self.instance_family,
            })
        }
    }
}
#[doc(hidden)]
pub type GetDefaultCreditSpecificationInputOperationOutputAlias =
    crate::operation::GetDefaultCreditSpecification;
#[doc(hidden)]
pub type GetDefaultCreditSpecificationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetDefaultCreditSpecificationInput {
    /// Consumes the builder and constructs an Operation<[`GetDefaultCreditSpecification`](crate::operation::GetDefaultCreditSpecification)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetDefaultCreditSpecification,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_default_credit_specification(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetDefaultCreditSpecification::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetDefaultCreditSpecification",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetDefaultCreditSpecificationInput`](crate::input::GetDefaultCreditSpecificationInput)
    pub fn builder() -> crate::input::get_default_credit_specification_input::Builder {
        crate::input::get_default_credit_specification_input::Builder::default()
    }
}

/// See [`GetEbsDefaultKmsKeyIdInput`](crate::input::GetEbsDefaultKmsKeyIdInput)
pub mod get_ebs_default_kms_key_id_input {
    /// A builder for [`GetEbsDefaultKmsKeyIdInput`](crate::input::GetEbsDefaultKmsKeyIdInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetEbsDefaultKmsKeyIdInput`](crate::input::GetEbsDefaultKmsKeyIdInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetEbsDefaultKmsKeyIdInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetEbsDefaultKmsKeyIdInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetEbsDefaultKmsKeyIdInputOperationOutputAlias = crate::operation::GetEbsDefaultKmsKeyId;
#[doc(hidden)]
pub type GetEbsDefaultKmsKeyIdInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetEbsDefaultKmsKeyIdInput {
    /// Consumes the builder and constructs an Operation<[`GetEbsDefaultKmsKeyId`](crate::operation::GetEbsDefaultKmsKeyId)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetEbsDefaultKmsKeyId,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_get_ebs_default_kms_key_id(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetEbsDefaultKmsKeyId::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetEbsDefaultKmsKeyId",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetEbsDefaultKmsKeyIdInput`](crate::input::GetEbsDefaultKmsKeyIdInput)
    pub fn builder() -> crate::input::get_ebs_default_kms_key_id_input::Builder {
        crate::input::get_ebs_default_kms_key_id_input::Builder::default()
    }
}

/// See [`GetEbsEncryptionByDefaultInput`](crate::input::GetEbsEncryptionByDefaultInput)
pub mod get_ebs_encryption_by_default_input {
    /// A builder for [`GetEbsEncryptionByDefaultInput`](crate::input::GetEbsEncryptionByDefaultInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetEbsEncryptionByDefaultInput`](crate::input::GetEbsEncryptionByDefaultInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetEbsEncryptionByDefaultInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetEbsEncryptionByDefaultInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetEbsEncryptionByDefaultInputOperationOutputAlias =
    crate::operation::GetEbsEncryptionByDefault;
#[doc(hidden)]
pub type GetEbsEncryptionByDefaultInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetEbsEncryptionByDefaultInput {
    /// Consumes the builder and constructs an Operation<[`GetEbsEncryptionByDefault`](crate::operation::GetEbsEncryptionByDefault)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetEbsEncryptionByDefault,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_ebs_encryption_by_default(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetEbsEncryptionByDefault::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetEbsEncryptionByDefault",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetEbsEncryptionByDefaultInput`](crate::input::GetEbsEncryptionByDefaultInput)
    pub fn builder() -> crate::input::get_ebs_encryption_by_default_input::Builder {
        crate::input::get_ebs_encryption_by_default_input::Builder::default()
    }
}

/// See [`GetFlowLogsIntegrationTemplateInput`](crate::input::GetFlowLogsIntegrationTemplateInput)
pub mod get_flow_logs_integration_template_input {
    /// A builder for [`GetFlowLogsIntegrationTemplateInput`](crate::input::GetFlowLogsIntegrationTemplateInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) flow_log_id: std::option::Option<std::string::String>,
        pub(crate) config_delivery_s3_destination_arn: std::option::Option<std::string::String>,
        pub(crate) integrate_services: std::option::Option<crate::model::IntegrateServices>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the flow log.</p>
        pub fn flow_log_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.flow_log_id = Some(input.into());
            self
        }
        pub fn set_flow_log_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.flow_log_id = input;
            self
        }
        /// <p>To store the CloudFormation template in Amazon S3, specify the location in Amazon S3.</p>
        pub fn config_delivery_s3_destination_arn(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.config_delivery_s3_destination_arn = Some(input.into());
            self
        }
        pub fn set_config_delivery_s3_destination_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.config_delivery_s3_destination_arn = input;
            self
        }
        /// <p>Information about the service integration.</p>
        pub fn integrate_services(mut self, input: crate::model::IntegrateServices) -> Self {
            self.integrate_services = Some(input);
            self
        }
        pub fn set_integrate_services(
            mut self,
            input: std::option::Option<crate::model::IntegrateServices>,
        ) -> Self {
            self.integrate_services = input;
            self
        }
        /// Consumes the builder and constructs a [`GetFlowLogsIntegrationTemplateInput`](crate::input::GetFlowLogsIntegrationTemplateInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetFlowLogsIntegrationTemplateInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetFlowLogsIntegrationTemplateInput {
                dry_run: self.dry_run,
                flow_log_id: self.flow_log_id,
                config_delivery_s3_destination_arn: self.config_delivery_s3_destination_arn,
                integrate_services: self.integrate_services,
            })
        }
    }
}
#[doc(hidden)]
pub type GetFlowLogsIntegrationTemplateInputOperationOutputAlias =
    crate::operation::GetFlowLogsIntegrationTemplate;
#[doc(hidden)]
pub type GetFlowLogsIntegrationTemplateInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetFlowLogsIntegrationTemplateInput {
    /// Consumes the builder and constructs an Operation<[`GetFlowLogsIntegrationTemplate`](crate::operation::GetFlowLogsIntegrationTemplate)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetFlowLogsIntegrationTemplate,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_flow_logs_integration_template(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetFlowLogsIntegrationTemplate::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetFlowLogsIntegrationTemplate",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetFlowLogsIntegrationTemplateInput`](crate::input::GetFlowLogsIntegrationTemplateInput)
    pub fn builder() -> crate::input::get_flow_logs_integration_template_input::Builder {
        crate::input::get_flow_logs_integration_template_input::Builder::default()
    }
}

/// See [`GetGroupsForCapacityReservationInput`](crate::input::GetGroupsForCapacityReservationInput)
pub mod get_groups_for_capacity_reservation_input {
    /// A builder for [`GetGroupsForCapacityReservationInput`](crate::input::GetGroupsForCapacityReservationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) capacity_reservation_id: std::option::Option<std::string::String>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Capacity Reservation.</p>
        pub fn capacity_reservation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.capacity_reservation_id = Some(input.into());
            self
        }
        pub fn set_capacity_reservation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.capacity_reservation_id = input;
            self
        }
        /// <p>The token to use to retrieve the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetGroupsForCapacityReservationInput`](crate::input::GetGroupsForCapacityReservationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetGroupsForCapacityReservationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetGroupsForCapacityReservationInput {
                capacity_reservation_id: self.capacity_reservation_id,
                next_token: self.next_token,
                max_results: self.max_results,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetGroupsForCapacityReservationInputOperationOutputAlias =
    crate::operation::GetGroupsForCapacityReservation;
#[doc(hidden)]
pub type GetGroupsForCapacityReservationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetGroupsForCapacityReservationInput {
    /// Consumes the builder and constructs an Operation<[`GetGroupsForCapacityReservation`](crate::operation::GetGroupsForCapacityReservation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetGroupsForCapacityReservation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_groups_for_capacity_reservation(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetGroupsForCapacityReservation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetGroupsForCapacityReservation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetGroupsForCapacityReservationInput`](crate::input::GetGroupsForCapacityReservationInput)
    pub fn builder() -> crate::input::get_groups_for_capacity_reservation_input::Builder {
        crate::input::get_groups_for_capacity_reservation_input::Builder::default()
    }
}

/// See [`GetHostReservationPurchasePreviewInput`](crate::input::GetHostReservationPurchasePreviewInput)
pub mod get_host_reservation_purchase_preview_input {
    /// A builder for [`GetHostReservationPurchasePreviewInput`](crate::input::GetHostReservationPurchasePreviewInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) host_id_set: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) offering_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        pub fn host_id_set(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.host_id_set.unwrap_or_default();
            v.push(input.into());
            self.host_id_set = Some(v);
            self
        }
        pub fn set_host_id_set(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.host_id_set = input;
            self
        }
        /// <p>The offering ID of the reservation.</p>
        pub fn offering_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.offering_id = Some(input.into());
            self
        }
        pub fn set_offering_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.offering_id = input;
            self
        }
        /// Consumes the builder and constructs a [`GetHostReservationPurchasePreviewInput`](crate::input::GetHostReservationPurchasePreviewInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetHostReservationPurchasePreviewInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetHostReservationPurchasePreviewInput {
                host_id_set: self.host_id_set,
                offering_id: self.offering_id,
            })
        }
    }
}
#[doc(hidden)]
pub type GetHostReservationPurchasePreviewInputOperationOutputAlias =
    crate::operation::GetHostReservationPurchasePreview;
#[doc(hidden)]
pub type GetHostReservationPurchasePreviewInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetHostReservationPurchasePreviewInput {
    /// Consumes the builder and constructs an Operation<[`GetHostReservationPurchasePreview`](crate::operation::GetHostReservationPurchasePreview)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetHostReservationPurchasePreview,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_host_reservation_purchase_preview(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetHostReservationPurchasePreview::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetHostReservationPurchasePreview",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetHostReservationPurchasePreviewInput`](crate::input::GetHostReservationPurchasePreviewInput)
    pub fn builder() -> crate::input::get_host_reservation_purchase_preview_input::Builder {
        crate::input::get_host_reservation_purchase_preview_input::Builder::default()
    }
}

/// See [`GetLaunchTemplateDataInput`](crate::input::GetLaunchTemplateDataInput)
pub mod get_launch_template_data_input {
    /// A builder for [`GetLaunchTemplateDataInput`](crate::input::GetLaunchTemplateDataInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// Consumes the builder and constructs a [`GetLaunchTemplateDataInput`](crate::input::GetLaunchTemplateDataInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetLaunchTemplateDataInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetLaunchTemplateDataInput {
                dry_run: self.dry_run,
                instance_id: self.instance_id,
            })
        }
    }
}
#[doc(hidden)]
pub type GetLaunchTemplateDataInputOperationOutputAlias = crate::operation::GetLaunchTemplateData;
#[doc(hidden)]
pub type GetLaunchTemplateDataInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetLaunchTemplateDataInput {
    /// Consumes the builder and constructs an Operation<[`GetLaunchTemplateData`](crate::operation::GetLaunchTemplateData)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetLaunchTemplateData,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_get_launch_template_data(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetLaunchTemplateData::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetLaunchTemplateData",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetLaunchTemplateDataInput`](crate::input::GetLaunchTemplateDataInput)
    pub fn builder() -> crate::input::get_launch_template_data_input::Builder {
        crate::input::get_launch_template_data_input::Builder::default()
    }
}

/// See [`GetManagedPrefixListAssociationsInput`](crate::input::GetManagedPrefixListAssociationsInput)
pub mod get_managed_prefix_list_associations_input {
    /// A builder for [`GetManagedPrefixListAssociationsInput`](crate::input::GetManagedPrefixListAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the prefix list.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`GetManagedPrefixListAssociationsInput`](crate::input::GetManagedPrefixListAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetManagedPrefixListAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetManagedPrefixListAssociationsInput {
                dry_run: self.dry_run,
                prefix_list_id: self.prefix_list_id,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type GetManagedPrefixListAssociationsInputOperationOutputAlias =
    crate::operation::GetManagedPrefixListAssociations;
#[doc(hidden)]
pub type GetManagedPrefixListAssociationsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetManagedPrefixListAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`GetManagedPrefixListAssociations`](crate::operation::GetManagedPrefixListAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetManagedPrefixListAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_managed_prefix_list_associations(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetManagedPrefixListAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetManagedPrefixListAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetManagedPrefixListAssociationsInput`](crate::input::GetManagedPrefixListAssociationsInput)
    pub fn builder() -> crate::input::get_managed_prefix_list_associations_input::Builder {
        crate::input::get_managed_prefix_list_associations_input::Builder::default()
    }
}

/// See [`GetManagedPrefixListEntriesInput`](crate::input::GetManagedPrefixListEntriesInput)
pub mod get_managed_prefix_list_entries_input {
    /// A builder for [`GetManagedPrefixListEntriesInput`](crate::input::GetManagedPrefixListEntriesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) target_version: std::option::Option<i64>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the prefix list.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// <p>The version of the prefix list for which to return the entries. The default is the current version.</p>
        pub fn target_version(mut self, input: i64) -> Self {
            self.target_version = Some(input);
            self
        }
        pub fn set_target_version(mut self, input: std::option::Option<i64>) -> Self {
            self.target_version = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// Consumes the builder and constructs a [`GetManagedPrefixListEntriesInput`](crate::input::GetManagedPrefixListEntriesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetManagedPrefixListEntriesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetManagedPrefixListEntriesInput {
                dry_run: self.dry_run,
                prefix_list_id: self.prefix_list_id,
                target_version: self.target_version,
                max_results: self.max_results,
                next_token: self.next_token,
            })
        }
    }
}
#[doc(hidden)]
pub type GetManagedPrefixListEntriesInputOperationOutputAlias =
    crate::operation::GetManagedPrefixListEntries;
#[doc(hidden)]
pub type GetManagedPrefixListEntriesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetManagedPrefixListEntriesInput {
    /// Consumes the builder and constructs an Operation<[`GetManagedPrefixListEntries`](crate::operation::GetManagedPrefixListEntries)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetManagedPrefixListEntries,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_managed_prefix_list_entries(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetManagedPrefixListEntries::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetManagedPrefixListEntries",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetManagedPrefixListEntriesInput`](crate::input::GetManagedPrefixListEntriesInput)
    pub fn builder() -> crate::input::get_managed_prefix_list_entries_input::Builder {
        crate::input::get_managed_prefix_list_entries_input::Builder::default()
    }
}

/// See [`GetPasswordDataInput`](crate::input::GetPasswordDataInput)
pub mod get_password_data_input {
    /// A builder for [`GetPasswordDataInput`](crate::input::GetPasswordDataInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Windows instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetPasswordDataInput`](crate::input::GetPasswordDataInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetPasswordDataInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetPasswordDataInput {
                instance_id: self.instance_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetPasswordDataInputOperationOutputAlias = crate::operation::GetPasswordData;
#[doc(hidden)]
pub type GetPasswordDataInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetPasswordDataInput {
    /// Consumes the builder and constructs an Operation<[`GetPasswordData`](crate::operation::GetPasswordData)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetPasswordData,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_get_password_data(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetPasswordData::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetPasswordData",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetPasswordDataInput`](crate::input::GetPasswordDataInput)
    pub fn builder() -> crate::input::get_password_data_input::Builder {
        crate::input::get_password_data_input::Builder::default()
    }
}

/// See [`GetReservedInstancesExchangeQuoteInput`](crate::input::GetReservedInstancesExchangeQuoteInput)
pub mod get_reserved_instances_exchange_quote_input {
    /// A builder for [`GetReservedInstancesExchangeQuoteInput`](crate::input::GetReservedInstancesExchangeQuoteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) reserved_instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) target_configurations:
            std::option::Option<std::vec::Vec<crate::model::TargetConfigurationRequest>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn reserved_instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.reserved_instance_ids.unwrap_or_default();
            v.push(input.into());
            self.reserved_instance_ids = Some(v);
            self
        }
        pub fn set_reserved_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.reserved_instance_ids = input;
            self
        }
        pub fn target_configurations(
            mut self,
            input: impl Into<crate::model::TargetConfigurationRequest>,
        ) -> Self {
            let mut v = self.target_configurations.unwrap_or_default();
            v.push(input.into());
            self.target_configurations = Some(v);
            self
        }
        pub fn set_target_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TargetConfigurationRequest>>,
        ) -> Self {
            self.target_configurations = input;
            self
        }
        /// Consumes the builder and constructs a [`GetReservedInstancesExchangeQuoteInput`](crate::input::GetReservedInstancesExchangeQuoteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetReservedInstancesExchangeQuoteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetReservedInstancesExchangeQuoteInput {
                dry_run: self.dry_run,
                reserved_instance_ids: self.reserved_instance_ids,
                target_configurations: self.target_configurations,
            })
        }
    }
}
#[doc(hidden)]
pub type GetReservedInstancesExchangeQuoteInputOperationOutputAlias =
    crate::operation::GetReservedInstancesExchangeQuote;
#[doc(hidden)]
pub type GetReservedInstancesExchangeQuoteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetReservedInstancesExchangeQuoteInput {
    /// Consumes the builder and constructs an Operation<[`GetReservedInstancesExchangeQuote`](crate::operation::GetReservedInstancesExchangeQuote)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetReservedInstancesExchangeQuote,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_reserved_instances_exchange_quote(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetReservedInstancesExchangeQuote::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetReservedInstancesExchangeQuote",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetReservedInstancesExchangeQuoteInput`](crate::input::GetReservedInstancesExchangeQuoteInput)
    pub fn builder() -> crate::input::get_reserved_instances_exchange_quote_input::Builder {
        crate::input::get_reserved_instances_exchange_quote_input::Builder::default()
    }
}

/// See [`GetSerialConsoleAccessStatusInput`](crate::input::GetSerialConsoleAccessStatusInput)
pub mod get_serial_console_access_status_input {
    /// A builder for [`GetSerialConsoleAccessStatusInput`](crate::input::GetSerialConsoleAccessStatusInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetSerialConsoleAccessStatusInput`](crate::input::GetSerialConsoleAccessStatusInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetSerialConsoleAccessStatusInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetSerialConsoleAccessStatusInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetSerialConsoleAccessStatusInputOperationOutputAlias =
    crate::operation::GetSerialConsoleAccessStatus;
#[doc(hidden)]
pub type GetSerialConsoleAccessStatusInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl GetSerialConsoleAccessStatusInput {
    /// Consumes the builder and constructs an Operation<[`GetSerialConsoleAccessStatus`](crate::operation::GetSerialConsoleAccessStatus)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetSerialConsoleAccessStatus,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_serial_console_access_status(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetSerialConsoleAccessStatus::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetSerialConsoleAccessStatus",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetSerialConsoleAccessStatusInput`](crate::input::GetSerialConsoleAccessStatusInput)
    pub fn builder() -> crate::input::get_serial_console_access_status_input::Builder {
        crate::input::get_serial_console_access_status_input::Builder::default()
    }
}

/// See [`GetTransitGatewayAttachmentPropagationsInput`](crate::input::GetTransitGatewayAttachmentPropagationsInput)
pub mod get_transit_gateway_attachment_propagations_input {
    /// A builder for [`GetTransitGatewayAttachmentPropagationsInput`](crate::input::GetTransitGatewayAttachmentPropagationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetTransitGatewayAttachmentPropagationsInput`](crate::input::GetTransitGatewayAttachmentPropagationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetTransitGatewayAttachmentPropagationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetTransitGatewayAttachmentPropagationsInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetTransitGatewayAttachmentPropagationsInputOperationOutputAlias =
    crate::operation::GetTransitGatewayAttachmentPropagations;
#[doc(hidden)]
pub type GetTransitGatewayAttachmentPropagationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl GetTransitGatewayAttachmentPropagationsInput {
    /// Consumes the builder and constructs an Operation<[`GetTransitGatewayAttachmentPropagations`](crate::operation::GetTransitGatewayAttachmentPropagations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetTransitGatewayAttachmentPropagations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_transit_gateway_attachment_propagations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetTransitGatewayAttachmentPropagations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetTransitGatewayAttachmentPropagations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetTransitGatewayAttachmentPropagationsInput`](crate::input::GetTransitGatewayAttachmentPropagationsInput)
    pub fn builder() -> crate::input::get_transit_gateway_attachment_propagations_input::Builder {
        crate::input::get_transit_gateway_attachment_propagations_input::Builder::default()
    }
}

/// See [`GetTransitGatewayMulticastDomainAssociationsInput`](crate::input::GetTransitGatewayMulticastDomainAssociationsInput)
pub mod get_transit_gateway_multicast_domain_associations_input {
    /// A builder for [`GetTransitGatewayMulticastDomainAssociationsInput`](crate::input::GetTransitGatewayMulticastDomainAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetTransitGatewayMulticastDomainAssociationsInput`](crate::input::GetTransitGatewayMulticastDomainAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetTransitGatewayMulticastDomainAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::GetTransitGatewayMulticastDomainAssociationsInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    filters: self.filters,
                    max_results: self.max_results,
                    next_token: self.next_token,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type GetTransitGatewayMulticastDomainAssociationsInputOperationOutputAlias =
    crate::operation::GetTransitGatewayMulticastDomainAssociations;
#[doc(hidden)]
pub type GetTransitGatewayMulticastDomainAssociationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl GetTransitGatewayMulticastDomainAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`GetTransitGatewayMulticastDomainAssociations`](crate::operation::GetTransitGatewayMulticastDomainAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetTransitGatewayMulticastDomainAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_transit_gateway_multicast_domain_associations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetTransitGatewayMulticastDomainAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetTransitGatewayMulticastDomainAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetTransitGatewayMulticastDomainAssociationsInput`](crate::input::GetTransitGatewayMulticastDomainAssociationsInput)
    pub fn builder(
    ) -> crate::input::get_transit_gateway_multicast_domain_associations_input::Builder {
        crate::input::get_transit_gateway_multicast_domain_associations_input::Builder::default()
    }
}

/// See [`GetTransitGatewayPrefixListReferencesInput`](crate::input::GetTransitGatewayPrefixListReferencesInput)
pub mod get_transit_gateway_prefix_list_references_input {
    /// A builder for [`GetTransitGatewayPrefixListReferencesInput`](crate::input::GetTransitGatewayPrefixListReferencesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetTransitGatewayPrefixListReferencesInput`](crate::input::GetTransitGatewayPrefixListReferencesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetTransitGatewayPrefixListReferencesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetTransitGatewayPrefixListReferencesInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetTransitGatewayPrefixListReferencesInputOperationOutputAlias =
    crate::operation::GetTransitGatewayPrefixListReferences;
#[doc(hidden)]
pub type GetTransitGatewayPrefixListReferencesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl GetTransitGatewayPrefixListReferencesInput {
    /// Consumes the builder and constructs an Operation<[`GetTransitGatewayPrefixListReferences`](crate::operation::GetTransitGatewayPrefixListReferences)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetTransitGatewayPrefixListReferences,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_transit_gateway_prefix_list_references(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetTransitGatewayPrefixListReferences::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetTransitGatewayPrefixListReferences",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetTransitGatewayPrefixListReferencesInput`](crate::input::GetTransitGatewayPrefixListReferencesInput)
    pub fn builder() -> crate::input::get_transit_gateway_prefix_list_references_input::Builder {
        crate::input::get_transit_gateway_prefix_list_references_input::Builder::default()
    }
}

/// See [`GetTransitGatewayRouteTableAssociationsInput`](crate::input::GetTransitGatewayRouteTableAssociationsInput)
pub mod get_transit_gateway_route_table_associations_input {
    /// A builder for [`GetTransitGatewayRouteTableAssociationsInput`](crate::input::GetTransitGatewayRouteTableAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetTransitGatewayRouteTableAssociationsInput`](crate::input::GetTransitGatewayRouteTableAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetTransitGatewayRouteTableAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetTransitGatewayRouteTableAssociationsInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetTransitGatewayRouteTableAssociationsInputOperationOutputAlias =
    crate::operation::GetTransitGatewayRouteTableAssociations;
#[doc(hidden)]
pub type GetTransitGatewayRouteTableAssociationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl GetTransitGatewayRouteTableAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`GetTransitGatewayRouteTableAssociations`](crate::operation::GetTransitGatewayRouteTableAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetTransitGatewayRouteTableAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_transit_gateway_route_table_associations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetTransitGatewayRouteTableAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetTransitGatewayRouteTableAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetTransitGatewayRouteTableAssociationsInput`](crate::input::GetTransitGatewayRouteTableAssociationsInput)
    pub fn builder() -> crate::input::get_transit_gateway_route_table_associations_input::Builder {
        crate::input::get_transit_gateway_route_table_associations_input::Builder::default()
    }
}

/// See [`GetTransitGatewayRouteTablePropagationsInput`](crate::input::GetTransitGatewayRouteTablePropagationsInput)
pub mod get_transit_gateway_route_table_propagations_input {
    /// A builder for [`GetTransitGatewayRouteTablePropagationsInput`](crate::input::GetTransitGatewayRouteTablePropagationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`GetTransitGatewayRouteTablePropagationsInput`](crate::input::GetTransitGatewayRouteTablePropagationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::GetTransitGatewayRouteTablePropagationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::GetTransitGatewayRouteTablePropagationsInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type GetTransitGatewayRouteTablePropagationsInputOperationOutputAlias =
    crate::operation::GetTransitGatewayRouteTablePropagations;
#[doc(hidden)]
pub type GetTransitGatewayRouteTablePropagationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl GetTransitGatewayRouteTablePropagationsInput {
    /// Consumes the builder and constructs an Operation<[`GetTransitGatewayRouteTablePropagations`](crate::operation::GetTransitGatewayRouteTablePropagations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::GetTransitGatewayRouteTablePropagations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_get_transit_gateway_route_table_propagations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::GetTransitGatewayRouteTablePropagations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "GetTransitGatewayRouteTablePropagations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`GetTransitGatewayRouteTablePropagationsInput`](crate::input::GetTransitGatewayRouteTablePropagationsInput)
    pub fn builder() -> crate::input::get_transit_gateway_route_table_propagations_input::Builder {
        crate::input::get_transit_gateway_route_table_propagations_input::Builder::default()
    }
}

/// See [`ImportClientVpnClientCertificateRevocationListInput`](crate::input::ImportClientVpnClientCertificateRevocationListInput)
pub mod import_client_vpn_client_certificate_revocation_list_input {
    /// A builder for [`ImportClientVpnClientCertificateRevocationListInput`](crate::input::ImportClientVpnClientCertificateRevocationListInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) certificate_revocation_list: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint to which the client certificate revocation list applies.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The client certificate revocation list file. For more information, see <a href="https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/cvpn-working-certificates.html#cvpn-working-certificates-generate">Generate a Client Certificate Revocation List</a> in the
        /// <i>AWS Client VPN Administrator Guide</i>.</p>
        pub fn certificate_revocation_list(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.certificate_revocation_list = Some(input.into());
            self
        }
        pub fn set_certificate_revocation_list(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.certificate_revocation_list = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ImportClientVpnClientCertificateRevocationListInput`](crate::input::ImportClientVpnClientCertificateRevocationListInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ImportClientVpnClientCertificateRevocationListInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::ImportClientVpnClientCertificateRevocationListInput {
                    client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                    certificate_revocation_list: self.certificate_revocation_list,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type ImportClientVpnClientCertificateRevocationListInputOperationOutputAlias =
    crate::operation::ImportClientVpnClientCertificateRevocationList;
#[doc(hidden)]
pub type ImportClientVpnClientCertificateRevocationListInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ImportClientVpnClientCertificateRevocationListInput {
    /// Consumes the builder and constructs an Operation<[`ImportClientVpnClientCertificateRevocationList`](crate::operation::ImportClientVpnClientCertificateRevocationList)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ImportClientVpnClientCertificateRevocationList,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_import_client_vpn_client_certificate_revocation_list(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ImportClientVpnClientCertificateRevocationList::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ImportClientVpnClientCertificateRevocationList",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ImportClientVpnClientCertificateRevocationListInput`](crate::input::ImportClientVpnClientCertificateRevocationListInput)
    pub fn builder(
    ) -> crate::input::import_client_vpn_client_certificate_revocation_list_input::Builder {
        crate::input::import_client_vpn_client_certificate_revocation_list_input::Builder::default()
    }
}

/// See [`ImportImageInput`](crate::input::ImportImageInput)
pub mod import_image_input {
    /// A builder for [`ImportImageInput`](crate::input::ImportImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) architecture: std::option::Option<std::string::String>,
        pub(crate) client_data: std::option::Option<crate::model::ClientData>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) disk_containers:
            std::option::Option<std::vec::Vec<crate::model::ImageDiskContainer>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) encrypted: std::option::Option<bool>,
        pub(crate) hypervisor: std::option::Option<std::string::String>,
        pub(crate) kms_key_id: std::option::Option<std::string::String>,
        pub(crate) license_type: std::option::Option<std::string::String>,
        pub(crate) platform: std::option::Option<std::string::String>,
        pub(crate) role_name: std::option::Option<std::string::String>,
        pub(crate) license_specifications: std::option::Option<
            std::vec::Vec<crate::model::ImportImageLicenseConfigurationRequest>,
        >,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>The architecture of the virtual machine.</p>
        /// <p>Valid values: <code>i386</code> | <code>x86_64</code> | <code>arm64</code>
        /// </p>
        pub fn architecture(mut self, input: impl Into<std::string::String>) -> Self {
            self.architecture = Some(input.into());
            self
        }
        pub fn set_architecture(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.architecture = input;
            self
        }
        /// <p>The client-specific data.</p>
        pub fn client_data(mut self, input: crate::model::ClientData) -> Self {
            self.client_data = Some(input);
            self
        }
        pub fn set_client_data(
            mut self,
            input: std::option::Option<crate::model::ClientData>,
        ) -> Self {
            self.client_data = input;
            self
        }
        /// <p>The token to enable idempotency for VM import requests.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>A description string for the import image task.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        pub fn disk_containers(
            mut self,
            input: impl Into<crate::model::ImageDiskContainer>,
        ) -> Self {
            let mut v = self.disk_containers.unwrap_or_default();
            v.push(input.into());
            self.disk_containers = Some(v);
            self
        }
        pub fn set_disk_containers(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ImageDiskContainer>>,
        ) -> Self {
            self.disk_containers = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Specifies whether the destination AMI of the imported image should be encrypted. The default CMK for EBS is used
        /// unless you specify a non-default AWS Key Management Service (AWS KMS) CMK using <code>KmsKeyId</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS Encryption</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn encrypted(mut self, input: bool) -> Self {
            self.encrypted = Some(input);
            self
        }
        pub fn set_encrypted(mut self, input: std::option::Option<bool>) -> Self {
            self.encrypted = input;
            self
        }
        /// <p>The target hypervisor platform.</p>
        /// <p>Valid values: <code>xen</code>
        /// </p>
        pub fn hypervisor(mut self, input: impl Into<std::string::String>) -> Self {
            self.hypervisor = Some(input.into());
            self
        }
        pub fn set_hypervisor(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.hypervisor = input;
            self
        }
        /// <p>An identifier for the symmetric AWS Key Management Service (AWS KMS) customer master key (CMK) to use when creating the
        /// encrypted AMI. This parameter is only required if you want to use a non-default CMK; if this
        /// parameter is not specified, the default CMK for EBS is used. If a <code>KmsKeyId</code> is
        /// specified, the <code>Encrypted</code> flag must also be set. </p>
        /// <p>The CMK identifier may be provided in any of the following formats: </p>
        /// <ul>
        /// <li>
        /// <p>Key ID</p>
        /// </li>
        /// <li>
        /// <p>Key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>.</p>
        /// </li>
        /// <li>
        /// <p>ARN using key ID. The ID ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>key</code> namespace, and then the CMK ID. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:key/<i>abcd1234-a123-456a-a12b-a123b4cd56ef</i>.</p>
        /// </li>
        /// <li>
        /// <p>ARN using key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>. </p>
        /// </li>
        /// </ul>
        /// <p>AWS parses <code>KmsKeyId</code> asynchronously, meaning that the action you call may appear to complete even
        /// though you provided an invalid identifier. This action will eventually report failure. </p>
        /// <p>The specified CMK must exist in the Region that the AMI is being copied to.</p>
        /// <p>Amazon EBS does not support asymmetric CMKs.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kms_key_id = Some(input.into());
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kms_key_id = input;
            self
        }
        /// <p>The license type to be used for the Amazon Machine Image (AMI) after importing.</p>
        /// <p>By default, we detect the source-system operating system (OS) and apply the appropriate license. Specify
        /// <code>AWS</code> to replace the source-system license with an AWS license, if appropriate. Specify <code>BYOL</code>
        /// to retain the source-system license, if appropriate.</p>
        /// <p>To use <code>BYOL</code>, you must have existing licenses with rights to use these licenses in a third party
        /// cloud, such as AWS. For more information, see <a href="https://docs.aws.amazon.com/vm-import/latest/userguide/vmimport-image-import.html#prerequisites-image">Prerequisites</a> in the
        /// VM Import/Export User Guide.</p>
        pub fn license_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.license_type = Some(input.into());
            self
        }
        pub fn set_license_type(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.license_type = input;
            self
        }
        /// <p>The operating system of the virtual machine.</p>
        /// <p>Valid values: <code>Windows</code> | <code>Linux</code>
        /// </p>
        pub fn platform(mut self, input: impl Into<std::string::String>) -> Self {
            self.platform = Some(input.into());
            self
        }
        pub fn set_platform(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.platform = input;
            self
        }
        /// <p>The name of the role to use when not using the default role, 'vmimport'.</p>
        pub fn role_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.role_name = Some(input.into());
            self
        }
        pub fn set_role_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.role_name = input;
            self
        }
        pub fn license_specifications(
            mut self,
            input: impl Into<crate::model::ImportImageLicenseConfigurationRequest>,
        ) -> Self {
            let mut v = self.license_specifications.unwrap_or_default();
            v.push(input.into());
            self.license_specifications = Some(v);
            self
        }
        pub fn set_license_specifications(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::ImportImageLicenseConfigurationRequest>,
            >,
        ) -> Self {
            self.license_specifications = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`ImportImageInput`](crate::input::ImportImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ImportImageInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ImportImageInput {
                architecture: self.architecture,
                client_data: self.client_data,
                client_token: self.client_token,
                description: self.description,
                disk_containers: self.disk_containers,
                dry_run: self.dry_run,
                encrypted: self.encrypted,
                hypervisor: self.hypervisor,
                kms_key_id: self.kms_key_id,
                license_type: self.license_type,
                platform: self.platform,
                role_name: self.role_name,
                license_specifications: self.license_specifications,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type ImportImageInputOperationOutputAlias = crate::operation::ImportImage;
#[doc(hidden)]
pub type ImportImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ImportImageInput {
    /// Consumes the builder and constructs an Operation<[`ImportImage`](crate::operation::ImportImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ImportImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_import_image(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ImportImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ImportImage", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ImportImageInput`](crate::input::ImportImageInput)
    pub fn builder() -> crate::input::import_image_input::Builder {
        crate::input::import_image_input::Builder::default()
    }
}

/// See [`ImportInstanceInput`](crate::input::ImportInstanceInput)
pub mod import_instance_input {
    /// A builder for [`ImportInstanceInput`](crate::input::ImportInstanceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) disk_images: std::option::Option<std::vec::Vec<crate::model::DiskImage>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) launch_specification:
            std::option::Option<crate::model::ImportInstanceLaunchSpecification>,
        pub(crate) platform: std::option::Option<crate::model::PlatformValues>,
    }
    impl Builder {
        /// <p>A description for the instance being imported.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        pub fn disk_images(mut self, input: impl Into<crate::model::DiskImage>) -> Self {
            let mut v = self.disk_images.unwrap_or_default();
            v.push(input.into());
            self.disk_images = Some(v);
            self
        }
        pub fn set_disk_images(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::DiskImage>>,
        ) -> Self {
            self.disk_images = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The launch specification.</p>
        pub fn launch_specification(
            mut self,
            input: crate::model::ImportInstanceLaunchSpecification,
        ) -> Self {
            self.launch_specification = Some(input);
            self
        }
        pub fn set_launch_specification(
            mut self,
            input: std::option::Option<crate::model::ImportInstanceLaunchSpecification>,
        ) -> Self {
            self.launch_specification = input;
            self
        }
        /// <p>The instance operating system.</p>
        pub fn platform(mut self, input: crate::model::PlatformValues) -> Self {
            self.platform = Some(input);
            self
        }
        pub fn set_platform(
            mut self,
            input: std::option::Option<crate::model::PlatformValues>,
        ) -> Self {
            self.platform = input;
            self
        }
        /// Consumes the builder and constructs a [`ImportInstanceInput`](crate::input::ImportInstanceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ImportInstanceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ImportInstanceInput {
                description: self.description,
                disk_images: self.disk_images,
                dry_run: self.dry_run,
                launch_specification: self.launch_specification,
                platform: self.platform,
            })
        }
    }
}
#[doc(hidden)]
pub type ImportInstanceInputOperationOutputAlias = crate::operation::ImportInstance;
#[doc(hidden)]
pub type ImportInstanceInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ImportInstanceInput {
    /// Consumes the builder and constructs an Operation<[`ImportInstance`](crate::operation::ImportInstance)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ImportInstance,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_import_instance(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ImportInstance::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ImportInstance",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ImportInstanceInput`](crate::input::ImportInstanceInput)
    pub fn builder() -> crate::input::import_instance_input::Builder {
        crate::input::import_instance_input::Builder::default()
    }
}

/// See [`ImportKeyPairInput`](crate::input::ImportKeyPairInput)
pub mod import_key_pair_input {
    /// A builder for [`ImportKeyPairInput`](crate::input::ImportKeyPairInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) key_name: std::option::Option<std::string::String>,
        pub(crate) public_key_material: std::option::Option<smithy_types::Blob>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>A unique name for the key pair.</p>
        pub fn key_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.key_name = Some(input.into());
            self
        }
        pub fn set_key_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.key_name = input;
            self
        }
        /// <p>The public key. For API calls, the text must be base64-encoded. For command line tools, base64 encoding is performed for you.</p>
        pub fn public_key_material(mut self, input: smithy_types::Blob) -> Self {
            self.public_key_material = Some(input);
            self
        }
        pub fn set_public_key_material(
            mut self,
            input: std::option::Option<smithy_types::Blob>,
        ) -> Self {
            self.public_key_material = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`ImportKeyPairInput`](crate::input::ImportKeyPairInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ImportKeyPairInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ImportKeyPairInput {
                dry_run: self.dry_run,
                key_name: self.key_name,
                public_key_material: self.public_key_material,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type ImportKeyPairInputOperationOutputAlias = crate::operation::ImportKeyPair;
#[doc(hidden)]
pub type ImportKeyPairInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ImportKeyPairInput {
    /// Consumes the builder and constructs an Operation<[`ImportKeyPair`](crate::operation::ImportKeyPair)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ImportKeyPair,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_import_key_pair(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ImportKeyPair::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ImportKeyPair",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ImportKeyPairInput`](crate::input::ImportKeyPairInput)
    pub fn builder() -> crate::input::import_key_pair_input::Builder {
        crate::input::import_key_pair_input::Builder::default()
    }
}

/// See [`ImportSnapshotInput`](crate::input::ImportSnapshotInput)
pub mod import_snapshot_input {
    /// A builder for [`ImportSnapshotInput`](crate::input::ImportSnapshotInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_data: std::option::Option<crate::model::ClientData>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) disk_container: std::option::Option<crate::model::SnapshotDiskContainer>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) encrypted: std::option::Option<bool>,
        pub(crate) kms_key_id: std::option::Option<std::string::String>,
        pub(crate) role_name: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>The client-specific data.</p>
        pub fn client_data(mut self, input: crate::model::ClientData) -> Self {
            self.client_data = Some(input);
            self
        }
        pub fn set_client_data(
            mut self,
            input: std::option::Option<crate::model::ClientData>,
        ) -> Self {
            self.client_data = input;
            self
        }
        /// <p>Token to enable idempotency for VM import requests.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>The description string for the import snapshot task.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Information about the disk container.</p>
        pub fn disk_container(mut self, input: crate::model::SnapshotDiskContainer) -> Self {
            self.disk_container = Some(input);
            self
        }
        pub fn set_disk_container(
            mut self,
            input: std::option::Option<crate::model::SnapshotDiskContainer>,
        ) -> Self {
            self.disk_container = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Specifies whether the destination snapshot of the imported image should be encrypted. The default CMK for EBS is
        /// used unless you specify a non-default AWS Key Management Service (AWS KMS) CMK using <code>KmsKeyId</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS Encryption</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn encrypted(mut self, input: bool) -> Self {
            self.encrypted = Some(input);
            self
        }
        pub fn set_encrypted(mut self, input: std::option::Option<bool>) -> Self {
            self.encrypted = input;
            self
        }
        /// <p>An identifier for the symmetric AWS Key Management Service (AWS KMS) customer master key (CMK) to use when creating the
        /// encrypted snapshot. This parameter is only required if you want to use a non-default CMK; if this
        /// parameter is not specified, the default CMK for EBS is used. If a <code>KmsKeyId</code> is
        /// specified, the <code>Encrypted</code> flag must also be set. </p>
        /// <p>The CMK identifier may be provided in any of the following formats: </p>
        /// <ul>
        /// <li>
        /// <p>Key ID</p>
        /// </li>
        /// <li>
        /// <p>Key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>.</p>
        /// </li>
        /// <li>
        /// <p>ARN using key ID. The ID ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>key</code> namespace, and then the CMK ID. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:key/<i>abcd1234-a123-456a-a12b-a123b4cd56ef</i>.</p>
        /// </li>
        /// <li>
        /// <p>ARN using key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>. </p>
        /// </li>
        /// </ul>
        /// <p>AWS parses <code>KmsKeyId</code> asynchronously, meaning that the action you call may appear to complete even
        /// though you provided an invalid identifier. This action will eventually report failure. </p>
        /// <p>The specified CMK must exist in the Region that the snapshot is being copied to.</p>
        /// <p>Amazon EBS does not support asymmetric CMKs.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kms_key_id = Some(input.into());
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kms_key_id = input;
            self
        }
        /// <p>The name of the role to use when not using the default role, 'vmimport'.</p>
        pub fn role_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.role_name = Some(input.into());
            self
        }
        pub fn set_role_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.role_name = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`ImportSnapshotInput`](crate::input::ImportSnapshotInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ImportSnapshotInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ImportSnapshotInput {
                client_data: self.client_data,
                client_token: self.client_token,
                description: self.description,
                disk_container: self.disk_container,
                dry_run: self.dry_run,
                encrypted: self.encrypted,
                kms_key_id: self.kms_key_id,
                role_name: self.role_name,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type ImportSnapshotInputOperationOutputAlias = crate::operation::ImportSnapshot;
#[doc(hidden)]
pub type ImportSnapshotInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ImportSnapshotInput {
    /// Consumes the builder and constructs an Operation<[`ImportSnapshot`](crate::operation::ImportSnapshot)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ImportSnapshot,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_import_snapshot(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ImportSnapshot::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ImportSnapshot",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ImportSnapshotInput`](crate::input::ImportSnapshotInput)
    pub fn builder() -> crate::input::import_snapshot_input::Builder {
        crate::input::import_snapshot_input::Builder::default()
    }
}

/// See [`ImportVolumeInput`](crate::input::ImportVolumeInput)
pub mod import_volume_input {
    /// A builder for [`ImportVolumeInput`](crate::input::ImportVolumeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zone: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) image: std::option::Option<crate::model::DiskImageDetail>,
        pub(crate) volume: std::option::Option<crate::model::VolumeDetail>,
    }
    impl Builder {
        /// <p>The Availability Zone for the resulting EBS volume.</p>
        pub fn availability_zone(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone = Some(input.into());
            self
        }
        pub fn set_availability_zone(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone = input;
            self
        }
        /// <p>A description of the volume.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The disk image.</p>
        pub fn image(mut self, input: crate::model::DiskImageDetail) -> Self {
            self.image = Some(input);
            self
        }
        pub fn set_image(
            mut self,
            input: std::option::Option<crate::model::DiskImageDetail>,
        ) -> Self {
            self.image = input;
            self
        }
        /// <p>The volume size.</p>
        pub fn volume(mut self, input: crate::model::VolumeDetail) -> Self {
            self.volume = Some(input);
            self
        }
        pub fn set_volume(
            mut self,
            input: std::option::Option<crate::model::VolumeDetail>,
        ) -> Self {
            self.volume = input;
            self
        }
        /// Consumes the builder and constructs a [`ImportVolumeInput`](crate::input::ImportVolumeInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ImportVolumeInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ImportVolumeInput {
                availability_zone: self.availability_zone,
                description: self.description,
                dry_run: self.dry_run,
                image: self.image,
                volume: self.volume,
            })
        }
    }
}
#[doc(hidden)]
pub type ImportVolumeInputOperationOutputAlias = crate::operation::ImportVolume;
#[doc(hidden)]
pub type ImportVolumeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ImportVolumeInput {
    /// Consumes the builder and constructs an Operation<[`ImportVolume`](crate::operation::ImportVolume)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ImportVolume,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_import_volume(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ImportVolume::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ImportVolume", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ImportVolumeInput`](crate::input::ImportVolumeInput)
    pub fn builder() -> crate::input::import_volume_input::Builder {
        crate::input::import_volume_input::Builder::default()
    }
}

/// See [`ModifyAddressAttributeInput`](crate::input::ModifyAddressAttributeInput)
pub mod modify_address_attribute_input {
    /// A builder for [`ModifyAddressAttributeInput`](crate::input::ModifyAddressAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) allocation_id: std::option::Option<std::string::String>,
        pub(crate) domain_name: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>[EC2-VPC] The allocation ID.</p>
        pub fn allocation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.allocation_id = Some(input.into());
            self
        }
        pub fn set_allocation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.allocation_id = input;
            self
        }
        /// <p>The domain name to modify for the IP address.</p>
        pub fn domain_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.domain_name = Some(input.into());
            self
        }
        pub fn set_domain_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.domain_name = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyAddressAttributeInput`](crate::input::ModifyAddressAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyAddressAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyAddressAttributeInput {
                allocation_id: self.allocation_id,
                domain_name: self.domain_name,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyAddressAttributeInputOperationOutputAlias = crate::operation::ModifyAddressAttribute;
#[doc(hidden)]
pub type ModifyAddressAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyAddressAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyAddressAttribute`](crate::operation::ModifyAddressAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyAddressAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_address_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyAddressAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyAddressAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyAddressAttributeInput`](crate::input::ModifyAddressAttributeInput)
    pub fn builder() -> crate::input::modify_address_attribute_input::Builder {
        crate::input::modify_address_attribute_input::Builder::default()
    }
}

/// See [`ModifyAvailabilityZoneGroupInput`](crate::input::ModifyAvailabilityZoneGroupInput)
pub mod modify_availability_zone_group_input {
    /// A builder for [`ModifyAvailabilityZoneGroupInput`](crate::input::ModifyAvailabilityZoneGroupInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) opt_in_status:
            std::option::Option<crate::model::ModifyAvailabilityZoneOptInStatus>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The name of the Availability Zone group, Local Zone group, or Wavelength Zone
        /// group.</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        /// <p>Indicates whether you are opted in to the Local Zone group or Wavelength Zone group. The
        /// only valid value is <code>opted-in</code>. You must contact <a href="https://console.aws.amazon.com/support/home#/case/create%3FissueType=customer-service%26serviceCode=general-info%26getting-started%26categoryCode=using-aws%26services">AWS Support</a> to opt out of a Local Zone group, or Wavelength Zone group.</p>
        pub fn opt_in_status(
            mut self,
            input: crate::model::ModifyAvailabilityZoneOptInStatus,
        ) -> Self {
            self.opt_in_status = Some(input);
            self
        }
        pub fn set_opt_in_status(
            mut self,
            input: std::option::Option<crate::model::ModifyAvailabilityZoneOptInStatus>,
        ) -> Self {
            self.opt_in_status = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyAvailabilityZoneGroupInput`](crate::input::ModifyAvailabilityZoneGroupInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyAvailabilityZoneGroupInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyAvailabilityZoneGroupInput {
                group_name: self.group_name,
                opt_in_status: self.opt_in_status,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyAvailabilityZoneGroupInputOperationOutputAlias =
    crate::operation::ModifyAvailabilityZoneGroup;
#[doc(hidden)]
pub type ModifyAvailabilityZoneGroupInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyAvailabilityZoneGroupInput {
    /// Consumes the builder and constructs an Operation<[`ModifyAvailabilityZoneGroup`](crate::operation::ModifyAvailabilityZoneGroup)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyAvailabilityZoneGroup,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_availability_zone_group(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyAvailabilityZoneGroup::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyAvailabilityZoneGroup",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyAvailabilityZoneGroupInput`](crate::input::ModifyAvailabilityZoneGroupInput)
    pub fn builder() -> crate::input::modify_availability_zone_group_input::Builder {
        crate::input::modify_availability_zone_group_input::Builder::default()
    }
}

/// See [`ModifyCapacityReservationInput`](crate::input::ModifyCapacityReservationInput)
pub mod modify_capacity_reservation_input {
    /// A builder for [`ModifyCapacityReservationInput`](crate::input::ModifyCapacityReservationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) capacity_reservation_id: std::option::Option<std::string::String>,
        pub(crate) instance_count: std::option::Option<i32>,
        pub(crate) end_date: std::option::Option<smithy_types::Instant>,
        pub(crate) end_date_type: std::option::Option<crate::model::EndDateType>,
        pub(crate) accept: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Capacity Reservation.</p>
        pub fn capacity_reservation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.capacity_reservation_id = Some(input.into());
            self
        }
        pub fn set_capacity_reservation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.capacity_reservation_id = input;
            self
        }
        /// <p>The number of instances for which to reserve capacity.</p>
        pub fn instance_count(mut self, input: i32) -> Self {
            self.instance_count = Some(input);
            self
        }
        pub fn set_instance_count(mut self, input: std::option::Option<i32>) -> Self {
            self.instance_count = input;
            self
        }
        /// <p>The date and time at which the Capacity Reservation expires. When a Capacity Reservation expires, the reserved capacity
        /// is released and you can no longer launch instances into it. The Capacity Reservation's state changes to
        /// <code>expired</code> when it reaches its end date and time.</p>
        /// <p>The Capacity Reservation is cancelled within an hour from the specified time. For example, if you specify
        /// 5/31/2019, 13:30:55, the Capacity Reservation is guaranteed to end between 13:30:55 and 14:30:55 on 5/31/2019.</p>
        /// <p>You must provide an <code>EndDate</code> value if <code>EndDateType</code> is
        /// <code>limited</code>. Omit <code>EndDate</code> if <code>EndDateType</code> is
        /// <code>unlimited</code>.</p>
        pub fn end_date(mut self, input: smithy_types::Instant) -> Self {
            self.end_date = Some(input);
            self
        }
        pub fn set_end_date(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.end_date = input;
            self
        }
        /// <p>Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have one of the following end
        /// types:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>unlimited</code> - The Capacity Reservation remains active until you explicitly cancel it. Do not
        /// provide an <code>EndDate</code> value if <code>EndDateType</code> is
        /// <code>unlimited</code>.</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>limited</code> - The Capacity Reservation expires automatically at a specified date and time. You must
        /// provide an <code>EndDate</code> value if <code>EndDateType</code> is
        /// <code>limited</code>.</p>
        /// </li>
        /// </ul>
        pub fn end_date_type(mut self, input: crate::model::EndDateType) -> Self {
            self.end_date_type = Some(input);
            self
        }
        pub fn set_end_date_type(
            mut self,
            input: std::option::Option<crate::model::EndDateType>,
        ) -> Self {
            self.end_date_type = input;
            self
        }
        /// <p>Reserved. Capacity Reservations you have created are accepted by default.</p>
        pub fn accept(mut self, input: bool) -> Self {
            self.accept = Some(input);
            self
        }
        pub fn set_accept(mut self, input: std::option::Option<bool>) -> Self {
            self.accept = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyCapacityReservationInput`](crate::input::ModifyCapacityReservationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyCapacityReservationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyCapacityReservationInput {
                capacity_reservation_id: self.capacity_reservation_id,
                instance_count: self.instance_count,
                end_date: self.end_date,
                end_date_type: self.end_date_type,
                accept: self.accept,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyCapacityReservationInputOperationOutputAlias =
    crate::operation::ModifyCapacityReservation;
#[doc(hidden)]
pub type ModifyCapacityReservationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyCapacityReservationInput {
    /// Consumes the builder and constructs an Operation<[`ModifyCapacityReservation`](crate::operation::ModifyCapacityReservation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyCapacityReservation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_capacity_reservation(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyCapacityReservation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyCapacityReservation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyCapacityReservationInput`](crate::input::ModifyCapacityReservationInput)
    pub fn builder() -> crate::input::modify_capacity_reservation_input::Builder {
        crate::input::modify_capacity_reservation_input::Builder::default()
    }
}

/// See [`ModifyClientVpnEndpointInput`](crate::input::ModifyClientVpnEndpointInput)
pub mod modify_client_vpn_endpoint_input {
    /// A builder for [`ModifyClientVpnEndpointInput`](crate::input::ModifyClientVpnEndpointInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) server_certificate_arn: std::option::Option<std::string::String>,
        pub(crate) connection_log_options: std::option::Option<crate::model::ConnectionLogOptions>,
        pub(crate) dns_servers: std::option::Option<crate::model::DnsServersOptionsModifyStructure>,
        pub(crate) vpn_port: std::option::Option<i32>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) split_tunnel: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) self_service_portal: std::option::Option<crate::model::SelfServicePortal>,
        pub(crate) client_connect_options: std::option::Option<crate::model::ClientConnectOptions>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint to modify.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The ARN of the server certificate to be used. The server certificate must be provisioned in AWS Certificate Manager (ACM).</p>
        pub fn server_certificate_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.server_certificate_arn = Some(input.into());
            self
        }
        pub fn set_server_certificate_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.server_certificate_arn = input;
            self
        }
        /// <p>Information about the client connection logging options.</p>
        /// <p>If you enable client connection logging, data about client connections is sent to a
        /// Cloudwatch Logs log stream. The following information is logged:</p>
        /// <ul>
        /// <li>
        /// <p>Client connection requests</p>
        /// </li>
        /// <li>
        /// <p>Client connection results (successful and unsuccessful)</p>
        /// </li>
        /// <li>
        /// <p>Reasons for unsuccessful client connection requests</p>
        /// </li>
        /// <li>
        /// <p>Client connection termination time</p>
        /// </li>
        /// </ul>
        pub fn connection_log_options(mut self, input: crate::model::ConnectionLogOptions) -> Self {
            self.connection_log_options = Some(input);
            self
        }
        pub fn set_connection_log_options(
            mut self,
            input: std::option::Option<crate::model::ConnectionLogOptions>,
        ) -> Self {
            self.connection_log_options = input;
            self
        }
        /// <p>Information about the DNS servers to be used by Client VPN connections. A Client VPN endpoint can have
        /// up to two DNS servers.</p>
        pub fn dns_servers(
            mut self,
            input: crate::model::DnsServersOptionsModifyStructure,
        ) -> Self {
            self.dns_servers = Some(input);
            self
        }
        pub fn set_dns_servers(
            mut self,
            input: std::option::Option<crate::model::DnsServersOptionsModifyStructure>,
        ) -> Self {
            self.dns_servers = input;
            self
        }
        /// <p>The port number to assign to the Client VPN endpoint for TCP and UDP traffic.</p>
        /// <p>Valid Values: <code>443</code> | <code>1194</code>
        /// </p>
        /// <p>Default Value: <code>443</code>
        /// </p>
        pub fn vpn_port(mut self, input: i32) -> Self {
            self.vpn_port = Some(input);
            self
        }
        pub fn set_vpn_port(mut self, input: std::option::Option<i32>) -> Self {
            self.vpn_port = input;
            self
        }
        /// <p>A brief description of the Client VPN endpoint.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Indicates whether the VPN is split-tunnel.</p>
        /// <p>For information about split-tunnel VPN endpoints, see <a href="https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html">Split-Tunnel AWS Client VPN Endpoint</a> in the <i>AWS
        /// Client VPN Administrator Guide</i>.</p>
        pub fn split_tunnel(mut self, input: bool) -> Self {
            self.split_tunnel = Some(input);
            self
        }
        pub fn set_split_tunnel(mut self, input: std::option::Option<bool>) -> Self {
            self.split_tunnel = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn security_group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.security_group_ids.unwrap_or_default();
            v.push(input.into());
            self.security_group_ids = Some(v);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.security_group_ids = input;
            self
        }
        /// <p>The ID of the VPC to associate with the Client VPN endpoint.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>Specify whether to enable the self-service portal for the Client VPN endpoint.</p>
        pub fn self_service_portal(mut self, input: crate::model::SelfServicePortal) -> Self {
            self.self_service_portal = Some(input);
            self
        }
        pub fn set_self_service_portal(
            mut self,
            input: std::option::Option<crate::model::SelfServicePortal>,
        ) -> Self {
            self.self_service_portal = input;
            self
        }
        /// <p>The options for managing connection authorization for new client connections.</p>
        pub fn client_connect_options(mut self, input: crate::model::ClientConnectOptions) -> Self {
            self.client_connect_options = Some(input);
            self
        }
        pub fn set_client_connect_options(
            mut self,
            input: std::option::Option<crate::model::ClientConnectOptions>,
        ) -> Self {
            self.client_connect_options = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyClientVpnEndpointInput`](crate::input::ModifyClientVpnEndpointInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyClientVpnEndpointInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyClientVpnEndpointInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                server_certificate_arn: self.server_certificate_arn,
                connection_log_options: self.connection_log_options,
                dns_servers: self.dns_servers,
                vpn_port: self.vpn_port,
                description: self.description,
                split_tunnel: self.split_tunnel,
                dry_run: self.dry_run,
                security_group_ids: self.security_group_ids,
                vpc_id: self.vpc_id,
                self_service_portal: self.self_service_portal,
                client_connect_options: self.client_connect_options,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyClientVpnEndpointInputOperationOutputAlias =
    crate::operation::ModifyClientVpnEndpoint;
#[doc(hidden)]
pub type ModifyClientVpnEndpointInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyClientVpnEndpointInput {
    /// Consumes the builder and constructs an Operation<[`ModifyClientVpnEndpoint`](crate::operation::ModifyClientVpnEndpoint)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyClientVpnEndpoint,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_client_vpn_endpoint(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyClientVpnEndpoint::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyClientVpnEndpoint",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyClientVpnEndpointInput`](crate::input::ModifyClientVpnEndpointInput)
    pub fn builder() -> crate::input::modify_client_vpn_endpoint_input::Builder {
        crate::input::modify_client_vpn_endpoint_input::Builder::default()
    }
}

/// See [`ModifyDefaultCreditSpecificationInput`](crate::input::ModifyDefaultCreditSpecificationInput)
pub mod modify_default_credit_specification_input {
    /// A builder for [`ModifyDefaultCreditSpecificationInput`](crate::input::ModifyDefaultCreditSpecificationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_family:
            std::option::Option<crate::model::UnlimitedSupportedInstanceFamily>,
        pub(crate) cpu_credits: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The instance family.</p>
        pub fn instance_family(
            mut self,
            input: crate::model::UnlimitedSupportedInstanceFamily,
        ) -> Self {
            self.instance_family = Some(input);
            self
        }
        pub fn set_instance_family(
            mut self,
            input: std::option::Option<crate::model::UnlimitedSupportedInstanceFamily>,
        ) -> Self {
            self.instance_family = input;
            self
        }
        /// <p>The credit option for CPU usage of the instance family.</p>
        /// <p>Valid Values: <code>standard</code> | <code>unlimited</code>
        /// </p>
        pub fn cpu_credits(mut self, input: impl Into<std::string::String>) -> Self {
            self.cpu_credits = Some(input.into());
            self
        }
        pub fn set_cpu_credits(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cpu_credits = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyDefaultCreditSpecificationInput`](crate::input::ModifyDefaultCreditSpecificationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyDefaultCreditSpecificationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyDefaultCreditSpecificationInput {
                dry_run: self.dry_run,
                instance_family: self.instance_family,
                cpu_credits: self.cpu_credits,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyDefaultCreditSpecificationInputOperationOutputAlias =
    crate::operation::ModifyDefaultCreditSpecification;
#[doc(hidden)]
pub type ModifyDefaultCreditSpecificationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyDefaultCreditSpecificationInput {
    /// Consumes the builder and constructs an Operation<[`ModifyDefaultCreditSpecification`](crate::operation::ModifyDefaultCreditSpecification)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyDefaultCreditSpecification,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_default_credit_specification(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyDefaultCreditSpecification::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyDefaultCreditSpecification",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyDefaultCreditSpecificationInput`](crate::input::ModifyDefaultCreditSpecificationInput)
    pub fn builder() -> crate::input::modify_default_credit_specification_input::Builder {
        crate::input::modify_default_credit_specification_input::Builder::default()
    }
}

/// See [`ModifyEbsDefaultKmsKeyIdInput`](crate::input::ModifyEbsDefaultKmsKeyIdInput)
pub mod modify_ebs_default_kms_key_id_input {
    /// A builder for [`ModifyEbsDefaultKmsKeyIdInput`](crate::input::ModifyEbsDefaultKmsKeyIdInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) kms_key_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The identifier of the AWS Key Management Service (AWS KMS) customer master key (CMK) to use for Amazon EBS encryption.
        /// If this parameter is not specified, your AWS managed CMK for EBS is used. If <code>KmsKeyId</code> is
        /// specified, the encrypted state must be <code>true</code>.</p>
        /// <p>You can specify the CMK using any of the following:</p>
        /// <ul>
        /// <li>
        /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Key alias. For example, alias/ExampleAlias.</p>
        /// </li>
        /// <li>
        /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
        /// </li>
        /// <li>
        /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
        /// </li>
        /// </ul>
        /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an ID, alias, or ARN that is not valid,
        /// the action can appear to complete, but eventually fails.</p>  
        /// <p>Amazon EBS does not support asymmetric CMKs.</p>
        pub fn kms_key_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kms_key_id = Some(input.into());
            self
        }
        pub fn set_kms_key_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kms_key_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyEbsDefaultKmsKeyIdInput`](crate::input::ModifyEbsDefaultKmsKeyIdInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyEbsDefaultKmsKeyIdInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyEbsDefaultKmsKeyIdInput {
                kms_key_id: self.kms_key_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyEbsDefaultKmsKeyIdInputOperationOutputAlias =
    crate::operation::ModifyEbsDefaultKmsKeyId;
#[doc(hidden)]
pub type ModifyEbsDefaultKmsKeyIdInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyEbsDefaultKmsKeyIdInput {
    /// Consumes the builder and constructs an Operation<[`ModifyEbsDefaultKmsKeyId`](crate::operation::ModifyEbsDefaultKmsKeyId)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyEbsDefaultKmsKeyId,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_ebs_default_kms_key_id(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyEbsDefaultKmsKeyId::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyEbsDefaultKmsKeyId",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyEbsDefaultKmsKeyIdInput`](crate::input::ModifyEbsDefaultKmsKeyIdInput)
    pub fn builder() -> crate::input::modify_ebs_default_kms_key_id_input::Builder {
        crate::input::modify_ebs_default_kms_key_id_input::Builder::default()
    }
}

/// See [`ModifyFleetInput`](crate::input::ModifyFleetInput)
pub mod modify_fleet_input {
    /// A builder for [`ModifyFleetInput`](crate::input::ModifyFleetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) excess_capacity_termination_policy:
            std::option::Option<crate::model::FleetExcessCapacityTerminationPolicy>,
        pub(crate) launch_template_configs:
            std::option::Option<std::vec::Vec<crate::model::FleetLaunchTemplateConfigRequest>>,
        pub(crate) fleet_id: std::option::Option<std::string::String>,
        pub(crate) target_capacity_specification:
            std::option::Option<crate::model::TargetCapacitySpecificationRequest>,
        pub(crate) context: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Indicates whether running instances should be terminated if the total target capacity of
        /// the EC2 Fleet is decreased below the current size of the EC2 Fleet.</p>
        pub fn excess_capacity_termination_policy(
            mut self,
            input: crate::model::FleetExcessCapacityTerminationPolicy,
        ) -> Self {
            self.excess_capacity_termination_policy = Some(input);
            self
        }
        pub fn set_excess_capacity_termination_policy(
            mut self,
            input: std::option::Option<crate::model::FleetExcessCapacityTerminationPolicy>,
        ) -> Self {
            self.excess_capacity_termination_policy = input;
            self
        }
        pub fn launch_template_configs(
            mut self,
            input: impl Into<crate::model::FleetLaunchTemplateConfigRequest>,
        ) -> Self {
            let mut v = self.launch_template_configs.unwrap_or_default();
            v.push(input.into());
            self.launch_template_configs = Some(v);
            self
        }
        pub fn set_launch_template_configs(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::FleetLaunchTemplateConfigRequest>,
            >,
        ) -> Self {
            self.launch_template_configs = input;
            self
        }
        /// <p>The ID of the EC2 Fleet.</p>
        pub fn fleet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.fleet_id = Some(input.into());
            self
        }
        pub fn set_fleet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.fleet_id = input;
            self
        }
        /// <p>The size of the EC2 Fleet.</p>
        pub fn target_capacity_specification(
            mut self,
            input: crate::model::TargetCapacitySpecificationRequest,
        ) -> Self {
            self.target_capacity_specification = Some(input);
            self
        }
        pub fn set_target_capacity_specification(
            mut self,
            input: std::option::Option<crate::model::TargetCapacitySpecificationRequest>,
        ) -> Self {
            self.target_capacity_specification = input;
            self
        }
        /// <p>Reserved.</p>
        pub fn context(mut self, input: impl Into<std::string::String>) -> Self {
            self.context = Some(input.into());
            self
        }
        pub fn set_context(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.context = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyFleetInput`](crate::input::ModifyFleetInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ModifyFleetInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ModifyFleetInput {
                dry_run: self.dry_run,
                excess_capacity_termination_policy: self.excess_capacity_termination_policy,
                launch_template_configs: self.launch_template_configs,
                fleet_id: self.fleet_id,
                target_capacity_specification: self.target_capacity_specification,
                context: self.context,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyFleetInputOperationOutputAlias = crate::operation::ModifyFleet;
#[doc(hidden)]
pub type ModifyFleetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyFleetInput {
    /// Consumes the builder and constructs an Operation<[`ModifyFleet`](crate::operation::ModifyFleet)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyFleet,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_fleet(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyFleet::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ModifyFleet", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyFleetInput`](crate::input::ModifyFleetInput)
    pub fn builder() -> crate::input::modify_fleet_input::Builder {
        crate::input::modify_fleet_input::Builder::default()
    }
}

/// See [`ModifyFpgaImageAttributeInput`](crate::input::ModifyFpgaImageAttributeInput)
pub mod modify_fpga_image_attribute_input {
    /// A builder for [`ModifyFpgaImageAttributeInput`](crate::input::ModifyFpgaImageAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) fpga_image_id: std::option::Option<std::string::String>,
        pub(crate) attribute: std::option::Option<crate::model::FpgaImageAttributeName>,
        pub(crate) operation_type: std::option::Option<crate::model::OperationType>,
        pub(crate) user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) user_groups: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) product_codes: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) load_permission: std::option::Option<crate::model::LoadPermissionModifications>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) name: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the AFI.</p>
        pub fn fpga_image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.fpga_image_id = Some(input.into());
            self
        }
        pub fn set_fpga_image_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.fpga_image_id = input;
            self
        }
        /// <p>The name of the attribute.</p>
        pub fn attribute(mut self, input: crate::model::FpgaImageAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::FpgaImageAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The operation type.</p>
        pub fn operation_type(mut self, input: crate::model::OperationType) -> Self {
            self.operation_type = Some(input);
            self
        }
        pub fn set_operation_type(
            mut self,
            input: std::option::Option<crate::model::OperationType>,
        ) -> Self {
            self.operation_type = input;
            self
        }
        pub fn user_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.user_ids.unwrap_or_default();
            v.push(input.into());
            self.user_ids = Some(v);
            self
        }
        pub fn set_user_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.user_ids = input;
            self
        }
        pub fn user_groups(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.user_groups.unwrap_or_default();
            v.push(input.into());
            self.user_groups = Some(v);
            self
        }
        pub fn set_user_groups(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.user_groups = input;
            self
        }
        pub fn product_codes(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.product_codes.unwrap_or_default();
            v.push(input.into());
            self.product_codes = Some(v);
            self
        }
        pub fn set_product_codes(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.product_codes = input;
            self
        }
        /// <p>The load permission for the AFI.</p>
        pub fn load_permission(mut self, input: crate::model::LoadPermissionModifications) -> Self {
            self.load_permission = Some(input);
            self
        }
        pub fn set_load_permission(
            mut self,
            input: std::option::Option<crate::model::LoadPermissionModifications>,
        ) -> Self {
            self.load_permission = input;
            self
        }
        /// <p>A description for the AFI.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>A name for the AFI.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyFpgaImageAttributeInput`](crate::input::ModifyFpgaImageAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyFpgaImageAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyFpgaImageAttributeInput {
                dry_run: self.dry_run,
                fpga_image_id: self.fpga_image_id,
                attribute: self.attribute,
                operation_type: self.operation_type,
                user_ids: self.user_ids,
                user_groups: self.user_groups,
                product_codes: self.product_codes,
                load_permission: self.load_permission,
                description: self.description,
                name: self.name,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyFpgaImageAttributeInputOperationOutputAlias =
    crate::operation::ModifyFpgaImageAttribute;
#[doc(hidden)]
pub type ModifyFpgaImageAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyFpgaImageAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyFpgaImageAttribute`](crate::operation::ModifyFpgaImageAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyFpgaImageAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_fpga_image_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyFpgaImageAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyFpgaImageAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyFpgaImageAttributeInput`](crate::input::ModifyFpgaImageAttributeInput)
    pub fn builder() -> crate::input::modify_fpga_image_attribute_input::Builder {
        crate::input::modify_fpga_image_attribute_input::Builder::default()
    }
}

/// See [`ModifyHostsInput`](crate::input::ModifyHostsInput)
pub mod modify_hosts_input {
    /// A builder for [`ModifyHostsInput`](crate::input::ModifyHostsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) auto_placement: std::option::Option<crate::model::AutoPlacement>,
        pub(crate) host_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) host_recovery: std::option::Option<crate::model::HostRecovery>,
        pub(crate) instance_type: std::option::Option<std::string::String>,
        pub(crate) instance_family: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Specify whether to enable or disable auto-placement.</p>
        pub fn auto_placement(mut self, input: crate::model::AutoPlacement) -> Self {
            self.auto_placement = Some(input);
            self
        }
        pub fn set_auto_placement(
            mut self,
            input: std::option::Option<crate::model::AutoPlacement>,
        ) -> Self {
            self.auto_placement = input;
            self
        }
        pub fn host_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.host_ids.unwrap_or_default();
            v.push(input.into());
            self.host_ids = Some(v);
            self
        }
        pub fn set_host_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.host_ids = input;
            self
        }
        /// <p>Indicates whether to enable or disable host recovery for the Dedicated Host. For more information,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/dedicated-hosts-recovery.html">
        /// Host recovery</a> in the <i>Amazon EC2 User Guide</i>.</p>
        pub fn host_recovery(mut self, input: crate::model::HostRecovery) -> Self {
            self.host_recovery = Some(input);
            self
        }
        pub fn set_host_recovery(
            mut self,
            input: std::option::Option<crate::model::HostRecovery>,
        ) -> Self {
            self.host_recovery = input;
            self
        }
        /// <p>Specifies the instance type to be supported by the Dedicated Host. Specify this parameter to
        /// modify a Dedicated Host to support only a specific instance type.</p>
        /// <p>If you want to modify a Dedicated Host to support multiple instance types in its current instance
        /// family, omit this parameter and specify <b>InstanceFamily</b>
        /// instead. You cannot specify <b>InstanceType</b> and
        /// <b>InstanceFamily</b> in the same request.</p>
        pub fn instance_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_type = Some(input.into());
            self
        }
        pub fn set_instance_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.instance_type = input;
            self
        }
        /// <p>Specifies the instance family to be supported by the Dedicated Host. Specify this parameter
        /// to modify a Dedicated Host to support multiple instance types within its current
        /// instance family.</p>
        /// <p>If you want to modify a Dedicated Host to support a specific instance type only, omit this parameter
        /// and specify <b>InstanceType</b> instead. You cannot specify
        /// <b>InstanceFamily</b> and <b>InstanceType</b>
        /// in the same request.</p>
        pub fn instance_family(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_family = Some(input.into());
            self
        }
        pub fn set_instance_family(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.instance_family = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyHostsInput`](crate::input::ModifyHostsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ModifyHostsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ModifyHostsInput {
                auto_placement: self.auto_placement,
                host_ids: self.host_ids,
                host_recovery: self.host_recovery,
                instance_type: self.instance_type,
                instance_family: self.instance_family,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyHostsInputOperationOutputAlias = crate::operation::ModifyHosts;
#[doc(hidden)]
pub type ModifyHostsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyHostsInput {
    /// Consumes the builder and constructs an Operation<[`ModifyHosts`](crate::operation::ModifyHosts)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyHosts,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_hosts(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyHosts::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ModifyHosts", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyHostsInput`](crate::input::ModifyHostsInput)
    pub fn builder() -> crate::input::modify_hosts_input::Builder {
        crate::input::modify_hosts_input::Builder::default()
    }
}

/// See [`ModifyIdentityIdFormatInput`](crate::input::ModifyIdentityIdFormatInput)
pub mod modify_identity_id_format_input {
    /// A builder for [`ModifyIdentityIdFormatInput`](crate::input::ModifyIdentityIdFormatInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) principal_arn: std::option::Option<std::string::String>,
        pub(crate) resource: std::option::Option<std::string::String>,
        pub(crate) use_long_ids: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ARN of the principal, which can be an IAM user, IAM role, or the root user. Specify
        /// <code>all</code> to modify the ID format for all IAM users, IAM roles, and the root user of
        /// the account.</p>
        pub fn principal_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.principal_arn = Some(input.into());
            self
        }
        pub fn set_principal_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.principal_arn = input;
            self
        }
        /// <p>The type of resource: <code>bundle</code> | <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
        /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
        /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
        /// <code>import-task</code> | <code>internet-gateway</code> | <code>network-acl</code>
        /// | <code>network-acl-association</code> | <code>network-interface</code> |
        /// <code>network-interface-attachment</code> | <code>prefix-list</code> |
        /// <code>route-table</code> | <code>route-table-association</code> |
        /// <code>security-group</code> | <code>subnet</code> |
        /// <code>subnet-cidr-block-association</code> | <code>vpc</code> |
        /// <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> | <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>.</p>
        /// <p>Alternatively, use the <code>all-current</code> option to include all resource types that are
        /// currently within their opt-in period for longer IDs.</p>
        pub fn resource(mut self, input: impl Into<std::string::String>) -> Self {
            self.resource = Some(input.into());
            self
        }
        pub fn set_resource(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.resource = input;
            self
        }
        /// <p>Indicates whether the resource should use longer IDs (17-character IDs)</p>
        pub fn use_long_ids(mut self, input: bool) -> Self {
            self.use_long_ids = Some(input);
            self
        }
        pub fn set_use_long_ids(mut self, input: std::option::Option<bool>) -> Self {
            self.use_long_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyIdentityIdFormatInput`](crate::input::ModifyIdentityIdFormatInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyIdentityIdFormatInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyIdentityIdFormatInput {
                principal_arn: self.principal_arn,
                resource: self.resource,
                use_long_ids: self.use_long_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyIdentityIdFormatInputOperationOutputAlias = crate::operation::ModifyIdentityIdFormat;
#[doc(hidden)]
pub type ModifyIdentityIdFormatInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyIdentityIdFormatInput {
    /// Consumes the builder and constructs an Operation<[`ModifyIdentityIdFormat`](crate::operation::ModifyIdentityIdFormat)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyIdentityIdFormat,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_identity_id_format(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyIdentityIdFormat::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyIdentityIdFormat",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyIdentityIdFormatInput`](crate::input::ModifyIdentityIdFormatInput)
    pub fn builder() -> crate::input::modify_identity_id_format_input::Builder {
        crate::input::modify_identity_id_format_input::Builder::default()
    }
}

/// See [`ModifyIdFormatInput`](crate::input::ModifyIdFormatInput)
pub mod modify_id_format_input {
    /// A builder for [`ModifyIdFormatInput`](crate::input::ModifyIdFormatInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) resource: std::option::Option<std::string::String>,
        pub(crate) use_long_ids: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The type of resource: <code>bundle</code> | <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
        /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
        /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
        /// <code>import-task</code> | <code>internet-gateway</code> | <code>network-acl</code>
        /// | <code>network-acl-association</code> | <code>network-interface</code> |
        /// <code>network-interface-attachment</code> | <code>prefix-list</code> |
        /// <code>route-table</code> | <code>route-table-association</code> |
        /// <code>security-group</code> | <code>subnet</code> |
        /// <code>subnet-cidr-block-association</code> | <code>vpc</code> |
        /// <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> | <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>.</p>
        /// <p>Alternatively, use the <code>all-current</code> option to include all resource types that are
        /// currently within their opt-in period for longer IDs.</p>
        pub fn resource(mut self, input: impl Into<std::string::String>) -> Self {
            self.resource = Some(input.into());
            self
        }
        pub fn set_resource(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.resource = input;
            self
        }
        /// <p>Indicate whether the resource should use longer IDs (17-character IDs).</p>
        pub fn use_long_ids(mut self, input: bool) -> Self {
            self.use_long_ids = Some(input);
            self
        }
        pub fn set_use_long_ids(mut self, input: std::option::Option<bool>) -> Self {
            self.use_long_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyIdFormatInput`](crate::input::ModifyIdFormatInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyIdFormatInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyIdFormatInput {
                resource: self.resource,
                use_long_ids: self.use_long_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyIdFormatInputOperationOutputAlias = crate::operation::ModifyIdFormat;
#[doc(hidden)]
pub type ModifyIdFormatInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyIdFormatInput {
    /// Consumes the builder and constructs an Operation<[`ModifyIdFormat`](crate::operation::ModifyIdFormat)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyIdFormat,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_id_format(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyIdFormat::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyIdFormat",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyIdFormatInput`](crate::input::ModifyIdFormatInput)
    pub fn builder() -> crate::input::modify_id_format_input::Builder {
        crate::input::modify_id_format_input::Builder::default()
    }
}

/// See [`ModifyImageAttributeInput`](crate::input::ModifyImageAttributeInput)
pub mod modify_image_attribute_input {
    /// A builder for [`ModifyImageAttributeInput`](crate::input::ModifyImageAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<crate::model::AttributeValue>,
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) launch_permission:
            std::option::Option<crate::model::LaunchPermissionModifications>,
        pub(crate) operation_type: std::option::Option<crate::model::OperationType>,
        pub(crate) product_codes: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) user_groups: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) value: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The name of the attribute to modify.
        /// The valid values are <code>description</code>, <code>launchPermission</code>, and <code>productCodes</code>.</p>
        pub fn attribute(mut self, input: impl Into<std::string::String>) -> Self {
            self.attribute = Some(input.into());
            self
        }
        pub fn set_attribute(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.attribute = input;
            self
        }
        /// <p>A new description for the AMI.</p>
        pub fn description(mut self, input: crate::model::AttributeValue) -> Self {
            self.description = Some(input);
            self
        }
        pub fn set_description(
            mut self,
            input: std::option::Option<crate::model::AttributeValue>,
        ) -> Self {
            self.description = input;
            self
        }
        /// <p>The ID of the AMI.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>A new launch permission for the AMI.</p>
        pub fn launch_permission(
            mut self,
            input: crate::model::LaunchPermissionModifications,
        ) -> Self {
            self.launch_permission = Some(input);
            self
        }
        pub fn set_launch_permission(
            mut self,
            input: std::option::Option<crate::model::LaunchPermissionModifications>,
        ) -> Self {
            self.launch_permission = input;
            self
        }
        /// <p>The operation type.
        /// This parameter can be used only when the <code>Attribute</code> parameter is <code>launchPermission</code>.</p>
        pub fn operation_type(mut self, input: crate::model::OperationType) -> Self {
            self.operation_type = Some(input);
            self
        }
        pub fn set_operation_type(
            mut self,
            input: std::option::Option<crate::model::OperationType>,
        ) -> Self {
            self.operation_type = input;
            self
        }
        pub fn product_codes(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.product_codes.unwrap_or_default();
            v.push(input.into());
            self.product_codes = Some(v);
            self
        }
        pub fn set_product_codes(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.product_codes = input;
            self
        }
        pub fn user_groups(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.user_groups.unwrap_or_default();
            v.push(input.into());
            self.user_groups = Some(v);
            self
        }
        pub fn set_user_groups(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.user_groups = input;
            self
        }
        pub fn user_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.user_ids.unwrap_or_default();
            v.push(input.into());
            self.user_ids = Some(v);
            self
        }
        pub fn set_user_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.user_ids = input;
            self
        }
        /// <p>The value of the attribute being modified.
        /// This parameter can be used only when the <code>Attribute</code> parameter is <code>description</code> or <code>productCodes</code>.</p>
        pub fn value(mut self, input: impl Into<std::string::String>) -> Self {
            self.value = Some(input.into());
            self
        }
        pub fn set_value(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.value = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyImageAttributeInput`](crate::input::ModifyImageAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyImageAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyImageAttributeInput {
                attribute: self.attribute,
                description: self.description,
                image_id: self.image_id,
                launch_permission: self.launch_permission,
                operation_type: self.operation_type,
                product_codes: self.product_codes,
                user_groups: self.user_groups,
                user_ids: self.user_ids,
                value: self.value,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyImageAttributeInputOperationOutputAlias = crate::operation::ModifyImageAttribute;
#[doc(hidden)]
pub type ModifyImageAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyImageAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyImageAttribute`](crate::operation::ModifyImageAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyImageAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_image_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyImageAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyImageAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyImageAttributeInput`](crate::input::ModifyImageAttributeInput)
    pub fn builder() -> crate::input::modify_image_attribute_input::Builder {
        crate::input::modify_image_attribute_input::Builder::default()
    }
}

/// See [`ModifyInstanceAttributeInput`](crate::input::ModifyInstanceAttributeInput)
pub mod modify_instance_attribute_input {
    /// A builder for [`ModifyInstanceAttributeInput`](crate::input::ModifyInstanceAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) source_dest_check: std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) attribute: std::option::Option<crate::model::InstanceAttributeName>,
        pub(crate) block_device_mappings: std::option::Option<
            std::vec::Vec<crate::model::InstanceBlockDeviceMappingSpecification>,
        >,
        pub(crate) disable_api_termination:
            std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) ebs_optimized: std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) ena_support: std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) groups: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) instance_initiated_shutdown_behavior:
            std::option::Option<crate::model::AttributeValue>,
        pub(crate) instance_type: std::option::Option<crate::model::AttributeValue>,
        pub(crate) kernel: std::option::Option<crate::model::AttributeValue>,
        pub(crate) ramdisk: std::option::Option<crate::model::AttributeValue>,
        pub(crate) sriov_net_support: std::option::Option<crate::model::AttributeValue>,
        pub(crate) user_data: std::option::Option<crate::model::BlobAttributeValue>,
        pub(crate) value: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Enable or disable source/destination checks, which ensure that the instance
        /// is either the source or the destination of any traffic that it receives.
        /// If the value is <code>true</code>, source/destination checks are enabled;
        /// otherwise, they are disabled. The default value is <code>true</code>.
        /// You must disable source/destination checks if the instance runs services
        /// such as network address translation, routing, or firewalls.</p>
        pub fn source_dest_check(mut self, input: crate::model::AttributeBooleanValue) -> Self {
            self.source_dest_check = Some(input);
            self
        }
        pub fn set_source_dest_check(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.source_dest_check = input;
            self
        }
        /// <p>The name of the attribute.</p>
        pub fn attribute(mut self, input: crate::model::InstanceAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::InstanceAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        pub fn block_device_mappings(
            mut self,
            input: impl Into<crate::model::InstanceBlockDeviceMappingSpecification>,
        ) -> Self {
            let mut v = self.block_device_mappings.unwrap_or_default();
            v.push(input.into());
            self.block_device_mappings = Some(v);
            self
        }
        pub fn set_block_device_mappings(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::InstanceBlockDeviceMappingSpecification>,
            >,
        ) -> Self {
            self.block_device_mappings = input;
            self
        }
        /// <p>If the value is <code>true</code>, you can't terminate the instance using the Amazon
        /// EC2 console, CLI, or API; otherwise, you can. You cannot use this parameter for Spot
        /// Instances.</p>
        pub fn disable_api_termination(
            mut self,
            input: crate::model::AttributeBooleanValue,
        ) -> Self {
            self.disable_api_termination = Some(input);
            self
        }
        pub fn set_disable_api_termination(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.disable_api_termination = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Specifies whether the instance is optimized for Amazon EBS I/O. This optimization
        /// provides dedicated throughput to Amazon EBS and an optimized configuration stack to
        /// provide optimal EBS I/O performance. This optimization isn't available with all instance
        /// types. Additional usage charges apply when using an EBS Optimized instance.</p>
        pub fn ebs_optimized(mut self, input: crate::model::AttributeBooleanValue) -> Self {
            self.ebs_optimized = Some(input);
            self
        }
        pub fn set_ebs_optimized(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.ebs_optimized = input;
            self
        }
        /// <p>Set to <code>true</code> to enable enhanced networking with ENA for the
        /// instance.</p>
        /// <p>This option is supported only for HVM instances. Specifying this option with a PV
        /// instance can make it unreachable.</p>
        pub fn ena_support(mut self, input: crate::model::AttributeBooleanValue) -> Self {
            self.ena_support = Some(input);
            self
        }
        pub fn set_ena_support(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.ena_support = input;
            self
        }
        pub fn groups(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.groups.unwrap_or_default();
            v.push(input.into());
            self.groups = Some(v);
            self
        }
        pub fn set_groups(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.groups = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>Specifies whether an instance stops or terminates when you initiate shutdown from the
        /// instance (using the operating system command for system shutdown).</p>
        pub fn instance_initiated_shutdown_behavior(
            mut self,
            input: crate::model::AttributeValue,
        ) -> Self {
            self.instance_initiated_shutdown_behavior = Some(input);
            self
        }
        pub fn set_instance_initiated_shutdown_behavior(
            mut self,
            input: std::option::Option<crate::model::AttributeValue>,
        ) -> Self {
            self.instance_initiated_shutdown_behavior = input;
            self
        }
        /// <p>Changes the instance type to the specified value. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance
        /// types</a> in the <i>Amazon EC2 User Guide</i>. If the instance type is not valid,
        /// the error returned is <code>InvalidInstanceAttributeValue</code>.</p>
        pub fn instance_type(mut self, input: crate::model::AttributeValue) -> Self {
            self.instance_type = Some(input);
            self
        }
        pub fn set_instance_type(
            mut self,
            input: std::option::Option<crate::model::AttributeValue>,
        ) -> Self {
            self.instance_type = input;
            self
        }
        /// <p>Changes the instance's kernel to the specified value. We recommend that you use
        /// PV-GRUB instead of kernels and RAM disks. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html">PV-GRUB</a>.</p>
        pub fn kernel(mut self, input: crate::model::AttributeValue) -> Self {
            self.kernel = Some(input);
            self
        }
        pub fn set_kernel(
            mut self,
            input: std::option::Option<crate::model::AttributeValue>,
        ) -> Self {
            self.kernel = input;
            self
        }
        /// <p>Changes the instance's RAM disk to the specified value. We recommend that you use
        /// PV-GRUB instead of kernels and RAM disks. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html">PV-GRUB</a>.</p>
        pub fn ramdisk(mut self, input: crate::model::AttributeValue) -> Self {
            self.ramdisk = Some(input);
            self
        }
        pub fn set_ramdisk(
            mut self,
            input: std::option::Option<crate::model::AttributeValue>,
        ) -> Self {
            self.ramdisk = input;
            self
        }
        /// <p>Set to <code>simple</code> to enable enhanced networking with the Intel 82599 Virtual
        /// Function interface for the instance.</p>
        /// <p>There is no way to disable enhanced networking with the Intel 82599 Virtual Function
        /// interface at this time.</p>
        /// <p>This option is supported only for HVM instances. Specifying this option with a PV
        /// instance can make it unreachable.</p>
        pub fn sriov_net_support(mut self, input: crate::model::AttributeValue) -> Self {
            self.sriov_net_support = Some(input);
            self
        }
        pub fn set_sriov_net_support(
            mut self,
            input: std::option::Option<crate::model::AttributeValue>,
        ) -> Self {
            self.sriov_net_support = input;
            self
        }
        /// <p>Changes the instance's user data to the specified value. If you are using an Amazon Web Services SDK
        /// or command line tool, base64-encoding is performed for you, and you can load the text
        /// from a file. Otherwise, you must provide base64-encoded text.</p>
        pub fn user_data(mut self, input: crate::model::BlobAttributeValue) -> Self {
            self.user_data = Some(input);
            self
        }
        pub fn set_user_data(
            mut self,
            input: std::option::Option<crate::model::BlobAttributeValue>,
        ) -> Self {
            self.user_data = input;
            self
        }
        /// <p>A new value for the attribute. Use only with the <code>kernel</code>,
        /// <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code>, or
        /// <code>instanceInitiatedShutdownBehavior</code> attribute.</p>
        pub fn value(mut self, input: impl Into<std::string::String>) -> Self {
            self.value = Some(input.into());
            self
        }
        pub fn set_value(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.value = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyInstanceAttributeInput`](crate::input::ModifyInstanceAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyInstanceAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyInstanceAttributeInput {
                source_dest_check: self.source_dest_check,
                attribute: self.attribute,
                block_device_mappings: self.block_device_mappings,
                disable_api_termination: self.disable_api_termination,
                dry_run: self.dry_run,
                ebs_optimized: self.ebs_optimized,
                ena_support: self.ena_support,
                groups: self.groups,
                instance_id: self.instance_id,
                instance_initiated_shutdown_behavior: self.instance_initiated_shutdown_behavior,
                instance_type: self.instance_type,
                kernel: self.kernel,
                ramdisk: self.ramdisk,
                sriov_net_support: self.sriov_net_support,
                user_data: self.user_data,
                value: self.value,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyInstanceAttributeInputOperationOutputAlias =
    crate::operation::ModifyInstanceAttribute;
#[doc(hidden)]
pub type ModifyInstanceAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyInstanceAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyInstanceAttribute`](crate::operation::ModifyInstanceAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyInstanceAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_instance_attribute(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyInstanceAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyInstanceAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyInstanceAttributeInput`](crate::input::ModifyInstanceAttributeInput)
    pub fn builder() -> crate::input::modify_instance_attribute_input::Builder {
        crate::input::modify_instance_attribute_input::Builder::default()
    }
}

/// See [`ModifyInstanceCapacityReservationAttributesInput`](crate::input::ModifyInstanceCapacityReservationAttributesInput)
pub mod modify_instance_capacity_reservation_attributes_input {
    /// A builder for [`ModifyInstanceCapacityReservationAttributesInput`](crate::input::ModifyInstanceCapacityReservationAttributesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) capacity_reservation_specification:
            std::option::Option<crate::model::CapacityReservationSpecification>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the instance to be modified.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>Information about the Capacity Reservation targeting option.</p>
        pub fn capacity_reservation_specification(
            mut self,
            input: crate::model::CapacityReservationSpecification,
        ) -> Self {
            self.capacity_reservation_specification = Some(input);
            self
        }
        pub fn set_capacity_reservation_specification(
            mut self,
            input: std::option::Option<crate::model::CapacityReservationSpecification>,
        ) -> Self {
            self.capacity_reservation_specification = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyInstanceCapacityReservationAttributesInput`](crate::input::ModifyInstanceCapacityReservationAttributesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyInstanceCapacityReservationAttributesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::ModifyInstanceCapacityReservationAttributesInput {
                    instance_id: self.instance_id,
                    capacity_reservation_specification: self.capacity_reservation_specification,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type ModifyInstanceCapacityReservationAttributesInputOperationOutputAlias =
    crate::operation::ModifyInstanceCapacityReservationAttributes;
#[doc(hidden)]
pub type ModifyInstanceCapacityReservationAttributesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ModifyInstanceCapacityReservationAttributesInput {
    /// Consumes the builder and constructs an Operation<[`ModifyInstanceCapacityReservationAttributes`](crate::operation::ModifyInstanceCapacityReservationAttributes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyInstanceCapacityReservationAttributes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_instance_capacity_reservation_attributes(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyInstanceCapacityReservationAttributes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyInstanceCapacityReservationAttributes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyInstanceCapacityReservationAttributesInput`](crate::input::ModifyInstanceCapacityReservationAttributesInput)
    pub fn builder() -> crate::input::modify_instance_capacity_reservation_attributes_input::Builder
    {
        crate::input::modify_instance_capacity_reservation_attributes_input::Builder::default()
    }
}

/// See [`ModifyInstanceCreditSpecificationInput`](crate::input::ModifyInstanceCreditSpecificationInput)
pub mod modify_instance_credit_specification_input {
    /// A builder for [`ModifyInstanceCreditSpecificationInput`](crate::input::ModifyInstanceCreditSpecificationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) instance_credit_specifications:
            std::option::Option<std::vec::Vec<crate::model::InstanceCreditSpecificationRequest>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>A unique, case-sensitive token that you provide to ensure idempotency of your
        /// modification request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
        /// Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        pub fn instance_credit_specifications(
            mut self,
            input: impl Into<crate::model::InstanceCreditSpecificationRequest>,
        ) -> Self {
            let mut v = self.instance_credit_specifications.unwrap_or_default();
            v.push(input.into());
            self.instance_credit_specifications = Some(v);
            self
        }
        pub fn set_instance_credit_specifications(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::InstanceCreditSpecificationRequest>,
            >,
        ) -> Self {
            self.instance_credit_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyInstanceCreditSpecificationInput`](crate::input::ModifyInstanceCreditSpecificationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyInstanceCreditSpecificationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyInstanceCreditSpecificationInput {
                dry_run: self.dry_run,
                client_token: self.client_token,
                instance_credit_specifications: self.instance_credit_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyInstanceCreditSpecificationInputOperationOutputAlias =
    crate::operation::ModifyInstanceCreditSpecification;
#[doc(hidden)]
pub type ModifyInstanceCreditSpecificationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyInstanceCreditSpecificationInput {
    /// Consumes the builder and constructs an Operation<[`ModifyInstanceCreditSpecification`](crate::operation::ModifyInstanceCreditSpecification)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyInstanceCreditSpecification,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_instance_credit_specification(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyInstanceCreditSpecification::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyInstanceCreditSpecification",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyInstanceCreditSpecificationInput`](crate::input::ModifyInstanceCreditSpecificationInput)
    pub fn builder() -> crate::input::modify_instance_credit_specification_input::Builder {
        crate::input::modify_instance_credit_specification_input::Builder::default()
    }
}

/// See [`ModifyInstanceEventStartTimeInput`](crate::input::ModifyInstanceEventStartTimeInput)
pub mod modify_instance_event_start_time_input {
    /// A builder for [`ModifyInstanceEventStartTimeInput`](crate::input::ModifyInstanceEventStartTimeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) instance_event_id: std::option::Option<std::string::String>,
        pub(crate) not_before: std::option::Option<smithy_types::Instant>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance with the scheduled event.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The ID of the event whose date and time you are modifying.</p>
        pub fn instance_event_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_event_id = Some(input.into());
            self
        }
        pub fn set_instance_event_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.instance_event_id = input;
            self
        }
        /// <p>The new date and time when the event will take place.</p>
        pub fn not_before(mut self, input: smithy_types::Instant) -> Self {
            self.not_before = Some(input);
            self
        }
        pub fn set_not_before(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.not_before = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyInstanceEventStartTimeInput`](crate::input::ModifyInstanceEventStartTimeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyInstanceEventStartTimeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyInstanceEventStartTimeInput {
                dry_run: self.dry_run,
                instance_id: self.instance_id,
                instance_event_id: self.instance_event_id,
                not_before: self.not_before,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyInstanceEventStartTimeInputOperationOutputAlias =
    crate::operation::ModifyInstanceEventStartTime;
#[doc(hidden)]
pub type ModifyInstanceEventStartTimeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyInstanceEventStartTimeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyInstanceEventStartTime`](crate::operation::ModifyInstanceEventStartTime)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyInstanceEventStartTime,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_instance_event_start_time(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyInstanceEventStartTime::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyInstanceEventStartTime",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyInstanceEventStartTimeInput`](crate::input::ModifyInstanceEventStartTimeInput)
    pub fn builder() -> crate::input::modify_instance_event_start_time_input::Builder {
        crate::input::modify_instance_event_start_time_input::Builder::default()
    }
}

/// See [`ModifyInstanceMetadataOptionsInput`](crate::input::ModifyInstanceMetadataOptionsInput)
pub mod modify_instance_metadata_options_input {
    /// A builder for [`ModifyInstanceMetadataOptionsInput`](crate::input::ModifyInstanceMetadataOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) http_tokens: std::option::Option<crate::model::HttpTokensState>,
        pub(crate) http_put_response_hop_limit: std::option::Option<i32>,
        pub(crate) http_endpoint: std::option::Option<crate::model::InstanceMetadataEndpointState>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The state of token usage for your instance metadata requests. If the parameter is not
        /// specified in the request, the default state is <code>optional</code>.</p>
        /// <p>If the state is <code>optional</code>, you can choose to retrieve instance metadata
        /// with or without a signed token header on your request. If you retrieve the IAM role
        /// credentials without a token, the version 1.0 role credentials are returned. If you
        /// retrieve the IAM role credentials using a valid signed token, the version 2.0 role
        /// credentials are returned.</p>
        /// <p>If the state is <code>required</code>, you must send a signed token header with any
        /// instance metadata retrieval requests. In this state, retrieving the IAM role credential
        /// always returns the version 2.0 credentials; the version 1.0 credentials are not
        /// available.</p>
        pub fn http_tokens(mut self, input: crate::model::HttpTokensState) -> Self {
            self.http_tokens = Some(input);
            self
        }
        pub fn set_http_tokens(
            mut self,
            input: std::option::Option<crate::model::HttpTokensState>,
        ) -> Self {
            self.http_tokens = input;
            self
        }
        /// <p>The desired HTTP PUT response hop limit for instance metadata requests. The larger the
        /// number, the further instance metadata requests can travel. If no parameter is specified, the existing state is maintained.</p>
        /// <p>Possible values: Integers from 1 to 64</p>
        pub fn http_put_response_hop_limit(mut self, input: i32) -> Self {
            self.http_put_response_hop_limit = Some(input);
            self
        }
        pub fn set_http_put_response_hop_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.http_put_response_hop_limit = input;
            self
        }
        /// <p>This parameter enables or disables the HTTP metadata endpoint on your instances. If
        /// the parameter is not specified, the existing state is maintained.</p>
        /// <note>
        /// <p>If you specify a value of <code>disabled</code>, you will not be able to access your
        /// instance metadata.</p>
        /// </note>
        pub fn http_endpoint(mut self, input: crate::model::InstanceMetadataEndpointState) -> Self {
            self.http_endpoint = Some(input);
            self
        }
        pub fn set_http_endpoint(
            mut self,
            input: std::option::Option<crate::model::InstanceMetadataEndpointState>,
        ) -> Self {
            self.http_endpoint = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyInstanceMetadataOptionsInput`](crate::input::ModifyInstanceMetadataOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyInstanceMetadataOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyInstanceMetadataOptionsInput {
                instance_id: self.instance_id,
                http_tokens: self.http_tokens,
                http_put_response_hop_limit: self.http_put_response_hop_limit,
                http_endpoint: self.http_endpoint,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyInstanceMetadataOptionsInputOperationOutputAlias =
    crate::operation::ModifyInstanceMetadataOptions;
#[doc(hidden)]
pub type ModifyInstanceMetadataOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyInstanceMetadataOptionsInput {
    /// Consumes the builder and constructs an Operation<[`ModifyInstanceMetadataOptions`](crate::operation::ModifyInstanceMetadataOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyInstanceMetadataOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_instance_metadata_options(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyInstanceMetadataOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyInstanceMetadataOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyInstanceMetadataOptionsInput`](crate::input::ModifyInstanceMetadataOptionsInput)
    pub fn builder() -> crate::input::modify_instance_metadata_options_input::Builder {
        crate::input::modify_instance_metadata_options_input::Builder::default()
    }
}

/// See [`ModifyInstancePlacementInput`](crate::input::ModifyInstancePlacementInput)
pub mod modify_instance_placement_input {
    /// A builder for [`ModifyInstancePlacementInput`](crate::input::ModifyInstancePlacementInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) affinity: std::option::Option<crate::model::Affinity>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) host_id: std::option::Option<std::string::String>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) tenancy: std::option::Option<crate::model::HostTenancy>,
        pub(crate) partition_number: std::option::Option<i32>,
        pub(crate) host_resource_group_arn: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The affinity setting for the instance.</p>
        pub fn affinity(mut self, input: crate::model::Affinity) -> Self {
            self.affinity = Some(input);
            self
        }
        pub fn set_affinity(mut self, input: std::option::Option<crate::model::Affinity>) -> Self {
            self.affinity = input;
            self
        }
        /// <p>The name of the placement group in which to place the instance. For spread placement
        /// groups, the instance must have a tenancy of <code>default</code>. For cluster and
        /// partition placement groups, the instance must have a tenancy of <code>default</code> or
        /// <code>dedicated</code>.</p>
        /// <p>To remove an instance from a placement group, specify an empty string
        /// ("").</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        /// <p>The ID of the Dedicated Host with which to associate the instance.</p>
        pub fn host_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.host_id = Some(input.into());
            self
        }
        pub fn set_host_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.host_id = input;
            self
        }
        /// <p>The ID of the instance that you are modifying.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>The tenancy for the instance.</p>
        pub fn tenancy(mut self, input: crate::model::HostTenancy) -> Self {
            self.tenancy = Some(input);
            self
        }
        pub fn set_tenancy(
            mut self,
            input: std::option::Option<crate::model::HostTenancy>,
        ) -> Self {
            self.tenancy = input;
            self
        }
        /// <p>Reserved for future use.</p>
        pub fn partition_number(mut self, input: i32) -> Self {
            self.partition_number = Some(input);
            self
        }
        pub fn set_partition_number(mut self, input: std::option::Option<i32>) -> Self {
            self.partition_number = input;
            self
        }
        /// <p>The ARN of the host resource group in which to place the instance.</p>
        pub fn host_resource_group_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.host_resource_group_arn = Some(input.into());
            self
        }
        pub fn set_host_resource_group_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.host_resource_group_arn = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyInstancePlacementInput`](crate::input::ModifyInstancePlacementInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyInstancePlacementInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyInstancePlacementInput {
                affinity: self.affinity,
                group_name: self.group_name,
                host_id: self.host_id,
                instance_id: self.instance_id,
                tenancy: self.tenancy,
                partition_number: self.partition_number,
                host_resource_group_arn: self.host_resource_group_arn,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyInstancePlacementInputOperationOutputAlias =
    crate::operation::ModifyInstancePlacement;
#[doc(hidden)]
pub type ModifyInstancePlacementInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyInstancePlacementInput {
    /// Consumes the builder and constructs an Operation<[`ModifyInstancePlacement`](crate::operation::ModifyInstancePlacement)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyInstancePlacement,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_instance_placement(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyInstancePlacement::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyInstancePlacement",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyInstancePlacementInput`](crate::input::ModifyInstancePlacementInput)
    pub fn builder() -> crate::input::modify_instance_placement_input::Builder {
        crate::input::modify_instance_placement_input::Builder::default()
    }
}

/// See [`ModifyLaunchTemplateInput`](crate::input::ModifyLaunchTemplateInput)
pub mod modify_launch_template_input {
    /// A builder for [`ModifyLaunchTemplateInput`](crate::input::ModifyLaunchTemplateInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) launch_template_id: std::option::Option<std::string::String>,
        pub(crate) launch_template_name: std::option::Option<std::string::String>,
        pub(crate) default_version: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
        /// Idempotency</a>.</p>
        /// <p>Constraint: Maximum 128 ASCII characters.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>The ID of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_id = Some(input.into());
            self
        }
        pub fn set_launch_template_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_id = input;
            self
        }
        /// <p>The name of the launch template. You must specify either the launch template ID or
        /// launch template name in the request.</p>
        pub fn launch_template_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_template_name = Some(input.into());
            self
        }
        pub fn set_launch_template_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.launch_template_name = input;
            self
        }
        /// <p>The version number of the launch template to set as the default version.</p>
        pub fn default_version(mut self, input: impl Into<std::string::String>) -> Self {
            self.default_version = Some(input.into());
            self
        }
        pub fn set_default_version(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.default_version = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyLaunchTemplateInput`](crate::input::ModifyLaunchTemplateInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyLaunchTemplateInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyLaunchTemplateInput {
                dry_run: self.dry_run,
                client_token: self.client_token,
                launch_template_id: self.launch_template_id,
                launch_template_name: self.launch_template_name,
                default_version: self.default_version,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyLaunchTemplateInputOperationOutputAlias = crate::operation::ModifyLaunchTemplate;
#[doc(hidden)]
pub type ModifyLaunchTemplateInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyLaunchTemplateInput {
    /// Consumes the builder and constructs an Operation<[`ModifyLaunchTemplate`](crate::operation::ModifyLaunchTemplate)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyLaunchTemplate,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_launch_template(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyLaunchTemplate::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyLaunchTemplate",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyLaunchTemplateInput`](crate::input::ModifyLaunchTemplateInput)
    pub fn builder() -> crate::input::modify_launch_template_input::Builder {
        crate::input::modify_launch_template_input::Builder::default()
    }
}

/// See [`ModifyManagedPrefixListInput`](crate::input::ModifyManagedPrefixListInput)
pub mod modify_managed_prefix_list_input {
    /// A builder for [`ModifyManagedPrefixListInput`](crate::input::ModifyManagedPrefixListInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) current_version: std::option::Option<i64>,
        pub(crate) prefix_list_name: std::option::Option<std::string::String>,
        pub(crate) add_entries:
            std::option::Option<std::vec::Vec<crate::model::AddPrefixListEntry>>,
        pub(crate) remove_entries:
            std::option::Option<std::vec::Vec<crate::model::RemovePrefixListEntry>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the prefix list.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// <p>The current version of the prefix list.</p>
        pub fn current_version(mut self, input: i64) -> Self {
            self.current_version = Some(input);
            self
        }
        pub fn set_current_version(mut self, input: std::option::Option<i64>) -> Self {
            self.current_version = input;
            self
        }
        /// <p>A name for the prefix list.</p>
        pub fn prefix_list_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_name = Some(input.into());
            self
        }
        pub fn set_prefix_list_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_name = input;
            self
        }
        pub fn add_entries(mut self, input: impl Into<crate::model::AddPrefixListEntry>) -> Self {
            let mut v = self.add_entries.unwrap_or_default();
            v.push(input.into());
            self.add_entries = Some(v);
            self
        }
        pub fn set_add_entries(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AddPrefixListEntry>>,
        ) -> Self {
            self.add_entries = input;
            self
        }
        pub fn remove_entries(
            mut self,
            input: impl Into<crate::model::RemovePrefixListEntry>,
        ) -> Self {
            let mut v = self.remove_entries.unwrap_or_default();
            v.push(input.into());
            self.remove_entries = Some(v);
            self
        }
        pub fn set_remove_entries(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::RemovePrefixListEntry>>,
        ) -> Self {
            self.remove_entries = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyManagedPrefixListInput`](crate::input::ModifyManagedPrefixListInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyManagedPrefixListInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyManagedPrefixListInput {
                dry_run: self.dry_run,
                prefix_list_id: self.prefix_list_id,
                current_version: self.current_version,
                prefix_list_name: self.prefix_list_name,
                add_entries: self.add_entries,
                remove_entries: self.remove_entries,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyManagedPrefixListInputOperationOutputAlias =
    crate::operation::ModifyManagedPrefixList;
#[doc(hidden)]
pub type ModifyManagedPrefixListInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyManagedPrefixListInput {
    /// Consumes the builder and constructs an Operation<[`ModifyManagedPrefixList`](crate::operation::ModifyManagedPrefixList)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyManagedPrefixList,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_managed_prefix_list(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyManagedPrefixList::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyManagedPrefixList",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyManagedPrefixListInput`](crate::input::ModifyManagedPrefixListInput)
    pub fn builder() -> crate::input::modify_managed_prefix_list_input::Builder {
        crate::input::modify_managed_prefix_list_input::Builder::default()
    }
}

/// See [`ModifyNetworkInterfaceAttributeInput`](crate::input::ModifyNetworkInterfaceAttributeInput)
pub mod modify_network_interface_attribute_input {
    /// A builder for [`ModifyNetworkInterfaceAttributeInput`](crate::input::ModifyNetworkInterfaceAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attachment: std::option::Option<crate::model::NetworkInterfaceAttachmentChanges>,
        pub(crate) description: std::option::Option<crate::model::AttributeValue>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) groups: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) source_dest_check: std::option::Option<crate::model::AttributeBooleanValue>,
    }
    impl Builder {
        /// <p>Information about the interface attachment. If modifying the 'delete on termination' attribute, you must specify the ID of the interface attachment.</p>
        pub fn attachment(
            mut self,
            input: crate::model::NetworkInterfaceAttachmentChanges,
        ) -> Self {
            self.attachment = Some(input);
            self
        }
        pub fn set_attachment(
            mut self,
            input: std::option::Option<crate::model::NetworkInterfaceAttachmentChanges>,
        ) -> Self {
            self.attachment = input;
            self
        }
        /// <p>A description for the network interface.</p>
        pub fn description(mut self, input: crate::model::AttributeValue) -> Self {
            self.description = Some(input);
            self
        }
        pub fn set_description(
            mut self,
            input: std::option::Option<crate::model::AttributeValue>,
        ) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn groups(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.groups.unwrap_or_default();
            v.push(input.into());
            self.groups = Some(v);
            self
        }
        pub fn set_groups(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.groups = input;
            self
        }
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>Enable or disable source/destination checks, which ensure that the instance
        /// is either the source or the destination of any traffic that it receives.
        /// If the value is <code>true</code>, source/destination checks are enabled;
        /// otherwise, they are disabled. The default value is <code>true</code>.
        /// You must disable source/destination checks if the instance runs services
        /// such as network address translation, routing, or firewalls.</p>
        pub fn source_dest_check(mut self, input: crate::model::AttributeBooleanValue) -> Self {
            self.source_dest_check = Some(input);
            self
        }
        pub fn set_source_dest_check(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.source_dest_check = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyNetworkInterfaceAttributeInput`](crate::input::ModifyNetworkInterfaceAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyNetworkInterfaceAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyNetworkInterfaceAttributeInput {
                attachment: self.attachment,
                description: self.description,
                dry_run: self.dry_run,
                groups: self.groups,
                network_interface_id: self.network_interface_id,
                source_dest_check: self.source_dest_check,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyNetworkInterfaceAttributeInputOperationOutputAlias =
    crate::operation::ModifyNetworkInterfaceAttribute;
#[doc(hidden)]
pub type ModifyNetworkInterfaceAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyNetworkInterfaceAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyNetworkInterfaceAttribute`](crate::operation::ModifyNetworkInterfaceAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyNetworkInterfaceAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_network_interface_attribute(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyNetworkInterfaceAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyNetworkInterfaceAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyNetworkInterfaceAttributeInput`](crate::input::ModifyNetworkInterfaceAttributeInput)
    pub fn builder() -> crate::input::modify_network_interface_attribute_input::Builder {
        crate::input::modify_network_interface_attribute_input::Builder::default()
    }
}

/// See [`ModifyReservedInstancesInput`](crate::input::ModifyReservedInstancesInput)
pub mod modify_reserved_instances_input {
    /// A builder for [`ModifyReservedInstancesInput`](crate::input::ModifyReservedInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) reserved_instances_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) target_configurations:
            std::option::Option<std::vec::Vec<crate::model::ReservedInstancesConfiguration>>,
    }
    impl Builder {
        pub fn reserved_instances_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.reserved_instances_ids.unwrap_or_default();
            v.push(input.into());
            self.reserved_instances_ids = Some(v);
            self
        }
        pub fn set_reserved_instances_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.reserved_instances_ids = input;
            self
        }
        /// <p>A unique, case-sensitive token you provide to ensure idempotency of your modification request. For more information, see
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        pub fn target_configurations(
            mut self,
            input: impl Into<crate::model::ReservedInstancesConfiguration>,
        ) -> Self {
            let mut v = self.target_configurations.unwrap_or_default();
            v.push(input.into());
            self.target_configurations = Some(v);
            self
        }
        pub fn set_target_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ReservedInstancesConfiguration>>,
        ) -> Self {
            self.target_configurations = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyReservedInstancesInput`](crate::input::ModifyReservedInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyReservedInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyReservedInstancesInput {
                reserved_instances_ids: self.reserved_instances_ids,
                client_token: self.client_token,
                target_configurations: self.target_configurations,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyReservedInstancesInputOperationOutputAlias =
    crate::operation::ModifyReservedInstances;
#[doc(hidden)]
pub type ModifyReservedInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyReservedInstancesInput {
    /// Consumes the builder and constructs an Operation<[`ModifyReservedInstances`](crate::operation::ModifyReservedInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyReservedInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_reserved_instances(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyReservedInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyReservedInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyReservedInstancesInput`](crate::input::ModifyReservedInstancesInput)
    pub fn builder() -> crate::input::modify_reserved_instances_input::Builder {
        crate::input::modify_reserved_instances_input::Builder::default()
    }
}

/// See [`ModifySnapshotAttributeInput`](crate::input::ModifySnapshotAttributeInput)
pub mod modify_snapshot_attribute_input {
    /// A builder for [`ModifySnapshotAttributeInput`](crate::input::ModifySnapshotAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::SnapshotAttributeName>,
        pub(crate) create_volume_permission:
            std::option::Option<crate::model::CreateVolumePermissionModifications>,
        pub(crate) group_names: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) operation_type: std::option::Option<crate::model::OperationType>,
        pub(crate) snapshot_id: std::option::Option<std::string::String>,
        pub(crate) user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The snapshot attribute to modify. Only volume creation permissions can be modified.</p>
        pub fn attribute(mut self, input: crate::model::SnapshotAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::SnapshotAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>A JSON representation of the snapshot attribute modification.</p>
        pub fn create_volume_permission(
            mut self,
            input: crate::model::CreateVolumePermissionModifications,
        ) -> Self {
            self.create_volume_permission = Some(input);
            self
        }
        pub fn set_create_volume_permission(
            mut self,
            input: std::option::Option<crate::model::CreateVolumePermissionModifications>,
        ) -> Self {
            self.create_volume_permission = input;
            self
        }
        pub fn group_names(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.group_names.unwrap_or_default();
            v.push(input.into());
            self.group_names = Some(v);
            self
        }
        pub fn set_group_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.group_names = input;
            self
        }
        /// <p>The type of operation to perform to the attribute.</p>
        pub fn operation_type(mut self, input: crate::model::OperationType) -> Self {
            self.operation_type = Some(input);
            self
        }
        pub fn set_operation_type(
            mut self,
            input: std::option::Option<crate::model::OperationType>,
        ) -> Self {
            self.operation_type = input;
            self
        }
        /// <p>The ID of the snapshot.</p>
        pub fn snapshot_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.snapshot_id = Some(input.into());
            self
        }
        pub fn set_snapshot_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.snapshot_id = input;
            self
        }
        pub fn user_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.user_ids.unwrap_or_default();
            v.push(input.into());
            self.user_ids = Some(v);
            self
        }
        pub fn set_user_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.user_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifySnapshotAttributeInput`](crate::input::ModifySnapshotAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifySnapshotAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifySnapshotAttributeInput {
                attribute: self.attribute,
                create_volume_permission: self.create_volume_permission,
                group_names: self.group_names,
                operation_type: self.operation_type,
                snapshot_id: self.snapshot_id,
                user_ids: self.user_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifySnapshotAttributeInputOperationOutputAlias =
    crate::operation::ModifySnapshotAttribute;
#[doc(hidden)]
pub type ModifySnapshotAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifySnapshotAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifySnapshotAttribute`](crate::operation::ModifySnapshotAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifySnapshotAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_snapshot_attribute(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifySnapshotAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifySnapshotAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifySnapshotAttributeInput`](crate::input::ModifySnapshotAttributeInput)
    pub fn builder() -> crate::input::modify_snapshot_attribute_input::Builder {
        crate::input::modify_snapshot_attribute_input::Builder::default()
    }
}

/// See [`ModifySpotFleetRequestInput`](crate::input::ModifySpotFleetRequestInput)
pub mod modify_spot_fleet_request_input {
    /// A builder for [`ModifySpotFleetRequestInput`](crate::input::ModifySpotFleetRequestInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) excess_capacity_termination_policy:
            std::option::Option<crate::model::ExcessCapacityTerminationPolicy>,
        pub(crate) launch_template_configs:
            std::option::Option<std::vec::Vec<crate::model::LaunchTemplateConfig>>,
        pub(crate) spot_fleet_request_id: std::option::Option<std::string::String>,
        pub(crate) target_capacity: std::option::Option<i32>,
        pub(crate) on_demand_target_capacity: std::option::Option<i32>,
        pub(crate) context: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Indicates whether running Spot Instances should be terminated if the target capacity
        /// of the Spot Fleet request is decreased below the current size of the Spot Fleet.</p>
        pub fn excess_capacity_termination_policy(
            mut self,
            input: crate::model::ExcessCapacityTerminationPolicy,
        ) -> Self {
            self.excess_capacity_termination_policy = Some(input);
            self
        }
        pub fn set_excess_capacity_termination_policy(
            mut self,
            input: std::option::Option<crate::model::ExcessCapacityTerminationPolicy>,
        ) -> Self {
            self.excess_capacity_termination_policy = input;
            self
        }
        pub fn launch_template_configs(
            mut self,
            input: impl Into<crate::model::LaunchTemplateConfig>,
        ) -> Self {
            let mut v = self.launch_template_configs.unwrap_or_default();
            v.push(input.into());
            self.launch_template_configs = Some(v);
            self
        }
        pub fn set_launch_template_configs(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::LaunchTemplateConfig>>,
        ) -> Self {
            self.launch_template_configs = input;
            self
        }
        /// <p>The ID of the Spot Fleet request.</p>
        pub fn spot_fleet_request_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.spot_fleet_request_id = Some(input.into());
            self
        }
        pub fn set_spot_fleet_request_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.spot_fleet_request_id = input;
            self
        }
        /// <p>The size of the fleet.</p>
        pub fn target_capacity(mut self, input: i32) -> Self {
            self.target_capacity = Some(input);
            self
        }
        pub fn set_target_capacity(mut self, input: std::option::Option<i32>) -> Self {
            self.target_capacity = input;
            self
        }
        /// <p>The number of On-Demand Instances in the fleet.</p>
        pub fn on_demand_target_capacity(mut self, input: i32) -> Self {
            self.on_demand_target_capacity = Some(input);
            self
        }
        pub fn set_on_demand_target_capacity(mut self, input: std::option::Option<i32>) -> Self {
            self.on_demand_target_capacity = input;
            self
        }
        /// <p>Reserved.</p>
        pub fn context(mut self, input: impl Into<std::string::String>) -> Self {
            self.context = Some(input.into());
            self
        }
        pub fn set_context(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.context = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifySpotFleetRequestInput`](crate::input::ModifySpotFleetRequestInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifySpotFleetRequestInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifySpotFleetRequestInput {
                excess_capacity_termination_policy: self.excess_capacity_termination_policy,
                launch_template_configs: self.launch_template_configs,
                spot_fleet_request_id: self.spot_fleet_request_id,
                target_capacity: self.target_capacity,
                on_demand_target_capacity: self.on_demand_target_capacity,
                context: self.context,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifySpotFleetRequestInputOperationOutputAlias = crate::operation::ModifySpotFleetRequest;
#[doc(hidden)]
pub type ModifySpotFleetRequestInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifySpotFleetRequestInput {
    /// Consumes the builder and constructs an Operation<[`ModifySpotFleetRequest`](crate::operation::ModifySpotFleetRequest)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifySpotFleetRequest,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_spot_fleet_request(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifySpotFleetRequest::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifySpotFleetRequest",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifySpotFleetRequestInput`](crate::input::ModifySpotFleetRequestInput)
    pub fn builder() -> crate::input::modify_spot_fleet_request_input::Builder {
        crate::input::modify_spot_fleet_request_input::Builder::default()
    }
}

/// See [`ModifySubnetAttributeInput`](crate::input::ModifySubnetAttributeInput)
pub mod modify_subnet_attribute_input {
    /// A builder for [`ModifySubnetAttributeInput`](crate::input::ModifySubnetAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) assign_ipv6_address_on_creation:
            std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) map_public_ip_on_launch:
            std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) subnet_id: std::option::Option<std::string::String>,
        pub(crate) map_customer_owned_ip_on_launch:
            std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) customer_owned_ipv4_pool: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Specify <code>true</code> to indicate that network interfaces created in the
        /// specified subnet should be assigned an IPv6 address. This includes a network interface
        /// that's created when launching an instance into the subnet (the instance therefore
        /// receives an IPv6 address). </p>
        /// <p>If you enable the IPv6 addressing feature for your subnet, your network interface
        /// or instance only receives an IPv6 address if it's created using version
        /// <code>2016-11-15</code> or later of the Amazon EC2 API.</p>
        pub fn assign_ipv6_address_on_creation(
            mut self,
            input: crate::model::AttributeBooleanValue,
        ) -> Self {
            self.assign_ipv6_address_on_creation = Some(input);
            self
        }
        pub fn set_assign_ipv6_address_on_creation(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.assign_ipv6_address_on_creation = input;
            self
        }
        /// <p>Specify <code>true</code> to indicate that network interfaces attached to instances created in the
        /// specified subnet should be assigned a public IPv4 address.</p>
        pub fn map_public_ip_on_launch(
            mut self,
            input: crate::model::AttributeBooleanValue,
        ) -> Self {
            self.map_public_ip_on_launch = Some(input);
            self
        }
        pub fn set_map_public_ip_on_launch(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.map_public_ip_on_launch = input;
            self
        }
        /// <p>The ID of the subnet.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        /// <p>Specify <code>true</code> to indicate that network interfaces  attached to instances created in the
        /// specified subnet should be assigned a customer-owned IPv4 address.</p>
        /// <p>When this value is <code>true</code>, you must specify the customer-owned IP pool using <code>CustomerOwnedIpv4Pool</code>.</p>
        pub fn map_customer_owned_ip_on_launch(
            mut self,
            input: crate::model::AttributeBooleanValue,
        ) -> Self {
            self.map_customer_owned_ip_on_launch = Some(input);
            self
        }
        pub fn set_map_customer_owned_ip_on_launch(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.map_customer_owned_ip_on_launch = input;
            self
        }
        /// <p>The customer-owned IPv4 address pool associated with the subnet.</p>
        /// <p>You must set this value when you specify <code>true</code> for <code>MapCustomerOwnedIpOnLaunch</code>.</p>
        pub fn customer_owned_ipv4_pool(mut self, input: impl Into<std::string::String>) -> Self {
            self.customer_owned_ipv4_pool = Some(input.into());
            self
        }
        pub fn set_customer_owned_ipv4_pool(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.customer_owned_ipv4_pool = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifySubnetAttributeInput`](crate::input::ModifySubnetAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifySubnetAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifySubnetAttributeInput {
                assign_ipv6_address_on_creation: self.assign_ipv6_address_on_creation,
                map_public_ip_on_launch: self.map_public_ip_on_launch,
                subnet_id: self.subnet_id,
                map_customer_owned_ip_on_launch: self.map_customer_owned_ip_on_launch,
                customer_owned_ipv4_pool: self.customer_owned_ipv4_pool,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifySubnetAttributeInputOperationOutputAlias = crate::operation::ModifySubnetAttribute;
#[doc(hidden)]
pub type ModifySubnetAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifySubnetAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifySubnetAttribute`](crate::operation::ModifySubnetAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifySubnetAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_subnet_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifySubnetAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifySubnetAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifySubnetAttributeInput`](crate::input::ModifySubnetAttributeInput)
    pub fn builder() -> crate::input::modify_subnet_attribute_input::Builder {
        crate::input::modify_subnet_attribute_input::Builder::default()
    }
}

/// See [`ModifyTrafficMirrorFilterNetworkServicesInput`](crate::input::ModifyTrafficMirrorFilterNetworkServicesInput)
pub mod modify_traffic_mirror_filter_network_services_input {
    /// A builder for [`ModifyTrafficMirrorFilterNetworkServicesInput`](crate::input::ModifyTrafficMirrorFilterNetworkServicesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_filter_id: std::option::Option<std::string::String>,
        pub(crate) add_network_services:
            std::option::Option<std::vec::Vec<crate::model::TrafficMirrorNetworkService>>,
        pub(crate) remove_network_services:
            std::option::Option<std::vec::Vec<crate::model::TrafficMirrorNetworkService>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Traffic Mirror filter.</p>
        pub fn traffic_mirror_filter_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_filter_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_filter_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_id = input;
            self
        }
        pub fn add_network_services(
            mut self,
            input: impl Into<crate::model::TrafficMirrorNetworkService>,
        ) -> Self {
            let mut v = self.add_network_services.unwrap_or_default();
            v.push(input.into());
            self.add_network_services = Some(v);
            self
        }
        pub fn set_add_network_services(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TrafficMirrorNetworkService>>,
        ) -> Self {
            self.add_network_services = input;
            self
        }
        pub fn remove_network_services(
            mut self,
            input: impl Into<crate::model::TrafficMirrorNetworkService>,
        ) -> Self {
            let mut v = self.remove_network_services.unwrap_or_default();
            v.push(input.into());
            self.remove_network_services = Some(v);
            self
        }
        pub fn set_remove_network_services(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TrafficMirrorNetworkService>>,
        ) -> Self {
            self.remove_network_services = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyTrafficMirrorFilterNetworkServicesInput`](crate::input::ModifyTrafficMirrorFilterNetworkServicesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyTrafficMirrorFilterNetworkServicesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::ModifyTrafficMirrorFilterNetworkServicesInput {
                    traffic_mirror_filter_id: self.traffic_mirror_filter_id,
                    add_network_services: self.add_network_services,
                    remove_network_services: self.remove_network_services,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type ModifyTrafficMirrorFilterNetworkServicesInputOperationOutputAlias =
    crate::operation::ModifyTrafficMirrorFilterNetworkServices;
#[doc(hidden)]
pub type ModifyTrafficMirrorFilterNetworkServicesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ModifyTrafficMirrorFilterNetworkServicesInput {
    /// Consumes the builder and constructs an Operation<[`ModifyTrafficMirrorFilterNetworkServices`](crate::operation::ModifyTrafficMirrorFilterNetworkServices)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyTrafficMirrorFilterNetworkServices,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_traffic_mirror_filter_network_services(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyTrafficMirrorFilterNetworkServices::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyTrafficMirrorFilterNetworkServices",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyTrafficMirrorFilterNetworkServicesInput`](crate::input::ModifyTrafficMirrorFilterNetworkServicesInput)
    pub fn builder() -> crate::input::modify_traffic_mirror_filter_network_services_input::Builder {
        crate::input::modify_traffic_mirror_filter_network_services_input::Builder::default()
    }
}

/// See [`ModifyTrafficMirrorFilterRuleInput`](crate::input::ModifyTrafficMirrorFilterRuleInput)
pub mod modify_traffic_mirror_filter_rule_input {
    /// A builder for [`ModifyTrafficMirrorFilterRuleInput`](crate::input::ModifyTrafficMirrorFilterRuleInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_filter_rule_id: std::option::Option<std::string::String>,
        pub(crate) traffic_direction: std::option::Option<crate::model::TrafficDirection>,
        pub(crate) rule_number: std::option::Option<i32>,
        pub(crate) rule_action: std::option::Option<crate::model::TrafficMirrorRuleAction>,
        pub(crate) destination_port_range:
            std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        pub(crate) source_port_range:
            std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        pub(crate) protocol: std::option::Option<i32>,
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) source_cidr_block: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) remove_fields:
            std::option::Option<std::vec::Vec<crate::model::TrafficMirrorFilterRuleField>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Traffic Mirror rule.</p>
        pub fn traffic_mirror_filter_rule_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_rule_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_filter_rule_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_rule_id = input;
            self
        }
        /// <p>The type of traffic (<code>ingress</code> | <code>egress</code>) to assign to the rule.</p>
        pub fn traffic_direction(mut self, input: crate::model::TrafficDirection) -> Self {
            self.traffic_direction = Some(input);
            self
        }
        pub fn set_traffic_direction(
            mut self,
            input: std::option::Option<crate::model::TrafficDirection>,
        ) -> Self {
            self.traffic_direction = input;
            self
        }
        /// <p>The number of the Traffic Mirror rule. This number must be unique for each Traffic Mirror rule in a given
        /// direction. The rules are processed in ascending order by rule number.</p>
        pub fn rule_number(mut self, input: i32) -> Self {
            self.rule_number = Some(input);
            self
        }
        pub fn set_rule_number(mut self, input: std::option::Option<i32>) -> Self {
            self.rule_number = input;
            self
        }
        /// <p>The action to assign to the rule.</p>
        pub fn rule_action(mut self, input: crate::model::TrafficMirrorRuleAction) -> Self {
            self.rule_action = Some(input);
            self
        }
        pub fn set_rule_action(
            mut self,
            input: std::option::Option<crate::model::TrafficMirrorRuleAction>,
        ) -> Self {
            self.rule_action = input;
            self
        }
        /// <p>The destination ports that are associated with the Traffic Mirror rule.</p>
        pub fn destination_port_range(
            mut self,
            input: crate::model::TrafficMirrorPortRangeRequest,
        ) -> Self {
            self.destination_port_range = Some(input);
            self
        }
        pub fn set_destination_port_range(
            mut self,
            input: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        ) -> Self {
            self.destination_port_range = input;
            self
        }
        /// <p>The port range to assign to the Traffic Mirror rule.</p>
        pub fn source_port_range(
            mut self,
            input: crate::model::TrafficMirrorPortRangeRequest,
        ) -> Self {
            self.source_port_range = Some(input);
            self
        }
        pub fn set_source_port_range(
            mut self,
            input: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
        ) -> Self {
            self.source_port_range = input;
            self
        }
        /// <p>The protocol, for example TCP, to assign to the Traffic Mirror rule.</p>
        pub fn protocol(mut self, input: i32) -> Self {
            self.protocol = Some(input);
            self
        }
        pub fn set_protocol(mut self, input: std::option::Option<i32>) -> Self {
            self.protocol = input;
            self
        }
        /// <p>The destination CIDR block to assign to the Traffic Mirror rule.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The source CIDR block to assign to the Traffic Mirror rule.</p>
        pub fn source_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_cidr_block = Some(input.into());
            self
        }
        pub fn set_source_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_cidr_block = input;
            self
        }
        /// <p>The description to assign to the Traffic Mirror rule.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        pub fn remove_fields(
            mut self,
            input: impl Into<crate::model::TrafficMirrorFilterRuleField>,
        ) -> Self {
            let mut v = self.remove_fields.unwrap_or_default();
            v.push(input.into());
            self.remove_fields = Some(v);
            self
        }
        pub fn set_remove_fields(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TrafficMirrorFilterRuleField>>,
        ) -> Self {
            self.remove_fields = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyTrafficMirrorFilterRuleInput`](crate::input::ModifyTrafficMirrorFilterRuleInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyTrafficMirrorFilterRuleInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyTrafficMirrorFilterRuleInput {
                traffic_mirror_filter_rule_id: self.traffic_mirror_filter_rule_id,
                traffic_direction: self.traffic_direction,
                rule_number: self.rule_number,
                rule_action: self.rule_action,
                destination_port_range: self.destination_port_range,
                source_port_range: self.source_port_range,
                protocol: self.protocol,
                destination_cidr_block: self.destination_cidr_block,
                source_cidr_block: self.source_cidr_block,
                description: self.description,
                remove_fields: self.remove_fields,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyTrafficMirrorFilterRuleInputOperationOutputAlias =
    crate::operation::ModifyTrafficMirrorFilterRule;
#[doc(hidden)]
pub type ModifyTrafficMirrorFilterRuleInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyTrafficMirrorFilterRuleInput {
    /// Consumes the builder and constructs an Operation<[`ModifyTrafficMirrorFilterRule`](crate::operation::ModifyTrafficMirrorFilterRule)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyTrafficMirrorFilterRule,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_traffic_mirror_filter_rule(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyTrafficMirrorFilterRule::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyTrafficMirrorFilterRule",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyTrafficMirrorFilterRuleInput`](crate::input::ModifyTrafficMirrorFilterRuleInput)
    pub fn builder() -> crate::input::modify_traffic_mirror_filter_rule_input::Builder {
        crate::input::modify_traffic_mirror_filter_rule_input::Builder::default()
    }
}

/// See [`ModifyTrafficMirrorSessionInput`](crate::input::ModifyTrafficMirrorSessionInput)
pub mod modify_traffic_mirror_session_input {
    /// A builder for [`ModifyTrafficMirrorSessionInput`](crate::input::ModifyTrafficMirrorSessionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) traffic_mirror_session_id: std::option::Option<std::string::String>,
        pub(crate) traffic_mirror_target_id: std::option::Option<std::string::String>,
        pub(crate) traffic_mirror_filter_id: std::option::Option<std::string::String>,
        pub(crate) packet_length: std::option::Option<i32>,
        pub(crate) session_number: std::option::Option<i32>,
        pub(crate) virtual_network_id: std::option::Option<i32>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) remove_fields:
            std::option::Option<std::vec::Vec<crate::model::TrafficMirrorSessionField>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Traffic Mirror session.</p>
        pub fn traffic_mirror_session_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_session_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_session_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_session_id = input;
            self
        }
        /// <p>The Traffic Mirror target. The target must be in the same VPC as the source, or have a VPC peering connection with the source.</p>
        pub fn traffic_mirror_target_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_target_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_target_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_target_id = input;
            self
        }
        /// <p>The ID of the Traffic Mirror filter.</p>
        pub fn traffic_mirror_filter_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.traffic_mirror_filter_id = Some(input.into());
            self
        }
        pub fn set_traffic_mirror_filter_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.traffic_mirror_filter_id = input;
            self
        }
        /// <p>The number of bytes in each packet to mirror. These are bytes after the VXLAN header. To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set this value to 100, then the first 100 bytes that meet the filter criteria are copied to the target. Do not specify this parameter when you want to mirror the entire packet.</p>
        pub fn packet_length(mut self, input: i32) -> Self {
            self.packet_length = Some(input);
            self
        }
        pub fn set_packet_length(mut self, input: std::option::Option<i32>) -> Self {
            self.packet_length = input;
            self
        }
        /// <p>The session number determines the order in which sessions are evaluated when an interface is used by multiple sessions. The first session with a matching filter is the one that mirrors the packets.</p>
        /// <p>Valid values are 1-32766.</p>
        pub fn session_number(mut self, input: i32) -> Self {
            self.session_number = Some(input);
            self
        }
        pub fn set_session_number(mut self, input: std::option::Option<i32>) -> Self {
            self.session_number = input;
            self
        }
        /// <p>The virtual network ID of the Traffic Mirror session.</p>
        pub fn virtual_network_id(mut self, input: i32) -> Self {
            self.virtual_network_id = Some(input);
            self
        }
        pub fn set_virtual_network_id(mut self, input: std::option::Option<i32>) -> Self {
            self.virtual_network_id = input;
            self
        }
        /// <p>The description to assign to the Traffic Mirror session.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        pub fn remove_fields(
            mut self,
            input: impl Into<crate::model::TrafficMirrorSessionField>,
        ) -> Self {
            let mut v = self.remove_fields.unwrap_or_default();
            v.push(input.into());
            self.remove_fields = Some(v);
            self
        }
        pub fn set_remove_fields(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TrafficMirrorSessionField>>,
        ) -> Self {
            self.remove_fields = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyTrafficMirrorSessionInput`](crate::input::ModifyTrafficMirrorSessionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyTrafficMirrorSessionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyTrafficMirrorSessionInput {
                traffic_mirror_session_id: self.traffic_mirror_session_id,
                traffic_mirror_target_id: self.traffic_mirror_target_id,
                traffic_mirror_filter_id: self.traffic_mirror_filter_id,
                packet_length: self.packet_length,
                session_number: self.session_number,
                virtual_network_id: self.virtual_network_id,
                description: self.description,
                remove_fields: self.remove_fields,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyTrafficMirrorSessionInputOperationOutputAlias =
    crate::operation::ModifyTrafficMirrorSession;
#[doc(hidden)]
pub type ModifyTrafficMirrorSessionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyTrafficMirrorSessionInput {
    /// Consumes the builder and constructs an Operation<[`ModifyTrafficMirrorSession`](crate::operation::ModifyTrafficMirrorSession)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyTrafficMirrorSession,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_traffic_mirror_session(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyTrafficMirrorSession::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyTrafficMirrorSession",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyTrafficMirrorSessionInput`](crate::input::ModifyTrafficMirrorSessionInput)
    pub fn builder() -> crate::input::modify_traffic_mirror_session_input::Builder {
        crate::input::modify_traffic_mirror_session_input::Builder::default()
    }
}

/// See [`ModifyTransitGatewayInput`](crate::input::ModifyTransitGatewayInput)
pub mod modify_transit_gateway_input {
    /// A builder for [`ModifyTransitGatewayInput`](crate::input::ModifyTransitGatewayInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) options: std::option::Option<crate::model::ModifyTransitGatewayOptions>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>The description for the transit gateway.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>The options to modify.</p>
        pub fn options(mut self, input: crate::model::ModifyTransitGatewayOptions) -> Self {
            self.options = Some(input);
            self
        }
        pub fn set_options(
            mut self,
            input: std::option::Option<crate::model::ModifyTransitGatewayOptions>,
        ) -> Self {
            self.options = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyTransitGatewayInput`](crate::input::ModifyTransitGatewayInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyTransitGatewayInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyTransitGatewayInput {
                transit_gateway_id: self.transit_gateway_id,
                description: self.description,
                options: self.options,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyTransitGatewayInputOperationOutputAlias = crate::operation::ModifyTransitGateway;
#[doc(hidden)]
pub type ModifyTransitGatewayInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyTransitGatewayInput {
    /// Consumes the builder and constructs an Operation<[`ModifyTransitGateway`](crate::operation::ModifyTransitGateway)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyTransitGateway,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_transit_gateway(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyTransitGateway::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyTransitGateway",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyTransitGatewayInput`](crate::input::ModifyTransitGatewayInput)
    pub fn builder() -> crate::input::modify_transit_gateway_input::Builder {
        crate::input::modify_transit_gateway_input::Builder::default()
    }
}

/// See [`ModifyTransitGatewayPrefixListReferenceInput`](crate::input::ModifyTransitGatewayPrefixListReferenceInput)
pub mod modify_transit_gateway_prefix_list_reference_input {
    /// A builder for [`ModifyTransitGatewayPrefixListReferenceInput`](crate::input::ModifyTransitGatewayPrefixListReferenceInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) blackhole: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the prefix list.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// <p>The ID of the attachment to which traffic is routed.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Indicates whether to drop traffic that matches this route.</p>
        pub fn blackhole(mut self, input: bool) -> Self {
            self.blackhole = Some(input);
            self
        }
        pub fn set_blackhole(mut self, input: std::option::Option<bool>) -> Self {
            self.blackhole = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyTransitGatewayPrefixListReferenceInput`](crate::input::ModifyTransitGatewayPrefixListReferenceInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyTransitGatewayPrefixListReferenceInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyTransitGatewayPrefixListReferenceInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                prefix_list_id: self.prefix_list_id,
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                blackhole: self.blackhole,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyTransitGatewayPrefixListReferenceInputOperationOutputAlias =
    crate::operation::ModifyTransitGatewayPrefixListReference;
#[doc(hidden)]
pub type ModifyTransitGatewayPrefixListReferenceInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ModifyTransitGatewayPrefixListReferenceInput {
    /// Consumes the builder and constructs an Operation<[`ModifyTransitGatewayPrefixListReference`](crate::operation::ModifyTransitGatewayPrefixListReference)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyTransitGatewayPrefixListReference,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_transit_gateway_prefix_list_reference(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyTransitGatewayPrefixListReference::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyTransitGatewayPrefixListReference",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyTransitGatewayPrefixListReferenceInput`](crate::input::ModifyTransitGatewayPrefixListReferenceInput)
    pub fn builder() -> crate::input::modify_transit_gateway_prefix_list_reference_input::Builder {
        crate::input::modify_transit_gateway_prefix_list_reference_input::Builder::default()
    }
}

/// See [`ModifyTransitGatewayVpcAttachmentInput`](crate::input::ModifyTransitGatewayVpcAttachmentInput)
pub mod modify_transit_gateway_vpc_attachment_input {
    /// A builder for [`ModifyTransitGatewayVpcAttachmentInput`](crate::input::ModifyTransitGatewayVpcAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) add_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) remove_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) options:
            std::option::Option<crate::model::ModifyTransitGatewayVpcAttachmentRequestOptions>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        pub fn add_subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.add_subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.add_subnet_ids = Some(v);
            self
        }
        pub fn set_add_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.add_subnet_ids = input;
            self
        }
        pub fn remove_subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.remove_subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.remove_subnet_ids = Some(v);
            self
        }
        pub fn set_remove_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.remove_subnet_ids = input;
            self
        }
        /// <p>The new VPC attachment options.</p>
        /// <note>
        /// <p>You cannot modify the IPv6 options.</p>
        /// </note>
        pub fn options(
            mut self,
            input: crate::model::ModifyTransitGatewayVpcAttachmentRequestOptions,
        ) -> Self {
            self.options = Some(input);
            self
        }
        pub fn set_options(
            mut self,
            input: std::option::Option<
                crate::model::ModifyTransitGatewayVpcAttachmentRequestOptions,
            >,
        ) -> Self {
            self.options = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyTransitGatewayVpcAttachmentInput`](crate::input::ModifyTransitGatewayVpcAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyTransitGatewayVpcAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyTransitGatewayVpcAttachmentInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                add_subnet_ids: self.add_subnet_ids,
                remove_subnet_ids: self.remove_subnet_ids,
                options: self.options,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyTransitGatewayVpcAttachmentInputOperationOutputAlias =
    crate::operation::ModifyTransitGatewayVpcAttachment;
#[doc(hidden)]
pub type ModifyTransitGatewayVpcAttachmentInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyTransitGatewayVpcAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`ModifyTransitGatewayVpcAttachment`](crate::operation::ModifyTransitGatewayVpcAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyTransitGatewayVpcAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_transit_gateway_vpc_attachment(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyTransitGatewayVpcAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyTransitGatewayVpcAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyTransitGatewayVpcAttachmentInput`](crate::input::ModifyTransitGatewayVpcAttachmentInput)
    pub fn builder() -> crate::input::modify_transit_gateway_vpc_attachment_input::Builder {
        crate::input::modify_transit_gateway_vpc_attachment_input::Builder::default()
    }
}

/// See [`ModifyVolumeInput`](crate::input::ModifyVolumeInput)
pub mod modify_volume_input {
    /// A builder for [`ModifyVolumeInput`](crate::input::ModifyVolumeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) volume_id: std::option::Option<std::string::String>,
        pub(crate) size: std::option::Option<i32>,
        pub(crate) volume_type: std::option::Option<crate::model::VolumeType>,
        pub(crate) iops: std::option::Option<i32>,
        pub(crate) throughput: std::option::Option<i32>,
        pub(crate) multi_attach_enabled: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the volume.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        /// <p>The target size of the volume, in GiB. The target volume size must be greater than or
        /// equal to the existing size of the volume.</p>
        /// <p>The following are the supported volumes sizes for each volume type:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>gp2</code> and <code>gp3</code>: 1-16,384</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>io1</code> and <code>io2</code>: 4-16,384</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>st1</code> and <code>sc1</code>: 125-16,384</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>standard</code>: 1-1,024</p>
        /// </li>
        /// </ul>
        /// <p>Default: If no size is specified, the existing size is retained.</p>
        pub fn size(mut self, input: i32) -> Self {
            self.size = Some(input);
            self
        }
        pub fn set_size(mut self, input: std::option::Option<i32>) -> Self {
            self.size = input;
            self
        }
        /// <p>The target EBS volume type of the volume. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html">Amazon EBS volume types</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        /// <p>Default: If no type is specified, the existing type is retained.</p>
        pub fn volume_type(mut self, input: crate::model::VolumeType) -> Self {
            self.volume_type = Some(input);
            self
        }
        pub fn set_volume_type(
            mut self,
            input: std::option::Option<crate::model::VolumeType>,
        ) -> Self {
            self.volume_type = input;
            self
        }
        /// <p>The target IOPS rate of the volume. This parameter is valid only for <code>gp3</code>, <code>io1</code>, and <code>io2</code> volumes.</p>
        /// <p>The following are the supported values for each volume type:</p>
        /// <ul>
        /// <li>
        /// <p>
        /// <code>gp3</code>: 3,000-16,000 IOPS</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>io1</code>: 100-64,000 IOPS</p>
        /// </li>
        /// <li>
        /// <p>
        /// <code>io2</code>: 100-64,000 IOPS</p>
        /// </li>
        /// </ul>
        /// <p>Default: If no IOPS value is specified, the existing value is retained, unless a volume type is modified that supports different values.</p>
        pub fn iops(mut self, input: i32) -> Self {
            self.iops = Some(input);
            self
        }
        pub fn set_iops(mut self, input: std::option::Option<i32>) -> Self {
            self.iops = input;
            self
        }
        /// <p>The target throughput of the volume, in MiB/s. This parameter is valid only for <code>gp3</code> volumes.
        /// The maximum value is 1,000.</p>
        /// <p>Default: If no throughput value is specified, the existing value is retained.</p>
        /// <p>Valid Range: Minimum value of 125. Maximum value of 1000.</p>
        pub fn throughput(mut self, input: i32) -> Self {
            self.throughput = Some(input);
            self
        }
        pub fn set_throughput(mut self, input: std::option::Option<i32>) -> Self {
            self.throughput = input;
            self
        }
        /// <p>Specifies whether to enable Amazon EBS Multi-Attach. If you enable Multi-Attach, you can attach the
        /// volume to up to 16 <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">
        /// Nitro-based instances</a> in the same Availability Zone. This parameter is
        /// supported with <code>io1</code> and <code>io2</code> volumes only. For more information, see
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-volumes-multi.html">
        /// Amazon EBS Multi-Attach</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn multi_attach_enabled(mut self, input: bool) -> Self {
            self.multi_attach_enabled = Some(input);
            self
        }
        pub fn set_multi_attach_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.multi_attach_enabled = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVolumeInput`](crate::input::ModifyVolumeInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ModifyVolumeInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ModifyVolumeInput {
                dry_run: self.dry_run,
                volume_id: self.volume_id,
                size: self.size,
                volume_type: self.volume_type,
                iops: self.iops,
                throughput: self.throughput,
                multi_attach_enabled: self.multi_attach_enabled,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVolumeInputOperationOutputAlias = crate::operation::ModifyVolume;
#[doc(hidden)]
pub type ModifyVolumeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVolumeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVolume`](crate::operation::ModifyVolume)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVolume,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_volume(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVolume::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ModifyVolume", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVolumeInput`](crate::input::ModifyVolumeInput)
    pub fn builder() -> crate::input::modify_volume_input::Builder {
        crate::input::modify_volume_input::Builder::default()
    }
}

/// See [`ModifyVolumeAttributeInput`](crate::input::ModifyVolumeAttributeInput)
pub mod modify_volume_attribute_input {
    /// A builder for [`ModifyVolumeAttributeInput`](crate::input::ModifyVolumeAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) auto_enable_io: std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) volume_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Indicates whether the volume should be auto-enabled for I/O operations.</p>
        pub fn auto_enable_io(mut self, input: crate::model::AttributeBooleanValue) -> Self {
            self.auto_enable_io = Some(input);
            self
        }
        pub fn set_auto_enable_io(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.auto_enable_io = input;
            self
        }
        /// <p>The ID of the volume.</p>
        pub fn volume_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.volume_id = Some(input.into());
            self
        }
        pub fn set_volume_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.volume_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVolumeAttributeInput`](crate::input::ModifyVolumeAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVolumeAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVolumeAttributeInput {
                auto_enable_io: self.auto_enable_io,
                volume_id: self.volume_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVolumeAttributeInputOperationOutputAlias = crate::operation::ModifyVolumeAttribute;
#[doc(hidden)]
pub type ModifyVolumeAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVolumeAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVolumeAttribute`](crate::operation::ModifyVolumeAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVolumeAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_volume_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVolumeAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVolumeAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVolumeAttributeInput`](crate::input::ModifyVolumeAttributeInput)
    pub fn builder() -> crate::input::modify_volume_attribute_input::Builder {
        crate::input::modify_volume_attribute_input::Builder::default()
    }
}

/// See [`ModifyVpcAttributeInput`](crate::input::ModifyVpcAttributeInput)
pub mod modify_vpc_attribute_input {
    /// A builder for [`ModifyVpcAttributeInput`](crate::input::ModifyVpcAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) enable_dns_hostnames: std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) enable_dns_support: std::option::Option<crate::model::AttributeBooleanValue>,
        pub(crate) vpc_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Indicates whether the instances launched in the VPC get DNS hostnames. If enabled, instances in the VPC get DNS hostnames; otherwise, they do not.</p>
        /// <p>You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use separate requests for each attribute. You can only enable DNS hostnames if you've enabled DNS support.</p>
        pub fn enable_dns_hostnames(mut self, input: crate::model::AttributeBooleanValue) -> Self {
            self.enable_dns_hostnames = Some(input);
            self
        }
        pub fn set_enable_dns_hostnames(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.enable_dns_hostnames = input;
            self
        }
        /// <p>Indicates whether the DNS resolution is supported for the VPC. If enabled, queries to
        /// the Amazon provided DNS server at the 169.254.169.253 IP address, or the reserved IP
        /// address at the base of the VPC network range "plus two" succeed. If disabled, the Amazon
        /// provided DNS service in the VPC that resolves public DNS hostnames to IP addresses is
        /// not enabled.</p>
        /// <p>You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use separate requests for each attribute.</p>
        pub fn enable_dns_support(mut self, input: crate::model::AttributeBooleanValue) -> Self {
            self.enable_dns_support = Some(input);
            self
        }
        pub fn set_enable_dns_support(
            mut self,
            input: std::option::Option<crate::model::AttributeBooleanValue>,
        ) -> Self {
            self.enable_dns_support = input;
            self
        }
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpcAttributeInput`](crate::input::ModifyVpcAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpcAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpcAttributeInput {
                enable_dns_hostnames: self.enable_dns_hostnames,
                enable_dns_support: self.enable_dns_support,
                vpc_id: self.vpc_id,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpcAttributeInputOperationOutputAlias = crate::operation::ModifyVpcAttribute;
#[doc(hidden)]
pub type ModifyVpcAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpcAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpcAttribute`](crate::operation::ModifyVpcAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpcAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_vpc_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpcAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpcAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpcAttributeInput`](crate::input::ModifyVpcAttributeInput)
    pub fn builder() -> crate::input::modify_vpc_attribute_input::Builder {
        crate::input::modify_vpc_attribute_input::Builder::default()
    }
}

/// See [`ModifyVpcEndpointInput`](crate::input::ModifyVpcEndpointInput)
pub mod modify_vpc_endpoint_input {
    /// A builder for [`ModifyVpcEndpointInput`](crate::input::ModifyVpcEndpointInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) reset_policy: std::option::Option<bool>,
        pub(crate) policy_document: std::option::Option<std::string::String>,
        pub(crate) add_route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) remove_route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) add_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) remove_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) add_security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) remove_security_group_ids:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) private_dns_enabled: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the endpoint.</p>
        pub fn vpc_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_endpoint_id = Some(input.into());
            self
        }
        pub fn set_vpc_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_endpoint_id = input;
            self
        }
        /// <p>(Gateway endpoint) Specify <code>true</code> to reset the policy document to the
        /// default policy. The default policy allows full access to the service.</p>
        pub fn reset_policy(mut self, input: bool) -> Self {
            self.reset_policy = Some(input);
            self
        }
        pub fn set_reset_policy(mut self, input: std::option::Option<bool>) -> Self {
            self.reset_policy = input;
            self
        }
        /// <p>(Interface and gateway endpoints) A policy to attach to the endpoint that controls access to the service. The policy must
        /// be in valid JSON format.</p>
        pub fn policy_document(mut self, input: impl Into<std::string::String>) -> Self {
            self.policy_document = Some(input.into());
            self
        }
        pub fn set_policy_document(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.policy_document = input;
            self
        }
        pub fn add_route_table_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.add_route_table_ids.unwrap_or_default();
            v.push(input.into());
            self.add_route_table_ids = Some(v);
            self
        }
        pub fn set_add_route_table_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.add_route_table_ids = input;
            self
        }
        pub fn remove_route_table_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.remove_route_table_ids.unwrap_or_default();
            v.push(input.into());
            self.remove_route_table_ids = Some(v);
            self
        }
        pub fn set_remove_route_table_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.remove_route_table_ids = input;
            self
        }
        pub fn add_subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.add_subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.add_subnet_ids = Some(v);
            self
        }
        pub fn set_add_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.add_subnet_ids = input;
            self
        }
        pub fn remove_subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.remove_subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.remove_subnet_ids = Some(v);
            self
        }
        pub fn set_remove_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.remove_subnet_ids = input;
            self
        }
        pub fn add_security_group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.add_security_group_ids.unwrap_or_default();
            v.push(input.into());
            self.add_security_group_ids = Some(v);
            self
        }
        pub fn set_add_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.add_security_group_ids = input;
            self
        }
        pub fn remove_security_group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.remove_security_group_ids.unwrap_or_default();
            v.push(input.into());
            self.remove_security_group_ids = Some(v);
            self
        }
        pub fn set_remove_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.remove_security_group_ids = input;
            self
        }
        /// <p>(Interface endpoint) Indicates whether a private hosted zone is associated with the
        /// VPC.</p>
        pub fn private_dns_enabled(mut self, input: bool) -> Self {
            self.private_dns_enabled = Some(input);
            self
        }
        pub fn set_private_dns_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.private_dns_enabled = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpcEndpointInput`](crate::input::ModifyVpcEndpointInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpcEndpointInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpcEndpointInput {
                dry_run: self.dry_run,
                vpc_endpoint_id: self.vpc_endpoint_id,
                reset_policy: self.reset_policy,
                policy_document: self.policy_document,
                add_route_table_ids: self.add_route_table_ids,
                remove_route_table_ids: self.remove_route_table_ids,
                add_subnet_ids: self.add_subnet_ids,
                remove_subnet_ids: self.remove_subnet_ids,
                add_security_group_ids: self.add_security_group_ids,
                remove_security_group_ids: self.remove_security_group_ids,
                private_dns_enabled: self.private_dns_enabled,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpcEndpointInputOperationOutputAlias = crate::operation::ModifyVpcEndpoint;
#[doc(hidden)]
pub type ModifyVpcEndpointInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpcEndpointInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpcEndpoint`](crate::operation::ModifyVpcEndpoint)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpcEndpoint,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_vpc_endpoint(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpcEndpoint::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpcEndpoint",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpcEndpointInput`](crate::input::ModifyVpcEndpointInput)
    pub fn builder() -> crate::input::modify_vpc_endpoint_input::Builder {
        crate::input::modify_vpc_endpoint_input::Builder::default()
    }
}

/// See [`ModifyVpcEndpointConnectionNotificationInput`](crate::input::ModifyVpcEndpointConnectionNotificationInput)
pub mod modify_vpc_endpoint_connection_notification_input {
    /// A builder for [`ModifyVpcEndpointConnectionNotificationInput`](crate::input::ModifyVpcEndpointConnectionNotificationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) connection_notification_id: std::option::Option<std::string::String>,
        pub(crate) connection_notification_arn: std::option::Option<std::string::String>,
        pub(crate) connection_events: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the notification.</p>
        pub fn connection_notification_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.connection_notification_id = Some(input.into());
            self
        }
        pub fn set_connection_notification_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.connection_notification_id = input;
            self
        }
        /// <p>The ARN for the SNS topic for the notification.</p>
        pub fn connection_notification_arn(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.connection_notification_arn = Some(input.into());
            self
        }
        pub fn set_connection_notification_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.connection_notification_arn = input;
            self
        }
        pub fn connection_events(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.connection_events.unwrap_or_default();
            v.push(input.into());
            self.connection_events = Some(v);
            self
        }
        pub fn set_connection_events(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.connection_events = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpcEndpointConnectionNotificationInput`](crate::input::ModifyVpcEndpointConnectionNotificationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpcEndpointConnectionNotificationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpcEndpointConnectionNotificationInput {
                dry_run: self.dry_run,
                connection_notification_id: self.connection_notification_id,
                connection_notification_arn: self.connection_notification_arn,
                connection_events: self.connection_events,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpcEndpointConnectionNotificationInputOperationOutputAlias =
    crate::operation::ModifyVpcEndpointConnectionNotification;
#[doc(hidden)]
pub type ModifyVpcEndpointConnectionNotificationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ModifyVpcEndpointConnectionNotificationInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpcEndpointConnectionNotification`](crate::operation::ModifyVpcEndpointConnectionNotification)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpcEndpointConnectionNotification,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_vpc_endpoint_connection_notification(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpcEndpointConnectionNotification::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpcEndpointConnectionNotification",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpcEndpointConnectionNotificationInput`](crate::input::ModifyVpcEndpointConnectionNotificationInput)
    pub fn builder() -> crate::input::modify_vpc_endpoint_connection_notification_input::Builder {
        crate::input::modify_vpc_endpoint_connection_notification_input::Builder::default()
    }
}

/// See [`ModifyVpcEndpointServiceConfigurationInput`](crate::input::ModifyVpcEndpointServiceConfigurationInput)
pub mod modify_vpc_endpoint_service_configuration_input {
    /// A builder for [`ModifyVpcEndpointServiceConfigurationInput`](crate::input::ModifyVpcEndpointServiceConfigurationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_id: std::option::Option<std::string::String>,
        pub(crate) private_dns_name: std::option::Option<std::string::String>,
        pub(crate) remove_private_dns_name: std::option::Option<bool>,
        pub(crate) acceptance_required: std::option::Option<bool>,
        pub(crate) add_network_load_balancer_arns:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) remove_network_load_balancer_arns:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) add_gateway_load_balancer_arns:
            std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) remove_gateway_load_balancer_arns:
            std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the service.</p>
        pub fn service_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_id = Some(input.into());
            self
        }
        pub fn set_service_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_id = input;
            self
        }
        /// <p>(Interface endpoint configuration) The private DNS name to assign to the endpoint service.</p>
        pub fn private_dns_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.private_dns_name = Some(input.into());
            self
        }
        pub fn set_private_dns_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.private_dns_name = input;
            self
        }
        /// <p>(Interface endpoint configuration) Removes the private DNS name of the endpoint service.</p>
        pub fn remove_private_dns_name(mut self, input: bool) -> Self {
            self.remove_private_dns_name = Some(input);
            self
        }
        pub fn set_remove_private_dns_name(mut self, input: std::option::Option<bool>) -> Self {
            self.remove_private_dns_name = input;
            self
        }
        /// <p>Indicates whether requests to create an endpoint to your service must be accepted.</p>
        pub fn acceptance_required(mut self, input: bool) -> Self {
            self.acceptance_required = Some(input);
            self
        }
        pub fn set_acceptance_required(mut self, input: std::option::Option<bool>) -> Self {
            self.acceptance_required = input;
            self
        }
        pub fn add_network_load_balancer_arns(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.add_network_load_balancer_arns.unwrap_or_default();
            v.push(input.into());
            self.add_network_load_balancer_arns = Some(v);
            self
        }
        pub fn set_add_network_load_balancer_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.add_network_load_balancer_arns = input;
            self
        }
        pub fn remove_network_load_balancer_arns(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.remove_network_load_balancer_arns.unwrap_or_default();
            v.push(input.into());
            self.remove_network_load_balancer_arns = Some(v);
            self
        }
        pub fn set_remove_network_load_balancer_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.remove_network_load_balancer_arns = input;
            self
        }
        pub fn add_gateway_load_balancer_arns(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.add_gateway_load_balancer_arns.unwrap_or_default();
            v.push(input.into());
            self.add_gateway_load_balancer_arns = Some(v);
            self
        }
        pub fn set_add_gateway_load_balancer_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.add_gateway_load_balancer_arns = input;
            self
        }
        pub fn remove_gateway_load_balancer_arns(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            let mut v = self.remove_gateway_load_balancer_arns.unwrap_or_default();
            v.push(input.into());
            self.remove_gateway_load_balancer_arns = Some(v);
            self
        }
        pub fn set_remove_gateway_load_balancer_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.remove_gateway_load_balancer_arns = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpcEndpointServiceConfigurationInput`](crate::input::ModifyVpcEndpointServiceConfigurationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpcEndpointServiceConfigurationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpcEndpointServiceConfigurationInput {
                dry_run: self.dry_run,
                service_id: self.service_id,
                private_dns_name: self.private_dns_name,
                remove_private_dns_name: self.remove_private_dns_name,
                acceptance_required: self.acceptance_required,
                add_network_load_balancer_arns: self.add_network_load_balancer_arns,
                remove_network_load_balancer_arns: self.remove_network_load_balancer_arns,
                add_gateway_load_balancer_arns: self.add_gateway_load_balancer_arns,
                remove_gateway_load_balancer_arns: self.remove_gateway_load_balancer_arns,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpcEndpointServiceConfigurationInputOperationOutputAlias =
    crate::operation::ModifyVpcEndpointServiceConfiguration;
#[doc(hidden)]
pub type ModifyVpcEndpointServiceConfigurationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ModifyVpcEndpointServiceConfigurationInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpcEndpointServiceConfiguration`](crate::operation::ModifyVpcEndpointServiceConfiguration)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpcEndpointServiceConfiguration,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_vpc_endpoint_service_configuration(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpcEndpointServiceConfiguration::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpcEndpointServiceConfiguration",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpcEndpointServiceConfigurationInput`](crate::input::ModifyVpcEndpointServiceConfigurationInput)
    pub fn builder() -> crate::input::modify_vpc_endpoint_service_configuration_input::Builder {
        crate::input::modify_vpc_endpoint_service_configuration_input::Builder::default()
    }
}

/// See [`ModifyVpcEndpointServicePermissionsInput`](crate::input::ModifyVpcEndpointServicePermissionsInput)
pub mod modify_vpc_endpoint_service_permissions_input {
    /// A builder for [`ModifyVpcEndpointServicePermissionsInput`](crate::input::ModifyVpcEndpointServicePermissionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_id: std::option::Option<std::string::String>,
        pub(crate) add_allowed_principals: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) remove_allowed_principals:
            std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the service.</p>
        pub fn service_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_id = Some(input.into());
            self
        }
        pub fn set_service_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_id = input;
            self
        }
        pub fn add_allowed_principals(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.add_allowed_principals.unwrap_or_default();
            v.push(input.into());
            self.add_allowed_principals = Some(v);
            self
        }
        pub fn set_add_allowed_principals(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.add_allowed_principals = input;
            self
        }
        pub fn remove_allowed_principals(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.remove_allowed_principals.unwrap_or_default();
            v.push(input.into());
            self.remove_allowed_principals = Some(v);
            self
        }
        pub fn set_remove_allowed_principals(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.remove_allowed_principals = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpcEndpointServicePermissionsInput`](crate::input::ModifyVpcEndpointServicePermissionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpcEndpointServicePermissionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpcEndpointServicePermissionsInput {
                dry_run: self.dry_run,
                service_id: self.service_id,
                add_allowed_principals: self.add_allowed_principals,
                remove_allowed_principals: self.remove_allowed_principals,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpcEndpointServicePermissionsInputOperationOutputAlias =
    crate::operation::ModifyVpcEndpointServicePermissions;
#[doc(hidden)]
pub type ModifyVpcEndpointServicePermissionsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ModifyVpcEndpointServicePermissionsInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpcEndpointServicePermissions`](crate::operation::ModifyVpcEndpointServicePermissions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpcEndpointServicePermissions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_vpc_endpoint_service_permissions(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpcEndpointServicePermissions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpcEndpointServicePermissions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpcEndpointServicePermissionsInput`](crate::input::ModifyVpcEndpointServicePermissionsInput)
    pub fn builder() -> crate::input::modify_vpc_endpoint_service_permissions_input::Builder {
        crate::input::modify_vpc_endpoint_service_permissions_input::Builder::default()
    }
}

/// See [`ModifyVpcPeeringConnectionOptionsInput`](crate::input::ModifyVpcPeeringConnectionOptionsInput)
pub mod modify_vpc_peering_connection_options_input {
    /// A builder for [`ModifyVpcPeeringConnectionOptionsInput`](crate::input::ModifyVpcPeeringConnectionOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) accepter_peering_connection_options:
            std::option::Option<crate::model::PeeringConnectionOptionsRequest>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) requester_peering_connection_options:
            std::option::Option<crate::model::PeeringConnectionOptionsRequest>,
        pub(crate) vpc_peering_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The VPC peering connection options for the accepter VPC.</p>
        pub fn accepter_peering_connection_options(
            mut self,
            input: crate::model::PeeringConnectionOptionsRequest,
        ) -> Self {
            self.accepter_peering_connection_options = Some(input);
            self
        }
        pub fn set_accepter_peering_connection_options(
            mut self,
            input: std::option::Option<crate::model::PeeringConnectionOptionsRequest>,
        ) -> Self {
            self.accepter_peering_connection_options = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The VPC peering connection options for the requester VPC.</p>
        pub fn requester_peering_connection_options(
            mut self,
            input: crate::model::PeeringConnectionOptionsRequest,
        ) -> Self {
            self.requester_peering_connection_options = Some(input);
            self
        }
        pub fn set_requester_peering_connection_options(
            mut self,
            input: std::option::Option<crate::model::PeeringConnectionOptionsRequest>,
        ) -> Self {
            self.requester_peering_connection_options = input;
            self
        }
        /// <p>The ID of the VPC peering connection.</p>
        pub fn vpc_peering_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_peering_connection_id = Some(input.into());
            self
        }
        pub fn set_vpc_peering_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_peering_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpcPeeringConnectionOptionsInput`](crate::input::ModifyVpcPeeringConnectionOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpcPeeringConnectionOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpcPeeringConnectionOptionsInput {
                accepter_peering_connection_options: self.accepter_peering_connection_options,
                dry_run: self.dry_run,
                requester_peering_connection_options: self.requester_peering_connection_options,
                vpc_peering_connection_id: self.vpc_peering_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpcPeeringConnectionOptionsInputOperationOutputAlias =
    crate::operation::ModifyVpcPeeringConnectionOptions;
#[doc(hidden)]
pub type ModifyVpcPeeringConnectionOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpcPeeringConnectionOptionsInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpcPeeringConnectionOptions`](crate::operation::ModifyVpcPeeringConnectionOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpcPeeringConnectionOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_vpc_peering_connection_options(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpcPeeringConnectionOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpcPeeringConnectionOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpcPeeringConnectionOptionsInput`](crate::input::ModifyVpcPeeringConnectionOptionsInput)
    pub fn builder() -> crate::input::modify_vpc_peering_connection_options_input::Builder {
        crate::input::modify_vpc_peering_connection_options_input::Builder::default()
    }
}

/// See [`ModifyVpcTenancyInput`](crate::input::ModifyVpcTenancyInput)
pub mod modify_vpc_tenancy_input {
    /// A builder for [`ModifyVpcTenancyInput`](crate::input::ModifyVpcTenancyInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpc_id: std::option::Option<std::string::String>,
        pub(crate) instance_tenancy: std::option::Option<crate::model::VpcTenancy>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the VPC.</p>
        pub fn vpc_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_id = Some(input.into());
            self
        }
        pub fn set_vpc_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.vpc_id = input;
            self
        }
        /// <p>The instance tenancy attribute for the VPC. </p>
        pub fn instance_tenancy(mut self, input: crate::model::VpcTenancy) -> Self {
            self.instance_tenancy = Some(input);
            self
        }
        pub fn set_instance_tenancy(
            mut self,
            input: std::option::Option<crate::model::VpcTenancy>,
        ) -> Self {
            self.instance_tenancy = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpcTenancyInput`](crate::input::ModifyVpcTenancyInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpcTenancyInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpcTenancyInput {
                vpc_id: self.vpc_id,
                instance_tenancy: self.instance_tenancy,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpcTenancyInputOperationOutputAlias = crate::operation::ModifyVpcTenancy;
#[doc(hidden)]
pub type ModifyVpcTenancyInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpcTenancyInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpcTenancy`](crate::operation::ModifyVpcTenancy)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpcTenancy,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_vpc_tenancy(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpcTenancy::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpcTenancy",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpcTenancyInput`](crate::input::ModifyVpcTenancyInput)
    pub fn builder() -> crate::input::modify_vpc_tenancy_input::Builder {
        crate::input::modify_vpc_tenancy_input::Builder::default()
    }
}

/// See [`ModifyVpnConnectionInput`](crate::input::ModifyVpnConnectionInput)
pub mod modify_vpn_connection_input {
    /// A builder for [`ModifyVpnConnectionInput`](crate::input::ModifyVpnConnectionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpn_connection_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) customer_gateway_id: std::option::Option<std::string::String>,
        pub(crate) vpn_gateway_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the VPN connection.</p>
        pub fn vpn_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_connection_id = Some(input.into());
            self
        }
        pub fn set_vpn_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_connection_id = input;
            self
        }
        /// <p>The ID of the transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>The ID of the customer gateway at your end of the VPN connection.</p>
        pub fn customer_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.customer_gateway_id = Some(input.into());
            self
        }
        pub fn set_customer_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.customer_gateway_id = input;
            self
        }
        /// <p>The ID of the virtual private gateway at the AWS side of the VPN connection.</p>
        pub fn vpn_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_gateway_id = Some(input.into());
            self
        }
        pub fn set_vpn_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_gateway_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpnConnectionInput`](crate::input::ModifyVpnConnectionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpnConnectionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpnConnectionInput {
                vpn_connection_id: self.vpn_connection_id,
                transit_gateway_id: self.transit_gateway_id,
                customer_gateway_id: self.customer_gateway_id,
                vpn_gateway_id: self.vpn_gateway_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpnConnectionInputOperationOutputAlias = crate::operation::ModifyVpnConnection;
#[doc(hidden)]
pub type ModifyVpnConnectionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpnConnectionInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpnConnection`](crate::operation::ModifyVpnConnection)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpnConnection,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_vpn_connection(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpnConnection::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpnConnection",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpnConnectionInput`](crate::input::ModifyVpnConnectionInput)
    pub fn builder() -> crate::input::modify_vpn_connection_input::Builder {
        crate::input::modify_vpn_connection_input::Builder::default()
    }
}

/// See [`ModifyVpnConnectionOptionsInput`](crate::input::ModifyVpnConnectionOptionsInput)
pub mod modify_vpn_connection_options_input {
    /// A builder for [`ModifyVpnConnectionOptionsInput`](crate::input::ModifyVpnConnectionOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpn_connection_id: std::option::Option<std::string::String>,
        pub(crate) local_ipv4_network_cidr: std::option::Option<std::string::String>,
        pub(crate) remote_ipv4_network_cidr: std::option::Option<std::string::String>,
        pub(crate) local_ipv6_network_cidr: std::option::Option<std::string::String>,
        pub(crate) remote_ipv6_network_cidr: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Site-to-Site VPN connection.
        /// </p>
        pub fn vpn_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_connection_id = Some(input.into());
            self
        }
        pub fn set_vpn_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_connection_id = input;
            self
        }
        /// <p>The IPv4 CIDR on the customer gateway (on-premises) side of the VPN connection.</p>
        /// <p>Default: <code>0.0.0.0/0</code>
        /// </p>
        pub fn local_ipv4_network_cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.local_ipv4_network_cidr = Some(input.into());
            self
        }
        pub fn set_local_ipv4_network_cidr(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_ipv4_network_cidr = input;
            self
        }
        /// <p>The IPv4 CIDR on the AWS side of the VPN connection.</p>
        /// <p>Default: <code>0.0.0.0/0</code>
        /// </p>
        pub fn remote_ipv4_network_cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.remote_ipv4_network_cidr = Some(input.into());
            self
        }
        pub fn set_remote_ipv4_network_cidr(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.remote_ipv4_network_cidr = input;
            self
        }
        /// <p>The IPv6 CIDR on the customer gateway (on-premises) side of the VPN connection.</p>
        /// <p>Default: <code>::/0</code>
        /// </p>
        pub fn local_ipv6_network_cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.local_ipv6_network_cidr = Some(input.into());
            self
        }
        pub fn set_local_ipv6_network_cidr(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_ipv6_network_cidr = input;
            self
        }
        /// <p>The IPv6 CIDR on the AWS side of the VPN connection.</p>
        /// <p>Default: <code>::/0</code>
        /// </p>
        pub fn remote_ipv6_network_cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.remote_ipv6_network_cidr = Some(input.into());
            self
        }
        pub fn set_remote_ipv6_network_cidr(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.remote_ipv6_network_cidr = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpnConnectionOptionsInput`](crate::input::ModifyVpnConnectionOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpnConnectionOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpnConnectionOptionsInput {
                vpn_connection_id: self.vpn_connection_id,
                local_ipv4_network_cidr: self.local_ipv4_network_cidr,
                remote_ipv4_network_cidr: self.remote_ipv4_network_cidr,
                local_ipv6_network_cidr: self.local_ipv6_network_cidr,
                remote_ipv6_network_cidr: self.remote_ipv6_network_cidr,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpnConnectionOptionsInputOperationOutputAlias =
    crate::operation::ModifyVpnConnectionOptions;
#[doc(hidden)]
pub type ModifyVpnConnectionOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpnConnectionOptionsInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpnConnectionOptions`](crate::operation::ModifyVpnConnectionOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpnConnectionOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_vpn_connection_options(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpnConnectionOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpnConnectionOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpnConnectionOptionsInput`](crate::input::ModifyVpnConnectionOptionsInput)
    pub fn builder() -> crate::input::modify_vpn_connection_options_input::Builder {
        crate::input::modify_vpn_connection_options_input::Builder::default()
    }
}

/// See [`ModifyVpnTunnelCertificateInput`](crate::input::ModifyVpnTunnelCertificateInput)
pub mod modify_vpn_tunnel_certificate_input {
    /// A builder for [`ModifyVpnTunnelCertificateInput`](crate::input::ModifyVpnTunnelCertificateInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpn_connection_id: std::option::Option<std::string::String>,
        pub(crate) vpn_tunnel_outside_ip_address: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the AWS Site-to-Site VPN connection.</p>
        pub fn vpn_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_connection_id = Some(input.into());
            self
        }
        pub fn set_vpn_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_connection_id = input;
            self
        }
        /// <p>The external IP address of the VPN tunnel.</p>
        pub fn vpn_tunnel_outside_ip_address(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.vpn_tunnel_outside_ip_address = Some(input.into());
            self
        }
        pub fn set_vpn_tunnel_outside_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_tunnel_outside_ip_address = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpnTunnelCertificateInput`](crate::input::ModifyVpnTunnelCertificateInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpnTunnelCertificateInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpnTunnelCertificateInput {
                vpn_connection_id: self.vpn_connection_id,
                vpn_tunnel_outside_ip_address: self.vpn_tunnel_outside_ip_address,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpnTunnelCertificateInputOperationOutputAlias =
    crate::operation::ModifyVpnTunnelCertificate;
#[doc(hidden)]
pub type ModifyVpnTunnelCertificateInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpnTunnelCertificateInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpnTunnelCertificate`](crate::operation::ModifyVpnTunnelCertificate)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpnTunnelCertificate,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_modify_vpn_tunnel_certificate(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpnTunnelCertificate::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpnTunnelCertificate",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpnTunnelCertificateInput`](crate::input::ModifyVpnTunnelCertificateInput)
    pub fn builder() -> crate::input::modify_vpn_tunnel_certificate_input::Builder {
        crate::input::modify_vpn_tunnel_certificate_input::Builder::default()
    }
}

/// See [`ModifyVpnTunnelOptionsInput`](crate::input::ModifyVpnTunnelOptionsInput)
pub mod modify_vpn_tunnel_options_input {
    /// A builder for [`ModifyVpnTunnelOptionsInput`](crate::input::ModifyVpnTunnelOptionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) vpn_connection_id: std::option::Option<std::string::String>,
        pub(crate) vpn_tunnel_outside_ip_address: std::option::Option<std::string::String>,
        pub(crate) tunnel_options:
            std::option::Option<crate::model::ModifyVpnTunnelOptionsSpecification>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the AWS Site-to-Site VPN connection.</p>
        pub fn vpn_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpn_connection_id = Some(input.into());
            self
        }
        pub fn set_vpn_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_connection_id = input;
            self
        }
        /// <p>The external IP address of the VPN tunnel.</p>
        pub fn vpn_tunnel_outside_ip_address(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.vpn_tunnel_outside_ip_address = Some(input.into());
            self
        }
        pub fn set_vpn_tunnel_outside_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpn_tunnel_outside_ip_address = input;
            self
        }
        /// <p>The tunnel options to modify.</p>
        pub fn tunnel_options(
            mut self,
            input: crate::model::ModifyVpnTunnelOptionsSpecification,
        ) -> Self {
            self.tunnel_options = Some(input);
            self
        }
        pub fn set_tunnel_options(
            mut self,
            input: std::option::Option<crate::model::ModifyVpnTunnelOptionsSpecification>,
        ) -> Self {
            self.tunnel_options = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ModifyVpnTunnelOptionsInput`](crate::input::ModifyVpnTunnelOptionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ModifyVpnTunnelOptionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ModifyVpnTunnelOptionsInput {
                vpn_connection_id: self.vpn_connection_id,
                vpn_tunnel_outside_ip_address: self.vpn_tunnel_outside_ip_address,
                tunnel_options: self.tunnel_options,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ModifyVpnTunnelOptionsInputOperationOutputAlias = crate::operation::ModifyVpnTunnelOptions;
#[doc(hidden)]
pub type ModifyVpnTunnelOptionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ModifyVpnTunnelOptionsInput {
    /// Consumes the builder and constructs an Operation<[`ModifyVpnTunnelOptions`](crate::operation::ModifyVpnTunnelOptions)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ModifyVpnTunnelOptions,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_modify_vpn_tunnel_options(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ModifyVpnTunnelOptions::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ModifyVpnTunnelOptions",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ModifyVpnTunnelOptionsInput`](crate::input::ModifyVpnTunnelOptionsInput)
    pub fn builder() -> crate::input::modify_vpn_tunnel_options_input::Builder {
        crate::input::modify_vpn_tunnel_options_input::Builder::default()
    }
}

/// See [`MonitorInstancesInput`](crate::input::MonitorInstancesInput)
pub mod monitor_instances_input {
    /// A builder for [`MonitorInstancesInput`](crate::input::MonitorInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`MonitorInstancesInput`](crate::input::MonitorInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::MonitorInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::MonitorInstancesInput {
                instance_ids: self.instance_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type MonitorInstancesInputOperationOutputAlias = crate::operation::MonitorInstances;
#[doc(hidden)]
pub type MonitorInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl MonitorInstancesInput {
    /// Consumes the builder and constructs an Operation<[`MonitorInstances`](crate::operation::MonitorInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::MonitorInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_monitor_instances(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::MonitorInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "MonitorInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`MonitorInstancesInput`](crate::input::MonitorInstancesInput)
    pub fn builder() -> crate::input::monitor_instances_input::Builder {
        crate::input::monitor_instances_input::Builder::default()
    }
}

/// See [`MoveAddressToVpcInput`](crate::input::MoveAddressToVpcInput)
pub mod move_address_to_vpc_input {
    /// A builder for [`MoveAddressToVpcInput`](crate::input::MoveAddressToVpcInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) public_ip: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The Elastic IP address.</p>
        pub fn public_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.public_ip = Some(input.into());
            self
        }
        pub fn set_public_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.public_ip = input;
            self
        }
        /// Consumes the builder and constructs a [`MoveAddressToVpcInput`](crate::input::MoveAddressToVpcInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::MoveAddressToVpcInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::MoveAddressToVpcInput {
                dry_run: self.dry_run,
                public_ip: self.public_ip,
            })
        }
    }
}
#[doc(hidden)]
pub type MoveAddressToVpcInputOperationOutputAlias = crate::operation::MoveAddressToVpc;
#[doc(hidden)]
pub type MoveAddressToVpcInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl MoveAddressToVpcInput {
    /// Consumes the builder and constructs an Operation<[`MoveAddressToVpc`](crate::operation::MoveAddressToVpc)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::MoveAddressToVpc,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_move_address_to_vpc(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::MoveAddressToVpc::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "MoveAddressToVpc",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`MoveAddressToVpcInput`](crate::input::MoveAddressToVpcInput)
    pub fn builder() -> crate::input::move_address_to_vpc_input::Builder {
        crate::input::move_address_to_vpc_input::Builder::default()
    }
}

/// See [`ProvisionByoipCidrInput`](crate::input::ProvisionByoipCidrInput)
pub mod provision_byoip_cidr_input {
    /// A builder for [`ProvisionByoipCidrInput`](crate::input::ProvisionByoipCidrInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr: std::option::Option<std::string::String>,
        pub(crate) cidr_authorization_context:
            std::option::Option<crate::model::CidrAuthorizationContext>,
        pub(crate) publicly_advertisable: std::option::Option<bool>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) pool_tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) multi_region: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The public IPv4 or IPv6 address range, in CIDR notation. The most specific IPv4 prefix that you can
        /// specify is /24. The most specific IPv6 prefix you can specify is /56. The address range cannot overlap with another address range that you've
        /// brought to this or another Region.</p>
        pub fn cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr = Some(input.into());
            self
        }
        pub fn set_cidr(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr = input;
            self
        }
        /// <p>A signed document that proves that you are authorized to bring the specified IP address
        /// range to Amazon using BYOIP.</p>
        pub fn cidr_authorization_context(
            mut self,
            input: crate::model::CidrAuthorizationContext,
        ) -> Self {
            self.cidr_authorization_context = Some(input);
            self
        }
        pub fn set_cidr_authorization_context(
            mut self,
            input: std::option::Option<crate::model::CidrAuthorizationContext>,
        ) -> Self {
            self.cidr_authorization_context = input;
            self
        }
        /// <p>(IPv6 only) Indicate whether the address range will be publicly advertised to the
        /// internet.</p>
        /// <p>Default: true</p>
        pub fn publicly_advertisable(mut self, input: bool) -> Self {
            self.publicly_advertisable = Some(input);
            self
        }
        pub fn set_publicly_advertisable(mut self, input: std::option::Option<bool>) -> Self {
            self.publicly_advertisable = input;
            self
        }
        /// <p>A description for the address range and the address pool.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn pool_tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.pool_tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.pool_tag_specifications = Some(v);
            self
        }
        pub fn set_pool_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.pool_tag_specifications = input;
            self
        }
        /// <para>Reserved.</para>
        pub fn multi_region(mut self, input: bool) -> Self {
            self.multi_region = Some(input);
            self
        }
        pub fn set_multi_region(mut self, input: std::option::Option<bool>) -> Self {
            self.multi_region = input;
            self
        }
        /// Consumes the builder and constructs a [`ProvisionByoipCidrInput`](crate::input::ProvisionByoipCidrInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ProvisionByoipCidrInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ProvisionByoipCidrInput {
                cidr: self.cidr,
                cidr_authorization_context: self.cidr_authorization_context,
                publicly_advertisable: self.publicly_advertisable,
                description: self.description,
                dry_run: self.dry_run,
                pool_tag_specifications: self.pool_tag_specifications,
                multi_region: self.multi_region,
            })
        }
    }
}
#[doc(hidden)]
pub type ProvisionByoipCidrInputOperationOutputAlias = crate::operation::ProvisionByoipCidr;
#[doc(hidden)]
pub type ProvisionByoipCidrInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ProvisionByoipCidrInput {
    /// Consumes the builder and constructs an Operation<[`ProvisionByoipCidr`](crate::operation::ProvisionByoipCidr)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ProvisionByoipCidr,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_provision_byoip_cidr(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ProvisionByoipCidr::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ProvisionByoipCidr",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ProvisionByoipCidrInput`](crate::input::ProvisionByoipCidrInput)
    pub fn builder() -> crate::input::provision_byoip_cidr_input::Builder {
        crate::input::provision_byoip_cidr_input::Builder::default()
    }
}

/// See [`PurchaseHostReservationInput`](crate::input::PurchaseHostReservationInput)
pub mod purchase_host_reservation_input {
    /// A builder for [`PurchaseHostReservationInput`](crate::input::PurchaseHostReservationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) currency_code: std::option::Option<crate::model::CurrencyCodeValues>,
        pub(crate) host_id_set: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) limit_price: std::option::Option<std::string::String>,
        pub(crate) offering_id: std::option::Option<std::string::String>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    }
    impl Builder {
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>The currency in which the <code>totalUpfrontPrice</code>, <code>LimitPrice</code>,
        /// and <code>totalHourlyPrice</code> amounts are specified. At this time, the only
        /// supported currency is <code>USD</code>.</p>
        pub fn currency_code(mut self, input: crate::model::CurrencyCodeValues) -> Self {
            self.currency_code = Some(input);
            self
        }
        pub fn set_currency_code(
            mut self,
            input: std::option::Option<crate::model::CurrencyCodeValues>,
        ) -> Self {
            self.currency_code = input;
            self
        }
        pub fn host_id_set(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.host_id_set.unwrap_or_default();
            v.push(input.into());
            self.host_id_set = Some(v);
            self
        }
        pub fn set_host_id_set(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.host_id_set = input;
            self
        }
        /// <p>The specified limit is checked against the total upfront cost of the reservation
        /// (calculated as the offering's upfront cost multiplied by the host count). If the total
        /// upfront cost is greater than the specified price limit, the request fails. This is used
        /// to ensure that the purchase does not exceed the expected upfront cost of the purchase.
        /// At this time, the only supported currency is <code>USD</code>. For example, to indicate
        /// a limit price of USD 100, specify 100.00.</p>
        pub fn limit_price(mut self, input: impl Into<std::string::String>) -> Self {
            self.limit_price = Some(input.into());
            self
        }
        pub fn set_limit_price(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.limit_price = input;
            self
        }
        /// <p>The ID of the offering.</p>
        pub fn offering_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.offering_id = Some(input.into());
            self
        }
        pub fn set_offering_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.offering_id = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// Consumes the builder and constructs a [`PurchaseHostReservationInput`](crate::input::PurchaseHostReservationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::PurchaseHostReservationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::PurchaseHostReservationInput {
                client_token: self.client_token,
                currency_code: self.currency_code,
                host_id_set: self.host_id_set,
                limit_price: self.limit_price,
                offering_id: self.offering_id,
                tag_specifications: self.tag_specifications,
            })
        }
    }
}
#[doc(hidden)]
pub type PurchaseHostReservationInputOperationOutputAlias =
    crate::operation::PurchaseHostReservation;
#[doc(hidden)]
pub type PurchaseHostReservationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl PurchaseHostReservationInput {
    /// Consumes the builder and constructs an Operation<[`PurchaseHostReservation`](crate::operation::PurchaseHostReservation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::PurchaseHostReservation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_purchase_host_reservation(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::PurchaseHostReservation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "PurchaseHostReservation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`PurchaseHostReservationInput`](crate::input::PurchaseHostReservationInput)
    pub fn builder() -> crate::input::purchase_host_reservation_input::Builder {
        crate::input::purchase_host_reservation_input::Builder::default()
    }
}

/// See [`PurchaseReservedInstancesOfferingInput`](crate::input::PurchaseReservedInstancesOfferingInput)
pub mod purchase_reserved_instances_offering_input {
    /// A builder for [`PurchaseReservedInstancesOfferingInput`](crate::input::PurchaseReservedInstancesOfferingInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_count: std::option::Option<i32>,
        pub(crate) reserved_instances_offering_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) limit_price: std::option::Option<crate::model::ReservedInstanceLimitPrice>,
        pub(crate) purchase_time: std::option::Option<smithy_types::Instant>,
    }
    impl Builder {
        /// <p>The number of Reserved Instances to purchase.</p>
        pub fn instance_count(mut self, input: i32) -> Self {
            self.instance_count = Some(input);
            self
        }
        pub fn set_instance_count(mut self, input: std::option::Option<i32>) -> Self {
            self.instance_count = input;
            self
        }
        /// <p>The ID of the Reserved Instance offering to purchase.</p>
        pub fn reserved_instances_offering_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.reserved_instances_offering_id = Some(input.into());
            self
        }
        pub fn set_reserved_instances_offering_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.reserved_instances_offering_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Specified for Reserved Instance Marketplace offerings to limit the total order and ensure that the Reserved Instances are not purchased at unexpected prices.</p>
        pub fn limit_price(mut self, input: crate::model::ReservedInstanceLimitPrice) -> Self {
            self.limit_price = Some(input);
            self
        }
        pub fn set_limit_price(
            mut self,
            input: std::option::Option<crate::model::ReservedInstanceLimitPrice>,
        ) -> Self {
            self.limit_price = input;
            self
        }
        /// <p>The time at which to purchase the Reserved Instance, in UTC format (for example, <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
        pub fn purchase_time(mut self, input: smithy_types::Instant) -> Self {
            self.purchase_time = Some(input);
            self
        }
        pub fn set_purchase_time(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.purchase_time = input;
            self
        }
        /// Consumes the builder and constructs a [`PurchaseReservedInstancesOfferingInput`](crate::input::PurchaseReservedInstancesOfferingInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::PurchaseReservedInstancesOfferingInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::PurchaseReservedInstancesOfferingInput {
                instance_count: self.instance_count,
                reserved_instances_offering_id: self.reserved_instances_offering_id,
                dry_run: self.dry_run,
                limit_price: self.limit_price,
                purchase_time: self.purchase_time,
            })
        }
    }
}
#[doc(hidden)]
pub type PurchaseReservedInstancesOfferingInputOperationOutputAlias =
    crate::operation::PurchaseReservedInstancesOffering;
#[doc(hidden)]
pub type PurchaseReservedInstancesOfferingInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl PurchaseReservedInstancesOfferingInput {
    /// Consumes the builder and constructs an Operation<[`PurchaseReservedInstancesOffering`](crate::operation::PurchaseReservedInstancesOffering)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::PurchaseReservedInstancesOffering,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_purchase_reserved_instances_offering(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::PurchaseReservedInstancesOffering::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "PurchaseReservedInstancesOffering",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`PurchaseReservedInstancesOfferingInput`](crate::input::PurchaseReservedInstancesOfferingInput)
    pub fn builder() -> crate::input::purchase_reserved_instances_offering_input::Builder {
        crate::input::purchase_reserved_instances_offering_input::Builder::default()
    }
}

/// See [`PurchaseScheduledInstancesInput`](crate::input::PurchaseScheduledInstancesInput)
pub mod purchase_scheduled_instances_input {
    /// A builder for [`PurchaseScheduledInstancesInput`](crate::input::PurchaseScheduledInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) purchase_requests:
            std::option::Option<std::vec::Vec<crate::model::PurchaseRequest>>,
    }
    impl Builder {
        /// <p>Unique, case-sensitive identifier that ensures the idempotency of the request.
        /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn purchase_requests(
            mut self,
            input: impl Into<crate::model::PurchaseRequest>,
        ) -> Self {
            let mut v = self.purchase_requests.unwrap_or_default();
            v.push(input.into());
            self.purchase_requests = Some(v);
            self
        }
        pub fn set_purchase_requests(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::PurchaseRequest>>,
        ) -> Self {
            self.purchase_requests = input;
            self
        }
        /// Consumes the builder and constructs a [`PurchaseScheduledInstancesInput`](crate::input::PurchaseScheduledInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::PurchaseScheduledInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::PurchaseScheduledInstancesInput {
                client_token: self.client_token,
                dry_run: self.dry_run,
                purchase_requests: self.purchase_requests,
            })
        }
    }
}
#[doc(hidden)]
pub type PurchaseScheduledInstancesInputOperationOutputAlias =
    crate::operation::PurchaseScheduledInstances;
#[doc(hidden)]
pub type PurchaseScheduledInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl PurchaseScheduledInstancesInput {
    /// Consumes the builder and constructs an Operation<[`PurchaseScheduledInstances`](crate::operation::PurchaseScheduledInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::PurchaseScheduledInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_purchase_scheduled_instances(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::PurchaseScheduledInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "PurchaseScheduledInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`PurchaseScheduledInstancesInput`](crate::input::PurchaseScheduledInstancesInput)
    pub fn builder() -> crate::input::purchase_scheduled_instances_input::Builder {
        crate::input::purchase_scheduled_instances_input::Builder::default()
    }
}

/// See [`RebootInstancesInput`](crate::input::RebootInstancesInput)
pub mod reboot_instances_input {
    /// A builder for [`RebootInstancesInput`](crate::input::RebootInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RebootInstancesInput`](crate::input::RebootInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RebootInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RebootInstancesInput {
                instance_ids: self.instance_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type RebootInstancesInputOperationOutputAlias = crate::operation::RebootInstances;
#[doc(hidden)]
pub type RebootInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RebootInstancesInput {
    /// Consumes the builder and constructs an Operation<[`RebootInstances`](crate::operation::RebootInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RebootInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_reboot_instances(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RebootInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RebootInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RebootInstancesInput`](crate::input::RebootInstancesInput)
    pub fn builder() -> crate::input::reboot_instances_input::Builder {
        crate::input::reboot_instances_input::Builder::default()
    }
}

/// See [`RegisterImageInput`](crate::input::RegisterImageInput)
pub mod register_image_input {
    /// A builder for [`RegisterImageInput`](crate::input::RegisterImageInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) image_location: std::option::Option<std::string::String>,
        pub(crate) architecture: std::option::Option<crate::model::ArchitectureValues>,
        pub(crate) block_device_mappings:
            std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) ena_support: std::option::Option<bool>,
        pub(crate) kernel_id: std::option::Option<std::string::String>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) billing_products: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) ramdisk_id: std::option::Option<std::string::String>,
        pub(crate) root_device_name: std::option::Option<std::string::String>,
        pub(crate) sriov_net_support: std::option::Option<std::string::String>,
        pub(crate) virtualization_type: std::option::Option<std::string::String>,
        pub(crate) boot_mode: std::option::Option<crate::model::BootModeValues>,
    }
    impl Builder {
        /// <p>The full path to your AMI manifest in Amazon S3 storage. The specified bucket must have the
        /// <code>aws-exec-read</code> canned access control list (ACL) to ensure that it can be accessed
        /// by Amazon EC2. For more information, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl">Canned ACLs</a> in the
        /// <i>Amazon S3 Service Developer Guide</i>.</p>
        pub fn image_location(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_location = Some(input.into());
            self
        }
        pub fn set_image_location(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.image_location = input;
            self
        }
        /// <p>The architecture of the AMI.</p>
        /// <p>Default: For Amazon EBS-backed AMIs, <code>i386</code>.
        /// For instance store-backed AMIs, the architecture specified in the manifest file.</p>
        pub fn architecture(mut self, input: crate::model::ArchitectureValues) -> Self {
            self.architecture = Some(input);
            self
        }
        pub fn set_architecture(
            mut self,
            input: std::option::Option<crate::model::ArchitectureValues>,
        ) -> Self {
            self.architecture = input;
            self
        }
        pub fn block_device_mappings(
            mut self,
            input: impl Into<crate::model::BlockDeviceMapping>,
        ) -> Self {
            let mut v = self.block_device_mappings.unwrap_or_default();
            v.push(input.into());
            self.block_device_mappings = Some(v);
            self
        }
        pub fn set_block_device_mappings(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
        ) -> Self {
            self.block_device_mappings = input;
            self
        }
        /// <p>A description for your AMI.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Set to <code>true</code> to enable enhanced networking with ENA for the AMI and any instances that you launch from the AMI.</p>
        /// <p>This option is supported only for HVM AMIs. Specifying this option with a PV AMI can make instances launched from the AMI unreachable.</p>
        pub fn ena_support(mut self, input: bool) -> Self {
            self.ena_support = Some(input);
            self
        }
        pub fn set_ena_support(mut self, input: std::option::Option<bool>) -> Self {
            self.ena_support = input;
            self
        }
        /// <p>The ID of the kernel.</p>
        pub fn kernel_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kernel_id = Some(input.into());
            self
        }
        pub fn set_kernel_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kernel_id = input;
            self
        }
        /// <p>A name for your AMI.</p>
        /// <p>Constraints: 3-128 alphanumeric characters, parentheses (()), square brackets ([]), spaces ( ), periods (.), slashes (/), dashes (-), single quotes ('), at-signs (@), or underscores(_)</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        pub fn billing_products(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.billing_products.unwrap_or_default();
            v.push(input.into());
            self.billing_products = Some(v);
            self
        }
        pub fn set_billing_products(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.billing_products = input;
            self
        }
        /// <p>The ID of the RAM disk.</p>
        pub fn ramdisk_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.ramdisk_id = Some(input.into());
            self
        }
        pub fn set_ramdisk_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ramdisk_id = input;
            self
        }
        /// <p>The device name of the root device volume (for example, <code>/dev/sda1</code>).</p>
        pub fn root_device_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.root_device_name = Some(input.into());
            self
        }
        pub fn set_root_device_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.root_device_name = input;
            self
        }
        /// <p>Set to <code>simple</code> to enable enhanced networking with the Intel 82599 Virtual Function interface for the AMI and any instances that you launch from the AMI.</p>
        /// <p>There is no way to disable <code>sriovNetSupport</code> at this time.</p>
        /// <p>This option is supported only for HVM AMIs. Specifying this option with a PV AMI can make instances launched from the AMI unreachable.</p>
        pub fn sriov_net_support(mut self, input: impl Into<std::string::String>) -> Self {
            self.sriov_net_support = Some(input.into());
            self
        }
        pub fn set_sriov_net_support(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.sriov_net_support = input;
            self
        }
        /// <p>The type of virtualization (<code>hvm</code> | <code>paravirtual</code>).</p>
        /// <p>Default: <code>paravirtual</code>
        /// </p>
        pub fn virtualization_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.virtualization_type = Some(input.into());
            self
        }
        pub fn set_virtualization_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.virtualization_type = input;
            self
        }
        /// <p>The boot mode of the AMI. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ami-boot.html">Boot modes</a> in the
        /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
        pub fn boot_mode(mut self, input: crate::model::BootModeValues) -> Self {
            self.boot_mode = Some(input);
            self
        }
        pub fn set_boot_mode(
            mut self,
            input: std::option::Option<crate::model::BootModeValues>,
        ) -> Self {
            self.boot_mode = input;
            self
        }
        /// Consumes the builder and constructs a [`RegisterImageInput`](crate::input::RegisterImageInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::RegisterImageInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::RegisterImageInput {
                image_location: self.image_location,
                architecture: self.architecture,
                block_device_mappings: self.block_device_mappings,
                description: self.description,
                dry_run: self.dry_run,
                ena_support: self.ena_support,
                kernel_id: self.kernel_id,
                name: self.name,
                billing_products: self.billing_products,
                ramdisk_id: self.ramdisk_id,
                root_device_name: self.root_device_name,
                sriov_net_support: self.sriov_net_support,
                virtualization_type: self.virtualization_type,
                boot_mode: self.boot_mode,
            })
        }
    }
}
#[doc(hidden)]
pub type RegisterImageInputOperationOutputAlias = crate::operation::RegisterImage;
#[doc(hidden)]
pub type RegisterImageInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RegisterImageInput {
    /// Consumes the builder and constructs an Operation<[`RegisterImage`](crate::operation::RegisterImage)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RegisterImage,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_register_image(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RegisterImage::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RegisterImage",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RegisterImageInput`](crate::input::RegisterImageInput)
    pub fn builder() -> crate::input::register_image_input::Builder {
        crate::input::register_image_input::Builder::default()
    }
}

/// See [`RegisterInstanceEventNotificationAttributesInput`](crate::input::RegisterInstanceEventNotificationAttributesInput)
pub mod register_instance_event_notification_attributes_input {
    /// A builder for [`RegisterInstanceEventNotificationAttributesInput`](crate::input::RegisterInstanceEventNotificationAttributesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_tag_attribute:
            std::option::Option<crate::model::RegisterInstanceTagAttributeRequest>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Information about the tag keys to register.</p>
        pub fn instance_tag_attribute(
            mut self,
            input: crate::model::RegisterInstanceTagAttributeRequest,
        ) -> Self {
            self.instance_tag_attribute = Some(input);
            self
        }
        pub fn set_instance_tag_attribute(
            mut self,
            input: std::option::Option<crate::model::RegisterInstanceTagAttributeRequest>,
        ) -> Self {
            self.instance_tag_attribute = input;
            self
        }
        /// Consumes the builder and constructs a [`RegisterInstanceEventNotificationAttributesInput`](crate::input::RegisterInstanceEventNotificationAttributesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RegisterInstanceEventNotificationAttributesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::RegisterInstanceEventNotificationAttributesInput {
                    dry_run: self.dry_run,
                    instance_tag_attribute: self.instance_tag_attribute,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type RegisterInstanceEventNotificationAttributesInputOperationOutputAlias =
    crate::operation::RegisterInstanceEventNotificationAttributes;
#[doc(hidden)]
pub type RegisterInstanceEventNotificationAttributesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl RegisterInstanceEventNotificationAttributesInput {
    /// Consumes the builder and constructs an Operation<[`RegisterInstanceEventNotificationAttributes`](crate::operation::RegisterInstanceEventNotificationAttributes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RegisterInstanceEventNotificationAttributes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_register_instance_event_notification_attributes(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RegisterInstanceEventNotificationAttributes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RegisterInstanceEventNotificationAttributes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RegisterInstanceEventNotificationAttributesInput`](crate::input::RegisterInstanceEventNotificationAttributesInput)
    pub fn builder() -> crate::input::register_instance_event_notification_attributes_input::Builder
    {
        crate::input::register_instance_event_notification_attributes_input::Builder::default()
    }
}

/// See [`RegisterTransitGatewayMulticastGroupMembersInput`](crate::input::RegisterTransitGatewayMulticastGroupMembersInput)
pub mod register_transit_gateway_multicast_group_members_input {
    /// A builder for [`RegisterTransitGatewayMulticastGroupMembersInput`](crate::input::RegisterTransitGatewayMulticastGroupMembersInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) group_ip_address: std::option::Option<std::string::String>,
        pub(crate) network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The IP address assigned to the  transit gateway multicast group.</p>
        pub fn group_ip_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_ip_address = Some(input.into());
            self
        }
        pub fn set_group_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.group_ip_address = input;
            self
        }
        pub fn network_interface_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_interface_ids.unwrap_or_default();
            v.push(input.into());
            self.network_interface_ids = Some(v);
            self
        }
        pub fn set_network_interface_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_interface_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RegisterTransitGatewayMulticastGroupMembersInput`](crate::input::RegisterTransitGatewayMulticastGroupMembersInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RegisterTransitGatewayMulticastGroupMembersInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::RegisterTransitGatewayMulticastGroupMembersInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    group_ip_address: self.group_ip_address,
                    network_interface_ids: self.network_interface_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type RegisterTransitGatewayMulticastGroupMembersInputOperationOutputAlias =
    crate::operation::RegisterTransitGatewayMulticastGroupMembers;
#[doc(hidden)]
pub type RegisterTransitGatewayMulticastGroupMembersInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl RegisterTransitGatewayMulticastGroupMembersInput {
    /// Consumes the builder and constructs an Operation<[`RegisterTransitGatewayMulticastGroupMembers`](crate::operation::RegisterTransitGatewayMulticastGroupMembers)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RegisterTransitGatewayMulticastGroupMembers,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_register_transit_gateway_multicast_group_members(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RegisterTransitGatewayMulticastGroupMembers::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RegisterTransitGatewayMulticastGroupMembers",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RegisterTransitGatewayMulticastGroupMembersInput`](crate::input::RegisterTransitGatewayMulticastGroupMembersInput)
    pub fn builder() -> crate::input::register_transit_gateway_multicast_group_members_input::Builder
    {
        crate::input::register_transit_gateway_multicast_group_members_input::Builder::default()
    }
}

/// See [`RegisterTransitGatewayMulticastGroupSourcesInput`](crate::input::RegisterTransitGatewayMulticastGroupSourcesInput)
pub mod register_transit_gateway_multicast_group_sources_input {
    /// A builder for [`RegisterTransitGatewayMulticastGroupSourcesInput`](crate::input::RegisterTransitGatewayMulticastGroupSourcesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) group_ip_address: std::option::Option<std::string::String>,
        pub(crate) network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The IP address assigned to the  transit gateway multicast group.</p>
        pub fn group_ip_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_ip_address = Some(input.into());
            self
        }
        pub fn set_group_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.group_ip_address = input;
            self
        }
        pub fn network_interface_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.network_interface_ids.unwrap_or_default();
            v.push(input.into());
            self.network_interface_ids = Some(v);
            self
        }
        pub fn set_network_interface_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.network_interface_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RegisterTransitGatewayMulticastGroupSourcesInput`](crate::input::RegisterTransitGatewayMulticastGroupSourcesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RegisterTransitGatewayMulticastGroupSourcesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::RegisterTransitGatewayMulticastGroupSourcesInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    group_ip_address: self.group_ip_address,
                    network_interface_ids: self.network_interface_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type RegisterTransitGatewayMulticastGroupSourcesInputOperationOutputAlias =
    crate::operation::RegisterTransitGatewayMulticastGroupSources;
#[doc(hidden)]
pub type RegisterTransitGatewayMulticastGroupSourcesInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl RegisterTransitGatewayMulticastGroupSourcesInput {
    /// Consumes the builder and constructs an Operation<[`RegisterTransitGatewayMulticastGroupSources`](crate::operation::RegisterTransitGatewayMulticastGroupSources)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RegisterTransitGatewayMulticastGroupSources,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_register_transit_gateway_multicast_group_sources(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RegisterTransitGatewayMulticastGroupSources::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RegisterTransitGatewayMulticastGroupSources",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RegisterTransitGatewayMulticastGroupSourcesInput`](crate::input::RegisterTransitGatewayMulticastGroupSourcesInput)
    pub fn builder() -> crate::input::register_transit_gateway_multicast_group_sources_input::Builder
    {
        crate::input::register_transit_gateway_multicast_group_sources_input::Builder::default()
    }
}

/// See [`RejectTransitGatewayMulticastDomainAssociationsInput`](crate::input::RejectTransitGatewayMulticastDomainAssociationsInput)
pub mod reject_transit_gateway_multicast_domain_associations_input {
    /// A builder for [`RejectTransitGatewayMulticastDomainAssociationsInput`](crate::input::RejectTransitGatewayMulticastDomainAssociationsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        /// <p>The ID of the transit gateway attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        pub fn subnet_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.subnet_ids.unwrap_or_default();
            v.push(input.into());
            self.subnet_ids = Some(v);
            self
        }
        pub fn set_subnet_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.subnet_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RejectTransitGatewayMulticastDomainAssociationsInput`](crate::input::RejectTransitGatewayMulticastDomainAssociationsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RejectTransitGatewayMulticastDomainAssociationsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::RejectTransitGatewayMulticastDomainAssociationsInput {
                    transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                    transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                    subnet_ids: self.subnet_ids,
                    dry_run: self.dry_run,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type RejectTransitGatewayMulticastDomainAssociationsInputOperationOutputAlias =
    crate::operation::RejectTransitGatewayMulticastDomainAssociations;
#[doc(hidden)]
pub type RejectTransitGatewayMulticastDomainAssociationsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl RejectTransitGatewayMulticastDomainAssociationsInput {
    /// Consumes the builder and constructs an Operation<[`RejectTransitGatewayMulticastDomainAssociations`](crate::operation::RejectTransitGatewayMulticastDomainAssociations)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RejectTransitGatewayMulticastDomainAssociations,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_reject_transit_gateway_multicast_domain_associations(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RejectTransitGatewayMulticastDomainAssociations::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RejectTransitGatewayMulticastDomainAssociations",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RejectTransitGatewayMulticastDomainAssociationsInput`](crate::input::RejectTransitGatewayMulticastDomainAssociationsInput)
    pub fn builder(
    ) -> crate::input::reject_transit_gateway_multicast_domain_associations_input::Builder {
        crate::input::reject_transit_gateway_multicast_domain_associations_input::Builder::default()
    }
}

/// See [`RejectTransitGatewayPeeringAttachmentInput`](crate::input::RejectTransitGatewayPeeringAttachmentInput)
pub mod reject_transit_gateway_peering_attachment_input {
    /// A builder for [`RejectTransitGatewayPeeringAttachmentInput`](crate::input::RejectTransitGatewayPeeringAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway peering attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RejectTransitGatewayPeeringAttachmentInput`](crate::input::RejectTransitGatewayPeeringAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RejectTransitGatewayPeeringAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RejectTransitGatewayPeeringAttachmentInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type RejectTransitGatewayPeeringAttachmentInputOperationOutputAlias =
    crate::operation::RejectTransitGatewayPeeringAttachment;
#[doc(hidden)]
pub type RejectTransitGatewayPeeringAttachmentInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl RejectTransitGatewayPeeringAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`RejectTransitGatewayPeeringAttachment`](crate::operation::RejectTransitGatewayPeeringAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RejectTransitGatewayPeeringAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_reject_transit_gateway_peering_attachment(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RejectTransitGatewayPeeringAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RejectTransitGatewayPeeringAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RejectTransitGatewayPeeringAttachmentInput`](crate::input::RejectTransitGatewayPeeringAttachmentInput)
    pub fn builder() -> crate::input::reject_transit_gateway_peering_attachment_input::Builder {
        crate::input::reject_transit_gateway_peering_attachment_input::Builder::default()
    }
}

/// See [`RejectTransitGatewayVpcAttachmentInput`](crate::input::RejectTransitGatewayVpcAttachmentInput)
pub mod reject_transit_gateway_vpc_attachment_input {
    /// A builder for [`RejectTransitGatewayVpcAttachmentInput`](crate::input::RejectTransitGatewayVpcAttachmentInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RejectTransitGatewayVpcAttachmentInput`](crate::input::RejectTransitGatewayVpcAttachmentInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RejectTransitGatewayVpcAttachmentInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RejectTransitGatewayVpcAttachmentInput {
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type RejectTransitGatewayVpcAttachmentInputOperationOutputAlias =
    crate::operation::RejectTransitGatewayVpcAttachment;
#[doc(hidden)]
pub type RejectTransitGatewayVpcAttachmentInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RejectTransitGatewayVpcAttachmentInput {
    /// Consumes the builder and constructs an Operation<[`RejectTransitGatewayVpcAttachment`](crate::operation::RejectTransitGatewayVpcAttachment)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RejectTransitGatewayVpcAttachment,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_reject_transit_gateway_vpc_attachment(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RejectTransitGatewayVpcAttachment::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RejectTransitGatewayVpcAttachment",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RejectTransitGatewayVpcAttachmentInput`](crate::input::RejectTransitGatewayVpcAttachmentInput)
    pub fn builder() -> crate::input::reject_transit_gateway_vpc_attachment_input::Builder {
        crate::input::reject_transit_gateway_vpc_attachment_input::Builder::default()
    }
}

/// See [`RejectVpcEndpointConnectionsInput`](crate::input::RejectVpcEndpointConnectionsInput)
pub mod reject_vpc_endpoint_connections_input {
    /// A builder for [`RejectVpcEndpointConnectionsInput`](crate::input::RejectVpcEndpointConnectionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_id: std::option::Option<std::string::String>,
        pub(crate) vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the service.</p>
        pub fn service_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_id = Some(input.into());
            self
        }
        pub fn set_service_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_id = input;
            self
        }
        pub fn vpc_endpoint_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.vpc_endpoint_ids.unwrap_or_default();
            v.push(input.into());
            self.vpc_endpoint_ids = Some(v);
            self
        }
        pub fn set_vpc_endpoint_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.vpc_endpoint_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`RejectVpcEndpointConnectionsInput`](crate::input::RejectVpcEndpointConnectionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RejectVpcEndpointConnectionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RejectVpcEndpointConnectionsInput {
                dry_run: self.dry_run,
                service_id: self.service_id,
                vpc_endpoint_ids: self.vpc_endpoint_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type RejectVpcEndpointConnectionsInputOperationOutputAlias =
    crate::operation::RejectVpcEndpointConnections;
#[doc(hidden)]
pub type RejectVpcEndpointConnectionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RejectVpcEndpointConnectionsInput {
    /// Consumes the builder and constructs an Operation<[`RejectVpcEndpointConnections`](crate::operation::RejectVpcEndpointConnections)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RejectVpcEndpointConnections,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_reject_vpc_endpoint_connections(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RejectVpcEndpointConnections::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RejectVpcEndpointConnections",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RejectVpcEndpointConnectionsInput`](crate::input::RejectVpcEndpointConnectionsInput)
    pub fn builder() -> crate::input::reject_vpc_endpoint_connections_input::Builder {
        crate::input::reject_vpc_endpoint_connections_input::Builder::default()
    }
}

/// See [`RejectVpcPeeringConnectionInput`](crate::input::RejectVpcPeeringConnectionInput)
pub mod reject_vpc_peering_connection_input {
    /// A builder for [`RejectVpcPeeringConnectionInput`](crate::input::RejectVpcPeeringConnectionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_peering_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the VPC peering connection.</p>
        pub fn vpc_peering_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_peering_connection_id = Some(input.into());
            self
        }
        pub fn set_vpc_peering_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_peering_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`RejectVpcPeeringConnectionInput`](crate::input::RejectVpcPeeringConnectionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RejectVpcPeeringConnectionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RejectVpcPeeringConnectionInput {
                dry_run: self.dry_run,
                vpc_peering_connection_id: self.vpc_peering_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type RejectVpcPeeringConnectionInputOperationOutputAlias =
    crate::operation::RejectVpcPeeringConnection;
#[doc(hidden)]
pub type RejectVpcPeeringConnectionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RejectVpcPeeringConnectionInput {
    /// Consumes the builder and constructs an Operation<[`RejectVpcPeeringConnection`](crate::operation::RejectVpcPeeringConnection)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RejectVpcPeeringConnection,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_reject_vpc_peering_connection(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RejectVpcPeeringConnection::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RejectVpcPeeringConnection",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RejectVpcPeeringConnectionInput`](crate::input::RejectVpcPeeringConnectionInput)
    pub fn builder() -> crate::input::reject_vpc_peering_connection_input::Builder {
        crate::input::reject_vpc_peering_connection_input::Builder::default()
    }
}

/// See [`ReleaseAddressInput`](crate::input::ReleaseAddressInput)
pub mod release_address_input {
    /// A builder for [`ReleaseAddressInput`](crate::input::ReleaseAddressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) allocation_id: std::option::Option<std::string::String>,
        pub(crate) public_ip: std::option::Option<std::string::String>,
        pub(crate) network_border_group: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>[EC2-VPC] The allocation ID. Required for EC2-VPC.</p>
        pub fn allocation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.allocation_id = Some(input.into());
            self
        }
        pub fn set_allocation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.allocation_id = input;
            self
        }
        /// <p>[EC2-Classic] The Elastic IP address. Required for EC2-Classic.</p>
        pub fn public_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.public_ip = Some(input.into());
            self
        }
        pub fn set_public_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.public_ip = input;
            self
        }
        /// <p>The set of Availability Zones, Local Zones, or Wavelength Zones from which AWS advertises
        /// IP addresses.</p>
        /// <p>If you provide an incorrect network border group, you will receive an <code>InvalidAddress.NotFound</code> error. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html">Error Codes</a>.</p>
        /// <note>
        /// <p>You cannot use a network border group with EC2 Classic. If you attempt this operation on EC2 classic, you will receive an <code>InvalidParameterCombination</code> error. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html">Error Codes</a>.</p>
        /// </note>
        pub fn network_border_group(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_border_group = Some(input.into());
            self
        }
        pub fn set_network_border_group(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_border_group = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ReleaseAddressInput`](crate::input::ReleaseAddressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ReleaseAddressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ReleaseAddressInput {
                allocation_id: self.allocation_id,
                public_ip: self.public_ip,
                network_border_group: self.network_border_group,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ReleaseAddressInputOperationOutputAlias = crate::operation::ReleaseAddress;
#[doc(hidden)]
pub type ReleaseAddressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReleaseAddressInput {
    /// Consumes the builder and constructs an Operation<[`ReleaseAddress`](crate::operation::ReleaseAddress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReleaseAddress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_release_address(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReleaseAddress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ReleaseAddress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReleaseAddressInput`](crate::input::ReleaseAddressInput)
    pub fn builder() -> crate::input::release_address_input::Builder {
        crate::input::release_address_input::Builder::default()
    }
}

/// See [`ReleaseHostsInput`](crate::input::ReleaseHostsInput)
pub mod release_hosts_input {
    /// A builder for [`ReleaseHostsInput`](crate::input::ReleaseHostsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) host_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        pub fn host_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.host_ids.unwrap_or_default();
            v.push(input.into());
            self.host_ids = Some(v);
            self
        }
        pub fn set_host_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.host_ids = input;
            self
        }
        /// Consumes the builder and constructs a [`ReleaseHostsInput`](crate::input::ReleaseHostsInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ReleaseHostsInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ReleaseHostsInput {
                host_ids: self.host_ids,
            })
        }
    }
}
#[doc(hidden)]
pub type ReleaseHostsInputOperationOutputAlias = crate::operation::ReleaseHosts;
#[doc(hidden)]
pub type ReleaseHostsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReleaseHostsInput {
    /// Consumes the builder and constructs an Operation<[`ReleaseHosts`](crate::operation::ReleaseHosts)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReleaseHosts,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_release_hosts(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReleaseHosts::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ReleaseHosts", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReleaseHostsInput`](crate::input::ReleaseHostsInput)
    pub fn builder() -> crate::input::release_hosts_input::Builder {
        crate::input::release_hosts_input::Builder::default()
    }
}

/// See [`ReplaceIamInstanceProfileAssociationInput`](crate::input::ReplaceIamInstanceProfileAssociationInput)
pub mod replace_iam_instance_profile_association_input {
    /// A builder for [`ReplaceIamInstanceProfileAssociationInput`](crate::input::ReplaceIamInstanceProfileAssociationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) iam_instance_profile:
            std::option::Option<crate::model::IamInstanceProfileSpecification>,
        pub(crate) association_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The IAM instance profile.</p>
        pub fn iam_instance_profile(
            mut self,
            input: crate::model::IamInstanceProfileSpecification,
        ) -> Self {
            self.iam_instance_profile = Some(input);
            self
        }
        pub fn set_iam_instance_profile(
            mut self,
            input: std::option::Option<crate::model::IamInstanceProfileSpecification>,
        ) -> Self {
            self.iam_instance_profile = input;
            self
        }
        /// <p>The ID of the existing IAM instance profile association.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// Consumes the builder and constructs a [`ReplaceIamInstanceProfileAssociationInput`](crate::input::ReplaceIamInstanceProfileAssociationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ReplaceIamInstanceProfileAssociationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ReplaceIamInstanceProfileAssociationInput {
                iam_instance_profile: self.iam_instance_profile,
                association_id: self.association_id,
            })
        }
    }
}
#[doc(hidden)]
pub type ReplaceIamInstanceProfileAssociationInputOperationOutputAlias =
    crate::operation::ReplaceIamInstanceProfileAssociation;
#[doc(hidden)]
pub type ReplaceIamInstanceProfileAssociationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl ReplaceIamInstanceProfileAssociationInput {
    /// Consumes the builder and constructs an Operation<[`ReplaceIamInstanceProfileAssociation`](crate::operation::ReplaceIamInstanceProfileAssociation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReplaceIamInstanceProfileAssociation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_replace_iam_instance_profile_association(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReplaceIamInstanceProfileAssociation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ReplaceIamInstanceProfileAssociation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReplaceIamInstanceProfileAssociationInput`](crate::input::ReplaceIamInstanceProfileAssociationInput)
    pub fn builder() -> crate::input::replace_iam_instance_profile_association_input::Builder {
        crate::input::replace_iam_instance_profile_association_input::Builder::default()
    }
}

/// See [`ReplaceNetworkAclAssociationInput`](crate::input::ReplaceNetworkAclAssociationInput)
pub mod replace_network_acl_association_input {
    /// A builder for [`ReplaceNetworkAclAssociationInput`](crate::input::ReplaceNetworkAclAssociationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_acl_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the current association between the original network ACL and the subnet.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the new network ACL to associate with the subnet.</p>
        pub fn network_acl_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_acl_id = Some(input.into());
            self
        }
        pub fn set_network_acl_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_acl_id = input;
            self
        }
        /// Consumes the builder and constructs a [`ReplaceNetworkAclAssociationInput`](crate::input::ReplaceNetworkAclAssociationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ReplaceNetworkAclAssociationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ReplaceNetworkAclAssociationInput {
                association_id: self.association_id,
                dry_run: self.dry_run,
                network_acl_id: self.network_acl_id,
            })
        }
    }
}
#[doc(hidden)]
pub type ReplaceNetworkAclAssociationInputOperationOutputAlias =
    crate::operation::ReplaceNetworkAclAssociation;
#[doc(hidden)]
pub type ReplaceNetworkAclAssociationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReplaceNetworkAclAssociationInput {
    /// Consumes the builder and constructs an Operation<[`ReplaceNetworkAclAssociation`](crate::operation::ReplaceNetworkAclAssociation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReplaceNetworkAclAssociation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_replace_network_acl_association(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReplaceNetworkAclAssociation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ReplaceNetworkAclAssociation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReplaceNetworkAclAssociationInput`](crate::input::ReplaceNetworkAclAssociationInput)
    pub fn builder() -> crate::input::replace_network_acl_association_input::Builder {
        crate::input::replace_network_acl_association_input::Builder::default()
    }
}

/// See [`ReplaceNetworkAclEntryInput`](crate::input::ReplaceNetworkAclEntryInput)
pub mod replace_network_acl_entry_input {
    /// A builder for [`ReplaceNetworkAclEntryInput`](crate::input::ReplaceNetworkAclEntryInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr_block: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) egress: std::option::Option<bool>,
        pub(crate) icmp_type_code: std::option::Option<crate::model::IcmpTypeCode>,
        pub(crate) ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) network_acl_id: std::option::Option<std::string::String>,
        pub(crate) port_range: std::option::Option<crate::model::PortRange>,
        pub(crate) protocol: std::option::Option<std::string::String>,
        pub(crate) rule_action: std::option::Option<crate::model::RuleAction>,
        pub(crate) rule_number: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The IPv4 network range to allow or deny, in CIDR notation (for example
        /// <code>172.16.0.0/24</code>).</p>
        pub fn cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_block = Some(input.into());
            self
        }
        pub fn set_cidr_block(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_block = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Indicates whether to replace the egress rule.</p>
        /// <p>Default: If no value is specified, we replace the ingress rule.</p>
        pub fn egress(mut self, input: bool) -> Self {
            self.egress = Some(input);
            self
        }
        pub fn set_egress(mut self, input: std::option::Option<bool>) -> Self {
            self.egress = input;
            self
        }
        /// <p>ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol
        /// 1 (ICMP) or protocol 58 (ICMPv6) with an IPv6 CIDR block.</p>
        pub fn icmp_type_code(mut self, input: crate::model::IcmpTypeCode) -> Self {
            self.icmp_type_code = Some(input);
            self
        }
        pub fn set_icmp_type_code(
            mut self,
            input: std::option::Option<crate::model::IcmpTypeCode>,
        ) -> Self {
            self.icmp_type_code = input;
            self
        }
        /// <p>The IPv6 network range to allow or deny, in CIDR notation (for example
        /// <code>2001:bd8:1234:1a00::/64</code>).</p>
        pub fn ipv6_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ipv6_cidr_block = input;
            self
        }
        /// <p>The ID of the ACL.</p>
        pub fn network_acl_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_acl_id = Some(input.into());
            self
        }
        pub fn set_network_acl_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_acl_id = input;
            self
        }
        /// <p>TCP or UDP protocols: The range of ports the rule applies to.
        /// Required if specifying protocol 6 (TCP) or 17 (UDP).</p>
        pub fn port_range(mut self, input: crate::model::PortRange) -> Self {
            self.port_range = Some(input);
            self
        }
        pub fn set_port_range(
            mut self,
            input: std::option::Option<crate::model::PortRange>,
        ) -> Self {
            self.port_range = input;
            self
        }
        /// <p>The protocol number. A value of "-1" means all protocols. If you specify "-1" or a
        /// protocol number other than "6" (TCP), "17" (UDP), or "1" (ICMP), traffic on all ports is
        /// allowed, regardless of any ports or ICMP types or codes that you specify. If you specify
        /// protocol "58" (ICMPv6) and specify an IPv4 CIDR block, traffic for all ICMP types and
        /// codes allowed, regardless of any that you specify. If you specify protocol "58" (ICMPv6)
        /// and specify an IPv6 CIDR block, you must specify an ICMP type and code.</p>
        pub fn protocol(mut self, input: impl Into<std::string::String>) -> Self {
            self.protocol = Some(input.into());
            self
        }
        pub fn set_protocol(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.protocol = input;
            self
        }
        /// <p>Indicates whether to allow or deny the traffic that matches the rule.</p>
        pub fn rule_action(mut self, input: crate::model::RuleAction) -> Self {
            self.rule_action = Some(input);
            self
        }
        pub fn set_rule_action(
            mut self,
            input: std::option::Option<crate::model::RuleAction>,
        ) -> Self {
            self.rule_action = input;
            self
        }
        /// <p>The rule number of the entry to replace.</p>
        pub fn rule_number(mut self, input: i32) -> Self {
            self.rule_number = Some(input);
            self
        }
        pub fn set_rule_number(mut self, input: std::option::Option<i32>) -> Self {
            self.rule_number = input;
            self
        }
        /// Consumes the builder and constructs a [`ReplaceNetworkAclEntryInput`](crate::input::ReplaceNetworkAclEntryInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ReplaceNetworkAclEntryInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ReplaceNetworkAclEntryInput {
                cidr_block: self.cidr_block,
                dry_run: self.dry_run,
                egress: self.egress,
                icmp_type_code: self.icmp_type_code,
                ipv6_cidr_block: self.ipv6_cidr_block,
                network_acl_id: self.network_acl_id,
                port_range: self.port_range,
                protocol: self.protocol,
                rule_action: self.rule_action,
                rule_number: self.rule_number,
            })
        }
    }
}
#[doc(hidden)]
pub type ReplaceNetworkAclEntryInputOperationOutputAlias = crate::operation::ReplaceNetworkAclEntry;
#[doc(hidden)]
pub type ReplaceNetworkAclEntryInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReplaceNetworkAclEntryInput {
    /// Consumes the builder and constructs an Operation<[`ReplaceNetworkAclEntry`](crate::operation::ReplaceNetworkAclEntry)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReplaceNetworkAclEntry,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_replace_network_acl_entry(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReplaceNetworkAclEntry::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ReplaceNetworkAclEntry",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReplaceNetworkAclEntryInput`](crate::input::ReplaceNetworkAclEntryInput)
    pub fn builder() -> crate::input::replace_network_acl_entry_input::Builder {
        crate::input::replace_network_acl_entry_input::Builder::default()
    }
}

/// See [`ReplaceRouteInput`](crate::input::ReplaceRouteInput)
pub mod replace_route_input {
    /// A builder for [`ReplaceRouteInput`](crate::input::ReplaceRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) destination_ipv6_cidr_block: std::option::Option<std::string::String>,
        pub(crate) destination_prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) vpc_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) egress_only_internet_gateway_id: std::option::Option<std::string::String>,
        pub(crate) gateway_id: std::option::Option<std::string::String>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) local_target: std::option::Option<bool>,
        pub(crate) nat_gateway_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_id: std::option::Option<std::string::String>,
        pub(crate) local_gateway_id: std::option::Option<std::string::String>,
        pub(crate) carrier_gateway_id: std::option::Option<std::string::String>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
        pub(crate) vpc_peering_connection_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The IPv4 CIDR address block used for the destination match. The value that you
        /// provide must match the CIDR of an existing route in the table.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The IPv6 CIDR address block used for the destination match. The value that you
        /// provide must match the CIDR of an existing route in the table.</p>
        pub fn destination_ipv6_cidr_block(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.destination_ipv6_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_ipv6_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_ipv6_cidr_block = input;
            self
        }
        /// <p>The ID of the prefix list for the route.</p>
        pub fn destination_prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_prefix_list_id = Some(input.into());
            self
        }
        pub fn set_destination_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_prefix_list_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of a VPC endpoint. Supported for Gateway Load Balancer endpoints only.</p>
        pub fn vpc_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_endpoint_id = Some(input.into());
            self
        }
        pub fn set_vpc_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_endpoint_id = input;
            self
        }
        /// <p>[IPv6 traffic only] The ID of an egress-only internet gateway.</p>
        pub fn egress_only_internet_gateway_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.egress_only_internet_gateway_id = Some(input.into());
            self
        }
        pub fn set_egress_only_internet_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.egress_only_internet_gateway_id = input;
            self
        }
        /// <p>The ID of an internet gateway or virtual private gateway.</p>
        pub fn gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.gateway_id = Some(input.into());
            self
        }
        pub fn set_gateway_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.gateway_id = input;
            self
        }
        /// <p>The ID of a NAT instance in your VPC.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>Specifies whether to reset the local route to its default target (<code>local</code>).</p>
        pub fn local_target(mut self, input: bool) -> Self {
            self.local_target = Some(input);
            self
        }
        pub fn set_local_target(mut self, input: std::option::Option<bool>) -> Self {
            self.local_target = input;
            self
        }
        /// <p>[IPv4 traffic only] The ID of a NAT gateway.</p>
        pub fn nat_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.nat_gateway_id = Some(input.into());
            self
        }
        pub fn set_nat_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.nat_gateway_id = input;
            self
        }
        /// <p>The ID of a transit gateway.</p>
        pub fn transit_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.transit_gateway_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_id = input;
            self
        }
        /// <p>The ID of the local gateway.</p>
        pub fn local_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.local_gateway_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_id = input;
            self
        }
        /// <p>[IPv4 traffic only] The ID of a carrier gateway.</p>
        pub fn carrier_gateway_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.carrier_gateway_id = Some(input.into());
            self
        }
        pub fn set_carrier_gateway_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.carrier_gateway_id = input;
            self
        }
        /// <p>The ID of a network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>The ID of the route table.</p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// <p>The ID of a VPC peering connection.</p>
        pub fn vpc_peering_connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.vpc_peering_connection_id = Some(input.into());
            self
        }
        pub fn set_vpc_peering_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vpc_peering_connection_id = input;
            self
        }
        /// Consumes the builder and constructs a [`ReplaceRouteInput`](crate::input::ReplaceRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::ReplaceRouteInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::ReplaceRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                destination_ipv6_cidr_block: self.destination_ipv6_cidr_block,
                destination_prefix_list_id: self.destination_prefix_list_id,
                dry_run: self.dry_run,
                vpc_endpoint_id: self.vpc_endpoint_id,
                egress_only_internet_gateway_id: self.egress_only_internet_gateway_id,
                gateway_id: self.gateway_id,
                instance_id: self.instance_id,
                local_target: self.local_target,
                nat_gateway_id: self.nat_gateway_id,
                transit_gateway_id: self.transit_gateway_id,
                local_gateway_id: self.local_gateway_id,
                carrier_gateway_id: self.carrier_gateway_id,
                network_interface_id: self.network_interface_id,
                route_table_id: self.route_table_id,
                vpc_peering_connection_id: self.vpc_peering_connection_id,
            })
        }
    }
}
#[doc(hidden)]
pub type ReplaceRouteInputOperationOutputAlias = crate::operation::ReplaceRoute;
#[doc(hidden)]
pub type ReplaceRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReplaceRouteInput {
    /// Consumes the builder and constructs an Operation<[`ReplaceRoute`](crate::operation::ReplaceRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReplaceRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_replace_route(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReplaceRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("ReplaceRoute", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReplaceRouteInput`](crate::input::ReplaceRouteInput)
    pub fn builder() -> crate::input::replace_route_input::Builder {
        crate::input::replace_route_input::Builder::default()
    }
}

/// See [`ReplaceRouteTableAssociationInput`](crate::input::ReplaceRouteTableAssociationInput)
pub mod replace_route_table_association_input {
    /// A builder for [`ReplaceRouteTableAssociationInput`](crate::input::ReplaceRouteTableAssociationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) association_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) route_table_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The association ID.</p>
        pub fn association_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.association_id = Some(input.into());
            self
        }
        pub fn set_association_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.association_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the new route table to associate with the subnet.</p>
        pub fn route_table_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.route_table_id = Some(input.into());
            self
        }
        pub fn set_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.route_table_id = input;
            self
        }
        /// Consumes the builder and constructs a [`ReplaceRouteTableAssociationInput`](crate::input::ReplaceRouteTableAssociationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ReplaceRouteTableAssociationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ReplaceRouteTableAssociationInput {
                association_id: self.association_id,
                dry_run: self.dry_run,
                route_table_id: self.route_table_id,
            })
        }
    }
}
#[doc(hidden)]
pub type ReplaceRouteTableAssociationInputOperationOutputAlias =
    crate::operation::ReplaceRouteTableAssociation;
#[doc(hidden)]
pub type ReplaceRouteTableAssociationInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReplaceRouteTableAssociationInput {
    /// Consumes the builder and constructs an Operation<[`ReplaceRouteTableAssociation`](crate::operation::ReplaceRouteTableAssociation)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReplaceRouteTableAssociation,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_replace_route_table_association(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReplaceRouteTableAssociation::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ReplaceRouteTableAssociation",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReplaceRouteTableAssociationInput`](crate::input::ReplaceRouteTableAssociationInput)
    pub fn builder() -> crate::input::replace_route_table_association_input::Builder {
        crate::input::replace_route_table_association_input::Builder::default()
    }
}

/// See [`ReplaceTransitGatewayRouteInput`](crate::input::ReplaceTransitGatewayRouteInput)
pub mod replace_transit_gateway_route_input {
    /// A builder for [`ReplaceTransitGatewayRouteInput`](crate::input::ReplaceTransitGatewayRouteInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) destination_cidr_block: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) transit_gateway_attachment_id: std::option::Option<std::string::String>,
        pub(crate) blackhole: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The CIDR range used for the destination match. Routing decisions are based on the most specific match.</p>
        pub fn destination_cidr_block(mut self, input: impl Into<std::string::String>) -> Self {
            self.destination_cidr_block = Some(input.into());
            self
        }
        pub fn set_destination_cidr_block(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.destination_cidr_block = input;
            self
        }
        /// <p>The ID of the route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        /// <p>The ID of the attachment.</p>
        pub fn transit_gateway_attachment_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_attachment_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_attachment_id = input;
            self
        }
        /// <p>Indicates whether traffic matching this route is to be dropped.</p>
        pub fn blackhole(mut self, input: bool) -> Self {
            self.blackhole = Some(input);
            self
        }
        pub fn set_blackhole(mut self, input: std::option::Option<bool>) -> Self {
            self.blackhole = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ReplaceTransitGatewayRouteInput`](crate::input::ReplaceTransitGatewayRouteInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ReplaceTransitGatewayRouteInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ReplaceTransitGatewayRouteInput {
                destination_cidr_block: self.destination_cidr_block,
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                transit_gateway_attachment_id: self.transit_gateway_attachment_id,
                blackhole: self.blackhole,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ReplaceTransitGatewayRouteInputOperationOutputAlias =
    crate::operation::ReplaceTransitGatewayRoute;
#[doc(hidden)]
pub type ReplaceTransitGatewayRouteInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReplaceTransitGatewayRouteInput {
    /// Consumes the builder and constructs an Operation<[`ReplaceTransitGatewayRoute`](crate::operation::ReplaceTransitGatewayRoute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReplaceTransitGatewayRoute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_replace_transit_gateway_route(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReplaceTransitGatewayRoute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ReplaceTransitGatewayRoute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReplaceTransitGatewayRouteInput`](crate::input::ReplaceTransitGatewayRouteInput)
    pub fn builder() -> crate::input::replace_transit_gateway_route_input::Builder {
        crate::input::replace_transit_gateway_route_input::Builder::default()
    }
}

/// See [`ReportInstanceStatusInput`](crate::input::ReportInstanceStatusInput)
pub mod report_instance_status_input {
    /// A builder for [`ReportInstanceStatusInput`](crate::input::ReportInstanceStatusInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) description: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) end_time: std::option::Option<smithy_types::Instant>,
        pub(crate) instances: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) reason_codes:
            std::option::Option<std::vec::Vec<crate::model::ReportInstanceReasonCodes>>,
        pub(crate) start_time: std::option::Option<smithy_types::Instant>,
        pub(crate) status: std::option::Option<crate::model::ReportStatusType>,
    }
    impl Builder {
        /// <p>Descriptive text about the health state of your instance.</p>
        pub fn description(mut self, input: impl Into<std::string::String>) -> Self {
            self.description = Some(input.into());
            self
        }
        pub fn set_description(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.description = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The time at which the reported instance health state ended.</p>
        pub fn end_time(mut self, input: smithy_types::Instant) -> Self {
            self.end_time = Some(input);
            self
        }
        pub fn set_end_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.end_time = input;
            self
        }
        pub fn instances(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instances.unwrap_or_default();
            v.push(input.into());
            self.instances = Some(v);
            self
        }
        pub fn set_instances(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instances = input;
            self
        }
        pub fn reason_codes(
            mut self,
            input: impl Into<crate::model::ReportInstanceReasonCodes>,
        ) -> Self {
            let mut v = self.reason_codes.unwrap_or_default();
            v.push(input.into());
            self.reason_codes = Some(v);
            self
        }
        pub fn set_reason_codes(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ReportInstanceReasonCodes>>,
        ) -> Self {
            self.reason_codes = input;
            self
        }
        /// <p>The time at which the reported instance health state began.</p>
        pub fn start_time(mut self, input: smithy_types::Instant) -> Self {
            self.start_time = Some(input);
            self
        }
        pub fn set_start_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.start_time = input;
            self
        }
        /// <p>The status of all instances listed.</p>
        pub fn status(mut self, input: crate::model::ReportStatusType) -> Self {
            self.status = Some(input);
            self
        }
        pub fn set_status(
            mut self,
            input: std::option::Option<crate::model::ReportStatusType>,
        ) -> Self {
            self.status = input;
            self
        }
        /// Consumes the builder and constructs a [`ReportInstanceStatusInput`](crate::input::ReportInstanceStatusInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ReportInstanceStatusInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ReportInstanceStatusInput {
                description: self.description,
                dry_run: self.dry_run,
                end_time: self.end_time,
                instances: self.instances,
                reason_codes: self.reason_codes,
                start_time: self.start_time,
                status: self.status,
            })
        }
    }
}
#[doc(hidden)]
pub type ReportInstanceStatusInputOperationOutputAlias = crate::operation::ReportInstanceStatus;
#[doc(hidden)]
pub type ReportInstanceStatusInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ReportInstanceStatusInput {
    /// Consumes the builder and constructs an Operation<[`ReportInstanceStatus`](crate::operation::ReportInstanceStatus)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ReportInstanceStatus,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_report_instance_status(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ReportInstanceStatus::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ReportInstanceStatus",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ReportInstanceStatusInput`](crate::input::ReportInstanceStatusInput)
    pub fn builder() -> crate::input::report_instance_status_input::Builder {
        crate::input::report_instance_status_input::Builder::default()
    }
}

/// See [`RequestSpotFleetInput`](crate::input::RequestSpotFleetInput)
pub mod request_spot_fleet_input {
    /// A builder for [`RequestSpotFleetInput`](crate::input::RequestSpotFleetInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) spot_fleet_request_config:
            std::option::Option<crate::model::SpotFleetRequestConfigData>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The configuration for the Spot Fleet request.</p>
        pub fn spot_fleet_request_config(
            mut self,
            input: crate::model::SpotFleetRequestConfigData,
        ) -> Self {
            self.spot_fleet_request_config = Some(input);
            self
        }
        pub fn set_spot_fleet_request_config(
            mut self,
            input: std::option::Option<crate::model::SpotFleetRequestConfigData>,
        ) -> Self {
            self.spot_fleet_request_config = input;
            self
        }
        /// Consumes the builder and constructs a [`RequestSpotFleetInput`](crate::input::RequestSpotFleetInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RequestSpotFleetInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RequestSpotFleetInput {
                dry_run: self.dry_run,
                spot_fleet_request_config: self.spot_fleet_request_config,
            })
        }
    }
}
#[doc(hidden)]
pub type RequestSpotFleetInputOperationOutputAlias = crate::operation::RequestSpotFleet;
#[doc(hidden)]
pub type RequestSpotFleetInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RequestSpotFleetInput {
    /// Consumes the builder and constructs an Operation<[`RequestSpotFleet`](crate::operation::RequestSpotFleet)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RequestSpotFleet,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_request_spot_fleet(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RequestSpotFleet::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RequestSpotFleet",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RequestSpotFleetInput`](crate::input::RequestSpotFleetInput)
    pub fn builder() -> crate::input::request_spot_fleet_input::Builder {
        crate::input::request_spot_fleet_input::Builder::default()
    }
}

/// See [`RequestSpotInstancesInput`](crate::input::RequestSpotInstancesInput)
pub mod request_spot_instances_input {
    /// A builder for [`RequestSpotInstancesInput`](crate::input::RequestSpotInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) availability_zone_group: std::option::Option<std::string::String>,
        pub(crate) block_duration_minutes: std::option::Option<i32>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_count: std::option::Option<i32>,
        pub(crate) launch_group: std::option::Option<std::string::String>,
        pub(crate) launch_specification:
            std::option::Option<crate::model::RequestSpotLaunchSpecification>,
        pub(crate) spot_price: std::option::Option<std::string::String>,
        pub(crate) r#type: std::option::Option<crate::model::SpotInstanceType>,
        pub(crate) valid_from: std::option::Option<smithy_types::Instant>,
        pub(crate) valid_until: std::option::Option<smithy_types::Instant>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) instance_interruption_behavior:
            std::option::Option<crate::model::InstanceInterruptionBehavior>,
    }
    impl Builder {
        /// <p>The user-specified name for a logical grouping of requests.</p>
        /// <p>When you specify an Availability Zone group in a Spot Instance request, all Spot
        /// Instances in the request are launched in the same Availability Zone. Instance proximity
        /// is maintained with this parameter, but the choice of Availability Zone is not. The group
        /// applies only to requests for Spot Instances of the same instance type. Any additional
        /// Spot Instance requests that are specified with the same Availability Zone group name are
        /// launched in that same Availability Zone, as long as at least one instance from the group
        /// is still active.</p>
        /// <p>If there is no active instance running in the Availability Zone group that you specify
        /// for a new Spot Instance request (all instances are terminated, the request is expired,
        /// or the maximum price you specified falls below current Spot price), then Amazon EC2 launches
        /// the instance in any Availability Zone where the constraint can be met. Consequently, the
        /// subsequent set of Spot Instances could be placed in a different zone from the original
        /// request, even if you specified the same Availability Zone group.</p>
        /// <p>Default: Instances are launched in any available Availability Zone.</p>
        pub fn availability_zone_group(mut self, input: impl Into<std::string::String>) -> Self {
            self.availability_zone_group = Some(input.into());
            self
        }
        pub fn set_availability_zone_group(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.availability_zone_group = input;
            self
        }
        /// <p>Deprecated.</p>
        pub fn block_duration_minutes(mut self, input: i32) -> Self {
            self.block_duration_minutes = Some(input);
            self
        }
        pub fn set_block_duration_minutes(mut self, input: std::option::Option<i32>) -> Self {
            self.block_duration_minutes = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
        /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
        /// Idempotency</a> in the <i>Amazon EC2 User Guide for Linux Instances</i>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually
        /// making the request, and provides an error response. If you have the required
        /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
        /// <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The maximum number of Spot Instances to launch.</p>
        /// <p>Default: 1</p>
        pub fn instance_count(mut self, input: i32) -> Self {
            self.instance_count = Some(input);
            self
        }
        pub fn set_instance_count(mut self, input: std::option::Option<i32>) -> Self {
            self.instance_count = input;
            self
        }
        /// <p>The instance launch group. Launch groups are Spot Instances that launch together and
        /// terminate together.</p>
        /// <p>Default: Instances are launched and terminated individually</p>
        pub fn launch_group(mut self, input: impl Into<std::string::String>) -> Self {
            self.launch_group = Some(input.into());
            self
        }
        pub fn set_launch_group(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.launch_group = input;
            self
        }
        /// <p>The launch specification.</p>
        pub fn launch_specification(
            mut self,
            input: crate::model::RequestSpotLaunchSpecification,
        ) -> Self {
            self.launch_specification = Some(input);
            self
        }
        pub fn set_launch_specification(
            mut self,
            input: std::option::Option<crate::model::RequestSpotLaunchSpecification>,
        ) -> Self {
            self.launch_specification = input;
            self
        }
        /// <p>The maximum price per hour that you are willing to pay for a Spot Instance. The
        /// default is the On-Demand price.</p>
        pub fn spot_price(mut self, input: impl Into<std::string::String>) -> Self {
            self.spot_price = Some(input.into());
            self
        }
        pub fn set_spot_price(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.spot_price = input;
            self
        }
        /// <p>The Spot Instance request type.</p>
        /// <p>Default: <code>one-time</code>
        /// </p>
        pub fn r#type(mut self, input: crate::model::SpotInstanceType) -> Self {
            self.r#type = Some(input);
            self
        }
        pub fn set_type(
            mut self,
            input: std::option::Option<crate::model::SpotInstanceType>,
        ) -> Self {
            self.r#type = input;
            self
        }
        /// <p>The start date of the request. If this is a one-time request, the request becomes
        /// active at this date and time and remains active until all instances launch, the request
        /// expires, or the request is canceled. If the request is persistent, the request becomes
        /// active at this date and time and remains active until it expires or is canceled.</p>
        /// <p>The specified start date and time cannot be equal to the current date and time. You
        /// must specify a start date and time that occurs after the current date and time.</p>
        pub fn valid_from(mut self, input: smithy_types::Instant) -> Self {
            self.valid_from = Some(input);
            self
        }
        pub fn set_valid_from(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.valid_from = input;
            self
        }
        /// <p>The end date of the request, in UTC format
        /// (<i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
        /// <ul>
        /// <li>
        /// <p>For a persistent request, the request remains active until the
        /// <code>ValidUntil</code> date and time is reached. Otherwise, the request
        /// remains active until you cancel it. </p>
        /// </li>
        /// <li>
        /// <p>For a one-time request, the request remains active until all instances launch,
        /// the request is canceled, or the <code>ValidUntil</code> date and time is
        /// reached. By default, the request is valid for 7 days from the date the request
        /// was created.</p>
        /// </li>
        /// </ul>
        pub fn valid_until(mut self, input: smithy_types::Instant) -> Self {
            self.valid_until = Some(input);
            self
        }
        pub fn set_valid_until(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.valid_until = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>The behavior when a Spot Instance is interrupted. The default is <code>terminate</code>.</p>
        pub fn instance_interruption_behavior(
            mut self,
            input: crate::model::InstanceInterruptionBehavior,
        ) -> Self {
            self.instance_interruption_behavior = Some(input);
            self
        }
        pub fn set_instance_interruption_behavior(
            mut self,
            input: std::option::Option<crate::model::InstanceInterruptionBehavior>,
        ) -> Self {
            self.instance_interruption_behavior = input;
            self
        }
        /// Consumes the builder and constructs a [`RequestSpotInstancesInput`](crate::input::RequestSpotInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RequestSpotInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RequestSpotInstancesInput {
                availability_zone_group: self.availability_zone_group,
                block_duration_minutes: self.block_duration_minutes,
                client_token: self.client_token,
                dry_run: self.dry_run,
                instance_count: self.instance_count,
                launch_group: self.launch_group,
                launch_specification: self.launch_specification,
                spot_price: self.spot_price,
                r#type: self.r#type,
                valid_from: self.valid_from,
                valid_until: self.valid_until,
                tag_specifications: self.tag_specifications,
                instance_interruption_behavior: self.instance_interruption_behavior,
            })
        }
    }
}
#[doc(hidden)]
pub type RequestSpotInstancesInputOperationOutputAlias = crate::operation::RequestSpotInstances;
#[doc(hidden)]
pub type RequestSpotInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RequestSpotInstancesInput {
    /// Consumes the builder and constructs an Operation<[`RequestSpotInstances`](crate::operation::RequestSpotInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RequestSpotInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_request_spot_instances(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RequestSpotInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RequestSpotInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RequestSpotInstancesInput`](crate::input::RequestSpotInstancesInput)
    pub fn builder() -> crate::input::request_spot_instances_input::Builder {
        crate::input::request_spot_instances_input::Builder::default()
    }
}

/// See [`ResetAddressAttributeInput`](crate::input::ResetAddressAttributeInput)
pub mod reset_address_attribute_input {
    /// A builder for [`ResetAddressAttributeInput`](crate::input::ResetAddressAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) allocation_id: std::option::Option<std::string::String>,
        pub(crate) attribute: std::option::Option<crate::model::AddressAttributeName>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>[EC2-VPC] The allocation ID.</p>
        pub fn allocation_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.allocation_id = Some(input.into());
            self
        }
        pub fn set_allocation_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.allocation_id = input;
            self
        }
        /// <p>The attribute of the IP address.</p>
        pub fn attribute(mut self, input: crate::model::AddressAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::AddressAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ResetAddressAttributeInput`](crate::input::ResetAddressAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ResetAddressAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ResetAddressAttributeInput {
                allocation_id: self.allocation_id,
                attribute: self.attribute,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ResetAddressAttributeInputOperationOutputAlias = crate::operation::ResetAddressAttribute;
#[doc(hidden)]
pub type ResetAddressAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ResetAddressAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ResetAddressAttribute`](crate::operation::ResetAddressAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ResetAddressAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_reset_address_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ResetAddressAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ResetAddressAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ResetAddressAttributeInput`](crate::input::ResetAddressAttributeInput)
    pub fn builder() -> crate::input::reset_address_attribute_input::Builder {
        crate::input::reset_address_attribute_input::Builder::default()
    }
}

/// See [`ResetEbsDefaultKmsKeyIdInput`](crate::input::ResetEbsDefaultKmsKeyIdInput)
pub mod reset_ebs_default_kms_key_id_input {
    /// A builder for [`ResetEbsDefaultKmsKeyIdInput`](crate::input::ResetEbsDefaultKmsKeyIdInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ResetEbsDefaultKmsKeyIdInput`](crate::input::ResetEbsDefaultKmsKeyIdInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ResetEbsDefaultKmsKeyIdInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ResetEbsDefaultKmsKeyIdInput {
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ResetEbsDefaultKmsKeyIdInputOperationOutputAlias =
    crate::operation::ResetEbsDefaultKmsKeyId;
#[doc(hidden)]
pub type ResetEbsDefaultKmsKeyIdInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ResetEbsDefaultKmsKeyIdInput {
    /// Consumes the builder and constructs an Operation<[`ResetEbsDefaultKmsKeyId`](crate::operation::ResetEbsDefaultKmsKeyId)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ResetEbsDefaultKmsKeyId,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_reset_ebs_default_kms_key_id(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ResetEbsDefaultKmsKeyId::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ResetEbsDefaultKmsKeyId",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ResetEbsDefaultKmsKeyIdInput`](crate::input::ResetEbsDefaultKmsKeyIdInput)
    pub fn builder() -> crate::input::reset_ebs_default_kms_key_id_input::Builder {
        crate::input::reset_ebs_default_kms_key_id_input::Builder::default()
    }
}

/// See [`ResetFpgaImageAttributeInput`](crate::input::ResetFpgaImageAttributeInput)
pub mod reset_fpga_image_attribute_input {
    /// A builder for [`ResetFpgaImageAttributeInput`](crate::input::ResetFpgaImageAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) fpga_image_id: std::option::Option<std::string::String>,
        pub(crate) attribute: std::option::Option<crate::model::ResetFpgaImageAttributeName>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the AFI.</p>
        pub fn fpga_image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.fpga_image_id = Some(input.into());
            self
        }
        pub fn set_fpga_image_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.fpga_image_id = input;
            self
        }
        /// <p>The attribute.</p>
        pub fn attribute(mut self, input: crate::model::ResetFpgaImageAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::ResetFpgaImageAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// Consumes the builder and constructs a [`ResetFpgaImageAttributeInput`](crate::input::ResetFpgaImageAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ResetFpgaImageAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ResetFpgaImageAttributeInput {
                dry_run: self.dry_run,
                fpga_image_id: self.fpga_image_id,
                attribute: self.attribute,
            })
        }
    }
}
#[doc(hidden)]
pub type ResetFpgaImageAttributeInputOperationOutputAlias =
    crate::operation::ResetFpgaImageAttribute;
#[doc(hidden)]
pub type ResetFpgaImageAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ResetFpgaImageAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ResetFpgaImageAttribute`](crate::operation::ResetFpgaImageAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ResetFpgaImageAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_reset_fpga_image_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ResetFpgaImageAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ResetFpgaImageAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ResetFpgaImageAttributeInput`](crate::input::ResetFpgaImageAttributeInput)
    pub fn builder() -> crate::input::reset_fpga_image_attribute_input::Builder {
        crate::input::reset_fpga_image_attribute_input::Builder::default()
    }
}

/// See [`ResetImageAttributeInput`](crate::input::ResetImageAttributeInput)
pub mod reset_image_attribute_input {
    /// A builder for [`ResetImageAttributeInput`](crate::input::ResetImageAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::ResetImageAttributeName>,
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The attribute to reset (currently you can only reset the launch permission attribute).</p>
        pub fn attribute(mut self, input: crate::model::ResetImageAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::ResetImageAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The ID of the AMI.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ResetImageAttributeInput`](crate::input::ResetImageAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ResetImageAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ResetImageAttributeInput {
                attribute: self.attribute,
                image_id: self.image_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ResetImageAttributeInputOperationOutputAlias = crate::operation::ResetImageAttribute;
#[doc(hidden)]
pub type ResetImageAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ResetImageAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ResetImageAttribute`](crate::operation::ResetImageAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ResetImageAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_reset_image_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ResetImageAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ResetImageAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ResetImageAttributeInput`](crate::input::ResetImageAttributeInput)
    pub fn builder() -> crate::input::reset_image_attribute_input::Builder {
        crate::input::reset_image_attribute_input::Builder::default()
    }
}

/// See [`ResetInstanceAttributeInput`](crate::input::ResetInstanceAttributeInput)
pub mod reset_instance_attribute_input {
    /// A builder for [`ResetInstanceAttributeInput`](crate::input::ResetInstanceAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::InstanceAttributeName>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The attribute to reset.</p>
        /// <important>
        /// <p>You can only reset the following attributes: <code>kernel</code> |
        /// <code>ramdisk</code> | <code>sourceDestCheck</code>. To change an instance
        /// attribute, use <a>ModifyInstanceAttribute</a>.</p>
        /// </important>
        pub fn attribute(mut self, input: crate::model::InstanceAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::InstanceAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// Consumes the builder and constructs a [`ResetInstanceAttributeInput`](crate::input::ResetInstanceAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ResetInstanceAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ResetInstanceAttributeInput {
                attribute: self.attribute,
                dry_run: self.dry_run,
                instance_id: self.instance_id,
            })
        }
    }
}
#[doc(hidden)]
pub type ResetInstanceAttributeInputOperationOutputAlias = crate::operation::ResetInstanceAttribute;
#[doc(hidden)]
pub type ResetInstanceAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ResetInstanceAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ResetInstanceAttribute`](crate::operation::ResetInstanceAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ResetInstanceAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_reset_instance_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ResetInstanceAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ResetInstanceAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ResetInstanceAttributeInput`](crate::input::ResetInstanceAttributeInput)
    pub fn builder() -> crate::input::reset_instance_attribute_input::Builder {
        crate::input::reset_instance_attribute_input::Builder::default()
    }
}

/// See [`ResetNetworkInterfaceAttributeInput`](crate::input::ResetNetworkInterfaceAttributeInput)
pub mod reset_network_interface_attribute_input {
    /// A builder for [`ResetNetworkInterfaceAttributeInput`](crate::input::ResetNetworkInterfaceAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) source_dest_check: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        /// <p>The source/destination checking attribute. Resets the value to <code>true</code>.</p>
        pub fn source_dest_check(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_dest_check = Some(input.into());
            self
        }
        pub fn set_source_dest_check(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_dest_check = input;
            self
        }
        /// Consumes the builder and constructs a [`ResetNetworkInterfaceAttributeInput`](crate::input::ResetNetworkInterfaceAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ResetNetworkInterfaceAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ResetNetworkInterfaceAttributeInput {
                dry_run: self.dry_run,
                network_interface_id: self.network_interface_id,
                source_dest_check: self.source_dest_check,
            })
        }
    }
}
#[doc(hidden)]
pub type ResetNetworkInterfaceAttributeInputOperationOutputAlias =
    crate::operation::ResetNetworkInterfaceAttribute;
#[doc(hidden)]
pub type ResetNetworkInterfaceAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ResetNetworkInterfaceAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ResetNetworkInterfaceAttribute`](crate::operation::ResetNetworkInterfaceAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ResetNetworkInterfaceAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_reset_network_interface_attribute(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ResetNetworkInterfaceAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ResetNetworkInterfaceAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ResetNetworkInterfaceAttributeInput`](crate::input::ResetNetworkInterfaceAttributeInput)
    pub fn builder() -> crate::input::reset_network_interface_attribute_input::Builder {
        crate::input::reset_network_interface_attribute_input::Builder::default()
    }
}

/// See [`ResetSnapshotAttributeInput`](crate::input::ResetSnapshotAttributeInput)
pub mod reset_snapshot_attribute_input {
    /// A builder for [`ResetSnapshotAttributeInput`](crate::input::ResetSnapshotAttributeInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) attribute: std::option::Option<crate::model::SnapshotAttributeName>,
        pub(crate) snapshot_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The attribute to reset. Currently, only the attribute for permission to create volumes can
        /// be reset.</p>
        pub fn attribute(mut self, input: crate::model::SnapshotAttributeName) -> Self {
            self.attribute = Some(input);
            self
        }
        pub fn set_attribute(
            mut self,
            input: std::option::Option<crate::model::SnapshotAttributeName>,
        ) -> Self {
            self.attribute = input;
            self
        }
        /// <p>The ID of the snapshot.</p>
        pub fn snapshot_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.snapshot_id = Some(input.into());
            self
        }
        pub fn set_snapshot_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.snapshot_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`ResetSnapshotAttributeInput`](crate::input::ResetSnapshotAttributeInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::ResetSnapshotAttributeInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::ResetSnapshotAttributeInput {
                attribute: self.attribute,
                snapshot_id: self.snapshot_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type ResetSnapshotAttributeInputOperationOutputAlias = crate::operation::ResetSnapshotAttribute;
#[doc(hidden)]
pub type ResetSnapshotAttributeInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl ResetSnapshotAttributeInput {
    /// Consumes the builder and constructs an Operation<[`ResetSnapshotAttribute`](crate::operation::ResetSnapshotAttribute)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::ResetSnapshotAttribute,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_reset_snapshot_attribute(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::ResetSnapshotAttribute::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "ResetSnapshotAttribute",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`ResetSnapshotAttributeInput`](crate::input::ResetSnapshotAttributeInput)
    pub fn builder() -> crate::input::reset_snapshot_attribute_input::Builder {
        crate::input::reset_snapshot_attribute_input::Builder::default()
    }
}

/// See [`RestoreAddressToClassicInput`](crate::input::RestoreAddressToClassicInput)
pub mod restore_address_to_classic_input {
    /// A builder for [`RestoreAddressToClassicInput`](crate::input::RestoreAddressToClassicInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) public_ip: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The Elastic IP address.</p>
        pub fn public_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.public_ip = Some(input.into());
            self
        }
        pub fn set_public_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.public_ip = input;
            self
        }
        /// Consumes the builder and constructs a [`RestoreAddressToClassicInput`](crate::input::RestoreAddressToClassicInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RestoreAddressToClassicInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RestoreAddressToClassicInput {
                dry_run: self.dry_run,
                public_ip: self.public_ip,
            })
        }
    }
}
#[doc(hidden)]
pub type RestoreAddressToClassicInputOperationOutputAlias =
    crate::operation::RestoreAddressToClassic;
#[doc(hidden)]
pub type RestoreAddressToClassicInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RestoreAddressToClassicInput {
    /// Consumes the builder and constructs an Operation<[`RestoreAddressToClassic`](crate::operation::RestoreAddressToClassic)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RestoreAddressToClassic,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_restore_address_to_classic(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RestoreAddressToClassic::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RestoreAddressToClassic",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RestoreAddressToClassicInput`](crate::input::RestoreAddressToClassicInput)
    pub fn builder() -> crate::input::restore_address_to_classic_input::Builder {
        crate::input::restore_address_to_classic_input::Builder::default()
    }
}

/// See [`RestoreManagedPrefixListVersionInput`](crate::input::RestoreManagedPrefixListVersionInput)
pub mod restore_managed_prefix_list_version_input {
    /// A builder for [`RestoreManagedPrefixListVersionInput`](crate::input::RestoreManagedPrefixListVersionInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) prefix_list_id: std::option::Option<std::string::String>,
        pub(crate) previous_version: std::option::Option<i64>,
        pub(crate) current_version: std::option::Option<i64>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the prefix list.</p>
        pub fn prefix_list_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.prefix_list_id = Some(input.into());
            self
        }
        pub fn set_prefix_list_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.prefix_list_id = input;
            self
        }
        /// <p>The version to restore.</p>
        pub fn previous_version(mut self, input: i64) -> Self {
            self.previous_version = Some(input);
            self
        }
        pub fn set_previous_version(mut self, input: std::option::Option<i64>) -> Self {
            self.previous_version = input;
            self
        }
        /// <p>The current version number for the prefix list.</p>
        pub fn current_version(mut self, input: i64) -> Self {
            self.current_version = Some(input);
            self
        }
        pub fn set_current_version(mut self, input: std::option::Option<i64>) -> Self {
            self.current_version = input;
            self
        }
        /// Consumes the builder and constructs a [`RestoreManagedPrefixListVersionInput`](crate::input::RestoreManagedPrefixListVersionInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RestoreManagedPrefixListVersionInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RestoreManagedPrefixListVersionInput {
                dry_run: self.dry_run,
                prefix_list_id: self.prefix_list_id,
                previous_version: self.previous_version,
                current_version: self.current_version,
            })
        }
    }
}
#[doc(hidden)]
pub type RestoreManagedPrefixListVersionInputOperationOutputAlias =
    crate::operation::RestoreManagedPrefixListVersion;
#[doc(hidden)]
pub type RestoreManagedPrefixListVersionInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RestoreManagedPrefixListVersionInput {
    /// Consumes the builder and constructs an Operation<[`RestoreManagedPrefixListVersion`](crate::operation::RestoreManagedPrefixListVersion)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RestoreManagedPrefixListVersion,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_restore_managed_prefix_list_version(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RestoreManagedPrefixListVersion::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RestoreManagedPrefixListVersion",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RestoreManagedPrefixListVersionInput`](crate::input::RestoreManagedPrefixListVersionInput)
    pub fn builder() -> crate::input::restore_managed_prefix_list_version_input::Builder {
        crate::input::restore_managed_prefix_list_version_input::Builder::default()
    }
}

/// See [`RevokeClientVpnIngressInput`](crate::input::RevokeClientVpnIngressInput)
pub mod revoke_client_vpn_ingress_input {
    /// A builder for [`RevokeClientVpnIngressInput`](crate::input::RevokeClientVpnIngressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) target_network_cidr: std::option::Option<std::string::String>,
        pub(crate) access_group_id: std::option::Option<std::string::String>,
        pub(crate) revoke_all_groups: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint with which the authorization rule is associated.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The IPv4 address range, in CIDR notation, of the network for which access is being removed.</p>
        pub fn target_network_cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.target_network_cidr = Some(input.into());
            self
        }
        pub fn set_target_network_cidr(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.target_network_cidr = input;
            self
        }
        /// <p>The ID of the Active Directory group for which to revoke access. </p>
        pub fn access_group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.access_group_id = Some(input.into());
            self
        }
        pub fn set_access_group_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.access_group_id = input;
            self
        }
        /// <p>Indicates whether access should be revoked for all clients.</p>
        pub fn revoke_all_groups(mut self, input: bool) -> Self {
            self.revoke_all_groups = Some(input);
            self
        }
        pub fn set_revoke_all_groups(mut self, input: std::option::Option<bool>) -> Self {
            self.revoke_all_groups = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RevokeClientVpnIngressInput`](crate::input::RevokeClientVpnIngressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RevokeClientVpnIngressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RevokeClientVpnIngressInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                target_network_cidr: self.target_network_cidr,
                access_group_id: self.access_group_id,
                revoke_all_groups: self.revoke_all_groups,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type RevokeClientVpnIngressInputOperationOutputAlias = crate::operation::RevokeClientVpnIngress;
#[doc(hidden)]
pub type RevokeClientVpnIngressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RevokeClientVpnIngressInput {
    /// Consumes the builder and constructs an Operation<[`RevokeClientVpnIngress`](crate::operation::RevokeClientVpnIngress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RevokeClientVpnIngress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_revoke_client_vpn_ingress(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RevokeClientVpnIngress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RevokeClientVpnIngress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RevokeClientVpnIngressInput`](crate::input::RevokeClientVpnIngressInput)
    pub fn builder() -> crate::input::revoke_client_vpn_ingress_input::Builder {
        crate::input::revoke_client_vpn_ingress_input::Builder::default()
    }
}

/// See [`RevokeSecurityGroupEgressInput`](crate::input::RevokeSecurityGroupEgressInput)
pub mod revoke_security_group_egress_input {
    /// A builder for [`RevokeSecurityGroupEgressInput`](crate::input::RevokeSecurityGroupEgressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_id: std::option::Option<std::string::String>,
        pub(crate) ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        pub(crate) cidr_ip: std::option::Option<std::string::String>,
        pub(crate) from_port: std::option::Option<i32>,
        pub(crate) ip_protocol: std::option::Option<std::string::String>,
        pub(crate) to_port: std::option::Option<i32>,
        pub(crate) source_security_group_name: std::option::Option<std::string::String>,
        pub(crate) source_security_group_owner_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the security group.</p>
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_id = Some(input.into());
            self
        }
        pub fn set_group_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_id = input;
            self
        }
        pub fn ip_permissions(mut self, input: impl Into<crate::model::IpPermission>) -> Self {
            let mut v = self.ip_permissions.unwrap_or_default();
            v.push(input.into());
            self.ip_permissions = Some(v);
            self
        }
        pub fn set_ip_permissions(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        ) -> Self {
            self.ip_permissions = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the CIDR.</p>
        pub fn cidr_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_ip = Some(input.into());
            self
        }
        pub fn set_cidr_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_ip = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
        pub fn from_port(mut self, input: i32) -> Self {
            self.from_port = Some(input);
            self
        }
        pub fn set_from_port(mut self, input: std::option::Option<i32>) -> Self {
            self.from_port = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the protocol name or
        /// number.</p>
        pub fn ip_protocol(mut self, input: impl Into<std::string::String>) -> Self {
            self.ip_protocol = Some(input.into());
            self
        }
        pub fn set_ip_protocol(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ip_protocol = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
        pub fn to_port(mut self, input: i32) -> Self {
            self.to_port = Some(input);
            self
        }
        pub fn set_to_port(mut self, input: std::option::Option<i32>) -> Self {
            self.to_port = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify a
        /// destination security group.</p>
        pub fn source_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_security_group_name = Some(input.into());
            self
        }
        pub fn set_source_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_name = input;
            self
        }
        /// <p>Not supported. Use a set of IP permissions to specify a destination security
        /// group.</p>
        pub fn source_security_group_owner_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = Some(input.into());
            self
        }
        pub fn set_source_security_group_owner_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = input;
            self
        }
        /// Consumes the builder and constructs a [`RevokeSecurityGroupEgressInput`](crate::input::RevokeSecurityGroupEgressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RevokeSecurityGroupEgressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RevokeSecurityGroupEgressInput {
                dry_run: self.dry_run,
                group_id: self.group_id,
                ip_permissions: self.ip_permissions,
                cidr_ip: self.cidr_ip,
                from_port: self.from_port,
                ip_protocol: self.ip_protocol,
                to_port: self.to_port,
                source_security_group_name: self.source_security_group_name,
                source_security_group_owner_id: self.source_security_group_owner_id,
            })
        }
    }
}
#[doc(hidden)]
pub type RevokeSecurityGroupEgressInputOperationOutputAlias =
    crate::operation::RevokeSecurityGroupEgress;
#[doc(hidden)]
pub type RevokeSecurityGroupEgressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RevokeSecurityGroupEgressInput {
    /// Consumes the builder and constructs an Operation<[`RevokeSecurityGroupEgress`](crate::operation::RevokeSecurityGroupEgress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RevokeSecurityGroupEgress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_revoke_security_group_egress(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RevokeSecurityGroupEgress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RevokeSecurityGroupEgress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RevokeSecurityGroupEgressInput`](crate::input::RevokeSecurityGroupEgressInput)
    pub fn builder() -> crate::input::revoke_security_group_egress_input::Builder {
        crate::input::revoke_security_group_egress_input::Builder::default()
    }
}

/// See [`RevokeSecurityGroupIngressInput`](crate::input::RevokeSecurityGroupIngressInput)
pub mod revoke_security_group_ingress_input {
    /// A builder for [`RevokeSecurityGroupIngressInput`](crate::input::RevokeSecurityGroupIngressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr_ip: std::option::Option<std::string::String>,
        pub(crate) from_port: std::option::Option<i32>,
        pub(crate) group_id: std::option::Option<std::string::String>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        pub(crate) ip_protocol: std::option::Option<std::string::String>,
        pub(crate) source_security_group_name: std::option::Option<std::string::String>,
        pub(crate) source_security_group_owner_id: std::option::Option<std::string::String>,
        pub(crate) to_port: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The CIDR IP address range. You can't specify this parameter when specifying a source security group.</p>
        pub fn cidr_ip(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr_ip = Some(input.into());
            self
        }
        pub fn set_cidr_ip(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr_ip = input;
            self
        }
        /// <p>The start of port range for the TCP and UDP protocols, or an ICMP type number. For the ICMP type number,
        /// use <code>-1</code> to specify all ICMP types.</p>
        pub fn from_port(mut self, input: i32) -> Self {
            self.from_port = Some(input);
            self
        }
        pub fn set_from_port(mut self, input: std::option::Option<i32>) -> Self {
            self.from_port = input;
            self
        }
        /// <p>The ID of the security group. You must specify either the security group ID or the
        /// security group name in the request. For security groups in a nondefault VPC, you must
        /// specify the security group ID.</p>
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_id = Some(input.into());
            self
        }
        pub fn set_group_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_id = input;
            self
        }
        /// <p>[EC2-Classic, default VPC] The name of the security group. You must specify either the
        /// security group ID or the security group name in the request.</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        pub fn ip_permissions(mut self, input: impl Into<crate::model::IpPermission>) -> Self {
            let mut v = self.ip_permissions.unwrap_or_default();
            v.push(input.into());
            self.ip_permissions = Some(v);
            self
        }
        pub fn set_ip_permissions(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        ) -> Self {
            self.ip_permissions = input;
            self
        }
        /// <p>The IP protocol name (<code>tcp</code>, <code>udp</code>, <code>icmp</code>) or number
        /// (see <a href="http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml">Protocol Numbers</a>).
        /// Use <code>-1</code> to specify all.</p>
        pub fn ip_protocol(mut self, input: impl Into<std::string::String>) -> Self {
            self.ip_protocol = Some(input.into());
            self
        }
        pub fn set_ip_protocol(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ip_protocol = input;
            self
        }
        /// <p>[EC2-Classic, default VPC] The name of the source security group. You can't specify this parameter in combination with the following parameters: the CIDR IP address range, the start of the port range, the IP protocol, and the end of the port range. For EC2-VPC, the source security group must be in the same VPC. To revoke a specific rule for an IP protocol and port range, use a set of IP permissions instead.</p>
        pub fn source_security_group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_security_group_name = Some(input.into());
            self
        }
        pub fn set_source_security_group_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_name = input;
            self
        }
        /// <p>[EC2-Classic] The AWS account ID of the source security group, if the source security group is in a different account. You can't specify this parameter in combination with the following parameters: the CIDR IP address range, the IP protocol, the start of the port range, and the end of the port range. To revoke a specific rule for an IP protocol and port range, use a set of IP permissions instead.</p>
        pub fn source_security_group_owner_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = Some(input.into());
            self
        }
        pub fn set_source_security_group_owner_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_security_group_owner_id = input;
            self
        }
        /// <p>The end of port range for the TCP and UDP protocols, or an ICMP code number. For the ICMP code number,
        /// use <code>-1</code> to specify all ICMP codes for the ICMP type.</p>
        pub fn to_port(mut self, input: i32) -> Self {
            self.to_port = Some(input);
            self
        }
        pub fn set_to_port(mut self, input: std::option::Option<i32>) -> Self {
            self.to_port = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`RevokeSecurityGroupIngressInput`](crate::input::RevokeSecurityGroupIngressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RevokeSecurityGroupIngressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RevokeSecurityGroupIngressInput {
                cidr_ip: self.cidr_ip,
                from_port: self.from_port,
                group_id: self.group_id,
                group_name: self.group_name,
                ip_permissions: self.ip_permissions,
                ip_protocol: self.ip_protocol,
                source_security_group_name: self.source_security_group_name,
                source_security_group_owner_id: self.source_security_group_owner_id,
                to_port: self.to_port,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type RevokeSecurityGroupIngressInputOperationOutputAlias =
    crate::operation::RevokeSecurityGroupIngress;
#[doc(hidden)]
pub type RevokeSecurityGroupIngressInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RevokeSecurityGroupIngressInput {
    /// Consumes the builder and constructs an Operation<[`RevokeSecurityGroupIngress`](crate::operation::RevokeSecurityGroupIngress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RevokeSecurityGroupIngress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_revoke_security_group_ingress(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RevokeSecurityGroupIngress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RevokeSecurityGroupIngress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RevokeSecurityGroupIngressInput`](crate::input::RevokeSecurityGroupIngressInput)
    pub fn builder() -> crate::input::revoke_security_group_ingress_input::Builder {
        crate::input::revoke_security_group_ingress_input::Builder::default()
    }
}

/// See [`RunInstancesInput`](crate::input::RunInstancesInput)
pub mod run_instances_input {
    /// A builder for [`RunInstancesInput`](crate::input::RunInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) block_device_mappings:
            std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
        pub(crate) image_id: std::option::Option<std::string::String>,
        pub(crate) instance_type: std::option::Option<crate::model::InstanceType>,
        pub(crate) ipv6_address_count: std::option::Option<i32>,
        pub(crate) ipv6_addresses:
            std::option::Option<std::vec::Vec<crate::model::InstanceIpv6Address>>,
        pub(crate) kernel_id: std::option::Option<std::string::String>,
        pub(crate) key_name: std::option::Option<std::string::String>,
        pub(crate) max_count: std::option::Option<i32>,
        pub(crate) min_count: std::option::Option<i32>,
        pub(crate) monitoring: std::option::Option<crate::model::RunInstancesMonitoringEnabled>,
        pub(crate) placement: std::option::Option<crate::model::Placement>,
        pub(crate) ramdisk_id: std::option::Option<std::string::String>,
        pub(crate) security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) security_groups: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) subnet_id: std::option::Option<std::string::String>,
        pub(crate) user_data: std::option::Option<std::string::String>,
        pub(crate) additional_info: std::option::Option<std::string::String>,
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) disable_api_termination: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) ebs_optimized: std::option::Option<bool>,
        pub(crate) iam_instance_profile:
            std::option::Option<crate::model::IamInstanceProfileSpecification>,
        pub(crate) instance_initiated_shutdown_behavior:
            std::option::Option<crate::model::ShutdownBehavior>,
        pub(crate) network_interfaces:
            std::option::Option<std::vec::Vec<crate::model::InstanceNetworkInterfaceSpecification>>,
        pub(crate) private_ip_address: std::option::Option<std::string::String>,
        pub(crate) elastic_gpu_specification:
            std::option::Option<std::vec::Vec<crate::model::ElasticGpuSpecification>>,
        pub(crate) elastic_inference_accelerators:
            std::option::Option<std::vec::Vec<crate::model::ElasticInferenceAccelerator>>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) launch_template: std::option::Option<crate::model::LaunchTemplateSpecification>,
        pub(crate) instance_market_options:
            std::option::Option<crate::model::InstanceMarketOptionsRequest>,
        pub(crate) credit_specification:
            std::option::Option<crate::model::CreditSpecificationRequest>,
        pub(crate) cpu_options: std::option::Option<crate::model::CpuOptionsRequest>,
        pub(crate) capacity_reservation_specification:
            std::option::Option<crate::model::CapacityReservationSpecification>,
        pub(crate) hibernation_options:
            std::option::Option<crate::model::HibernationOptionsRequest>,
        pub(crate) license_specifications:
            std::option::Option<std::vec::Vec<crate::model::LicenseConfigurationRequest>>,
        pub(crate) metadata_options:
            std::option::Option<crate::model::InstanceMetadataOptionsRequest>,
        pub(crate) enclave_options: std::option::Option<crate::model::EnclaveOptionsRequest>,
    }
    impl Builder {
        pub fn block_device_mappings(
            mut self,
            input: impl Into<crate::model::BlockDeviceMapping>,
        ) -> Self {
            let mut v = self.block_device_mappings.unwrap_or_default();
            v.push(input.into());
            self.block_device_mappings = Some(v);
            self
        }
        pub fn set_block_device_mappings(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
        ) -> Self {
            self.block_device_mappings = input;
            self
        }
        /// <p>The ID of the AMI. An AMI ID is required to launch an instance and must be
        /// specified here or in a launch template.</p>
        pub fn image_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.image_id = Some(input.into());
            self
        }
        pub fn set_image_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.image_id = input;
            self
        }
        /// <p>The instance type. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance types</a> in the
        /// <i>Amazon EC2 User Guide</i>.</p>
        /// <p>Default: <code>m1.small</code>
        /// </p>
        pub fn instance_type(mut self, input: crate::model::InstanceType) -> Self {
            self.instance_type = Some(input);
            self
        }
        pub fn set_instance_type(
            mut self,
            input: std::option::Option<crate::model::InstanceType>,
        ) -> Self {
            self.instance_type = input;
            self
        }
        /// <p>[EC2-VPC] The number of IPv6 addresses to associate with the primary network
        /// interface. Amazon EC2 chooses the IPv6 addresses from the range of your subnet. You
        /// cannot specify this option and the option to assign specific IPv6 addresses in the same
        /// request. You can specify this option if you've specified a minimum number of instances
        /// to launch.</p>
        /// <p>You cannot specify this option and the network interfaces option in the same
        /// request.</p>
        pub fn ipv6_address_count(mut self, input: i32) -> Self {
            self.ipv6_address_count = Some(input);
            self
        }
        pub fn set_ipv6_address_count(mut self, input: std::option::Option<i32>) -> Self {
            self.ipv6_address_count = input;
            self
        }
        pub fn ipv6_addresses(
            mut self,
            input: impl Into<crate::model::InstanceIpv6Address>,
        ) -> Self {
            let mut v = self.ipv6_addresses.unwrap_or_default();
            v.push(input.into());
            self.ipv6_addresses = Some(v);
            self
        }
        pub fn set_ipv6_addresses(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::InstanceIpv6Address>>,
        ) -> Self {
            self.ipv6_addresses = input;
            self
        }
        /// <p>The ID of the kernel.</p>
        /// <important>
        /// <p>We recommend that you use PV-GRUB instead of kernels and RAM disks. For more
        /// information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html"> PV-GRUB</a> in the
        /// <i>Amazon EC2 User Guide</i>.</p>
        /// </important>
        pub fn kernel_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.kernel_id = Some(input.into());
            self
        }
        pub fn set_kernel_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.kernel_id = input;
            self
        }
        /// <p>The name of the key pair. You can create a key pair using <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateKeyPair.html">CreateKeyPair</a> or
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportKeyPair.html">ImportKeyPair</a>.</p>
        /// <important>
        /// <p>If you do not specify a key pair, you can't connect to the instance unless you
        /// choose an AMI that is configured to allow users another way to log in.</p>
        /// </important>
        pub fn key_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.key_name = Some(input.into());
            self
        }
        pub fn set_key_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.key_name = input;
            self
        }
        /// <p>The maximum number of instances to launch. If you specify more instances than Amazon
        /// EC2 can launch in the target Availability Zone, Amazon EC2 launches the largest possible
        /// number of instances above <code>MinCount</code>.</p>
        /// <p>Constraints: Between 1 and the maximum number you're allowed for the specified
        /// instance type. For more information about the default limits, and how to request an
        /// increase, see <a href="http://aws.amazon.com/ec2/faqs/#How_many_instances_can_I_run_in_Amazon_EC2">How many instances can I
        /// run in Amazon EC2</a> in the Amazon EC2 FAQ.</p>
        pub fn max_count(mut self, input: i32) -> Self {
            self.max_count = Some(input);
            self
        }
        pub fn set_max_count(mut self, input: std::option::Option<i32>) -> Self {
            self.max_count = input;
            self
        }
        /// <p>The minimum number of instances to launch. If you specify a minimum that is more
        /// instances than Amazon EC2 can launch in the target Availability Zone, Amazon EC2
        /// launches no instances.</p>
        /// <p>Constraints: Between 1 and the maximum number you're allowed for the specified
        /// instance type. For more information about the default limits, and how to request an
        /// increase, see <a href="http://aws.amazon.com/ec2/faqs/#How_many_instances_can_I_run_in_Amazon_EC2">How many instances can I
        /// run in Amazon EC2</a> in the Amazon EC2 General FAQ.</p>
        pub fn min_count(mut self, input: i32) -> Self {
            self.min_count = Some(input);
            self
        }
        pub fn set_min_count(mut self, input: std::option::Option<i32>) -> Self {
            self.min_count = input;
            self
        }
        /// <p>Specifies whether detailed monitoring is enabled for the instance.</p>
        pub fn monitoring(mut self, input: crate::model::RunInstancesMonitoringEnabled) -> Self {
            self.monitoring = Some(input);
            self
        }
        pub fn set_monitoring(
            mut self,
            input: std::option::Option<crate::model::RunInstancesMonitoringEnabled>,
        ) -> Self {
            self.monitoring = input;
            self
        }
        /// <p>The placement for the instance.</p>
        pub fn placement(mut self, input: crate::model::Placement) -> Self {
            self.placement = Some(input);
            self
        }
        pub fn set_placement(
            mut self,
            input: std::option::Option<crate::model::Placement>,
        ) -> Self {
            self.placement = input;
            self
        }
        /// <p>The ID of the RAM disk to select. Some kernels require additional drivers at launch.
        /// Check the kernel requirements for information about whether you need to specify a RAM
        /// disk. To find kernel requirements, go to the Amazon Web Services Resource Center and search for the
        /// kernel ID.</p>
        /// <important>
        /// <p>We recommend that you use PV-GRUB instead of kernels and RAM disks. For more
        /// information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html"> PV-GRUB</a> in the
        /// <i>Amazon EC2 User Guide</i>.</p>
        /// </important>
        pub fn ramdisk_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.ramdisk_id = Some(input.into());
            self
        }
        pub fn set_ramdisk_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.ramdisk_id = input;
            self
        }
        pub fn security_group_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.security_group_ids.unwrap_or_default();
            v.push(input.into());
            self.security_group_ids = Some(v);
            self
        }
        pub fn set_security_group_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.security_group_ids = input;
            self
        }
        pub fn security_groups(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.security_groups.unwrap_or_default();
            v.push(input.into());
            self.security_groups = Some(v);
            self
        }
        pub fn set_security_groups(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.security_groups = input;
            self
        }
        /// <p>[EC2-VPC] The ID of the subnet to launch the instance into.</p>
        /// <p>If you specify a network interface, you must specify any subnets as part of the network interface.</p>
        pub fn subnet_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.subnet_id = Some(input.into());
            self
        }
        pub fn set_subnet_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.subnet_id = input;
            self
        }
        /// <p>The user data to make available to the instance. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/user-data.html">Running commands
        /// on your Linux instance at launch</a> (Linux) and <a href="https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/ec2-instance-metadata.html#instancedata-add-user-data">Adding User Data</a> (Windows). If you are using a command line tool,
        /// base64-encoding is performed for you, and you can load the text from a file. Otherwise,
        /// you must provide base64-encoded text. User data is limited to 16 KB.</p>
        pub fn user_data(mut self, input: impl Into<std::string::String>) -> Self {
            self.user_data = Some(input.into());
            self
        }
        pub fn set_user_data(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.user_data = input;
            self
        }
        /// <p>Reserved.</p>
        pub fn additional_info(mut self, input: impl Into<std::string::String>) -> Self {
            self.additional_info = Some(input.into());
            self
        }
        pub fn set_additional_info(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.additional_info = input;
            self
        }
        /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
        /// request. If you do not specify a client token, a randomly generated token is used for the
        /// request to ensure idempotency.</p>
        /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
        /// Idempotency</a>.</p>
        /// <p>Constraints: Maximum 64 ASCII characters</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>If you set this parameter to <code>true</code>, you can't terminate the instance using
        /// the Amazon EC2 console, CLI, or API; otherwise, you can. To change this attribute after launch,
        /// use <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceAttribute.html">ModifyInstanceAttribute</a>.
        /// Alternatively, if you set <code>InstanceInitiatedShutdownBehavior</code> to
        /// <code>terminate</code>, you can terminate the instance by running the shutdown
        /// command from the instance.</p>
        /// <p>Default: <code>false</code>
        /// </p>
        pub fn disable_api_termination(mut self, input: bool) -> Self {
            self.disable_api_termination = Some(input);
            self
        }
        pub fn set_disable_api_termination(mut self, input: std::option::Option<bool>) -> Self {
            self.disable_api_termination = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
        /// provides dedicated throughput to Amazon EBS and an optimized configuration stack to
        /// provide optimal Amazon EBS I/O performance. This optimization isn't available with all
        /// instance types. Additional usage charges apply when using an EBS-optimized
        /// instance.</p>
        /// <p>Default: <code>false</code>
        /// </p>
        pub fn ebs_optimized(mut self, input: bool) -> Self {
            self.ebs_optimized = Some(input);
            self
        }
        pub fn set_ebs_optimized(mut self, input: std::option::Option<bool>) -> Self {
            self.ebs_optimized = input;
            self
        }
        /// <p>The name or Amazon Resource Name (ARN) of an IAM instance profile.</p>
        pub fn iam_instance_profile(
            mut self,
            input: crate::model::IamInstanceProfileSpecification,
        ) -> Self {
            self.iam_instance_profile = Some(input);
            self
        }
        pub fn set_iam_instance_profile(
            mut self,
            input: std::option::Option<crate::model::IamInstanceProfileSpecification>,
        ) -> Self {
            self.iam_instance_profile = input;
            self
        }
        /// <p>Indicates whether an instance stops or terminates when you initiate shutdown from the
        /// instance (using the operating system command for system shutdown).</p>
        /// <p>Default: <code>stop</code>
        /// </p>
        pub fn instance_initiated_shutdown_behavior(
            mut self,
            input: crate::model::ShutdownBehavior,
        ) -> Self {
            self.instance_initiated_shutdown_behavior = Some(input);
            self
        }
        pub fn set_instance_initiated_shutdown_behavior(
            mut self,
            input: std::option::Option<crate::model::ShutdownBehavior>,
        ) -> Self {
            self.instance_initiated_shutdown_behavior = input;
            self
        }
        pub fn network_interfaces(
            mut self,
            input: impl Into<crate::model::InstanceNetworkInterfaceSpecification>,
        ) -> Self {
            let mut v = self.network_interfaces.unwrap_or_default();
            v.push(input.into());
            self.network_interfaces = Some(v);
            self
        }
        pub fn set_network_interfaces(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::InstanceNetworkInterfaceSpecification>,
            >,
        ) -> Self {
            self.network_interfaces = input;
            self
        }
        /// <p>[EC2-VPC] The primary IPv4 address. You must specify a value from the IPv4 address
        /// range of the subnet.</p>
        /// <p>Only one private IP address can be designated as primary. You can't specify this
        /// option if you've specified the option to designate a private IP address as the primary
        /// IP address in a network interface specification. You cannot specify this option if
        /// you're launching more than one instance in the request.</p>
        /// <p>You cannot specify this option and the network interfaces option in the same
        /// request.</p>
        pub fn private_ip_address(mut self, input: impl Into<std::string::String>) -> Self {
            self.private_ip_address = Some(input.into());
            self
        }
        pub fn set_private_ip_address(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.private_ip_address = input;
            self
        }
        pub fn elastic_gpu_specification(
            mut self,
            input: impl Into<crate::model::ElasticGpuSpecification>,
        ) -> Self {
            let mut v = self.elastic_gpu_specification.unwrap_or_default();
            v.push(input.into());
            self.elastic_gpu_specification = Some(v);
            self
        }
        pub fn set_elastic_gpu_specification(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ElasticGpuSpecification>>,
        ) -> Self {
            self.elastic_gpu_specification = input;
            self
        }
        pub fn elastic_inference_accelerators(
            mut self,
            input: impl Into<crate::model::ElasticInferenceAccelerator>,
        ) -> Self {
            let mut v = self.elastic_inference_accelerators.unwrap_or_default();
            v.push(input.into());
            self.elastic_inference_accelerators = Some(v);
            self
        }
        pub fn set_elastic_inference_accelerators(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ElasticInferenceAccelerator>>,
        ) -> Self {
            self.elastic_inference_accelerators = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>The launch template to use to launch the instances. Any parameters that you specify in
        /// <a>RunInstances</a> override the same parameters in the launch template.
        /// You can specify either the name or ID of a launch template, but not both.</p>
        pub fn launch_template(mut self, input: crate::model::LaunchTemplateSpecification) -> Self {
            self.launch_template = Some(input);
            self
        }
        pub fn set_launch_template(
            mut self,
            input: std::option::Option<crate::model::LaunchTemplateSpecification>,
        ) -> Self {
            self.launch_template = input;
            self
        }
        /// <p>The market (purchasing) option for the instances.</p>
        /// <p>For <a>RunInstances</a>, persistent Spot Instance requests are
        /// only supported when <b>InstanceInterruptionBehavior</b> is set
        /// to either <code>hibernate</code> or <code>stop</code>.</p>
        pub fn instance_market_options(
            mut self,
            input: crate::model::InstanceMarketOptionsRequest,
        ) -> Self {
            self.instance_market_options = Some(input);
            self
        }
        pub fn set_instance_market_options(
            mut self,
            input: std::option::Option<crate::model::InstanceMarketOptionsRequest>,
        ) -> Self {
            self.instance_market_options = input;
            self
        }
        /// <p>The credit option for CPU usage of the burstable performance instance. Valid values
        /// are <code>standard</code> and <code>unlimited</code>. To change this attribute after
        /// launch, use <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html">
        /// ModifyInstanceCreditSpecification</a>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html">Burstable
        /// performance instances</a> in the <i>Amazon EC2 User Guide</i>.</p>
        /// <p>Default: <code>standard</code> (T2 instances) or <code>unlimited</code> (T3/T3a
        /// instances)</p>
        pub fn credit_specification(
            mut self,
            input: crate::model::CreditSpecificationRequest,
        ) -> Self {
            self.credit_specification = Some(input);
            self
        }
        pub fn set_credit_specification(
            mut self,
            input: std::option::Option<crate::model::CreditSpecificationRequest>,
        ) -> Self {
            self.credit_specification = input;
            self
        }
        /// <p>The CPU options for the instance. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html">Optimizing CPU options</a> in the <i>Amazon EC2 User Guide</i>.</p>
        pub fn cpu_options(mut self, input: crate::model::CpuOptionsRequest) -> Self {
            self.cpu_options = Some(input);
            self
        }
        pub fn set_cpu_options(
            mut self,
            input: std::option::Option<crate::model::CpuOptionsRequest>,
        ) -> Self {
            self.cpu_options = input;
            self
        }
        /// <p>Information about the Capacity Reservation targeting option. If you do not specify this parameter, the
        /// instance's Capacity Reservation preference defaults to <code>open</code>, which enables
        /// it to run in any open Capacity Reservation that has matching attributes (instance type,
        /// platform, Availability Zone).</p>
        pub fn capacity_reservation_specification(
            mut self,
            input: crate::model::CapacityReservationSpecification,
        ) -> Self {
            self.capacity_reservation_specification = Some(input);
            self
        }
        pub fn set_capacity_reservation_specification(
            mut self,
            input: std::option::Option<crate::model::CapacityReservationSpecification>,
        ) -> Self {
            self.capacity_reservation_specification = input;
            self
        }
        /// <p>Indicates whether an instance is enabled for hibernation. For more information, see
        /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html">Hibernate
        /// your instance</a> in the <i>Amazon EC2 User Guide</i>.</p>
        /// <p>You can't enable hibernation and Amazon Web Services Nitro Enclaves on the same instance.</p>
        pub fn hibernation_options(
            mut self,
            input: crate::model::HibernationOptionsRequest,
        ) -> Self {
            self.hibernation_options = Some(input);
            self
        }
        pub fn set_hibernation_options(
            mut self,
            input: std::option::Option<crate::model::HibernationOptionsRequest>,
        ) -> Self {
            self.hibernation_options = input;
            self
        }
        pub fn license_specifications(
            mut self,
            input: impl Into<crate::model::LicenseConfigurationRequest>,
        ) -> Self {
            let mut v = self.license_specifications.unwrap_or_default();
            v.push(input.into());
            self.license_specifications = Some(v);
            self
        }
        pub fn set_license_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::LicenseConfigurationRequest>>,
        ) -> Self {
            self.license_specifications = input;
            self
        }
        /// <p>The metadata options for the instance. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html">Instance metadata and user data</a>.</p>
        pub fn metadata_options(
            mut self,
            input: crate::model::InstanceMetadataOptionsRequest,
        ) -> Self {
            self.metadata_options = Some(input);
            self
        }
        pub fn set_metadata_options(
            mut self,
            input: std::option::Option<crate::model::InstanceMetadataOptionsRequest>,
        ) -> Self {
            self.metadata_options = input;
            self
        }
        /// <p>Indicates whether the instance is enabled for Amazon Web Services Nitro Enclaves. For more information,
        /// see <a href="https://docs.aws.amazon.com/enclaves/latest/user/nitro-enclave.html">
        /// What is Amazon Web Services Nitro Enclaves?</a> in the <i>Amazon Web Services Nitro Enclaves User Guide</i>.</p>    
        /// <p>You can't enable Amazon Web Services Nitro Enclaves and hibernation on the same instance.</p>
        pub fn enclave_options(mut self, input: crate::model::EnclaveOptionsRequest) -> Self {
            self.enclave_options = Some(input);
            self
        }
        pub fn set_enclave_options(
            mut self,
            input: std::option::Option<crate::model::EnclaveOptionsRequest>,
        ) -> Self {
            self.enclave_options = input;
            self
        }
        /// Consumes the builder and constructs a [`RunInstancesInput`](crate::input::RunInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::RunInstancesInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::RunInstancesInput {
                block_device_mappings: self.block_device_mappings,
                image_id: self.image_id,
                instance_type: self.instance_type,
                ipv6_address_count: self.ipv6_address_count,
                ipv6_addresses: self.ipv6_addresses,
                kernel_id: self.kernel_id,
                key_name: self.key_name,
                max_count: self.max_count,
                min_count: self.min_count,
                monitoring: self.monitoring,
                placement: self.placement,
                ramdisk_id: self.ramdisk_id,
                security_group_ids: self.security_group_ids,
                security_groups: self.security_groups,
                subnet_id: self.subnet_id,
                user_data: self.user_data,
                additional_info: self.additional_info,
                client_token: self.client_token,
                disable_api_termination: self.disable_api_termination,
                dry_run: self.dry_run,
                ebs_optimized: self.ebs_optimized,
                iam_instance_profile: self.iam_instance_profile,
                instance_initiated_shutdown_behavior: self.instance_initiated_shutdown_behavior,
                network_interfaces: self.network_interfaces,
                private_ip_address: self.private_ip_address,
                elastic_gpu_specification: self.elastic_gpu_specification,
                elastic_inference_accelerators: self.elastic_inference_accelerators,
                tag_specifications: self.tag_specifications,
                launch_template: self.launch_template,
                instance_market_options: self.instance_market_options,
                credit_specification: self.credit_specification,
                cpu_options: self.cpu_options,
                capacity_reservation_specification: self.capacity_reservation_specification,
                hibernation_options: self.hibernation_options,
                license_specifications: self.license_specifications,
                metadata_options: self.metadata_options,
                enclave_options: self.enclave_options,
            })
        }
    }
}
#[doc(hidden)]
pub type RunInstancesInputOperationOutputAlias = crate::operation::RunInstances;
#[doc(hidden)]
pub type RunInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RunInstancesInput {
    /// Consumes the builder and constructs an Operation<[`RunInstances`](crate::operation::RunInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RunInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_run_instances(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RunInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new("RunInstances", "ec2"));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RunInstancesInput`](crate::input::RunInstancesInput)
    pub fn builder() -> crate::input::run_instances_input::Builder {
        crate::input::run_instances_input::Builder::default()
    }
}

/// See [`RunScheduledInstancesInput`](crate::input::RunScheduledInstancesInput)
pub mod run_scheduled_instances_input {
    /// A builder for [`RunScheduledInstancesInput`](crate::input::RunScheduledInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) instance_count: std::option::Option<i32>,
        pub(crate) launch_specification:
            std::option::Option<crate::model::ScheduledInstancesLaunchSpecification>,
        pub(crate) scheduled_instance_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Unique, case-sensitive identifier that ensures the idempotency of the request.
        /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The number of instances.</p>
        /// <p>Default: 1</p>
        pub fn instance_count(mut self, input: i32) -> Self {
            self.instance_count = Some(input);
            self
        }
        pub fn set_instance_count(mut self, input: std::option::Option<i32>) -> Self {
            self.instance_count = input;
            self
        }
        /// <p>The launch specification. You must match the instance type, Availability Zone,
        /// network, and platform of the schedule that you purchased.</p>
        pub fn launch_specification(
            mut self,
            input: crate::model::ScheduledInstancesLaunchSpecification,
        ) -> Self {
            self.launch_specification = Some(input);
            self
        }
        pub fn set_launch_specification(
            mut self,
            input: std::option::Option<crate::model::ScheduledInstancesLaunchSpecification>,
        ) -> Self {
            self.launch_specification = input;
            self
        }
        /// <p>The Scheduled Instance ID.</p>
        pub fn scheduled_instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.scheduled_instance_id = Some(input.into());
            self
        }
        pub fn set_scheduled_instance_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.scheduled_instance_id = input;
            self
        }
        /// Consumes the builder and constructs a [`RunScheduledInstancesInput`](crate::input::RunScheduledInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::RunScheduledInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::RunScheduledInstancesInput {
                client_token: self.client_token,
                dry_run: self.dry_run,
                instance_count: self.instance_count,
                launch_specification: self.launch_specification,
                scheduled_instance_id: self.scheduled_instance_id,
            })
        }
    }
}
#[doc(hidden)]
pub type RunScheduledInstancesInputOperationOutputAlias = crate::operation::RunScheduledInstances;
#[doc(hidden)]
pub type RunScheduledInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl RunScheduledInstancesInput {
    /// Consumes the builder and constructs an Operation<[`RunScheduledInstances`](crate::operation::RunScheduledInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::RunScheduledInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_run_scheduled_instances(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::RunScheduledInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "RunScheduledInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`RunScheduledInstancesInput`](crate::input::RunScheduledInstancesInput)
    pub fn builder() -> crate::input::run_scheduled_instances_input::Builder {
        crate::input::run_scheduled_instances_input::Builder::default()
    }
}

/// See [`SearchLocalGatewayRoutesInput`](crate::input::SearchLocalGatewayRoutesInput)
pub mod search_local_gateway_routes_input {
    /// A builder for [`SearchLocalGatewayRoutesInput`](crate::input::SearchLocalGatewayRoutesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) local_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the local gateway route table.</p>
        pub fn local_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_local_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.local_gateway_route_table_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`SearchLocalGatewayRoutesInput`](crate::input::SearchLocalGatewayRoutesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::SearchLocalGatewayRoutesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::SearchLocalGatewayRoutesInput {
                local_gateway_route_table_id: self.local_gateway_route_table_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type SearchLocalGatewayRoutesInputOperationOutputAlias =
    crate::operation::SearchLocalGatewayRoutes;
#[doc(hidden)]
pub type SearchLocalGatewayRoutesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl SearchLocalGatewayRoutesInput {
    /// Consumes the builder and constructs an Operation<[`SearchLocalGatewayRoutes`](crate::operation::SearchLocalGatewayRoutes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::SearchLocalGatewayRoutes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_search_local_gateway_routes(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::SearchLocalGatewayRoutes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "SearchLocalGatewayRoutes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`SearchLocalGatewayRoutesInput`](crate::input::SearchLocalGatewayRoutesInput)
    pub fn builder() -> crate::input::search_local_gateway_routes_input::Builder {
        crate::input::search_local_gateway_routes_input::Builder::default()
    }
}

/// See [`SearchTransitGatewayMulticastGroupsInput`](crate::input::SearchTransitGatewayMulticastGroupsInput)
pub mod search_transit_gateway_multicast_groups_input {
    /// A builder for [`SearchTransitGatewayMulticastGroupsInput`](crate::input::SearchTransitGatewayMulticastGroupsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) next_token: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway multicast domain.</p>
        pub fn transit_gateway_multicast_domain_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_multicast_domain_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_multicast_domain_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of results to return with a single call.
        /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>The token for the next page of results.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.next_token = Some(input.into());
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.next_token = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`SearchTransitGatewayMulticastGroupsInput`](crate::input::SearchTransitGatewayMulticastGroupsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::SearchTransitGatewayMulticastGroupsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::SearchTransitGatewayMulticastGroupsInput {
                transit_gateway_multicast_domain_id: self.transit_gateway_multicast_domain_id,
                filters: self.filters,
                max_results: self.max_results,
                next_token: self.next_token,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type SearchTransitGatewayMulticastGroupsInputOperationOutputAlias =
    crate::operation::SearchTransitGatewayMulticastGroups;
#[doc(hidden)]
pub type SearchTransitGatewayMulticastGroupsInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl SearchTransitGatewayMulticastGroupsInput {
    /// Consumes the builder and constructs an Operation<[`SearchTransitGatewayMulticastGroups`](crate::operation::SearchTransitGatewayMulticastGroups)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::SearchTransitGatewayMulticastGroups,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_search_transit_gateway_multicast_groups(
                    &self,
                )
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::SearchTransitGatewayMulticastGroups::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "SearchTransitGatewayMulticastGroups",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`SearchTransitGatewayMulticastGroupsInput`](crate::input::SearchTransitGatewayMulticastGroupsInput)
    pub fn builder() -> crate::input::search_transit_gateway_multicast_groups_input::Builder {
        crate::input::search_transit_gateway_multicast_groups_input::Builder::default()
    }
}

/// See [`SearchTransitGatewayRoutesInput`](crate::input::SearchTransitGatewayRoutesInput)
pub mod search_transit_gateway_routes_input {
    /// A builder for [`SearchTransitGatewayRoutesInput`](crate::input::SearchTransitGatewayRoutesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transit_gateway_route_table_id: std::option::Option<std::string::String>,
        pub(crate) filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        pub(crate) max_results: std::option::Option<i32>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the transit gateway route table.</p>
        pub fn transit_gateway_route_table_id(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = Some(input.into());
            self
        }
        pub fn set_transit_gateway_route_table_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transit_gateway_route_table_id = input;
            self
        }
        pub fn filters(mut self, input: impl Into<crate::model::Filter>) -> Self {
            let mut v = self.filters.unwrap_or_default();
            v.push(input.into());
            self.filters = Some(v);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Filter>>,
        ) -> Self {
            self.filters = input;
            self
        }
        /// <p>The maximum number of routes to return.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.max_results = Some(input);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.max_results = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`SearchTransitGatewayRoutesInput`](crate::input::SearchTransitGatewayRoutesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::SearchTransitGatewayRoutesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::SearchTransitGatewayRoutesInput {
                transit_gateway_route_table_id: self.transit_gateway_route_table_id,
                filters: self.filters,
                max_results: self.max_results,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type SearchTransitGatewayRoutesInputOperationOutputAlias =
    crate::operation::SearchTransitGatewayRoutes;
#[doc(hidden)]
pub type SearchTransitGatewayRoutesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl SearchTransitGatewayRoutesInput {
    /// Consumes the builder and constructs an Operation<[`SearchTransitGatewayRoutes`](crate::operation::SearchTransitGatewayRoutes)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::SearchTransitGatewayRoutes,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_search_transit_gateway_routes(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::SearchTransitGatewayRoutes::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "SearchTransitGatewayRoutes",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`SearchTransitGatewayRoutesInput`](crate::input::SearchTransitGatewayRoutesInput)
    pub fn builder() -> crate::input::search_transit_gateway_routes_input::Builder {
        crate::input::search_transit_gateway_routes_input::Builder::default()
    }
}

/// See [`SendDiagnosticInterruptInput`](crate::input::SendDiagnosticInterruptInput)
pub mod send_diagnostic_interrupt_input {
    /// A builder for [`SendDiagnosticInterruptInput`](crate::input::SendDiagnosticInterruptInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_id: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the instance.</p>
        pub fn instance_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.instance_id = Some(input.into());
            self
        }
        pub fn set_instance_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.instance_id = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`SendDiagnosticInterruptInput`](crate::input::SendDiagnosticInterruptInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::SendDiagnosticInterruptInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::SendDiagnosticInterruptInput {
                instance_id: self.instance_id,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type SendDiagnosticInterruptInputOperationOutputAlias =
    crate::operation::SendDiagnosticInterrupt;
#[doc(hidden)]
pub type SendDiagnosticInterruptInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl SendDiagnosticInterruptInput {
    /// Consumes the builder and constructs an Operation<[`SendDiagnosticInterrupt`](crate::operation::SendDiagnosticInterrupt)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::SendDiagnosticInterrupt,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_send_diagnostic_interrupt(&self)
                .map_err(|err| {
                smithy_http::operation::BuildError::SerializationError(err.into())
            })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::SendDiagnosticInterrupt::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "SendDiagnosticInterrupt",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`SendDiagnosticInterruptInput`](crate::input::SendDiagnosticInterruptInput)
    pub fn builder() -> crate::input::send_diagnostic_interrupt_input::Builder {
        crate::input::send_diagnostic_interrupt_input::Builder::default()
    }
}

/// See [`StartInstancesInput`](crate::input::StartInstancesInput)
pub mod start_instances_input {
    /// A builder for [`StartInstancesInput`](crate::input::StartInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) additional_info: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>Reserved.</p>
        pub fn additional_info(mut self, input: impl Into<std::string::String>) -> Self {
            self.additional_info = Some(input.into());
            self
        }
        pub fn set_additional_info(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.additional_info = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`StartInstancesInput`](crate::input::StartInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::StartInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::StartInstancesInput {
                instance_ids: self.instance_ids,
                additional_info: self.additional_info,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type StartInstancesInputOperationOutputAlias = crate::operation::StartInstances;
#[doc(hidden)]
pub type StartInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl StartInstancesInput {
    /// Consumes the builder and constructs an Operation<[`StartInstances`](crate::operation::StartInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::StartInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_start_instances(&self).map_err(
                |err| smithy_http::operation::BuildError::SerializationError(err.into()),
            )?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::StartInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "StartInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`StartInstancesInput`](crate::input::StartInstancesInput)
    pub fn builder() -> crate::input::start_instances_input::Builder {
        crate::input::start_instances_input::Builder::default()
    }
}

/// See [`StartNetworkInsightsAnalysisInput`](crate::input::StartNetworkInsightsAnalysisInput)
pub mod start_network_insights_analysis_input {
    /// A builder for [`StartNetworkInsightsAnalysisInput`](crate::input::StartNetworkInsightsAnalysisInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_insights_path_id: std::option::Option<std::string::String>,
        pub(crate) filter_in_arns: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) tag_specifications:
            std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        pub(crate) client_token: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ID of the path.</p>
        pub fn network_insights_path_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_insights_path_id = Some(input.into());
            self
        }
        pub fn set_network_insights_path_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_insights_path_id = input;
            self
        }
        pub fn filter_in_arns(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.filter_in_arns.unwrap_or_default();
            v.push(input.into());
            self.filter_in_arns = Some(v);
            self
        }
        pub fn set_filter_in_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.filter_in_arns = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        pub fn tag_specifications(
            mut self,
            input: impl Into<crate::model::TagSpecification>,
        ) -> Self {
            let mut v = self.tag_specifications.unwrap_or_default();
            v.push(input.into());
            self.tag_specifications = Some(v);
            self
        }
        pub fn set_tag_specifications(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
        ) -> Self {
            self.tag_specifications = input;
            self
        }
        /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
        pub fn client_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_token = Some(input.into());
            self
        }
        pub fn set_client_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.client_token = input;
            self
        }
        /// Consumes the builder and constructs a [`StartNetworkInsightsAnalysisInput`](crate::input::StartNetworkInsightsAnalysisInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::StartNetworkInsightsAnalysisInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::StartNetworkInsightsAnalysisInput {
                network_insights_path_id: self.network_insights_path_id,
                filter_in_arns: self.filter_in_arns,
                dry_run: self.dry_run,
                tag_specifications: self.tag_specifications,
                client_token: self.client_token,
            })
        }
    }
}
#[doc(hidden)]
pub type StartNetworkInsightsAnalysisInputOperationOutputAlias =
    crate::operation::StartNetworkInsightsAnalysis;
#[doc(hidden)]
pub type StartNetworkInsightsAnalysisInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl StartNetworkInsightsAnalysisInput {
    /// Consumes the builder and constructs an Operation<[`StartNetworkInsightsAnalysis`](crate::operation::StartNetworkInsightsAnalysis)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        mut self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::StartNetworkInsightsAnalysis,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            if self.client_token.is_none() {
                self.client_token = Some(_config.make_token.make_idempotency_token());
            }
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_start_network_insights_analysis(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::StartNetworkInsightsAnalysis::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "StartNetworkInsightsAnalysis",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`StartNetworkInsightsAnalysisInput`](crate::input::StartNetworkInsightsAnalysisInput)
    pub fn builder() -> crate::input::start_network_insights_analysis_input::Builder {
        crate::input::start_network_insights_analysis_input::Builder::default()
    }
}

/// See [`StartVpcEndpointServicePrivateDnsVerificationInput`](crate::input::StartVpcEndpointServicePrivateDnsVerificationInput)
pub mod start_vpc_endpoint_service_private_dns_verification_input {
    /// A builder for [`StartVpcEndpointServicePrivateDnsVerificationInput`](crate::input::StartVpcEndpointServicePrivateDnsVerificationInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) service_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the endpoint service.</p>
        pub fn service_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.service_id = Some(input.into());
            self
        }
        pub fn set_service_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.service_id = input;
            self
        }
        /// Consumes the builder and constructs a [`StartVpcEndpointServicePrivateDnsVerificationInput`](crate::input::StartVpcEndpointServicePrivateDnsVerificationInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::StartVpcEndpointServicePrivateDnsVerificationInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::StartVpcEndpointServicePrivateDnsVerificationInput {
                    dry_run: self.dry_run,
                    service_id: self.service_id,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type StartVpcEndpointServicePrivateDnsVerificationInputOperationOutputAlias =
    crate::operation::StartVpcEndpointServicePrivateDnsVerification;
#[doc(hidden)]
pub type StartVpcEndpointServicePrivateDnsVerificationInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl StartVpcEndpointServicePrivateDnsVerificationInput {
    /// Consumes the builder and constructs an Operation<[`StartVpcEndpointServicePrivateDnsVerification`](crate::operation::StartVpcEndpointServicePrivateDnsVerification)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::StartVpcEndpointServicePrivateDnsVerification,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_start_vpc_endpoint_service_private_dns_verification(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::StartVpcEndpointServicePrivateDnsVerification::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "StartVpcEndpointServicePrivateDnsVerification",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`StartVpcEndpointServicePrivateDnsVerificationInput`](crate::input::StartVpcEndpointServicePrivateDnsVerificationInput)
    pub fn builder(
    ) -> crate::input::start_vpc_endpoint_service_private_dns_verification_input::Builder {
        crate::input::start_vpc_endpoint_service_private_dns_verification_input::Builder::default()
    }
}

/// See [`StopInstancesInput`](crate::input::StopInstancesInput)
pub mod stop_instances_input {
    /// A builder for [`StopInstancesInput`](crate::input::StopInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) hibernate: std::option::Option<bool>,
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) force: std::option::Option<bool>,
    }
    impl Builder {
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>Hibernates the instance if the instance was enabled for hibernation at launch. If the
        /// instance cannot hibernate successfully, a normal shutdown occurs. For more information,
        /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html">Hibernate
        /// your instance</a> in the <i>Amazon EC2 User Guide</i>.</p>
        /// <p> Default: <code>false</code>
        /// </p>
        pub fn hibernate(mut self, input: bool) -> Self {
            self.hibernate = Some(input);
            self
        }
        pub fn set_hibernate(mut self, input: std::option::Option<bool>) -> Self {
            self.hibernate = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>Forces the instances to stop. The instances do not have an opportunity to flush file
        /// system caches or file system metadata. If you use this option, you must perform file
        /// system check and repair procedures. This option is not recommended for Windows
        /// instances.</p>
        /// <p>Default: <code>false</code>
        /// </p>
        pub fn force(mut self, input: bool) -> Self {
            self.force = Some(input);
            self
        }
        pub fn set_force(mut self, input: std::option::Option<bool>) -> Self {
            self.force = input;
            self
        }
        /// Consumes the builder and constructs a [`StopInstancesInput`](crate::input::StopInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<crate::input::StopInstancesInput, smithy_http::operation::BuildError>
        {
            Ok(crate::input::StopInstancesInput {
                instance_ids: self.instance_ids,
                hibernate: self.hibernate,
                dry_run: self.dry_run,
                force: self.force,
            })
        }
    }
}
#[doc(hidden)]
pub type StopInstancesInputOperationOutputAlias = crate::operation::StopInstances;
#[doc(hidden)]
pub type StopInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl StopInstancesInput {
    /// Consumes the builder and constructs an Operation<[`StopInstances`](crate::operation::StopInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::StopInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_stop_instances(&self).map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::StopInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "StopInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`StopInstancesInput`](crate::input::StopInstancesInput)
    pub fn builder() -> crate::input::stop_instances_input::Builder {
        crate::input::stop_instances_input::Builder::default()
    }
}

/// See [`TerminateClientVpnConnectionsInput`](crate::input::TerminateClientVpnConnectionsInput)
pub mod terminate_client_vpn_connections_input {
    /// A builder for [`TerminateClientVpnConnectionsInput`](crate::input::TerminateClientVpnConnectionsInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) client_vpn_endpoint_id: std::option::Option<std::string::String>,
        pub(crate) connection_id: std::option::Option<std::string::String>,
        pub(crate) username: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The ID of the Client VPN endpoint to which the client is connected.</p>
        pub fn client_vpn_endpoint_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.client_vpn_endpoint_id = Some(input.into());
            self
        }
        pub fn set_client_vpn_endpoint_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.client_vpn_endpoint_id = input;
            self
        }
        /// <p>The ID of the client connection to be terminated.</p>
        pub fn connection_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.connection_id = Some(input.into());
            self
        }
        pub fn set_connection_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.connection_id = input;
            self
        }
        /// <p>The name of the user who initiated the connection. Use this option to terminate all active connections for
        /// the specified user. This option can only be used if the user has established up to five connections.</p>
        pub fn username(mut self, input: impl Into<std::string::String>) -> Self {
            self.username = Some(input.into());
            self
        }
        pub fn set_username(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.username = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`TerminateClientVpnConnectionsInput`](crate::input::TerminateClientVpnConnectionsInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::TerminateClientVpnConnectionsInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::TerminateClientVpnConnectionsInput {
                client_vpn_endpoint_id: self.client_vpn_endpoint_id,
                connection_id: self.connection_id,
                username: self.username,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type TerminateClientVpnConnectionsInputOperationOutputAlias =
    crate::operation::TerminateClientVpnConnections;
#[doc(hidden)]
pub type TerminateClientVpnConnectionsInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl TerminateClientVpnConnectionsInput {
    /// Consumes the builder and constructs an Operation<[`TerminateClientVpnConnections`](crate::operation::TerminateClientVpnConnections)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::TerminateClientVpnConnections,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_terminate_client_vpn_connections(&self)
                    .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::TerminateClientVpnConnections::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "TerminateClientVpnConnections",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`TerminateClientVpnConnectionsInput`](crate::input::TerminateClientVpnConnectionsInput)
    pub fn builder() -> crate::input::terminate_client_vpn_connections_input::Builder {
        crate::input::terminate_client_vpn_connections_input::Builder::default()
    }
}

/// See [`TerminateInstancesInput`](crate::input::TerminateInstancesInput)
pub mod terminate_instances_input {
    /// A builder for [`TerminateInstancesInput`](crate::input::TerminateInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`TerminateInstancesInput`](crate::input::TerminateInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::TerminateInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::TerminateInstancesInput {
                instance_ids: self.instance_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type TerminateInstancesInputOperationOutputAlias = crate::operation::TerminateInstances;
#[doc(hidden)]
pub type TerminateInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl TerminateInstancesInput {
    /// Consumes the builder and constructs an Operation<[`TerminateInstances`](crate::operation::TerminateInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::TerminateInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_terminate_instances(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::TerminateInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "TerminateInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`TerminateInstancesInput`](crate::input::TerminateInstancesInput)
    pub fn builder() -> crate::input::terminate_instances_input::Builder {
        crate::input::terminate_instances_input::Builder::default()
    }
}

/// See [`UnassignIpv6AddressesInput`](crate::input::UnassignIpv6AddressesInput)
pub mod unassign_ipv6_addresses_input {
    /// A builder for [`UnassignIpv6AddressesInput`](crate::input::UnassignIpv6AddressesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) ipv6_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        pub fn ipv6_addresses(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.ipv6_addresses.unwrap_or_default();
            v.push(input.into());
            self.ipv6_addresses = Some(v);
            self
        }
        pub fn set_ipv6_addresses(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.ipv6_addresses = input;
            self
        }
        /// Consumes the builder and constructs a [`UnassignIpv6AddressesInput`](crate::input::UnassignIpv6AddressesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::UnassignIpv6AddressesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::UnassignIpv6AddressesInput {
                network_interface_id: self.network_interface_id,
                ipv6_addresses: self.ipv6_addresses,
            })
        }
    }
}
#[doc(hidden)]
pub type UnassignIpv6AddressesInputOperationOutputAlias = crate::operation::UnassignIpv6Addresses;
#[doc(hidden)]
pub type UnassignIpv6AddressesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl UnassignIpv6AddressesInput {
    /// Consumes the builder and constructs an Operation<[`UnassignIpv6Addresses`](crate::operation::UnassignIpv6Addresses)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::UnassignIpv6Addresses,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_unassign_ipv6_addresses(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::UnassignIpv6Addresses::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "UnassignIpv6Addresses",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`UnassignIpv6AddressesInput`](crate::input::UnassignIpv6AddressesInput)
    pub fn builder() -> crate::input::unassign_ipv6_addresses_input::Builder {
        crate::input::unassign_ipv6_addresses_input::Builder::default()
    }
}

/// See [`UnassignPrivateIpAddressesInput`](crate::input::UnassignPrivateIpAddressesInput)
pub mod unassign_private_ip_addresses_input {
    /// A builder for [`UnassignPrivateIpAddressesInput`](crate::input::UnassignPrivateIpAddressesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) network_interface_id: std::option::Option<std::string::String>,
        pub(crate) private_ip_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
    }
    impl Builder {
        /// <p>The ID of the network interface.</p>
        pub fn network_interface_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.network_interface_id = Some(input.into());
            self
        }
        pub fn set_network_interface_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.network_interface_id = input;
            self
        }
        pub fn private_ip_addresses(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.private_ip_addresses.unwrap_or_default();
            v.push(input.into());
            self.private_ip_addresses = Some(v);
            self
        }
        pub fn set_private_ip_addresses(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.private_ip_addresses = input;
            self
        }
        /// Consumes the builder and constructs a [`UnassignPrivateIpAddressesInput`](crate::input::UnassignPrivateIpAddressesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::UnassignPrivateIpAddressesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::UnassignPrivateIpAddressesInput {
                network_interface_id: self.network_interface_id,
                private_ip_addresses: self.private_ip_addresses,
            })
        }
    }
}
#[doc(hidden)]
pub type UnassignPrivateIpAddressesInputOperationOutputAlias =
    crate::operation::UnassignPrivateIpAddresses;
#[doc(hidden)]
pub type UnassignPrivateIpAddressesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl UnassignPrivateIpAddressesInput {
    /// Consumes the builder and constructs an Operation<[`UnassignPrivateIpAddresses`](crate::operation::UnassignPrivateIpAddresses)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::UnassignPrivateIpAddresses,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_unassign_private_ip_addresses(&self)
                    .map_err(|err| {
                        smithy_http::operation::BuildError::SerializationError(err.into())
                    })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::UnassignPrivateIpAddresses::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "UnassignPrivateIpAddresses",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`UnassignPrivateIpAddressesInput`](crate::input::UnassignPrivateIpAddressesInput)
    pub fn builder() -> crate::input::unassign_private_ip_addresses_input::Builder {
        crate::input::unassign_private_ip_addresses_input::Builder::default()
    }
}

/// See [`UnmonitorInstancesInput`](crate::input::UnmonitorInstancesInput)
pub mod unmonitor_instances_input {
    /// A builder for [`UnmonitorInstancesInput`](crate::input::UnmonitorInstancesInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        pub fn instance_ids(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.instance_ids.unwrap_or_default();
            v.push(input.into());
            self.instance_ids = Some(v);
            self
        }
        pub fn set_instance_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.instance_ids = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`UnmonitorInstancesInput`](crate::input::UnmonitorInstancesInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::UnmonitorInstancesInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::UnmonitorInstancesInput {
                instance_ids: self.instance_ids,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type UnmonitorInstancesInputOperationOutputAlias = crate::operation::UnmonitorInstances;
#[doc(hidden)]
pub type UnmonitorInstancesInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl UnmonitorInstancesInput {
    /// Consumes the builder and constructs an Operation<[`UnmonitorInstances`](crate::operation::UnmonitorInstances)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::UnmonitorInstances,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_unmonitor_instances(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::UnmonitorInstances::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "UnmonitorInstances",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`UnmonitorInstancesInput`](crate::input::UnmonitorInstancesInput)
    pub fn builder() -> crate::input::unmonitor_instances_input::Builder {
        crate::input::unmonitor_instances_input::Builder::default()
    }
}

/// See [`UpdateSecurityGroupRuleDescriptionsEgressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsEgressInput)
pub mod update_security_group_rule_descriptions_egress_input {
    /// A builder for [`UpdateSecurityGroupRuleDescriptionsEgressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsEgressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_id: std::option::Option<std::string::String>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the security group. You must specify either the security group ID or the
        /// security group name in the request. For security groups in a nondefault VPC, you must
        /// specify the security group ID.</p>
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_id = Some(input.into());
            self
        }
        pub fn set_group_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_id = input;
            self
        }
        /// <p>[Default VPC] The name of the security group. You must specify either the security group
        /// ID or the security group name in the request.</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        pub fn ip_permissions(mut self, input: impl Into<crate::model::IpPermission>) -> Self {
            let mut v = self.ip_permissions.unwrap_or_default();
            v.push(input.into());
            self.ip_permissions = Some(v);
            self
        }
        pub fn set_ip_permissions(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        ) -> Self {
            self.ip_permissions = input;
            self
        }
        /// Consumes the builder and constructs a [`UpdateSecurityGroupRuleDescriptionsEgressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsEgressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::UpdateSecurityGroupRuleDescriptionsEgressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::UpdateSecurityGroupRuleDescriptionsEgressInput {
                    dry_run: self.dry_run,
                    group_id: self.group_id,
                    group_name: self.group_name,
                    ip_permissions: self.ip_permissions,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type UpdateSecurityGroupRuleDescriptionsEgressInputOperationOutputAlias =
    crate::operation::UpdateSecurityGroupRuleDescriptionsEgress;
#[doc(hidden)]
pub type UpdateSecurityGroupRuleDescriptionsEgressInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl UpdateSecurityGroupRuleDescriptionsEgressInput {
    /// Consumes the builder and constructs an Operation<[`UpdateSecurityGroupRuleDescriptionsEgress`](crate::operation::UpdateSecurityGroupRuleDescriptionsEgress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::UpdateSecurityGroupRuleDescriptionsEgress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_update_security_group_rule_descriptions_egress(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::UpdateSecurityGroupRuleDescriptionsEgress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "UpdateSecurityGroupRuleDescriptionsEgress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`UpdateSecurityGroupRuleDescriptionsEgressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsEgressInput)
    pub fn builder() -> crate::input::update_security_group_rule_descriptions_egress_input::Builder
    {
        crate::input::update_security_group_rule_descriptions_egress_input::Builder::default()
    }
}

/// See [`UpdateSecurityGroupRuleDescriptionsIngressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsIngressInput)
pub mod update_security_group_rule_descriptions_ingress_input {
    /// A builder for [`UpdateSecurityGroupRuleDescriptionsIngressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsIngressInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dry_run: std::option::Option<bool>,
        pub(crate) group_id: std::option::Option<std::string::String>,
        pub(crate) group_name: std::option::Option<std::string::String>,
        pub(crate) ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
    }
    impl Builder {
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// <p>The ID of the security group. You must specify either the security group ID or the
        /// security group name in the request. For security groups in a nondefault VPC, you must
        /// specify the security group ID.</p>
        pub fn group_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_id = Some(input.into());
            self
        }
        pub fn set_group_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_id = input;
            self
        }
        /// <p>[EC2-Classic, default VPC] The name of the security group. You must specify either the
        /// security group ID or the security group name in the request.</p>
        pub fn group_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.group_name = Some(input.into());
            self
        }
        pub fn set_group_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.group_name = input;
            self
        }
        pub fn ip_permissions(mut self, input: impl Into<crate::model::IpPermission>) -> Self {
            let mut v = self.ip_permissions.unwrap_or_default();
            v.push(input.into());
            self.ip_permissions = Some(v);
            self
        }
        pub fn set_ip_permissions(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
        ) -> Self {
            self.ip_permissions = input;
            self
        }
        /// Consumes the builder and constructs a [`UpdateSecurityGroupRuleDescriptionsIngressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsIngressInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::UpdateSecurityGroupRuleDescriptionsIngressInput,
            smithy_http::operation::BuildError,
        > {
            Ok(
                crate::input::UpdateSecurityGroupRuleDescriptionsIngressInput {
                    dry_run: self.dry_run,
                    group_id: self.group_id,
                    group_name: self.group_name,
                    ip_permissions: self.ip_permissions,
                },
            )
        }
    }
}
#[doc(hidden)]
pub type UpdateSecurityGroupRuleDescriptionsIngressInputOperationOutputAlias =
    crate::operation::UpdateSecurityGroupRuleDescriptionsIngress;
#[doc(hidden)]
pub type UpdateSecurityGroupRuleDescriptionsIngressInputOperationRetryAlias =
    aws_http::AwsErrorRetryPolicy;
impl UpdateSecurityGroupRuleDescriptionsIngressInput {
    /// Consumes the builder and constructs an Operation<[`UpdateSecurityGroupRuleDescriptionsIngress`](crate::operation::UpdateSecurityGroupRuleDescriptionsIngress)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::UpdateSecurityGroupRuleDescriptionsIngress,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body =
                crate::operation_ser::serialize_operation_update_security_group_rule_descriptions_ingress(&self).map_err(|err|smithy_http::operation::BuildError::SerializationError(err.into()))?
            ;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::UpdateSecurityGroupRuleDescriptionsIngress::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "UpdateSecurityGroupRuleDescriptionsIngress",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`UpdateSecurityGroupRuleDescriptionsIngressInput`](crate::input::UpdateSecurityGroupRuleDescriptionsIngressInput)
    pub fn builder() -> crate::input::update_security_group_rule_descriptions_ingress_input::Builder
    {
        crate::input::update_security_group_rule_descriptions_ingress_input::Builder::default()
    }
}

/// See [`WithdrawByoipCidrInput`](crate::input::WithdrawByoipCidrInput)
pub mod withdraw_byoip_cidr_input {
    /// A builder for [`WithdrawByoipCidrInput`](crate::input::WithdrawByoipCidrInput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) cidr: std::option::Option<std::string::String>,
        pub(crate) dry_run: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>The address range, in CIDR notation.</p>
        pub fn cidr(mut self, input: impl Into<std::string::String>) -> Self {
            self.cidr = Some(input.into());
            self
        }
        pub fn set_cidr(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.cidr = input;
            self
        }
        /// <p>Checks whether you have the required permissions for the action, without actually making the request,
        /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
        /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
        pub fn dry_run(mut self, input: bool) -> Self {
            self.dry_run = Some(input);
            self
        }
        pub fn set_dry_run(mut self, input: std::option::Option<bool>) -> Self {
            self.dry_run = input;
            self
        }
        /// Consumes the builder and constructs a [`WithdrawByoipCidrInput`](crate::input::WithdrawByoipCidrInput)
        pub fn build(
            self,
        ) -> std::result::Result<
            crate::input::WithdrawByoipCidrInput,
            smithy_http::operation::BuildError,
        > {
            Ok(crate::input::WithdrawByoipCidrInput {
                cidr: self.cidr,
                dry_run: self.dry_run,
            })
        }
    }
}
#[doc(hidden)]
pub type WithdrawByoipCidrInputOperationOutputAlias = crate::operation::WithdrawByoipCidr;
#[doc(hidden)]
pub type WithdrawByoipCidrInputOperationRetryAlias = aws_http::AwsErrorRetryPolicy;
impl WithdrawByoipCidrInput {
    /// Consumes the builder and constructs an Operation<[`WithdrawByoipCidr`](crate::operation::WithdrawByoipCidr)>
    #[allow(clippy::let_and_return)]
    pub fn make_operation(
        &self,
        _config: &crate::config::Config,
    ) -> std::result::Result<
        smithy_http::operation::Operation<
            crate::operation::WithdrawByoipCidr,
            aws_http::AwsErrorRetryPolicy,
        >,
        smithy_http::operation::BuildError,
    > {
        Ok({
            let request = self.request_builder_base()?;
            let body = crate::operation_ser::serialize_operation_withdraw_byoip_cidr(&self)
                .map_err(|err| {
                    smithy_http::operation::BuildError::SerializationError(err.into())
                })?;
            let request = Self::assemble(request, body);
            #[allow(unused_mut)]
            let mut request =
                smithy_http::operation::Request::new(request.map(smithy_http::body::SdkBody::from));
            request
                .config_mut()
                .insert(aws_http::user_agent::AwsUserAgent::new_from_environment(
                    crate::API_METADATA.clone(),
                ));
            #[allow(unused_mut)]
            let mut signing_config = aws_sig_auth::signer::OperationSigningConfig::default_config();
            request.config_mut().insert(signing_config);
            request
                .config_mut()
                .insert(aws_types::SigningService::from_static(
                    _config.signing_service(),
                ));
            aws_endpoint::set_endpoint_resolver(
                &mut request.config_mut(),
                _config.endpoint_resolver.clone(),
            );
            if let Some(region) = &_config.region {
                request.config_mut().insert(region.clone());
            }
            aws_auth::provider::set_provider(
                &mut request.config_mut(),
                _config.credentials_provider.clone(),
            );
            let op = smithy_http::operation::Operation::new(
                request,
                crate::operation::WithdrawByoipCidr::new(),
            )
            .with_metadata(smithy_http::operation::Metadata::new(
                "WithdrawByoipCidr",
                "ec2",
            ));
            let op = op.with_retry_policy(aws_http::AwsErrorRetryPolicy::new());
            op
        })
    }
    fn uri_base(&self, output: &mut String) -> Result<(), smithy_http::operation::BuildError> {
        write!(output, "/").expect("formatting should succeed");
        Ok(())
    }
    #[allow(clippy::unnecessary_wraps)]
    fn update_http_builder(
        &self,
        builder: http::request::Builder,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut uri = String::new();
        self.uri_base(&mut uri)?;
        Ok(builder.method("POST").uri(uri))
    }
    #[allow(clippy::unnecessary_wraps)]
    fn request_builder_base(
        &self,
    ) -> std::result::Result<http::request::Builder, smithy_http::operation::BuildError> {
        let mut builder = self.update_http_builder(http::request::Builder::new())?;
        builder = smithy_http::header::set_header_if_absent(
            builder,
            "content-type",
            "application/x-www-form-urlencoded",
        );
        Ok(builder)
    }
    fn assemble(
        mut builder: http::request::Builder,
        body: smithy_http::body::SdkBody,
    ) -> http::request::Request<smithy_http::body::SdkBody> {
        if let Some(content_length) = body.content_length() {
            builder = builder.header(http::header::CONTENT_LENGTH, content_length)
        }
        builder.body(body).expect("should be valid request")
    }
    /// Creates a new builder-style object to manufacture [`WithdrawByoipCidrInput`](crate::input::WithdrawByoipCidrInput)
    pub fn builder() -> crate::input::withdraw_byoip_cidr_input::Builder {
        crate::input::withdraw_byoip_cidr_input::Builder::default()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct WithdrawByoipCidrInput {
    /// <p>The address range, in CIDR notation.</p>
    pub cidr: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for WithdrawByoipCidrInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("WithdrawByoipCidrInput");
        formatter.field("cidr", &self.cidr);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct UpdateSecurityGroupRuleDescriptionsIngressInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the security group. You must specify either the security group ID or the
    /// security group name in the request. For security groups in a nondefault VPC, you must
    /// specify the security group ID.</p>
    pub group_id: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic, default VPC] The name of the security group. You must specify either the
    /// security group ID or the security group name in the request.</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>The IP permissions for the security group rule. </p>
    pub ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
}
impl std::fmt::Debug for UpdateSecurityGroupRuleDescriptionsIngressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("UpdateSecurityGroupRuleDescriptionsIngressInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_id", &self.group_id);
        formatter.field("group_name", &self.group_name);
        formatter.field("ip_permissions", &self.ip_permissions);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct UpdateSecurityGroupRuleDescriptionsEgressInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the security group. You must specify either the security group ID or the
    /// security group name in the request. For security groups in a nondefault VPC, you must
    /// specify the security group ID.</p>
    pub group_id: std::option::Option<std::string::String>,
    /// <p>[Default VPC] The name of the security group. You must specify either the security group
    /// ID or the security group name in the request.</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>The IP permissions for the security group rule.</p>
    pub ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
}
impl std::fmt::Debug for UpdateSecurityGroupRuleDescriptionsEgressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("UpdateSecurityGroupRuleDescriptionsEgressInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_id", &self.group_id);
        formatter.field("group_name", &self.group_name);
        formatter.field("ip_permissions", &self.ip_permissions);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct UnmonitorInstancesInput {
    /// <p>The IDs of the instances.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for UnmonitorInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("UnmonitorInstancesInput");
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for UnassignPrivateIpAddresses.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct UnassignPrivateIpAddressesInput {
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The secondary private IP addresses to unassign from the network interface. You can specify this option multiple times to unassign more than one IP address.</p>
    pub private_ip_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for UnassignPrivateIpAddressesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("UnassignPrivateIpAddressesInput");
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("private_ip_addresses", &self.private_ip_addresses);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct UnassignIpv6AddressesInput {
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The IPv6 addresses to unassign from the network interface.</p>
    pub ipv6_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for UnassignIpv6AddressesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("UnassignIpv6AddressesInput");
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("ipv6_addresses", &self.ipv6_addresses);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct TerminateInstancesInput {
    /// <p>The IDs of the instances.</p>
    /// <p>Constraints: Up to 1000 instance IDs. We recommend breaking up this request into
    /// smaller batches.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for TerminateInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("TerminateInstancesInput");
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct TerminateClientVpnConnectionsInput {
    /// <p>The ID of the Client VPN endpoint to which the client is connected.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The ID of the client connection to be terminated.</p>
    pub connection_id: std::option::Option<std::string::String>,
    /// <p>The name of the user who initiated the connection. Use this option to terminate all active connections for
    /// the specified user. This option can only be used if the user has established up to five connections.</p>
    pub username: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for TerminateClientVpnConnectionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("TerminateClientVpnConnectionsInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("connection_id", &self.connection_id);
        formatter.field("username", &self.username);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct StopInstancesInput {
    /// <p>The IDs of the instances.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Hibernates the instance if the instance was enabled for hibernation at launch. If the
    /// instance cannot hibernate successfully, a normal shutdown occurs. For more information,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html">Hibernate
    /// your instance</a> in the <i>Amazon EC2 User Guide</i>.</p>
    /// <p> Default: <code>false</code>
    /// </p>
    pub hibernate: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Forces the instances to stop. The instances do not have an opportunity to flush file
    /// system caches or file system metadata. If you use this option, you must perform file
    /// system check and repair procedures. This option is not recommended for Windows
    /// instances.</p>
    /// <p>Default: <code>false</code>
    /// </p>
    pub force: std::option::Option<bool>,
}
impl std::fmt::Debug for StopInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("StopInstancesInput");
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("hibernate", &self.hibernate);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("force", &self.force);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct StartVpcEndpointServicePrivateDnsVerificationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the endpoint service.</p>
    pub service_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for StartVpcEndpointServicePrivateDnsVerificationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("StartVpcEndpointServicePrivateDnsVerificationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_id", &self.service_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct StartNetworkInsightsAnalysisInput {
    /// <p>The ID of the path.</p>
    pub network_insights_path_id: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Names (ARN) of the resources that the path must traverse.</p>
    pub filter_in_arns: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tags to apply.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for StartNetworkInsightsAnalysisInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("StartNetworkInsightsAnalysisInput");
        formatter.field("network_insights_path_id", &self.network_insights_path_id);
        formatter.field("filter_in_arns", &self.filter_in_arns);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct StartInstancesInput {
    /// <p>The IDs of the instances.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Reserved.</p>
    pub additional_info: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for StartInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("StartInstancesInput");
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("additional_info", &self.additional_info);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SendDiagnosticInterruptInput {
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for SendDiagnosticInterruptInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SendDiagnosticInterruptInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SearchTransitGatewayRoutesInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>attachment.transit-gateway-attachment-id</code>- The id of the transit gateway attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.resource-id</code> - The resource id of the transit gateway attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.resource-type</code> - The attachment resource type. Valid values
    /// are <code>vpc</code> | <code>vpn</code> | <code>direct-connect-gateway</code> |
    /// <code>peering</code> | <code>connect</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>prefix-list-id</code> - The ID of the prefix list.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.exact-match</code> - The exact match of the specified filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.longest-prefix-match</code> - The longest prefix that matches the route.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.subnet-of-match</code> - The routes with a subnet that match the specified CIDR filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.supernet-of-match</code> - The routes with a CIDR that encompass the CIDR filter. For example, if you have 10.0.1.0/29 and 10.0.1.0/31 routes in your route table and you specify supernet-of-match as 10.0.1.0/30, then the result returns 10.0.1.0/29.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the route (<code>active</code> | <code>blackhole</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>type</code> - The type of route (<code>propagated</code> |
    /// <code>static</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of routes to return.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for SearchTransitGatewayRoutesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SearchTransitGatewayRoutesInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SearchTransitGatewayMulticastGroupsInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>group-ip-address</code> - The IP address of the  transit gateway multicast group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>is-group-member</code> - The resource is a group member. Valid values are <code>true</code> | <code>false</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>is-group-source</code> - The resource is a group source. Valid values are <code>true</code> | <code>false</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>member-type</code> - The member type. Valid values are <code>igmp</code> | <code>static</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-id</code> - The ID of the resource.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-type</code> - The type of resource. Valid values are <code>vpc</code> | <code>vpn</code> | <code>direct-connect-gateway</code> | <code>tgw-peering</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>source-type</code> - The source type. Valid values are <code>igmp</code> | <code>static</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the subnet association. Valid values are <code>associated</code> | <code>associated</code> | <code>disassociated</code> | <code>disassociating</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>subnet-id</code> - The ID of the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The id of the transit gateway attachment.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for SearchTransitGatewayMulticastGroupsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SearchTransitGatewayMulticastGroupsInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SearchLocalGatewayRoutesInput {
    /// <p>The ID of the local gateway route table.</p>
    pub local_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>One or more filters.</p>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for SearchLocalGatewayRoutesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SearchLocalGatewayRoutesInput");
        formatter.field(
            "local_gateway_route_table_id",
            &self.local_gateway_route_table_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for RunScheduledInstances.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RunScheduledInstancesInput {
    /// <p>Unique, case-sensitive identifier that ensures the idempotency of the request.
    /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The number of instances.</p>
    /// <p>Default: 1</p>
    pub instance_count: std::option::Option<i32>,
    /// <p>The launch specification. You must match the instance type, Availability Zone,
    /// network, and platform of the schedule that you purchased.</p>
    pub launch_specification:
        std::option::Option<crate::model::ScheduledInstancesLaunchSpecification>,
    /// <p>The Scheduled Instance ID.</p>
    pub scheduled_instance_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for RunScheduledInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RunScheduledInstancesInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_count", &self.instance_count);
        formatter.field("launch_specification", &self.launch_specification);
        formatter.field("scheduled_instance_id", &self.scheduled_instance_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RunInstancesInput {
    /// <p>The block device mapping entries.</p>
    pub block_device_mappings: std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
    /// <p>The ID of the AMI. An AMI ID is required to launch an instance and must be
    /// specified here or in a launch template.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>The instance type. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance types</a> in the
    /// <i>Amazon EC2 User Guide</i>.</p>
    /// <p>Default: <code>m1.small</code>
    /// </p>
    pub instance_type: std::option::Option<crate::model::InstanceType>,
    /// <p>[EC2-VPC] The number of IPv6 addresses to associate with the primary network
    /// interface. Amazon EC2 chooses the IPv6 addresses from the range of your subnet. You
    /// cannot specify this option and the option to assign specific IPv6 addresses in the same
    /// request. You can specify this option if you've specified a minimum number of instances
    /// to launch.</p>
    /// <p>You cannot specify this option and the network interfaces option in the same
    /// request.</p>
    pub ipv6_address_count: std::option::Option<i32>,
    /// <p>[EC2-VPC] The IPv6 addresses from the range of the subnet to associate with the
    /// primary network interface. You cannot specify this option and the option to assign a
    /// number of IPv6 addresses in the same request. You cannot specify this option if you've
    /// specified a minimum number of instances to launch.</p>
    /// <p>You cannot specify this option and the network interfaces option in the same
    /// request.</p>
    pub ipv6_addresses: std::option::Option<std::vec::Vec<crate::model::InstanceIpv6Address>>,
    /// <p>The ID of the kernel.</p>
    /// <important>
    /// <p>We recommend that you use PV-GRUB instead of kernels and RAM disks. For more
    /// information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html"> PV-GRUB</a> in the
    /// <i>Amazon EC2 User Guide</i>.</p>
    /// </important>
    pub kernel_id: std::option::Option<std::string::String>,
    /// <p>The name of the key pair. You can create a key pair using <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateKeyPair.html">CreateKeyPair</a> or
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ImportKeyPair.html">ImportKeyPair</a>.</p>
    /// <important>
    /// <p>If you do not specify a key pair, you can't connect to the instance unless you
    /// choose an AMI that is configured to allow users another way to log in.</p>
    /// </important>
    pub key_name: std::option::Option<std::string::String>,
    /// <p>The maximum number of instances to launch. If you specify more instances than Amazon
    /// EC2 can launch in the target Availability Zone, Amazon EC2 launches the largest possible
    /// number of instances above <code>MinCount</code>.</p>
    /// <p>Constraints: Between 1 and the maximum number you're allowed for the specified
    /// instance type. For more information about the default limits, and how to request an
    /// increase, see <a href="http://aws.amazon.com/ec2/faqs/#How_many_instances_can_I_run_in_Amazon_EC2">How many instances can I
    /// run in Amazon EC2</a> in the Amazon EC2 FAQ.</p>
    pub max_count: std::option::Option<i32>,
    /// <p>The minimum number of instances to launch. If you specify a minimum that is more
    /// instances than Amazon EC2 can launch in the target Availability Zone, Amazon EC2
    /// launches no instances.</p>
    /// <p>Constraints: Between 1 and the maximum number you're allowed for the specified
    /// instance type. For more information about the default limits, and how to request an
    /// increase, see <a href="http://aws.amazon.com/ec2/faqs/#How_many_instances_can_I_run_in_Amazon_EC2">How many instances can I
    /// run in Amazon EC2</a> in the Amazon EC2 General FAQ.</p>
    pub min_count: std::option::Option<i32>,
    /// <p>Specifies whether detailed monitoring is enabled for the instance.</p>
    pub monitoring: std::option::Option<crate::model::RunInstancesMonitoringEnabled>,
    /// <p>The placement for the instance.</p>
    pub placement: std::option::Option<crate::model::Placement>,
    /// <p>The ID of the RAM disk to select. Some kernels require additional drivers at launch.
    /// Check the kernel requirements for information about whether you need to specify a RAM
    /// disk. To find kernel requirements, go to the Amazon Web Services Resource Center and search for the
    /// kernel ID.</p>
    /// <important>
    /// <p>We recommend that you use PV-GRUB instead of kernels and RAM disks. For more
    /// information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html"> PV-GRUB</a> in the
    /// <i>Amazon EC2 User Guide</i>.</p>
    /// </important>
    pub ramdisk_id: std::option::Option<std::string::String>,
    /// <p>The IDs of the security groups. You can create a security group using
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateSecurityGroup.html">CreateSecurityGroup</a>.</p>
    /// <p>If you specify a network interface, you must specify any security groups as part of the network interface.</p>
    pub security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>[EC2-Classic, default VPC] The names of the security groups. For a nondefault VPC, you
    /// must use security group IDs instead.</p>
    /// <p>If you specify a network interface, you must specify any security groups as part of
    /// the network interface.</p>
    /// <p>Default: Amazon EC2 uses the default security group.</p>
    pub security_groups: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>[EC2-VPC] The ID of the subnet to launch the instance into.</p>
    /// <p>If you specify a network interface, you must specify any subnets as part of the network interface.</p>
    pub subnet_id: std::option::Option<std::string::String>,
    /// <p>The user data to make available to the instance. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/user-data.html">Running commands
    /// on your Linux instance at launch</a> (Linux) and <a href="https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/ec2-instance-metadata.html#instancedata-add-user-data">Adding User Data</a> (Windows). If you are using a command line tool,
    /// base64-encoding is performed for you, and you can load the text from a file. Otherwise,
    /// you must provide base64-encoded text. User data is limited to 16 KB.</p>
    pub user_data: std::option::Option<std::string::String>,
    /// <p>Reserved.</p>
    pub additional_info: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
    /// request. If you do not specify a client token, a randomly generated token is used for the
    /// request to ensure idempotency.</p>
    /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
    /// Idempotency</a>.</p>
    /// <p>Constraints: Maximum 64 ASCII characters</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>If you set this parameter to <code>true</code>, you can't terminate the instance using
    /// the Amazon EC2 console, CLI, or API; otherwise, you can. To change this attribute after launch,
    /// use <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceAttribute.html">ModifyInstanceAttribute</a>.
    /// Alternatively, if you set <code>InstanceInitiatedShutdownBehavior</code> to
    /// <code>terminate</code>, you can terminate the instance by running the shutdown
    /// command from the instance.</p>
    /// <p>Default: <code>false</code>
    /// </p>
    pub disable_api_termination: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Indicates whether the instance is optimized for Amazon EBS I/O. This optimization
    /// provides dedicated throughput to Amazon EBS and an optimized configuration stack to
    /// provide optimal Amazon EBS I/O performance. This optimization isn't available with all
    /// instance types. Additional usage charges apply when using an EBS-optimized
    /// instance.</p>
    /// <p>Default: <code>false</code>
    /// </p>
    pub ebs_optimized: std::option::Option<bool>,
    /// <p>The name or Amazon Resource Name (ARN) of an IAM instance profile.</p>
    pub iam_instance_profile: std::option::Option<crate::model::IamInstanceProfileSpecification>,
    /// <p>Indicates whether an instance stops or terminates when you initiate shutdown from the
    /// instance (using the operating system command for system shutdown).</p>
    /// <p>Default: <code>stop</code>
    /// </p>
    pub instance_initiated_shutdown_behavior: std::option::Option<crate::model::ShutdownBehavior>,
    /// <p>The network interfaces to associate with the instance. If you specify a network interface,
    /// you must specify any security groups and subnets as part of the network interface.</p>
    pub network_interfaces:
        std::option::Option<std::vec::Vec<crate::model::InstanceNetworkInterfaceSpecification>>,
    /// <p>[EC2-VPC] The primary IPv4 address. You must specify a value from the IPv4 address
    /// range of the subnet.</p>
    /// <p>Only one private IP address can be designated as primary. You can't specify this
    /// option if you've specified the option to designate a private IP address as the primary
    /// IP address in a network interface specification. You cannot specify this option if
    /// you're launching more than one instance in the request.</p>
    /// <p>You cannot specify this option and the network interfaces option in the same
    /// request.</p>
    pub private_ip_address: std::option::Option<std::string::String>,
    /// <p>An elastic GPU to associate with the instance. An Elastic GPU is a GPU resource that
    /// you can attach to your Windows instance to accelerate the graphics performance of your
    /// applications. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/elastic-graphics.html">Amazon EC2 Elastic
    /// GPUs</a> in the <i>Amazon EC2 User Guide</i>.</p>
    pub elastic_gpu_specification:
        std::option::Option<std::vec::Vec<crate::model::ElasticGpuSpecification>>,
    /// <p>An elastic inference accelerator to associate with the instance. Elastic inference
    /// accelerators are a resource you can attach to your Amazon EC2 instances to accelerate
    /// your Deep Learning (DL) inference workloads.</p>
    /// <p>You cannot specify accelerators from different generations in the same request.</p>
    pub elastic_inference_accelerators:
        std::option::Option<std::vec::Vec<crate::model::ElasticInferenceAccelerator>>,
    /// <p>The tags to apply to the resources during launch. You can only tag instances and
    /// volumes on launch. The specified tags are applied to all instances or volumes that are
    /// created during launch. To tag a resource after it has been created, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html">CreateTags</a>.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>The launch template to use to launch the instances. Any parameters that you specify in
    /// <a>RunInstances</a> override the same parameters in the launch template.
    /// You can specify either the name or ID of a launch template, but not both.</p>
    pub launch_template: std::option::Option<crate::model::LaunchTemplateSpecification>,
    /// <p>The market (purchasing) option for the instances.</p>
    /// <p>For <a>RunInstances</a>, persistent Spot Instance requests are
    /// only supported when <b>InstanceInterruptionBehavior</b> is set
    /// to either <code>hibernate</code> or <code>stop</code>.</p>
    pub instance_market_options: std::option::Option<crate::model::InstanceMarketOptionsRequest>,
    /// <p>The credit option for CPU usage of the burstable performance instance. Valid values
    /// are <code>standard</code> and <code>unlimited</code>. To change this attribute after
    /// launch, use <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html">
    /// ModifyInstanceCreditSpecification</a>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html">Burstable
    /// performance instances</a> in the <i>Amazon EC2 User Guide</i>.</p>
    /// <p>Default: <code>standard</code> (T2 instances) or <code>unlimited</code> (T3/T3a
    /// instances)</p>
    pub credit_specification: std::option::Option<crate::model::CreditSpecificationRequest>,
    /// <p>The CPU options for the instance. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html">Optimizing CPU options</a> in the <i>Amazon EC2 User Guide</i>.</p>
    pub cpu_options: std::option::Option<crate::model::CpuOptionsRequest>,
    /// <p>Information about the Capacity Reservation targeting option. If you do not specify this parameter, the
    /// instance's Capacity Reservation preference defaults to <code>open</code>, which enables
    /// it to run in any open Capacity Reservation that has matching attributes (instance type,
    /// platform, Availability Zone).</p>
    pub capacity_reservation_specification:
        std::option::Option<crate::model::CapacityReservationSpecification>,
    /// <p>Indicates whether an instance is enabled for hibernation. For more information, see
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html">Hibernate
    /// your instance</a> in the <i>Amazon EC2 User Guide</i>.</p>
    /// <p>You can't enable hibernation and Amazon Web Services Nitro Enclaves on the same instance.</p>
    pub hibernation_options: std::option::Option<crate::model::HibernationOptionsRequest>,
    /// <p>The license configurations.</p>
    pub license_specifications:
        std::option::Option<std::vec::Vec<crate::model::LicenseConfigurationRequest>>,
    /// <p>The metadata options for the instance. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html">Instance metadata and user data</a>.</p>
    pub metadata_options: std::option::Option<crate::model::InstanceMetadataOptionsRequest>,
    /// <p>Indicates whether the instance is enabled for Amazon Web Services Nitro Enclaves. For more information,
    /// see <a href="https://docs.aws.amazon.com/enclaves/latest/user/nitro-enclave.html">
    /// What is Amazon Web Services Nitro Enclaves?</a> in the <i>Amazon Web Services Nitro Enclaves User Guide</i>.</p>    
    /// <p>You can't enable Amazon Web Services Nitro Enclaves and hibernation on the same instance.</p>
    pub enclave_options: std::option::Option<crate::model::EnclaveOptionsRequest>,
}
impl std::fmt::Debug for RunInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RunInstancesInput");
        formatter.field("block_device_mappings", &self.block_device_mappings);
        formatter.field("image_id", &self.image_id);
        formatter.field("instance_type", &self.instance_type);
        formatter.field("ipv6_address_count", &self.ipv6_address_count);
        formatter.field("ipv6_addresses", &self.ipv6_addresses);
        formatter.field("kernel_id", &self.kernel_id);
        formatter.field("key_name", &self.key_name);
        formatter.field("max_count", &self.max_count);
        formatter.field("min_count", &self.min_count);
        formatter.field("monitoring", &self.monitoring);
        formatter.field("placement", &self.placement);
        formatter.field("ramdisk_id", &self.ramdisk_id);
        formatter.field("security_group_ids", &self.security_group_ids);
        formatter.field("security_groups", &self.security_groups);
        formatter.field("subnet_id", &self.subnet_id);
        formatter.field("user_data", &self.user_data);
        formatter.field("additional_info", &self.additional_info);
        formatter.field("client_token", &self.client_token);
        formatter.field("disable_api_termination", &self.disable_api_termination);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("ebs_optimized", &self.ebs_optimized);
        formatter.field("iam_instance_profile", &self.iam_instance_profile);
        formatter.field(
            "instance_initiated_shutdown_behavior",
            &self.instance_initiated_shutdown_behavior,
        );
        formatter.field("network_interfaces", &self.network_interfaces);
        formatter.field("private_ip_address", &self.private_ip_address);
        formatter.field("elastic_gpu_specification", &self.elastic_gpu_specification);
        formatter.field(
            "elastic_inference_accelerators",
            &self.elastic_inference_accelerators,
        );
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("launch_template", &self.launch_template);
        formatter.field("instance_market_options", &self.instance_market_options);
        formatter.field("credit_specification", &self.credit_specification);
        formatter.field("cpu_options", &self.cpu_options);
        formatter.field(
            "capacity_reservation_specification",
            &self.capacity_reservation_specification,
        );
        formatter.field("hibernation_options", &self.hibernation_options);
        formatter.field("license_specifications", &self.license_specifications);
        formatter.field("metadata_options", &self.metadata_options);
        formatter.field("enclave_options", &self.enclave_options);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RevokeSecurityGroupIngressInput {
    /// <p>The CIDR IP address range. You can't specify this parameter when specifying a source security group.</p>
    pub cidr_ip: std::option::Option<std::string::String>,
    /// <p>The start of port range for the TCP and UDP protocols, or an ICMP type number. For the ICMP type number,
    /// use <code>-1</code> to specify all ICMP types.</p>
    pub from_port: std::option::Option<i32>,
    /// <p>The ID of the security group. You must specify either the security group ID or the
    /// security group name in the request. For security groups in a nondefault VPC, you must
    /// specify the security group ID.</p>
    pub group_id: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic, default VPC] The name of the security group. You must specify either the
    /// security group ID or the security group name in the request.</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>The sets of IP permissions. You can't specify a source security group and a CIDR IP address range in the same set of permissions.</p>
    pub ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
    /// <p>The IP protocol name (<code>tcp</code>, <code>udp</code>, <code>icmp</code>) or number
    /// (see <a href="http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml">Protocol Numbers</a>).
    /// Use <code>-1</code> to specify all.</p>
    pub ip_protocol: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic, default VPC] The name of the source security group. You can't specify this parameter in combination with the following parameters: the CIDR IP address range, the start of the port range, the IP protocol, and the end of the port range. For EC2-VPC, the source security group must be in the same VPC. To revoke a specific rule for an IP protocol and port range, use a set of IP permissions instead.</p>
    pub source_security_group_name: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic] The AWS account ID of the source security group, if the source security group is in a different account. You can't specify this parameter in combination with the following parameters: the CIDR IP address range, the IP protocol, the start of the port range, and the end of the port range. To revoke a specific rule for an IP protocol and port range, use a set of IP permissions instead.</p>
    pub source_security_group_owner_id: std::option::Option<std::string::String>,
    /// <p>The end of port range for the TCP and UDP protocols, or an ICMP code number. For the ICMP code number,
    /// use <code>-1</code> to specify all ICMP codes for the ICMP type.</p>
    pub to_port: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RevokeSecurityGroupIngressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RevokeSecurityGroupIngressInput");
        formatter.field("cidr_ip", &self.cidr_ip);
        formatter.field("from_port", &self.from_port);
        formatter.field("group_id", &self.group_id);
        formatter.field("group_name", &self.group_name);
        formatter.field("ip_permissions", &self.ip_permissions);
        formatter.field("ip_protocol", &self.ip_protocol);
        formatter.field(
            "source_security_group_name",
            &self.source_security_group_name,
        );
        formatter.field(
            "source_security_group_owner_id",
            &self.source_security_group_owner_id,
        );
        formatter.field("to_port", &self.to_port);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RevokeSecurityGroupEgressInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the security group.</p>
    pub group_id: std::option::Option<std::string::String>,
    /// <p>The sets of IP permissions. You can't specify a destination security group and a CIDR IP address range in the same set of permissions.</p>
    pub ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
    /// <p>Not supported. Use a set of IP permissions to specify the CIDR.</p>
    pub cidr_ip: std::option::Option<std::string::String>,
    /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
    pub from_port: std::option::Option<i32>,
    /// <p>Not supported. Use a set of IP permissions to specify the protocol name or
    /// number.</p>
    pub ip_protocol: std::option::Option<std::string::String>,
    /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
    pub to_port: std::option::Option<i32>,
    /// <p>Not supported. Use a set of IP permissions to specify a
    /// destination security group.</p>
    pub source_security_group_name: std::option::Option<std::string::String>,
    /// <p>Not supported. Use a set of IP permissions to specify a destination security
    /// group.</p>
    pub source_security_group_owner_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for RevokeSecurityGroupEgressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RevokeSecurityGroupEgressInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_id", &self.group_id);
        formatter.field("ip_permissions", &self.ip_permissions);
        formatter.field("cidr_ip", &self.cidr_ip);
        formatter.field("from_port", &self.from_port);
        formatter.field("ip_protocol", &self.ip_protocol);
        formatter.field("to_port", &self.to_port);
        formatter.field(
            "source_security_group_name",
            &self.source_security_group_name,
        );
        formatter.field(
            "source_security_group_owner_id",
            &self.source_security_group_owner_id,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RevokeClientVpnIngressInput {
    /// <p>The ID of the Client VPN endpoint with which the authorization rule is associated.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The IPv4 address range, in CIDR notation, of the network for which access is being removed.</p>
    pub target_network_cidr: std::option::Option<std::string::String>,
    /// <p>The ID of the Active Directory group for which to revoke access. </p>
    pub access_group_id: std::option::Option<std::string::String>,
    /// <p>Indicates whether access should be revoked for all clients.</p>
    pub revoke_all_groups: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RevokeClientVpnIngressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RevokeClientVpnIngressInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("target_network_cidr", &self.target_network_cidr);
        formatter.field("access_group_id", &self.access_group_id);
        formatter.field("revoke_all_groups", &self.revoke_all_groups);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RestoreManagedPrefixListVersionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the prefix list.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
    /// <p>The version to restore.</p>
    pub previous_version: std::option::Option<i64>,
    /// <p>The current version number for the prefix list.</p>
    pub current_version: std::option::Option<i64>,
}
impl std::fmt::Debug for RestoreManagedPrefixListVersionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RestoreManagedPrefixListVersionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.field("previous_version", &self.previous_version);
        formatter.field("current_version", &self.current_version);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RestoreAddressToClassicInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The Elastic IP address.</p>
    pub public_ip: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for RestoreAddressToClassicInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RestoreAddressToClassicInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("public_ip", &self.public_ip);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResetSnapshotAttributeInput {
    /// <p>The attribute to reset. Currently, only the attribute for permission to create volumes can
    /// be reset.</p>
    pub attribute: std::option::Option<crate::model::SnapshotAttributeName>,
    /// <p>The ID of the snapshot.</p>
    pub snapshot_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ResetSnapshotAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResetSnapshotAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("snapshot_id", &self.snapshot_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for ResetNetworkInterfaceAttribute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResetNetworkInterfaceAttributeInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The source/destination checking attribute. Resets the value to <code>true</code>.</p>
    pub source_dest_check: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ResetNetworkInterfaceAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResetNetworkInterfaceAttributeInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("source_dest_check", &self.source_dest_check);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResetInstanceAttributeInput {
    /// <p>The attribute to reset.</p>
    /// <important>
    /// <p>You can only reset the following attributes: <code>kernel</code> |
    /// <code>ramdisk</code> | <code>sourceDestCheck</code>. To change an instance
    /// attribute, use <a>ModifyInstanceAttribute</a>.</p>
    /// </important>
    pub attribute: std::option::Option<crate::model::InstanceAttributeName>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ResetInstanceAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResetInstanceAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for ResetImageAttribute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResetImageAttributeInput {
    /// <p>The attribute to reset (currently you can only reset the launch permission attribute).</p>
    pub attribute: std::option::Option<crate::model::ResetImageAttributeName>,
    /// <p>The ID of the AMI.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ResetImageAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResetImageAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("image_id", &self.image_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResetFpgaImageAttributeInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the AFI.</p>
    pub fpga_image_id: std::option::Option<std::string::String>,
    /// <p>The attribute.</p>
    pub attribute: std::option::Option<crate::model::ResetFpgaImageAttributeName>,
}
impl std::fmt::Debug for ResetFpgaImageAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResetFpgaImageAttributeInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("fpga_image_id", &self.fpga_image_id);
        formatter.field("attribute", &self.attribute);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResetEbsDefaultKmsKeyIdInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ResetEbsDefaultKmsKeyIdInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResetEbsDefaultKmsKeyIdInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResetAddressAttributeInput {
    /// <p>[EC2-VPC] The allocation ID.</p>
    pub allocation_id: std::option::Option<std::string::String>,
    /// <p>The attribute of the IP address.</p>
    pub attribute: std::option::Option<crate::model::AddressAttributeName>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ResetAddressAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResetAddressAttributeInput");
        formatter.field("allocation_id", &self.allocation_id);
        formatter.field("attribute", &self.attribute);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for RequestSpotInstances.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RequestSpotInstancesInput {
    /// <p>The user-specified name for a logical grouping of requests.</p>
    /// <p>When you specify an Availability Zone group in a Spot Instance request, all Spot
    /// Instances in the request are launched in the same Availability Zone. Instance proximity
    /// is maintained with this parameter, but the choice of Availability Zone is not. The group
    /// applies only to requests for Spot Instances of the same instance type. Any additional
    /// Spot Instance requests that are specified with the same Availability Zone group name are
    /// launched in that same Availability Zone, as long as at least one instance from the group
    /// is still active.</p>
    /// <p>If there is no active instance running in the Availability Zone group that you specify
    /// for a new Spot Instance request (all instances are terminated, the request is expired,
    /// or the maximum price you specified falls below current Spot price), then Amazon EC2 launches
    /// the instance in any Availability Zone where the constraint can be met. Consequently, the
    /// subsequent set of Spot Instances could be placed in a different zone from the original
    /// request, even if you specified the same Availability Zone group.</p>
    /// <p>Default: Instances are launched in any available Availability Zone.</p>
    pub availability_zone_group: std::option::Option<std::string::String>,
    /// <p>Deprecated.</p>
    pub block_duration_minutes: std::option::Option<i32>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a> in the <i>Amazon EC2 User Guide for Linux Instances</i>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of Spot Instances to launch.</p>
    /// <p>Default: 1</p>
    pub instance_count: std::option::Option<i32>,
    /// <p>The instance launch group. Launch groups are Spot Instances that launch together and
    /// terminate together.</p>
    /// <p>Default: Instances are launched and terminated individually</p>
    pub launch_group: std::option::Option<std::string::String>,
    /// <p>The launch specification.</p>
    pub launch_specification: std::option::Option<crate::model::RequestSpotLaunchSpecification>,
    /// <p>The maximum price per hour that you are willing to pay for a Spot Instance. The
    /// default is the On-Demand price.</p>
    pub spot_price: std::option::Option<std::string::String>,
    /// <p>The Spot Instance request type.</p>
    /// <p>Default: <code>one-time</code>
    /// </p>
    pub r#type: std::option::Option<crate::model::SpotInstanceType>,
    /// <p>The start date of the request. If this is a one-time request, the request becomes
    /// active at this date and time and remains active until all instances launch, the request
    /// expires, or the request is canceled. If the request is persistent, the request becomes
    /// active at this date and time and remains active until it expires or is canceled.</p>
    /// <p>The specified start date and time cannot be equal to the current date and time. You
    /// must specify a start date and time that occurs after the current date and time.</p>
    pub valid_from: std::option::Option<smithy_types::Instant>,
    /// <p>The end date of the request, in UTC format
    /// (<i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
    /// <ul>
    /// <li>
    /// <p>For a persistent request, the request remains active until the
    /// <code>ValidUntil</code> date and time is reached. Otherwise, the request
    /// remains active until you cancel it. </p>
    /// </li>
    /// <li>
    /// <p>For a one-time request, the request remains active until all instances launch,
    /// the request is canceled, or the <code>ValidUntil</code> date and time is
    /// reached. By default, the request is valid for 7 days from the date the request
    /// was created.</p>
    /// </li>
    /// </ul>
    pub valid_until: std::option::Option<smithy_types::Instant>,
    /// <p>The key-value pair for tagging the Spot Instance request on creation. The value for
    /// <code>ResourceType</code> must be <code>spot-instances-request</code>, otherwise the
    /// Spot Instance request fails. To tag the Spot Instance request after it has been created,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html">CreateTags</a>. </p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>The behavior when a Spot Instance is interrupted. The default is <code>terminate</code>.</p>
    pub instance_interruption_behavior:
        std::option::Option<crate::model::InstanceInterruptionBehavior>,
}
impl std::fmt::Debug for RequestSpotInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RequestSpotInstancesInput");
        formatter.field("availability_zone_group", &self.availability_zone_group);
        formatter.field("block_duration_minutes", &self.block_duration_minutes);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_count", &self.instance_count);
        formatter.field("launch_group", &self.launch_group);
        formatter.field("launch_specification", &self.launch_specification);
        formatter.field("spot_price", &self.spot_price);
        formatter.field("r#type", &self.r#type);
        formatter.field("valid_from", &self.valid_from);
        formatter.field("valid_until", &self.valid_until);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field(
            "instance_interruption_behavior",
            &self.instance_interruption_behavior,
        );
        formatter.finish()
    }
}

/// <p>Contains the parameters for RequestSpotFleet.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RequestSpotFleetInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The configuration for the Spot Fleet request.</p>
    pub spot_fleet_request_config: std::option::Option<crate::model::SpotFleetRequestConfigData>,
}
impl std::fmt::Debug for RequestSpotFleetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RequestSpotFleetInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("spot_fleet_request_config", &self.spot_fleet_request_config);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReportInstanceStatusInput {
    /// <p>Descriptive text about the health state of your instance.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The time at which the reported instance health state ended.</p>
    pub end_time: std::option::Option<smithy_types::Instant>,
    /// <p>The instances.</p>
    pub instances: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The reason codes that describe the health state of your instance.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-stuck-in-state</code>: My instance is stuck in a state.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>unresponsive</code>: My instance is unresponsive.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>not-accepting-credentials</code>: My instance is not accepting my
    /// credentials.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>password-not-available</code>: A password is not available for my
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>performance-network</code>: My instance is experiencing performance
    /// problems that I believe are network related.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>performance-instance-store</code>: My instance is experiencing performance
    /// problems that I believe are related to the instance stores.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>performance-ebs-volume</code>: My instance is experiencing performance
    /// problems that I believe are related to an EBS volume.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>performance-other</code>: My instance is experiencing performance
    /// problems.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>other</code>: [explain using the description parameter]</p>
    /// </li>
    /// </ul>
    pub reason_codes: std::option::Option<std::vec::Vec<crate::model::ReportInstanceReasonCodes>>,
    /// <p>The time at which the reported instance health state began.</p>
    pub start_time: std::option::Option<smithy_types::Instant>,
    /// <p>The status of all instances listed.</p>
    pub status: std::option::Option<crate::model::ReportStatusType>,
}
impl std::fmt::Debug for ReportInstanceStatusInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReportInstanceStatusInput");
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("end_time", &self.end_time);
        formatter.field("instances", &self.instances);
        formatter.field("reason_codes", &self.reason_codes);
        formatter.field("start_time", &self.start_time);
        formatter.field("status", &self.status);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReplaceTransitGatewayRouteInput {
    /// <p>The CIDR range used for the destination match. Routing decisions are based on the most specific match.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Indicates whether traffic matching this route is to be dropped.</p>
    pub blackhole: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ReplaceTransitGatewayRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReplaceTransitGatewayRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("blackhole", &self.blackhole);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReplaceRouteTableAssociationInput {
    /// <p>The association ID.</p>
    pub association_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the new route table to associate with the subnet.</p>
    pub route_table_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ReplaceRouteTableAssociationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReplaceRouteTableAssociationInput");
        formatter.field("association_id", &self.association_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReplaceRouteInput {
    /// <p>The IPv4 CIDR address block used for the destination match. The value that you
    /// provide must match the CIDR of an existing route in the table.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The IPv6 CIDR address block used for the destination match. The value that you
    /// provide must match the CIDR of an existing route in the table.</p>
    pub destination_ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the prefix list for the route.</p>
    pub destination_prefix_list_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of a VPC endpoint. Supported for Gateway Load Balancer endpoints only.</p>
    pub vpc_endpoint_id: std::option::Option<std::string::String>,
    /// <p>[IPv6 traffic only] The ID of an egress-only internet gateway.</p>
    pub egress_only_internet_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of an internet gateway or virtual private gateway.</p>
    pub gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of a NAT instance in your VPC.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>Specifies whether to reset the local route to its default target (<code>local</code>).</p>
    pub local_target: std::option::Option<bool>,
    /// <p>[IPv4 traffic only] The ID of a NAT gateway.</p>
    pub nat_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of a transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the local gateway.</p>
    pub local_gateway_id: std::option::Option<std::string::String>,
    /// <p>[IPv4 traffic only] The ID of a carrier gateway.</p>
    pub carrier_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of a network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The ID of the route table.</p>
    pub route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of a VPC peering connection.</p>
    pub vpc_peering_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ReplaceRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReplaceRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field(
            "destination_ipv6_cidr_block",
            &self.destination_ipv6_cidr_block,
        );
        formatter.field(
            "destination_prefix_list_id",
            &self.destination_prefix_list_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_endpoint_id", &self.vpc_endpoint_id);
        formatter.field(
            "egress_only_internet_gateway_id",
            &self.egress_only_internet_gateway_id,
        );
        formatter.field("gateway_id", &self.gateway_id);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("local_target", &self.local_target);
        formatter.field("nat_gateway_id", &self.nat_gateway_id);
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("local_gateway_id", &self.local_gateway_id);
        formatter.field("carrier_gateway_id", &self.carrier_gateway_id);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.field("vpc_peering_connection_id", &self.vpc_peering_connection_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReplaceNetworkAclEntryInput {
    /// <p>The IPv4 network range to allow or deny, in CIDR notation (for example
    /// <code>172.16.0.0/24</code>).</p>
    pub cidr_block: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Indicates whether to replace the egress rule.</p>
    /// <p>Default: If no value is specified, we replace the ingress rule.</p>
    pub egress: std::option::Option<bool>,
    /// <p>ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol
    /// 1 (ICMP) or protocol 58 (ICMPv6) with an IPv6 CIDR block.</p>
    pub icmp_type_code: std::option::Option<crate::model::IcmpTypeCode>,
    /// <p>The IPv6 network range to allow or deny, in CIDR notation (for example
    /// <code>2001:bd8:1234:1a00::/64</code>).</p>
    pub ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the ACL.</p>
    pub network_acl_id: std::option::Option<std::string::String>,
    /// <p>TCP or UDP protocols: The range of ports the rule applies to.
    /// Required if specifying protocol 6 (TCP) or 17 (UDP).</p>
    pub port_range: std::option::Option<crate::model::PortRange>,
    /// <p>The protocol number. A value of "-1" means all protocols. If you specify "-1" or a
    /// protocol number other than "6" (TCP), "17" (UDP), or "1" (ICMP), traffic on all ports is
    /// allowed, regardless of any ports or ICMP types or codes that you specify. If you specify
    /// protocol "58" (ICMPv6) and specify an IPv4 CIDR block, traffic for all ICMP types and
    /// codes allowed, regardless of any that you specify. If you specify protocol "58" (ICMPv6)
    /// and specify an IPv6 CIDR block, you must specify an ICMP type and code.</p>
    pub protocol: std::option::Option<std::string::String>,
    /// <p>Indicates whether to allow or deny the traffic that matches the rule.</p>
    pub rule_action: std::option::Option<crate::model::RuleAction>,
    /// <p>The rule number of the entry to replace.</p>
    pub rule_number: std::option::Option<i32>,
}
impl std::fmt::Debug for ReplaceNetworkAclEntryInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReplaceNetworkAclEntryInput");
        formatter.field("cidr_block", &self.cidr_block);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("egress", &self.egress);
        formatter.field("icmp_type_code", &self.icmp_type_code);
        formatter.field("ipv6_cidr_block", &self.ipv6_cidr_block);
        formatter.field("network_acl_id", &self.network_acl_id);
        formatter.field("port_range", &self.port_range);
        formatter.field("protocol", &self.protocol);
        formatter.field("rule_action", &self.rule_action);
        formatter.field("rule_number", &self.rule_number);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReplaceNetworkAclAssociationInput {
    /// <p>The ID of the current association between the original network ACL and the subnet.</p>
    pub association_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the new network ACL to associate with the subnet.</p>
    pub network_acl_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ReplaceNetworkAclAssociationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReplaceNetworkAclAssociationInput");
        formatter.field("association_id", &self.association_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_acl_id", &self.network_acl_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReplaceIamInstanceProfileAssociationInput {
    /// <p>The IAM instance profile.</p>
    pub iam_instance_profile: std::option::Option<crate::model::IamInstanceProfileSpecification>,
    /// <p>The ID of the existing IAM instance profile association.</p>
    pub association_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ReplaceIamInstanceProfileAssociationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReplaceIamInstanceProfileAssociationInput");
        formatter.field("iam_instance_profile", &self.iam_instance_profile);
        formatter.field("association_id", &self.association_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReleaseHostsInput {
    /// <p>The IDs of the Dedicated Hosts to release.</p>
    pub host_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for ReleaseHostsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReleaseHostsInput");
        formatter.field("host_ids", &self.host_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ReleaseAddressInput {
    /// <p>[EC2-VPC] The allocation ID. Required for EC2-VPC.</p>
    pub allocation_id: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic] The Elastic IP address. Required for EC2-Classic.</p>
    pub public_ip: std::option::Option<std::string::String>,
    /// <p>The set of Availability Zones, Local Zones, or Wavelength Zones from which AWS advertises
    /// IP addresses.</p>
    /// <p>If you provide an incorrect network border group, you will receive an <code>InvalidAddress.NotFound</code> error. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html">Error Codes</a>.</p>
    /// <note>
    /// <p>You cannot use a network border group with EC2 Classic. If you attempt this operation on EC2 classic, you will receive an <code>InvalidParameterCombination</code> error. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html">Error Codes</a>.</p>
    /// </note>
    pub network_border_group: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ReleaseAddressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ReleaseAddressInput");
        formatter.field("allocation_id", &self.allocation_id);
        formatter.field("public_ip", &self.public_ip);
        formatter.field("network_border_group", &self.network_border_group);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RejectVpcPeeringConnectionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC peering connection.</p>
    pub vpc_peering_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for RejectVpcPeeringConnectionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RejectVpcPeeringConnectionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_peering_connection_id", &self.vpc_peering_connection_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RejectVpcEndpointConnectionsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the service.</p>
    pub service_id: std::option::Option<std::string::String>,
    /// <p>The IDs of one or more VPC endpoints.</p>
    pub vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for RejectVpcEndpointConnectionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RejectVpcEndpointConnectionsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_id", &self.service_id);
        formatter.field("vpc_endpoint_ids", &self.vpc_endpoint_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RejectTransitGatewayVpcAttachmentInput {
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RejectTransitGatewayVpcAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RejectTransitGatewayVpcAttachmentInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RejectTransitGatewayPeeringAttachmentInput {
    /// <p>The ID of the transit gateway peering attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RejectTransitGatewayPeeringAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RejectTransitGatewayPeeringAttachmentInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RejectTransitGatewayMulticastDomainAssociationsInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The ID of the transit gateway attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>The IDs of the subnets to associate with the transit gateway multicast domain.</p>
    pub subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RejectTransitGatewayMulticastDomainAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RejectTransitGatewayMulticastDomainAssociationsInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("subnet_ids", &self.subnet_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RegisterTransitGatewayMulticastGroupSourcesInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The IP address assigned to the  transit gateway multicast group.</p>
    pub group_ip_address: std::option::Option<std::string::String>,
    /// <p>The group sources' network interface IDs to register with the  transit gateway multicast group.</p>
    pub network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RegisterTransitGatewayMulticastGroupSourcesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RegisterTransitGatewayMulticastGroupSourcesInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field("group_ip_address", &self.group_ip_address);
        formatter.field("network_interface_ids", &self.network_interface_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RegisterTransitGatewayMulticastGroupMembersInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The IP address assigned to the  transit gateway multicast group.</p>
    pub group_ip_address: std::option::Option<std::string::String>,
    /// <p>The group members' network interface IDs to register with the  transit gateway multicast group.</p>
    pub network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RegisterTransitGatewayMulticastGroupMembersInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RegisterTransitGatewayMulticastGroupMembersInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field("group_ip_address", &self.group_ip_address);
        formatter.field("network_interface_ids", &self.network_interface_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RegisterInstanceEventNotificationAttributesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Information about the tag keys to register.</p>
    pub instance_tag_attribute:
        std::option::Option<crate::model::RegisterInstanceTagAttributeRequest>,
}
impl std::fmt::Debug for RegisterInstanceEventNotificationAttributesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RegisterInstanceEventNotificationAttributesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_tag_attribute", &self.instance_tag_attribute);
        formatter.finish()
    }
}

/// <p>Contains the parameters for RegisterImage.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RegisterImageInput {
    /// <p>The full path to your AMI manifest in Amazon S3 storage. The specified bucket must have the
    /// <code>aws-exec-read</code> canned access control list (ACL) to ensure that it can be accessed
    /// by Amazon EC2. For more information, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl">Canned ACLs</a> in the
    /// <i>Amazon S3 Service Developer Guide</i>.</p>
    pub image_location: std::option::Option<std::string::String>,
    /// <p>The architecture of the AMI.</p>
    /// <p>Default: For Amazon EBS-backed AMIs, <code>i386</code>.
    /// For instance store-backed AMIs, the architecture specified in the manifest file.</p>
    pub architecture: std::option::Option<crate::model::ArchitectureValues>,
    /// <p>The block device mapping entries.</p>
    /// <p>If you specify an EBS volume using the ID of an EBS snapshot, you can't specify the encryption state of the volume.</p>
    /// <p>If you create an AMI on an Outpost, then all backing snapshots must be on the same Outpost or in the Region
    /// of that Outpost. AMIs on an Outpost that include local snapshots can be used to launch instances on the same Outpost
    /// only. For more information, <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#ami">
    /// Amazon EBS local snapshots on Outposts</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub block_device_mappings: std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
    /// <p>A description for your AMI.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Set to <code>true</code> to enable enhanced networking with ENA for the AMI and any instances that you launch from the AMI.</p>
    /// <p>This option is supported only for HVM AMIs. Specifying this option with a PV AMI can make instances launched from the AMI unreachable.</p>
    pub ena_support: std::option::Option<bool>,
    /// <p>The ID of the kernel.</p>
    pub kernel_id: std::option::Option<std::string::String>,
    /// <p>A name for your AMI.</p>
    /// <p>Constraints: 3-128 alphanumeric characters, parentheses (()), square brackets ([]), spaces ( ), periods (.), slashes (/), dashes (-), single quotes ('), at-signs (@), or underscores(_)</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>The billing product codes. Your account must be authorized to specify billing product codes. Otherwise,
    /// you can use the AWS Marketplace to bill for the use of an AMI.</p>
    pub billing_products: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of the RAM disk.</p>
    pub ramdisk_id: std::option::Option<std::string::String>,
    /// <p>The device name of the root device volume (for example, <code>/dev/sda1</code>).</p>
    pub root_device_name: std::option::Option<std::string::String>,
    /// <p>Set to <code>simple</code> to enable enhanced networking with the Intel 82599 Virtual Function interface for the AMI and any instances that you launch from the AMI.</p>
    /// <p>There is no way to disable <code>sriovNetSupport</code> at this time.</p>
    /// <p>This option is supported only for HVM AMIs. Specifying this option with a PV AMI can make instances launched from the AMI unreachable.</p>
    pub sriov_net_support: std::option::Option<std::string::String>,
    /// <p>The type of virtualization (<code>hvm</code> | <code>paravirtual</code>).</p>
    /// <p>Default: <code>paravirtual</code>
    /// </p>
    pub virtualization_type: std::option::Option<std::string::String>,
    /// <p>The boot mode of the AMI. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ami-boot.html">Boot modes</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub boot_mode: std::option::Option<crate::model::BootModeValues>,
}
impl std::fmt::Debug for RegisterImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RegisterImageInput");
        formatter.field("image_location", &self.image_location);
        formatter.field("architecture", &self.architecture);
        formatter.field("block_device_mappings", &self.block_device_mappings);
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("ena_support", &self.ena_support);
        formatter.field("kernel_id", &self.kernel_id);
        formatter.field("name", &self.name);
        formatter.field("billing_products", &self.billing_products);
        formatter.field("ramdisk_id", &self.ramdisk_id);
        formatter.field("root_device_name", &self.root_device_name);
        formatter.field("sriov_net_support", &self.sriov_net_support);
        formatter.field("virtualization_type", &self.virtualization_type);
        formatter.field("boot_mode", &self.boot_mode);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RebootInstancesInput {
    /// <p>The instance IDs.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for RebootInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RebootInstancesInput");
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for PurchaseScheduledInstances.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PurchaseScheduledInstancesInput {
    /// <p>Unique, case-sensitive identifier that ensures the idempotency of the request.
    /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The purchase requests.</p>
    pub purchase_requests: std::option::Option<std::vec::Vec<crate::model::PurchaseRequest>>,
}
impl std::fmt::Debug for PurchaseScheduledInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PurchaseScheduledInstancesInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("purchase_requests", &self.purchase_requests);
        formatter.finish()
    }
}

/// <p>Contains the parameters for PurchaseReservedInstancesOffering.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PurchaseReservedInstancesOfferingInput {
    /// <p>The number of Reserved Instances to purchase.</p>
    pub instance_count: std::option::Option<i32>,
    /// <p>The ID of the Reserved Instance offering to purchase.</p>
    pub reserved_instances_offering_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Specified for Reserved Instance Marketplace offerings to limit the total order and ensure that the Reserved Instances are not purchased at unexpected prices.</p>
    pub limit_price: std::option::Option<crate::model::ReservedInstanceLimitPrice>,
    /// <p>The time at which to purchase the Reserved Instance, in UTC format (for example, <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
    pub purchase_time: std::option::Option<smithy_types::Instant>,
}
impl std::fmt::Debug for PurchaseReservedInstancesOfferingInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PurchaseReservedInstancesOfferingInput");
        formatter.field("instance_count", &self.instance_count);
        formatter.field(
            "reserved_instances_offering_id",
            &self.reserved_instances_offering_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field("limit_price", &self.limit_price);
        formatter.field("purchase_time", &self.purchase_time);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PurchaseHostReservationInput {
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The currency in which the <code>totalUpfrontPrice</code>, <code>LimitPrice</code>,
    /// and <code>totalHourlyPrice</code> amounts are specified. At this time, the only
    /// supported currency is <code>USD</code>.</p>
    pub currency_code: std::option::Option<crate::model::CurrencyCodeValues>,
    /// <p>The IDs of the Dedicated Hosts with which the reservation will be associated.</p>
    pub host_id_set: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The specified limit is checked against the total upfront cost of the reservation
    /// (calculated as the offering's upfront cost multiplied by the host count). If the total
    /// upfront cost is greater than the specified price limit, the request fails. This is used
    /// to ensure that the purchase does not exceed the expected upfront cost of the purchase.
    /// At this time, the only supported currency is <code>USD</code>. For example, to indicate
    /// a limit price of USD 100, specify 100.00.</p>
    pub limit_price: std::option::Option<std::string::String>,
    /// <p>The ID of the offering.</p>
    pub offering_id: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the Dedicated Host Reservation during purchase.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for PurchaseHostReservationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PurchaseHostReservationInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("currency_code", &self.currency_code);
        formatter.field("host_id_set", &self.host_id_set);
        formatter.field("limit_price", &self.limit_price);
        formatter.field("offering_id", &self.offering_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ProvisionByoipCidrInput {
    /// <p>The public IPv4 or IPv6 address range, in CIDR notation. The most specific IPv4 prefix that you can
    /// specify is /24. The most specific IPv6 prefix you can specify is /56. The address range cannot overlap with another address range that you've
    /// brought to this or another Region.</p>
    pub cidr: std::option::Option<std::string::String>,
    /// <p>A signed document that proves that you are authorized to bring the specified IP address
    /// range to Amazon using BYOIP.</p>
    pub cidr_authorization_context: std::option::Option<crate::model::CidrAuthorizationContext>,
    /// <p>(IPv6 only) Indicate whether the address range will be publicly advertised to the
    /// internet.</p>
    /// <p>Default: true</p>
    pub publicly_advertisable: std::option::Option<bool>,
    /// <p>A description for the address range and the address pool.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tags to apply to the address pool.</p>
    pub pool_tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <para>Reserved.</para>
    pub multi_region: std::option::Option<bool>,
}
impl std::fmt::Debug for ProvisionByoipCidrInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ProvisionByoipCidrInput");
        formatter.field("cidr", &self.cidr);
        formatter.field(
            "cidr_authorization_context",
            &self.cidr_authorization_context,
        );
        formatter.field("publicly_advertisable", &self.publicly_advertisable);
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("pool_tag_specifications", &self.pool_tag_specifications);
        formatter.field("multi_region", &self.multi_region);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct MoveAddressToVpcInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The Elastic IP address.</p>
    pub public_ip: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for MoveAddressToVpcInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("MoveAddressToVpcInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("public_ip", &self.public_ip);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct MonitorInstancesInput {
    /// <p>The IDs of the instances.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for MonitorInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("MonitorInstancesInput");
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpnTunnelOptionsInput {
    /// <p>The ID of the AWS Site-to-Site VPN connection.</p>
    pub vpn_connection_id: std::option::Option<std::string::String>,
    /// <p>The external IP address of the VPN tunnel.</p>
    pub vpn_tunnel_outside_ip_address: std::option::Option<std::string::String>,
    /// <p>The tunnel options to modify.</p>
    pub tunnel_options: std::option::Option<crate::model::ModifyVpnTunnelOptionsSpecification>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVpnTunnelOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpnTunnelOptionsInput");
        formatter.field("vpn_connection_id", &self.vpn_connection_id);
        formatter.field(
            "vpn_tunnel_outside_ip_address",
            &self.vpn_tunnel_outside_ip_address,
        );
        formatter.field("tunnel_options", &self.tunnel_options);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpnTunnelCertificateInput {
    /// <p>The ID of the AWS Site-to-Site VPN connection.</p>
    pub vpn_connection_id: std::option::Option<std::string::String>,
    /// <p>The external IP address of the VPN tunnel.</p>
    pub vpn_tunnel_outside_ip_address: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVpnTunnelCertificateInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpnTunnelCertificateInput");
        formatter.field("vpn_connection_id", &self.vpn_connection_id);
        formatter.field(
            "vpn_tunnel_outside_ip_address",
            &self.vpn_tunnel_outside_ip_address,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpnConnectionOptionsInput {
    /// <p>The ID of the Site-to-Site VPN connection.
    /// </p>
    pub vpn_connection_id: std::option::Option<std::string::String>,
    /// <p>The IPv4 CIDR on the customer gateway (on-premises) side of the VPN connection.</p>
    /// <p>Default: <code>0.0.0.0/0</code>
    /// </p>
    pub local_ipv4_network_cidr: std::option::Option<std::string::String>,
    /// <p>The IPv4 CIDR on the AWS side of the VPN connection.</p>
    /// <p>Default: <code>0.0.0.0/0</code>
    /// </p>
    pub remote_ipv4_network_cidr: std::option::Option<std::string::String>,
    /// <p>The IPv6 CIDR on the customer gateway (on-premises) side of the VPN connection.</p>
    /// <p>Default: <code>::/0</code>
    /// </p>
    pub local_ipv6_network_cidr: std::option::Option<std::string::String>,
    /// <p>The IPv6 CIDR on the AWS side of the VPN connection.</p>
    /// <p>Default: <code>::/0</code>
    /// </p>
    pub remote_ipv6_network_cidr: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVpnConnectionOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpnConnectionOptionsInput");
        formatter.field("vpn_connection_id", &self.vpn_connection_id);
        formatter.field("local_ipv4_network_cidr", &self.local_ipv4_network_cidr);
        formatter.field("remote_ipv4_network_cidr", &self.remote_ipv4_network_cidr);
        formatter.field("local_ipv6_network_cidr", &self.local_ipv6_network_cidr);
        formatter.field("remote_ipv6_network_cidr", &self.remote_ipv6_network_cidr);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpnConnectionInput {
    /// <p>The ID of the VPN connection.</p>
    pub vpn_connection_id: std::option::Option<std::string::String>,
    /// <p>The ID of the transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the customer gateway at your end of the VPN connection.</p>
    pub customer_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the virtual private gateway at the AWS side of the VPN connection.</p>
    pub vpn_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVpnConnectionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpnConnectionInput");
        formatter.field("vpn_connection_id", &self.vpn_connection_id);
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("customer_gateway_id", &self.customer_gateway_id);
        formatter.field("vpn_gateway_id", &self.vpn_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpcTenancyInput {
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The instance tenancy attribute for the VPC. </p>
    pub instance_tenancy: std::option::Option<crate::model::VpcTenancy>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVpcTenancyInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpcTenancyInput");
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("instance_tenancy", &self.instance_tenancy);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpcPeeringConnectionOptionsInput {
    /// <p>The VPC peering connection options for the accepter VPC.</p>
    pub accepter_peering_connection_options:
        std::option::Option<crate::model::PeeringConnectionOptionsRequest>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The VPC peering connection options for the requester VPC.</p>
    pub requester_peering_connection_options:
        std::option::Option<crate::model::PeeringConnectionOptionsRequest>,
    /// <p>The ID of the VPC peering connection.</p>
    pub vpc_peering_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyVpcPeeringConnectionOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpcPeeringConnectionOptionsInput");
        formatter.field(
            "accepter_peering_connection_options",
            &self.accepter_peering_connection_options,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "requester_peering_connection_options",
            &self.requester_peering_connection_options,
        );
        formatter.field("vpc_peering_connection_id", &self.vpc_peering_connection_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpcEndpointServicePermissionsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the service.</p>
    pub service_id: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Names (ARN) of one or more principals.
    /// Permissions are granted to the principals in this list.
    /// To grant permissions to all principals, specify an asterisk (*).</p>
    pub add_allowed_principals: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The Amazon Resource Names (ARN) of one or more principals.
    /// Permissions are revoked for principals in this list.</p>
    pub remove_allowed_principals: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for ModifyVpcEndpointServicePermissionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpcEndpointServicePermissionsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_id", &self.service_id);
        formatter.field("add_allowed_principals", &self.add_allowed_principals);
        formatter.field("remove_allowed_principals", &self.remove_allowed_principals);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpcEndpointServiceConfigurationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the service.</p>
    pub service_id: std::option::Option<std::string::String>,
    /// <p>(Interface endpoint configuration) The private DNS name to assign to the endpoint service.</p>
    pub private_dns_name: std::option::Option<std::string::String>,
    /// <p>(Interface endpoint configuration) Removes the private DNS name of the endpoint service.</p>
    pub remove_private_dns_name: std::option::Option<bool>,
    /// <p>Indicates whether requests to create an endpoint to your service must be accepted.</p>
    pub acceptance_required: std::option::Option<bool>,
    /// <p>The Amazon Resource Names (ARNs) of Network Load Balancers to add to your service
    /// configuration.</p>
    pub add_network_load_balancer_arns: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The Amazon Resource Names (ARNs) of Network Load Balancers to remove from your service
    /// configuration.</p>
    pub remove_network_load_balancer_arns: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The Amazon Resource Names (ARNs) of Gateway Load Balancers to add to your service
    /// configuration.</p>
    pub add_gateway_load_balancer_arns: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The Amazon Resource Names (ARNs) of Gateway Load Balancers to remove from your service
    /// configuration.</p>
    pub remove_gateway_load_balancer_arns: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for ModifyVpcEndpointServiceConfigurationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpcEndpointServiceConfigurationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_id", &self.service_id);
        formatter.field("private_dns_name", &self.private_dns_name);
        formatter.field("remove_private_dns_name", &self.remove_private_dns_name);
        formatter.field("acceptance_required", &self.acceptance_required);
        formatter.field(
            "add_network_load_balancer_arns",
            &self.add_network_load_balancer_arns,
        );
        formatter.field(
            "remove_network_load_balancer_arns",
            &self.remove_network_load_balancer_arns,
        );
        formatter.field(
            "add_gateway_load_balancer_arns",
            &self.add_gateway_load_balancer_arns,
        );
        formatter.field(
            "remove_gateway_load_balancer_arns",
            &self.remove_gateway_load_balancer_arns,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpcEndpointConnectionNotificationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the notification.</p>
    pub connection_notification_id: std::option::Option<std::string::String>,
    /// <p>The ARN for the SNS topic for the notification.</p>
    pub connection_notification_arn: std::option::Option<std::string::String>,
    /// <p>One or more events for the endpoint. Valid values are <code>Accept</code>,
    /// <code>Connect</code>, <code>Delete</code>, and <code>Reject</code>.</p>
    pub connection_events: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for ModifyVpcEndpointConnectionNotificationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpcEndpointConnectionNotificationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "connection_notification_id",
            &self.connection_notification_id,
        );
        formatter.field(
            "connection_notification_arn",
            &self.connection_notification_arn,
        );
        formatter.field("connection_events", &self.connection_events);
        formatter.finish()
    }
}

/// <p>Contains the parameters for ModifyVpcEndpoint.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpcEndpointInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the endpoint.</p>
    pub vpc_endpoint_id: std::option::Option<std::string::String>,
    /// <p>(Gateway endpoint) Specify <code>true</code> to reset the policy document to the
    /// default policy. The default policy allows full access to the service.</p>
    pub reset_policy: std::option::Option<bool>,
    /// <p>(Interface and gateway endpoints) A policy to attach to the endpoint that controls access to the service. The policy must
    /// be in valid JSON format.</p>
    pub policy_document: std::option::Option<std::string::String>,
    /// <p>(Gateway endpoint) One or more route tables IDs to associate with the endpoint.</p>
    pub add_route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Gateway endpoint) One or more route table IDs to disassociate from the endpoint.</p>
    pub remove_route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Interface and Gateway Load Balancer endpoints) One or more subnet IDs in which to serve the endpoint. For a Gateway Load Balancer endpoint, you can specify only one subnet.</p>
    pub add_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Interface endpoint) One or more subnets IDs in which to remove the endpoint.</p>
    pub remove_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Interface endpoint) One or more security group IDs to associate with the network interface.</p>
    pub add_security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Interface endpoint) One or more security group IDs to disassociate from the network interface.</p>
    pub remove_security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Interface endpoint) Indicates whether a private hosted zone is associated with the
    /// VPC.</p>
    pub private_dns_enabled: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVpcEndpointInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpcEndpointInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_endpoint_id", &self.vpc_endpoint_id);
        formatter.field("reset_policy", &self.reset_policy);
        formatter.field("policy_document", &self.policy_document);
        formatter.field("add_route_table_ids", &self.add_route_table_ids);
        formatter.field("remove_route_table_ids", &self.remove_route_table_ids);
        formatter.field("add_subnet_ids", &self.add_subnet_ids);
        formatter.field("remove_subnet_ids", &self.remove_subnet_ids);
        formatter.field("add_security_group_ids", &self.add_security_group_ids);
        formatter.field("remove_security_group_ids", &self.remove_security_group_ids);
        formatter.field("private_dns_enabled", &self.private_dns_enabled);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVpcAttributeInput {
    /// <p>Indicates whether the instances launched in the VPC get DNS hostnames. If enabled, instances in the VPC get DNS hostnames; otherwise, they do not.</p>
    /// <p>You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use separate requests for each attribute. You can only enable DNS hostnames if you've enabled DNS support.</p>
    pub enable_dns_hostnames: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>Indicates whether the DNS resolution is supported for the VPC. If enabled, queries to
    /// the Amazon provided DNS server at the 169.254.169.253 IP address, or the reserved IP
    /// address at the base of the VPC network range "plus two" succeed. If disabled, the Amazon
    /// provided DNS service in the VPC that resolves public DNS hostnames to IP addresses is
    /// not enabled.</p>
    /// <p>You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use separate requests for each attribute.</p>
    pub enable_dns_support: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyVpcAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVpcAttributeInput");
        formatter.field("enable_dns_hostnames", &self.enable_dns_hostnames);
        formatter.field("enable_dns_support", &self.enable_dns_support);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVolumeAttributeInput {
    /// <p>Indicates whether the volume should be auto-enabled for I/O operations.</p>
    pub auto_enable_io: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>The ID of the volume.</p>
    pub volume_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVolumeAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVolumeAttributeInput");
        formatter.field("auto_enable_io", &self.auto_enable_io);
        formatter.field("volume_id", &self.volume_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyVolumeInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the volume.</p>
    pub volume_id: std::option::Option<std::string::String>,
    /// <p>The target size of the volume, in GiB. The target volume size must be greater than or
    /// equal to the existing size of the volume.</p>
    /// <p>The following are the supported volumes sizes for each volume type:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>gp2</code> and <code>gp3</code>: 1-16,384</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>io1</code> and <code>io2</code>: 4-16,384</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>st1</code> and <code>sc1</code>: 125-16,384</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>standard</code>: 1-1,024</p>
    /// </li>
    /// </ul>
    /// <p>Default: If no size is specified, the existing size is retained.</p>
    pub size: std::option::Option<i32>,
    /// <p>The target EBS volume type of the volume. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html">Amazon EBS volume types</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    /// <p>Default: If no type is specified, the existing type is retained.</p>
    pub volume_type: std::option::Option<crate::model::VolumeType>,
    /// <p>The target IOPS rate of the volume. This parameter is valid only for <code>gp3</code>, <code>io1</code>, and <code>io2</code> volumes.</p>
    /// <p>The following are the supported values for each volume type:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>gp3</code>: 3,000-16,000 IOPS</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>io1</code>: 100-64,000 IOPS</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>io2</code>: 100-64,000 IOPS</p>
    /// </li>
    /// </ul>
    /// <p>Default: If no IOPS value is specified, the existing value is retained, unless a volume type is modified that supports different values.</p>
    pub iops: std::option::Option<i32>,
    /// <p>The target throughput of the volume, in MiB/s. This parameter is valid only for <code>gp3</code> volumes.
    /// The maximum value is 1,000.</p>
    /// <p>Default: If no throughput value is specified, the existing value is retained.</p>
    /// <p>Valid Range: Minimum value of 125. Maximum value of 1000.</p>
    pub throughput: std::option::Option<i32>,
    /// <p>Specifies whether to enable Amazon EBS Multi-Attach. If you enable Multi-Attach, you can attach the
    /// volume to up to 16 <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">
    /// Nitro-based instances</a> in the same Availability Zone. This parameter is
    /// supported with <code>io1</code> and <code>io2</code> volumes only. For more information, see
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-volumes-multi.html">
    /// Amazon EBS Multi-Attach</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub multi_attach_enabled: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyVolumeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyVolumeInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("volume_id", &self.volume_id);
        formatter.field("size", &self.size);
        formatter.field("volume_type", &self.volume_type);
        formatter.field("iops", &self.iops);
        formatter.field("throughput", &self.throughput);
        formatter.field("multi_attach_enabled", &self.multi_attach_enabled);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyTransitGatewayVpcAttachmentInput {
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>The IDs of one or more subnets to add. You can specify at most one subnet per Availability Zone.</p>
    pub add_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The IDs of one or more subnets to remove.</p>
    pub remove_subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The new VPC attachment options.</p>
    /// <note>
    /// <p>You cannot modify the IPv6 options.</p>
    /// </note>
    pub options: std::option::Option<crate::model::ModifyTransitGatewayVpcAttachmentRequestOptions>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyTransitGatewayVpcAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyTransitGatewayVpcAttachmentInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("add_subnet_ids", &self.add_subnet_ids);
        formatter.field("remove_subnet_ids", &self.remove_subnet_ids);
        formatter.field("options", &self.options);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyTransitGatewayPrefixListReferenceInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the prefix list.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment to which traffic is routed.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Indicates whether to drop traffic that matches this route.</p>
    pub blackhole: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyTransitGatewayPrefixListReferenceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyTransitGatewayPrefixListReferenceInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("blackhole", &self.blackhole);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyTransitGatewayInput {
    /// <p>The ID of the transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The description for the transit gateway.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The options to modify.</p>
    pub options: std::option::Option<crate::model::ModifyTransitGatewayOptions>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyTransitGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyTransitGatewayInput");
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("description", &self.description);
        formatter.field("options", &self.options);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyTrafficMirrorSessionInput {
    /// <p>The ID of the Traffic Mirror session.</p>
    pub traffic_mirror_session_id: std::option::Option<std::string::String>,
    /// <p>The Traffic Mirror target. The target must be in the same VPC as the source, or have a VPC peering connection with the source.</p>
    pub traffic_mirror_target_id: std::option::Option<std::string::String>,
    /// <p>The ID of the Traffic Mirror filter.</p>
    pub traffic_mirror_filter_id: std::option::Option<std::string::String>,
    /// <p>The number of bytes in each packet to mirror. These are bytes after the VXLAN header. To mirror a subset, set this to the length (in bytes) to mirror. For example, if you set this value to 100, then the first 100 bytes that meet the filter criteria are copied to the target. Do not specify this parameter when you want to mirror the entire packet.</p>
    pub packet_length: std::option::Option<i32>,
    /// <p>The session number determines the order in which sessions are evaluated when an interface is used by multiple sessions. The first session with a matching filter is the one that mirrors the packets.</p>
    /// <p>Valid values are 1-32766.</p>
    pub session_number: std::option::Option<i32>,
    /// <p>The virtual network ID of the Traffic Mirror session.</p>
    pub virtual_network_id: std::option::Option<i32>,
    /// <p>The description to assign to the Traffic Mirror session.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The properties that you want to remove from the Traffic Mirror session.</p>
    /// <p>When you remove a property from a Traffic Mirror session, the property is set to the default.</p>
    pub remove_fields: std::option::Option<std::vec::Vec<crate::model::TrafficMirrorSessionField>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyTrafficMirrorSessionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyTrafficMirrorSessionInput");
        formatter.field("traffic_mirror_session_id", &self.traffic_mirror_session_id);
        formatter.field("traffic_mirror_target_id", &self.traffic_mirror_target_id);
        formatter.field("traffic_mirror_filter_id", &self.traffic_mirror_filter_id);
        formatter.field("packet_length", &self.packet_length);
        formatter.field("session_number", &self.session_number);
        formatter.field("virtual_network_id", &self.virtual_network_id);
        formatter.field("description", &self.description);
        formatter.field("remove_fields", &self.remove_fields);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyTrafficMirrorFilterRuleInput {
    /// <p>The ID of the Traffic Mirror rule.</p>
    pub traffic_mirror_filter_rule_id: std::option::Option<std::string::String>,
    /// <p>The type of traffic (<code>ingress</code> | <code>egress</code>) to assign to the rule.</p>
    pub traffic_direction: std::option::Option<crate::model::TrafficDirection>,
    /// <p>The number of the Traffic Mirror rule. This number must be unique for each Traffic Mirror rule in a given
    /// direction. The rules are processed in ascending order by rule number.</p>
    pub rule_number: std::option::Option<i32>,
    /// <p>The action to assign to the rule.</p>
    pub rule_action: std::option::Option<crate::model::TrafficMirrorRuleAction>,
    /// <p>The destination ports that are associated with the Traffic Mirror rule.</p>
    pub destination_port_range: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
    /// <p>The port range to assign to the Traffic Mirror rule.</p>
    pub source_port_range: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
    /// <p>The protocol, for example TCP, to assign to the Traffic Mirror rule.</p>
    pub protocol: std::option::Option<i32>,
    /// <p>The destination CIDR block to assign to the Traffic Mirror rule.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The source CIDR block to assign to the Traffic Mirror rule.</p>
    pub source_cidr_block: std::option::Option<std::string::String>,
    /// <p>The description to assign to the Traffic Mirror rule.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The properties that you want to remove from the Traffic Mirror filter rule.</p>
    /// <p>When you remove a property from a Traffic Mirror filter rule, the property is set to the default.</p>
    pub remove_fields:
        std::option::Option<std::vec::Vec<crate::model::TrafficMirrorFilterRuleField>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyTrafficMirrorFilterRuleInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyTrafficMirrorFilterRuleInput");
        formatter.field(
            "traffic_mirror_filter_rule_id",
            &self.traffic_mirror_filter_rule_id,
        );
        formatter.field("traffic_direction", &self.traffic_direction);
        formatter.field("rule_number", &self.rule_number);
        formatter.field("rule_action", &self.rule_action);
        formatter.field("destination_port_range", &self.destination_port_range);
        formatter.field("source_port_range", &self.source_port_range);
        formatter.field("protocol", &self.protocol);
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field("source_cidr_block", &self.source_cidr_block);
        formatter.field("description", &self.description);
        formatter.field("remove_fields", &self.remove_fields);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyTrafficMirrorFilterNetworkServicesInput {
    /// <p>The ID of the Traffic Mirror filter.</p>
    pub traffic_mirror_filter_id: std::option::Option<std::string::String>,
    /// <p>The network service, for example Amazon DNS, that you want to mirror.</p>
    pub add_network_services:
        std::option::Option<std::vec::Vec<crate::model::TrafficMirrorNetworkService>>,
    /// <p>The network service, for example Amazon DNS, that you no longer want to mirror.</p>
    pub remove_network_services:
        std::option::Option<std::vec::Vec<crate::model::TrafficMirrorNetworkService>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyTrafficMirrorFilterNetworkServicesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyTrafficMirrorFilterNetworkServicesInput");
        formatter.field("traffic_mirror_filter_id", &self.traffic_mirror_filter_id);
        formatter.field("add_network_services", &self.add_network_services);
        formatter.field("remove_network_services", &self.remove_network_services);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifySubnetAttributeInput {
    /// <p>Specify <code>true</code> to indicate that network interfaces created in the
    /// specified subnet should be assigned an IPv6 address. This includes a network interface
    /// that's created when launching an instance into the subnet (the instance therefore
    /// receives an IPv6 address). </p>
    /// <p>If you enable the IPv6 addressing feature for your subnet, your network interface
    /// or instance only receives an IPv6 address if it's created using version
    /// <code>2016-11-15</code> or later of the Amazon EC2 API.</p>
    pub assign_ipv6_address_on_creation: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>Specify <code>true</code> to indicate that network interfaces attached to instances created in the
    /// specified subnet should be assigned a public IPv4 address.</p>
    pub map_public_ip_on_launch: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>The ID of the subnet.</p>
    pub subnet_id: std::option::Option<std::string::String>,
    /// <p>Specify <code>true</code> to indicate that network interfaces  attached to instances created in the
    /// specified subnet should be assigned a customer-owned IPv4 address.</p>
    /// <p>When this value is <code>true</code>, you must specify the customer-owned IP pool using <code>CustomerOwnedIpv4Pool</code>.</p>
    pub map_customer_owned_ip_on_launch: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>The customer-owned IPv4 address pool associated with the subnet.</p>
    /// <p>You must set this value when you specify <code>true</code> for <code>MapCustomerOwnedIpOnLaunch</code>.</p>
    pub customer_owned_ipv4_pool: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifySubnetAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifySubnetAttributeInput");
        formatter.field(
            "assign_ipv6_address_on_creation",
            &self.assign_ipv6_address_on_creation,
        );
        formatter.field("map_public_ip_on_launch", &self.map_public_ip_on_launch);
        formatter.field("subnet_id", &self.subnet_id);
        formatter.field(
            "map_customer_owned_ip_on_launch",
            &self.map_customer_owned_ip_on_launch,
        );
        formatter.field("customer_owned_ipv4_pool", &self.customer_owned_ipv4_pool);
        formatter.finish()
    }
}

/// <p>Contains the parameters for ModifySpotFleetRequest.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifySpotFleetRequestInput {
    /// <p>Indicates whether running Spot Instances should be terminated if the target capacity
    /// of the Spot Fleet request is decreased below the current size of the Spot Fleet.</p>
    pub excess_capacity_termination_policy:
        std::option::Option<crate::model::ExcessCapacityTerminationPolicy>,
    /// <p>The launch template and overrides. You can only use this parameter if you specified a
    /// launch template (<code>LaunchTemplateConfigs</code>) in your Spot Fleet request. If you
    /// specified <code>LaunchSpecifications</code> in your Spot Fleet request, then omit this
    /// parameter.</p>
    pub launch_template_configs:
        std::option::Option<std::vec::Vec<crate::model::LaunchTemplateConfig>>,
    /// <p>The ID of the Spot Fleet request.</p>
    pub spot_fleet_request_id: std::option::Option<std::string::String>,
    /// <p>The size of the fleet.</p>
    pub target_capacity: std::option::Option<i32>,
    /// <p>The number of On-Demand Instances in the fleet.</p>
    pub on_demand_target_capacity: std::option::Option<i32>,
    /// <p>Reserved.</p>
    pub context: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifySpotFleetRequestInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifySpotFleetRequestInput");
        formatter.field(
            "excess_capacity_termination_policy",
            &self.excess_capacity_termination_policy,
        );
        formatter.field("launch_template_configs", &self.launch_template_configs);
        formatter.field("spot_fleet_request_id", &self.spot_fleet_request_id);
        formatter.field("target_capacity", &self.target_capacity);
        formatter.field("on_demand_target_capacity", &self.on_demand_target_capacity);
        formatter.field("context", &self.context);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifySnapshotAttributeInput {
    /// <p>The snapshot attribute to modify. Only volume creation permissions can be modified.</p>
    pub attribute: std::option::Option<crate::model::SnapshotAttributeName>,
    /// <p>A JSON representation of the snapshot attribute modification.</p>
    pub create_volume_permission:
        std::option::Option<crate::model::CreateVolumePermissionModifications>,
    /// <p>The group to modify for the snapshot.</p>
    pub group_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The type of operation to perform to the attribute.</p>
    pub operation_type: std::option::Option<crate::model::OperationType>,
    /// <p>The ID of the snapshot.</p>
    pub snapshot_id: std::option::Option<std::string::String>,
    /// <p>The account ID to modify for the snapshot.</p>
    pub user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifySnapshotAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifySnapshotAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("create_volume_permission", &self.create_volume_permission);
        formatter.field("group_names", &self.group_names);
        formatter.field("operation_type", &self.operation_type);
        formatter.field("snapshot_id", &self.snapshot_id);
        formatter.field("user_ids", &self.user_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for ModifyReservedInstances.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyReservedInstancesInput {
    /// <p>The IDs of the Reserved Instances to modify.</p>
    pub reserved_instances_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>A unique, case-sensitive token you provide to ensure idempotency of your modification request. For more information, see
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The configuration settings for the Reserved Instances to modify.</p>
    pub target_configurations:
        std::option::Option<std::vec::Vec<crate::model::ReservedInstancesConfiguration>>,
}
impl std::fmt::Debug for ModifyReservedInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyReservedInstancesInput");
        formatter.field("reserved_instances_ids", &self.reserved_instances_ids);
        formatter.field("client_token", &self.client_token);
        formatter.field("target_configurations", &self.target_configurations);
        formatter.finish()
    }
}

/// <p>Contains the parameters for ModifyNetworkInterfaceAttribute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyNetworkInterfaceAttributeInput {
    /// <p>Information about the interface attachment. If modifying the 'delete on termination' attribute, you must specify the ID of the interface attachment.</p>
    pub attachment: std::option::Option<crate::model::NetworkInterfaceAttachmentChanges>,
    /// <p>A description for the network interface.</p>
    pub description: std::option::Option<crate::model::AttributeValue>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Changes the security groups for the network interface. The new set of groups you specify replaces the current set. You must specify at least one group, even if it's just the default security group in the VPC. You must specify the ID of the security group, not the name.</p>
    pub groups: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>Enable or disable source/destination checks, which ensure that the instance
    /// is either the source or the destination of any traffic that it receives.
    /// If the value is <code>true</code>, source/destination checks are enabled;
    /// otherwise, they are disabled. The default value is <code>true</code>.
    /// You must disable source/destination checks if the instance runs services
    /// such as network address translation, routing, or firewalls.</p>
    pub source_dest_check: std::option::Option<crate::model::AttributeBooleanValue>,
}
impl std::fmt::Debug for ModifyNetworkInterfaceAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyNetworkInterfaceAttributeInput");
        formatter.field("attachment", &self.attachment);
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("groups", &self.groups);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("source_dest_check", &self.source_dest_check);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyManagedPrefixListInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the prefix list.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
    /// <p>The current version of the prefix list.</p>
    pub current_version: std::option::Option<i64>,
    /// <p>A name for the prefix list.</p>
    pub prefix_list_name: std::option::Option<std::string::String>,
    /// <p>One or more entries to add to the prefix list.</p>
    pub add_entries: std::option::Option<std::vec::Vec<crate::model::AddPrefixListEntry>>,
    /// <p>One or more entries to remove from the prefix list.</p>
    pub remove_entries: std::option::Option<std::vec::Vec<crate::model::RemovePrefixListEntry>>,
}
impl std::fmt::Debug for ModifyManagedPrefixListInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyManagedPrefixListInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.field("current_version", &self.current_version);
        formatter.field("prefix_list_name", &self.prefix_list_name);
        formatter.field("add_entries", &self.add_entries);
        formatter.field("remove_entries", &self.remove_entries);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyLaunchTemplateInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
    /// Idempotency</a>.</p>
    /// <p>Constraint: Maximum 128 ASCII characters.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The ID of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_id: std::option::Option<std::string::String>,
    /// <p>The name of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_name: std::option::Option<std::string::String>,
    /// <p>The version number of the launch template to set as the default version.</p>
    pub default_version: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyLaunchTemplateInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyLaunchTemplateInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.field("launch_template_id", &self.launch_template_id);
        formatter.field("launch_template_name", &self.launch_template_name);
        formatter.field("default_version", &self.default_version);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyInstancePlacementInput {
    /// <p>The affinity setting for the instance.</p>
    pub affinity: std::option::Option<crate::model::Affinity>,
    /// <p>The name of the placement group in which to place the instance. For spread placement
    /// groups, the instance must have a tenancy of <code>default</code>. For cluster and
    /// partition placement groups, the instance must have a tenancy of <code>default</code> or
    /// <code>dedicated</code>.</p>
    /// <p>To remove an instance from a placement group, specify an empty string
    /// ("").</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>The ID of the Dedicated Host with which to associate the instance.</p>
    pub host_id: std::option::Option<std::string::String>,
    /// <p>The ID of the instance that you are modifying.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The tenancy for the instance.</p>
    pub tenancy: std::option::Option<crate::model::HostTenancy>,
    /// <p>Reserved for future use.</p>
    pub partition_number: std::option::Option<i32>,
    /// <p>The ARN of the host resource group in which to place the instance.</p>
    pub host_resource_group_arn: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyInstancePlacementInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyInstancePlacementInput");
        formatter.field("affinity", &self.affinity);
        formatter.field("group_name", &self.group_name);
        formatter.field("host_id", &self.host_id);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("tenancy", &self.tenancy);
        formatter.field("partition_number", &self.partition_number);
        formatter.field("host_resource_group_arn", &self.host_resource_group_arn);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyInstanceMetadataOptionsInput {
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The state of token usage for your instance metadata requests. If the parameter is not
    /// specified in the request, the default state is <code>optional</code>.</p>
    /// <p>If the state is <code>optional</code>, you can choose to retrieve instance metadata
    /// with or without a signed token header on your request. If you retrieve the IAM role
    /// credentials without a token, the version 1.0 role credentials are returned. If you
    /// retrieve the IAM role credentials using a valid signed token, the version 2.0 role
    /// credentials are returned.</p>
    /// <p>If the state is <code>required</code>, you must send a signed token header with any
    /// instance metadata retrieval requests. In this state, retrieving the IAM role credential
    /// always returns the version 2.0 credentials; the version 1.0 credentials are not
    /// available.</p>
    pub http_tokens: std::option::Option<crate::model::HttpTokensState>,
    /// <p>The desired HTTP PUT response hop limit for instance metadata requests. The larger the
    /// number, the further instance metadata requests can travel. If no parameter is specified, the existing state is maintained.</p>
    /// <p>Possible values: Integers from 1 to 64</p>
    pub http_put_response_hop_limit: std::option::Option<i32>,
    /// <p>This parameter enables or disables the HTTP metadata endpoint on your instances. If
    /// the parameter is not specified, the existing state is maintained.</p>
    /// <note>
    /// <p>If you specify a value of <code>disabled</code>, you will not be able to access your
    /// instance metadata.</p>
    /// </note>
    pub http_endpoint: std::option::Option<crate::model::InstanceMetadataEndpointState>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyInstanceMetadataOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyInstanceMetadataOptionsInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field("http_tokens", &self.http_tokens);
        formatter.field(
            "http_put_response_hop_limit",
            &self.http_put_response_hop_limit,
        );
        formatter.field("http_endpoint", &self.http_endpoint);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyInstanceEventStartTimeInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance with the scheduled event.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The ID of the event whose date and time you are modifying.</p>
    pub instance_event_id: std::option::Option<std::string::String>,
    /// <p>The new date and time when the event will take place.</p>
    pub not_before: std::option::Option<smithy_types::Instant>,
}
impl std::fmt::Debug for ModifyInstanceEventStartTimeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyInstanceEventStartTimeInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("instance_event_id", &self.instance_event_id);
        formatter.field("not_before", &self.not_before);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyInstanceCreditSpecificationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>A unique, case-sensitive token that you provide to ensure idempotency of your
    /// modification request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Information about the credit option for CPU usage.</p>
    pub instance_credit_specifications:
        std::option::Option<std::vec::Vec<crate::model::InstanceCreditSpecificationRequest>>,
}
impl std::fmt::Debug for ModifyInstanceCreditSpecificationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyInstanceCreditSpecificationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.field(
            "instance_credit_specifications",
            &self.instance_credit_specifications,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyInstanceCapacityReservationAttributesInput {
    /// <p>The ID of the instance to be modified.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>Information about the Capacity Reservation targeting option.</p>
    pub capacity_reservation_specification:
        std::option::Option<crate::model::CapacityReservationSpecification>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyInstanceCapacityReservationAttributesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyInstanceCapacityReservationAttributesInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field(
            "capacity_reservation_specification",
            &self.capacity_reservation_specification,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyInstanceAttributeInput {
    /// <p>Enable or disable source/destination checks, which ensure that the instance
    /// is either the source or the destination of any traffic that it receives.
    /// If the value is <code>true</code>, source/destination checks are enabled;
    /// otherwise, they are disabled. The default value is <code>true</code>.
    /// You must disable source/destination checks if the instance runs services
    /// such as network address translation, routing, or firewalls.</p>
    pub source_dest_check: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>The name of the attribute.</p>
    pub attribute: std::option::Option<crate::model::InstanceAttributeName>,
    /// <p>Modifies the <code>DeleteOnTermination</code> attribute for volumes that are currently
    /// attached. The volume must be owned by the caller. If no value is specified for
    /// <code>DeleteOnTermination</code>, the default is <code>true</code> and the volume is
    /// deleted when the instance is terminated.</p>
    /// <p>To add instance store volumes to an Amazon EBS-backed instance, you must add them when
    /// you launch the instance. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/block-device-mapping-concepts.html#Using_OverridingAMIBDM">Updating the block device mapping when launching an instance</a> in the
    /// <i>Amazon EC2 User Guide</i>.</p>
    pub block_device_mappings:
        std::option::Option<std::vec::Vec<crate::model::InstanceBlockDeviceMappingSpecification>>,
    /// <p>If the value is <code>true</code>, you can't terminate the instance using the Amazon
    /// EC2 console, CLI, or API; otherwise, you can. You cannot use this parameter for Spot
    /// Instances.</p>
    pub disable_api_termination: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Specifies whether the instance is optimized for Amazon EBS I/O. This optimization
    /// provides dedicated throughput to Amazon EBS and an optimized configuration stack to
    /// provide optimal EBS I/O performance. This optimization isn't available with all instance
    /// types. Additional usage charges apply when using an EBS Optimized instance.</p>
    pub ebs_optimized: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>Set to <code>true</code> to enable enhanced networking with ENA for the
    /// instance.</p>
    /// <p>This option is supported only for HVM instances. Specifying this option with a PV
    /// instance can make it unreachable.</p>
    pub ena_support: std::option::Option<crate::model::AttributeBooleanValue>,
    /// <p>[EC2-VPC] Replaces the security groups of the instance with the specified security groups.
    /// You must specify at least one security group, even if it's just the default security group for the VPC. You must
    /// specify the security group ID, not the security group name.</p>
    pub groups: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>Specifies whether an instance stops or terminates when you initiate shutdown from the
    /// instance (using the operating system command for system shutdown).</p>
    pub instance_initiated_shutdown_behavior: std::option::Option<crate::model::AttributeValue>,
    /// <p>Changes the instance type to the specified value. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance
    /// types</a> in the <i>Amazon EC2 User Guide</i>. If the instance type is not valid,
    /// the error returned is <code>InvalidInstanceAttributeValue</code>.</p>
    pub instance_type: std::option::Option<crate::model::AttributeValue>,
    /// <p>Changes the instance's kernel to the specified value. We recommend that you use
    /// PV-GRUB instead of kernels and RAM disks. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html">PV-GRUB</a>.</p>
    pub kernel: std::option::Option<crate::model::AttributeValue>,
    /// <p>Changes the instance's RAM disk to the specified value. We recommend that you use
    /// PV-GRUB instead of kernels and RAM disks. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html">PV-GRUB</a>.</p>
    pub ramdisk: std::option::Option<crate::model::AttributeValue>,
    /// <p>Set to <code>simple</code> to enable enhanced networking with the Intel 82599 Virtual
    /// Function interface for the instance.</p>
    /// <p>There is no way to disable enhanced networking with the Intel 82599 Virtual Function
    /// interface at this time.</p>
    /// <p>This option is supported only for HVM instances. Specifying this option with a PV
    /// instance can make it unreachable.</p>
    pub sriov_net_support: std::option::Option<crate::model::AttributeValue>,
    /// <p>Changes the instance's user data to the specified value. If you are using an Amazon Web Services SDK
    /// or command line tool, base64-encoding is performed for you, and you can load the text
    /// from a file. Otherwise, you must provide base64-encoded text.</p>
    pub user_data: std::option::Option<crate::model::BlobAttributeValue>,
    /// <p>A new value for the attribute. Use only with the <code>kernel</code>,
    /// <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code>, or
    /// <code>instanceInitiatedShutdownBehavior</code> attribute.</p>
    pub value: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyInstanceAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyInstanceAttributeInput");
        formatter.field("source_dest_check", &self.source_dest_check);
        formatter.field("attribute", &self.attribute);
        formatter.field("block_device_mappings", &self.block_device_mappings);
        formatter.field("disable_api_termination", &self.disable_api_termination);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("ebs_optimized", &self.ebs_optimized);
        formatter.field("ena_support", &self.ena_support);
        formatter.field("groups", &self.groups);
        formatter.field("instance_id", &self.instance_id);
        formatter.field(
            "instance_initiated_shutdown_behavior",
            &self.instance_initiated_shutdown_behavior,
        );
        formatter.field("instance_type", &self.instance_type);
        formatter.field("kernel", &self.kernel);
        formatter.field("ramdisk", &self.ramdisk);
        formatter.field("sriov_net_support", &self.sriov_net_support);
        formatter.field("user_data", &self.user_data);
        formatter.field("value", &self.value);
        formatter.finish()
    }
}

/// <p>Contains the parameters for ModifyImageAttribute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyImageAttributeInput {
    /// <p>The name of the attribute to modify.
    /// The valid values are <code>description</code>, <code>launchPermission</code>, and <code>productCodes</code>.</p>
    pub attribute: std::option::Option<std::string::String>,
    /// <p>A new description for the AMI.</p>
    pub description: std::option::Option<crate::model::AttributeValue>,
    /// <p>The ID of the AMI.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>A new launch permission for the AMI.</p>
    pub launch_permission: std::option::Option<crate::model::LaunchPermissionModifications>,
    /// <p>The operation type.
    /// This parameter can be used only when the <code>Attribute</code> parameter is <code>launchPermission</code>.</p>
    pub operation_type: std::option::Option<crate::model::OperationType>,
    /// <p>The DevPay product codes. After you add a product code to an AMI, it can't be removed.</p>
    pub product_codes: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The user groups.
    /// This parameter can be used only when the <code>Attribute</code> parameter is <code>launchPermission</code>.</p>
    pub user_groups: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The AWS account IDs.
    /// This parameter can be used only when the <code>Attribute</code> parameter is <code>launchPermission</code>.</p>
    pub user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The value of the attribute being modified.
    /// This parameter can be used only when the <code>Attribute</code> parameter is <code>description</code> or <code>productCodes</code>.</p>
    pub value: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyImageAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyImageAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("description", &self.description);
        formatter.field("image_id", &self.image_id);
        formatter.field("launch_permission", &self.launch_permission);
        formatter.field("operation_type", &self.operation_type);
        formatter.field("product_codes", &self.product_codes);
        formatter.field("user_groups", &self.user_groups);
        formatter.field("user_ids", &self.user_ids);
        formatter.field("value", &self.value);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyIdFormatInput {
    /// <p>The type of resource: <code>bundle</code> | <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
    /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
    /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
    /// <code>import-task</code> | <code>internet-gateway</code> | <code>network-acl</code>
    /// | <code>network-acl-association</code> | <code>network-interface</code> |
    /// <code>network-interface-attachment</code> | <code>prefix-list</code> |
    /// <code>route-table</code> | <code>route-table-association</code> |
    /// <code>security-group</code> | <code>subnet</code> |
    /// <code>subnet-cidr-block-association</code> | <code>vpc</code> |
    /// <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> | <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>.</p>
    /// <p>Alternatively, use the <code>all-current</code> option to include all resource types that are
    /// currently within their opt-in period for longer IDs.</p>
    pub resource: std::option::Option<std::string::String>,
    /// <p>Indicate whether the resource should use longer IDs (17-character IDs).</p>
    pub use_long_ids: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyIdFormatInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyIdFormatInput");
        formatter.field("resource", &self.resource);
        formatter.field("use_long_ids", &self.use_long_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyIdentityIdFormatInput {
    /// <p>The ARN of the principal, which can be an IAM user, IAM role, or the root user. Specify
    /// <code>all</code> to modify the ID format for all IAM users, IAM roles, and the root user of
    /// the account.</p>
    pub principal_arn: std::option::Option<std::string::String>,
    /// <p>The type of resource: <code>bundle</code> | <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
    /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
    /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
    /// <code>import-task</code> | <code>internet-gateway</code> | <code>network-acl</code>
    /// | <code>network-acl-association</code> | <code>network-interface</code> |
    /// <code>network-interface-attachment</code> | <code>prefix-list</code> |
    /// <code>route-table</code> | <code>route-table-association</code> |
    /// <code>security-group</code> | <code>subnet</code> |
    /// <code>subnet-cidr-block-association</code> | <code>vpc</code> |
    /// <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> | <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>.</p>
    /// <p>Alternatively, use the <code>all-current</code> option to include all resource types that are
    /// currently within their opt-in period for longer IDs.</p>
    pub resource: std::option::Option<std::string::String>,
    /// <p>Indicates whether the resource should use longer IDs (17-character IDs)</p>
    pub use_long_ids: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyIdentityIdFormatInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyIdentityIdFormatInput");
        formatter.field("principal_arn", &self.principal_arn);
        formatter.field("resource", &self.resource);
        formatter.field("use_long_ids", &self.use_long_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyHostsInput {
    /// <p>Specify whether to enable or disable auto-placement.</p>
    pub auto_placement: std::option::Option<crate::model::AutoPlacement>,
    /// <p>The IDs of the Dedicated Hosts to modify.</p>
    pub host_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Indicates whether to enable or disable host recovery for the Dedicated Host. For more information,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/dedicated-hosts-recovery.html">
    /// Host recovery</a> in the <i>Amazon EC2 User Guide</i>.</p>
    pub host_recovery: std::option::Option<crate::model::HostRecovery>,
    /// <p>Specifies the instance type to be supported by the Dedicated Host. Specify this parameter to
    /// modify a Dedicated Host to support only a specific instance type.</p>
    /// <p>If you want to modify a Dedicated Host to support multiple instance types in its current instance
    /// family, omit this parameter and specify <b>InstanceFamily</b>
    /// instead. You cannot specify <b>InstanceType</b> and
    /// <b>InstanceFamily</b> in the same request.</p>
    pub instance_type: std::option::Option<std::string::String>,
    /// <p>Specifies the instance family to be supported by the Dedicated Host. Specify this parameter
    /// to modify a Dedicated Host to support multiple instance types within its current
    /// instance family.</p>
    /// <p>If you want to modify a Dedicated Host to support a specific instance type only, omit this parameter
    /// and specify <b>InstanceType</b> instead. You cannot specify
    /// <b>InstanceFamily</b> and <b>InstanceType</b>
    /// in the same request.</p>
    pub instance_family: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyHostsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyHostsInput");
        formatter.field("auto_placement", &self.auto_placement);
        formatter.field("host_ids", &self.host_ids);
        formatter.field("host_recovery", &self.host_recovery);
        formatter.field("instance_type", &self.instance_type);
        formatter.field("instance_family", &self.instance_family);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyFpgaImageAttributeInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the AFI.</p>
    pub fpga_image_id: std::option::Option<std::string::String>,
    /// <p>The name of the attribute.</p>
    pub attribute: std::option::Option<crate::model::FpgaImageAttributeName>,
    /// <p>The operation type.</p>
    pub operation_type: std::option::Option<crate::model::OperationType>,
    /// <p>The AWS account IDs. This parameter is valid only when modifying the <code>loadPermission</code> attribute.</p>
    pub user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The user groups. This parameter is valid only when modifying the <code>loadPermission</code> attribute.</p>
    pub user_groups: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The product codes. After you add a product code to an AFI, it can't be removed.
    /// This parameter is valid only when modifying the <code>productCodes</code> attribute.</p>
    pub product_codes: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The load permission for the AFI.</p>
    pub load_permission: std::option::Option<crate::model::LoadPermissionModifications>,
    /// <p>A description for the AFI.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>A name for the AFI.</p>
    pub name: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyFpgaImageAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyFpgaImageAttributeInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("fpga_image_id", &self.fpga_image_id);
        formatter.field("attribute", &self.attribute);
        formatter.field("operation_type", &self.operation_type);
        formatter.field("user_ids", &self.user_ids);
        formatter.field("user_groups", &self.user_groups);
        formatter.field("product_codes", &self.product_codes);
        formatter.field("load_permission", &self.load_permission);
        formatter.field("description", &self.description);
        formatter.field("name", &self.name);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyFleetInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Indicates whether running instances should be terminated if the total target capacity of
    /// the EC2 Fleet is decreased below the current size of the EC2 Fleet.</p>
    pub excess_capacity_termination_policy:
        std::option::Option<crate::model::FleetExcessCapacityTerminationPolicy>,
    /// <p>The launch template and overrides.</p>
    pub launch_template_configs:
        std::option::Option<std::vec::Vec<crate::model::FleetLaunchTemplateConfigRequest>>,
    /// <p>The ID of the EC2 Fleet.</p>
    pub fleet_id: std::option::Option<std::string::String>,
    /// <p>The size of the EC2 Fleet.</p>
    pub target_capacity_specification:
        std::option::Option<crate::model::TargetCapacitySpecificationRequest>,
    /// <p>Reserved.</p>
    pub context: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyFleetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyFleetInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "excess_capacity_termination_policy",
            &self.excess_capacity_termination_policy,
        );
        formatter.field("launch_template_configs", &self.launch_template_configs);
        formatter.field("fleet_id", &self.fleet_id);
        formatter.field(
            "target_capacity_specification",
            &self.target_capacity_specification,
        );
        formatter.field("context", &self.context);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyEbsDefaultKmsKeyIdInput {
    /// <p>The identifier of the AWS Key Management Service (AWS KMS) customer master key (CMK) to use for Amazon EBS encryption.
    /// If this parameter is not specified, your AWS managed CMK for EBS is used. If <code>KmsKeyId</code> is
    /// specified, the encrypted state must be <code>true</code>.</p>
    /// <p>You can specify the CMK using any of the following:</p>
    /// <ul>
    /// <li>
    /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Key alias. For example, alias/ExampleAlias.</p>
    /// </li>
    /// <li>
    /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
    /// </li>
    /// </ul>
    /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an ID, alias, or ARN that is not valid,
    /// the action can appear to complete, but eventually fails.</p>  
    /// <p>Amazon EBS does not support asymmetric CMKs.</p>
    pub kms_key_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyEbsDefaultKmsKeyIdInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyEbsDefaultKmsKeyIdInput");
        formatter.field("kms_key_id", &self.kms_key_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyDefaultCreditSpecificationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The instance family.</p>
    pub instance_family: std::option::Option<crate::model::UnlimitedSupportedInstanceFamily>,
    /// <p>The credit option for CPU usage of the instance family.</p>
    /// <p>Valid Values: <code>standard</code> | <code>unlimited</code>
    /// </p>
    pub cpu_credits: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for ModifyDefaultCreditSpecificationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyDefaultCreditSpecificationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_family", &self.instance_family);
        formatter.field("cpu_credits", &self.cpu_credits);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyClientVpnEndpointInput {
    /// <p>The ID of the Client VPN endpoint to modify.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The ARN of the server certificate to be used. The server certificate must be provisioned in AWS Certificate Manager (ACM).</p>
    pub server_certificate_arn: std::option::Option<std::string::String>,
    /// <p>Information about the client connection logging options.</p>
    /// <p>If you enable client connection logging, data about client connections is sent to a
    /// Cloudwatch Logs log stream. The following information is logged:</p>
    /// <ul>
    /// <li>
    /// <p>Client connection requests</p>
    /// </li>
    /// <li>
    /// <p>Client connection results (successful and unsuccessful)</p>
    /// </li>
    /// <li>
    /// <p>Reasons for unsuccessful client connection requests</p>
    /// </li>
    /// <li>
    /// <p>Client connection termination time</p>
    /// </li>
    /// </ul>
    pub connection_log_options: std::option::Option<crate::model::ConnectionLogOptions>,
    /// <p>Information about the DNS servers to be used by Client VPN connections. A Client VPN endpoint can have
    /// up to two DNS servers.</p>
    pub dns_servers: std::option::Option<crate::model::DnsServersOptionsModifyStructure>,
    /// <p>The port number to assign to the Client VPN endpoint for TCP and UDP traffic.</p>
    /// <p>Valid Values: <code>443</code> | <code>1194</code>
    /// </p>
    /// <p>Default Value: <code>443</code>
    /// </p>
    pub vpn_port: std::option::Option<i32>,
    /// <p>A brief description of the Client VPN endpoint.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Indicates whether the VPN is split-tunnel.</p>
    /// <p>For information about split-tunnel VPN endpoints, see <a href="https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html">Split-Tunnel AWS Client VPN Endpoint</a> in the <i>AWS
    /// Client VPN Administrator Guide</i>.</p>
    pub split_tunnel: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of one or more security groups to apply to the target network.</p>
    pub security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of the VPC to associate with the Client VPN endpoint.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>Specify whether to enable the self-service portal for the Client VPN endpoint.</p>
    pub self_service_portal: std::option::Option<crate::model::SelfServicePortal>,
    /// <p>The options for managing connection authorization for new client connections.</p>
    pub client_connect_options: std::option::Option<crate::model::ClientConnectOptions>,
}
impl std::fmt::Debug for ModifyClientVpnEndpointInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyClientVpnEndpointInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("server_certificate_arn", &self.server_certificate_arn);
        formatter.field("connection_log_options", &self.connection_log_options);
        formatter.field("dns_servers", &self.dns_servers);
        formatter.field("vpn_port", &self.vpn_port);
        formatter.field("description", &self.description);
        formatter.field("split_tunnel", &self.split_tunnel);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("security_group_ids", &self.security_group_ids);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("self_service_portal", &self.self_service_portal);
        formatter.field("client_connect_options", &self.client_connect_options);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyCapacityReservationInput {
    /// <p>The ID of the Capacity Reservation.</p>
    pub capacity_reservation_id: std::option::Option<std::string::String>,
    /// <p>The number of instances for which to reserve capacity.</p>
    pub instance_count: std::option::Option<i32>,
    /// <p>The date and time at which the Capacity Reservation expires. When a Capacity Reservation expires, the reserved capacity
    /// is released and you can no longer launch instances into it. The Capacity Reservation's state changes to
    /// <code>expired</code> when it reaches its end date and time.</p>
    /// <p>The Capacity Reservation is cancelled within an hour from the specified time. For example, if you specify
    /// 5/31/2019, 13:30:55, the Capacity Reservation is guaranteed to end between 13:30:55 and 14:30:55 on 5/31/2019.</p>
    /// <p>You must provide an <code>EndDate</code> value if <code>EndDateType</code> is
    /// <code>limited</code>. Omit <code>EndDate</code> if <code>EndDateType</code> is
    /// <code>unlimited</code>.</p>
    pub end_date: std::option::Option<smithy_types::Instant>,
    /// <p>Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have one of the following end
    /// types:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>unlimited</code> - The Capacity Reservation remains active until you explicitly cancel it. Do not
    /// provide an <code>EndDate</code> value if <code>EndDateType</code> is
    /// <code>unlimited</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>limited</code> - The Capacity Reservation expires automatically at a specified date and time. You must
    /// provide an <code>EndDate</code> value if <code>EndDateType</code> is
    /// <code>limited</code>.</p>
    /// </li>
    /// </ul>
    pub end_date_type: std::option::Option<crate::model::EndDateType>,
    /// <p>Reserved. Capacity Reservations you have created are accepted by default.</p>
    pub accept: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyCapacityReservationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyCapacityReservationInput");
        formatter.field("capacity_reservation_id", &self.capacity_reservation_id);
        formatter.field("instance_count", &self.instance_count);
        formatter.field("end_date", &self.end_date);
        formatter.field("end_date_type", &self.end_date_type);
        formatter.field("accept", &self.accept);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyAvailabilityZoneGroupInput {
    /// <p>The name of the Availability Zone group, Local Zone group, or Wavelength Zone
    /// group.</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>Indicates whether you are opted in to the Local Zone group or Wavelength Zone group. The
    /// only valid value is <code>opted-in</code>. You must contact <a href="https://console.aws.amazon.com/support/home#/case/create%3FissueType=customer-service%26serviceCode=general-info%26getting-started%26categoryCode=using-aws%26services">AWS Support</a> to opt out of a Local Zone group, or Wavelength Zone group.</p>
    pub opt_in_status: std::option::Option<crate::model::ModifyAvailabilityZoneOptInStatus>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyAvailabilityZoneGroupInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyAvailabilityZoneGroupInput");
        formatter.field("group_name", &self.group_name);
        formatter.field("opt_in_status", &self.opt_in_status);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ModifyAddressAttributeInput {
    /// <p>[EC2-VPC] The allocation ID.</p>
    pub allocation_id: std::option::Option<std::string::String>,
    /// <p>The domain name to modify for the IP address.</p>
    pub domain_name: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ModifyAddressAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ModifyAddressAttributeInput");
        formatter.field("allocation_id", &self.allocation_id);
        formatter.field("domain_name", &self.domain_name);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ImportVolumeInput {
    /// <p>The Availability Zone for the resulting EBS volume.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>A description of the volume.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The disk image.</p>
    pub image: std::option::Option<crate::model::DiskImageDetail>,
    /// <p>The volume size.</p>
    pub volume: std::option::Option<crate::model::VolumeDetail>,
}
impl std::fmt::Debug for ImportVolumeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ImportVolumeInput");
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("image", &self.image);
        formatter.field("volume", &self.volume);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ImportSnapshotInput {
    /// <p>The client-specific data.</p>
    pub client_data: std::option::Option<crate::model::ClientData>,
    /// <p>Token to enable idempotency for VM import requests.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The description string for the import snapshot task.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Information about the disk container.</p>
    pub disk_container: std::option::Option<crate::model::SnapshotDiskContainer>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Specifies whether the destination snapshot of the imported image should be encrypted. The default CMK for EBS is
    /// used unless you specify a non-default AWS Key Management Service (AWS KMS) CMK using <code>KmsKeyId</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS Encryption</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub encrypted: std::option::Option<bool>,
    /// <p>An identifier for the symmetric AWS Key Management Service (AWS KMS) customer master key (CMK) to use when creating the
    /// encrypted snapshot. This parameter is only required if you want to use a non-default CMK; if this
    /// parameter is not specified, the default CMK for EBS is used. If a <code>KmsKeyId</code> is
    /// specified, the <code>Encrypted</code> flag must also be set. </p>
    /// <p>The CMK identifier may be provided in any of the following formats: </p>
    /// <ul>
    /// <li>
    /// <p>Key ID</p>
    /// </li>
    /// <li>
    /// <p>Key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>.</p>
    /// </li>
    /// <li>
    /// <p>ARN using key ID. The ID ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>key</code> namespace, and then the CMK ID. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:key/<i>abcd1234-a123-456a-a12b-a123b4cd56ef</i>.</p>
    /// </li>
    /// <li>
    /// <p>ARN using key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>. </p>
    /// </li>
    /// </ul>
    /// <p>AWS parses <code>KmsKeyId</code> asynchronously, meaning that the action you call may appear to complete even
    /// though you provided an invalid identifier. This action will eventually report failure. </p>
    /// <p>The specified CMK must exist in the Region that the snapshot is being copied to.</p>
    /// <p>Amazon EBS does not support asymmetric CMKs.</p>
    pub kms_key_id: std::option::Option<std::string::String>,
    /// <p>The name of the role to use when not using the default role, 'vmimport'.</p>
    pub role_name: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the import snapshot task during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for ImportSnapshotInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ImportSnapshotInput");
        formatter.field("client_data", &self.client_data);
        formatter.field("client_token", &self.client_token);
        formatter.field("description", &self.description);
        formatter.field("disk_container", &self.disk_container);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("encrypted", &self.encrypted);
        formatter.field("kms_key_id", &self.kms_key_id);
        formatter.field("role_name", &self.role_name);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ImportKeyPairInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>A unique name for the key pair.</p>
    pub key_name: std::option::Option<std::string::String>,
    /// <p>The public key. For API calls, the text must be base64-encoded. For command line tools, base64 encoding is performed for you.</p>
    pub public_key_material: std::option::Option<smithy_types::Blob>,
    /// <p>The tags to apply to the imported key pair.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for ImportKeyPairInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ImportKeyPairInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("key_name", &self.key_name);
        formatter.field("public_key_material", &self.public_key_material);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ImportInstanceInput {
    /// <p>A description for the instance being imported.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The disk image.</p>
    pub disk_images: std::option::Option<std::vec::Vec<crate::model::DiskImage>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The launch specification.</p>
    pub launch_specification: std::option::Option<crate::model::ImportInstanceLaunchSpecification>,
    /// <p>The instance operating system.</p>
    pub platform: std::option::Option<crate::model::PlatformValues>,
}
impl std::fmt::Debug for ImportInstanceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ImportInstanceInput");
        formatter.field("description", &self.description);
        formatter.field("disk_images", &self.disk_images);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("launch_specification", &self.launch_specification);
        formatter.field("platform", &self.platform);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ImportImageInput {
    /// <p>The architecture of the virtual machine.</p>
    /// <p>Valid values: <code>i386</code> | <code>x86_64</code> | <code>arm64</code>
    /// </p>
    pub architecture: std::option::Option<std::string::String>,
    /// <p>The client-specific data.</p>
    pub client_data: std::option::Option<crate::model::ClientData>,
    /// <p>The token to enable idempotency for VM import requests.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>A description string for the import image task.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Information about the disk containers.</p>
    pub disk_containers: std::option::Option<std::vec::Vec<crate::model::ImageDiskContainer>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Specifies whether the destination AMI of the imported image should be encrypted. The default CMK for EBS is used
    /// unless you specify a non-default AWS Key Management Service (AWS KMS) CMK using <code>KmsKeyId</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS Encryption</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub encrypted: std::option::Option<bool>,
    /// <p>The target hypervisor platform.</p>
    /// <p>Valid values: <code>xen</code>
    /// </p>
    pub hypervisor: std::option::Option<std::string::String>,
    /// <p>An identifier for the symmetric AWS Key Management Service (AWS KMS) customer master key (CMK) to use when creating the
    /// encrypted AMI. This parameter is only required if you want to use a non-default CMK; if this
    /// parameter is not specified, the default CMK for EBS is used. If a <code>KmsKeyId</code> is
    /// specified, the <code>Encrypted</code> flag must also be set. </p>
    /// <p>The CMK identifier may be provided in any of the following formats: </p>
    /// <ul>
    /// <li>
    /// <p>Key ID</p>
    /// </li>
    /// <li>
    /// <p>Key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>.</p>
    /// </li>
    /// <li>
    /// <p>ARN using key ID. The ID ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>key</code> namespace, and then the CMK ID. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:key/<i>abcd1234-a123-456a-a12b-a123b4cd56ef</i>.</p>
    /// </li>
    /// <li>
    /// <p>ARN using key alias. The alias ARN contains the <code>arn:aws:kms</code> namespace, followed by the Region of the CMK, the AWS account ID of the CMK owner, the <code>alias</code> namespace, and then the CMK alias. For example, arn:aws:kms:<i>us-east-1</i>:<i>012345678910</i>:alias/<i>ExampleAlias</i>. </p>
    /// </li>
    /// </ul>
    /// <p>AWS parses <code>KmsKeyId</code> asynchronously, meaning that the action you call may appear to complete even
    /// though you provided an invalid identifier. This action will eventually report failure. </p>
    /// <p>The specified CMK must exist in the Region that the AMI is being copied to.</p>
    /// <p>Amazon EBS does not support asymmetric CMKs.</p>
    pub kms_key_id: std::option::Option<std::string::String>,
    /// <p>The license type to be used for the Amazon Machine Image (AMI) after importing.</p>
    /// <p>By default, we detect the source-system operating system (OS) and apply the appropriate license. Specify
    /// <code>AWS</code> to replace the source-system license with an AWS license, if appropriate. Specify <code>BYOL</code>
    /// to retain the source-system license, if appropriate.</p>
    /// <p>To use <code>BYOL</code>, you must have existing licenses with rights to use these licenses in a third party
    /// cloud, such as AWS. For more information, see <a href="https://docs.aws.amazon.com/vm-import/latest/userguide/vmimport-image-import.html#prerequisites-image">Prerequisites</a> in the
    /// VM Import/Export User Guide.</p>
    pub license_type: std::option::Option<std::string::String>,
    /// <p>The operating system of the virtual machine.</p>
    /// <p>Valid values: <code>Windows</code> | <code>Linux</code>
    /// </p>
    pub platform: std::option::Option<std::string::String>,
    /// <p>The name of the role to use when not using the default role, 'vmimport'.</p>
    pub role_name: std::option::Option<std::string::String>,
    /// <p>The ARNs of the license configurations.</p>
    pub license_specifications:
        std::option::Option<std::vec::Vec<crate::model::ImportImageLicenseConfigurationRequest>>,
    /// <p>The tags to apply to the import image task during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for ImportImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ImportImageInput");
        formatter.field("architecture", &self.architecture);
        formatter.field("client_data", &self.client_data);
        formatter.field("client_token", &self.client_token);
        formatter.field("description", &self.description);
        formatter.field("disk_containers", &self.disk_containers);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("encrypted", &self.encrypted);
        formatter.field("hypervisor", &self.hypervisor);
        formatter.field("kms_key_id", &self.kms_key_id);
        formatter.field("license_type", &self.license_type);
        formatter.field("platform", &self.platform);
        formatter.field("role_name", &self.role_name);
        formatter.field("license_specifications", &self.license_specifications);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ImportClientVpnClientCertificateRevocationListInput {
    /// <p>The ID of the Client VPN endpoint to which the client certificate revocation list applies.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The client certificate revocation list file. For more information, see <a href="https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/cvpn-working-certificates.html#cvpn-working-certificates-generate">Generate a Client Certificate Revocation List</a> in the
    /// <i>AWS Client VPN Administrator Guide</i>.</p>
    pub certificate_revocation_list: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ImportClientVpnClientCertificateRevocationListInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ImportClientVpnClientCertificateRevocationListInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field(
            "certificate_revocation_list",
            &self.certificate_revocation_list,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetTransitGatewayRouteTablePropagationsInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>resource-id</code> - The ID of the resource.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-type</code> - The resource type. Valid values are <code>vpc</code>
    /// | <code>vpn</code> | <code>direct-connect-gateway</code> | <code>peering</code>
    /// | <code>connect</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The ID of the attachment.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetTransitGatewayRouteTablePropagationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetTransitGatewayRouteTablePropagationsInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetTransitGatewayRouteTableAssociationsInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>resource-id</code> - The ID of the resource.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-type</code> - The resource type. Valid values are <code>vpc</code>
    /// | <code>vpn</code> | <code>direct-connect-gateway</code> | <code>peering</code>
    /// | <code>connect</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The ID of the attachment.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetTransitGatewayRouteTableAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetTransitGatewayRouteTableAssociationsInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetTransitGatewayPrefixListReferencesInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>attachment.resource-id</code> - The ID of the resource for the attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.resource-type</code> - The type of resource for the
    /// attachment. Valid values are <code>vpc</code> | <code>vpn</code> |
    /// <code>direct-connect-gateway</code> | <code>peering</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.transit-gateway-attachment-id</code> - The ID of the attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>is-blackhole</code> - Whether traffic matching the route is blocked (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>prefix-list-id</code> - The ID of the prefix list.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>prefix-list-owner-id</code> - The ID of the owner of the prefix list.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the prefix list reference (<code>pending</code> | <code>available</code> | <code>modifying</code> | <code>deleting</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetTransitGatewayPrefixListReferencesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetTransitGatewayPrefixListReferencesInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetTransitGatewayMulticastDomainAssociationsInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>resource-id</code> - The ID of the resource.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-type</code> - The type of resource. The valid value is: <code>vpc</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the subnet association. Valid values are
    /// <code>associated</code> |
    /// <code>associating</code>
    /// | <code>disassociated</code> | <code>disassociating</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>subnet-id</code> - The ID of the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The id of the transit gateway attachment.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetTransitGatewayMulticastDomainAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetTransitGatewayMulticastDomainAssociationsInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetTransitGatewayAttachmentPropagationsInput {
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>transit-gateway-route-table-id</code> - The ID of the transit gateway route table.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetTransitGatewayAttachmentPropagationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetTransitGatewayAttachmentPropagationsInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetSerialConsoleAccessStatusInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetSerialConsoleAccessStatusInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetSerialConsoleAccessStatusInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for GetReservedInstanceExchangeQuote.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetReservedInstancesExchangeQuoteInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the Convertible Reserved Instances to exchange.</p>
    pub reserved_instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The configuration of the target Convertible Reserved Instance to exchange for your
    /// current Convertible Reserved Instances.</p>
    pub target_configurations:
        std::option::Option<std::vec::Vec<crate::model::TargetConfigurationRequest>>,
}
impl std::fmt::Debug for GetReservedInstancesExchangeQuoteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetReservedInstancesExchangeQuoteInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("reserved_instance_ids", &self.reserved_instance_ids);
        formatter.field("target_configurations", &self.target_configurations);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetPasswordDataInput {
    /// <p>The ID of the Windows instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetPasswordDataInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetPasswordDataInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetManagedPrefixListEntriesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the prefix list.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
    /// <p>The version of the prefix list for which to return the entries. The default is the current version.</p>
    pub target_version: std::option::Option<i64>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for GetManagedPrefixListEntriesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetManagedPrefixListEntriesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.field("target_version", &self.target_version);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetManagedPrefixListAssociationsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the prefix list.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for GetManagedPrefixListAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetManagedPrefixListAssociationsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetLaunchTemplateDataInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for GetLaunchTemplateDataInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetLaunchTemplateDataInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetHostReservationPurchasePreviewInput {
    /// <p>The IDs of the Dedicated Hosts with which the reservation is associated.</p>
    pub host_id_set: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The offering ID of the reservation.</p>
    pub offering_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for GetHostReservationPurchasePreviewInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetHostReservationPurchasePreviewInput");
        formatter.field("host_id_set", &self.host_id_set);
        formatter.field("offering_id", &self.offering_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetGroupsForCapacityReservationInput {
    /// <p>The ID of the Capacity Reservation.</p>
    pub capacity_reservation_id: std::option::Option<std::string::String>,
    /// <p>The token to use to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetGroupsForCapacityReservationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetGroupsForCapacityReservationInput");
        formatter.field("capacity_reservation_id", &self.capacity_reservation_id);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetFlowLogsIntegrationTemplateInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the flow log.</p>
    pub flow_log_id: std::option::Option<std::string::String>,
    /// <p>To store the CloudFormation template in Amazon S3, specify the location in Amazon S3.</p>
    pub config_delivery_s3_destination_arn: std::option::Option<std::string::String>,
    /// <p>Information about the service integration.</p>
    pub integrate_services: std::option::Option<crate::model::IntegrateServices>,
}
impl std::fmt::Debug for GetFlowLogsIntegrationTemplateInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetFlowLogsIntegrationTemplateInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("flow_log_id", &self.flow_log_id);
        formatter.field(
            "config_delivery_s3_destination_arn",
            &self.config_delivery_s3_destination_arn,
        );
        formatter.field("integrate_services", &self.integrate_services);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetEbsEncryptionByDefaultInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetEbsEncryptionByDefaultInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetEbsEncryptionByDefaultInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetEbsDefaultKmsKeyIdInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetEbsDefaultKmsKeyIdInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetEbsDefaultKmsKeyIdInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetDefaultCreditSpecificationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The instance family.</p>
    pub instance_family: std::option::Option<crate::model::UnlimitedSupportedInstanceFamily>,
}
impl std::fmt::Debug for GetDefaultCreditSpecificationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetDefaultCreditSpecificationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_family", &self.instance_family);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetConsoleScreenshotInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>When set to <code>true</code>, acts as keystroke input and wakes up an instance that's
    /// in standby or "sleep" mode.</p>
    pub wake_up: std::option::Option<bool>,
}
impl std::fmt::Debug for GetConsoleScreenshotInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetConsoleScreenshotInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("wake_up", &self.wake_up);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetConsoleOutputInput {
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>When enabled, retrieves the latest console output for the instance.</p>
    /// <p>Default: disabled (<code>false</code>)</p>
    pub latest: std::option::Option<bool>,
}
impl std::fmt::Debug for GetConsoleOutputInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetConsoleOutputInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("latest", &self.latest);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetCoipPoolUsageInput {
    /// <p>The ID of the address pool.</p>
    pub pool_id: std::option::Option<std::string::String>,
    /// <p>The filters. The following are the possible values:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>coip-address-usage.allocation-id</code>
    /// </p>
    /// </li>
    /// </ul>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>coip-address-usage.aws-account-id</code>
    /// </p>
    /// </li>
    /// </ul>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>coip-address-usage.aws-service</code>
    /// </p>
    /// </li>
    /// </ul>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>coip-address-usage.co-ip</code>
    /// </p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetCoipPoolUsageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetCoipPoolUsageInput");
        formatter.field("pool_id", &self.pool_id);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetCapacityReservationUsageInput {
    /// <p>The ID of the Capacity Reservation.</p>
    pub capacity_reservation_id: std::option::Option<std::string::String>,
    /// <p>The token to use to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
    /// <p>Valid range: Minimum value of 1. Maximum value of 1000.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetCapacityReservationUsageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetCapacityReservationUsageInput");
        formatter.field("capacity_reservation_id", &self.capacity_reservation_id);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetAssociatedIpv6PoolCidrsInput {
    /// <p>The ID of the IPv6 address pool.</p>
    pub pool_id: std::option::Option<std::string::String>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetAssociatedIpv6PoolCidrsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetAssociatedIpv6PoolCidrsInput");
        formatter.field("pool_id", &self.pool_id);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetAssociatedEnclaveCertificateIamRolesInput {
    /// <p>The ARN of the ACM certificate for which to view the associated IAM roles, encryption keys, and Amazon
    /// S3 object information.</p>
    pub certificate_arn: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for GetAssociatedEnclaveCertificateIamRolesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetAssociatedEnclaveCertificateIamRolesInput");
        formatter.field("certificate_arn", &self.certificate_arn);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ExportTransitGatewayRoutesInput {
    /// <p>The ID of the route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>attachment.transit-gateway-attachment-id</code> - The id of the transit gateway attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.resource-id</code> - The resource id of the transit gateway attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.exact-match</code> - The exact match of the specified filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.longest-prefix-match</code> - The longest prefix that matches the route.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.subnet-of-match</code> - The routes with a subnet that match the specified CIDR filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-search.supernet-of-match</code> - The routes with a CIDR that encompass the CIDR filter. For example, if you have 10.0.1.0/29 and 10.0.1.0/31 routes in your route table and you specify supernet-of-match as 10.0.1.0/30, then the result returns 10.0.1.0/29.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the route (<code>active</code> | <code>blackhole</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-route-destination-cidr-block</code> - The CIDR range.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>type</code> - The type of route (<code>propagated</code> |
    /// <code>static</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The name of the S3 bucket.</p>
    pub s3_bucket: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ExportTransitGatewayRoutesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ExportTransitGatewayRoutesInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("s3_bucket", &self.s3_bucket);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ExportImageInput {
    /// <p>Token to enable idempotency for export image requests.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>A description of the image being exported. The maximum length is 255 characters.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The disk image format.</p>
    pub disk_image_format: std::option::Option<crate::model::DiskImageFormat>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the image.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>Information about the destination Amazon S3 bucket. The bucket must exist and grant WRITE
    /// and READ_ACP permissions to the AWS account vm-import-export@amazon.com.</p>
    pub s3_export_location: std::option::Option<crate::model::ExportTaskS3LocationRequest>,
    /// <p>The name of the role that grants VM Import/Export permission to export images to your Amazon
    /// S3 bucket. If this parameter is not specified, the default role is named 'vmimport'.</p>
    pub role_name: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the export image task during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for ExportImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ExportImageInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("description", &self.description);
        formatter.field("disk_image_format", &self.disk_image_format);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("image_id", &self.image_id);
        formatter.field("s3_export_location", &self.s3_export_location);
        formatter.field("role_name", &self.role_name);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ExportClientVpnClientConfigurationInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ExportClientVpnClientConfigurationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ExportClientVpnClientConfigurationInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ExportClientVpnClientCertificateRevocationListInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ExportClientVpnClientCertificateRevocationListInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ExportClientVpnClientCertificateRevocationListInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableVpcClassicLinkDnsSupportInput {
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for EnableVpcClassicLinkDnsSupportInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableVpcClassicLinkDnsSupportInput");
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableVpcClassicLinkInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for EnableVpcClassicLinkInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableVpcClassicLinkInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableVolumeIoInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the volume.</p>
    pub volume_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for EnableVolumeIoInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableVolumeIoInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("volume_id", &self.volume_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for EnableVgwRoutePropagation.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableVgwRoutePropagationInput {
    /// <p>The ID of the virtual private gateway that is attached to a VPC. The virtual private gateway must be attached to the same VPC that the routing tables are associated with. </p>
    pub gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the route table. The routing table must be associated with the same VPC that the virtual private gateway is attached to. </p>
    pub route_table_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for EnableVgwRoutePropagationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableVgwRoutePropagationInput");
        formatter.field("gateway_id", &self.gateway_id);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableTransitGatewayRouteTablePropagationInput {
    /// <p>The ID of the propagation route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for EnableTransitGatewayRouteTablePropagationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableTransitGatewayRouteTablePropagationInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableSerialConsoleAccessInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for EnableSerialConsoleAccessInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableSerialConsoleAccessInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableImageDeprecationInput {
    /// <p>The ID of the AMI.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>The date and time to deprecate the AMI, in UTC, in the following format:
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z.
    /// If you specify a value for seconds, Amazon EC2 rounds the seconds to the
    /// nearest minute.</p>
    /// <p>You can’t specify a date in the past. The upper limit for <code>DeprecateAt</code> is 10
    /// years from now.</p>
    pub deprecate_at: std::option::Option<smithy_types::Instant>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for EnableImageDeprecationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableImageDeprecationInput");
        formatter.field("image_id", &self.image_id);
        formatter.field("deprecate_at", &self.deprecate_at);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableFastSnapshotRestoresInput {
    /// <p>One or more Availability Zones. For example, <code>us-east-2a</code>.</p>
    pub availability_zones: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The IDs of one or more snapshots. For example, <code>snap-1234567890abcdef0</code>. You can specify
    /// a snapshot that was shared with you from another AWS account.</p>
    pub source_snapshot_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for EnableFastSnapshotRestoresInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableFastSnapshotRestoresInput");
        formatter.field("availability_zones", &self.availability_zones);
        formatter.field("source_snapshot_ids", &self.source_snapshot_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct EnableEbsEncryptionByDefaultInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for EnableEbsEncryptionByDefaultInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("EnableEbsEncryptionByDefaultInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateVpcCidrBlockInput {
    /// <p>The association ID for the CIDR block.</p>
    pub association_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DisassociateVpcCidrBlockInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateVpcCidrBlockInput");
        formatter.field("association_id", &self.association_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateTrunkInterfaceInput {
    /// <p>The ID ofthe association</p>
    pub association_id: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisassociateTrunkInterfaceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateTrunkInterfaceInput");
        formatter.field("association_id", &self.association_id);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateTransitGatewayRouteTableInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisassociateTransitGatewayRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateTransitGatewayRouteTableInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateTransitGatewayMulticastDomainInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>The IDs of the subnets;</p>
    pub subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisassociateTransitGatewayMulticastDomainInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateTransitGatewayMulticastDomainInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("subnet_ids", &self.subnet_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateSubnetCidrBlockInput {
    /// <p>The association ID for the CIDR block.</p>
    pub association_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DisassociateSubnetCidrBlockInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateSubnetCidrBlockInput");
        formatter.field("association_id", &self.association_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateRouteTableInput {
    /// <p>The association ID representing the current association between the route table and subnet or gateway.</p>
    pub association_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisassociateRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateRouteTableInput");
        formatter.field("association_id", &self.association_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateIamInstanceProfileInput {
    /// <p>The ID of the IAM instance profile association.</p>
    pub association_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DisassociateIamInstanceProfileInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateIamInstanceProfileInput");
        formatter.field("association_id", &self.association_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateEnclaveCertificateIamRoleInput {
    /// <p>The ARN of the ACM certificate from which to disassociate the IAM role.</p>
    pub certificate_arn: std::option::Option<std::string::String>,
    /// <p>The ARN of the IAM role to disassociate.</p>
    pub role_arn: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisassociateEnclaveCertificateIamRoleInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateEnclaveCertificateIamRoleInput");
        formatter.field("certificate_arn", &self.certificate_arn);
        formatter.field("role_arn", &self.role_arn);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateClientVpnTargetNetworkInput {
    /// <p>The ID of the Client VPN endpoint from which to disassociate the target network.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The ID of the target network association.</p>
    pub association_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisassociateClientVpnTargetNetworkInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateClientVpnTargetNetworkInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("association_id", &self.association_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisassociateAddressInput {
    /// <p>[EC2-VPC] The association ID. Required for EC2-VPC.</p>
    pub association_id: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic] The Elastic IP address. Required for EC2-Classic.</p>
    pub public_ip: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisassociateAddressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisassociateAddressInput");
        formatter.field("association_id", &self.association_id);
        formatter.field("public_ip", &self.public_ip);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableVpcClassicLinkDnsSupportInput {
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DisableVpcClassicLinkDnsSupportInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableVpcClassicLinkDnsSupportInput");
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableVpcClassicLinkInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DisableVpcClassicLinkInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableVpcClassicLinkInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DisableVgwRoutePropagation.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableVgwRoutePropagationInput {
    /// <p>The ID of the virtual private gateway.</p>
    pub gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the route table.</p>
    pub route_table_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisableVgwRoutePropagationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableVgwRoutePropagationInput");
        formatter.field("gateway_id", &self.gateway_id);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableTransitGatewayRouteTablePropagationInput {
    /// <p>The ID of the propagation route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisableTransitGatewayRouteTablePropagationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableTransitGatewayRouteTablePropagationInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableSerialConsoleAccessInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisableSerialConsoleAccessInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableSerialConsoleAccessInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableImageDeprecationInput {
    /// <p>The ID of the AMI.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisableImageDeprecationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableImageDeprecationInput");
        formatter.field("image_id", &self.image_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableFastSnapshotRestoresInput {
    /// <p>One or more Availability Zones. For example, <code>us-east-2a</code>.</p>
    pub availability_zones: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The IDs of one or more snapshots. For example, <code>snap-1234567890abcdef0</code>.</p>
    pub source_snapshot_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisableFastSnapshotRestoresInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableFastSnapshotRestoresInput");
        formatter.field("availability_zones", &self.availability_zones);
        formatter.field("source_snapshot_ids", &self.source_snapshot_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DisableEbsEncryptionByDefaultInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DisableEbsEncryptionByDefaultInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DisableEbsEncryptionByDefaultInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DetachVpnGateway.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DetachVpnGatewayInput {
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The ID of the virtual private gateway.</p>
    pub vpn_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DetachVpnGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DetachVpnGatewayInput");
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("vpn_gateway_id", &self.vpn_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DetachVolumeInput {
    /// <p>The device name.</p>
    pub device: std::option::Option<std::string::String>,
    /// <p>Forces detachment if the previous detachment attempt did not occur cleanly (for example,
    /// logging into an instance, unmounting the volume, and detaching normally). This option can lead
    /// to data loss or a corrupted file system. Use this option only as a last resort to detach a
    /// volume from a failed instance. The instance won't have an opportunity to flush file system
    /// caches or file system metadata. If you use this option, you must perform file system check and
    /// repair procedures.</p>
    pub force: std::option::Option<bool>,
    /// <p>The ID of the instance. If you are detaching a Multi-Attach enabled volume, you must specify an instance ID.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The ID of the volume.</p>
    pub volume_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DetachVolumeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DetachVolumeInput");
        formatter.field("device", &self.device);
        formatter.field("force", &self.force);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("volume_id", &self.volume_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DetachNetworkInterface.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DetachNetworkInterfaceInput {
    /// <p>The ID of the attachment.</p>
    pub attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Specifies whether to force a detachment.</p>
    /// <note>
    /// <ul>
    /// <li>
    /// <p>Use the <code>Force</code> parameter only as a last resort to detach a network interface from a failed instance. </p>
    /// </li>
    /// <li>
    /// <p>If you use the <code>Force</code> parameter to detach a network interface, you might not be able to attach a different network interface to the same index on the instance without first stopping and starting the instance.</p>
    /// </li>
    /// <li>
    /// <p>If you force the detachment of a network interface, the <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html">instance metadata</a>
    /// might not get updated. This means that the attributes associated
    /// with the detached network interface might still be visible. The
    /// instance metadata will get updated when you stop and start the
    /// instance.</p>
    /// </li>
    /// </ul>
    /// </note>
    pub force: std::option::Option<bool>,
}
impl std::fmt::Debug for DetachNetworkInterfaceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DetachNetworkInterfaceInput");
        formatter.field("attachment_id", &self.attachment_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("force", &self.force);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DetachInternetGatewayInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the internet gateway.</p>
    pub internet_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DetachInternetGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DetachInternetGatewayInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("internet_gateway_id", &self.internet_gateway_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DetachClassicLinkVpcInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance to unlink from the VPC.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC to which the instance is linked.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DetachClassicLinkVpcInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DetachClassicLinkVpcInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeVpnGateways.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpnGatewaysInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>amazon-side-asn</code> - The Autonomous System Number (ASN) for the Amazon side of the gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.state</code> - The current state of the attachment between the gateway and the VPC (<code>attaching</code> | <code>attached</code> | <code>detaching</code> | <code>detached</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.vpc-id</code> - The ID of an attached VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone for the virtual private gateway (if applicable).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the virtual private gateway (<code>pending</code> | <code>available</code> | <code>deleting</code> | <code>deleted</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>type</code> - The type of virtual private gateway. Currently the only supported type is <code>ipsec.1</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpn-gateway-id</code> - The ID of the virtual private gateway.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>One or more virtual private gateway IDs.</p>
    /// <p>Default: Describes all your virtual private gateways.</p>
    pub vpn_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeVpnGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpnGatewaysInput");
        formatter.field("filters", &self.filters);
        formatter.field("vpn_gateway_ids", &self.vpn_gateway_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeVpnConnections.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpnConnectionsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>customer-gateway-configuration</code> - The configuration information for the customer gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>customer-gateway-id</code> - The ID of a customer gateway associated with the VPN connection.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the VPN connection (<code>pending</code> | <code>available</code> | <code>deleting</code> | <code>deleted</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>option.static-routes-only</code> - Indicates whether the connection has static routes only. Used for devices that do not support Border Gateway Protocol (BGP).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.destination-cidr-block</code> - The destination CIDR block. This corresponds to the subnet used in a customer data center.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>bgp-asn</code> - The BGP Autonomous System Number (ASN) associated with a BGP device.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>type</code> - The type of VPN connection. Currently the only supported type is <code>ipsec.1</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpn-connection-id</code> - The ID of the VPN connection.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpn-gateway-id</code> - The ID of a virtual private gateway associated with the VPN connection.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of a transit gateway associated with the VPN connection.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>One or more VPN connection IDs.</p>
    /// <p>Default: Describes your VPN connections.</p>
    pub vpn_connection_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeVpnConnectionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpnConnectionsInput");
        formatter.field("filters", &self.filters);
        formatter.field("vpn_connection_ids", &self.vpn_connection_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>cidr</code> - The primary IPv4 CIDR block of the VPC. The CIDR block you
    /// specify must exactly match the VPC's CIDR block for information to be returned
    /// for the VPC. Must contain the slash followed by one or two digits (for example,
    /// <code>/28</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>cidr-block-association.cidr-block</code> - An IPv4 CIDR block associated with the
    /// VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>cidr-block-association.association-id</code> - The association ID for
    /// an IPv4 CIDR block associated with the VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>cidr-block-association.state</code> - The state of an IPv4 CIDR block
    /// associated with the VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>dhcp-options-id</code> - The ID of a set of DHCP options.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-cidr-block-association.ipv6-cidr-block</code> - An IPv6 CIDR
    /// block associated with the VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-cidr-block-association.ipv6-pool</code> - The ID of the IPv6 address pool from which the IPv6 CIDR block is allocated.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-cidr-block-association.association-id</code> - The association
    /// ID for an IPv6 CIDR block associated with the VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-cidr-block-association.state</code> - The state of an IPv6 CIDR
    /// block associated with the VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>isDefault</code> - Indicates whether the VPC is the default VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the AWS account that owns the VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the VPC (<code>pending</code> | <code>available</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>One or more VPC IDs.</p>
    /// <p>Default: Describes all your VPCs.</p>
    pub vpc_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeVpcsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcsInput");
        formatter.field("filters", &self.filters);
        formatter.field("vpc_ids", &self.vpc_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcPeeringConnectionsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>accepter-vpc-info.cidr-block</code> - The IPv4 CIDR block of the accepter
    /// VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>accepter-vpc-info.owner-id</code> - The AWS account ID of the owner of the
    /// accepter VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>accepter-vpc-info.vpc-id</code> - The ID of the accepter VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>expiration-time</code> - The expiration date and time for the VPC peering
    /// connection.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>requester-vpc-info.cidr-block</code> - The IPv4 CIDR block of the
    /// requester's VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>requester-vpc-info.owner-id</code> - The AWS account ID of the owner of the
    /// requester VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>requester-vpc-info.vpc-id</code> - The ID of the requester VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status-code</code> - The status of the VPC peering connection
    /// (<code>pending-acceptance</code> | <code>failed</code> |
    /// <code>expired</code> | <code>provisioning</code> | <code>active</code> |
    /// <code>deleting</code> | <code>deleted</code> |
    /// <code>rejected</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status-message</code> - A message that provides more information about the status
    /// of the VPC peering connection, if applicable.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-peering-connection-id</code> - The ID of the VPC peering connection.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more VPC peering connection IDs.</p>
    /// <p>Default: Describes all your VPC peering connections.</p>
    pub vpc_peering_connection_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeVpcPeeringConnectionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcPeeringConnectionsInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "vpc_peering_connection_ids",
            &self.vpc_peering_connection_ids,
        );
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeVpcEndpointServices.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcEndpointServicesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more service names.</p>
    pub service_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>service-name</code> - The name of the service.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>service-type</code> - The type of service (<code>Interface</code> |
    /// <code>Gateway</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value. For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of items to return for this request. The request returns a token that you can specify in a subsequent call to get the next set of results.</p>
    /// <p>Constraint: If the value is greater than 1,000, we return only 1,000 items.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of items to return. (You received this token from a prior call.)</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeVpcEndpointServicesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcEndpointServicesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_names", &self.service_names);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcEndpointServicePermissionsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the service.</p>
    pub service_id: std::option::Option<std::string::String>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>principal</code> - The ARN of the principal.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>principal-type</code> - The principal type (<code>All</code> |
    /// <code>Service</code> | <code>OrganizationUnit</code> | <code>Account</code>
    /// | <code>User</code> | <code>Role</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining
    /// results of the initial request can be seen by sending another request with the returned
    /// <code>NextToken</code> value. This value can be between 5 and 1,000; if
    /// <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are
    /// returned.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeVpcEndpointServicePermissionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcEndpointServicePermissionsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_id", &self.service_id);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcEndpointServiceConfigurationsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of one or more services.</p>
    pub service_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>service-name</code> - The name of the service.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>service-id</code> - The ID of the service.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>service-state</code> - The state of the service (<code>Pending</code> |
    /// <code>Available</code> | <code>Deleting</code> | <code>Deleted</code> |
    /// <code>Failed</code>). </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value. For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining
    /// results of the initial request can be seen by sending another request with the returned
    /// <code>NextToken</code> value. This value can be between 5 and 1,000; if
    /// <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are
    /// returned.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeVpcEndpointServiceConfigurationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcEndpointServiceConfigurationsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_ids", &self.service_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeVpcEndpoints.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcEndpointsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more endpoint IDs.</p>
    pub vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>service-name</code> - The name of the service.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC in which the endpoint resides.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-endpoint-id</code> - The ID of the endpoint.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-endpoint-state</code> - The state of the endpoint
    /// (<code>pendingAcceptance</code> | <code>pending</code> |
    /// <code>available</code> | <code>deleting</code> | <code>deleted</code> |
    /// <code>rejected</code> | <code>failed</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-endpoint-type</code> - The type of VPC endpoint (<code>Interface</code> | <code>Gateway</code> | <code>GatewayLoadBalancer</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value. For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of items to return for this request. The request returns a token that you can specify in a subsequent call to get the next set of results.</p>
    /// <p>Constraint: If the value is greater than 1,000, we return only 1,000 items.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of items to return. (You received this token from a prior call.)</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeVpcEndpointsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcEndpointsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_endpoint_ids", &self.vpc_endpoint_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcEndpointConnectionsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>service-id</code> - The ID of the service.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-endpoint-owner</code> - The AWS account number of the owner of the
    /// endpoint.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-endpoint-state</code> - The state of the endpoint
    /// (<code>pendingAcceptance</code> | <code>pending</code> |
    /// <code>available</code> | <code>deleting</code> | <code>deleted</code> |
    /// <code>rejected</code> | <code>failed</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-endpoint-id</code> - The ID of the endpoint.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining
    /// results of the initial request can be seen by sending another request with the returned
    /// <code>NextToken</code> value. This value can be between 5 and 1,000; if
    /// <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are
    /// returned.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeVpcEndpointConnectionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcEndpointConnectionsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcEndpointConnectionNotificationsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the notification.</p>
    pub connection_notification_id: std::option::Option<std::string::String>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>connection-notification-arn</code> - The ARN of the SNS topic for the
    /// notification.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>connection-notification-id</code> - The ID of the
    /// notification.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>connection-notification-state</code> - The state of the notification
    /// (<code>Enabled</code> | <code>Disabled</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>connection-notification-type</code> - The type of notification
    /// (<code>Topic</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>service-id</code> - The ID of the endpoint service.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-endpoint-id</code> - The ID of the VPC endpoint.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another request with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeVpcEndpointConnectionNotificationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcEndpointConnectionNotificationsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "connection_notification_id",
            &self.connection_notification_id,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcClassicLinkDnsSupportInput {
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more VPC IDs.</p>
    pub vpc_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribeVpcClassicLinkDnsSupportInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcClassicLinkDnsSupportInput");
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("vpc_ids", &self.vpc_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcClassicLinkInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>is-classic-link-enabled</code> - Whether the VPC is enabled for ClassicLink
    /// (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more VPCs for which you want to describe the ClassicLink status.</p>
    pub vpc_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribeVpcClassicLinkInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcClassicLinkInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_ids", &self.vpc_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVpcAttributeInput {
    /// <p>The VPC attribute.</p>
    pub attribute: std::option::Option<crate::model::VpcAttributeName>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeVpcAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVpcAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVolumeStatusInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>action.code</code> - The action code for the event (for example,
    /// <code>enable-volume-io</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>action.description</code> - A description of the action.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>action.event-id</code> - The event ID associated with the action.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.description</code> - A description of the event.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.event-id</code> - The event ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.event-type</code> - The event type (for <code>io-enabled</code>:
    /// <code>passed</code> | <code>failed</code>; for <code>io-performance</code>:
    /// <code>io-performance:degraded</code> | <code>io-performance:severely-degraded</code> |
    /// <code>io-performance:stalled</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.not-after</code> - The latest end time for the event.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.not-before</code> - The earliest start time for the event.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-status.details-name</code> - The cause for
    /// <code>volume-status.status</code> (<code>io-enabled</code> |
    /// <code>io-performance</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-status.details-status</code> - The status of
    /// <code>volume-status.details-name</code> (for <code>io-enabled</code>:
    /// <code>passed</code> | <code>failed</code>; for <code>io-performance</code>:
    /// <code>normal</code> | <code>degraded</code> | <code>severely-degraded</code> |
    /// <code>stalled</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-status.status</code> - The status of the volume (<code>ok</code> |
    /// <code>impaired</code> | <code>warning</code> | <code>insufficient-data</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of volume results returned by <code>DescribeVolumeStatus</code> in
    /// paginated output. When this parameter is used, the request only returns
    /// <code>MaxResults</code> results in a single page along with a <code>NextToken</code>
    /// response element. The remaining results of the initial request can be seen by sending another
    /// request with the returned <code>NextToken</code> value. This value can be between 5 and 1,000;
    /// if <code>MaxResults</code> is given a value larger than 1,000, only 1,000 results are returned.
    /// If this parameter is not used, then <code>DescribeVolumeStatus</code> returns all results. You
    /// cannot specify this parameter and the volume IDs parameter in the same request.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The <code>NextToken</code> value to include in a future <code>DescribeVolumeStatus</code>
    /// request. When the results of the request exceed <code>MaxResults</code>, this value can be
    /// used to retrieve the next page of results. This value is <code>null</code> when there are no
    /// more results to return.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The IDs of the volumes.</p>
    /// <p>Default: Describes all your volumes.</p>
    pub volume_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeVolumeStatusInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVolumeStatusInput");
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("volume_ids", &self.volume_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVolumesModificationsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the volumes.</p>
    pub volume_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>modification-state</code> - The current modification state (modifying |
    /// optimizing | completed | failed).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>original-iops</code> - The original IOPS rate of the volume.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>original-size</code> - The original size of the volume, in GiB.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>original-volume-type</code> - The original volume type of the volume (standard |
    /// io1 | io2 | gp2 | sc1 | st1).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>originalMultiAttachEnabled</code> - Indicates whether Multi-Attach support was enabled (true | false).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>start-time</code> - The modification start time.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>target-iops</code> - The target IOPS rate of the volume.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>target-size</code> - The target size of the volume, in GiB.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>target-volume-type</code> - The target volume type of the volume (standard |
    /// io1 | io2 | gp2 | sc1 | st1).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>targetMultiAttachEnabled</code> - Indicates whether Multi-Attach support is to be enabled (true | false).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-id</code> - The ID of the volume.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The <code>nextToken</code> value returned by a previous paginated request.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results (up to a limit of 500) to be returned in a paginated
    /// request.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeVolumesModificationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVolumesModificationsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("volume_ids", &self.volume_ids);
        formatter.field("filters", &self.filters);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVolumesInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>attachment.attach-time</code> - The time stamp when the attachment
    /// initiated.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.delete-on-termination</code> - Whether the volume is deleted on
    /// instance termination.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.device</code> - The device name specified in the block device mapping
    /// (for example, <code>/dev/sda1</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.instance-id</code> - The ID of the instance the volume is attached
    /// to.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.status</code> - The attachment state (<code>attaching</code> |
    /// <code>attached</code> | <code>detaching</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone in which the volume was
    /// created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>create-time</code> - The time stamp when the volume was created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>encrypted</code> - Indicates whether the volume is encrypted (<code>true</code>
    /// | <code>false</code>)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>multi-attach-enabled</code> - Indicates whether the volume is enabled for Multi-Attach (<code>true</code>
    /// | <code>false</code>)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fast-restored</code> - Indicates whether the volume was created from a
    /// snapshot that is enabled for fast snapshot restore (<code>true</code> |
    /// <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>size</code> - The size of the volume, in GiB.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>snapshot-id</code> - The snapshot from which the volume was created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status</code> - The state of the volume (<code>creating</code> |
    /// <code>available</code> | <code>in-use</code> | <code>deleting</code> |
    /// <code>deleted</code> | <code>error</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-id</code> - The volume ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-type</code> - The Amazon EBS volume type (<code>gp2</code> | <code>gp3</code> | <code>io1</code> | <code>io2</code> |
    /// <code>st1</code> | <code>sc1</code>| <code>standard</code>)</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The volume IDs.</p>
    pub volume_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of volume results returned by <code>DescribeVolumes</code> in paginated
    /// output. When this parameter is used, <code>DescribeVolumes</code> only returns
    /// <code>MaxResults</code> results in a single page along with a <code>NextToken</code>
    /// response element. The remaining results of the initial request can be seen by sending another
    /// <code>DescribeVolumes</code> request with the returned <code>NextToken</code> value. This
    /// value can be between 5 and 500; if <code>MaxResults</code> is given a value larger than 500,
    /// only 500 results are returned. If this parameter is not used, then
    /// <code>DescribeVolumes</code> returns all results. You cannot specify this parameter and the
    /// volume IDs parameter in the same request.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The <code>NextToken</code> value returned from a previous paginated
    /// <code>DescribeVolumes</code> request where <code>MaxResults</code> was used and the results
    /// exceeded the value of that parameter. Pagination continues from the end of the previous
    /// results that returned the <code>NextToken</code> value. This value is <code>null</code> when
    /// there are no more results to return.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeVolumesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVolumesInput");
        formatter.field("filters", &self.filters);
        formatter.field("volume_ids", &self.volume_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeVolumeAttributeInput {
    /// <p>The attribute of the volume. This parameter is required.</p>
    pub attribute: std::option::Option<crate::model::VolumeAttributeName>,
    /// <p>The ID of the volume.</p>
    pub volume_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeVolumeAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeVolumeAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("volume_id", &self.volume_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTrunkInterfaceAssociationsInput {
    /// <p>The IDs of the associations.</p>
    pub association_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>gre-key</code> - The ID of a trunk interface association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>interface-protocol</code> - The interface protocol. Valid values are <code>VLAN</code> and <code>GRE</code>.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeTrunkInterfaceAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTrunkInterfaceAssociationsInput");
        formatter.field("association_ids", &self.association_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewayVpcAttachmentsInput {
    /// <p>The IDs of the attachments.</p>
    pub transit_gateway_attachment_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the attachment. Valid values are <code>available</code> | <code>deleted</code> | <code>deleting</code> | <code>failed</code> |  <code>failing</code> | <code>initiatingRequest</code> | <code>modifying</code> | <code>pendingAcceptance</code> | <code>pending</code> | <code>rollingBack</code> | <code>rejected</code> | <code>rejecting</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The ID of the attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewayVpcAttachmentsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewayVpcAttachmentsInput");
        formatter.field(
            "transit_gateway_attachment_ids",
            &self.transit_gateway_attachment_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewaysInput {
    /// <p>The IDs of the transit gateways.</p>
    pub transit_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>options.propagation-default-route-table-id</code> - The ID of the default propagation route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>options.amazon-side-asn</code> - The private ASN for the Amazon side of a BGP session.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>options.association-default-route-table-id</code> - The ID of the default association route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>options.auto-accept-shared-attachments</code> - Indicates whether there is automatic acceptance of attachment requests (<code>enable</code> | <code>disable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>options.default-route-table-association</code> - Indicates whether resource attachments are automatically
    /// associated with the default association route table (<code>enable</code> | <code>disable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>options.default-route-table-propagation</code> - Indicates whether resource attachments automatically propagate
    /// routes to the default propagation route table (<code>enable</code> | <code>disable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>options.dns-support</code> - Indicates whether DNS support is enabled (<code>enable</code> | <code>disable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>options.vpn-ecmp-support</code> - Indicates whether Equal Cost Multipath Protocol support is enabled  (<code>enable</code> | <code>disable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the AWS account that owns the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the transit gateway (<code>available</code> | <code>deleted</code> | <code>deleting</code> | <code>modifying</code> | <code>pending</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of the transit gateway.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewaysInput");
        formatter.field("transit_gateway_ids", &self.transit_gateway_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewayRouteTablesInput {
    /// <p>The IDs of the transit gateway route tables.</p>
    pub transit_gateway_route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>default-association-route-table</code> - Indicates whether this is the default
    /// association route table for the transit gateway (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>default-propagation-route-table</code> - Indicates whether this is the default
    /// propagation route table for the transit gateway (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the route table (<code>available</code> | <code>deleting</code> | <code>deleted</code> | <code>pending</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-route-table-id</code> - The ID of the transit gateway route table.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewayRouteTablesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewayRouteTablesInput");
        formatter.field(
            "transit_gateway_route_table_ids",
            &self.transit_gateway_route_table_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewayPeeringAttachmentsInput {
    /// <p>One or more IDs of the transit gateway peering attachments.</p>
    pub transit_gateway_attachment_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The ID of the transit gateway attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-owner-id</code> - The ID of your AWS account.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>remote-owner-id</code> - The ID of the AWS account in the remote Region that owns the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the peering attachment. Valid values are <code>available</code> | <code>deleted</code> | <code>deleting</code> | <code>failed</code> |  <code>failing</code> | <code>initiatingRequest</code> | <code>modifying</code> | <code>pendingAcceptance</code> | <code>pending</code> | <code>rollingBack</code> | <code>rejected</code> | <code>rejecting</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources that have a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of the transit gateway.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewayPeeringAttachmentsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewayPeeringAttachmentsInput");
        formatter.field(
            "transit_gateway_attachment_ids",
            &self.transit_gateway_attachment_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewayMulticastDomainsInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_ids:
        std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the transit gateway multicast domain. Valid values are <code>pending</code> | <code>available</code> | <code>deleting</code> | <code>deleted</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-multicast-domain-id</code> - The ID of the transit gateway multicast domain.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewayMulticastDomainsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewayMulticastDomainsInput");
        formatter.field(
            "transit_gateway_multicast_domain_ids",
            &self.transit_gateway_multicast_domain_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewayConnectsInput {
    /// <p>The IDs of the attachments.</p>
    pub transit_gateway_attachment_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>options.protocol</code> - The tunnel protocol (<code>gre</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the attachment (<code>initiating</code> |
    /// <code>initiatingRequest</code> | <code>pendingAcceptance</code> |
    /// <code>rollingBack</code> | <code>pending</code> | <code>available</code> |
    /// <code>modifying</code> | <code>deleting</code> | <code>deleted</code> |
    /// <code>failed</code> | <code>rejected</code> | <code>rejecting</code> |
    /// <code>failing</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The ID of the
    /// Connect attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transport-transit-gateway-attachment-id</code> - The ID of the transit gateway attachment from which the Connect attachment was created.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewayConnectsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewayConnectsInput");
        formatter.field(
            "transit_gateway_attachment_ids",
            &self.transit_gateway_attachment_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewayConnectPeersInput {
    /// <p>The IDs of the Connect peers.</p>
    pub transit_gateway_connect_peer_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the Connect peer (<code>pending</code> |
    /// <code>available</code> | <code>deleting</code> |
    /// <code>deleted</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The ID of the attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-connect-peer-id</code> - The ID of the Connect peer.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewayConnectPeersInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewayConnectPeersInput");
        formatter.field(
            "transit_gateway_connect_peer_ids",
            &self.transit_gateway_connect_peer_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTransitGatewayAttachmentsInput {
    /// <p>The IDs of the attachments.</p>
    pub transit_gateway_attachment_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>association.state</code> - The state of the association (<code>associating</code> | <code>associated</code> |
    /// <code>disassociating</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.transit-gateway-route-table-id</code> - The ID of the route table for the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-id</code> - The ID of the resource.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-owner-id</code> - The ID of the AWS account that owns the resource.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-type</code> - The resource type. Valid values are <code>vpc</code>
    /// | <code>vpn</code> | <code>direct-connect-gateway</code> | <code>peering</code>
    /// | <code>connect</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the attachment. Valid values are <code>available</code> | <code>deleted</code> | <code>deleting</code> | <code>failed</code> |  <code>failing</code> | <code>initiatingRequest</code> | <code>modifying</code> | <code>pendingAcceptance</code> | <code>pending</code> | <code>rollingBack</code> | <code>rejected</code> | <code>rejecting</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-attachment-id</code> - The ID of the attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-id</code> - The ID of the transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transit-gateway-owner-id</code> - The ID of the AWS account that owns the transit gateway.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeTransitGatewayAttachmentsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTransitGatewayAttachmentsInput");
        formatter.field(
            "transit_gateway_attachment_ids",
            &self.transit_gateway_attachment_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTrafficMirrorTargetsInput {
    /// <p>The ID of the Traffic Mirror targets.</p>
    pub traffic_mirror_target_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>description</code>: The Traffic Mirror target description.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-id</code>: The ID of the Traffic Mirror session network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-load-balancer-arn</code>: The Amazon Resource Name (ARN) of the Network Load Balancer that is associated with the session.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code>: The ID of the account that owns the Traffic Mirror session.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>traffic-mirror-target-id</code>: The ID of the Traffic Mirror target.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeTrafficMirrorTargetsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTrafficMirrorTargetsInput");
        formatter.field("traffic_mirror_target_ids", &self.traffic_mirror_target_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTrafficMirrorSessionsInput {
    /// <p>The ID of the Traffic Mirror session.</p>
    pub traffic_mirror_session_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>description</code>: The Traffic Mirror session description.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-id</code>: The ID of the Traffic Mirror session network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code>: The ID of the account that owns the Traffic Mirror session.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>packet-length</code>: The assigned number of packets to mirror. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>session-number</code>: The assigned session number. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>traffic-mirror-filter-id</code>: The ID of the Traffic Mirror filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>traffic-mirror-session-id</code>: The ID of the Traffic Mirror session.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>traffic-mirror-target-id</code>: The ID of the Traffic Mirror target.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>virtual-network-id</code>: The virtual network ID of the Traffic Mirror session.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeTrafficMirrorSessionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTrafficMirrorSessionsInput");
        formatter.field(
            "traffic_mirror_session_ids",
            &self.traffic_mirror_session_ids,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTrafficMirrorFiltersInput {
    /// <p>The ID of the Traffic Mirror filter.</p>
    pub traffic_mirror_filter_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>description</code>: The Traffic Mirror filter description.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>traffic-mirror-filter-id</code>: The ID of the Traffic Mirror filter.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeTrafficMirrorFiltersInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTrafficMirrorFiltersInput");
        formatter.field("traffic_mirror_filter_ids", &self.traffic_mirror_filter_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeTagsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>key</code> - The tag key.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-id</code> - The ID of the resource.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-type</code> - The resource type (<code>customer-gateway</code> | <code>dedicated-host</code> | <code>dhcp-options</code> | <code>elastic-ip</code> | <code>fleet</code> | <code>fpga-image</code> | <code>host-reservation</code> | <code>image</code> | <code>instance</code> | <code>internet-gateway</code> | <code>key-pair</code> | <code>launch-template</code> | <code>natgateway</code> | <code>network-acl</code> | <code>network-interface</code> | <code>placement-group</code> | <code>reserved-instances</code> | <code>route-table</code> | <code>security-group</code> | <code>snapshot</code> | <code>spot-instances-request</code> | <code>subnet</code> | <code>volume</code> | <code>vpc</code> | <code>vpc-endpoint</code> | <code>vpc-endpoint-service</code> | <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of the tag. For example,
    /// specify "tag:Owner" for the filter name and "TeamA" for the filter value to find
    /// resources with the tag "Owner=TeamA".</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>value</code> - The tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return in a single call.
    /// This value can be between 5 and 1000.
    /// To retrieve the remaining results, make another call with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeTagsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeTagsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSubnetsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone for the subnet. You can also use
    /// <code>availabilityZone</code> as the filter name.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone-id</code> - The ID of the Availability Zone for the subnet.
    /// You can also use <code>availabilityZoneId</code> as the filter name.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>available-ip-address-count</code> - The number of IPv4 addresses in the
    /// subnet that are available.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>cidr-block</code> - The IPv4 CIDR block of the subnet. The CIDR block you
    /// specify must exactly match the subnet's CIDR block for information to be
    /// returned for the subnet. You can also use <code>cidr</code> or
    /// <code>cidrBlock</code> as the filter names.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>default-for-az</code> - Indicates whether this is the default subnet for the
    /// Availability Zone. You can also use <code>defaultForAz</code> as the filter name.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-cidr-block-association.ipv6-cidr-block</code> - An IPv6 CIDR
    /// block associated with the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-cidr-block-association.association-id</code> - An association ID
    /// for an IPv6 CIDR block associated with the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-cidr-block-association.state</code> - The state of an IPv6 CIDR
    /// block associated with the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>outpost-arn</code> - The Amazon Resource Name (ARN) of the Outpost.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the AWS account that owns the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the subnet (<code>pending</code> | <code>available</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>subnet-arn</code> - The Amazon Resource Name (ARN) of the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>subnet-id</code> - The ID of the subnet.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC for the subnet.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>One or more subnet IDs.</p>
    /// <p>Default: Describes all your subnets.</p>
    pub subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeSubnetsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSubnetsInput");
        formatter.field("filters", &self.filters);
        formatter.field("subnet_ids", &self.subnet_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeStoreImageTasksInput {
    /// <p>The AMI IDs for which to show progress. Up to 20 AMI IDs can be included in a request.</p>
    pub image_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>task-state</code> - Returns tasks in a certain state (<code>InProgress</code> |
    /// <code>Completed</code> | <code>Failed</code>)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>bucket</code> - Returns task information for tasks that targeted a specific
    /// bucket. For the filter value, specify the bucket name.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value. This value can be
    /// between 1 and 200. You cannot specify this parameter and the <code>ImageIDs</code> parameter
    /// in the same call.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeStoreImageTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeStoreImageTasksInput");
        formatter.field("image_ids", &self.image_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeStaleSecurityGroupsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of items to return for this request. The request returns a token that you can specify in a subsequent call to get the next set of results.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of items to return. (You received this token from a prior call.)</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeStaleSecurityGroupsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeStaleSecurityGroupsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeSpotPriceHistory.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSpotPriceHistoryInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone for which prices should
    /// be returned.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The type of instance (for example,
    /// <code>m3.medium</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-description</code> - The product description for the Spot price
    /// (<code>Linux/UNIX</code> | <code>Red Hat Enterprise Linux</code> |
    /// <code>SUSE Linux</code> | <code>Windows</code> | <code>Linux/UNIX (Amazon
    /// VPC)</code> | <code>Red Hat Enterprise Linux (Amazon VPC)</code> |
    /// <code>SUSE Linux (Amazon VPC)</code> | <code>Windows (Amazon
    /// VPC)</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>spot-price</code> - The Spot price. The value must match exactly (or use
    /// wildcards; greater than or less than comparison is not supported).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>timestamp</code> - The time stamp of the Spot price history, in UTC format
    /// (for example,
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).
    /// You can use wildcards (* and ?). Greater than or less than comparison is not
    /// supported.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Filters the results by the specified Availability Zone.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The date and time, up to the current date, from which to stop retrieving the price
    /// history data, in UTC format (for example,
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
    pub end_time: std::option::Option<smithy_types::Instant>,
    /// <p>Filters the results by the specified instance types.</p>
    pub instance_types: std::option::Option<std::vec::Vec<crate::model::InstanceType>>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 1
    /// and 1000. The default value is 1000. To retrieve the remaining results, make another
    /// call with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Filters the results by the specified basic product descriptions.</p>
    pub product_descriptions: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The date and time, up to the past 90 days, from which to start retrieving the price
    /// history data, in UTC format (for example,
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
    pub start_time: std::option::Option<smithy_types::Instant>,
}
impl std::fmt::Debug for DescribeSpotPriceHistoryInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSpotPriceHistoryInput");
        formatter.field("filters", &self.filters);
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("end_time", &self.end_time);
        formatter.field("instance_types", &self.instance_types);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("product_descriptions", &self.product_descriptions);
        formatter.field("start_time", &self.start_time);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeSpotInstanceRequests.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSpotInstanceRequestsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone-group</code> - The Availability Zone group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>create-time</code> - The time stamp when the Spot Instance request was
    /// created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fault-code</code> - The fault code related to the request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fault-message</code> - The fault message related to the request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance that fulfilled the
    /// request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch-group</code> - The Spot Instance launch group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.block-device-mapping.delete-on-termination</code> - Indicates
    /// whether the EBS volume is deleted on instance termination.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.block-device-mapping.device-name</code> - The device name for the
    /// volume in the block device mapping (for example, <code>/dev/sdh</code> or
    /// <code>xvdh</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.block-device-mapping.snapshot-id</code> - The ID of the snapshot
    /// for the EBS volume.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.block-device-mapping.volume-size</code> - The size of the EBS
    /// volume, in GiB.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.block-device-mapping.volume-type</code> - The type of EBS volume:
    /// <code>gp2</code> for General Purpose SSD, <code>io1</code> or
    /// <code>io2</code> for Provisioned IOPS SSD, <code>st1</code> for Throughput
    /// Optimized HDD, <code>sc1</code>for Cold HDD, or <code>standard</code> for
    /// Magnetic.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.group-id</code> - The ID of the security group for the
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.group-name</code> - The name of the security group for the
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.image-id</code> - The ID of the AMI.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.instance-type</code> - The type of instance (for example,
    /// <code>m3.medium</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.kernel-id</code> - The kernel ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.key-name</code> - The name of the key pair the instance launched
    /// with.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.monitoring-enabled</code> - Whether detailed monitoring is
    /// enabled for the Spot Instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch.ramdisk-id</code> - The RAM disk ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launched-availability-zone</code> - The Availability Zone in which the
    /// request is launched.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.addresses.primary</code> - Indicates whether the IP
    /// address is the primary private IP address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.delete-on-termination</code> - Indicates whether the
    /// network interface is deleted when the instance is terminated.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.description</code> - A description of the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.device-index</code> - The index of the device for the
    /// network interface attachment on the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.group-id</code> - The ID of the security group
    /// associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.network-interface-id</code> - The ID of the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.private-ip-address</code> - The primary private IP
    /// address of the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.subnet-id</code> - The ID of the subnet for the
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-description</code> - The product description associated with the
    /// instance (<code>Linux/UNIX</code> | <code>Windows</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>spot-instance-request-id</code> - The Spot Instance request ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>spot-price</code> - The maximum hourly price for any Spot Instance
    /// launched to fulfill the request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the Spot Instance request (<code>open</code>
    /// | <code>active</code> | <code>closed</code> | <code>cancelled</code> |
    /// <code>failed</code>). Spot request status information can help you track
    /// your Amazon EC2 Spot Instance requests. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/spot-bid-status.html">Spot
    /// request status</a> in the <i>Amazon EC2 User Guide for Linux Instances</i>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status-code</code> - The short code describing the most recent
    /// evaluation of your Spot Instance request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status-message</code> - The message explaining the status of the Spot
    /// Instance request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>type</code> - The type of Spot Instance request (<code>one-time</code> |
    /// <code>persistent</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>valid-from</code> - The start date of the request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>valid-until</code> - The end date of the request.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more Spot Instance request IDs.</p>
    pub spot_instance_request_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token to request the next set of results. This value is <code>null</code> when
    /// there are no more results to return.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 5
    /// and 1000. To retrieve the remaining results, make another call with the returned
    /// <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeSpotInstanceRequestsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSpotInstanceRequestsInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("spot_instance_request_ids", &self.spot_instance_request_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeSpotFleetRequests.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSpotFleetRequestsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 1
    /// and 1000. The default value is 1000. To retrieve the remaining results, make another
    /// call with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The IDs of the Spot Fleet requests.</p>
    pub spot_fleet_request_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribeSpotFleetRequestsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSpotFleetRequestsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("spot_fleet_request_ids", &self.spot_fleet_request_ids);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeSpotFleetRequestHistory.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSpotFleetRequestHistoryInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The type of events to describe. By default, all events are described.</p>
    pub event_type: std::option::Option<crate::model::EventType>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 1
    /// and 1000. The default value is 1000. To retrieve the remaining results, make another
    /// call with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The ID of the Spot Fleet request.</p>
    pub spot_fleet_request_id: std::option::Option<std::string::String>,
    /// <p>The starting date and time for the events, in UTC format (for example,
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
    pub start_time: std::option::Option<smithy_types::Instant>,
}
impl std::fmt::Debug for DescribeSpotFleetRequestHistoryInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSpotFleetRequestHistoryInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("event_type", &self.event_type);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("spot_fleet_request_id", &self.spot_fleet_request_id);
        formatter.field("start_time", &self.start_time);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeSpotFleetInstances.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSpotFleetInstancesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 1
    /// and 1000. The default value is 1000. To retrieve the remaining results, make another
    /// call with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The ID of the Spot Fleet request.</p>
    pub spot_fleet_request_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeSpotFleetInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSpotFleetInstancesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("spot_fleet_request_id", &self.spot_fleet_request_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeSpotDatafeedSubscription.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSpotDatafeedSubscriptionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeSpotDatafeedSubscriptionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSpotDatafeedSubscriptionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSnapshotsInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>description</code> - A description of the snapshot.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>encrypted</code> - Indicates whether the snapshot is encrypted
    /// (<code>true</code> | <code>false</code>)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-alias</code> - The owner alias, from an Amazon-maintained list  
    /// (<code>amazon</code>).
    /// This is not the user-configured AWS account alias set using the IAM console.
    /// We recommend that you use the related parameter instead of this filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The AWS account ID of the owner. We recommend that
    /// you use the related parameter instead of this filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>progress</code> - The progress of the snapshot, as a percentage (for example,
    /// 80%).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>snapshot-id</code> - The snapshot ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>start-time</code> - The time stamp when the snapshot was initiated.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status</code> - The status of the snapshot (<code>pending</code> |
    /// <code>completed</code> | <code>error</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-id</code> - The ID of the volume the snapshot is for.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>volume-size</code> - The size of the volume, in GiB.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of snapshot results returned by <code>DescribeSnapshots</code> in
    /// paginated output. When this parameter is used, <code>DescribeSnapshots</code> only returns
    /// <code>MaxResults</code> results in a single page along with a <code>NextToken</code>
    /// response element. The remaining results of the initial request can be seen by sending another
    /// <code>DescribeSnapshots</code> request with the returned <code>NextToken</code> value. This
    /// value can be between 5 and 1,000; if <code>MaxResults</code> is given a value larger than 1,000,
    /// only 1,000 results are returned. If this parameter is not used, then
    /// <code>DescribeSnapshots</code> returns all results. You cannot specify this parameter and
    /// the snapshot IDs parameter in the same request.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The <code>NextToken</code> value returned from a previous paginated
    /// <code>DescribeSnapshots</code> request where <code>MaxResults</code> was used and the
    /// results exceeded the value of that parameter. Pagination continues from the end of the
    /// previous results that returned the <code>NextToken</code> value. This value is
    /// <code>null</code> when there are no more results to return.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Scopes the results to snapshots with the specified owners. You can specify a combination of
    /// AWS account IDs, <code>self</code>, and <code>amazon</code>.</p>
    pub owner_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The IDs of the AWS accounts that can create volumes from the snapshot.</p>
    pub restorable_by_user_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The snapshot IDs.</p>
    /// <p>Default: Describes the snapshots for which you have create volume permissions.</p>
    pub snapshot_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeSnapshotsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSnapshotsInput");
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("owner_ids", &self.owner_ids);
        formatter.field("restorable_by_user_ids", &self.restorable_by_user_ids);
        formatter.field("snapshot_ids", &self.snapshot_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSnapshotAttributeInput {
    /// <p>The snapshot attribute you would like to view.</p>
    pub attribute: std::option::Option<crate::model::SnapshotAttributeName>,
    /// <p>The ID of the EBS snapshot.</p>
    pub snapshot_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeSnapshotAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSnapshotAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("snapshot_id", &self.snapshot_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSecurityGroupsInput {
    /// <p>The filters. If using multiple filters for rules, the results include security groups for which any combination of rules - not necessarily a single rule - match all filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>description</code> - The description of the security group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.cidr</code> - An IPv4 CIDR block for an outbound
    /// security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.from-port</code> - For an outbound rule, the
    /// start of port range for the TCP and UDP protocols, or an ICMP type
    /// number.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.group-id</code> - The ID of a security group
    /// that has been referenced in an outbound security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.group-name</code> - The name of a security group
    /// that is referenced in an outbound security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.ipv6-cidr</code> - An IPv6 CIDR block for an
    /// outbound security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.prefix-list-id</code> - The ID of a prefix list to which a security group rule allows outbound access.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.protocol</code> - The IP protocol for an
    /// outbound security group rule (<code>tcp</code> | <code>udp</code> |
    /// <code>icmp</code>, a protocol number, or -1 for all protocols).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.to-port</code> - For an outbound rule, the end
    /// of port range for the TCP and UDP protocols, or an ICMP code.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>egress.ip-permission.user-id</code> - The ID of an AWS account that
    /// has been referenced in an outbound security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>group-id</code> - The ID of the security group. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>group-name</code> - The name of the security group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.cidr</code> - An IPv4 CIDR block for an inbound security
    /// group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.from-port</code> - For an inbound rule, the start of port
    /// range for the TCP and UDP protocols, or an ICMP type number.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.group-id</code> - The ID of a security group that has been
    /// referenced in an inbound security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.group-name</code> - The name of a security group that is
    /// referenced in an inbound security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.ipv6-cidr</code> - An IPv6 CIDR block for an inbound security
    /// group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.prefix-list-id</code> - The ID of a prefix list from which a security group rule allows inbound access.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.protocol</code> - The IP protocol for an inbound security
    /// group rule (<code>tcp</code> | <code>udp</code> | <code>icmp</code>, a
    /// protocol number, or -1 for all protocols).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.to-port</code> - For an inbound rule, the end of port range
    /// for the TCP and UDP protocols, or an ICMP code.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-permission.user-id</code> - The ID of an AWS account that has been
    /// referenced in an inbound security group rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The AWS account ID of the owner of the security group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC specified when the security group was created.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The IDs of the security groups. Required for security groups in a nondefault VPC.</p>
    /// <p>Default: Describes all your security groups.</p>
    pub group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>[EC2-Classic and default VPC only] The names of the security groups. You can specify either
    /// the security group name or the security group ID. For security groups in a nondefault VPC, use
    /// the <code>group-name</code> filter to describe security groups by name.</p>
    /// <p>Default: Describes all your security groups.</p>
    pub group_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another request with the returned <code>NextToken</code> value. This value
    /// can be between 5 and 1000. If this parameter is not specified, then all results are
    /// returned.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeSecurityGroupsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSecurityGroupsInput");
        formatter.field("filters", &self.filters);
        formatter.field("group_ids", &self.group_ids);
        formatter.field("group_names", &self.group_names);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeSecurityGroupReferencesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the security groups in your account.</p>
    pub group_id: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribeSecurityGroupReferencesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeSecurityGroupReferencesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_id", &self.group_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeScheduledInstances.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeScheduledInstancesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone (for example, <code>us-west-2a</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type (for example, <code>c4.large</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-platform</code> - The network platform (<code>EC2-Classic</code> or <code>EC2-VPC</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>platform</code> - The platform (<code>Linux/UNIX</code> or <code>Windows</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return in a single call.
    /// This value can be between 5 and 300. The default value is 100.
    /// To retrieve the remaining results, make another call with the returned
    /// <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The Scheduled Instance IDs.</p>
    pub scheduled_instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The time period for the first schedule to start.</p>
    pub slot_start_time_range: std::option::Option<crate::model::SlotStartTimeRangeRequest>,
}
impl std::fmt::Debug for DescribeScheduledInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeScheduledInstancesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("scheduled_instance_ids", &self.scheduled_instance_ids);
        formatter.field("slot_start_time_range", &self.slot_start_time_range);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeScheduledInstanceAvailability.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeScheduledInstanceAvailabilityInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone (for example, <code>us-west-2a</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type (for example, <code>c4.large</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-platform</code> - The network platform (<code>EC2-Classic</code> or <code>EC2-VPC</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>platform</code> - The platform (<code>Linux/UNIX</code> or <code>Windows</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The time period for the first schedule to start.</p>
    pub first_slot_start_time_range: std::option::Option<crate::model::SlotDateTimeRangeRequest>,
    /// <p>The maximum number of results to return in a single call.
    /// This value can be between 5 and 300. The default value is 300.
    /// To retrieve the remaining results, make another call with the returned
    /// <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The maximum available duration, in hours. This value must be greater than <code>MinSlotDurationInHours</code>
    /// and less than 1,720.</p>
    pub max_slot_duration_in_hours: std::option::Option<i32>,
    /// <p>The minimum available duration, in hours. The minimum required duration is 1,200 hours per year. For example, the minimum daily schedule is 4 hours, the minimum weekly schedule is 24 hours, and the minimum monthly schedule is 100 hours.</p>
    pub min_slot_duration_in_hours: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The schedule recurrence.</p>
    pub recurrence: std::option::Option<crate::model::ScheduledInstanceRecurrenceRequest>,
}
impl std::fmt::Debug for DescribeScheduledInstanceAvailabilityInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeScheduledInstanceAvailabilityInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field(
            "first_slot_start_time_range",
            &self.first_slot_start_time_range,
        );
        formatter.field("max_results", &self.max_results);
        formatter.field(
            "max_slot_duration_in_hours",
            &self.max_slot_duration_in_hours,
        );
        formatter.field(
            "min_slot_duration_in_hours",
            &self.min_slot_duration_in_hours,
        );
        formatter.field("next_token", &self.next_token);
        formatter.field("recurrence", &self.recurrence);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeRouteTablesInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>association.route-table-association-id</code> - The ID of an association
    /// ID for the route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.route-table-id</code> - The ID of the route table involved in
    /// the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.subnet-id</code> - The ID of the subnet involved in the
    /// association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.main</code> - Indicates whether the route table is the main
    /// route table for the VPC (<code>true</code> | <code>false</code>). Route tables
    /// that do not have an association ID are not returned in the response.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the AWS account that owns the route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route-table-id</code> - The ID of the route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.destination-cidr-block</code> - The IPv4 CIDR range specified in a
    /// route in the table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.destination-ipv6-cidr-block</code> - The IPv6 CIDR range specified in a route in the route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.destination-prefix-list-id</code> - The ID (prefix) of the AWS
    /// service specified in a route in the table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.egress-only-internet-gateway-id</code> - The ID of an
    /// egress-only Internet gateway specified in a route in the route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.gateway-id</code> - The ID of a gateway specified in a route in the table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.instance-id</code> - The ID of an instance specified in a route in the table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.nat-gateway-id</code> - The ID of a NAT gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.transit-gateway-id</code> - The ID of a transit gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.origin</code> - Describes how the route was created.
    /// <code>CreateRouteTable</code> indicates that the route was automatically
    /// created when the route table was created; <code>CreateRoute</code> indicates
    /// that the route was manually added to the route table;
    /// <code>EnableVgwRoutePropagation</code> indicates that the route was
    /// propagated by route propagation.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.state</code> - The state of a route in the route table
    /// (<code>active</code> | <code>blackhole</code>). The blackhole state
    /// indicates that the route's target isn't available (for example, the specified
    /// gateway isn't attached to the VPC, the specified NAT instance has been
    /// terminated, and so on).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>route.vpc-peering-connection-id</code> - The ID of a VPC peering
    /// connection specified in a route in the table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC for the route table.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more route table IDs.</p>
    /// <p>Default: Describes all your route tables.</p>
    pub route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeRouteTablesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeRouteTablesInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("route_table_ids", &self.route_table_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeReservedInstancesOfferings.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeReservedInstancesOfferingsInput {
    /// <p>The Availability Zone in which the Reserved Instance can be used.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone where the Reserved Instance can be
    /// used.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>duration</code> - The duration of the Reserved Instance (for example, one year or
    /// three years), in seconds (<code>31536000</code> | <code>94608000</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fixed-price</code> - The purchase price of the Reserved Instance (for example,
    /// 9800.0).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type that is covered by the
    /// reservation.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>marketplace</code> - Set to <code>true</code> to show only Reserved Instance
    /// Marketplace offerings. When this filter is not used, which is the default behavior, all
    /// offerings from both Amazon Web Services and the Reserved Instance Marketplace are listed.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-description</code> - The Reserved Instance product platform description.
    /// Instances that include <code>(Amazon VPC)</code> in the product platform description will
    /// only be displayed to EC2-Classic account holders and are for use with Amazon VPC.
    /// (<code>Linux/UNIX</code> | <code>Linux/UNIX (Amazon VPC)</code> | <code>SUSE
    /// Linux</code> | <code>SUSE Linux (Amazon VPC)</code> | <code>Red Hat Enterprise
    /// Linux</code> | <code>Red Hat Enterprise Linux (Amazon VPC)</code> | <code>Red Hat
    /// Enterprise Linux with HA (Amazon VPC)</code> | <code>Windows</code> | <code>Windows
    /// (Amazon VPC)</code> | <code>Windows with SQL Server Standard</code> | <code>Windows with
    /// SQL Server Standard (Amazon VPC)</code> | <code>Windows with SQL Server Web</code> |
    /// <code> Windows with SQL Server Web (Amazon VPC)</code> | <code>Windows with SQL Server
    /// Enterprise</code> | <code>Windows with SQL Server Enterprise (Amazon VPC)</code>) </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>reserved-instances-offering-id</code> - The Reserved Instances offering
    /// ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>scope</code> - The scope of the Reserved Instance (<code>Availability Zone</code> or
    /// <code>Region</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>usage-price</code> - The usage price of the Reserved Instance, per hour (for
    /// example, 0.84).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Include Reserved Instance Marketplace offerings in the response.</p>
    pub include_marketplace: std::option::Option<bool>,
    /// <p>The instance type that the reservation will cover (for example, <code>m1.small</code>). For more information, see
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance types</a> in the
    /// <i>Amazon EC2 User Guide</i>.</p>
    pub instance_type: std::option::Option<crate::model::InstanceType>,
    /// <p>The maximum duration (in seconds) to filter when searching for offerings.</p>
    /// <p>Default: 94608000 (3 years)</p>
    pub max_duration: std::option::Option<i64>,
    /// <p>The maximum number of instances to filter when searching for offerings.</p>
    /// <p>Default: 20</p>
    pub max_instance_count: std::option::Option<i32>,
    /// <p>The minimum duration (in seconds) to filter when searching for offerings.</p>
    /// <p>Default: 2592000 (1 month)</p>
    pub min_duration: std::option::Option<i64>,
    /// <p>The offering class of the Reserved Instance. Can be <code>standard</code> or <code>convertible</code>.</p>
    pub offering_class: std::option::Option<crate::model::OfferingClassType>,
    /// <p>The Reserved Instance product platform description. Instances that include <code>(Amazon
    /// VPC)</code> in the description are for use with Amazon VPC.</p>
    pub product_description: std::option::Option<crate::model::RiProductDescription>,
    /// <p>One or more Reserved Instances offering IDs.</p>
    pub reserved_instances_offering_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tenancy of the instances covered by the reservation. A Reserved Instance with a tenancy
    /// of <code>dedicated</code> is applied to instances that run in a VPC on single-tenant hardware
    /// (i.e., Dedicated Instances).</p>
    /// <p>
    /// <b>Important:</b> The <code>host</code> value cannot be used with this parameter. Use the <code>default</code> or <code>dedicated</code> values only.</p>
    /// <p>Default: <code>default</code>
    /// </p>
    pub instance_tenancy: std::option::Option<crate::model::Tenancy>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining
    /// results of the initial request can be seen by sending another request with the returned
    /// <code>NextToken</code> value. The maximum is 100.</p>
    /// <p>Default: 100</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The Reserved Instance offering type. If you are using tools that predate the 2011-11-01 API
    /// version, you only have access to the <code>Medium Utilization</code> Reserved Instance
    /// offering type. </p>
    pub offering_type: std::option::Option<crate::model::OfferingTypeValues>,
}
impl std::fmt::Debug for DescribeReservedInstancesOfferingsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeReservedInstancesOfferingsInput");
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("filters", &self.filters);
        formatter.field("include_marketplace", &self.include_marketplace);
        formatter.field("instance_type", &self.instance_type);
        formatter.field("max_duration", &self.max_duration);
        formatter.field("max_instance_count", &self.max_instance_count);
        formatter.field("min_duration", &self.min_duration);
        formatter.field("offering_class", &self.offering_class);
        formatter.field("product_description", &self.product_description);
        formatter.field(
            "reserved_instances_offering_ids",
            &self.reserved_instances_offering_ids,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_tenancy", &self.instance_tenancy);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("offering_type", &self.offering_type);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeReservedInstancesModifications.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeReservedInstancesModificationsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>client-token</code> - The idempotency token for the modification request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>create-date</code> - The time when the modification request was created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>effective-date</code> - The time when the modification becomes effective.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>modification-result.reserved-instances-id</code> - The ID for the Reserved Instances created as part of the modification request. This ID is only available when the status of the modification is <code>fulfilled</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>modification-result.target-configuration.availability-zone</code> - The Availability Zone for the new Reserved Instances.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>modification-result.target-configuration.instance-count </code> - The number of new Reserved Instances.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>modification-result.target-configuration.instance-type</code> - The instance type of the new Reserved Instances.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>modification-result.target-configuration.platform</code> - The network platform of the new Reserved Instances (<code>EC2-Classic</code> | <code>EC2-VPC</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>reserved-instances-id</code> - The ID of the Reserved Instances modified.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>reserved-instances-modification-id</code> - The ID of the modification request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status</code> - The status of the Reserved Instances modification request
    /// (<code>processing</code> | <code>fulfilled</code> | <code>failed</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status-message</code> - The reason for the status.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>update-date</code> - The time when the modification request was last updated.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>IDs for the submitted modification request.</p>
    pub reserved_instances_modification_ids:
        std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeReservedInstancesModificationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeReservedInstancesModificationsInput");
        formatter.field("filters", &self.filters);
        formatter.field(
            "reserved_instances_modification_ids",
            &self.reserved_instances_modification_ids,
        );
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeReservedInstancesListings.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeReservedInstancesListingsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>reserved-instances-id</code> - The ID of the Reserved Instances.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>reserved-instances-listing-id</code> - The ID of the Reserved Instances listing.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status</code> - The status of the Reserved Instance listing (<code>pending</code> | <code>active</code> |
    /// <code>cancelled</code> | <code>closed</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status-message</code> - The reason for the status.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>One or more Reserved Instance IDs.</p>
    pub reserved_instances_id: std::option::Option<std::string::String>,
    /// <p>One or more Reserved Instance listing IDs.</p>
    pub reserved_instances_listing_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeReservedInstancesListingsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeReservedInstancesListingsInput");
        formatter.field("filters", &self.filters);
        formatter.field("reserved_instances_id", &self.reserved_instances_id);
        formatter.field(
            "reserved_instances_listing_id",
            &self.reserved_instances_listing_id,
        );
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeReservedInstances.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeReservedInstancesInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone where the Reserved Instance can be used.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>duration</code> - The duration of the Reserved Instance (one year or three years), in seconds (<code>31536000</code> | <code>94608000</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>end</code> - The time when the Reserved Instance expires (for example, 2015-08-07T11:54:42.000Z).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fixed-price</code> - The purchase price of the Reserved Instance (for example, 9800.0).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type that is covered by the reservation.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>scope</code> - The scope of the Reserved Instance (<code>Region</code> or <code>Availability Zone</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-description</code> - The Reserved Instance product platform
    /// description. Instances that include <code>(Amazon VPC)</code> in the product platform
    /// description will only be displayed to EC2-Classic account holders and are for use with
    /// Amazon VPC (<code>Linux/UNIX</code> | <code>Linux/UNIX (Amazon VPC)</code> | <code>SUSE
    /// Linux</code> | <code>SUSE Linux (Amazon VPC)</code> | <code>Red Hat Enterprise
    /// Linux</code> | <code>Red Hat Enterprise Linux (Amazon VPC)</code> | <code>Red Hat
    /// Enterprise Linux with HA (Amazon VPC)</code> | <code>Windows</code> | <code>Windows
    /// (Amazon VPC)</code> | <code>Windows with SQL Server Standard</code> | <code>Windows with
    /// SQL Server Standard (Amazon VPC)</code> | <code>Windows with SQL Server Web</code> |
    /// <code>Windows with SQL Server Web (Amazon VPC)</code> | <code>Windows with SQL Server
    /// Enterprise</code> | <code>Windows with SQL Server Enterprise (Amazon
    /// VPC)</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>reserved-instances-id</code> - The ID of the Reserved Instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>start</code> - The time at which the Reserved Instance purchase request was placed (for example, 2014-08-07T11:54:42.000Z).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the Reserved Instance (<code>payment-pending</code> | <code>active</code> | <code>payment-failed</code> | <code>retired</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>usage-price</code> - The usage price of the Reserved Instance, per hour (for example, 0.84).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Describes whether the Reserved Instance is Standard or Convertible.</p>
    pub offering_class: std::option::Option<crate::model::OfferingClassType>,
    /// <p>One or more Reserved Instance IDs.</p>
    /// <p>Default: Describes all your Reserved Instances, or only those otherwise specified.</p>
    pub reserved_instances_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The Reserved Instance offering type. If you are using tools that predate the 2011-11-01 API
    /// version, you only have access to the <code>Medium Utilization</code> Reserved Instance
    /// offering type.</p>
    pub offering_type: std::option::Option<crate::model::OfferingTypeValues>,
}
impl std::fmt::Debug for DescribeReservedInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeReservedInstancesInput");
        formatter.field("filters", &self.filters);
        formatter.field("offering_class", &self.offering_class);
        formatter.field("reserved_instances_ids", &self.reserved_instances_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("offering_type", &self.offering_type);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeReplaceRootVolumeTasksInput {
    /// <p>The ID of the root volume replacement task to view.</p>
    pub replace_root_volume_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Filter to use:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance for which the root volume replacement task was created.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call. To retrieve the remaining results,
    /// make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeReplaceRootVolumeTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeReplaceRootVolumeTasksInput");
        formatter.field(
            "replace_root_volume_task_ids",
            &self.replace_root_volume_task_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeRegionsInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>endpoint</code> - The endpoint of the Region (for example, <code>ec2.us-east-1.amazonaws.com</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>opt-in-status</code> - The opt-in status of the Region (<code>opt-in-not-required</code> | <code>opted-in</code> |
    /// <code>not-opted-in</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>region-name</code> - The name of the Region (for example, <code>us-east-1</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The names of the Regions. You can specify any Regions, whether they are enabled and disabled for your account.</p>
    pub region_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Indicates whether to display all Regions, including Regions that are disabled for your account.</p>
    pub all_regions: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeRegionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeRegionsInput");
        formatter.field("filters", &self.filters);
        formatter.field("region_names", &self.region_names);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("all_regions", &self.all_regions);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribePublicIpv4PoolsInput {
    /// <p>The IDs of the address pools.</p>
    pub pool_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
}
impl std::fmt::Debug for DescribePublicIpv4PoolsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribePublicIpv4PoolsInput");
        formatter.field("pool_ids", &self.pool_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("filters", &self.filters);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribePrincipalIdFormatInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The type of resource: <code>bundle</code> |
    /// <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
    /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
    /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
    /// <code>import-task</code> | <code>instance</code> | <code>internet-gateway</code> |
    /// <code>network-acl</code> | <code>network-acl-association</code> |
    /// <code>network-interface</code> | <code>network-interface-attachment</code> |
    /// <code>prefix-list</code> | <code>reservation</code> | <code>route-table</code> |
    /// <code>route-table-association</code> | <code>security-group</code> |
    /// <code>snapshot</code> | <code>subnet</code> |
    /// <code>subnet-cidr-block-association</code> | <code>volume</code> | <code>vpc</code>
    /// | <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> |
    /// <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>
    /// </p>
    pub resources: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned NextToken value. </p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribePrincipalIdFormatInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribePrincipalIdFormatInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("resources", &self.resources);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribePrefixListsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>prefix-list-id</code>: The ID of a prefix list.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>prefix-list-name</code>: The name of a prefix list.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more prefix list IDs.</p>
    pub prefix_list_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribePrefixListsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribePrefixListsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("prefix_list_ids", &self.prefix_list_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribePlacementGroupsInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>group-name</code> - The name of the placement group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the placement group (<code>pending</code> |
    /// <code>available</code> | <code>deleting</code> |
    /// <code>deleted</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>strategy</code> - The strategy of the placement group
    /// (<code>cluster</code> | <code>spread</code> |
    /// <code>partition</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources that have a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The names of the placement groups.</p>
    /// <p>Default: Describes all your placement groups, or only those otherwise
    /// specified.</p>
    pub group_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The IDs of the placement groups.</p>
    pub group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribePlacementGroupsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribePlacementGroupsInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_names", &self.group_names);
        formatter.field("group_ids", &self.group_ids);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeNetworkInterfaces.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeNetworkInterfacesInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>addresses.private-ip-address</code> - The private IPv4 addresses
    /// associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>addresses.primary</code> - Whether the private IPv4 address is the primary
    /// IP address associated with the network interface. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>addresses.association.public-ip</code> - The association ID returned when
    /// the network interface was associated with the Elastic IP address
    /// (IPv4).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>addresses.association.owner-id</code> - The owner ID of the addresses associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.association-id</code> - The association ID returned when the
    /// network interface was associated with an IPv4 address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.allocation-id</code> - The allocation ID returned when you
    /// allocated the Elastic IP address (IPv4) for your network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.ip-owner-id</code> - The owner of the Elastic IP address
    /// (IPv4) associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.public-ip</code> - The address of the Elastic IP address
    /// (IPv4) bound to the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.public-dns-name</code> - The public DNS name for the network
    /// interface (IPv4).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.attachment-id</code> - The ID of the interface attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.attach-time</code> - The time that the network interface was attached to an instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.delete-on-termination</code> - Indicates whether the attachment is deleted when an instance is terminated.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.device-index</code> - The device index to which the network interface is attached.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.instance-id</code> - The ID of the instance to which the network interface is attached.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.instance-owner-id</code> - The owner ID of the instance to which the network interface is attached.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.status</code> - The status of the attachment (<code>attaching</code> | <code>attached</code> | <code>detaching</code> | <code>detached</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone of the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>description</code> - The description of the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>group-id</code> - The ID of a security group associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>group-name</code> - The name of a security group associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ipv6-addresses.ipv6-address</code> - An IPv6 address associated with
    /// the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>mac-address</code> - The MAC address of the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-id</code> - The ID of the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The account ID of the network interface owner.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>private-ip-address</code> - The private IPv4 address or addresses of the
    /// network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>private-dns-name</code> - The private DNS name of the network interface (IPv4).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>requester-id</code> - The alias or account ID of the principal or service that created the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>requester-managed</code> - Indicates whether the network interface is being managed by an Amazon Web Service
    /// (for example, Management Console, Auto Scaling, and so on).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>source-dest-check</code> - Indicates whether the network interface performs source/destination checking.
    /// A value of <code>true</code> means checking is enabled, and <code>false</code> means checking is disabled.
    /// The value must be <code>false</code> for the network interface to perform network address translation (NAT) in your VPC. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>status</code> - The status of the network interface. If the network interface is not attached to an instance, the status is <code>available</code>;
    /// if a network interface is attached to an instance the status is <code>in-use</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>subnet-id</code> - The ID of the subnet for the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC for the network interface.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more network interface IDs.</p>
    /// <p>Default: Describes all your network interfaces.</p>
    pub network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of items to return for this request. The request returns a token that you
    /// can specify in a subsequent call to get the next set of results. You cannot specify this
    /// parameter and the network interface IDs parameter in the same request.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeNetworkInterfacesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeNetworkInterfacesInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_interface_ids", &self.network_interface_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeNetworkInterfacePermissions.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeNetworkInterfacePermissionsInput {
    /// <p>One or more network interface permission IDs.</p>
    pub network_interface_permission_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>network-interface-permission.network-interface-permission-id</code> - The ID of the
    /// permission.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-permission.network-interface-id</code> - The ID of
    /// the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-permission.aws-account-id</code> - The account ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-permission.aws-service</code> - The Amazon Web Service.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-permission.permission</code> - The type of
    /// permission (<code>INSTANCE-ATTACH</code> |
    /// <code>EIP-ASSOCIATE</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining results,
    /// make another call with the returned <code>NextToken</code> value. If this parameter is not specified, up to 50 results are returned by default.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeNetworkInterfacePermissionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeNetworkInterfacePermissionsInput");
        formatter.field(
            "network_interface_permission_ids",
            &self.network_interface_permission_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeNetworkInterfaceAttribute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeNetworkInterfaceAttributeInput {
    /// <p>The attribute of the network interface. This parameter is required.</p>
    pub attribute: std::option::Option<crate::model::NetworkInterfaceAttribute>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeNetworkInterfaceAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeNetworkInterfaceAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeNetworkInsightsPathsInput {
    /// <p>The IDs of the paths.</p>
    pub network_insights_path_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters. The following are possible values:</p>
    /// <ul>
    /// <li>
    /// <p>Destination - The ID of the resource.</p>
    /// </li>
    /// <li>
    /// <p>DestinationPort - The destination port.</p>
    /// </li>
    /// <li>
    /// <p>Name - The path name.</p>
    /// </li>
    /// <li>
    /// <p>Protocol - The protocol.</p>
    /// </li>
    /// <li>
    /// <p>Source - The ID of the resource.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeNetworkInsightsPathsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeNetworkInsightsPathsInput");
        formatter.field("network_insights_path_ids", &self.network_insights_path_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeNetworkInsightsAnalysesInput {
    /// <p>The ID of the network insights analyses. You must specify either analysis IDs or a path ID.</p>
    pub network_insights_analysis_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of the path. You must specify either a path ID or analysis IDs.</p>
    pub network_insights_path_id: std::option::Option<std::string::String>,
    /// <p>The time when the network insights analyses started.</p>
    pub analysis_start_time: std::option::Option<smithy_types::Instant>,
    /// <p>The time when the network insights analyses ended.</p>
    pub analysis_end_time: std::option::Option<smithy_types::Instant>,
    /// <p>The filters. The following are possible values:</p>
    /// <ul>
    /// <li>
    /// <p>PathFound - A Boolean value that indicates whether a feasible path is found.</p>
    /// </li>
    /// <li>
    /// <p>Status - The status of the analysis (running | succeeded | failed).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeNetworkInsightsAnalysesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeNetworkInsightsAnalysesInput");
        formatter.field(
            "network_insights_analysis_ids",
            &self.network_insights_analysis_ids,
        );
        formatter.field("network_insights_path_id", &self.network_insights_path_id);
        formatter.field("analysis_start_time", &self.analysis_start_time);
        formatter.field("analysis_end_time", &self.analysis_end_time);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeNetworkAclsInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>association.association-id</code> - The ID of an association ID for the ACL.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.network-acl-id</code> - The ID of the network ACL involved in the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association.subnet-id</code> - The ID of the subnet involved in the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>default</code> - Indicates whether the ACL is the default network ACL for the VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.cidr</code> - The IPv4 CIDR range specified in the entry.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.icmp.code</code> - The ICMP code specified in the entry, if any.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.icmp.type</code> - The ICMP type specified in the entry, if any.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.ipv6-cidr</code> - The IPv6 CIDR range specified in the entry.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.port-range.from</code> - The start of the port range specified in the entry. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.port-range.to</code> - The end of the port range specified in the entry. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.protocol</code> - The protocol specified in the entry (<code>tcp</code> | <code>udp</code> | <code>icmp</code> or a protocol number).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.rule-action</code> - Allows or denies the matching traffic (<code>allow</code> | <code>deny</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>entry.rule-number</code> - The number of an entry (in other words, rule) in
    /// the set of ACL entries.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-acl-id</code> - The ID of the network ACL.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the AWS account that owns the network ACL.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC for the network ACL.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more network ACL IDs.</p>
    /// <p>Default: Describes all your network ACLs.</p>
    pub network_acl_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeNetworkAclsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeNetworkAclsInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_acl_ids", &self.network_acl_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeNatGatewaysInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>nat-gateway-id</code> - The ID of the NAT gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the NAT gateway (<code>pending</code> |
    /// <code>failed</code> | <code>available</code> | <code>deleting</code> | <code>deleted</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>subnet-id</code> - The ID of the subnet in which the NAT gateway resides.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC in which the NAT gateway resides.</p>
    /// </li>
    /// </ul>
    pub filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>One or more NAT gateway IDs.</p>
    pub nat_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeNatGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeNatGatewaysInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filter", &self.filter);
        formatter.field("max_results", &self.max_results);
        formatter.field("nat_gateway_ids", &self.nat_gateway_ids);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeMovingAddressesInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>moving-status</code> - The status of the Elastic IP address
    /// (<code>MovingToVpc</code> | <code>RestoringToClassic</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining
    /// results of the initial request can be seen by sending another request with the returned
    /// <code>NextToken</code> value. This value can be between 5 and 1000; if
    /// <code>MaxResults</code> is given a value outside of this range, an error is returned.</p>
    /// <p>Default: If no value is provided, the default is 1000.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more Elastic IP addresses.</p>
    pub public_ips: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribeMovingAddressesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeMovingAddressesInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("public_ips", &self.public_ips);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeManagedPrefixListsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the prefix list owner.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>prefix-list-id</code> - The ID of the prefix list.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>prefix-list-name</code> - The name of the prefix list.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more prefix list IDs.</p>
    pub prefix_list_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DescribeManagedPrefixListsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeManagedPrefixListsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("prefix_list_ids", &self.prefix_list_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLocalGatewayVirtualInterfacesInput {
    /// <p>The IDs of the virtual interfaces.</p>
    pub local_gateway_virtual_interface_ids:
        std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeLocalGatewayVirtualInterfacesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeLocalGatewayVirtualInterfacesInput");
        formatter.field(
            "local_gateway_virtual_interface_ids",
            &self.local_gateway_virtual_interface_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLocalGatewayVirtualInterfaceGroupsInput {
    /// <p>The IDs of the virtual interface groups.</p>
    pub local_gateway_virtual_interface_group_ids:
        std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>local-gateway-id</code> - The ID of a local gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-virtual-interface-id</code> - The ID of the virtual interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-virtual-interface-group-id</code> - The ID of the virtual interface group.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeLocalGatewayVirtualInterfaceGroupsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeLocalGatewayVirtualInterfaceGroupsInput");
        formatter.field(
            "local_gateway_virtual_interface_group_ids",
            &self.local_gateway_virtual_interface_group_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLocalGatewaysInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>local-gateway-id</code> - The ID of a local gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-id</code> - The ID of the local gateway route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-virtual-interface-group-association-id</code> - The ID of the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-virtual-interface-group-id</code> - The ID of the virtual interface group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>outpost-arn</code> - The Amazon Resource Name (ARN) of the Outpost.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the association.</p>
    /// </li>
    /// </ul>
    pub local_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeLocalGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeLocalGatewaysInput");
        formatter.field("local_gateway_ids", &self.local_gateway_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLocalGatewayRouteTableVpcAssociationsInput {
    /// <p>The IDs of the associations.</p>
    pub local_gateway_route_table_vpc_association_ids:
        std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>local-gateway-id</code> - The ID of a local gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-id</code> - The ID of the local gateway route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-vpc-association-id</code> - The ID of the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeLocalGatewayRouteTableVpcAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeLocalGatewayRouteTableVpcAssociationsInput");
        formatter.field(
            "local_gateway_route_table_vpc_association_ids",
            &self.local_gateway_route_table_vpc_association_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput {
    /// <p>The IDs of the associations.</p>
    pub local_gateway_route_table_virtual_interface_group_association_ids:
        std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>local-gateway-id</code> - The ID of a local gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-id</code> - The ID of the local gateway route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-virtual-interface-group-association-id</code> - The ID of the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-virtual-interface-group-id</code> - The ID of the virtual interface group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the association.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter =
            f.debug_struct("DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociationsInput");
        formatter.field(
            "local_gateway_route_table_virtual_interface_group_association_ids",
            &self.local_gateway_route_table_virtual_interface_group_association_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLocalGatewayRouteTablesInput {
    /// <p>The IDs of the local gateway route tables.</p>
    pub local_gateway_route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>local-gateway-id</code> - The ID of a local gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>local-gateway-route-table-id</code> - The ID of a local gateway route table.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>outpost-arn</code> - The Amazon Resource Name (ARN) of the Outpost.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the local gateway route table.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeLocalGatewayRouteTablesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeLocalGatewayRouteTablesInput");
        formatter.field(
            "local_gateway_route_table_ids",
            &self.local_gateway_route_table_ids,
        );
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLaunchTemplateVersionsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the launch template. To describe one or more versions of a specified launch
    /// template, you must specify either the launch template ID or the launch template name in
    /// the request. To describe all the latest or default launch template versions in your
    /// account, you must omit this parameter.</p>
    pub launch_template_id: std::option::Option<std::string::String>,
    /// <p>The name of the launch template. To describe one or more versions of a specified
    /// launch template, you must specify either the launch template ID or the launch template
    /// name in the request. To describe all the latest or default launch template versions in
    /// your account, you must omit this parameter.</p>
    pub launch_template_name: std::option::Option<std::string::String>,
    /// <p>One or more versions of the launch template. Valid values depend on whether you are describing a specified launch template (by ID or name) or all launch templates in your account.</p>
    /// <p>To describe one or more versions of a specified launch template, valid values are <code>$Latest</code>, <code>$Default</code>, and numbers.</p>
    /// <p>To describe all launch templates in your account that are defined as the latest
    /// version, the valid value is <code>$Latest</code>. To describe all launch templates in
    /// your account that are defined as the default version, the valid value is
    /// <code>$Default</code>. You can specify <code>$Latest</code> and
    /// <code>$Default</code> in the same call. You cannot specify numbers.</p>
    pub versions: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The version number after which to describe launch template versions.</p>
    pub min_version: std::option::Option<std::string::String>,
    /// <p>The version number up to which to describe launch template versions.</p>
    pub max_version: std::option::Option<std::string::String>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value. This value
    /// can be between 1 and 200.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>create-time</code> - The time the launch template version was created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-optimized</code> - A boolean that indicates whether the instance
    /// is optimized for Amazon EBS I/O.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>iam-instance-profile</code> - The ARN of the IAM instance
    /// profile.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>image-id</code> - The ID of the AMI.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>is-default-version</code> - A boolean that indicates whether the
    /// launch template version is the default version.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>kernel-id</code> - The kernel ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ram-disk-id</code> - The RAM disk ID.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
}
impl std::fmt::Debug for DescribeLaunchTemplateVersionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeLaunchTemplateVersionsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("launch_template_id", &self.launch_template_id);
        formatter.field("launch_template_name", &self.launch_template_name);
        formatter.field("versions", &self.versions);
        formatter.field("min_version", &self.min_version);
        formatter.field("max_version", &self.max_version);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("filters", &self.filters);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeLaunchTemplatesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more launch template IDs.</p>
    pub launch_template_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more launch template names.</p>
    pub launch_template_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>create-time</code> - The time the launch template was created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch-template-name</code> - The name of the launch template.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value. This value
    /// can be between 1 and 200.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeLaunchTemplatesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeLaunchTemplatesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("launch_template_ids", &self.launch_template_ids);
        formatter.field("launch_template_names", &self.launch_template_names);
        formatter.field("filters", &self.filters);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeKeyPairsInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>key-pair-id</code> - The ID of the key pair.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fingerprint</code> - The fingerprint of the key pair.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>key-name</code> - The name of the key pair.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The key pair names.</p>
    /// <p>Default: Describes all your key pairs.</p>
    pub key_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The IDs of the key pairs.</p>
    pub key_pair_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeKeyPairsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeKeyPairsInput");
        formatter.field("filters", &self.filters);
        formatter.field("key_names", &self.key_names);
        formatter.field("key_pair_ids", &self.key_pair_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeIpv6PoolsInput {
    /// <p>The IDs of the IPv6 address pools.</p>
    pub pool_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
}
impl std::fmt::Debug for DescribeIpv6PoolsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeIpv6PoolsInput");
        formatter.field("pool_ids", &self.pool_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInternetGatewaysInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>attachment.state</code> - The current state of the attachment between the gateway
    /// and the VPC (<code>available</code>). Present only if a VPC is attached.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>attachment.vpc-id</code> - The ID of an attached VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>internet-gateway-id</code> - The ID of the Internet gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the AWS account that owns the internet gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more internet gateway IDs.</p>
    /// <p>Default: Describes all your internet gateways.</p>
    pub internet_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeInternetGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInternetGatewaysInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("internet_gateway_ids", &self.internet_gateway_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInstanceTypesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is
    /// <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The instance types. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance types</a> in the <i>Amazon EC2 User Guide</i>.</p>
    pub instance_types: std::option::Option<std::vec::Vec<crate::model::InstanceType>>,
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>auto-recovery-supported</code> - Indicates whether auto recovery is supported
    /// (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>bare-metal</code> - Indicates whether it is a bare metal instance type
    /// (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>burstable-performance-supported</code> - Indicates whether it is a burstable
    /// performance instance type  (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>current-generation</code> - Indicates whether this instance type is the latest
    /// generation instance type of an instance family  (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.ebs-optimized-info.baseline-bandwidth-in-mbps</code> - The baseline
    /// bandwidth performance for an EBS-optimized instance type, in Mbps.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.ebs-optimized-info.baseline-iops</code> - The baseline input/output storage
    /// operations per second for an EBS-optimized instance type.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.ebs-optimized-info.baseline-throughput-in-mbps</code> - The baseline
    /// throughput performance for an EBS-optimized instance type, in MB/s.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.ebs-optimized-info.maximum-bandwidth-in-mbps</code> - The maximum bandwidth
    /// performance for an EBS-optimized instance type, in Mbps.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.ebs-optimized-info.maximum-iops</code> - The maximum input/output storage
    /// operations per second for an EBS-optimized instance type.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.ebs-optimized-info.maximum-throughput-in-mbps</code> - The maximum
    /// throughput performance for an EBS-optimized instance type, in MB/s.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.ebs-optimized-support</code> - Indicates whether the instance type is
    /// EBS-optimized (<code>supported</code> | <code>unsupported</code> |
    /// <code>default</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.encryption-support</code> - Indicates whether EBS encryption is supported
    /// (<code>supported</code> | <code>unsupported</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ebs-info.nvme-support</code> - Indicates whether non-volatile memory express (NVMe)
    /// is supported for EBS volumes (<code>required</code> | <code>supported</code> |
    /// <code>unsupported</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>free-tier-eligible</code> - Indicates whether the instance type is eligible to use
    /// in the free tier  (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>hibernation-supported</code> - Indicates whether On-Demand hibernation is supported
    /// (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>hypervisor</code> - The hypervisor (<code>nitro</code> | <code>xen</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-storage-info.disk.count</code> - The number of local disks.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-storage-info.disk.size-in-gb</code> - The storage size of each instance storage disk, in
    /// GB.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-storage-info.disk.type</code> - The storage technology for the local
    /// instance storage disks (<code>hdd</code> | <code>ssd</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-storage-info.nvme-support</code> - Indicates whether non-volatile memory
    /// express (NVMe) is supported for instance store (<code>required</code> | <code>supported</code>)
    /// | <code>unsupported</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-storage-info.total-size-in-gb</code> - The total amount of storage available from all local
    /// instance storage, in GB.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-storage-supported</code> - Indicates whether the instance type has local
    /// instance storage  (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type (for example <code>c5.2xlarge</code> or
    /// c5*).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>memory-info.size-in-mib</code> - The memory size.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.efa-info.maximum-efa-interfaces</code> - The maximum number of Elastic
    /// Fabric Adapters (EFAs) per instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.efa-supported</code> - Indicates whether the instance type supports
    /// Elastic Fabric Adapter (EFA)  (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.ena-support</code> - Indicates whether Elastic Network Adapter (ENA) is
    /// supported or required (<code>required</code> | <code>supported</code> |
    /// <code>unsupported</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.ipv4-addresses-per-interface</code> - The maximum number of private IPv4 addresses per
    /// network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.ipv6-addresses-per-interface</code> - The maximum number of private IPv6 addresses per
    /// network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.ipv6-supported</code> - Indicates whether the instance type supports
    /// IPv6  (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.maximum-network-interfaces</code> - The maximum number of network interfaces per instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-info.network-performance</code> - The network performance (for example, "25
    /// Gigabit").</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>processor-info.supported-architecture</code> - The CPU architecture
    /// (<code>arm64</code> | <code>i386</code> | <code>x86_64</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>processor-info.sustained-clock-speed-in-ghz</code> - The CPU clock speed, in GHz.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>supported-boot-mode</code> - The boot mode (<code>legacy-bios</code> |
    /// <code>uefi</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>supported-root-device-type</code> - The root device type (<code>ebs</code> |
    /// <code>instance-store</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>supported-usage-class</code> - The usage class (<code>on-demand</code> |
    /// <code>spot</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>supported-virtualization-type</code> - The virtualization type (<code>hvm</code> |
    /// <code>paravirtual</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vcpu-info.default-cores</code> - The default number of cores for the instance type.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vcpu-info.default-threads-per-core</code> - The default number of threads per core for the instance
    /// type.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vcpu-info.default-vcpus</code> - The default number of vCPUs for the instance type.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vcpu-info.valid-cores</code> - The number of cores that can be configured for the instance type.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vcpu-info.valid-threads-per-core</code> - The number of threads per core that can be configured for the instance type.
    /// For example, "1" or "1,2".</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results
    /// can be seen by sending another request with the next token value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeInstanceTypesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInstanceTypesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_types", &self.instance_types);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInstanceTypeOfferingsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is
    /// <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The location type.</p>
    pub location_type: std::option::Option<crate::model::LocationType>,
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>location</code> - This depends on the location type. For example, if the location type is
    /// <code>region</code> (default), the location is the Region code (for example, <code>us-east-2</code>.)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type. For example,
    /// <code>c5.2xlarge</code>.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results
    /// can be seen by sending another request with the next token value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeInstanceTypeOfferingsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInstanceTypeOfferingsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("location_type", &self.location_type);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInstanceStatusInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.code</code> - The code for the scheduled event
    /// (<code>instance-reboot</code> | <code>system-reboot</code> |
    /// <code>system-maintenance</code> | <code>instance-retirement</code> |
    /// <code>instance-stop</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.description</code> - A description of the event.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.instance-event-id</code> - The ID of the event whose date and time
    /// you are modifying.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.not-after</code> - The latest end time for the scheduled event
    /// (for example, <code>2014-09-15T17:15:20.000Z</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.not-before</code> - The earliest start time for the scheduled
    /// event (for example, <code>2014-09-15T17:15:20.000Z</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>event.not-before-deadline</code> - The deadline for starting the event
    /// (for example, <code>2014-09-15T17:15:20.000Z</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-state-code</code> - The code for the instance state, as a
    /// 16-bit unsigned integer. The high byte is used for internal purposes and should
    /// be ignored. The low byte is set based on the state represented. The valid values
    /// are 0 (pending), 16 (running), 32 (shutting-down), 48 (terminated), 64
    /// (stopping), and 80 (stopped).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-state-name</code> - The state of the instance
    /// (<code>pending</code> | <code>running</code> | <code>shutting-down</code> |
    /// <code>terminated</code> | <code>stopping</code> |
    /// <code>stopped</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-status.reachability</code> - Filters on instance status where
    /// the name is <code>reachability</code> (<code>passed</code> | <code>failed</code>
    /// | <code>initializing</code> | <code>insufficient-data</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-status.status</code> - The status of the instance
    /// (<code>ok</code> | <code>impaired</code> | <code>initializing</code> |
    /// <code>insufficient-data</code> | <code>not-applicable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>system-status.reachability</code> - Filters on system status where the
    /// name is <code>reachability</code> (<code>passed</code> | <code>failed</code> |
    /// <code>initializing</code> | <code>insufficient-data</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>system-status.status</code> - The system status of the instance
    /// (<code>ok</code> | <code>impaired</code> | <code>initializing</code> |
    /// <code>insufficient-data</code> | <code>not-applicable</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The instance IDs.</p>
    /// <p>Default: Describes all your instances.</p>
    /// <p>Constraints: Maximum 100 explicitly specified instance IDs.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value. This value
    /// can be between 5 and 1000. You cannot specify this parameter and the instance IDs
    /// parameter in the same call.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>When <code>true</code>, includes the health status for all instances. When
    /// <code>false</code>, includes the health status for running instances only.</p>
    /// <p>Default: <code>false</code>
    /// </p>
    pub include_all_instances: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeInstanceStatusInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInstanceStatusInput");
        formatter.field("filters", &self.filters);
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("include_all_instances", &self.include_all_instances);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInstancesInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>affinity</code> - The affinity setting for an instance running on a
    /// Dedicated Host (<code>default</code> | <code>host</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>architecture</code> - The instance architecture (<code>i386</code> |
    /// <code>x86_64</code> | <code>arm64</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.attach-time</code> - The attach time for an EBS
    /// volume mapped to the instance, for example,
    /// <code>2010-09-15T17:15:20.000Z</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.delete-on-termination</code> - A Boolean that
    /// indicates whether the EBS volume is deleted on instance termination.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.device-name</code> - The device name specified in the
    /// block device mapping (for example, <code>/dev/sdh</code> or
    /// <code>xvdh</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.status</code> - The status for the EBS volume
    /// (<code>attaching</code> | <code>attached</code> | <code>detaching</code> |
    /// <code>detached</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.volume-id</code> - The volume ID of the EBS
    /// volume.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>client-token</code> - The idempotency token you provided when you launched
    /// the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>dns-name</code> - The public DNS name of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>group-id</code> - The ID of the security group for the instance.
    /// EC2-Classic only.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>group-name</code> - The name of the security group for the instance.
    /// EC2-Classic only.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>hibernation-options.configured</code> - A Boolean that indicates whether
    /// the instance is enabled for hibernation. A value of <code>true</code> means that
    /// the instance is enabled for hibernation. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>host-id</code> - The ID of the Dedicated Host on which the instance is
    /// running, if applicable.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>hypervisor</code> - The hypervisor type of the instance
    /// (<code>ovm</code> | <code>xen</code>). The value <code>xen</code>
    /// is used for both Xen and Nitro hypervisors.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>iam-instance-profile.arn</code> - The instance profile associated with
    /// the instance. Specified as an ARN.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>image-id</code> - The ID of the image used to launch the
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-lifecycle</code> - Indicates whether this is a Spot Instance or
    /// a Scheduled Instance (<code>spot</code> | <code>scheduled</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-state-code</code> - The state of the instance, as a 16-bit
    /// unsigned integer. The high byte is used for internal purposes and should be
    /// ignored. The low byte is set based on the state represented. The valid values
    /// are: 0 (pending), 16 (running), 32 (shutting-down), 48 (terminated), 64
    /// (stopping), and 80 (stopped).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-state-name</code> - The state of the instance
    /// (<code>pending</code> | <code>running</code> | <code>shutting-down</code> |
    /// <code>terminated</code> | <code>stopping</code> |
    /// <code>stopped</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The type of instance (for example,
    /// <code>t2.micro</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance.group-id</code> - The ID of the security group for the
    /// instance. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance.group-name</code> - The name of the security group for the
    /// instance. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-address</code> - The public IPv4 address of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>kernel-id</code> - The kernel ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>key-name</code> - The name of the key pair used when the instance was
    /// launched.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch-index</code> - When launching multiple instances, this is the
    /// index for the instance in the launch group (for example, 0, 1, 2, and so on). </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>launch-time</code> - The time when the instance was launched.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>metadata-options.http-tokens</code> - The metadata request authorization
    /// state (<code>optional</code> | <code>required</code>)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>metadata-options.http-put-response-hop-limit</code> - The http metadata
    /// request put response hop limit (integer, possible values <code>1</code> to
    /// <code>64</code>)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>metadata-options.http-endpoint</code> - Enable or disable metadata
    /// access on http endpoint (<code>enabled</code> | <code>disabled</code>)</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>monitoring-state</code> - Indicates whether detailed monitoring is
    /// enabled (<code>disabled</code> | <code>enabled</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.addresses.private-ip-address</code> - The private IPv4
    /// address associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.addresses.primary</code> - Specifies whether the IPv4
    /// address of the network interface is the primary private IPv4 address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.addresses.association.public-ip</code> - The ID of the
    /// association of an Elastic IP address (IPv4) with a network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.addresses.association.ip-owner-id</code> - The owner
    /// ID of the private IPv4 address associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.association.public-ip</code> - The address of the
    /// Elastic IP address (IPv4) bound to the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.association.ip-owner-id</code> - The owner of the
    /// Elastic IP address (IPv4) associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.association.allocation-id</code> - The allocation ID
    /// returned when you allocated the Elastic IP address (IPv4) for your network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.association.association-id</code> - The association ID
    /// returned when the network interface was associated with an IPv4 address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.attachment.attachment-id</code> - The ID of the
    /// interface attachment.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.attachment.instance-id</code> - The ID of the instance
    /// to which the network interface is attached.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.attachment.instance-owner-id</code> - The owner ID of
    /// the instance to which the network interface is attached.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.attachment.device-index</code> - The device index to
    /// which the network interface is attached.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.attachment.status</code> - The status of the
    /// attachment (<code>attaching</code> | <code>attached</code> |
    /// <code>detaching</code> | <code>detached</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.attachment.attach-time</code> - The time that the
    /// network interface was attached to an instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.attachment.delete-on-termination</code> - Specifies
    /// whether the attachment is deleted when an instance is terminated.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.availability-zone</code> - The Availability Zone for
    /// the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.description</code> - The description of the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.group-id</code> - The ID of a security group
    /// associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.group-name</code> - The name of a security group
    /// associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.ipv6-addresses.ipv6-address</code> - The IPv6 address
    /// associated with the network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.mac-address</code> - The MAC address of the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.network-interface-id</code> - The ID of the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.owner-id</code> - The ID of the owner of the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.private-dns-name</code> - The private DNS name of the
    /// network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.requester-id</code> - The requester ID for the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.requester-managed</code> - Indicates whether the
    /// network interface is being managed by Amazon Web Services.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.status</code> - The status of the network interface
    /// (<code>available</code>) | <code>in-use</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.source-dest-check</code> - Whether the network
    /// interface performs source/destination checking. A value of <code>true</code>
    /// means that checking is enabled, and <code>false</code> means that checking is
    /// disabled. The value must be <code>false</code> for the network interface to
    /// perform network address translation (NAT) in your VPC.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.subnet-id</code> - The ID of the subnet for the
    /// network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface.vpc-id</code> - The ID of the VPC for the network
    /// interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>outpost-arn</code> - The Amazon Resource Name (ARN) of the Outpost.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The account ID of the instance owner.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>placement-group-name</code> - The name of the placement group for the
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>placement-partition-number</code> - The partition in which the instance is
    /// located.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>platform</code> - The platform. To list only Windows instances, use
    /// <code>windows</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>private-dns-name</code> - The private IPv4 DNS name of the
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>private-ip-address</code> - The private IPv4 address of the
    /// instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-code</code> - The product code associated with the AMI used to
    /// launch the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-code.type</code> - The type of product code (<code>devpay</code> |
    /// <code>marketplace</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ramdisk-id</code> - The RAM disk ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>reason</code> - The reason for the current state of the instance (for
    /// example, shows "User Initiated [date]" when you stop or terminate the instance).
    /// Similar to the state-reason-code filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>requester-id</code> - The ID of the entity that launched the instance on
    /// your behalf (for example, Management Console, Auto Scaling, and so
    /// on).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>reservation-id</code> - The ID of the instance's reservation. A
    /// reservation ID is created any time you launch an instance. A reservation ID has
    /// a one-to-one relationship with an instance launch request, but can be associated
    /// with more than one instance if you launch multiple instances using the same
    /// launch request. For example, if you launch one instance, you get one reservation
    /// ID. If you launch ten instances using the same launch request, you also get one
    /// reservation ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>root-device-name</code> - The device name of the root device volume (for
    /// example, <code>/dev/sda1</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>root-device-type</code> - The type of the root device volume
    /// (<code>ebs</code> | <code>instance-store</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>source-dest-check</code> - Indicates whether the instance performs
    /// source/destination checking. A value of <code>true</code> means that checking is
    /// enabled, and <code>false</code> means that checking is disabled. The value must
    /// be <code>false</code> for the instance to perform network address translation
    /// (NAT) in your VPC. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>spot-instance-request-id</code> - The ID of the Spot Instance
    /// request.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state-reason-code</code> - The reason code for the state change.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state-reason-message</code> - A message that describes the state
    /// change.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>subnet-id</code> - The ID of the subnet for the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources that have a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tenancy</code> - The tenancy of an instance (<code>dedicated</code> |
    /// <code>default</code> | <code>host</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>virtualization-type</code> - The virtualization type of the instance
    /// (<code>paravirtual</code> | <code>hvm</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC that the instance is running in.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The instance IDs.</p>
    /// <p>Default: Describes all your instances.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value. This value
    /// can be between 5 and 1000. You cannot specify this parameter and the instance IDs
    /// parameter in the same call.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInstancesInput");
        formatter.field("filters", &self.filters);
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInstanceEventNotificationAttributesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeInstanceEventNotificationAttributesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInstanceEventNotificationAttributesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInstanceCreditSpecificationsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The instance IDs.</p>
    /// <p>Default: Describes all your instances.</p>
    /// <p>Constraints: Maximum 1000 explicitly specified instance IDs.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value. This value
    /// can be between 5 and 1000. You cannot specify this parameter and the instance IDs
    /// parameter in the same call.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeInstanceCreditSpecificationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInstanceCreditSpecificationsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeInstanceAttributeInput {
    /// <p>The instance attribute.</p>
    /// <p>Note: The <code>enaSupport</code> attribute is not supported at this time.</p>
    pub attribute: std::option::Option<crate::model::InstanceAttributeName>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeInstanceAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeInstanceAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeImportSnapshotTasksInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The filters.</p>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>A list of import snapshot task IDs.</p>
    pub import_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining results, make another call
    /// with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>A token that indicates the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeImportSnapshotTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeImportSnapshotTasksInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("import_task_ids", &self.import_task_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeImportImageTasksInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Filter tasks using the <code>task-state</code> filter and one of the following values: <code>active</code>,
    /// <code>completed</code>, <code>deleting</code>, or <code>deleted</code>.</p>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The IDs of the import image tasks.</p>
    pub import_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return in a single call.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>A token that indicates the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeImportImageTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeImportImageTasksInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("import_task_ids", &self.import_task_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeImagesInput {
    /// <p>Scopes the images by users with explicit launch permissions.
    /// Specify an AWS account ID, <code>self</code> (the sender of the request),
    /// or <code>all</code> (public AMIs).</p>
    pub executable_users: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>architecture</code> - The image architecture (<code>i386</code> |
    /// <code>x86_64</code> | <code>arm64</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.delete-on-termination</code> - A Boolean value that indicates
    /// whether the Amazon EBS volume is deleted on instance termination.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.device-name</code> - The device name specified in the block device mapping (for
    /// example, <code>/dev/sdh</code> or <code>xvdh</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.snapshot-id</code> - The ID of the snapshot used for the EBS
    /// volume.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.volume-size</code> - The volume size of the EBS volume, in GiB.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.volume-type</code> - The volume type of the EBS volume
    /// (<code>gp2</code> | <code>io1</code> | <code>io2</code> | <code>st1 </code>| <code>sc1</code> |
    /// <code>standard</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>block-device-mapping.encrypted</code> - A Boolean that indicates whether the EBS volume is encrypted.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>description</code> - The description of the image (provided during image
    /// creation).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ena-support</code> - A Boolean that indicates whether enhanced networking
    /// with ENA is enabled.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>hypervisor</code> - The hypervisor type (<code>ovm</code> |
    /// <code>xen</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>image-id</code> - The ID of the image.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>image-type</code> - The image type (<code>machine</code> | <code>kernel</code> |
    /// <code>ramdisk</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>is-public</code> - A Boolean that indicates whether the image is public.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>kernel-id</code> - The kernel ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>manifest-location</code> - The location of the image manifest.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>name</code> - The name of the AMI (provided during image creation).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-alias</code> - The owner alias (<code>amazon</code> | <code>aws-marketplace</code>).
    /// The valid aliases are defined in an Amazon-maintained list. This is not the AWS account alias that can be
    /// set using the IAM console. We recommend that you use the <b>Owner</b>
    /// request parameter instead of this filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The AWS account ID of the owner. We recommend that you use the
    /// <b>Owner</b> request parameter instead of this filter.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>platform</code> - The platform. To only list Windows-based AMIs, use
    /// <code>windows</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-code</code> - The product code.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-code.type</code> - The type of the product code (<code>devpay</code> |
    /// <code>marketplace</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ramdisk-id</code> - The RAM disk ID.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>root-device-name</code> - The device name of the root device volume (for example, <code>/dev/sda1</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>root-device-type</code> - The type of the root device volume (<code>ebs</code> |
    /// <code>instance-store</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the image (<code>available</code> | <code>pending</code>
    /// | <code>failed</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state-reason-code</code> - The reason code for the state change.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state-reason-message</code> - The message for the state change.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>sriov-net-support</code> - A value of <code>simple</code> indicates
    /// that enhanced networking with the Intel 82599 VF interface is enabled.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>virtualization-type</code> - The virtualization type (<code>paravirtual</code> |
    /// <code>hvm</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The image IDs.</p>
    /// <p>Default: Describes all images available to you.</p>
    pub image_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Scopes the results to images with the specified owners. You can specify a combination of  
    /// AWS account IDs, <code>self</code>, <code>amazon</code>, and <code>aws-marketplace</code>.
    /// If you omit this parameter, the results include all images for which you have launch permissions,
    /// regardless of ownership.</p>
    pub owners: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>If <code>true</code>, all deprecated AMIs are included in the response. If
    /// <code>false</code>, no deprecated AMIs are included in the response. If no value is
    /// specified, the default value is <code>false</code>.</p>
    /// <note>
    /// <p>If you are the AMI owner, all deprecated AMIs appear in the response regardless of the value (<code>true</code> or <code>false</code>) that you set for this parameter.</p>
    /// </note>
    pub include_deprecated: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeImagesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeImagesInput");
        formatter.field("executable_users", &self.executable_users);
        formatter.field("filters", &self.filters);
        formatter.field("image_ids", &self.image_ids);
        formatter.field("owners", &self.owners);
        formatter.field("include_deprecated", &self.include_deprecated);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeImageAttribute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeImageAttributeInput {
    /// <p>The AMI attribute.</p>
    /// <p>
    /// <b>Note</b>: The <code>blockDeviceMapping</code> attribute is deprecated.
    /// Using this attribute returns the <code>Client.AuthFailure</code> error. To get information about
    /// the block device mappings for an AMI, use the <a>DescribeImages</a> action.</p>
    pub attribute: std::option::Option<crate::model::ImageAttributeName>,
    /// <p>The ID of the AMI.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeImageAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeImageAttributeInput");
        formatter.field("attribute", &self.attribute);
        formatter.field("image_id", &self.image_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeIdFormatInput {
    /// <p>The type of resource: <code>bundle</code> |
    /// <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
    /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
    /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
    /// <code>import-task</code> | <code>instance</code> | <code>internet-gateway</code> |
    /// <code>network-acl</code> | <code>network-acl-association</code> |
    /// <code>network-interface</code> | <code>network-interface-attachment</code> |
    /// <code>prefix-list</code> | <code>reservation</code> | <code>route-table</code> |
    /// <code>route-table-association</code> | <code>security-group</code> |
    /// <code>snapshot</code> | <code>subnet</code> |
    /// <code>subnet-cidr-block-association</code> | <code>volume</code> | <code>vpc</code>
    /// | <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> |
    /// <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>
    /// </p>
    pub resource: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeIdFormatInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeIdFormatInput");
        formatter.field("resource", &self.resource);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeIdentityIdFormatInput {
    /// <p>The ARN of the principal, which can be an IAM role, IAM user, or the root user.</p>
    pub principal_arn: std::option::Option<std::string::String>,
    /// <p>The type of resource: <code>bundle</code> |
    /// <code>conversion-task</code> | <code>customer-gateway</code> | <code>dhcp-options</code> |
    /// <code>elastic-ip-allocation</code> | <code>elastic-ip-association</code> |
    /// <code>export-task</code> | <code>flow-log</code> | <code>image</code> |
    /// <code>import-task</code> | <code>instance</code> | <code>internet-gateway</code> |
    /// <code>network-acl</code> | <code>network-acl-association</code> |
    /// <code>network-interface</code> | <code>network-interface-attachment</code> |
    /// <code>prefix-list</code> | <code>reservation</code> | <code>route-table</code> |
    /// <code>route-table-association</code> | <code>security-group</code> |
    /// <code>snapshot</code> | <code>subnet</code> |
    /// <code>subnet-cidr-block-association</code> | <code>volume</code> | <code>vpc</code>
    /// | <code>vpc-cidr-block-association</code> | <code>vpc-endpoint</code> |
    /// <code>vpc-peering-connection</code> | <code>vpn-connection</code> | <code>vpn-gateway</code>
    /// </p>
    pub resource: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeIdentityIdFormatInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeIdentityIdFormatInput");
        formatter.field("principal_arn", &self.principal_arn);
        formatter.field("resource", &self.resource);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeIamInstanceProfileAssociationsInput {
    /// <p>The IAM instance profile associations.</p>
    pub association_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the association (<code>associating</code> |
    /// <code>associated</code> | <code>disassociating</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeIamInstanceProfileAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeIamInstanceProfileAssociationsInput");
        formatter.field("association_ids", &self.association_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeHostsInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>auto-placement</code> - Whether auto-placement is enabled or disabled
    /// (<code>on</code> | <code>off</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone of the
    /// host.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>client-token</code> - The idempotency token that you provided when you
    /// allocated the host.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>host-reservation-id</code> - The ID of the reservation assigned to
    /// this host.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type size that the Dedicated Host
    /// is configured to support.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The allocation state of the Dedicated Host
    /// (<code>available</code> | <code>under-assessment</code> |
    /// <code>permanent-failure</code> | <code>released</code> |
    /// <code>released-permanent-failure</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The IDs of the Dedicated Hosts. The IDs are used for targeted instance
    /// launches.</p>
    pub host_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
    /// <p>You cannot specify this parameter and the host IDs parameter in the same request.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to use to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeHostsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeHostsInput");
        formatter.field("filter", &self.filter);
        formatter.field("host_ids", &self.host_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeHostReservationsInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-family</code> - The instance family (for example,
    /// <code>m4</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>payment-option</code> - The payment option (<code>NoUpfront</code> |
    /// <code>PartialUpfront</code> | <code>AllUpfront</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the reservation (<code>payment-pending</code>
    /// | <code>payment-failed</code> | <code>active</code> |
    /// <code>retired</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The host reservation IDs.</p>
    pub host_reservation_id_set: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to use to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeHostReservationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeHostReservationsInput");
        formatter.field("filter", &self.filter);
        formatter.field("host_reservation_id_set", &self.host_reservation_id_set);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeHostReservationOfferingsInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-family</code> - The instance family of the offering (for example,
    /// <code>m4</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>payment-option</code> - The payment option (<code>NoUpfront</code> |
    /// <code>PartialUpfront</code> | <code>AllUpfront</code>).</p>
    /// </li>
    /// </ul>
    pub filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>This is the maximum duration of the reservation to purchase, specified in seconds.
    /// Reservations are available in one-year and three-year terms. The number of seconds
    /// specified must be the number of seconds in a year (365x24x60x60) times one of the
    /// supported durations (1 or 3). For example, specify 94608000 for three years.</p>
    pub max_duration: std::option::Option<i32>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>This is the minimum duration of the reservation you'd like to purchase, specified
    /// in seconds. Reservations are available in one-year and three-year terms. The number of
    /// seconds specified must be the number of seconds in a year (365x24x60x60) times one of
    /// the supported durations (1 or 3). For example, specify 31536000 for one year.</p>
    pub min_duration: std::option::Option<i32>,
    /// <p>The token to use to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The ID of the reservation offering.</p>
    pub offering_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeHostReservationOfferingsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeHostReservationOfferingsInput");
        formatter.field("filter", &self.filter);
        formatter.field("max_duration", &self.max_duration);
        formatter.field("max_results", &self.max_results);
        formatter.field("min_duration", &self.min_duration);
        formatter.field("next_token", &self.next_token);
        formatter.field("offering_id", &self.offering_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeFpgaImagesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The AFI IDs.</p>
    pub fpga_image_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Filters the AFI by owner. Specify an AWS account ID, <code>self</code> (owner is the sender of the request), or an AWS owner alias (valid values are <code>amazon</code> | <code>aws-marketplace</code>).</p>
    pub owners: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>create-time</code> - The creation time of the AFI.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fpga-image-id</code> - The FPGA image identifier (AFI ID).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fpga-image-global-id</code> - The global FPGA image identifier (AGFI ID).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>name</code> - The name of the AFI.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The AWS account ID of the AFI owner.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>product-code</code> - The product code.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>shell-version</code> - The version of the AWS Shell that was used to create the bitstream.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the AFI (<code>pending</code> | <code>failed</code> | <code>available</code> | <code>unavailable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>update-time</code> - The time of the most recent update.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return in a single call.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeFpgaImagesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeFpgaImagesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("fpga_image_ids", &self.fpga_image_ids);
        formatter.field("owners", &self.owners);
        formatter.field("filters", &self.filters);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeFpgaImageAttributeInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the AFI.</p>
    pub fpga_image_id: std::option::Option<std::string::String>,
    /// <p>The AFI attribute.</p>
    pub attribute: std::option::Option<crate::model::FpgaImageAttributeName>,
}
impl std::fmt::Debug for DescribeFpgaImageAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeFpgaImageAttributeInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("fpga_image_id", &self.fpga_image_id);
        formatter.field("attribute", &self.attribute);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeFlowLogsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>deliver-log-status</code> - The status of the logs delivery (<code>SUCCESS</code> |
    /// <code>FAILED</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>log-destination-type</code> - The type of destination to which the flow
    /// log publishes data. Possible destination types include
    /// <code>cloud-watch-logs</code> and <code>s3</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>flow-log-id</code> - The ID of the flow log.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>log-group-name</code> - The name of the log group.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>resource-id</code> - The ID of the VPC, subnet, or network interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>traffic-type</code> - The type of traffic (<code>ACCEPT</code> |
    /// <code>REJECT</code> | <code>ALL</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filter: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>One or more flow log IDs.</p>
    /// <p>Constraint: Maximum of 1000 flow log IDs.</p>
    pub flow_log_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeFlowLogsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeFlowLogsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filter", &self.filter);
        formatter.field("flow_log_ids", &self.flow_log_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeFleetsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 1 and
    /// 1000. The default value is 1000. To retrieve the remaining results, make another call with
    /// the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The ID of the EC2 Fleets.</p>
    pub fleet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>activity-status</code> - The progress of the EC2 Fleet ( <code>error</code> |
    /// <code>pending-fulfillment</code> | <code>pending-termination</code> |
    /// <code>fulfilled</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>excess-capacity-termination-policy</code> - Indicates whether to terminate
    /// running instances if the target capacity is decreased below the current EC2 Fleet size
    /// (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>fleet-state</code> - The state of the EC2 Fleet (<code>submitted</code> |
    /// <code>active</code> | <code>deleted</code> | <code>failed</code> |
    /// <code>deleted-running</code> | <code>deleted-terminating</code> |
    /// <code>modifying</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>replace-unhealthy-instances</code> - Indicates whether EC2 Fleet should replace
    /// unhealthy instances (<code>true</code> | <code>false</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>type</code> - The type of request (<code>instant</code> |
    /// <code>request</code> | <code>maintain</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
}
impl std::fmt::Debug for DescribeFleetsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeFleetsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("fleet_ids", &self.fleet_ids);
        formatter.field("filters", &self.filters);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeFleetInstancesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 1 and
    /// 1000. The default value is 1000. To retrieve the remaining results, make another call with
    /// the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The ID of the EC2 Fleet.</p>
    pub fleet_id: std::option::Option<std::string::String>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The instance type.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
}
impl std::fmt::Debug for DescribeFleetInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeFleetInstancesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("fleet_id", &self.fleet_id);
        formatter.field("filters", &self.filters);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeFleetHistoryInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The type of events to describe. By default, all events are described.</p>
    pub event_type: std::option::Option<crate::model::FleetEventType>,
    /// <p>The maximum number of results to return in a single call. Specify a value between 1 and
    /// 1000. The default value is 1000. To retrieve the remaining results, make another call with
    /// the returned <code>NextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next set of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The ID of the EC2 Fleet.</p>
    pub fleet_id: std::option::Option<std::string::String>,
    /// <p>The start date and time for the events, in UTC format (for example,
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).</p>
    pub start_time: std::option::Option<smithy_types::Instant>,
}
impl std::fmt::Debug for DescribeFleetHistoryInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeFleetHistoryInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("event_type", &self.event_type);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("fleet_id", &self.fleet_id);
        formatter.field("start_time", &self.start_time);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeFastSnapshotRestoresInput {
    /// <p>The filters. The possible values are:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code>: The Availability Zone of the snapshot.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code>: The ID of the AWS account that enabled fast snapshot restore on the snapshot.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>snapshot-id</code>: The ID of the snapshot.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code>: The state of fast snapshot restores for the snapshot
    /// (<code>enabling</code> |
    /// <code>optimizing</code> |
    /// <code>enabled</code> |
    /// <code>disabling</code> |
    /// <code>disabled</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeFastSnapshotRestoresInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeFastSnapshotRestoresInput");
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeExportTasksInput {
    /// <p>The export task IDs.</p>
    pub export_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>the filters for the export tasks.</p>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
}
impl std::fmt::Debug for DescribeExportTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeExportTasksInput");
        formatter.field("export_task_ids", &self.export_task_ids);
        formatter.field("filters", &self.filters);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeExportImageTasksInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Filter tasks using the <code>task-state</code> filter and one of the following values: <code>active</code>,
    /// <code>completed</code>, <code>deleting</code>, or <code>deleted</code>.</p>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The IDs of the export image tasks.</p>
    pub export_image_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return in a single call.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>A token that indicates the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeExportImageTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeExportImageTasksInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("export_image_task_ids", &self.export_image_task_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeElasticGpusInput {
    /// <p>The Elastic Graphics accelerator IDs.</p>
    pub elastic_gpu_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone in which the
    /// Elastic Graphics accelerator resides.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>elastic-gpu-health</code> - The status of the Elastic Graphics accelerator
    /// (<code>OK</code> | <code>IMPAIRED</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>elastic-gpu-state</code> - The state of the Elastic Graphics accelerator
    /// (<code>ATTACHED</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>elastic-gpu-type</code> - The type of Elastic Graphics accelerator; for example,
    /// <code>eg1.medium</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance to which the
    /// Elastic Graphics accelerator is associated.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return in a single call. To retrieve the remaining
    /// results, make another call with the returned <code>NextToken</code> value. This value
    /// can be between 5 and 1000.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to request the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeElasticGpusInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeElasticGpusInput");
        formatter.field("elastic_gpu_ids", &self.elastic_gpu_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeEgressOnlyInternetGatewaysInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more egress-only internet gateway IDs.</p>
    pub egress_only_internet_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
}
impl std::fmt::Debug for DescribeEgressOnlyInternetGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeEgressOnlyInternetGatewaysInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "egress_only_internet_gateway_ids",
            &self.egress_only_internet_gateway_ids,
        );
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("filters", &self.filters);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeDhcpOptionsInput {
    /// <p>The IDs of one or more DHCP options sets.</p>
    /// <p>Default: Describes all your DHCP options sets.</p>
    pub dhcp_options_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>dhcp-options-id</code> - The ID of a DHCP options set.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>key</code> - The key for one of the options (for example, <code>domain-name</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>value</code> - The value for one of the options.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the AWS account that owns the DHCP options set.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeDhcpOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeDhcpOptionsInput");
        formatter.field("dhcp_options_ids", &self.dhcp_options_ids);
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DescribeCustomerGateways.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeCustomerGatewaysInput {
    /// <p>One or more customer gateway IDs.</p>
    /// <p>Default: Describes all your customer gateways.</p>
    pub customer_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>bgp-asn</code> - The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>customer-gateway-id</code> - The ID of the customer gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>ip-address</code> - The IP address of the customer gateway's Internet-routable external interface.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the customer gateway (<code>pending</code> | <code>available</code> | <code>deleting</code> | <code>deleted</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>type</code> - The type of customer gateway. Currently, the only supported type is <code>ipsec.1</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeCustomerGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeCustomerGatewaysInput");
        formatter.field("customer_gateway_ids", &self.customer_gateway_ids);
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeConversionTasksInput {
    /// <p>The conversion task IDs.</p>
    pub conversion_task_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeConversionTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeConversionTasksInput");
        formatter.field("conversion_task_ids", &self.conversion_task_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeCoipPoolsInput {
    /// <p>The IDs of the address pools.</p>
    pub pool_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters. The following are the possible values:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>coip-pool.pool-id</code>
    /// </p>
    /// </li>
    /// </ul>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>coip-pool.local-gateway-route-table-id</code>
    /// </p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeCoipPoolsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeCoipPoolsInput");
        formatter.field("pool_ids", &self.pool_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeClientVpnTargetNetworksInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The IDs of the target network associations.</p>
    pub association_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>association-id</code> - The ID of the association.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>target-network-id</code> - The ID of the subnet specified as the target network.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC in which the target network is located.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeClientVpnTargetNetworksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeClientVpnTargetNetworksInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("association_ids", &self.association_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeClientVpnRoutesInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>destination-cidr</code> - The CIDR of the route destination.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>origin</code> - How the route was associated with the Client VPN endpoint (<code>associate</code> | <code>add-route</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>target-subnet</code> - The ID of the subnet through which traffic is routed.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeClientVpnRoutesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeClientVpnRoutesInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeClientVpnEndpointsInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>endpoint-id</code> - The ID of the Client VPN endpoint.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>transport-protocol</code> - The transport protocol (<code>tcp</code> |
    /// <code>udp</code>).</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeClientVpnEndpointsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeClientVpnEndpointsInput");
        formatter.field("client_vpn_endpoint_ids", &self.client_vpn_endpoint_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeClientVpnConnectionsInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>connection-id</code> - The ID of the connection.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>username</code> - For Active Directory client authentication, the user name of the
    /// client who established the client connection.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeClientVpnConnectionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeClientVpnConnectionsInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("filters", &self.filters);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeClientVpnAuthorizationRulesInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The token to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>description</code> - The description of the authorization rule.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>destination-cidr</code> - The CIDR of the network to which the authorization rule
    /// applies.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>group-id</code> - The ID of the Active Directory group to which the authorization rule grants access.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the nextToken value.</p>
    pub max_results: std::option::Option<i32>,
}
impl std::fmt::Debug for DescribeClientVpnAuthorizationRulesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeClientVpnAuthorizationRulesInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("next_token", &self.next_token);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeClassicLinkInstancesInput {
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>group-id</code> - The ID of a VPC security group that's associated with the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC to which the instance is
    /// linked.</p>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC that the instance is linked to.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more instance IDs. Must be instances linked to a VPC through ClassicLink.</p>
    pub instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    /// <p>Constraint: If the value is greater than 1000, we return only 1000 items.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeClassicLinkInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeClassicLinkInstancesInput");
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_ids", &self.instance_ids);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeCarrierGatewaysInput {
    /// <p>One or more carrier gateway IDs.</p>
    pub carrier_gateway_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>carrier-gateway-id</code> - The ID of the carrier gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the carrier gateway (<code>pending</code> |
    /// <code>failed</code> | <code>available</code> | <code>deleting</code> | <code>deleted</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The AWS account ID of the owner of the carrier gateway.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>vpc-id</code> - The ID of the VPC associated with the carrier gateway.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeCarrierGatewaysInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeCarrierGatewaysInput");
        formatter.field("carrier_gateway_ids", &self.carrier_gateway_ids);
        formatter.field("filters", &self.filters);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeCapacityReservationsInput {
    /// <p>The ID of the Capacity Reservation.</p>
    pub capacity_reservation_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The token to use to retrieve the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return for the request in a single page. The remaining results can be seen by sending another request with the returned <code>nextToken</code> value. This value can be between 5 and 500. If <code>maxResults</code> is given a larger value than 500, you receive an error.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>One or more filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>instance-type</code> - The type of instance for which the Capacity Reservation reserves capacity.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>owner-id</code> - The ID of the account that owns the Capacity Reservation.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone-id</code> - The Availability Zone ID of the Capacity Reservation.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-platform</code> - The type of operating system for which the Capacity Reservation reserves capacity.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>availability-zone</code> - The Availability Zone ID of the Capacity Reservation.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tenancy</code> - Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of the
    /// following tenancy settings:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>default</code> - The Capacity Reservation is created on hardware that is shared with other accounts.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>dedicated</code> - The Capacity Reservation is created on single-tenant hardware that is dedicated to a single account.</p>
    /// </li>
    /// </ul>
    /// </li>
    /// <li>
    /// <p>
    /// <code>outpost-arn</code> - The Amazon Resource Name (ARN) of the Outpost on which the Capacity Reservation was created.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The current state of the Capacity Reservation. A Capacity Reservation can be in one of the following states:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>active</code>- The Capacity Reservation is active and the capacity is available for your use.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>expired</code> - The Capacity Reservation expired automatically at the date and time specified in your request.
    /// The reserved capacity is no longer available for your use.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>cancelled</code> - The Capacity Reservation was cancelled. The reserved capacity is no longer available for your use.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>pending</code> - The Capacity Reservation request was successful but the capacity provisioning is still pending.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>failed</code> - The Capacity Reservation request has failed. A request might fail due to invalid request parameters,
    /// capacity constraints, or instance limit constraints. Failed requests are retained for 60 minutes.</p>
    /// </li>
    /// </ul>
    /// </li>
    /// <li>
    /// <p>
    /// <code>start-date</code> - The date and time at which the Capacity Reservation was started.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>end-date</code> - The date and time at which the Capacity Reservation expires. When a Capacity Reservation expires, the reserved capacity is
    /// released and you can no longer launch instances into it. The Capacity Reservation's state changes to expired when it reaches its end date and time.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>end-date-type</code> - Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have one of the following end types:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>unlimited</code> - The Capacity Reservation remains active until you explicitly cancel it.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>limited</code> - The Capacity Reservation expires automatically at a specified date and time.</p>
    /// </li>
    /// </ul>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-match-criteria</code> - Indicates the type of instance launches that the Capacity Reservation accepts. The options include:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>open</code> - The Capacity Reservation accepts all instances that have matching
    /// attributes (instance type, platform, and Availability Zone). Instances
    /// that have matching attributes launch into the Capacity Reservation
    /// automatically without specifying any additional parameters.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>targeted</code> - The Capacity Reservation only accepts instances that have matching
    /// attributes (instance type, platform, and Availability Zone), and
    /// explicitly target the Capacity Reservation. This ensures that only
    /// permitted instances can use the reserved capacity.</p>
    /// </li>
    /// </ul>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeCapacityReservationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeCapacityReservationsInput");
        formatter.field("capacity_reservation_ids", &self.capacity_reservation_ids);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeByoipCidrsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The maximum number of results to return with a single call.
    /// To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DescribeByoipCidrsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeByoipCidrsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("max_results", &self.max_results);
        formatter.field("next_token", &self.next_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeBundleTasksInput {
    /// <p>The bundle task IDs.</p>
    /// <p>Default: Describes all your bundle tasks.</p>
    pub bundle_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>bundle-id</code> - The ID of the bundle task.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>error-code</code> - If the task failed, the error code returned.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>error-message</code> - If the task failed, the error message returned.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>progress</code> - The level of task completion, as a percentage (for example, 20%).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>s3-bucket</code> - The Amazon S3 bucket to store the AMI.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>s3-prefix</code> - The beginning of the AMI name.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>start-time</code> - The time the task started (for example, 2013-09-15T17:15:20.000Z).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the task (<code>pending</code> | <code>waiting-for-shutdown</code> | <code>bundling</code> |
    /// <code>storing</code> | <code>cancelling</code> | <code>complete</code> | <code>failed</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>update-time</code> - The time of the most recent update for the task.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeBundleTasksInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeBundleTasksInput");
        formatter.field("bundle_ids", &self.bundle_ids);
        formatter.field("filters", &self.filters);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeAvailabilityZonesInput {
    /// <p>The filters.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>group-name</code> - For Availability Zones, use the Region name. For Local
    /// Zones, use the name of the group associated with the Local Zone (for example,
    /// <code>us-west-2-lax-1</code>) For Wavelength Zones, use the name of the group associated
    /// with the Wavelength Zone (for example, <code>us-east-1-wl1-bos-wlz-1</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>message</code> - The Zone message.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>opt-in-status</code> - The opt-in status (<code>opted-in</code>, and
    /// <code>not-opted-in</code> | <code>opt-in-not-required</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>parent-zoneID</code> - The ID of the zone that handles some of the Local Zone
    /// and Wavelength Zone control plane operations, such as API calls.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>parent-zoneName</code> - The ID of the zone that handles some of the Local Zone
    /// and Wavelength Zone control plane operations, such as API calls.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>region-name</code> - The name of the Region for the Zone (for example,
    /// <code>us-east-1</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>state</code> - The state of the Availability Zone, the Local Zone, or the
    /// Wavelength Zone (<code>available</code> | <code>information</code> | <code>impaired</code>
    /// | <code>unavailable</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>zone-id</code> - The ID of the Availability Zone (for example,
    /// <code>use1-az1</code>), the Local Zone (for example, <code>usw2-lax1-az1</code>), or the
    /// Wavelength Zone (for example, <code>us-east-1-wl1-bos-wlz-1</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>zone-type</code> - The type of zone, for example, <code>local-zone</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>zone-name</code> - The name of the Availability Zone (for example,
    /// <code>us-east-1a</code>), the Local Zone (for example, <code>us-west-2-lax-1a</code>), or
    /// the Wavelength Zone (for example, <code>us-east-1-wl1-bos-wlz-1</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>zone-type</code> - The type of zone, for example, <code>local-zone</code>.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>The names of the Availability Zones, Local Zones, and Wavelength Zones.</p>
    pub zone_names: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The IDs of the Availability Zones, Local Zones, and Wavelength Zones.</p>
    pub zone_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Include all Availability Zones, Local Zones, and Wavelength Zones regardless of your
    /// opt-in status.</p>
    /// <p>If you do not use this parameter, the results include only the zones for the Regions where you have chosen the option to opt in.</p>
    pub all_availability_zones: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeAvailabilityZonesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeAvailabilityZonesInput");
        formatter.field("filters", &self.filters);
        formatter.field("zone_names", &self.zone_names);
        formatter.field("zone_ids", &self.zone_ids);
        formatter.field("all_availability_zones", &self.all_availability_zones);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeAggregateIdFormatInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeAggregateIdFormatInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeAggregateIdFormatInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeAddressesAttributeInput {
    /// <p>[EC2-VPC] The allocation IDs.</p>
    pub allocation_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The attribute of the IP address.</p>
    pub attribute: std::option::Option<crate::model::AddressAttributeName>,
    /// <p>The token for the next page of results.</p>
    pub next_token: std::option::Option<std::string::String>,
    /// <p>The maximum number of results to return with a single call. To retrieve the remaining results, make another call with the returned <code>nextToken</code> value.</p>
    pub max_results: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeAddressesAttributeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeAddressesAttributeInput");
        formatter.field("allocation_ids", &self.allocation_ids);
        formatter.field("attribute", &self.attribute);
        formatter.field("next_token", &self.next_token);
        formatter.field("max_results", &self.max_results);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeAddressesInput {
    /// <p>One or more filters. Filter names and values are case-sensitive.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>allocation-id</code> - [EC2-VPC] The allocation ID for the address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>association-id</code> - [EC2-VPC] The association ID for the address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>domain</code> - Indicates whether the address is for use in EC2-Classic (<code>standard</code>)
    /// or in a VPC (<code>vpc</code>).</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instance-id</code> - The ID of the instance the address is associated with, if any.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-border-group</code> -  A unique set of Availability Zones, Local Zones,
    /// or Wavelength Zones from where Amazon Web Services advertises IP addresses. </p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-id</code> - [EC2-VPC] The ID of the network interface that the address is associated with, if any.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>network-interface-owner-id</code> - The account ID of the owner.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>private-ip-address</code> - [EC2-VPC] The private IP address associated with the Elastic IP address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>public-ip</code> - The Elastic IP address, or the carrier IP address.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag</code>:<key> - The key/value combination of a tag assigned to the resource. Use the tag key in the filter name and the tag value as the filter value.
    /// For example, to find all resources that have a tag with the key <code>Owner</code> and the value <code>TeamA</code>, specify <code>tag:Owner</code> for the filter name and <code>TeamA</code> for the filter value.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>tag-key</code> - The key of a tag assigned to the resource. Use this filter to find all resources assigned a tag with a specific key, regardless of the tag value.</p>
    /// </li>
    /// </ul>
    pub filters: std::option::Option<std::vec::Vec<crate::model::Filter>>,
    /// <p>One or more Elastic IP addresses.</p>
    /// <p>Default: Describes all your Elastic IP addresses.</p>
    pub public_ips: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>[EC2-VPC] Information about the allocation IDs.</p>
    pub allocation_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeAddressesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeAddressesInput");
        formatter.field("filters", &self.filters);
        formatter.field("public_ips", &self.public_ips);
        formatter.field("allocation_ids", &self.allocation_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DescribeAccountAttributesInput {
    /// <p>The account attribute names.</p>
    pub attribute_names: std::option::Option<std::vec::Vec<crate::model::AccountAttributeName>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DescribeAccountAttributesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DescribeAccountAttributesInput");
        formatter.field("attribute_names", &self.attribute_names);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeregisterTransitGatewayMulticastGroupSourcesInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The IP address assigned to the  transit gateway multicast group.</p>
    pub group_ip_address: std::option::Option<std::string::String>,
    /// <p>The IDs of the group sources' network interfaces.</p>
    pub network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeregisterTransitGatewayMulticastGroupSourcesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeregisterTransitGatewayMulticastGroupSourcesInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field("group_ip_address", &self.group_ip_address);
        formatter.field("network_interface_ids", &self.network_interface_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeregisterTransitGatewayMulticastGroupMembersInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The IP address assigned to the  transit gateway multicast group.</p>
    pub group_ip_address: std::option::Option<std::string::String>,
    /// <p>The IDs of the group members' network interfaces.</p>
    pub network_interface_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeregisterTransitGatewayMulticastGroupMembersInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeregisterTransitGatewayMulticastGroupMembersInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field("group_ip_address", &self.group_ip_address);
        formatter.field("network_interface_ids", &self.network_interface_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeregisterInstanceEventNotificationAttributesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Information about the tag keys to deregister.</p>
    pub instance_tag_attribute:
        std::option::Option<crate::model::DeregisterInstanceTagAttributeRequest>,
}
impl std::fmt::Debug for DeregisterInstanceEventNotificationAttributesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeregisterInstanceEventNotificationAttributesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_tag_attribute", &self.instance_tag_attribute);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeregisterImage.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeregisterImageInput {
    /// <p>The ID of the AMI.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeregisterImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeregisterImageInput");
        formatter.field("image_id", &self.image_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeprovisionByoipCidrInput {
    /// <p>The address range, in CIDR notation. The prefix must be the same prefix
    /// that you specified when you provisioned the address range.</p>
    pub cidr: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeprovisionByoipCidrInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeprovisionByoipCidrInput");
        formatter.field("cidr", &self.cidr);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteVpnGateway.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpnGatewayInput {
    /// <p>The ID of the virtual private gateway.</p>
    pub vpn_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteVpnGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpnGatewayInput");
        formatter.field("vpn_gateway_id", &self.vpn_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteVpnConnectionRoute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpnConnectionRouteInput {
    /// <p>The CIDR block associated with the local subnet of the customer network.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the VPN connection.</p>
    pub vpn_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteVpnConnectionRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpnConnectionRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field("vpn_connection_id", &self.vpn_connection_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteVpnConnection.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpnConnectionInput {
    /// <p>The ID of the VPN connection.</p>
    pub vpn_connection_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteVpnConnectionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpnConnectionInput");
        formatter.field("vpn_connection_id", &self.vpn_connection_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpcPeeringConnectionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC peering connection.</p>
    pub vpc_peering_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteVpcPeeringConnectionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpcPeeringConnectionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_peering_connection_id", &self.vpc_peering_connection_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpcEndpointServiceConfigurationsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of one or more services.</p>
    pub service_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DeleteVpcEndpointServiceConfigurationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpcEndpointServiceConfigurationsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_ids", &self.service_ids);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteVpcEndpoints.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpcEndpointsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more VPC endpoint IDs.</p>
    pub vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DeleteVpcEndpointsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpcEndpointsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_endpoint_ids", &self.vpc_endpoint_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpcEndpointConnectionNotificationsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more notification IDs.</p>
    pub connection_notification_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DeleteVpcEndpointConnectionNotificationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpcEndpointConnectionNotificationsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "connection_notification_ids",
            &self.connection_notification_ids,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVpcInput {
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteVpcInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVpcInput");
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteVolumeInput {
    /// <p>The ID of the volume.</p>
    pub volume_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteVolumeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteVolumeInput");
        formatter.field("volume_id", &self.volume_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayVpcAttachmentInput {
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayVpcAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayVpcAttachmentInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayRouteTableInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayRouteTableInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayRouteInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The CIDR range for the route. This must match the CIDR for the route exactly.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayRouteInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayPrefixListReferenceInput {
    /// <p>The ID of the route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the prefix list.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayPrefixListReferenceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayPrefixListReferenceInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayPeeringAttachmentInput {
    /// <p>The ID of the transit gateway peering attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayPeeringAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayPeeringAttachmentInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayMulticastDomainInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayMulticastDomainInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayMulticastDomainInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayConnectPeerInput {
    /// <p>The ID of the Connect peer.</p>
    pub transit_gateway_connect_peer_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayConnectPeerInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayConnectPeerInput");
        formatter.field(
            "transit_gateway_connect_peer_id",
            &self.transit_gateway_connect_peer_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayConnectInput {
    /// <p>The ID of the Connect attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayConnectInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayConnectInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTransitGatewayInput {
    /// <p>The ID of the transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTransitGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTransitGatewayInput");
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTrafficMirrorTargetInput {
    /// <p>The ID of the Traffic Mirror target.</p>
    pub traffic_mirror_target_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTrafficMirrorTargetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTrafficMirrorTargetInput");
        formatter.field("traffic_mirror_target_id", &self.traffic_mirror_target_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTrafficMirrorSessionInput {
    /// <p>The ID of the Traffic Mirror session.</p>
    pub traffic_mirror_session_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTrafficMirrorSessionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTrafficMirrorSessionInput");
        formatter.field("traffic_mirror_session_id", &self.traffic_mirror_session_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTrafficMirrorFilterRuleInput {
    /// <p>The ID of the Traffic Mirror rule.</p>
    pub traffic_mirror_filter_rule_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTrafficMirrorFilterRuleInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTrafficMirrorFilterRuleInput");
        formatter.field(
            "traffic_mirror_filter_rule_id",
            &self.traffic_mirror_filter_rule_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTrafficMirrorFilterInput {
    /// <p>The ID of the Traffic Mirror filter.</p>
    pub traffic_mirror_filter_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteTrafficMirrorFilterInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTrafficMirrorFilterInput");
        formatter.field("traffic_mirror_filter_id", &self.traffic_mirror_filter_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteTagsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the resources, separated by spaces.</p>
    /// <p>Constraints: Up to 1000 resource IDs. We recommend breaking up this request into smaller batches.</p>
    pub resources: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The tags to delete. Specify a tag key and an optional tag value to delete
    /// specific tags. If you specify a tag key without a tag value, we delete any tag with this
    /// key regardless of its value. If you specify a tag key with an empty string as the tag
    /// value, we delete the tag only if its value is an empty string.</p>
    /// <p>If you omit this parameter, we delete all user-defined tags for the specified
    /// resources. We do not delete AWS-generated tags (tags that have the <code>aws:</code>
    /// prefix).</p>
    pub tags: std::option::Option<std::vec::Vec<crate::model::Tag>>,
}
impl std::fmt::Debug for DeleteTagsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteTagsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("resources", &self.resources);
        formatter.field("tags", &self.tags);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteSubnetInput {
    /// <p>The ID of the subnet.</p>
    pub subnet_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteSubnetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteSubnetInput");
        formatter.field("subnet_id", &self.subnet_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteSpotDatafeedSubscription.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteSpotDatafeedSubscriptionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteSpotDatafeedSubscriptionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteSpotDatafeedSubscriptionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteSnapshotInput {
    /// <p>The ID of the EBS snapshot.</p>
    pub snapshot_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteSnapshotInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteSnapshotInput");
        formatter.field("snapshot_id", &self.snapshot_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteSecurityGroupInput {
    /// <p>The ID of the security group. Required for a nondefault VPC.</p>
    pub group_id: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic, default VPC] The name of the security group. You can specify either the security group name or the security group ID.</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteSecurityGroupInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteSecurityGroupInput");
        formatter.field("group_id", &self.group_id);
        formatter.field("group_name", &self.group_name);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteRouteTableInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the route table.</p>
    pub route_table_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteRouteTableInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteRouteInput {
    /// <p>The IPv4 CIDR range for the route. The value you specify must match the CIDR for the route exactly.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The IPv6 CIDR range for the route. The value you specify must match the CIDR for the route exactly.</p>
    pub destination_ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the prefix list for the route.</p>
    pub destination_prefix_list_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the route table.</p>
    pub route_table_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field(
            "destination_ipv6_cidr_block",
            &self.destination_ipv6_cidr_block,
        );
        formatter.field(
            "destination_prefix_list_id",
            &self.destination_prefix_list_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteQueuedReservedInstancesInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the Reserved Instances.</p>
    pub reserved_instances_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DeleteQueuedReservedInstancesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteQueuedReservedInstancesInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("reserved_instances_ids", &self.reserved_instances_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeletePlacementGroupInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The name of the placement group.</p>
    pub group_name: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeletePlacementGroupInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeletePlacementGroupInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_name", &self.group_name);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteNetworkInterfacePermission.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteNetworkInterfacePermissionInput {
    /// <p>The ID of the network interface permission.</p>
    pub network_interface_permission_id: std::option::Option<std::string::String>,
    /// <p>Specify <code>true</code> to remove the permission even if the network interface is
    /// attached to an instance.</p>
    pub force: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteNetworkInterfacePermissionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteNetworkInterfacePermissionInput");
        formatter.field(
            "network_interface_permission_id",
            &self.network_interface_permission_id,
        );
        formatter.field("force", &self.force);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteNetworkInterface.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteNetworkInterfaceInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteNetworkInterfaceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteNetworkInterfaceInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteNetworkInsightsPathInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the path.</p>
    pub network_insights_path_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteNetworkInsightsPathInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteNetworkInsightsPathInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_insights_path_id", &self.network_insights_path_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteNetworkInsightsAnalysisInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the network insights analysis.</p>
    pub network_insights_analysis_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteNetworkInsightsAnalysisInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteNetworkInsightsAnalysisInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "network_insights_analysis_id",
            &self.network_insights_analysis_id,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteNetworkAclEntryInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Indicates whether the rule is an egress rule.</p>
    pub egress: std::option::Option<bool>,
    /// <p>The ID of the network ACL.</p>
    pub network_acl_id: std::option::Option<std::string::String>,
    /// <p>The rule number of the entry to delete.</p>
    pub rule_number: std::option::Option<i32>,
}
impl std::fmt::Debug for DeleteNetworkAclEntryInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteNetworkAclEntryInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("egress", &self.egress);
        formatter.field("network_acl_id", &self.network_acl_id);
        formatter.field("rule_number", &self.rule_number);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteNetworkAclInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the network ACL.</p>
    pub network_acl_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteNetworkAclInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteNetworkAclInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_acl_id", &self.network_acl_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteNatGatewayInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the NAT gateway.</p>
    pub nat_gateway_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteNatGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteNatGatewayInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("nat_gateway_id", &self.nat_gateway_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteManagedPrefixListInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the prefix list.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteManagedPrefixListInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteManagedPrefixListInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteLocalGatewayRouteTableVpcAssociationInput {
    /// <p>The ID of the association.</p>
    pub local_gateway_route_table_vpc_association_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteLocalGatewayRouteTableVpcAssociationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteLocalGatewayRouteTableVpcAssociationInput");
        formatter.field(
            "local_gateway_route_table_vpc_association_id",
            &self.local_gateway_route_table_vpc_association_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteLocalGatewayRouteInput {
    /// <p>The CIDR range for the route. This must match the CIDR for the route exactly.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the local gateway route table.</p>
    pub local_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteLocalGatewayRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteLocalGatewayRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field(
            "local_gateway_route_table_id",
            &self.local_gateway_route_table_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteLaunchTemplateVersionsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_id: std::option::Option<std::string::String>,
    /// <p>The name of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_name: std::option::Option<std::string::String>,
    /// <p>The version numbers of one or more launch template versions to delete.</p>
    pub versions: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DeleteLaunchTemplateVersionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteLaunchTemplateVersionsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("launch_template_id", &self.launch_template_id);
        formatter.field("launch_template_name", &self.launch_template_name);
        formatter.field("versions", &self.versions);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteLaunchTemplateInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_id: std::option::Option<std::string::String>,
    /// <p>The name of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_name: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteLaunchTemplateInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteLaunchTemplateInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("launch_template_id", &self.launch_template_id);
        formatter.field("launch_template_name", &self.launch_template_name);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteKeyPairInput {
    /// <p>The name of the key pair.</p>
    pub key_name: std::option::Option<std::string::String>,
    /// <p>The ID of the key pair.</p>
    pub key_pair_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteKeyPairInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteKeyPairInput");
        formatter.field("key_name", &self.key_name);
        formatter.field("key_pair_id", &self.key_pair_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteInternetGatewayInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the internet gateway.</p>
    pub internet_gateway_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteInternetGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteInternetGatewayInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("internet_gateway_id", &self.internet_gateway_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteFpgaImageInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the AFI.</p>
    pub fpga_image_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteFpgaImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteFpgaImageInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("fpga_image_id", &self.fpga_image_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteFlowLogsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more flow log IDs.</p>
    /// <p>Constraint: Maximum of 1000 flow log IDs.</p>
    pub flow_log_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for DeleteFlowLogsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteFlowLogsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("flow_log_ids", &self.flow_log_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteFleetsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the EC2 Fleets.</p>
    pub fleet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Indicates whether to terminate the instances when the EC2 Fleet is deleted. The default is to
    /// terminate the instances.</p>
    /// <p>To let the instances continue to run after the EC2 Fleet is deleted, specify
    /// <code>NoTerminateInstances</code>. Supported only for fleets of type
    /// <code>maintain</code> and <code>request</code>.</p>
    /// <p>For <code>instant</code> fleets, you cannot specify <code>NoTerminateInstances</code>. A
    /// deleted <code>instant</code> fleet with running instances is not supported.</p>
    pub terminate_instances: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteFleetsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteFleetsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("fleet_ids", &self.fleet_ids);
        formatter.field("terminate_instances", &self.terminate_instances);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteEgressOnlyInternetGatewayInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the egress-only internet gateway.</p>
    pub egress_only_internet_gateway_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for DeleteEgressOnlyInternetGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteEgressOnlyInternetGatewayInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "egress_only_internet_gateway_id",
            &self.egress_only_internet_gateway_id,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteDhcpOptionsInput {
    /// <p>The ID of the DHCP options set.</p>
    pub dhcp_options_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteDhcpOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteDhcpOptionsInput");
        formatter.field("dhcp_options_id", &self.dhcp_options_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for DeleteCustomerGateway.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteCustomerGatewayInput {
    /// <p>The ID of the customer gateway.</p>
    pub customer_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteCustomerGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteCustomerGatewayInput");
        formatter.field("customer_gateway_id", &self.customer_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteClientVpnRouteInput {
    /// <p>The ID of the Client VPN endpoint from which the route is to be deleted.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The ID of the target subnet used by the route.</p>
    pub target_vpc_subnet_id: std::option::Option<std::string::String>,
    /// <p>The IPv4 address range, in CIDR notation, of the route to be deleted.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteClientVpnRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteClientVpnRouteInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("target_vpc_subnet_id", &self.target_vpc_subnet_id);
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteClientVpnEndpointInput {
    /// <p>The ID of the Client VPN to be deleted.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteClientVpnEndpointInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteClientVpnEndpointInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteCarrierGatewayInput {
    /// <p>The ID of the carrier gateway.</p>
    pub carrier_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for DeleteCarrierGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteCarrierGatewayInput");
        formatter.field("carrier_gateway_id", &self.carrier_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateVpnGateway.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpnGatewayInput {
    /// <p>The Availability Zone for the virtual private gateway.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>The type of VPN connection this virtual private gateway supports.</p>
    pub r#type: std::option::Option<crate::model::GatewayType>,
    /// <p>The tags to apply to the virtual private gateway.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>A private Autonomous System Number (ASN) for the Amazon side of a BGP session. If you're using a 16-bit ASN, it must be in the 64512 to 65534 range. If you're using a 32-bit ASN, it must be in the 4200000000 to 4294967294 range.</p>
    /// <p>Default: 64512</p>
    pub amazon_side_asn: std::option::Option<i64>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateVpnGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpnGatewayInput");
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("r#type", &self.r#type);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("amazon_side_asn", &self.amazon_side_asn);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateVpnConnectionRoute.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpnConnectionRouteInput {
    /// <p>The CIDR block associated with the local subnet of the customer network.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the VPN connection.</p>
    pub vpn_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateVpnConnectionRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpnConnectionRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field("vpn_connection_id", &self.vpn_connection_id);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateVpnConnection.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpnConnectionInput {
    /// <p>The ID of the customer gateway.</p>
    pub customer_gateway_id: std::option::Option<std::string::String>,
    /// <p>The type of VPN connection (<code>ipsec.1</code>).</p>
    pub r#type: std::option::Option<std::string::String>,
    /// <p>The ID of the virtual private gateway. If you specify a virtual private gateway, you cannot specify a transit gateway.</p>
    pub vpn_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the transit gateway. If you specify a transit gateway, you cannot specify a virtual private gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The options for the VPN connection.</p>
    pub options: std::option::Option<crate::model::VpnConnectionOptionsSpecification>,
    /// <p>The tags to apply to the VPN connection.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateVpnConnectionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpnConnectionInput");
        formatter.field("customer_gateway_id", &self.customer_gateway_id);
        formatter.field("r#type", &self.r#type);
        formatter.field("vpn_gateway_id", &self.vpn_gateway_id);
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("options", &self.options);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpcPeeringConnectionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The AWS account ID of the owner of the accepter VPC.</p>
    /// <p>Default: Your AWS account ID</p>
    pub peer_owner_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC with which you are creating the VPC peering connection. You must
    /// specify this parameter in the request.</p>
    pub peer_vpc_id: std::option::Option<std::string::String>,
    /// <p>The ID of the requester VPC. You must specify this parameter in the
    /// request.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The Region code for the accepter VPC, if the accepter VPC is located in a Region
    /// other than the Region in which you make the request.</p>
    /// <p>Default: The Region in which you make the request.</p>
    pub peer_region: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the peering connection.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateVpcPeeringConnectionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpcPeeringConnectionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("peer_owner_id", &self.peer_owner_id);
        formatter.field("peer_vpc_id", &self.peer_vpc_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("peer_region", &self.peer_region);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpcEndpointServiceConfigurationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Indicates whether requests from service consumers to create an endpoint to your service must
    /// be accepted. To accept a request, use <a>AcceptVpcEndpointConnections</a>.</p>
    pub acceptance_required: std::option::Option<bool>,
    /// <p>(Interface endpoint configuration) The private DNS name to assign to the VPC endpoint service.</p>
    pub private_dns_name: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Names (ARNs) of one or more Network Load Balancers for your
    /// service.</p>
    pub network_load_balancer_arns: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The Amazon Resource Names (ARNs) of one or more Gateway Load Balancers.</p>
    pub gateway_load_balancer_arns: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
    /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The tags to associate with the service.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateVpcEndpointServiceConfigurationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpcEndpointServiceConfigurationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("acceptance_required", &self.acceptance_required);
        formatter.field("private_dns_name", &self.private_dns_name);
        formatter.field(
            "network_load_balancer_arns",
            &self.network_load_balancer_arns,
        );
        formatter.field(
            "gateway_load_balancer_arns",
            &self.gateway_load_balancer_arns,
        );
        formatter.field("client_token", &self.client_token);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpcEndpointConnectionNotificationInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the endpoint service.</p>
    pub service_id: std::option::Option<std::string::String>,
    /// <p>The ID of the endpoint.</p>
    pub vpc_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The ARN of the SNS topic for the notifications.</p>
    pub connection_notification_arn: std::option::Option<std::string::String>,
    /// <p>One or more endpoint events for which to receive notifications. Valid values are
    /// <code>Accept</code>, <code>Connect</code>, <code>Delete</code>, and
    /// <code>Reject</code>.</p>
    pub connection_events: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateVpcEndpointConnectionNotificationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpcEndpointConnectionNotificationInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_id", &self.service_id);
        formatter.field("vpc_endpoint_id", &self.vpc_endpoint_id);
        formatter.field(
            "connection_notification_arn",
            &self.connection_notification_arn,
        );
        formatter.field("connection_events", &self.connection_events);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateVpcEndpoint.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpcEndpointInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The type of endpoint.</p>
    /// <p>Default: Gateway</p>
    pub vpc_endpoint_type: std::option::Option<crate::model::VpcEndpointType>,
    /// <p>The ID of the VPC in which the endpoint will be used.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The service name. To get a list of available services, use the <a>DescribeVpcEndpointServices</a> request, or get the name from the service
    /// provider.</p>
    pub service_name: std::option::Option<std::string::String>,
    /// <p>(Interface and gateway endpoints) A policy to attach to the endpoint that controls access to the
    /// service. The policy must be in valid JSON format. If this parameter is not specified, we
    /// attach a default policy that allows full access to the service.</p>
    pub policy_document: std::option::Option<std::string::String>,
    /// <p>(Gateway endpoint) One or more route table IDs.</p>
    pub route_table_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Interface and Gateway Load Balancer endpoints) The ID of one or more subnets in which to create an endpoint
    /// network interface. For a Gateway Load Balancer endpoint, you can specify one subnet only.</p>
    pub subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>(Interface endpoint) The ID of one or more security groups to associate with the
    /// endpoint network interface.</p>
    pub security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>(Interface endpoint) Indicates whether to associate a private hosted zone with the
    /// specified VPC. The private hosted zone contains a record set for the default public DNS
    /// name for the service for the Region (for example,
    /// <code>kinesis.us-east-1.amazonaws.com</code>), which resolves to the private IP
    /// addresses of the endpoint network interfaces in the VPC. This enables you to make
    /// requests to the default public DNS name for the service instead of the public DNS names
    /// that are automatically generated by the VPC endpoint service.</p>
    /// <p>To use a private hosted zone, you must set the following VPC attributes to
    /// <code>true</code>: <code>enableDnsHostnames</code> and
    /// <code>enableDnsSupport</code>. Use <a>ModifyVpcAttribute</a> to set the VPC
    /// attributes.</p>
    /// <p>Default: <code>true</code>
    /// </p>
    pub private_dns_enabled: std::option::Option<bool>,
    /// <p>The tags to associate with the endpoint.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateVpcEndpointInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpcEndpointInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_endpoint_type", &self.vpc_endpoint_type);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("service_name", &self.service_name);
        formatter.field("policy_document", &self.policy_document);
        formatter.field("route_table_ids", &self.route_table_ids);
        formatter.field("subnet_ids", &self.subnet_ids);
        formatter.field("security_group_ids", &self.security_group_ids);
        formatter.field("client_token", &self.client_token);
        formatter.field("private_dns_enabled", &self.private_dns_enabled);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVpcInput {
    /// <p>The IPv4 network range for the VPC, in CIDR notation. For example,
    /// <code>10.0.0.0/16</code>. We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
    pub cidr_block: std::option::Option<std::string::String>,
    /// <p>Requests an Amazon-provided IPv6 CIDR block with a /56 prefix length for the VPC.
    /// You cannot specify the range of IP addresses, or the size of the CIDR block.</p>
    pub amazon_provided_ipv6_cidr_block: std::option::Option<bool>,
    /// <p>The ID of an IPv6 address pool from which to allocate the IPv6 CIDR block.</p>
    pub ipv6_pool: std::option::Option<std::string::String>,
    /// <p>The IPv6 CIDR block from the IPv6 address pool. You must also specify <code>Ipv6Pool</code> in the request.</p>
    /// <p>To let Amazon choose the IPv6 CIDR block for you, omit this parameter.</p>
    pub ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tenancy options for instances launched into the VPC. For <code>default</code>, instances
    /// are launched with shared tenancy by default. You can launch instances with any tenancy into a
    /// shared tenancy VPC. For <code>dedicated</code>, instances are launched as dedicated tenancy
    /// instances by default. You can only launch instances with a tenancy of <code>dedicated</code>
    /// or <code>host</code> into a dedicated tenancy VPC. </p>
    /// <p>
    /// <b>Important:</b> The <code>host</code> value cannot be used with this parameter. Use the <code>default</code> or <code>dedicated</code> values only.</p>
    /// <p>Default: <code>default</code>
    /// </p>
    pub instance_tenancy: std::option::Option<crate::model::Tenancy>,
    /// <p>The name of the location from which we advertise the IPV6 CIDR block. Use this parameter to limit the address to this location.</p>
    /// <p> You must set <code>AmazonProvidedIpv6CidrBlock</code> to <code>true</code> to use this parameter.</p>
    pub ipv6_cidr_block_network_border_group: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the VPC.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateVpcInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVpcInput");
        formatter.field("cidr_block", &self.cidr_block);
        formatter.field(
            "amazon_provided_ipv6_cidr_block",
            &self.amazon_provided_ipv6_cidr_block,
        );
        formatter.field("ipv6_pool", &self.ipv6_pool);
        formatter.field("ipv6_cidr_block", &self.ipv6_cidr_block);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_tenancy", &self.instance_tenancy);
        formatter.field(
            "ipv6_cidr_block_network_border_group",
            &self.ipv6_cidr_block_network_border_group,
        );
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateVolumeInput {
    /// <p>The Availability Zone in which to create the volume.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>Indicates whether the volume should be encrypted.
    /// The effect of setting the encryption state to <code>true</code> depends on
    /// the volume origin (new or from a snapshot), starting encryption state, ownership, and whether encryption by default is enabled.
    /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-by-default">Encryption by default</a>
    /// in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    /// <p>Encrypted Amazon EBS volumes must be attached to instances that support Amazon EBS encryption.
    /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#EBSEncryption_supported_instances">Supported
    /// instance types</a>.</p>
    pub encrypted: std::option::Option<bool>,
    /// <p>The number of I/O operations per second (IOPS). For <code>gp3</code>, <code>io1</code>, and <code>io2</code> volumes, this represents
    /// the number of IOPS that are provisioned for the volume. For <code>gp2</code> volumes, this represents the baseline
    /// performance of the volume and the rate at which the volume accumulates I/O credits for bursting.</p>
    /// <p>The following are the supported values for each volume type:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>gp3</code>: 3,000-16,000 IOPS</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>io1</code>: 100-64,000 IOPS</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>io2</code>: 100-64,000 IOPS</p>
    /// </li>
    /// </ul>
    /// <p>For <code>io1</code> and <code>io2</code> volumes, we guarantee 64,000 IOPS only for  
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">Instances built on the Nitro System</a>. Other instance families guarantee performance
    /// up to 32,000 IOPS.</p>
    /// <p>This parameter is required for <code>io1</code> and <code>io2</code> volumes.
    /// The default for <code>gp3</code> volumes is 3,000 IOPS.
    /// This parameter is not supported for <code>gp2</code>, <code>st1</code>, <code>sc1</code>, or <code>standard</code> volumes.</p>
    pub iops: std::option::Option<i32>,
    /// <p>The identifier of the AWS Key Management Service (AWS KMS) customer master key (CMK) to use for Amazon EBS encryption.
    /// If this parameter is not specified, your AWS managed CMK for EBS is used. If <code>KmsKeyId</code> is
    /// specified, the encrypted state must be <code>true</code>.</p>
    /// <p>You can specify the CMK using any of the following:</p>
    /// <ul>
    /// <li>
    /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Key alias. For example, alias/ExampleAlias.</p>
    /// </li>
    /// <li>
    /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
    /// </li>
    /// </ul>
    /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an ID, alias, or ARN that is not valid,
    /// the action can appear to complete, but eventually fails.</p>
    pub kms_key_id: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the Outpost.</p>
    pub outpost_arn: std::option::Option<std::string::String>,
    /// <p>The size of the volume, in GiBs. You must specify either a snapshot ID or a volume size.
    /// If you specify a snapshot, the default is the snapshot size. You can specify a volume
    /// size that is equal to or larger than the snapshot size.</p>
    /// <p>The following are the supported volumes sizes for each volume type:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>gp2</code> and <code>gp3</code>: 1-16,384</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>io1</code> and <code>io2</code>: 4-16,384</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>st1</code> and <code>sc1</code>: 125-16,384</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>standard</code>: 1-1,024</p>
    /// </li>
    /// </ul>
    pub size: std::option::Option<i32>,
    /// <p>The snapshot from which to create the volume. You must specify either a snapshot ID or a volume size.</p>
    pub snapshot_id: std::option::Option<std::string::String>,
    /// <p>The volume type. This parameter can be one of the following values:</p>
    /// <ul>
    /// <li>
    /// <p>General Purpose SSD: <code>gp2</code> | <code>gp3</code>
    /// </p>
    /// </li>
    /// <li>
    /// <p>Provisioned IOPS SSD: <code>io1</code> | <code>io2</code>
    /// </p>
    /// </li>
    /// <li>
    /// <p>Throughput Optimized HDD: <code>st1</code>
    /// </p>
    /// </li>
    /// <li>
    /// <p>Cold HDD: <code>sc1</code>
    /// </p>
    /// </li>
    /// <li>
    /// <p>Magnetic: <code>standard</code>
    /// </p>
    /// </li>
    /// </ul>
    /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSVolumeTypes.html">Amazon EBS volume types</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    /// <p>Default: <code>gp2</code>
    /// </p>
    pub volume_type: std::option::Option<crate::model::VolumeType>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tags to apply to the volume during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Indicates whether to enable Amazon EBS Multi-Attach. If you enable Multi-Attach, you can attach the
    /// volume to up to 16 <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">Instances built on the Nitro System</a> in the same Availability Zone. This parameter is
    /// supported with <code>io1</code> and <code>io2</code> volumes only. For more information,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-volumes-multi.html">
    /// Amazon EBS Multi-Attach</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub multi_attach_enabled: std::option::Option<bool>,
    /// <p>The throughput to provision for a volume, with a maximum of 1,000 MiB/s.</p>
    /// <p>This parameter is valid only for <code>gp3</code> volumes.</p>
    /// <p>Valid Range: Minimum value of 125. Maximum value of 1000.</p>
    pub throughput: std::option::Option<i32>,
}
impl std::fmt::Debug for CreateVolumeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateVolumeInput");
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("encrypted", &self.encrypted);
        formatter.field("iops", &self.iops);
        formatter.field("kms_key_id", &self.kms_key_id);
        formatter.field("outpost_arn", &self.outpost_arn);
        formatter.field("size", &self.size);
        formatter.field("snapshot_id", &self.snapshot_id);
        formatter.field("volume_type", &self.volume_type);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("multi_attach_enabled", &self.multi_attach_enabled);
        formatter.field("throughput", &self.throughput);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayVpcAttachmentInput {
    /// <p>The ID of the transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The IDs of one or more subnets. You can specify only one subnet per Availability Zone.
    /// You must specify at least one subnet, but we recommend that you specify two subnets for better availability.
    /// The transit gateway uses one IP address from each specified subnet.</p>
    pub subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The VPC attachment options.</p>
    pub options: std::option::Option<crate::model::CreateTransitGatewayVpcAttachmentRequestOptions>,
    /// <p>The tags to apply to the VPC attachment.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayVpcAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayVpcAttachmentInput");
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("subnet_ids", &self.subnet_ids);
        formatter.field("options", &self.options);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayRouteTableInput {
    /// <p>The ID of the transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the transit gateway route table.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayRouteTableInput");
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayRouteInput {
    /// <p>The CIDR range used for destination matches. Routing decisions are based on the
    /// most specific match.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Indicates whether to drop traffic that matches this route.</p>
    pub blackhole: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("blackhole", &self.blackhole);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayPrefixListReferenceInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the prefix list that is used for destination matches.</p>
    pub prefix_list_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment to which traffic is routed.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Indicates whether to drop traffic that matches this route.</p>
    pub blackhole: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayPrefixListReferenceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayPrefixListReferenceInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field("prefix_list_id", &self.prefix_list_id);
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("blackhole", &self.blackhole);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayPeeringAttachmentInput {
    /// <p>The ID of the transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the peer transit gateway with which to create the peering attachment.</p>
    pub peer_transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The AWS account ID of the owner of the peer transit gateway.</p>
    pub peer_account_id: std::option::Option<std::string::String>,
    /// <p>The Region where the peer transit gateway is located.</p>
    pub peer_region: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the transit gateway peering attachment.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayPeeringAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayPeeringAttachmentInput");
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("peer_transit_gateway_id", &self.peer_transit_gateway_id);
        formatter.field("peer_account_id", &self.peer_account_id);
        formatter.field("peer_region", &self.peer_region);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayMulticastDomainInput {
    /// <p>The ID of the transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The options for the transit gateway multicast domain.</p>
    pub options:
        std::option::Option<crate::model::CreateTransitGatewayMulticastDomainRequestOptions>,
    /// <p>The tags for the transit gateway multicast domain.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayMulticastDomainInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayMulticastDomainInput");
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("options", &self.options);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayConnectPeerInput {
    /// <p>The ID of the Connect attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>The peer IP address (GRE outer IP address) on the transit gateway side of the Connect peer, which must be
    /// specified from a transit gateway CIDR block. If not specified, Amazon automatically assigns
    /// the first available IP address from the transit gateway CIDR block.</p>
    pub transit_gateway_address: std::option::Option<std::string::String>,
    /// <p>The peer IP address (GRE outer IP address) on the appliance side of the Connect peer.</p>
    pub peer_address: std::option::Option<std::string::String>,
    /// <p>The BGP options for the Connect peer.</p>
    pub bgp_options: std::option::Option<crate::model::TransitGatewayConnectRequestBgpOptions>,
    /// <p>The range of inside IP addresses that are used for BGP peering. You must specify a
    /// size /29 IPv4 CIDR block from the <code>169.254.0.0/16</code> range. The first address
    /// from the range must be configured on the appliance as the BGP IP address. You can also
    /// optionally specify a size /125 IPv6 CIDR block from the <code>fd00::/8</code>
    /// range.</p>
    pub inside_cidr_blocks: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The tags to apply to the Connect peer.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayConnectPeerInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayConnectPeerInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("transit_gateway_address", &self.transit_gateway_address);
        formatter.field("peer_address", &self.peer_address);
        formatter.field("bgp_options", &self.bgp_options);
        formatter.field("inside_cidr_blocks", &self.inside_cidr_blocks);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayConnectInput {
    /// <p>The ID of the transit gateway attachment. You can specify a VPC attachment or a AWS Direct Connect attachment.</p>
    pub transport_transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>The Connect attachment options.</p>
    pub options: std::option::Option<crate::model::CreateTransitGatewayConnectRequestOptions>,
    /// <p>The tags to apply to the Connect attachment.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayConnectInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayConnectInput");
        formatter.field(
            "transport_transit_gateway_attachment_id",
            &self.transport_transit_gateway_attachment_id,
        );
        formatter.field("options", &self.options);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTransitGatewayInput {
    /// <p>A description of the transit gateway.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The transit gateway options.</p>
    pub options: std::option::Option<crate::model::TransitGatewayRequestOptions>,
    /// <p>The tags to apply to the transit gateway.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateTransitGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTransitGatewayInput");
        formatter.field("description", &self.description);
        formatter.field("options", &self.options);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTrafficMirrorTargetInput {
    /// <p>The network interface ID that is associated with the target.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the Network Load Balancer that is associated with the target.</p>
    pub network_load_balancer_arn: std::option::Option<std::string::String>,
    /// <p>The description of the Traffic Mirror target.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the Traffic Mirror target.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateTrafficMirrorTargetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTrafficMirrorTargetInput");
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("network_load_balancer_arn", &self.network_load_balancer_arn);
        formatter.field("description", &self.description);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTrafficMirrorSessionInput {
    /// <p>The ID of the source network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The ID of the Traffic Mirror target.</p>
    pub traffic_mirror_target_id: std::option::Option<std::string::String>,
    /// <p>The ID of the Traffic Mirror filter.</p>
    pub traffic_mirror_filter_id: std::option::Option<std::string::String>,
    /// <p>The number of bytes in each packet to mirror. These are bytes after the VXLAN header. Do
    /// not specify this parameter when you want to mirror the entire packet. To mirror a subset of
    /// the packet, set this to the length (in bytes) that you want to mirror. For example, if you
    /// set this value to 100, then the first 100 bytes that meet the filter criteria are copied to
    /// the target.</p>
    /// <p>If you do not want to mirror the entire packet, use the <code>PacketLength</code> parameter to specify the number of bytes in each packet to mirror.</p>
    pub packet_length: std::option::Option<i32>,
    /// <p>The session number determines the order in which sessions are evaluated when an interface is used by multiple sessions. The first session with a matching filter is the one that mirrors the packets.</p>
    /// <p>Valid values are 1-32766.</p>
    pub session_number: std::option::Option<i32>,
    /// <p>The VXLAN ID for the Traffic Mirror session. For more information about the VXLAN
    /// protocol, see <a href="https://tools.ietf.org/html/rfc7348">RFC 7348</a>. If you do
    /// not specify a <code>VirtualNetworkId</code>, an account-wide unique id is chosen at
    /// random.</p>
    pub virtual_network_id: std::option::Option<i32>,
    /// <p>The description of the Traffic Mirror session.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The tags to assign to a Traffic Mirror session.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateTrafficMirrorSessionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTrafficMirrorSessionInput");
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("traffic_mirror_target_id", &self.traffic_mirror_target_id);
        formatter.field("traffic_mirror_filter_id", &self.traffic_mirror_filter_id);
        formatter.field("packet_length", &self.packet_length);
        formatter.field("session_number", &self.session_number);
        formatter.field("virtual_network_id", &self.virtual_network_id);
        formatter.field("description", &self.description);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTrafficMirrorFilterRuleInput {
    /// <p>The ID of the filter that this rule is associated with.</p>
    pub traffic_mirror_filter_id: std::option::Option<std::string::String>,
    /// <p>The type of traffic (<code>ingress</code> | <code>egress</code>).</p>
    pub traffic_direction: std::option::Option<crate::model::TrafficDirection>,
    /// <p>The number of the Traffic Mirror rule. This number must be unique for each Traffic Mirror rule in a given
    /// direction. The rules are processed in ascending order by rule number.</p>
    pub rule_number: std::option::Option<i32>,
    /// <p>The action to take (<code>accept</code> | <code>reject</code>) on the filtered traffic.</p>
    pub rule_action: std::option::Option<crate::model::TrafficMirrorRuleAction>,
    /// <p>The destination port range.</p>
    pub destination_port_range: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
    /// <p>The source port range.</p>
    pub source_port_range: std::option::Option<crate::model::TrafficMirrorPortRangeRequest>,
    /// <p>The protocol, for example UDP, to assign to the Traffic Mirror rule.</p>
    /// <p>For information about the protocol value, see <a href="https://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml">Protocol Numbers</a> on the  Internet Assigned Numbers Authority (IANA) website.</p>
    pub protocol: std::option::Option<i32>,
    /// <p>The destination CIDR block to assign to the Traffic Mirror rule.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The source CIDR block to assign to the Traffic Mirror rule.</p>
    pub source_cidr_block: std::option::Option<std::string::String>,
    /// <p>The description of the Traffic Mirror rule.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateTrafficMirrorFilterRuleInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTrafficMirrorFilterRuleInput");
        formatter.field("traffic_mirror_filter_id", &self.traffic_mirror_filter_id);
        formatter.field("traffic_direction", &self.traffic_direction);
        formatter.field("rule_number", &self.rule_number);
        formatter.field("rule_action", &self.rule_action);
        formatter.field("destination_port_range", &self.destination_port_range);
        formatter.field("source_port_range", &self.source_port_range);
        formatter.field("protocol", &self.protocol);
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field("source_cidr_block", &self.source_cidr_block);
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTrafficMirrorFilterInput {
    /// <p>The description of the Traffic Mirror filter.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The tags to assign to a Traffic Mirror filter.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateTrafficMirrorFilterInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTrafficMirrorFilterInput");
        formatter.field("description", &self.description);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateTagsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the resources, separated by spaces.</p>
    /// <p>Constraints: Up to 1000 resource IDs. We recommend breaking up this request into smaller batches.</p>
    pub resources: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The tags. The <code>value</code> parameter is required, but if you don't want the tag to have a value,
    /// specify the parameter with no value, and we set the value to an empty string.</p>
    pub tags: std::option::Option<std::vec::Vec<crate::model::Tag>>,
}
impl std::fmt::Debug for CreateTagsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTagsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("resources", &self.resources);
        formatter.field("tags", &self.tags);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateSubnetInput {
    /// <p>The tags to assign to the subnet.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>The Availability Zone or Local Zone for the subnet.</p>
    /// <p>Default: AWS selects one for you. If you create more than one subnet in your VPC, we
    /// do not necessarily select a different zone for each subnet.</p>
    /// <p>To create a subnet in a Local Zone, set this value to the Local Zone ID, for example
    /// <code>us-west-2-lax-1a</code>. For information about the Regions that support Local Zones,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-regions-availability-zones.html#concepts-available-regions">Available Regions</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    /// <p>To create a subnet in an Outpost, set this value to the Availability Zone for the
    /// Outpost and specify the Outpost ARN.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>The AZ ID or the Local Zone ID of the subnet.</p>
    pub availability_zone_id: std::option::Option<std::string::String>,
    /// <p>The IPv4 network range for the subnet, in CIDR notation. For example, <code>10.0.0.0/24</code>. We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
    pub cidr_block: std::option::Option<std::string::String>,
    /// <p>The IPv6 network range for the subnet, in CIDR notation. The subnet size must use a
    /// /64 prefix length.</p>
    pub ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the Outpost. If you specify an Outpost ARN, you must also
    /// specify the Availability Zone of the Outpost subnet.</p>
    pub outpost_arn: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateSubnetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateSubnetInput");
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("availability_zone_id", &self.availability_zone_id);
        formatter.field("cidr_block", &self.cidr_block);
        formatter.field("ipv6_cidr_block", &self.ipv6_cidr_block);
        formatter.field("outpost_arn", &self.outpost_arn);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateStoreImageTaskInput {
    /// <p>The ID of the AMI.</p>
    pub image_id: std::option::Option<std::string::String>,
    /// <p>The name of the S3 bucket in which the AMI object will be stored. The bucket must be in
    /// the Region in which the request is being made. The AMI object appears in the bucket only after
    /// the upload task has completed. </p>
    pub bucket: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the AMI object that will be stored in the S3 bucket. </p>
    pub s3_object_tags: std::option::Option<std::vec::Vec<crate::model::S3ObjectTag>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateStoreImageTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateStoreImageTaskInput");
        formatter.field("image_id", &self.image_id);
        formatter.field("bucket", &self.bucket);
        formatter.field("s3_object_tags", &self.s3_object_tags);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateSpotDatafeedSubscription.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateSpotDatafeedSubscriptionInput {
    /// <p>The name of the Amazon S3 bucket in which to store the Spot Instance data feed. For
    /// more information about bucket names, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/BucketRestrictions.html#bucketnamingrules">Rules for bucket
    /// naming</a> in the <i>Amazon S3 Developer Guide</i>.</p>
    pub bucket: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The prefix for the data feed file names.</p>
    pub prefix: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateSpotDatafeedSubscriptionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateSpotDatafeedSubscriptionInput");
        formatter.field("bucket", &self.bucket);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("prefix", &self.prefix);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateSnapshotsInput {
    /// <p> A description propagated to every snapshot specified by the instance.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The instance to specify which volumes should be included in the snapshots.</p>
    pub instance_specification: std::option::Option<crate::model::InstanceSpecification>,
    /// <p>The Amazon Resource Name (ARN) of the AWS Outpost on which to create the local  
    /// snapshots.</p>
    /// <ul>
    /// <li>
    /// <p>To create snapshots from an instance in a Region, omit this parameter. The
    /// snapshots are created in the same Region as the instance.</p>
    /// </li>
    /// <li>
    /// <p>To create snapshots from an instance on an Outpost and store the snapshots
    /// in the Region, omit this parameter. The snapshots are created in the Region
    /// for the Outpost.</p>
    /// </li>
    /// <li>
    /// <p>To create snapshots from an instance on an Outpost and store the snapshots
    /// on an Outpost, specify the ARN of the destination Outpost. The snapshots must
    /// be created on the same Outpost as the instance.</p>
    /// </li>
    /// </ul>
    /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#create-multivol-snapshot">
    /// Creating multi-volume local snapshots from instances on an Outpost</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub outpost_arn: std::option::Option<std::string::String>,
    /// <p>Tags to apply to every snapshot specified by the instance.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Copies the tags from the specified volume to corresponding snapshot.</p>
    pub copy_tags_from_source: std::option::Option<crate::model::CopyTagsFromSource>,
}
impl std::fmt::Debug for CreateSnapshotsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateSnapshotsInput");
        formatter.field("description", &self.description);
        formatter.field("instance_specification", &self.instance_specification);
        formatter.field("outpost_arn", &self.outpost_arn);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("copy_tags_from_source", &self.copy_tags_from_source);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateSnapshotInput {
    /// <p>A description for the snapshot.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the AWS Outpost on which to create a local  
    /// snapshot.</p>
    /// <ul>
    /// <li>
    /// <p>To create a snapshot of a volume in a Region, omit this parameter. The snapshot
    /// is created in the same Region as the volume.</p>
    /// </li>
    /// <li>
    /// <p>To create a snapshot of a volume on an Outpost and store the snapshot in the
    /// Region, omit this parameter. The snapshot is created in the Region for the
    /// Outpost.</p>
    /// </li>
    /// <li>
    /// <p>To create a snapshot of a volume on an Outpost and store the snapshot on an
    /// Outpost, specify the ARN of the destination Outpost. The snapshot must be created on
    /// the same Outpost as the volume.</p>
    /// </li>
    /// </ul>
    /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#create-snapshot">
    /// Creating local snapshots from volumes on an Outpost</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub outpost_arn: std::option::Option<std::string::String>,
    /// <p>The ID of the EBS volume.</p>
    pub volume_id: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the snapshot during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateSnapshotInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateSnapshotInput");
        formatter.field("description", &self.description);
        formatter.field("outpost_arn", &self.outpost_arn);
        formatter.field("volume_id", &self.volume_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateSecurityGroupInput {
    /// <p>A description for the security group. This is informational only.</p>
    /// <p>Constraints: Up to 255 characters in length</p>
    /// <p>Constraints for EC2-Classic: ASCII characters</p>
    /// <p>Constraints for EC2-VPC: a-z, A-Z, 0-9, spaces, and ._-:/()#,@[]+=&;{}!$*</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The name of the security group.</p>
    /// <p>Constraints: Up to 255 characters in length. Cannot start with
    /// <code>sg-</code>.</p>
    /// <p>Constraints for EC2-Classic: ASCII characters</p>
    /// <p>Constraints for EC2-VPC: a-z, A-Z, 0-9, spaces, and ._-:/()#,@[]+=&;{}!$*</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>[EC2-VPC] The ID of the VPC. Required for EC2-VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the security group.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateSecurityGroupInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateSecurityGroupInput");
        formatter.field("description", &self.description);
        formatter.field("group_name", &self.group_name);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateRouteTableInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the route table.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateRouteTableInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateRouteInput {
    /// <p>The IPv4 CIDR address block used for the destination match. Routing decisions are based on the most specific match. We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The IPv6 CIDR block used for the destination match. Routing decisions are based on the most specific match.</p>
    pub destination_ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of a prefix list used for the destination match.</p>
    pub destination_prefix_list_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of a VPC endpoint. Supported for Gateway Load Balancer endpoints only.</p>
    pub vpc_endpoint_id: std::option::Option<std::string::String>,
    /// <p>[IPv6 traffic only] The ID of an egress-only internet gateway.</p>
    pub egress_only_internet_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of an internet gateway or virtual private gateway attached to your
    /// VPC.</p>
    pub gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of a NAT instance in your VPC. The operation fails if you specify an instance ID unless exactly one network interface is attached.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>[IPv4 traffic only] The ID of a NAT gateway.</p>
    pub nat_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of a transit gateway.</p>
    pub transit_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the local gateway.</p>
    pub local_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the carrier gateway.</p>
    /// <p>You can only use this option when the VPC contains a subnet which is associated with a Wavelength Zone.</p>
    pub carrier_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of a network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The ID of the route table for the route.</p>
    pub route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of a VPC peering connection.</p>
    pub vpc_peering_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field(
            "destination_ipv6_cidr_block",
            &self.destination_ipv6_cidr_block,
        );
        formatter.field(
            "destination_prefix_list_id",
            &self.destination_prefix_list_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_endpoint_id", &self.vpc_endpoint_id);
        formatter.field(
            "egress_only_internet_gateway_id",
            &self.egress_only_internet_gateway_id,
        );
        formatter.field("gateway_id", &self.gateway_id);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("nat_gateway_id", &self.nat_gateway_id);
        formatter.field("transit_gateway_id", &self.transit_gateway_id);
        formatter.field("local_gateway_id", &self.local_gateway_id);
        formatter.field("carrier_gateway_id", &self.carrier_gateway_id);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.field("vpc_peering_connection_id", &self.vpc_peering_connection_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateRestoreImageTaskInput {
    /// <p>The name of the S3 bucket that contains the stored AMI object.</p>
    pub bucket: std::option::Option<std::string::String>,
    /// <p>The name of the stored AMI object in the bucket.</p>
    pub object_key: std::option::Option<std::string::String>,
    /// <p>The name for the restored AMI. The name must be unique for AMIs in the Region for this
    /// account. If you do not provide a name, the new AMI gets the same name as the original
    /// AMI.</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the AMI and snapshots on restoration. You can tag the AMI, the
    /// snapshots, or both.</p>
    /// <ul>
    /// <li>
    /// <p>To tag the AMI, the value for <code>ResourceType</code> must be <code>image</code>.</p>
    /// </li>
    /// <li>
    /// <p>To
    /// tag the snapshots, the value for <code>ResourceType</code> must be <code>snapshot</code>. The
    /// same tag is applied to all of the snapshots that are created.</p>
    /// </li>
    /// </ul>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateRestoreImageTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateRestoreImageTaskInput");
        formatter.field("bucket", &self.bucket);
        formatter.field("object_key", &self.object_key);
        formatter.field("name", &self.name);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateReservedInstancesListing.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateReservedInstancesListingInput {
    /// <p>Unique, case-sensitive identifier you provide to ensure idempotency of your
    /// listings. This helps avoid duplicate listings. For more information, see
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The number of instances that are a part of a Reserved Instance account to be listed in the Reserved Instance Marketplace. This number should be less than or equal to the instance count associated with the Reserved Instance ID specified in this call.</p>
    pub instance_count: std::option::Option<i32>,
    /// <p>A list specifying the price of the Standard Reserved Instance for each month remaining in the Reserved Instance term.</p>
    pub price_schedules:
        std::option::Option<std::vec::Vec<crate::model::PriceScheduleSpecification>>,
    /// <p>The ID of the active Standard Reserved Instance.</p>
    pub reserved_instances_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateReservedInstancesListingInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateReservedInstancesListingInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("instance_count", &self.instance_count);
        formatter.field("price_schedules", &self.price_schedules);
        formatter.field("reserved_instances_id", &self.reserved_instances_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateReplaceRootVolumeTaskInput {
    /// <p>The ID of the instance for which to replace the root volume.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The ID of the snapshot from which to restore the replacement root volume. If you want to
    /// restore the volume to the initial launch state, omit this parameter.</p>
    pub snapshot_id: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the request.
    /// If you do not specify a client token, a randomly generated token is used for the request
    /// to ensure idempotency. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tags to apply to the root volume replacement task.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateReplaceRootVolumeTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateReplaceRootVolumeTaskInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field("snapshot_id", &self.snapshot_id);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreatePlacementGroupInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>A name for the placement group. Must be unique within the scope of your account for
    /// the Region.</p>
    /// <p>Constraints: Up to 255 ASCII characters</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>The placement strategy.</p>
    pub strategy: std::option::Option<crate::model::PlacementStrategy>,
    /// <p>The number of partitions. Valid only when <b>Strategy</b> is
    /// set to <code>partition</code>.</p>
    pub partition_count: std::option::Option<i32>,
    /// <p>The tags to apply to the new placement group.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreatePlacementGroupInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreatePlacementGroupInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_name", &self.group_name);
        formatter.field("strategy", &self.strategy);
        formatter.field("partition_count", &self.partition_count);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateNetworkInterfacePermission.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateNetworkInterfacePermissionInput {
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The account ID.</p>
    pub aws_account_id: std::option::Option<std::string::String>,
    /// <p>The Amazon Web Service. Currently not supported.</p>
    pub aws_service: std::option::Option<std::string::String>,
    /// <p>The type of permission to grant.</p>
    pub permission: std::option::Option<crate::model::InterfacePermissionType>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateNetworkInterfacePermissionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateNetworkInterfacePermissionInput");
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("aws_account_id", &self.aws_account_id);
        formatter.field("aws_service", &self.aws_service);
        formatter.field("permission", &self.permission);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateNetworkInterface.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateNetworkInterfaceInput {
    /// <p>A description for the network interface.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of one or more security groups.</p>
    pub groups: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The number of IPv6 addresses to assign to a network interface. Amazon EC2
    /// automatically selects the IPv6 addresses from the subnet range. You can't use this
    /// option if specifying specific IPv6 addresses. If your subnet has the <code>AssignIpv6AddressOnCreation</code> attribute set
    /// to <code>true</code>, you can specify <code>0</code> to override this setting.</p>
    pub ipv6_address_count: std::option::Option<i32>,
    /// <p>One or more specific IPv6 addresses from the IPv6 CIDR block range of your subnet.
    /// You can't use this option if you're specifying a number of IPv6 addresses.</p>
    pub ipv6_addresses: std::option::Option<std::vec::Vec<crate::model::InstanceIpv6Address>>,
    /// <p>The primary private IPv4 address of the network interface. If you don't specify an
    /// IPv4 address, Amazon EC2 selects one for you from the subnet's IPv4 CIDR range. If you
    /// specify an IP address, you cannot indicate any IP addresses specified in
    /// <code>privateIpAddresses</code> as primary (only one IP address can be designated as
    /// primary).</p>
    pub private_ip_address: std::option::Option<std::string::String>,
    /// <p>One or more private IPv4 addresses.</p>
    pub private_ip_addresses:
        std::option::Option<std::vec::Vec<crate::model::PrivateIpAddressSpecification>>,
    /// <p>The number of secondary private IPv4 addresses to assign to a network interface. When
    /// you specify a number of secondary IPv4 addresses, Amazon EC2 selects these IP addresses
    /// within the subnet's IPv4 CIDR range. You can't specify this option and specify more than
    /// one private IP address using <code>privateIpAddresses</code>.</p>
    /// <p>The number of IP addresses you can assign to a network interface varies by instance
    /// type. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-eni.html#AvailableIpPerENI">IP Addresses Per ENI Per
    /// Instance Type</a> in the <i>Amazon Virtual Private Cloud User Guide</i>.</p>
    pub secondary_private_ip_address_count: std::option::Option<i32>,
    /// <p>Indicates the type of network interface. To create an Elastic Fabric Adapter (EFA), specify
    /// <code>efa</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html">
    /// Elastic Fabric Adapter</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>. To create a trunk network interface, specify
    /// <code>efa</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/eni-trunking.html">
    /// Network interface trunking</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub interface_type: std::option::Option<crate::model::NetworkInterfaceCreationType>,
    /// <p>The ID of the subnet to associate with the network interface.</p>
    pub subnet_id: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the new network interface.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateNetworkInterfaceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateNetworkInterfaceInput");
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("groups", &self.groups);
        formatter.field("ipv6_address_count", &self.ipv6_address_count);
        formatter.field("ipv6_addresses", &self.ipv6_addresses);
        formatter.field("private_ip_address", &self.private_ip_address);
        formatter.field("private_ip_addresses", &self.private_ip_addresses);
        formatter.field(
            "secondary_private_ip_address_count",
            &self.secondary_private_ip_address_count,
        );
        formatter.field("interface_type", &self.interface_type);
        formatter.field("subnet_id", &self.subnet_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateNetworkInsightsPathInput {
    /// <p>The IP address of the AWS resource that is the source of the path.</p>
    pub source_ip: std::option::Option<std::string::String>,
    /// <p>The IP address of the AWS resource that is the destination of the path.</p>
    pub destination_ip: std::option::Option<std::string::String>,
    /// <p>The AWS resource that is the source of the path.</p>
    pub source: std::option::Option<std::string::String>,
    /// <p>The AWS resource that is the destination of the path.</p>
    pub destination: std::option::Option<std::string::String>,
    /// <p>The protocol.</p>
    pub protocol: std::option::Option<crate::model::Protocol>,
    /// <p>The destination port.</p>
    pub destination_port: std::option::Option<i32>,
    /// <p>The tags to add to the path.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateNetworkInsightsPathInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateNetworkInsightsPathInput");
        formatter.field("source_ip", &self.source_ip);
        formatter.field("destination_ip", &self.destination_ip);
        formatter.field("source", &self.source);
        formatter.field("destination", &self.destination);
        formatter.field("protocol", &self.protocol);
        formatter.field("destination_port", &self.destination_port);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateNetworkAclEntryInput {
    /// <p>The IPv4 network range to allow or deny, in CIDR notation (for example
    /// <code>172.16.0.0/24</code>). We modify the specified CIDR block to its canonical form; for example, if you specify <code>100.68.0.18/18</code>, we modify it to <code>100.68.0.0/18</code>.</p>
    pub cidr_block: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Indicates whether this is an egress rule (rule is applied to traffic leaving the subnet).</p>
    pub egress: std::option::Option<bool>,
    /// <p>ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol
    /// 1 (ICMP) or protocol 58 (ICMPv6) with an IPv6 CIDR block.</p>
    pub icmp_type_code: std::option::Option<crate::model::IcmpTypeCode>,
    /// <p>The IPv6 network range to allow or deny, in CIDR notation (for example
    /// <code>2001:db8:1234:1a00::/64</code>).</p>
    pub ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the network ACL.</p>
    pub network_acl_id: std::option::Option<std::string::String>,
    /// <p>TCP or UDP protocols: The range of ports the rule applies to.
    /// Required if specifying protocol 6 (TCP) or 17 (UDP).</p>
    pub port_range: std::option::Option<crate::model::PortRange>,
    /// <p>The protocol number. A value of "-1" means all protocols. If you specify "-1" or a
    /// protocol number other than "6" (TCP), "17" (UDP), or "1" (ICMP), traffic on all ports is
    /// allowed, regardless of any ports or ICMP types or codes that you specify. If you specify
    /// protocol "58" (ICMPv6) and specify an IPv4 CIDR block, traffic for all ICMP types and
    /// codes allowed, regardless of any that you specify. If you specify protocol "58" (ICMPv6)
    /// and specify an IPv6 CIDR block, you must specify an ICMP type and code.</p>
    pub protocol: std::option::Option<std::string::String>,
    /// <p>Indicates whether to allow or deny the traffic that matches the rule.</p>
    pub rule_action: std::option::Option<crate::model::RuleAction>,
    /// <p>The rule number for the entry (for example, 100). ACL entries are processed in ascending order by rule number.</p>
    /// <p>Constraints: Positive integer from 1 to 32766. The range 32767 to 65535 is reserved for internal use.</p>
    pub rule_number: std::option::Option<i32>,
}
impl std::fmt::Debug for CreateNetworkAclEntryInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateNetworkAclEntryInput");
        formatter.field("cidr_block", &self.cidr_block);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("egress", &self.egress);
        formatter.field("icmp_type_code", &self.icmp_type_code);
        formatter.field("ipv6_cidr_block", &self.ipv6_cidr_block);
        formatter.field("network_acl_id", &self.network_acl_id);
        formatter.field("port_range", &self.port_range);
        formatter.field("protocol", &self.protocol);
        formatter.field("rule_action", &self.rule_action);
        formatter.field("rule_number", &self.rule_number);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateNetworkAclInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the network ACL.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateNetworkAclInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateNetworkAclInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateNatGatewayInput {
    /// <p>[Public NAT gateways only] The allocation ID of an Elastic IP address to associate
    /// with the NAT gateway. You cannot specify an Elastic IP address with a private NAT gateway.
    /// If the Elastic IP address is associated with another resource, you must first disassociate it.</p>
    pub allocation_id: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    /// <p>Constraint: Maximum 64 ASCII characters.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The subnet in which to create the NAT gateway.</p>
    pub subnet_id: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the NAT gateway.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Indicates whether the NAT gateway supports public or private connectivity.
    /// The default is public connectivity.</p>
    pub connectivity_type: std::option::Option<crate::model::ConnectivityType>,
}
impl std::fmt::Debug for CreateNatGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateNatGatewayInput");
        formatter.field("allocation_id", &self.allocation_id);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("subnet_id", &self.subnet_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("connectivity_type", &self.connectivity_type);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateManagedPrefixListInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>A name for the prefix list.</p>
    /// <p>Constraints: Up to 255 characters in length. The name cannot start with <code>com.amazonaws</code>.</p>
    pub prefix_list_name: std::option::Option<std::string::String>,
    /// <p>One or more entries for the prefix list.</p>
    pub entries: std::option::Option<std::vec::Vec<crate::model::AddPrefixListEntry>>,
    /// <p>The maximum number of entries for the prefix list.</p>
    pub max_entries: std::option::Option<i32>,
    /// <p>The tags to apply to the prefix list during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>The IP address type.</p>
    /// <p>Valid Values: <code>IPv4</code> | <code>IPv6</code>
    /// </p>
    pub address_family: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
    /// Idempotency</a>.</p>
    /// <p>Constraints: Up to 255 UTF-8 characters in length.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateManagedPrefixListInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateManagedPrefixListInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("prefix_list_name", &self.prefix_list_name);
        formatter.field("entries", &self.entries);
        formatter.field("max_entries", &self.max_entries);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("address_family", &self.address_family);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateLocalGatewayRouteTableVpcAssociationInput {
    /// <p>The ID of the local gateway route table.</p>
    pub local_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the local gateway route table VPC association.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateLocalGatewayRouteTableVpcAssociationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateLocalGatewayRouteTableVpcAssociationInput");
        formatter.field(
            "local_gateway_route_table_id",
            &self.local_gateway_route_table_id,
        );
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateLocalGatewayRouteInput {
    /// <p>The CIDR range used for destination matches. Routing decisions are based on
    /// the most specific match.</p>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the local gateway route table.</p>
    pub local_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the virtual interface group.</p>
    pub local_gateway_virtual_interface_group_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateLocalGatewayRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateLocalGatewayRouteInput");
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field(
            "local_gateway_route_table_id",
            &self.local_gateway_route_table_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.field(
            "local_gateway_virtual_interface_group_id",
            &self.local_gateway_virtual_interface_group_id,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateLaunchTemplateVersionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
    /// Idempotency</a>.</p>
    /// <p>Constraint: Maximum 128 ASCII characters.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The ID of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_id: std::option::Option<std::string::String>,
    /// <p>The name of the launch template. You must specify either the launch template ID or
    /// launch template name in the request.</p>
    pub launch_template_name: std::option::Option<std::string::String>,
    /// <p>The version number of the launch template version on which to base the new version.
    /// The new version inherits the same launch parameters as the source version, except for
    /// parameters that you specify in <code>LaunchTemplateData</code>. Snapshots applied
    /// to the block device mapping are ignored when creating a new version unless they
    /// are explicitly included.</p>
    pub source_version: std::option::Option<std::string::String>,
    /// <p>A description for the version of the launch template.</p>
    pub version_description: std::option::Option<std::string::String>,
    /// <p>The information for the launch template.</p>
    pub launch_template_data: std::option::Option<crate::model::RequestLaunchTemplateData>,
}
impl std::fmt::Debug for CreateLaunchTemplateVersionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateLaunchTemplateVersionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.field("launch_template_id", &self.launch_template_id);
        formatter.field("launch_template_name", &self.launch_template_name);
        formatter.field("source_version", &self.source_version);
        formatter.field("version_description", &self.version_description);
        formatter.field("launch_template_data", &self.launch_template_data);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateLaunchTemplateInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
    /// Idempotency</a>.</p>
    /// <p>Constraint: Maximum 128 ASCII characters.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>A name for the launch template.</p>
    pub launch_template_name: std::option::Option<std::string::String>,
    /// <p>A description for the first version of the launch template.</p>
    pub version_description: std::option::Option<std::string::String>,
    /// <p>The information for the launch template.</p>
    pub launch_template_data: std::option::Option<crate::model::RequestLaunchTemplateData>,
    /// <p>The tags to apply to the launch template during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateLaunchTemplateInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateLaunchTemplateInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.field("launch_template_name", &self.launch_template_name);
        formatter.field("version_description", &self.version_description);
        formatter.field("launch_template_data", &self.launch_template_data);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateKeyPairInput {
    /// <p>A unique name for the key pair.</p>
    /// <p>Constraints: Up to 255 ASCII characters</p>
    pub key_name: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tags to apply to the new key pair.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateKeyPairInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateKeyPairInput");
        formatter.field("key_name", &self.key_name);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateInternetGatewayInput {
    /// <p>The tags to assign to the internet gateway.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateInternetGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateInternetGatewayInput");
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateInstanceExportTaskInput {
    /// <p>A description for the conversion task or the resource being exported. The maximum length is 255 characters.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The format and location for an export instance task.</p>
    pub export_to_s3_task: std::option::Option<crate::model::ExportToS3TaskSpecification>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The target virtualization environment.</p>
    pub target_environment: std::option::Option<crate::model::ExportEnvironment>,
    /// <p>The tags to apply to the export instance task during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateInstanceExportTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateInstanceExportTaskInput");
        formatter.field("description", &self.description);
        formatter.field("export_to_s3_task", &self.export_to_s3_task);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("target_environment", &self.target_environment);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateImageInput {
    /// <p>The block device mappings. This parameter cannot be used to modify the encryption
    /// status of existing volumes or snapshots. To create an AMI with encrypted snapshots,
    /// use the <a>CopyImage</a> action.</p>
    pub block_device_mappings: std::option::Option<std::vec::Vec<crate::model::BlockDeviceMapping>>,
    /// <p>A description for the new image.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>A name for the new image.</p>
    /// <p>Constraints: 3-128 alphanumeric characters, parentheses (()), square brackets ([]), spaces ( ), periods (.), slashes (/), dashes (-), single quotes ('), at-signs (@), or underscores(_)</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>By default, Amazon EC2 attempts to shut down and reboot the instance before creating the image. If the <code>No Reboot</code> option is set, Amazon EC2 doesn't shut down the instance before creating the image. When this option is used, file system integrity on the created image can't be guaranteed.</p>
    pub no_reboot: std::option::Option<bool>,
    /// <p>The tags to apply to the AMI and snapshots on creation. You can tag the AMI, the
    /// snapshots, or both.</p>
    /// <ul>
    /// <li>
    /// <p>To tag the AMI, the value for <code>ResourceType</code> must be
    /// <code>image</code>.</p>
    /// </li>
    /// <li>
    /// <p>To tag the snapshots that are created of the root volume and of other EBS volumes that
    /// are attached to the instance, the value for <code>ResourceType</code> must be
    /// <code>snapshot</code>. The same tag is applied to all of the snapshots that are
    /// created.</p>
    /// </li>
    /// </ul>
    /// <p>If you specify other values for <code>ResourceType</code>, the request fails.</p>
    /// <p>To tag an AMI or snapshot after it has been created, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html">CreateTags</a>. </p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateImageInput");
        formatter.field("block_device_mappings", &self.block_device_mappings);
        formatter.field("description", &self.description);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("name", &self.name);
        formatter.field("no_reboot", &self.no_reboot);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateFpgaImageInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The location of the encrypted design checkpoint in Amazon S3. The input must be a tarball.</p>
    pub input_storage_location: std::option::Option<crate::model::StorageLocation>,
    /// <p>The location in Amazon S3 for the output logs.</p>
    pub logs_storage_location: std::option::Option<crate::model::StorageLocation>,
    /// <p>A description for the AFI.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>A name for the AFI.</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
    /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the FPGA image during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateFpgaImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateFpgaImageInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("input_storage_location", &self.input_storage_location);
        formatter.field("logs_storage_location", &self.logs_storage_location);
        formatter.field("description", &self.description);
        formatter.field("name", &self.name);
        formatter.field("client_token", &self.client_token);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateFlowLogsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The ARN for the IAM role that permits Amazon EC2 to publish flow logs to a CloudWatch Logs log group
    /// in your account.</p>
    /// <p>If you specify <code>LogDestinationType</code> as <code>s3</code>, do not specify
    /// <code>DeliverLogsPermissionArn</code> or <code>LogGroupName</code>.</p>
    pub deliver_logs_permission_arn: std::option::Option<std::string::String>,
    /// <p>The name of a new or existing CloudWatch Logs log group where Amazon EC2 publishes your flow logs.</p>
    /// <p>If you specify <code>LogDestinationType</code> as <code>s3</code>, do not specify
    /// <code>DeliverLogsPermissionArn</code> or <code>LogGroupName</code>.</p>
    pub log_group_name: std::option::Option<std::string::String>,
    /// <p>The ID of the subnet, network interface, or VPC for which you want to create a flow log.</p>
    /// <p>Constraints: Maximum of 1000 resources</p>
    pub resource_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The type of resource for which to create the flow log. For example, if you specified a VPC ID for
    /// the <code>ResourceId</code> property, specify <code>VPC</code> for this property.</p>
    pub resource_type: std::option::Option<crate::model::FlowLogsResourceType>,
    /// <p>The type of traffic to log. You can log traffic that the resource accepts or rejects, or all traffic.</p>
    pub traffic_type: std::option::Option<crate::model::TrafficType>,
    /// <p>Specifies the type of destination to which the flow log data is to be published. Flow log data can be
    /// published to CloudWatch Logs or Amazon S3. To publish flow log data to CloudWatch Logs, specify <code>cloud-watch-logs</code>. To
    /// publish flow log data to Amazon S3, specify <code>s3</code>.</p>
    /// <p>If you specify <code>LogDestinationType</code> as <code>s3</code>, do not specify
    /// <code>DeliverLogsPermissionArn</code> or <code>LogGroupName</code>.</p>
    /// <p>Default: <code>cloud-watch-logs</code>
    /// </p>
    pub log_destination_type: std::option::Option<crate::model::LogDestinationType>,
    /// <p>Specifies the destination to which the flow log data is to be published. Flow log data can be published
    /// to a CloudWatch Logs log group or an Amazon S3 bucket. The value specified for this parameter depends on the value specified
    /// for <code>LogDestinationType</code>.</p>
    /// <p>If <code>LogDestinationType</code> is not specified or <code>cloud-watch-logs</code>,
    /// specify the Amazon Resource Name (ARN) of the CloudWatch Logs log group. For example, to publish
    /// to a log group called <code>my-logs</code>, specify
    /// <code>arn:aws:logs:us-east-1:123456789012:log-group:my-logs</code>. Alternatively,
    /// use <code>LogGroupName</code> instead.</p>
    /// <p>If LogDestinationType is <code>s3</code>, specify the ARN of the Amazon S3 bucket. You can also specify a
    /// subfolder in the bucket. To specify a subfolder in the bucket, use the following  ARN format:
    /// <code>bucket_ARN/subfolder_name/</code>. For example, to specify a subfolder named <code>my-logs</code> in a
    /// bucket named <code>my-bucket</code>, use the following ARN: <code>arn:aws:s3:::my-bucket/my-logs/</code>. You
    /// cannot use <code>AWSLogs</code> as a subfolder name. This is a reserved term.</p>
    pub log_destination: std::option::Option<std::string::String>,
    /// <p>The fields to include in the flow log record, in the order in which they should
    /// appear. For a list of available fields, see <a href="https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs.html#flow-log-records">Flow Log Records</a>. If you
    /// omit this parameter, the flow log is created using the default format. If you specify this parameter, you must specify at least one field.</p>
    /// <p>Specify the fields using the <code>${field-id}</code> format, separated by spaces. For
    /// the AWS CLI, use single quotation marks (' ') to surround the parameter value.</p>
    pub log_format: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the flow logs.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record. You can specify 60 seconds (1 minute) or 600 seconds (10 minutes).</p>
    /// <p>When a network interface is attached to a <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html#ec2-nitro-instances">Nitro-based
    /// instance</a>, the aggregation interval is always 60 seconds or less, regardless
    /// of the value that you specify.</p>
    /// <p>Default: 600</p>
    pub max_aggregation_interval: std::option::Option<i32>,
}
impl std::fmt::Debug for CreateFlowLogsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateFlowLogsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.field(
            "deliver_logs_permission_arn",
            &self.deliver_logs_permission_arn,
        );
        formatter.field("log_group_name", &self.log_group_name);
        formatter.field("resource_ids", &self.resource_ids);
        formatter.field("resource_type", &self.resource_type);
        formatter.field("traffic_type", &self.traffic_type);
        formatter.field("log_destination_type", &self.log_destination_type);
        formatter.field("log_destination", &self.log_destination);
        formatter.field("log_format", &self.log_format);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("max_aggregation_interval", &self.max_aggregation_interval);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateFleetInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Describes the configuration of Spot Instances in an EC2 Fleet.</p>
    pub spot_options: std::option::Option<crate::model::SpotOptionsRequest>,
    /// <p>Describes the configuration of On-Demand Instances in an EC2 Fleet.</p>
    pub on_demand_options: std::option::Option<crate::model::OnDemandOptionsRequest>,
    /// <p>Indicates whether running instances should be terminated if the total target capacity of
    /// the EC2 Fleet is decreased below the current size of the EC2 Fleet.</p>
    pub excess_capacity_termination_policy:
        std::option::Option<crate::model::FleetExcessCapacityTerminationPolicy>,
    /// <p>The configuration for the EC2 Fleet.</p>
    pub launch_template_configs:
        std::option::Option<std::vec::Vec<crate::model::FleetLaunchTemplateConfigRequest>>,
    /// <p>The number of units to request.</p>
    pub target_capacity_specification:
        std::option::Option<crate::model::TargetCapacitySpecificationRequest>,
    /// <p>Indicates whether running instances should be terminated when the EC2 Fleet expires.</p>
    pub terminate_instances_with_expiration: std::option::Option<bool>,
    /// <p>The fleet type. The default value is <code>maintain</code>.</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>maintain</code> - The EC2 Fleet places an asynchronous request for your desired
    /// capacity, and continues to maintain your desired Spot capacity by replenishing
    /// interrupted Spot Instances.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>request</code> - The EC2 Fleet places an asynchronous one-time request for your
    /// desired capacity, but does submit Spot requests in alternative capacity pools if Spot
    /// capacity is unavailable, and does not maintain Spot capacity if Spot Instances are
    /// interrupted.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>instant</code> - The EC2 Fleet places a synchronous one-time request for your
    /// desired capacity, and returns errors for any instances that could not be
    /// launched.</p>
    /// </li>
    /// </ul>
    /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-fleet-configuration-strategies.html#ec2-fleet-request-type">EC2 Fleet
    /// request types</a> in the <i>Amazon EC2 User Guide</i>.</p>
    pub r#type: std::option::Option<crate::model::FleetType>,
    /// <p>The start date and time of the request, in UTC format (for example,
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).
    /// The default is to start fulfilling the request immediately.</p>
    pub valid_from: std::option::Option<smithy_types::Instant>,
    /// <p>The end date and time of the request, in UTC format (for example,
    /// <i>YYYY</i>-<i>MM</i>-<i>DD</i>T<i>HH</i>:<i>MM</i>:<i>SS</i>Z).
    /// At this point, no new EC2 Fleet requests are placed or able to fulfill the request. If no value is specified, the request remains until you cancel it.</p>
    pub valid_until: std::option::Option<smithy_types::Instant>,
    /// <p>Indicates whether EC2 Fleet should replace unhealthy Spot Instances. Supported only for
    /// fleets of type <code>maintain</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/manage-ec2-fleet.html#ec2-fleet-health-checks">EC2 Fleet
    /// health checks</a> in the <i>Amazon EC2 User Guide</i>.</p>
    pub replace_unhealthy_instances: std::option::Option<bool>,
    /// <p>The key-value pair for tagging the EC2 Fleet request on creation. For more information, see
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Using_Tags.html#tag-resources">Tagging your resources</a>.</p>
    /// <p>If the fleet type is <code>instant</code>, specify a resource type of <code>fleet</code>
    /// to tag the fleet or <code>instance</code> to tag the instances at launch.</p>
    /// <p>If the fleet type is <code>maintain</code> or <code>request</code>, specify a resource
    /// type of <code>fleet</code> to tag the fleet. You cannot specify a resource type of
    /// <code>instance</code>. To tag instances at launch, specify the tags in a <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-launch-templates.html#create-launch-template">launch template</a>.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Reserved.</p>
    pub context: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateFleetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateFleetInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.field("spot_options", &self.spot_options);
        formatter.field("on_demand_options", &self.on_demand_options);
        formatter.field(
            "excess_capacity_termination_policy",
            &self.excess_capacity_termination_policy,
        );
        formatter.field("launch_template_configs", &self.launch_template_configs);
        formatter.field(
            "target_capacity_specification",
            &self.target_capacity_specification,
        );
        formatter.field(
            "terminate_instances_with_expiration",
            &self.terminate_instances_with_expiration,
        );
        formatter.field("r#type", &self.r#type);
        formatter.field("valid_from", &self.valid_from);
        formatter.field("valid_until", &self.valid_until);
        formatter.field(
            "replace_unhealthy_instances",
            &self.replace_unhealthy_instances,
        );
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("context", &self.context);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateEgressOnlyInternetGatewayInput {
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC for which to create the egress-only internet gateway.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the egress-only internet gateway.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for CreateEgressOnlyInternetGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateEgressOnlyInternetGatewayInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateDhcpOptionsInput {
    /// <p>A DHCP configuration option.</p>
    pub dhcp_configurations: std::option::Option<std::vec::Vec<crate::model::NewDhcpConfiguration>>,
    /// <p>The tags to assign to the DHCP option.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateDhcpOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateDhcpOptionsInput");
        formatter.field("dhcp_configurations", &self.dhcp_configurations);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateDefaultVpcInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateDefaultVpcInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateDefaultVpcInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateDefaultSubnetInput {
    /// <p>The Availability Zone in which to create the default subnet.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateDefaultSubnetInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateDefaultSubnetInput");
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CreateCustomerGateway.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateCustomerGatewayInput {
    /// <p>For devices that support BGP, the customer gateway's BGP ASN.</p>
    /// <p>Default: 65000</p>
    pub bgp_asn: std::option::Option<i32>,
    /// <p>The Internet-routable IP address for the customer gateway's outside interface. The address must be static.</p>
    pub public_ip: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) for the customer gateway certificate.</p>
    pub certificate_arn: std::option::Option<std::string::String>,
    /// <p>The type of VPN connection that this customer gateway supports (<code>ipsec.1</code>).</p>
    pub r#type: std::option::Option<crate::model::GatewayType>,
    /// <p>The tags to apply to the customer gateway.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>A name for the customer gateway device.</p>
    /// <p>Length Constraints: Up to 255 characters.</p>
    pub device_name: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateCustomerGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateCustomerGatewayInput");
        formatter.field("bgp_asn", &self.bgp_asn);
        formatter.field("public_ip", &self.public_ip);
        formatter.field("certificate_arn", &self.certificate_arn);
        formatter.field("r#type", &self.r#type);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("device_name", &self.device_name);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateClientVpnRouteInput {
    /// <p>The ID of the Client VPN endpoint to which to add the route.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The IPv4 address range, in CIDR notation, of the route destination. For example:</p>
    /// <ul>
    /// <li>
    /// <p>To add a route for Internet access, enter <code>0.0.0.0/0</code>
    /// </p>
    /// </li>
    /// <li>
    /// <p>To add a route for a peered VPC, enter the peered VPC's IPv4 CIDR range</p>
    /// </li>
    /// <li>
    /// <p>To add a route for an on-premises network, enter the AWS Site-to-Site VPN connection's IPv4 CIDR range</p>
    /// </li>
    /// <li>
    /// <p>To add a route for the local network, enter the client CIDR range</p>
    /// </li>
    /// </ul>
    pub destination_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the subnet through which you want to route traffic. The specified subnet must be
    /// an existing target network of the Client VPN endpoint.</p>
    /// <p>Alternatively, if you're adding a route for the local network, specify <code>local</code>.</p>
    pub target_vpc_subnet_id: std::option::Option<std::string::String>,
    /// <p>A brief description of the route.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CreateClientVpnRouteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateClientVpnRouteInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("destination_cidr_block", &self.destination_cidr_block);
        formatter.field("target_vpc_subnet_id", &self.target_vpc_subnet_id);
        formatter.field("description", &self.description);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateClientVpnEndpointInput {
    /// <p>The IPv4 address range, in CIDR notation, from which to assign client IP addresses. The address range cannot overlap with the local CIDR of the VPC in which the associated subnet is located, or the routes that you add manually. The address range cannot be changed after the Client VPN endpoint has been created. The CIDR block should be /22 or greater.</p>
    pub client_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ARN of the server certificate. For more information, see
    /// the <a href="https://docs.aws.amazon.com/acm/latest/userguide/">AWS Certificate Manager User Guide</a>.</p>
    pub server_certificate_arn: std::option::Option<std::string::String>,
    /// <p>Information about the authentication method to be used to authenticate clients.</p>
    pub authentication_options:
        std::option::Option<std::vec::Vec<crate::model::ClientVpnAuthenticationRequest>>,
    /// <p>Information about the client connection logging options.</p>
    /// <p>If you enable client connection logging, data about client connections is sent to a
    /// Cloudwatch Logs log stream. The following information is logged:</p>
    /// <ul>
    /// <li>
    /// <p>Client connection requests</p>
    /// </li>
    /// <li>
    /// <p>Client connection results (successful and unsuccessful)</p>
    /// </li>
    /// <li>
    /// <p>Reasons for unsuccessful client connection requests</p>
    /// </li>
    /// <li>
    /// <p>Client connection termination time</p>
    /// </li>
    /// </ul>
    pub connection_log_options: std::option::Option<crate::model::ConnectionLogOptions>,
    /// <p>Information about the DNS servers to be used for DNS resolution. A Client VPN endpoint can
    /// have up to two DNS servers. If no DNS server is specified, the DNS address configured on the device is used for the DNS server.</p>
    pub dns_servers: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The transport protocol to be used by the VPN session.</p>
    /// <p>Default value: <code>udp</code>
    /// </p>
    pub transport_protocol: std::option::Option<crate::model::TransportProtocol>,
    /// <p>The port number to assign to the Client VPN endpoint for TCP and UDP traffic.</p>
    /// <p>Valid Values: <code>443</code> | <code>1194</code>
    /// </p>
    /// <p>Default Value: <code>443</code>
    /// </p>
    pub vpn_port: std::option::Option<i32>,
    /// <p>A brief description of the Client VPN endpoint.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Indicates whether split-tunnel is enabled on the AWS Client VPN endpoint.</p>
    /// <p>By default, split-tunnel on a VPN endpoint is disabled.</p>
    /// <p>For information about split-tunnel VPN endpoints, see <a href="https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/split-tunnel-vpn.html">Split-Tunnel AWS Client VPN Endpoint</a> in the <i>AWS
    /// Client VPN Administrator Guide</i>.</p>
    pub split_tunnel: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the Client VPN endpoint during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>The IDs of one or more security groups to apply to the target network. You must also specify the ID of the VPC that contains the security groups.</p>
    pub security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of the VPC to associate with the Client VPN endpoint. If no security group IDs are specified in the request, the default security group for the VPC is applied.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>Specify whether to enable the self-service portal for the Client VPN endpoint.</p>
    /// <p>Default Value: <code>enabled</code>
    /// </p>
    pub self_service_portal: std::option::Option<crate::model::SelfServicePortal>,
    /// <p>The options for managing connection authorization for new client connections.</p>
    pub client_connect_options: std::option::Option<crate::model::ClientConnectOptions>,
}
impl std::fmt::Debug for CreateClientVpnEndpointInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateClientVpnEndpointInput");
        formatter.field("client_cidr_block", &self.client_cidr_block);
        formatter.field("server_certificate_arn", &self.server_certificate_arn);
        formatter.field("authentication_options", &self.authentication_options);
        formatter.field("connection_log_options", &self.connection_log_options);
        formatter.field("dns_servers", &self.dns_servers);
        formatter.field("transport_protocol", &self.transport_protocol);
        formatter.field("vpn_port", &self.vpn_port);
        formatter.field("description", &self.description);
        formatter.field("split_tunnel", &self.split_tunnel);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("security_group_ids", &self.security_group_ids);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("self_service_portal", &self.self_service_portal);
        formatter.field("client_connect_options", &self.client_connect_options);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateCarrierGatewayInput {
    /// <p>The ID of the VPC to associate with the carrier gateway.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The tags to associate with the carrier gateway.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateCarrierGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateCarrierGatewayInput");
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CreateCapacityReservationInput {
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>The instance type for which to reserve capacity. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html">Instance types</a> in the <i>Amazon EC2 User Guide</i>.</p>
    pub instance_type: std::option::Option<std::string::String>,
    /// <p>The type of operating system for which to reserve capacity.</p>
    pub instance_platform: std::option::Option<crate::model::CapacityReservationInstancePlatform>,
    /// <p>The Availability Zone in which to create the Capacity Reservation.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>The ID of the Availability Zone in which to create the Capacity Reservation.</p>
    pub availability_zone_id: std::option::Option<std::string::String>,
    /// <p>Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of the following tenancy settings:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>default</code> - The Capacity Reservation is created on hardware that is shared with other accounts.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>dedicated</code> - The Capacity Reservation is created on single-tenant hardware that is dedicated to a single account.</p>
    /// </li>
    /// </ul>
    pub tenancy: std::option::Option<crate::model::CapacityReservationTenancy>,
    /// <p>The number of instances for which to reserve capacity.</p>
    pub instance_count: std::option::Option<i32>,
    /// <p>Indicates whether the Capacity Reservation supports EBS-optimized instances. This optimization provides
    /// dedicated throughput to Amazon EBS and an optimized configuration stack to provide
    /// optimal I/O performance. This optimization isn't available with all instance types.
    /// Additional usage charges apply when using an EBS- optimized instance.</p>
    pub ebs_optimized: std::option::Option<bool>,
    /// <p>Indicates whether the Capacity Reservation supports instances with temporary, block-level
    /// storage.</p>
    pub ephemeral_storage: std::option::Option<bool>,
    /// <p>The date and time at which the Capacity Reservation expires. When a Capacity Reservation expires, the reserved capacity
    /// is released and you can no longer launch instances into it. The Capacity Reservation's state changes to
    /// <code>expired</code> when it reaches its end date and time.</p>  
    /// <p>You must provide an <code>EndDate</code> value if <code>EndDateType</code> is
    /// <code>limited</code>. Omit <code>EndDate</code> if <code>EndDateType</code> is
    /// <code>unlimited</code>.</p>
    /// <p>If the <code>EndDateType</code> is <code>limited</code>, the Capacity Reservation is cancelled within an hour from the specified time. For example, if you specify
    /// 5/31/2019, 13:30:55, the Capacity Reservation is guaranteed to end between 13:30:55 and 14:30:55 on 5/31/2019.</p>
    pub end_date: std::option::Option<smithy_types::Instant>,
    /// <p>Indicates the way in which the Capacity Reservation ends. A Capacity Reservation can have one of the following end
    /// types:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>unlimited</code> - The Capacity Reservation remains active until you explicitly cancel it. Do not
    /// provide an <code>EndDate</code> if the <code>EndDateType</code> is
    /// <code>unlimited</code>.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>limited</code> - The Capacity Reservation expires automatically at a specified date and time. You must
    /// provide an <code>EndDate</code> value if the <code>EndDateType</code> value is
    /// <code>limited</code>.</p>
    /// </li>
    /// </ul>
    pub end_date_type: std::option::Option<crate::model::EndDateType>,
    /// <p>Indicates the type of instance launches that the Capacity Reservation accepts. The options
    /// include:</p>
    /// <ul>
    /// <li>
    /// <p>
    /// <code>open</code> - The Capacity Reservation automatically matches all instances that have matching attributes (instance type, platform,
    /// and Availability Zone). Instances that have matching attributes run in the Capacity Reservation automatically without specifying
    /// any additional parameters.</p>
    /// </li>
    /// <li>
    /// <p>
    /// <code>targeted</code> - The Capacity Reservation only accepts instances that have matching attributes
    /// (instance type, platform, and Availability Zone), and explicitly target the
    /// Capacity Reservation. This ensures that only permitted instances can use the reserved capacity. </p>
    /// </li>
    /// </ul>
    /// <p>Default: <code>open</code>
    /// </p>
    pub instance_match_criteria: std::option::Option<crate::model::InstanceMatchCriteria>,
    /// <p>The tags to apply to the Capacity Reservation during launch.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The Amazon Resource Name (ARN) of the Outpost on which to create the Capacity Reservation.</p>
    pub outpost_arn: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CreateCapacityReservationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CreateCapacityReservationInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("instance_type", &self.instance_type);
        formatter.field("instance_platform", &self.instance_platform);
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("availability_zone_id", &self.availability_zone_id);
        formatter.field("tenancy", &self.tenancy);
        formatter.field("instance_count", &self.instance_count);
        formatter.field("ebs_optimized", &self.ebs_optimized);
        formatter.field("ephemeral_storage", &self.ephemeral_storage);
        formatter.field("end_date", &self.end_date);
        formatter.field("end_date_type", &self.end_date_type);
        formatter.field("instance_match_criteria", &self.instance_match_criteria);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("outpost_arn", &self.outpost_arn);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CopySnapshotInput {
    /// <p>A description for the EBS snapshot.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the Outpost to which to copy the snapshot. Only
    /// specify this parameter when copying a snapshot from an AWS Region to an Outpost.
    /// The snapshot must be in the Region for the destination Outpost. You cannot copy a
    /// snapshot from an Outpost to a Region, from one Outpost to another, or within the same
    /// Outpost.</p>
    /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#copy-snapshots">
    /// Copying snapshots from an AWS Region to an Outpost</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub destination_outpost_arn: std::option::Option<std::string::String>,
    /// <p>The destination Region to use in the <code>PresignedUrl</code> parameter of a snapshot
    /// copy operation. This parameter is only valid for specifying the destination Region in a
    /// <code>PresignedUrl</code> parameter, where it is required.</p>
    /// <p>The snapshot copy is sent to the regional endpoint that you sent the HTTP
    /// request to (for example, <code>ec2.us-east-1.amazonaws.com</code>). With the AWS CLI, this is
    /// specified using the <code>--region</code> parameter or the default Region in your AWS
    /// configuration file.</p>
    pub destination_region: std::option::Option<std::string::String>,
    /// <p>To encrypt a copy of an unencrypted snapshot if encryption by default is not enabled,
    /// enable encryption using this parameter. Otherwise, omit this parameter. Encrypted snapshots
    /// are encrypted, even if you omit this parameter and encryption by default is not enabled. You
    /// cannot set this parameter to false. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS encryption</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub encrypted: std::option::Option<bool>,
    /// <p>The identifier of the AWS Key Management Service (AWS KMS) customer master key (CMK) to use for Amazon EBS encryption.
    /// If this parameter is not specified, your AWS managed CMK for EBS is used. If <code>KmsKeyId</code> is
    /// specified, the encrypted state must be <code>true</code>.</p>
    /// <p>You can specify the CMK using any of the following:</p>
    /// <ul>
    /// <li>
    /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Key alias. For example, alias/ExampleAlias.</p>
    /// </li>
    /// <li>
    /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
    /// </li>
    /// </ul>
    /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an ID, alias, or ARN that is not valid,
    /// the action can appear to complete, but eventually fails.</p>
    pub kms_key_id: std::option::Option<std::string::String>,
    /// <p>When you copy an encrypted source snapshot using the Amazon EC2 Query API, you must supply a
    /// pre-signed URL. This parameter is optional for unencrypted snapshots. For more information,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Query-Requests.html">Query
    /// requests</a>.</p>
    /// <p>The <code>PresignedUrl</code> should use the snapshot source endpoint, the
    /// <code>CopySnapshot</code> action, and include the <code>SourceRegion</code>,
    /// <code>SourceSnapshotId</code>, and <code>DestinationRegion</code> parameters. The
    /// <code>PresignedUrl</code> must be signed using AWS Signature Version 4. Because EBS
    /// snapshots are stored in Amazon S3, the signing algorithm for this parameter uses the same logic
    /// that is described in <a href="https://docs.aws.amazon.com/AmazonS3/latest/API/sigv4-query-string-auth.html">Authenticating Requests: Using Query
    /// Parameters (AWS Signature Version 4)</a> in the <i>Amazon Simple Storage Service API Reference</i>. An
    /// invalid or improperly signed <code>PresignedUrl</code> will cause the copy operation to fail
    /// asynchronously, and the snapshot will move to an <code>error</code> state.</p>
    pub presigned_url: std::option::Option<std::string::String>,
    /// <p>The ID of the Region that contains the snapshot to be copied.</p>
    pub source_region: std::option::Option<std::string::String>,
    /// <p>The ID of the EBS snapshot to copy.</p>
    pub source_snapshot_id: std::option::Option<std::string::String>,
    /// <p>The tags to apply to the new snapshot.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CopySnapshotInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CopySnapshotInput");
        formatter.field("description", &self.description);
        formatter.field("destination_outpost_arn", &self.destination_outpost_arn);
        formatter.field("destination_region", &self.destination_region);
        formatter.field("encrypted", &self.encrypted);
        formatter.field("kms_key_id", &self.kms_key_id);
        formatter.field("presigned_url", &self.presigned_url);
        formatter.field("source_region", &self.source_region);
        formatter.field("source_snapshot_id", &self.source_snapshot_id);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CopyImage.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CopyImageInput {
    /// <p>Unique, case-sensitive identifier you provide to ensure
    /// idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring idempotency</a>
    /// in the <i>Amazon EC2 API Reference</i>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>A description for the new AMI in the destination Region.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Specifies whether the destination snapshots of the copied image should be encrypted.
    /// You can encrypt a copy of an unencrypted snapshot, but you cannot create an unencrypted
    /// copy of an encrypted snapshot. The default CMK for EBS is used unless you specify a non-default
    /// AWS Key Management Service (AWS KMS) CMK using <code>KmsKeyId</code>. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html">Amazon EBS Encryption</a> in the <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub encrypted: std::option::Option<bool>,
    /// <p>The identifier of the symmetric AWS Key Management Service (AWS KMS) customer master key (CMK) to use when creating
    /// encrypted volumes. If this parameter is not specified, your AWS managed CMK for EBS is used.
    /// If you specify a CMK, you must also set the encrypted state to <code>true</code>.</p>
    /// <p>You can specify a CMK using any of the following:</p>
    /// <ul>
    /// <li>
    /// <p>Key ID. For example, 1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Key alias. For example, alias/ExampleAlias.</p>
    /// </li>
    /// <li>
    /// <p>Key ARN. For example, arn:aws:kms:us-east-1:012345678910:key/1234abcd-12ab-34cd-56ef-1234567890ab.</p>
    /// </li>
    /// <li>
    /// <p>Alias ARN. For example, arn:aws:kms:us-east-1:012345678910:alias/ExampleAlias.</p>
    /// </li>
    /// </ul>
    /// <p>AWS authenticates the CMK asynchronously. Therefore, if you specify an identifier that is not valid,
    /// the action can appear to complete, but eventually fails.</p>
    /// <p>The specified CMK must exist in the destination Region.</p>
    /// <p>Amazon EBS does not support asymmetric CMKs.</p>
    pub kms_key_id: std::option::Option<std::string::String>,
    /// <p>The name of the new AMI in the destination Region.</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>The ID of the AMI to copy.</p>
    pub source_image_id: std::option::Option<std::string::String>,
    /// <p>The name of the Region that contains the AMI to copy.</p>
    pub source_region: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the Outpost to which to copy the AMI. Only
    /// specify this parameter when copying an AMI from an AWS Region to an Outpost.
    /// The AMI must be in the Region of the destination Outpost. You cannot copy an
    /// AMI from an Outpost to a Region, from one Outpost to another, or within the same
    /// Outpost.</p>
    /// <p>For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/snapshots-outposts.html#copy-amis">
    /// Copying AMIs from an AWS Region to an Outpost</a> in the
    /// <i>Amazon Elastic Compute Cloud User Guide</i>.</p>
    pub destination_outpost_arn: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CopyImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CopyImageInput");
        formatter.field("client_token", &self.client_token);
        formatter.field("description", &self.description);
        formatter.field("encrypted", &self.encrypted);
        formatter.field("kms_key_id", &self.kms_key_id);
        formatter.field("name", &self.name);
        formatter.field("source_image_id", &self.source_image_id);
        formatter.field("source_region", &self.source_region);
        formatter.field("destination_outpost_arn", &self.destination_outpost_arn);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CopyFpgaImageInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the source AFI.</p>
    pub source_fpga_image_id: std::option::Option<std::string::String>,
    /// <p>The description for the new AFI.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>The name for the new AFI. The default is the name of the source AFI.</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>The Region that contains the source AFI.</p>
    pub source_region: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
    /// For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CopyFpgaImageInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CopyFpgaImageInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("source_fpga_image_id", &self.source_fpga_image_id);
        formatter.field("description", &self.description);
        formatter.field("name", &self.name);
        formatter.field("source_region", &self.source_region);
        formatter.field("client_token", &self.client_token);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ConfirmProductInstanceInput {
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The product code. This must be a product code that you own.</p>
    pub product_code: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ConfirmProductInstanceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ConfirmProductInstanceInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field("product_code", &self.product_code);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CancelSpotInstanceRequests.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelSpotInstanceRequestsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>One or more Spot Instance request IDs.</p>
    pub spot_instance_request_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for CancelSpotInstanceRequestsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelSpotInstanceRequestsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("spot_instance_request_ids", &self.spot_instance_request_ids);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CancelSpotFleetRequests.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelSpotFleetRequestsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually
    /// making the request, and provides an error response. If you have the required
    /// permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is
    /// <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the Spot Fleet requests.</p>
    pub spot_fleet_request_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Indicates whether to terminate instances for a Spot Fleet request if it is canceled
    /// successfully.</p>
    pub terminate_instances: std::option::Option<bool>,
}
impl std::fmt::Debug for CancelSpotFleetRequestsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelSpotFleetRequestsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("spot_fleet_request_ids", &self.spot_fleet_request_ids);
        formatter.field("terminate_instances", &self.terminate_instances);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CancelReservedInstancesListing.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelReservedInstancesListingInput {
    /// <p>The ID of the Reserved Instance listing.</p>
    pub reserved_instances_listing_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CancelReservedInstancesListingInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelReservedInstancesListingInput");
        formatter.field(
            "reserved_instances_listing_id",
            &self.reserved_instances_listing_id,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelImportTaskInput {
    /// <p>The reason for canceling the task.</p>
    pub cancel_reason: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the import image or import snapshot task to be canceled.</p>
    pub import_task_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CancelImportTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelImportTaskInput");
        formatter.field("cancel_reason", &self.cancel_reason);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("import_task_id", &self.import_task_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelExportTaskInput {
    /// <p>The ID of the export task. This is the ID returned by <code>CreateInstanceExportTask</code>.</p>
    pub export_task_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CancelExportTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelExportTaskInput");
        formatter.field("export_task_id", &self.export_task_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelConversionTaskInput {
    /// <p>The ID of the conversion task.</p>
    pub conversion_task_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The reason for canceling the conversion task.</p>
    pub reason_message: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for CancelConversionTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelConversionTaskInput");
        formatter.field("conversion_task_id", &self.conversion_task_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("reason_message", &self.reason_message);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelCapacityReservationInput {
    /// <p>The ID of the Capacity Reservation to be cancelled.</p>
    pub capacity_reservation_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CancelCapacityReservationInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelCapacityReservationInput");
        formatter.field("capacity_reservation_id", &self.capacity_reservation_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for CancelBundleTask.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CancelBundleTaskInput {
    /// <p>The ID of the bundle task.</p>
    pub bundle_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for CancelBundleTaskInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CancelBundleTaskInput");
        formatter.field("bundle_id", &self.bundle_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for BundleInstance.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct BundleInstanceInput {
    /// <p>The ID of the instance to bundle.</p>
    /// <p>Type: String</p>
    /// <p>Default: None</p>
    /// <p>Required: Yes</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The bucket in which to store the AMI. You can specify a bucket that you already own or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to someone else, Amazon EC2 returns an error.</p>
    pub storage: std::option::Option<crate::model::Storage>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for BundleInstanceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("BundleInstanceInput");
        formatter.field("instance_id", &self.instance_id);
        formatter.field("storage", &self.storage);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AuthorizeSecurityGroupIngressInput {
    /// <p>The IPv4 address range, in CIDR format. You can't specify this parameter when specifying a source
    /// security group. To specify an IPv6 address range, use a set of IP permissions.</p>
    /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
    pub cidr_ip: std::option::Option<std::string::String>,
    /// <p>The start of port range for the TCP and UDP protocols, or an ICMP type number.
    /// For the ICMP type number, use <code>-1</code> to specify all types. If you
    /// specify all ICMP types, you must specify all codes.</p>
    /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
    pub from_port: std::option::Option<i32>,
    /// <p>The ID of the security group. You must specify either the security group ID or the
    /// security group name in the request. For security groups in a nondefault VPC, you must
    /// specify the security group ID.</p>
    pub group_id: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic, default VPC] The name of the security group. You must specify either the
    /// security group ID or the security group name in the request.</p>
    pub group_name: std::option::Option<std::string::String>,
    /// <p>The sets of IP permissions.</p>
    pub ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
    /// <p>The IP protocol name (<code>tcp</code>, <code>udp</code>, <code>icmp</code>) or number
    /// (see <a href="http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml">Protocol Numbers</a>). To specify <code>icmpv6</code>, use a set of IP permissions.</p>
    /// <p>[VPC only] Use <code>-1</code> to specify all protocols. If you specify <code>-1</code> or a
    /// protocol other than <code>tcp</code>, <code>udp</code>, or <code>icmp</code>, traffic on all ports
    /// is allowed, regardless of any ports you specify.</p>
    /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
    pub ip_protocol: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic, default VPC] The name of the source security group. You can't specify this parameter
    /// in combination with the following parameters: the CIDR IP address range, the start of the port range,
    /// the IP protocol, and the end of the port range. Creates rules that grant full ICMP, UDP, and TCP access.
    /// To create a rule with a specific IP protocol and port range, use a set of IP permissions instead. For
    /// EC2-VPC, the source security group must be in the same VPC.</p>
    pub source_security_group_name: std::option::Option<std::string::String>,
    /// <p>[nondefault VPC] The AWS account ID for the source security group, if the source security group is
    /// in a different account. You can't specify this parameter in combination with the following parameters:
    /// the CIDR IP address range, the IP protocol, the start of the port range, and the end of the port range.
    /// Creates rules that grant full ICMP, UDP, and TCP access. To create a rule with a specific IP protocol
    /// and port range, use a set of IP permissions instead.</p>
    pub source_security_group_owner_id: std::option::Option<std::string::String>,
    /// <p>The end of port range for the TCP and UDP protocols, or an ICMP code number.
    /// For the ICMP code number, use <code>-1</code> to specify all codes. If you
    /// specify all ICMP types, you must specify all codes.</p>
    /// <p>Alternatively, use a set of IP permissions to specify multiple rules and a description for the rule.</p>
    pub to_port: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AuthorizeSecurityGroupIngressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AuthorizeSecurityGroupIngressInput");
        formatter.field("cidr_ip", &self.cidr_ip);
        formatter.field("from_port", &self.from_port);
        formatter.field("group_id", &self.group_id);
        formatter.field("group_name", &self.group_name);
        formatter.field("ip_permissions", &self.ip_permissions);
        formatter.field("ip_protocol", &self.ip_protocol);
        formatter.field(
            "source_security_group_name",
            &self.source_security_group_name,
        );
        formatter.field(
            "source_security_group_owner_id",
            &self.source_security_group_owner_id,
        );
        formatter.field("to_port", &self.to_port);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AuthorizeSecurityGroupEgressInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the security group.</p>
    pub group_id: std::option::Option<std::string::String>,
    /// <p>The sets of IP permissions. You can't specify a destination security group and a CIDR IP
    /// address range in the same set of permissions.</p>
    pub ip_permissions: std::option::Option<std::vec::Vec<crate::model::IpPermission>>,
    /// <p>Not supported. Use a set of IP permissions to specify the CIDR.</p>
    pub cidr_ip: std::option::Option<std::string::String>,
    /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
    pub from_port: std::option::Option<i32>,
    /// <p>Not supported. Use a set of IP permissions to specify the protocol name or
    /// number.</p>
    pub ip_protocol: std::option::Option<std::string::String>,
    /// <p>Not supported. Use a set of IP permissions to specify the port.</p>
    pub to_port: std::option::Option<i32>,
    /// <p>Not supported. Use a set of IP permissions to specify a
    /// destination security group.</p>
    pub source_security_group_name: std::option::Option<std::string::String>,
    /// <p>Not supported. Use a set of IP permissions to specify a
    /// destination security group.</p>
    pub source_security_group_owner_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AuthorizeSecurityGroupEgressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AuthorizeSecurityGroupEgressInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("group_id", &self.group_id);
        formatter.field("ip_permissions", &self.ip_permissions);
        formatter.field("cidr_ip", &self.cidr_ip);
        formatter.field("from_port", &self.from_port);
        formatter.field("ip_protocol", &self.ip_protocol);
        formatter.field("to_port", &self.to_port);
        formatter.field(
            "source_security_group_name",
            &self.source_security_group_name,
        );
        formatter.field(
            "source_security_group_owner_id",
            &self.source_security_group_owner_id,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AuthorizeClientVpnIngressInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The IPv4 address range, in CIDR notation, of the network for which access is being authorized.</p>
    pub target_network_cidr: std::option::Option<std::string::String>,
    /// <p>The ID of the group to grant access to, for example, the Active Directory group or identity provider (IdP) group. Required if <code>AuthorizeAllGroups</code> is <code>false</code> or not specified.</p>
    pub access_group_id: std::option::Option<std::string::String>,
    /// <p>Indicates whether to grant access to all clients. Specify <code>true</code> to grant all
    /// clients who successfully establish a VPN connection access to the network. Must be set
    /// to <code>true</code> if <code>AccessGroupId</code> is not specified.</p>
    pub authorize_all_groups: std::option::Option<bool>,
    /// <p>A brief description of the authorization rule.</p>
    pub description: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AuthorizeClientVpnIngressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AuthorizeClientVpnIngressInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("target_network_cidr", &self.target_network_cidr);
        formatter.field("access_group_id", &self.access_group_id);
        formatter.field("authorize_all_groups", &self.authorize_all_groups);
        formatter.field("description", &self.description);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for AttachVpnGateway.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AttachVpnGatewayInput {
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The ID of the virtual private gateway.</p>
    pub vpn_gateway_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AttachVpnGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AttachVpnGatewayInput");
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("vpn_gateway_id", &self.vpn_gateway_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AttachVolumeInput {
    /// <p>The device name (for example, <code>/dev/sdh</code> or <code>xvdh</code>).</p>
    pub device: std::option::Option<std::string::String>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The ID of the EBS volume. The volume and instance must be within the same Availability
    /// Zone.</p>
    pub volume_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AttachVolumeInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AttachVolumeInput");
        formatter.field("device", &self.device);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("volume_id", &self.volume_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for AttachNetworkInterface.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AttachNetworkInterfaceInput {
    /// <p>The index of the device for the network interface attachment.</p>
    pub device_index: std::option::Option<i32>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>The index of the network card. Some instance types support multiple network cards.
    /// The primary network interface must be assigned to network card index 0.
    /// The default is network card index 0.</p>
    pub network_card_index: std::option::Option<i32>,
}
impl std::fmt::Debug for AttachNetworkInterfaceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AttachNetworkInterfaceInput");
        formatter.field("device_index", &self.device_index);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("network_card_index", &self.network_card_index);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AttachInternetGatewayInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the internet gateway.</p>
    pub internet_gateway_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AttachInternetGatewayInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AttachInternetGatewayInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("internet_gateway_id", &self.internet_gateway_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AttachClassicLinkVpcInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of one or more of the VPC's security groups. You cannot specify security groups from a different VPC.</p>
    pub groups: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of an EC2-Classic instance to link to the ClassicLink-enabled VPC.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>The ID of a ClassicLink-enabled VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AttachClassicLinkVpcInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AttachClassicLinkVpcInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("groups", &self.groups);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateVpcCidrBlockInput {
    /// <p>Requests an Amazon-provided IPv6 CIDR block with a /56 prefix length for the VPC. You cannot specify the range of IPv6 addresses, or the size of the CIDR block.</p>
    pub amazon_provided_ipv6_cidr_block: std::option::Option<bool>,
    /// <p>An IPv4 CIDR block to associate with the VPC.</p>
    pub cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The name of the location from which we advertise the IPV6 CIDR block. Use this parameter
    /// to limit the CIDR block to this location.</p>
    /// <p> You must set <code>AmazonProvidedIpv6CidrBlock</code> to <code>true</code> to use this parameter.</p>
    /// <p> You can have one IPv6 CIDR block association per network border group.</p>
    pub ipv6_cidr_block_network_border_group: std::option::Option<std::string::String>,
    /// <p>The ID of an IPv6 address pool from which to allocate the IPv6 CIDR block.</p>
    pub ipv6_pool: std::option::Option<std::string::String>,
    /// <p>An IPv6 CIDR block from the IPv6 address pool. You must also specify <code>Ipv6Pool</code> in the request.</p>
    /// <p>To let Amazon choose the IPv6 CIDR block for you, omit this parameter.</p>
    pub ipv6_cidr_block: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AssociateVpcCidrBlockInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateVpcCidrBlockInput");
        formatter.field(
            "amazon_provided_ipv6_cidr_block",
            &self.amazon_provided_ipv6_cidr_block,
        );
        formatter.field("cidr_block", &self.cidr_block);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field(
            "ipv6_cidr_block_network_border_group",
            &self.ipv6_cidr_block_network_border_group,
        );
        formatter.field("ipv6_pool", &self.ipv6_pool);
        formatter.field("ipv6_cidr_block", &self.ipv6_cidr_block);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateTrunkInterfaceInput {
    /// <p>The ID of the branch network interface.</p>
    pub branch_interface_id: std::option::Option<std::string::String>,
    /// <p>The ID of the trunk network interface.</p>
    pub trunk_interface_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VLAN. This applies to the VLAN protocol.</p>
    pub vlan_id: std::option::Option<i32>,
    /// <p>The application key. This applies to the GRE protocol.</p>
    pub gre_key: std::option::Option<i32>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the
    /// request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Run_Instance_Idempotency.html">How to Ensure
    /// Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AssociateTrunkInterfaceInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateTrunkInterfaceInput");
        formatter.field("branch_interface_id", &self.branch_interface_id);
        formatter.field("trunk_interface_id", &self.trunk_interface_id);
        formatter.field("vlan_id", &self.vlan_id);
        formatter.field("gre_key", &self.gre_key);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateTransitGatewayRouteTableInput {
    /// <p>The ID of the transit gateway route table.</p>
    pub transit_gateway_route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AssociateTransitGatewayRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateTransitGatewayRouteTableInput");
        formatter.field(
            "transit_gateway_route_table_id",
            &self.transit_gateway_route_table_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateTransitGatewayMulticastDomainInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The ID of the transit gateway attachment to associate with the transit gateway multicast domain.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>The IDs of the subnets to associate with the transit gateway multicast domain.</p>
    pub subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AssociateTransitGatewayMulticastDomainInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateTransitGatewayMulticastDomainInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("subnet_ids", &self.subnet_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateSubnetCidrBlockInput {
    /// <p>The IPv6 CIDR block for your subnet. The subnet must have a /64 prefix
    /// length.</p>
    pub ipv6_cidr_block: std::option::Option<std::string::String>,
    /// <p>The ID of your subnet.</p>
    pub subnet_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AssociateSubnetCidrBlockInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateSubnetCidrBlockInput");
        formatter.field("ipv6_cidr_block", &self.ipv6_cidr_block);
        formatter.field("subnet_id", &self.subnet_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateRouteTableInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the route table.</p>
    pub route_table_id: std::option::Option<std::string::String>,
    /// <p>The ID of the subnet.</p>
    pub subnet_id: std::option::Option<std::string::String>,
    /// <p>The ID of the internet gateway or virtual private gateway.</p>
    pub gateway_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AssociateRouteTableInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateRouteTableInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("route_table_id", &self.route_table_id);
        formatter.field("subnet_id", &self.subnet_id);
        formatter.field("gateway_id", &self.gateway_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateIamInstanceProfileInput {
    /// <p>The IAM instance profile.</p>
    pub iam_instance_profile: std::option::Option<crate::model::IamInstanceProfileSpecification>,
    /// <p>The ID of the instance.</p>
    pub instance_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AssociateIamInstanceProfileInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateIamInstanceProfileInput");
        formatter.field("iam_instance_profile", &self.iam_instance_profile);
        formatter.field("instance_id", &self.instance_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateEnclaveCertificateIamRoleInput {
    /// <p>The ARN of the ACM certificate with which to associate the IAM role.</p>
    pub certificate_arn: std::option::Option<std::string::String>,
    /// <p>The ARN of the IAM role to associate with the ACM certificate. You can associate up to 16 IAM roles with an ACM
    /// certificate.</p>
    pub role_arn: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AssociateEnclaveCertificateIamRoleInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateEnclaveCertificateIamRoleInput");
        formatter.field("certificate_arn", &self.certificate_arn);
        formatter.field("role_arn", &self.role_arn);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateDhcpOptionsInput {
    /// <p>The ID of the DHCP options set, or <code>default</code> to associate
    /// no DHCP options with the VPC.</p>
    pub dhcp_options_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AssociateDhcpOptionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateDhcpOptionsInput");
        formatter.field("dhcp_options_id", &self.dhcp_options_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateClientVpnTargetNetworkInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The ID of the subnet to associate with the Client VPN endpoint.</p>
    pub subnet_id: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">How to Ensure Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AssociateClientVpnTargetNetworkInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateClientVpnTargetNetworkInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("subnet_id", &self.subnet_id);
        formatter.field("client_token", &self.client_token);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssociateAddressInput {
    /// <p>[EC2-VPC] The allocation ID. This is required for EC2-VPC.</p>
    pub allocation_id: std::option::Option<std::string::String>,
    /// <p>The ID of the instance. The instance must have exactly one attached network interface.
    /// For EC2-VPC, you can specify either the instance ID or the network interface ID, but not both.
    /// For EC2-Classic, you must specify an instance ID and the instance must be in the running
    /// state.</p>
    pub instance_id: std::option::Option<std::string::String>,
    /// <p>[EC2-Classic] The Elastic IP address to associate with the instance. This is required for
    /// EC2-Classic.</p>
    pub public_ip: std::option::Option<std::string::String>,
    /// <p>[EC2-VPC] For a VPC in an EC2-Classic account, specify true to allow an Elastic IP address that is already associated with an instance or network interface to be reassociated with the specified instance or network interface. Otherwise, the operation fails. In a VPC in an EC2-VPC-only account, reassociation is automatic, therefore you can specify false to ensure the operation fails if the Elastic IP address is already associated with another resource.</p>
    pub allow_reassociation: std::option::Option<bool>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>[EC2-VPC] The ID of the network interface. If the instance has more than one network interface, you must specify a network interface ID.</p>
    /// <p>For EC2-VPC, you can specify either the instance ID or the network interface ID, but not both. </p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>[EC2-VPC] The primary or secondary private IP address to associate with the Elastic IP address. If no private IP address is specified, the Elastic IP address is associated with the primary private IP address.</p>
    pub private_ip_address: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AssociateAddressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssociateAddressInput");
        formatter.field("allocation_id", &self.allocation_id);
        formatter.field("instance_id", &self.instance_id);
        formatter.field("public_ip", &self.public_ip);
        formatter.field("allow_reassociation", &self.allow_reassociation);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("private_ip_address", &self.private_ip_address);
        formatter.finish()
    }
}

/// <p>Contains the parameters for AssignPrivateIpAddresses.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssignPrivateIpAddressesInput {
    /// <p>Indicates whether to allow an IP address that is already assigned to another network interface or instance to be reassigned to the specified network interface.</p>
    pub allow_reassignment: std::option::Option<bool>,
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
    /// <p>One or more IP addresses to be assigned as a secondary private IP address to the network interface. You can't specify this parameter when also specifying a number of secondary IP addresses.</p>
    /// <p>If you don't specify an IP address, Amazon EC2 automatically selects an IP address within the subnet range.</p>
    pub private_ip_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The number of secondary IP addresses to assign to the network interface. You can't specify this parameter when also specifying private IP addresses.</p>
    pub secondary_private_ip_address_count: std::option::Option<i32>,
}
impl std::fmt::Debug for AssignPrivateIpAddressesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssignPrivateIpAddressesInput");
        formatter.field("allow_reassignment", &self.allow_reassignment);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.field("private_ip_addresses", &self.private_ip_addresses);
        formatter.field(
            "secondary_private_ip_address_count",
            &self.secondary_private_ip_address_count,
        );
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AssignIpv6AddressesInput {
    /// <p>The number of additional IPv6 addresses to assign to the network interface.
    /// The specified number of IPv6 addresses are assigned in addition to the
    /// existing IPv6 addresses that are already assigned to the network interface.
    /// Amazon EC2 automatically selects the IPv6 addresses from the subnet range. You
    /// can't use this option if specifying specific IPv6 addresses.</p>
    pub ipv6_address_count: std::option::Option<i32>,
    /// <p>One or more specific IPv6 addresses to be assigned to the network interface. You can't use this option if you're specifying a number of IPv6 addresses.</p>
    pub ipv6_addresses: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The ID of the network interface.</p>
    pub network_interface_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AssignIpv6AddressesInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AssignIpv6AddressesInput");
        formatter.field("ipv6_address_count", &self.ipv6_address_count);
        formatter.field("ipv6_addresses", &self.ipv6_addresses);
        formatter.field("network_interface_id", &self.network_interface_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ApplySecurityGroupsToClientVpnTargetNetworkInput {
    /// <p>The ID of the Client VPN endpoint.</p>
    pub client_vpn_endpoint_id: std::option::Option<std::string::String>,
    /// <p>The ID of the VPC in which the associated target network is located.</p>
    pub vpc_id: std::option::Option<std::string::String>,
    /// <p>The IDs of the security groups to apply to the associated target network. Up to 5 security groups can
    /// be applied to an associated target network.</p>
    pub security_group_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request, and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>. Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for ApplySecurityGroupsToClientVpnTargetNetworkInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ApplySecurityGroupsToClientVpnTargetNetworkInput");
        formatter.field("client_vpn_endpoint_id", &self.client_vpn_endpoint_id);
        formatter.field("vpc_id", &self.vpc_id);
        formatter.field("security_group_ids", &self.security_group_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AllocateHostsInput {
    /// <p>Indicates whether the host accepts any untargeted instance launches that
    /// match its instance type configuration, or if it only accepts Host tenancy
    /// instance launches that specify its unique host ID. For more information,
    /// see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/how-dedicated-hosts-work.html#dedicated-hosts-understanding">
    /// Understanding auto-placement and affinity</a> in the <i>Amazon EC2 User Guide</i>.</p>
    /// <p>Default: <code>on</code>
    /// </p>
    pub auto_placement: std::option::Option<crate::model::AutoPlacement>,
    /// <p>The Availability Zone in which to allocate the Dedicated Host.</p>
    pub availability_zone: std::option::Option<std::string::String>,
    /// <p>Unique, case-sensitive identifier that you provide to ensure the idempotency of the request. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html">Ensuring Idempotency</a>.</p>
    pub client_token: std::option::Option<std::string::String>,
    /// <p>Specifies the instance type to be supported by the Dedicated Hosts. If you
    /// specify an instance type, the Dedicated Hosts support instances of the
    /// specified instance type only.</p>
    /// <p>If you want the Dedicated Hosts to support multiple instance types in a specific
    /// instance family, omit this parameter and specify <b>InstanceFamily</b>
    /// instead. You cannot specify <b>InstanceType</b> and
    /// <b>InstanceFamily</b> in the same request.</p>
    pub instance_type: std::option::Option<std::string::String>,
    /// <p>Specifies the instance family to be supported by the Dedicated Hosts. If you specify
    /// an instance family, the Dedicated Hosts support multiple instance types within that
    /// instance family.</p>
    /// <p>If you want the Dedicated Hosts to support a specific instance type only, omit this
    /// parameter and specify <b>InstanceType</b>
    /// instead. You cannot specify <b>InstanceFamily</b> and
    /// <b>InstanceType</b> in the same request.</p>
    pub instance_family: std::option::Option<std::string::String>,
    /// <p>The number of Dedicated Hosts to allocate to your account with these parameters.</p>
    pub quantity: std::option::Option<i32>,
    /// <p>The tags to apply to the Dedicated Host during creation.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
    /// <p>Indicates whether to enable or disable host recovery for the Dedicated Host.
    /// Host recovery is disabled by default. For more information, see
    /// <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/dedicated-hosts-recovery.html">
    /// Host recovery</a> in the <i>Amazon EC2 User Guide</i>.</p>
    /// <p>Default: <code>off</code>
    /// </p>
    pub host_recovery: std::option::Option<crate::model::HostRecovery>,
}
impl std::fmt::Debug for AllocateHostsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AllocateHostsInput");
        formatter.field("auto_placement", &self.auto_placement);
        formatter.field("availability_zone", &self.availability_zone);
        formatter.field("client_token", &self.client_token);
        formatter.field("instance_type", &self.instance_type);
        formatter.field("instance_family", &self.instance_family);
        formatter.field("quantity", &self.quantity);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.field("host_recovery", &self.host_recovery);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AllocateAddressInput {
    /// <p>Indicates whether the Elastic IP address is for use with instances in a VPC or instances in EC2-Classic.</p>
    /// <p>Default: If the Region supports EC2-Classic, the default is <code>standard</code>. Otherwise, the default
    /// is <code>vpc</code>.</p>
    pub domain: std::option::Option<crate::model::DomainType>,
    /// <p>[EC2-VPC] The Elastic IP address to recover or an IPv4 address from an address pool.</p>
    pub address: std::option::Option<std::string::String>,
    /// <p>The ID of an address pool that you own. Use this parameter to let Amazon EC2 select an address from the address pool.
    /// To specify a specific address from the address pool, use the <code>Address</code> parameter instead.</p>
    pub public_ipv4_pool: std::option::Option<std::string::String>,
    /// <p> A unique set of Availability Zones, Local Zones, or Wavelength Zones from which AWS
    /// advertises IP addresses. Use this parameter to limit the IP address to this location. IP
    /// addresses cannot move between network border groups.</p>
    /// <p>Use <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_DescribeAvailabilityZones.html">DescribeAvailabilityZones</a> to view the network border groups.</p>
    /// <note>
    /// <p>You cannot use a network border group with EC2 Classic. If you attempt this operation on EC2 classic, you will receive an <code>InvalidParameterCombination</code> error. For more information, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/errors-overview.html">Error Codes</a>.</p>
    /// </note>
    pub network_border_group: std::option::Option<std::string::String>,
    /// <p>The ID of a customer-owned address pool. Use this parameter to let Amazon EC2
    /// select an address from the address pool. Alternatively, specify a specific
    /// address from the address pool.</p>
    pub customer_owned_ipv4_pool: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The tags to assign to the Elastic IP address.</p>
    pub tag_specifications: std::option::Option<std::vec::Vec<crate::model::TagSpecification>>,
}
impl std::fmt::Debug for AllocateAddressInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AllocateAddressInput");
        formatter.field("domain", &self.domain);
        formatter.field("address", &self.address);
        formatter.field("public_ipv4_pool", &self.public_ipv4_pool);
        formatter.field("network_border_group", &self.network_border_group);
        formatter.field("customer_owned_ipv4_pool", &self.customer_owned_ipv4_pool);
        formatter.field("dry_run", &self.dry_run);
        formatter.field("tag_specifications", &self.tag_specifications);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AdvertiseByoipCidrInput {
    /// <p>The address range, in CIDR notation. This must be the exact range that you provisioned.
    /// You can't advertise only a portion of the provisioned range.</p>
    pub cidr: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AdvertiseByoipCidrInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AdvertiseByoipCidrInput");
        formatter.field("cidr", &self.cidr);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AcceptVpcPeeringConnectionInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC peering connection. You must specify this parameter in the
    /// request.</p>
    pub vpc_peering_connection_id: std::option::Option<std::string::String>,
}
impl std::fmt::Debug for AcceptVpcPeeringConnectionInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AcceptVpcPeeringConnectionInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("vpc_peering_connection_id", &self.vpc_peering_connection_id);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AcceptVpcEndpointConnectionsInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The ID of the VPC endpoint service.</p>
    pub service_id: std::option::Option<std::string::String>,
    /// <p>The IDs of one or more interface VPC endpoints.</p>
    pub vpc_endpoint_ids: std::option::Option<std::vec::Vec<std::string::String>>,
}
impl std::fmt::Debug for AcceptVpcEndpointConnectionsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AcceptVpcEndpointConnectionsInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("service_id", &self.service_id);
        formatter.field("vpc_endpoint_ids", &self.vpc_endpoint_ids);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AcceptTransitGatewayVpcAttachmentInput {
    /// <p>The ID of the attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AcceptTransitGatewayVpcAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AcceptTransitGatewayVpcAttachmentInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AcceptTransitGatewayPeeringAttachmentInput {
    /// <p>The ID of the transit gateway attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AcceptTransitGatewayPeeringAttachmentInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AcceptTransitGatewayPeeringAttachmentInput");
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AcceptTransitGatewayMulticastDomainAssociationsInput {
    /// <p>The ID of the transit gateway multicast domain.</p>
    pub transit_gateway_multicast_domain_id: std::option::Option<std::string::String>,
    /// <p>The ID of the transit gateway attachment.</p>
    pub transit_gateway_attachment_id: std::option::Option<std::string::String>,
    /// <p>The IDs of the subnets to associate with the transit gateway multicast domain.</p>
    pub subnet_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
}
impl std::fmt::Debug for AcceptTransitGatewayMulticastDomainAssociationsInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AcceptTransitGatewayMulticastDomainAssociationsInput");
        formatter.field(
            "transit_gateway_multicast_domain_id",
            &self.transit_gateway_multicast_domain_id,
        );
        formatter.field(
            "transit_gateway_attachment_id",
            &self.transit_gateway_attachment_id,
        );
        formatter.field("subnet_ids", &self.subnet_ids);
        formatter.field("dry_run", &self.dry_run);
        formatter.finish()
    }
}

/// <p>Contains the parameters for accepting the quote.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AcceptReservedInstancesExchangeQuoteInput {
    /// <p>Checks whether you have the required permissions for the action, without actually making the request,
    /// and provides an error response. If you have the required permissions, the error response is <code>DryRunOperation</code>.
    /// Otherwise, it is <code>UnauthorizedOperation</code>.</p>
    pub dry_run: std::option::Option<bool>,
    /// <p>The IDs of the Convertible Reserved Instances to exchange for another Convertible
    /// Reserved Instance of the same or higher value.</p>
    pub reserved_instance_ids: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The configuration of the target Convertible Reserved Instance to exchange for your
    /// current Convertible Reserved Instances.</p>
    pub target_configurations:
        std::option::Option<std::vec::Vec<crate::model::TargetConfigurationRequest>>,
}
impl std::fmt::Debug for AcceptReservedInstancesExchangeQuoteInput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AcceptReservedInstancesExchangeQuoteInput");
        formatter.field("dry_run", &self.dry_run);
        formatter.field("reserved_instance_ids", &self.reserved_instance_ids);
        formatter.field("target_configurations", &self.target_configurations);
        formatter.finish()
    }
}
